;;; Sierra Script 1.0 - (do not remove this comment)
(script# 104)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use System)

(public
	AnimateCalm 0
)

(local
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newSound
)
(procedure (AnimateCalm param1 param2)
	(switch argc
		(0
			(ego setScript: clientCastCalm)
		)
		(1
			(param1 setScript: clientCastCalm)
		)
		(else 
			(param1 setScript: clientCastCalm param2)
		)
	)
)

(instance clientCastCalm of Script
	(properties)
	
	(method (dispose)
		(UnlockEgo)
		(super dispose:)
		(DisposeScript 104)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(StopEgo)
				(ego setLoop: 2)
				(= cycles 1)
			)
			(1
				(ego
					view: 521
					setLoop: 0
					setCel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
				((= newSound (Sound new:))
					number: (GetSongNumber 39)
					loop: 1
					priority: 6
					init:
					play:
				)
			)
			(2
				(PrintTimedMessage 6 104 0)
				(= seconds 6)
			)
			(3 (ego setCycle: BegLoop self))
			(4
				(newSound stop: dispose:)
				(StopEgo)
				(ego
					loop: 2
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(self dispose:)
			)
		)
	)
)
