;;; Sierra Script 1.0 - (do not remove this comment)
(script# 106)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use System)

(public
	AnimateDazzle 0
)

(local
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newSound
)
(procedure (AnimateDazzle param1 param2)
	(Load rsVIEW 521)
	(Load rsSOUND (GetSongNumber 17))
	(cond 
		((< 1 argc) (param1 setScript: clientCastDazz param2))
		(argc (param1 setScript: clientCastDazz))
		(else (ego setScript: clientCastDazz))
	)
)

(instance clientCastDazz of Script
	(properties)
	
	(method (dispose)
		(UnlockEgo)
		(super dispose:)
		(DisposeScript 106)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				((= newSound (Sound new:))
					number: (GetSongNumber 17)
					priority: 6
					init:
					play:
				)
				(ego
					view: 521
					setLoop: (if (or (== (ego loop?) 1) (== (ego loop?) 3))
						2
					else
						3
					)
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(1 (= cycles 2))
			(2
				(newSound stop: dispose:)
				(StopEgo)
				(ego
					loop: 2
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(self dispose:)
			)
		)
	)
)
