;;; Sierra Script 1.0 - (do not remove this comment)
(script# 84)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm84 0
)

(local
	local0
	local1 =  90
	local2 =  40
	local3 =  20
	local4
	local5
	local6 =  114
	local7 =  96
	local8 =  1
	local9 =  6
	local10
	local11
)
(instance rm84 of Room
	(properties
		picture 84
		style $0008
		north 78
		east 85
	)
	
	(method (init)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(cSound fade:)
		(self setLocales: 804)
		(if (or (== prevRoomNum 97) (== prevRoomNum 89))
			(Bset 253)
		)
		(if (not (Btest 253)) (rock init: stopUpd:))
		(if (Bset 84) (Bset 348))
		(StopEgo)
		(ego init:)
		(if
		(= local0 (not (if (Btest 206) else (Btest 204))))
			(antwerp init: loop: 3 setScript: bounceAndLook)
			(LoadMany 128 590 513 502 503 510 84)
			(LoadMany
				132
				(GetSongNumber 4)
				(GetSongNumber 5)
				(GetSongNumber 6)
				(GetSongNumber 9)
				54
			)
			(cSound stop:)
			(antSound number: (GetSongNumber 4) init:)
			(antHits init:)
			(cond 
				((= local11 (ego has: invBroadsword)) (Load rsVIEW 501))
				((ego has: invDagger) (Load rsVIEW 512))
			)
		)
		(if (ego knows: skDAZZLE)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: skFLAMEDART)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(if (ego knows: skCALM)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: skOPEN) (Load rsVIEW 521))
		(if (ego has: invDagger) (Load rsVIEW 524) (Load rsSCRIPT 101))
		(if (ego has: invSmallRock)
			(Load rsVIEW 510)
			(Load rsSCRIPT 102)
		)
		(switch prevRoomNum
			(89
				(ego posn: 25 90 setMotion: MoveTo 36 90)
			)
			(97
				(ego posn: 25 90 setMotion: MoveTo 36 90)
			)
			(78
				(ego posn: 160 30 setMotion: MoveTo 198 75)
			)
			(85
				(ego posn: 319 100 setMotion: MoveTo 295 100)
			)
		)
	)
	
	(method (doit)
		(cond 
			(
			(and (== (ego onControl: origin) cLRED) (== (ego loop?) 3)) (curRoom newRoom: 78))
			((<= (ego x?) 25) (curRoom newRoom: 89))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 74)
		(if (!= newRoomNum 89)
			(Bclear 247)
			(if (not (if (Btest 250) else (Btest 251)))
				(Bclear 253)
				(Bclear 252)
			)
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 30] temp30 temp31)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl ego pEvent 3) (HighPrint (Format @temp0 84 0 @userName)))
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look,search>')
						(cond 
							((Said '[<at,around][/place,area]')
								(cond 
									((Btest 206) (HighPrint 84 1))
									((Btest 204) (HighPrint 84 2))
									(else (HighPrint 84 3))
								)
							)
							(
								(Said
									'[<at,around][/antwerp,monster,creature,beast,animal,bouncer]'
								)
								(cond 
									((Btest 206) (HighPrint 84 4))
									((Btest 204) (HighPrint 84 5))
									(else (HighPrint 84 6))
								)
							)
							((Said '[<at][/boulder,boulder]')
								(cond 
									((not (ego inRect: 0 70 50 100)) (HighPrint 84 7))
									((Btest 253) (HighPrint 84 8))
									(else (HighPrint 84 9))
								)
							)
							((Said '/cave,entrance')
								(if (Btest 253)
									(HighPrint 84 8)
								else
									(HighPrint 84 10)
								)
							)
							((Said '/door,keyhole,hasp')
								(if (ego inRect: 0 70 50 100)
									(HighPrint 84 9)
								else
									(HighPrint 84 11)
								)
							)
							((or (Said '<up') (Said '/sky')) (HighPrint 84 12))
							((or (Said '<down') (Said '/ground,grass')) (HighPrint 84 13))
							((Said '/south,west') (HighPrint 84 14))
							((Said '/east,north') (HighPrint 84 15))
						)
					)
					((Said 'cast>')
						(switch (= temp30 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp30) (HighPrint 84 16))
							)
							(skDAZZLE
								(if (CastSpell temp30)
									(AnimateDazzle)
									(if local0 (HighPrint 84 17))
								)
							)
							(skFLAMEDART
								(if (CastSpell temp30)
									(if (gCast contains: antwerp)
										(FaceObject ego antwerp)
										(SetUpEgo)
									)
									(if local0
										(AnimateThrowingFlameDart antwerp)
										(antwerp setScript: antwerpAway)
									else
										(AnimateThrowingFlameDart 0)
									)
								)
							)
							(skOPEN
								(cond 
									((not (ego inRect: 0 70 50 100)) (HighPrint 84 18))
									((CastSpell temp30)
										(if (Btest 252)
											(HighPrint 84 19)
										else
											(self setScript: sMagicRock)
										)
									)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(= temp31 (if (gCast contains: antwerp) antwerp else 0))
						(if (AnimateThrowingDagger temp31)
							(if (gCast contains: antwerp)
								(FaceObject ego antwerp)
								(SetUpEgo)
							)
							(if local0 (antwerp setScript: antwerpAway))
						)
					)
					((Said 'throw/boulder')
						(= temp31 (if (gCast contains: antwerp) antwerp else 0))
						(if (AnimateThrowingRock temp31)
							(if (gCast contains: antwerp)
								(FaceObject ego antwerp)
								(SetUpEgo)
							)
							(if local0 (antwerp setScript: antwerpAway))
						)
					)
					(
						(Said
							'fight,kill[/bouncer,antwerp,animal,beast,monster,creature]'
						)
						(cond 
							((Btest 206) (HighPrint 84 4))
							((Btest 204) (HighPrint 84 5))
							((or local11 (ego has: invDagger)) (antwerp setScript: fightAntwerp))
							(else
								(HighPrint 84 20)
								(HighPrint 84 21)
								(ego setScript: bareHandAttack)
							)
						)
					)
					(
						(Said
							'feed[/antwerp,creature,monster,bouncer,animal,beast]'
						)
						(cond 
							((Btest 206) (HighPrint 84 22))
							((Btest 204) (HighPrint 84 5))
							(else (HighPrint 84 23))
						)
					)
					(
						(or
							(Said 'unlock,lockpick/door,boulder,hasp,keyhole')
							(Said 'use/key,lockpick')
							(Said 'open/hasp,keyhole')
						)
						(cond 
							((not (ego inRect: 0 70 50 100)) (HighPrint 84 24))
							((Btest 252) (HighPrint 84 19))
							((and (ego has: invLargeBrassKey) (Btest 245)) (HighPrint 84 25) (Bset 252))
							((not (HasLockPickTools)) (HighPrint 84 26))
							((TestSkill skLOCKPICKING 85 lockPickBonus) (HighPrint 84 27) (Bset 252))
							(else
								(HighPrint 84 28)
								(if (not (ego has: invThiefToolKit)) (HighPrint 84 29))
							)
						)
					)
					((Said 'shove,move,force,get,open/boulder,door')
						(if (not (Btest 253))
							(if (Btest 252)
								(if (TestSkill skSTRENGTH 40 0)
									(rock setScript: sMoveRock)
								else
									(HighPrint 84 30)
								)
							else
								(HighPrint 84 31)
							)
						else
							(HighPrint 84 32)
						)
					)
					(
						(or
							(Said 'say,holler<hiden/goseke')
							(Said 'hiden/goseke')
						)
						(if
							(and
								(ego inRect: 0 70 50 100)
								(Btest 253)
								(not (Btest 247))
								(not (Btest 250))
							)
							(Bset 247)
							(AddToScore POINTS_GIVECAVEPASSWORD 5)
							(HighPrint 84 33)
						else
							(HighPrint 84 34)
						)
					)
					((Said 'enter/cave,entrance') (HighPrint 84 35))
				)
			)
		)
	)
)

(instance antwerp of TargActor
	(properties
		y 96
		x 114
		yStep 4
		view 590
		loop 2
		cycleSpeed 1
		xStep 4
		moveSpeed 1
	)
	
	(method (doit)
		(if
			(and
				(== (self loop?) 0)
				(== (antSound loop?) 0)
				(== (self cel?) 0)
				(!= (self script?) fightAntwerp)
			)
			(antSound loop: 1 play:)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl antwerp pEvent 3)
					(HighPrint 84 37)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					(
						(Said
							'play/[antwerp,monster,creature,bouncer,animal,beast]'
						)
						(HighPrint 84 38)
					)
				)
			)
		)
	)
	
	(method (getHurt)
		(HighPrint 84 36)
	)
)

(instance bounceAndLook of Script
	(properties)
	
	(method (doit)
		(cond 
			(
				(and
					(< (- (antwerp x?) local1) (ego x?))
					(< (ego x?) (+ (antwerp x?) local1))
					(< (- (antwerp y?) local2) (ego y?))
					(< (ego y?) (+ (antwerp y?) local2))
				)
				(antwerp cycleSpeed: 0 moveSpeed: 0)
				(client setScript: antwerpFollow)
			)
			(
				(or
					(and
						(< (antwerp x?) (ego x?))
						(!= (antwerp loop?) 0)
					)
					(and
						(> (antwerp x?) (ego x?))
						(!= (antwerp loop?) 1)
					)
				)
				(self changeState: 0)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(antSound number: (GetSongNumber 4) play:)
				(if (< (antwerp x?) (ego x?))
					(antwerp
						loop: 0
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: EndLoop self
					)
				else
					(antwerp
						loop: 1
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: EndLoop self
					)
				)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance antwerpFollow of Script
	(properties)
	
	(method (doit)
		(asm
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #x
			pushi    0
			lofsa    antwerp
			send     4
			sub     
			sal      local4
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lofsa    antwerp
			send     4
			sub     
			sal      local5
			pushi    65491
			lal      local4
			lt?     
			bnt      code_0c75
			pprev   
			ldi      45
			lt?     
			bnt      code_0c75
			pushi    65528
			lal      local5
			lt?     
			bnt      code_0c75
			pprev   
			ldi      8
			lt?     
			bnt      code_0c75
			pushi    #cycleSpeed
			pushi    1
			pushi    1
			pushi    56
			pushi    1
			pushi    1
			lofsa    antwerp
			send     12
			pushi    #setScript
			pushi    1
			lofsa    antwerpPushes
			push    
			pToa     client
			send     6
code_0c75:
			-al      local8
			bnt      code_0c7d
			jmp      code_0d64
code_0c7d:
			lal      local1
			neg     
			push    
			lal      local4
			lt?     
			bnt      code_0c8b
			pprev   
			lal      local1
			lt?     
code_0c8b:
			not     
			bt       code_0ca1
			lal      local2
			neg     
			push    
			lal      local5
			lt?     
			bnt      code_0c9d
			pprev   
			lal      local2
			lt?     
code_0c9d:
			not     
			bnt      code_0cab
code_0ca1:
			pushi    #changeState
			pushi    1
			pushi    7
			self     6
			jmp      code_0d64
code_0cab:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			lt?     
			bnt      code_0cda
			lsl      local5
			lal      local3
			mul     
			push    
			lsl      local4
			lal      local2
			mul     
			add     
			push    
			ldi      0
			lt?     
			bnt      code_0cda
			pushi    #changeState
			pushi    1
			pushi    1
			self     6
			jmp      code_0d64
code_0cda:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			gt?     
			bnt      code_0cfe
			lsl      local4
			ldi      0
			lt?     
			bnt      code_0cfe
			pushi    #changeState
			pushi    1
			pushi    2
			self     6
			jmp      code_0d64
code_0cfe:
			lsl      local5
			lal      local3
			mul     
			push    
			lsl      local4
			lal      local2
			mul     
			add     
			push    
			ldi      0
			lt?     
			bnt      code_0d1b
			pushi    #changeState
			pushi    1
			pushi    3
			self     6
			jmp      code_0d64
code_0d1b:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			gt?     
			bnt      code_0d38
			pushi    #changeState
			pushi    1
			pushi    4
			self     6
			jmp      code_0d64
code_0d38:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			lt?     
			bnt      code_0d5d
			lsl      local4
			ldi      0
			gt?     
			bnt      code_0d5d
			pushi    #changeState
			pushi    1
			pushi    5
			self     6
			jmp      code_0d64
code_0d5d:
			pushi    #changeState
			pushi    1
			pushi    6
			self     6
code_0d64:
			lal      local8
			not     
			bnt      code_0d6e
			lal      local9
			sal      local8
code_0d6e:
			pushi    #doit
			pushi    0
			super    Script,  4
			ret     
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(if
					(and
						(< (- local6 local1) (ego x?))
						(< (ego x?) (+ local6 local1))
						(< (- local7 local2) (ego y?))
						(< (ego y?) (+ local7 local2))
					)
					(cond 
						((<= (antwerp x?) local6)
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						((<= (/ (+ (antwerp x?) (ego x?)) 2) local6)
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						(else
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo (+ (antwerp x?) (ego x?)) (ego y?)
							)
						)
					)
				else
					(antwerp
						setLoop: 1
						setCycle: Forward
						setMotion: MoveTo local6 local7
					)
				)
			)
			(2
				(antwerp
					setLoop: 1
					setCycle: Forward
					setMotion:
						MoveTo
						(+ (antwerp x?) (/ local5 2))
						(- (antwerp y?) (/ local5 2))
				)
			)
			(3
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion:
						MoveTo
						(- (antwerp x?) (/ local5 2))
						(- (antwerp y?) (/ local5 2))
				)
			)
			(4
				(if
					(and
						(< (- local6 local1) (ego x?))
						(< (ego x?) (+ local6 local1))
						(< (- local7 local2) (ego y?))
						(< (ego y?) (+ local7 local2))
					)
					(cond 
						((>= (antwerp x?) local6)
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						((>= (/ (+ (antwerp x?) (ego x?)) 2) local6)
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						(else
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo (+ (antwerp x?) (ego x?)) (ego y?)
							)
						)
					)
				else
					(antwerp
						setLoop: 0
						setCycle: Forward
						setMotion: MoveTo local6 local7
					)
				)
			)
			(5
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion:
						MoveTo
						(- (antwerp x?) (/ local5 2))
						(+ (antwerp y?) (/ local5 2))
				)
			)
			(6
				(antwerp
					setLoop: 1
					setCycle: Forward
					setMotion:
						MoveTo
						(+ (antwerp x?) (/ local5 2))
						(+ (antwerp y?) (/ local5 2))
				)
			)
			(7
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion: MoveTo local6 local7 self
				)
			)
			(8
				(client setScript: bounceAndLook)
			)
		)
	)
)

(instance antwerpPushes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (< (ego x?) (antwerp x?))
					(ego
						ignoreActors:
						setMotion: MoveTo (- (antwerp x?) 30) (antwerp y?) self
					)
				else
					(ego
						ignoreActors:
						setMotion: MoveTo (+ (antwerp x?) 30) (antwerp y?) self
					)
				)
			)
			(1
				(if (< (ego x?) (antwerp x?))
					(antwerp
						setLoop: 1
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (+ (ego x?) 21) (antwerp y?) self
					)
					(ego
						view: 513
						setLoop: 2
						cycleSpeed: 1
						setCycle: EndLoop
						setMotion: MoveTo (- (ego x?) 10) (ego y?)
					)
				else
					(antwerp
						setLoop: 0
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (- (ego x?) 21) (antwerp y?) self
					)
					(ego
						view: 513
						setLoop: 3
						cycleSpeed: 1
						setCycle: EndLoop
						setMotion: MoveTo (+ (ego x?) 10) (ego y?)
					)
				)
				(antHits play:)
			)
			(2
				(if (not (ReduceHP 10))
					(self changeState: 5)
				else
					(StopEgo)
					(= local4 45)
					(if (< (ego x?) (antwerp x?))
						(if (> 226 (+ (antwerp x?) local4))
							(= local4 (- 226 (antwerp x?)))
						)
						(antwerp
							setLoop: 1
							cel: 0
							setCycle: Forward
							setMotion: MoveTo (+ (antwerp x?) local4) (antwerp y?) self
						)
						(ego loop: 0)
					else
						(if (> 82 (- (antwerp x?) local4))
							(= local4 (- (antwerp x?) 82))
						)
						(antwerp
							setLoop: 0
							cel: 0
							setCycle: Forward
							setMotion: MoveTo (- (antwerp x?) local4) (antwerp y?) self
						)
						(ego loop: 1)
					)
					(UnlockEgo)
				)
			)
			(3 (= seconds 3))
			(4
				(antwerp cycleSpeed: 0 moveSpeed: 0)
				(client setScript: antwerpFollow)
			)
			(5
				(= local4 25)
				(if (< (ego x?) (antwerp x?))
					(if (> 226 (+ (antwerp x?) local4))
						(= local4 (- 226 (antwerp x?)))
					)
					(antwerp
						setLoop: 1
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (+ (antwerp x?) local4) (antwerp y?)
					)
					(ego loop: 2)
				else
					(if (> 82 (- (antwerp x?) local4))
						(= local4 (- (antwerp x?) 82))
					)
					(antwerp
						setLoop: 0
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (- (antwerp x?) local4) (antwerp y?)
					)
					(ego loop: 1)
				)
				(ego
					view: 503
					setLoop: 0
					cel: 0
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(6
				(Die
					84
					39
					82
					517
					2
					5
					80
					{Your figure remains still and silent.}
				)
			)
		)
	)
)

(instance fightAntwerp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(PrintTimedMessage 5 84 40)
				(antwerp setMotion: MoveTo 114 96)
				(ego ignoreActors: setMotion: MoveTo 250 100 self)
			)
			(1
				(ego
					view: 502
					cel: 0
					setLoop: (if local11 0 else 2)
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(2
				(if local11
					(ego view: 501 setLoop: 2)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(3
				(ego
					cel: 0
					setLoop: (if local11 6 else 1)
					setCycle: EndLoop self
				)
			)
			(4
				(ego
					cel: 0
					setLoop: (if local11 3 else 0)
					setCycle: EndLoop self
				)
			)
			(5
				(ego
					cel: 0
					setLoop: (if local11 7 else 0)
					setCycle: EndLoop self
				)
			)
			(6
				(if local10
					(-- local10)
					(self changeState: 2)
				else
					(= local10 4)
					(= cycles 4)
				)
			)
			(7
				(ego
					cel: 0
					setLoop: (if local11 4 else 2)
					setCycle: EndLoop self
				)
			)
			(8
				(if local10
					(-- local10)
					(self changeState: 7)
				else
					(ego
						view: 502
						cel: 5
						setLoop: (if local11 0 else 2)
						setCycle: BegLoop self
					)
				)
			)
			(9
				(PrintTimedMessage 4 84 41)
				(StopEgo)
				(ego
					setLoop: 1
					moveSpeed: 1
					cycleSpeed: 1
					ignoreActors:
					setMotion: MoveTo 158 96 self
				)
			)
			(10
				(ego
					view: 502
					cel: 0
					setLoop: (if local11 0 else 2)
					moveSpeed: 0
					cycleSpeed: 0
					setCycle: EndLoop self
				)
			)
			(11
				(antwerp
					setLoop: 0
					setCycle: CycleTo 2 1
					setStep: 1 5
					setMotion: MoveTo 114 0
				)
				(antSound number: (GetSongNumber 4) play:)
				(= cycles 13)
			)
			(12
				(antSound stop:)
				(if local11
					(ego view: 501 setLoop: 3)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(13
				(ego loop: (if local11 1 else 7) cel: 0)
				(antwerp setCycle: EndLoop setMotion: MoveTo 114 96 self)
			)
			(14
				(antwerp setCycle: Forward)
				(= cycles 10)
			)
			(15
				(antwerp
					yStep: 7
					setCycle: CycleTo 2 1
					ignoreActors: 1
					ignoreHorizon:
					illegalBits: 0
					setMotion: MoveTo 114 0
				)
				(antSound number: (GetSongNumber 5) play:)
				(= cycles 10)
			)
			(16
				(antSound stop:)
				(if local11
					(ego view: 501 setLoop: 3)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(17 (= cycles 16))
			(18
				(antwerp setMotion: MoveTo 114 96 self)
				(ego loop: (if local11 1 else 7) cel: 0)
			)
			;CI: NOTE: This case already exists, and will probably never be executed
			(18
				(antSound number: (GetSongNumber 9) play:)
				(antwerp setCycle: CycleTo 2 1 setMotion: MoveTo 114 92 self)
			)
			(19
				(antSound stop:)
				(antwerp setCycle: BegLoop self)
			)
			(20
				(antSound number: (GetSongNumber 6) play:)
				(antwerp yStep: 10 setMotion: MoveTo 114 -10)
				(= cycles 10)
			)
			(21
				(antSound stop:)
				(if local11
					(ego view: 501 setLoop: 5 cel: 0)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(22
				(ego
					view: 502
					cel: (if local11 5 else 2)
					setLoop: (if local11 0 else 3)
					setCycle: BegLoop self
				)
			)
			(23
				(StopEgo)
				(Bset 204)
				(UnlockEgo)
				(PrintTimedMessage 3 84 42)
			)
		)
	)
)

(instance antSound of Sound
	(properties
		priority 5
	)
)

(instance antHits of Sound
	(properties
		number 54
		priority 6
	)
)

(instance rock of Actor
	(properties
		y 89
		x 18
		yStep 1
		view 84
		xStep 1
	)
)

(instance sMoveRock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					view: 510
					setLoop: 1
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 2 1 self
				)
			)
			(1
				(rock
					setCycle: 0
					startUpd:
					illegalBits: 0
					xStep: 3
					setMotion: MoveTo -18 89 self
				)
				(ego setCycle: BegLoop)
			)
			(2
				(ChangeEgoWalk MOVE_WALK FALSE)
				(UnlockEgo)
				(AddToScore POINTS_FINDSECRETENTRANCE 10)
				(Bset 253)
				(rock dispose:)
			)
		)
	)
)

(instance sMagicRock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					view: 521
					illegalBits: 0
					setLoop: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(Bset 252)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(if (< [skills skOPEN] 50)
					(HighPrint 84 43)
					(UnlockEgo)
					(StopEgo)
					(client setScript: 0)
				else
					(rock
						setCycle: 0
						startUpd:
						illegalBits: 0
						setMotion: MoveTo -18 89 self
					)
				)
			)
			(2
				(AddToScore POINTS_FINDSECRETENTRANCE 10)
				(Bset 253)
				(rock dispose:)
				(StopEgo)
				(UnlockEgo)
			)
		)
	)
)

(instance bareHandAttack of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (antwerp x?) (antwerp y?) self)
			)
			(1 (client setScript: 0))
		)
	)
)

(instance antwerpAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (antwerp setCycle: EndLoop self))
			(1
				(antwerp
					setLoop: 2
					cel: 0
					ignoreHorizon:
					illegalBits: 0
					setPri: (antwerp priority?)
					setStep: 4 18
					setCycle: BegLoop
					setMotion: MoveTo 200 -10 self
				)
				(= local0 0)
				(Bset 204)
			)
			(2
				(UnlockEgo)
				(HighPrint 84 44)
			)
		)
	)
)
