;;; Sierra Script 1.0 - (do not remove this comment)
(script# 22)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use InputComparer)
(use LoadMany)
(use Extra)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm22 0
	hut 1
	walkEm 2
	flyAway 3
)

(local
	hutX
	hutY
	local2
	local3
)
(procedure (localproc_0012 param1 &tmp [temp0 4] [temp4 400])
	(DisposeDialog)
	(Format @temp4 &rest)
	(TextSize @[temp0 0] @temp4 userFont 0)
	(Print
		@temp4
		#at
		-1
		130
		#width
		(if (> [temp0 2] 24) 300 else 0)
		#mode
		1
		#dispose
		#time
		param1
	)
)

(procedure (localproc_0065)
	(HighPrint 22 0)
)

(procedure (localproc_006d)
	(HighPrint 22 1)
	(HighPrint 22 2)
	(HighPrint 22 3)
	(= countdownAwaitingResponse 100)
)

(procedure (localproc_0088)
	(HighPrint 22 4)
	(HighPrint 22 5)
	(= countdownAwaitingResponse 100)
)

(instance wing1 of Actor
	(properties
		yStep 4
		view 22
		loop 8
		illegalBits $0000
		xStep 6
	)
)

(instance wing2 of Actor
	(properties
		yStep 4
		view 22
		loop 9
		illegalBits $0000
		xStep 6
	)
)

(instance hut of Actor
	(properties
		yStep 4
		view 22
		loop 4
		illegalBits $0000
		xStep 6
	)
)

(instance hutDoor of Actor
	(properties
		view 22
		loop 5
		cycleSpeed 1
		illegalBits $0000
	)
)

(instance frontLeg of Actor
	(properties
		yStep 4
		view 22
		illegalBits $0000
		xStep 6
	)
)

(instance frontFoot of Actor
	(properties
		yStep 4
		view 22
		loop 1
		cel 1
		illegalBits $0000
		xStep 6
	)
)

(instance backLeg of Actor
	(properties
		yStep 4
		view 22
		loop 2
		illegalBits $0000
		xStep 6
	)
)

(instance backFoot of Actor
	(properties
		yStep 4
		view 22
		loop 3
		cel 1
		illegalBits $0000
		xStep 6
	)
)

(instance gate of Actor
	(properties
		y 158
		x 191
		view 23
		illegalBits $0000
	)
)

(instance dirt of Actor
	(properties
		y 156
		x 191
		view 23
		loop 1
		illegalBits $0000
	)
)

(instance eyes of Actor
	(properties
		y 130
		x 189
		z 2
		view 23
		loop 3
		cycleSpeed 1
		illegalBits $0000
	)
)

(instance skull1 of Extra
	(properties
		y 88
		x 117
		view 23
		loop 4
		cycleType 1
		minPause 40
		maxPause 80
		minCycles 2
		maxCycles 4
	)
)

(instance skull2 of Extra
	(properties
		y 89
		x 251
		view 23
		loop 4
		cycleType 1
		minPause 40
		maxPause 80
		minCycles 2
		maxCycles 4
	)
)

(instance skull3 of Extra
	(properties
		y 88
		x 72
		view 23
		loop 6
		cycleType 1
		minPause 40
		maxPause 80
		minCycles 2
		maxCycles 4
	)
)

(instance skull4 of Extra
	(properties
		y 85
		x 14
		view 23
		loop 5
		cycleType 1
		minPause 40
		maxPause 80
		minCycles 2
		maxCycles 4
	)
)

(instance skull5 of Extra
	(properties
		y 82
		x 295
		view 23
		loop 5
		cycleType 1
		minPause 40
		maxPause 80
		minCycles 2
		maxCycles 4
	)
)

(instance TP of Actor
	(properties
		y 160
		x 152
		view 531
		cycleSpeed 1
		illegalBits $0000
	)
)

(instance tpSound of Sound
	(properties
		number 28
		priority 1
	)
)

(instance tromp of Sound
	(properties
		number 66
		priority 1
	)
)

(instance rm22 of Room
	(properties
		picture 22
		style $0000
		south 33
	)
	
	(method (init)
		(LoadMany 128 22 23 19 531 516)
		(LoadMany 132 23 (GetSongNumber 28) (GetSongNumber 66))
		(super init:)
		(gKeyHandler add: self)
		(StatusLine enable:)
		(StopEgo)
		(= countdownAwaitingResponse 0)
		(cSound number: 23 loop: -1 play:)
		(if (not (Btest 173))
			(if (Btest 172)
				(= hutX 167)
				(= hutY 96)
				(hut
					setLoop: 4
					ignoreActors:
					posn: hutX hutY
					setPri: 4
					init:
					stopUpd:
				)
				(frontFoot
					setLoop: 1
					setPri: 3
					ignoreActors:
					posn: (- hutX 27) (- hutY 7)
					init:
					stopUpd:
				)
				(backFoot
					setLoop: 3
					setPri: 2
					ignoreActors:
					posn: (+ hutX 38) (- hutY 8)
					init:
					stopUpd:
				)
			else
				(= hutX 143)
				(= hutY 40)
				(frontLeg
					setLoop: 0
					setPri: 3
					ignoreActors:
					posn: (- hutX 20) hutY
					init:
					stopUpd:
				)
				(backLeg
					setLoop: 2
					setPri: 2
					ignoreActors:
					posn: (+ hutX 40) hutY
					init:
					stopUpd:
				)
				(frontFoot
					setLoop: 1
					setPri: 3
					ignoreActors:
					posn: (- hutX 27) (+ hutY 31)
					init:
					stopUpd:
				)
				(backFoot
					setLoop: 3
					setPri: 2
					ignoreActors:
					posn: (+ hutX 38) (+ hutY 32)
					init:
					stopUpd:
				)
				(gate setLoop: 0 setPri: 11 init: stopUpd:)
				(dirt ignoreActors: setPri: 11 init: stopUpd: hide:)
				(bonehead
					ignoreActors:
					setCycle: Forward
					setPri: 11
					init:
					stopUpd:
				)
				(eyes ignoreActors: setPri: 12 init: setCycle: Forward)
				(if (< global323 4) (eyes stopUpd: hide:))
				(hut
					setLoop: 4
					ignoreActors:
					posn: hutX hutY
					setPri: 4
					init:
					stopUpd:
				)
			)
		)
		(skull1 ignoreActors: setPri: 12 init:)
		(skull2 ignoreActors: setPri: 12 init:)
		(skull3 ignoreActors: setPri: 12 init:)
		(skull4 ignoreActors: setPri: 12 init:)
		(skull5 ignoreActors: setPri: 12 init:)
		(if (Btest 173)
			(skull1 stopUpd:)
			(skull2 stopUpd:)
			(skull3 stopUpd:)
			(skull4 stopUpd:)
			(skull5 stopUpd:)
		)
		(if (== prevRoomNum 21)
			(cond 
				((< global324 3)
					(ego view: 19 loop: 2 cel: 7 posn: 152 160 ignoreActors:)
					(TP ignoreActors: setPri: 15 init: setScript: frogIn)
				)
				((== global324 4) (hut setScript: flyAway))
				(else
					(ego posn: 152 160 loop: 2)
					(TP ignoreActors: setPri: 15 init: setScript: frogIn)
				)
			)
		else
			(ego posn: 225 189 init: setMotion: MoveTo 230 180)
		)
	)
	
	(method (doit)
		(if
			(and
				(ego inRect: 179 0 191 102)
				(Btest 172)
				(not local3)
				(< global324 4)
			)
			(Bclear 172)
			(curRoom newRoom: 21)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclear 171)
		(Bset 12)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 50])
		(cond 
			((super handleEvent: pEvent))
			((EventEqualsString pEvent {hut of brown})
				(cond 
					((Btest 172) (HighPrint 22 6))
					(
					(StringEquals (User inputLineAddr?) {now sit down})
						(AddToScore POINTS_HUTSIT 7)
						(if (not (hut script?))
							(hut setScript: walkEm)
						else
							(Print 22 7 #title {HUT} #at -1 20)
							; "I'm moving as fast as I can!"
						)
					)
					(else (HighPrint 22 6))
				)
			)
			((== (pEvent type?) evSAID)
				(cond 
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*]') (localproc_0065))
							((Said '/hut,house') (HighPrint 22 8))
							((Said '/leg,feet') (HighPrint 22 9))
							((Said '/fence') (HighPrint 22 10))
							((Said '/gate')
								(if local2
									(HighPrint 22 11)
								else
									(HighPrint 22 12)
								)
							)
							((Said '/goo')
								(if (Btest 98)
									(HighPrint 22 13)
								else
									(HighPrint 22 14)
								)
							)
							((Said '/skull,head')
								(HighPrint 22 15)
								(if (not local2)
									(if (< global323 4)
										(HighPrint 22 12)
									else
										(HighPrint 22 16)
									)
								)
							)
							((Said '/window') (HighPrint 22 17))
							((Said '/door')
								(if (Btest 172)
									(HighPrint 22 18)
								else
									(HighPrint 22 19)
								)
							)
							(
							(or (Said '/tree,bush,boulder') (Said '<up,down')) (HighPrint 22 20))
						)
					)
					((Said 'nap,rest')
						(if (== (ego view?) 19)
							(HighPrint 22 21)
						else
							(pEvent claimed: 0)
						)
					)
					((Said 'climb>')
						(cond 
							((Said '/fence,gate') (HighPrint 22 22))
							((Said '/hut,leg,chicken')
								(cond 
									((Btest 172) (HighPrint 22 23))
									(local2 (HighPrint 22 24))
									(else (HighPrint 22 25))
								)
							)
							((Said '/boulder,cliff') (HighPrint 22 26))
						)
					)
					((Said 'affirmative,n') (HighPrint 22 27))
					((Said 'say,recite,chat/rhyme,hut') (HighPrint 22 28))
				)
			)
		)
	)
)

(instance bonehead of Actor
	(properties
		y 137
		x 190
		z 1
		view 23
		loop 2
		illegalBits $0000
	)
	
	(method (doit)
		(if
		(and (== (ego onControl: origin) cYELLOW) (not (Btest 171)))
			(Bset 171)
			(bonehead setScript: boneTalk)
		)
		(if (> countdownAwaitingResponse 1) (-- countdownAwaitingResponse))
		(if (== countdownAwaitingResponse 1) (= countdownAwaitingResponse 0))
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (> countdownAwaitingResponse 1)
					(cond 
						((Said 'affirmative')
							(= countdownAwaitingResponse 0)
							(switch global323
								(0 (HighPrint 22 27))
								(1
									(HighPrint 22 29)
									(= global323 3)
									(AddToScore POINTS_MAKEDEALWITHSKULL 2)
								)
								(3 (HighPrint 22 30))
								(4
									(HighPrint 22 31)
									(gate setScript: openGate)
								)
							)
						)
						((Said 'n')
							(= countdownAwaitingResponse 0)
							(switch global323
								(0 (HighPrint 22 27))
								(1
									(HighPrint 22 32)
									(= global323 2)
								)
								(2 (HighPrint 22 32))
								(3 (HighPrint 22 33))
								(4 (HighPrint 22 31))
							)
						)
						(else
							(= countdownAwaitingResponse 80)
							(HighPrint 22 34)
							(switch global323
								(0 (HighPrint 22 27))
								(3 (HighPrint 22 35))
								(4 (HighPrint 22 36))
								(else  (HighPrint 22 37))
							)
							(pEvent claimed: 1)
						)
					)
				)
				(cond 
					((Said 'chat[/*]') (bonehead setScript: boneTalk))
					((Said 'open[<gate]')
						(if (== global323 4)
							(HighPrint 22 38)
							(gate setScript: openGate)
						else
							(HighPrint 22 39)
						)
					)
					((Said 'ask>')
						(cond 
							((== global323 0)
								(pEvent claimed: 1)
								(HighPrint 22 40)
								(bonehead setScript: boneTalk)
							)
							((Said '/deal')
								(switch global323
									(0
										(HighPrint 22 41)
										(bonehead setScript: boneTalk)
									)
									(1 (localproc_006d))
									(2 (localproc_0088))
									(3 (localproc_0088))
									(4 (HighPrint 22 42))
								)
							)
							((Said '/baba')
								(if (Btest 11)
									(HighPrint 22 43)
								else
									(HighPrint 22 44)
								)
							)
							((Said '/ogress') (HighPrint 22 45))
							((Said '/gem')
								(switch global323
									(0
										(bonehead setScript: boneTalk)
									)
									(1 (localproc_006d))
									(2 (localproc_0088))
									(3 (HighPrint 22 46))
									(else  (HighPrint 22 47))
								)
							)
							((Said '/eye')
								(if (< global323 4)
									(HighPrint 22 48)
								else
									(HighPrint 22 49)
								)
							)
							((Said '/skull') (HighPrint 22 50))
							((Said '/gate') (HighPrint 22 51))
							((Said '/fence') (HighPrint 22 52) (HighPrint 22 53))
							((Said '/hut,house') (HighPrint 22 54))
							((Said '/rhyme') (HighPrint 22 55))
							((Said '/*') (HighPrint 22 56))
						)
					)
					((Said 'gave[/eye,gem,skull][/skull,gem,eye]')
						(if (ego has: invGlowingGem)
							(if (== (ego onControl: origin) cYELLOW)
								(AddToScore POINTS_GIVEGEM 10)
								(bonehead setScript: putEyes)
							else
								(PrintNotCloseEnough)
							)
						else
							(PrintDontHaveIt)
						)
					)
				)
			)
		)
	)
)

(instance putEyes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(ego illegalBits: 0 setMotion: MoveTo 189 165 self)
			)
			(1
				(ego loop: 3 forceUpd:)
				(= cycles 2)
			)
			(2
				(HighPrint 22 57 25 4)
				(ego use: invGlowingGem)
				(eyes startUpd: show:)
				(= global323 4)
				(self cue:)
			)
			(3
				(ego setMotion: MoveTo 200 175 self)
			)
			(4
				(StopEgo)
				(ego loop: 3 forceUpd:)
				(= seconds 4)
			)
			(5
				(Bset 336)
				(HighPrint 22 58)
				(HighPrint 22 59)
				(HighPrint 22 60)
				(self cue:)
			)
			(6 (gate setScript: openGate))
		)
	)
)

(instance opener of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 15))
			(1
				(if (or (not (Btest 12)) (!= prevRoomNum 0))
					(localproc_0065)
				)
				(client setScript: 0)
			)
		)
	)
)

(instance boneTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(bonehead startUpd:)
				(= cycles 10)
			)
			(1
				(switch global323
					(0
						(= global323 1)
						(HighPrint 22 61)
					)
					(1 (HighPrint 22 62))
					(2
						(HighPrint 22 63)
						(= countdownAwaitingResponse 100)
					)
					(3
						(HighPrint 22 64)
						(= countdownAwaitingResponse 100)
					)
					(else 
						(if (and (Btest 11) (ego has: invMandrakeRoot))
							(HighPrint 22 65)
							(gate setScript: openGate)
						else
							(HighPrint 22 66)
							(= countdownAwaitingResponse 100)
						)
					)
				)
				(self cue:)
			)
			(2 (= cycles 10))
			(3
				(UnlockEgo)
				(bonehead cel: 0 stopUpd: setScript: 0)
				(if (and (ego has: invMandrakeRoot) (Btest 336))
					(gate setScript: openGate)
				)
			)
		)
	)
)

(instance openGate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(bonehead dispose:)
				(eyes dispose:)
				(gate ignoreActors: setPri: 1 setMotion: MoveTo 191 230)
				(dirt show: setCycle: Forward startUpd:)
				(= cycles 10)
			)
			(1
				(if (not (Btest 11))
					(HighPrint 22 67)
				else
					(HighPrint 22 68)
				)
				(self cue:)
			)
			(2
				(gate setMotion: MoveTo 191 230 self)
			)
			(3
				(gate stopUpd:)
				(= local2 1)
				(dirt setCycle: 0 setCel: 0 stopUpd:)
				(UnlockEgo)
			)
		)
	)
)

(instance walkEm of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canInput: 0)
				(frontLeg setCel: 1)
				(frontFoot
					setCel: 0
					posn: (+ (frontFoot x?) 5) (- (frontFoot y?) 5)
				)
				(= cycles 2)
			)
			(1
				(frontLeg
					setMotion: MoveTo (+ (frontLeg x?) 12) (+ (frontLeg y?) 8) self
				)
				(frontFoot
					setMotion: MoveTo (+ (frontFoot x?) 12) (+ (frontFoot y?) 8)
				)
			)
			(2
				(frontLeg
					setMotion: MoveTo (+ (frontLeg x?) 12) (+ (frontLeg y?) 8) self
				)
				(frontFoot
					setMotion: MoveTo (+ (frontFoot x?) 12) (+ (frontFoot y?) 8)
				)
				(hut setMotion: MoveTo (+ (hut x?) 12) (+ (hut y?) 8))
			)
			(3
				(frontLeg setCel: 0)
				(frontFoot
					setCel: 1
					posn: (- (frontFoot x?) 5) (+ (frontFoot y?) 5)
				)
				(hut setMotion: MoveTo (+ (hut x?) 12) (+ (hut y?) 8))
				(backLeg setCel: 1)
				(backFoot
					setCel: 0
					posn: (+ (backFoot x?) 5) (- (backFoot y?) 5)
				)
				(if (ego inRect: 123 0 235 103)
					(LockEgo)
					(ego
						view: 516
						setLoop: 3
						cel: 0
						cycleSpeed: 1
						setCycle: EndLoop
					)
					(= local3 1)
				)
				(= cycles 2)
			)
			(4
				(tromp number: (GetSongNumber 66) init: play:)
				(ShakeScreen 3)
				(backLeg
					setMotion: MoveTo (+ (backLeg x?) 24) (+ (backLeg y?) 16) self
				)
				(backFoot
					setMotion: MoveTo (+ (backFoot x?) 24) (+ (backFoot y?) 16)
				)
			)
			(5
				(backLeg setCel: 0)
				(backFoot
					setCel: 1
					posn: (- (backFoot x?) 5) (+ (backFoot y?) 5)
				)
				(= cycles 2)
			)
			(6
				(tromp play:)
				(ShakeScreen 3)
				(= cycles 2)
			)
			(7
				(frontLeg
					setCel: 1
					posn: (- (frontLeg x?) 5) (+ (frontLeg y?) 5)
				)
				(backLeg
					setCel: 1
					posn: (- (backLeg x?) 5) (+ (backLeg y?) 5)
				)
				(hut posn: (hut x?) (+ (hut y?) 10))
				(= cycles 1)
			)
			(8
				(frontLeg
					setCel: 2
					posn: (- (frontLeg x?) 2) (+ (frontLeg y?) 10)
				)
				(backLeg
					setCel: 2
					posn: (- (backLeg x?) 3) (+ (backLeg y?) 9)
				)
				(hut posn: (hut x?) (+ (hut y?) 10))
				(= cycles 1)
			)
			(9
				(frontLeg
					setCel: 2
					posn: (- (frontLeg x?) 1) (+ (frontLeg y?) 2)
				)
				(backLeg
					setCel: 2
					posn: (- (backLeg x?) 1) (+ (backLeg y?) 2)
				)
				(hut posn: (hut x?) (+ (hut y?) 10))
				(if local3 (ego setPri: 3))
				(= cycles 1)
			)
			(10
				(hut posn: (hut x?) (+ (hut y?) 10))
				(self cue:)
			)
			(11
				(= hutX (hut x?))
				(= hutY (hut y?))
				(hut stopUpd: ignoreActors: 0)
				(frontLeg dispose:)
				(backLeg dispose:)
				(frontFoot stopUpd:)
				(backFoot stopUpd:)
				(if local3 (ego dispose:))
				(= cycles 1)
			)
			(12
				(Bset 172)
				(tromp play:)
				(ShakeScreen 6 3)
				(= cycles 6)
			)
			(13
				(hutDoor
					ignoreActors:
					posn: (+ (hut x?) 17) (- (hut y?) 5)
					cel: 0
					init:
					setCycle: EndLoop self
				)
			)
			(14
				(UnlockEgo)
				(hutDoor stopUpd:)
				(hut setScript: 0)
				(if local3 (Die 22 69 80 { Bad strategy!_} 82 516 3 7))
			)
		)
	)
)

(instance flyAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(skull1 stopUpd: addToPic:)
				(skull2 stopUpd: addToPic:)
				(skull3 stopUpd: addToPic:)
				(skull4 stopUpd: addToPic:)
				(skull5 stopUpd: addToPic:)
				(if (gCast contains: gate) (gate addToPic:))
				(if (gCast contains: dirt) (dirt addToPic:))
				(if (gCast contains: bonehead) (bonehead addToPic:))
				(if (gCast contains: eyes) (eyes addToPic:))
				(TP
					ignoreActors:
					setPri: 15
					posn: 187 130
					init:
					setCycle: CycleTo 6 1 self
				)
			)
			(1
				(tpSound number: (GetSongNumber 28) init: play:)
				(TP setCycle: EndLoop)
				(ego posn: 187 130 init:)
				(hutDoor
					ignoreActors:
					posn: (+ (hut x?) 17) (- (hut y?) 5)
					cel: 2
					init:
					setPri: 4
					setCycle: BegLoop self
				)
				(FaceObject ego hutDoor)
			)
			(2
				(wing1
					ignoreActors:
					ignoreHorizon:
					setPri: 10
					posn: (- hutX 36) (- hutY 57)
					init:
					setCycle: EndLoop
				)
				(wing2
					ignoreActors:
					ignoreHorizon:
					posn: (+ hutX 46) (- hutY 52)
					init:
					setCycle: EndLoop self
				)
			)
			(3
				(hutDoor dispose:)
				(wing1 setLoop: 6 setCycle: Forward)
				(wing2 setLoop: 7 setCycle: Forward)
				(= cycles 12)
			)
			(4
				(ego loop: 3 forceUpd:)
				(localproc_0012 8 22 70)
				(hut setMotion: MoveTo hutX -100)
				(wing1 setMotion: MoveTo (wing1 x?) -43)
				(wing2 setMotion: MoveTo (wing2 x?) -58)
				(frontFoot
					ignoreHorizon:
					setMotion: MoveTo (frontFoot x?) -58
				)
				(backFoot
					ignoreHorizon:
					setMotion: MoveTo (backFoot x?) -58
				)
				(= seconds 8)
			)
			(5
				(Bset 173)
				(Bclear 172)
				(wing1 dispose:)
				(wing2 dispose:)
				(frontFoot dispose:)
				(backFoot dispose:)
				(hut dispose:)
				(curRoom newRoom: 600)
			)
		)
	)
)

(instance frogIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(TP setCycle: CycleTo 6 1 self)
			)
			(1
				(tpSound number: (GetSongNumber 28) init: play:)
				(ego init:)
				(TP setCycle: EndLoop)
				(= cycles 10)
			)
			(2
				(if (>= global324 3)
					(self changeState: 5)
				else
					(HighPrint 22 71)
					(HighPrint 22 72)
					(Print 22 73 #at -1 12 #width 145 #mode 1 #time 8)
					(= seconds 3)
					; "Hear me, oh Powers
; Of Mana and More:
; Turn this fool back
; As he was before."
				)
			)
			(3
				(tpSound play:)
				(ego setCycle: BegLoop self)
			)
			(4
				(StopEgo)
				(ego loop: 1)
				(= cycles 10)
			)
			(5
				(UnlockEgo)
				(switch global324
					(2
						(HighPrint 22 74)
						(Bset 326)
						(= dayCursedByBabaYaga currentDay)
					)
					(3 (HighPrint 22 75))
				)
				(TP dispose:)
			)
		)
	)
)
