;;; Sierra Script 1.0 - (do not remove this comment)
(script# 14)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowDagger1)
(use AnimateCalm)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm14 0
	bear 1
	bearUp 2
)

(local
	local0
	local1
	local2
	local3
	local4
	local5 =  6
	local6
	local7
	local8
	local9
	local10
	local11
	local12
	local13
	local14
	local15
	local16
	[local17 11]
	[local28 11]
	[local39 5]
	[local44 5]
	local49
	[local50 4]
)
(procedure (localproc_07b2)
	(= [local50 0] 146)
	(= [local50 1] 124)
	(= [local50 2] 319)
	(= [local50 3] 189)
	(if (< (ego x?) (bear x?))
		(= local1 110)
		(= local2 40)
	else
		(= local1 20)
		(= local2 5)
	)
)

(procedure (localproc_1002)
	(= local11 (- (bear x?) (ego x?)))
	(= local12 (- (bear y?) (ego y?)))
	(= local13 (+ (ego x?) (* local11 30)))
	(= local14 (+ (ego y?) (* local12 30)))
)

(instance magicHit of Sound
	(properties
		number 45
		priority 1
	)
)

(instance egoShoots of Sound
	(properties
		number 33
		priority 2
	)
)

(instance rm14 of Room
	(properties
		picture 14
		style $0003
		east 15
		south 13
	)
	
	(method (init)
		(if (not (Btest 161))
			(LoadMany 128 420 516 15 510)
			(if (ego knows: skFLAMEDART)
				(Load rsVIEW 522)
				(LoadMany 132 (GetSongNumber 33) (GetSongNumber 45))
			)
			(= gMonsterHealth 133)
			(= global332 420)
		)
		(if (ego knows: skDAZZLE)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: skCALM)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: skOPEN)
			(Load rsVIEW 521)
			(Load rsSCRIPT 105)
		)
		(Load rsSCRIPT 101)
		(Load rsSOUND 20)
		(super init:)
		(if (== egoWalkMode MOVE_RUN) (ChangeEgoWalk MOVE_WALK FALSE))
		(cond 
			((== prevRoomNum 13) (cSound priority: 1 number: 20 loop: -1 play:))
			((== (cSound number?) 23) (cSound priority: 1 number: 20 loop: -1 play:))
		)
		(if (not (Btest 161))
			(if (ego knows: skFLAMEDART)
				(egoShoots number: (GetSongNumber 33) init:)
				(magicHit number: (GetSongNumber 45) init:)
			)
			(dart init: stopUpd:)
			(puff init: stopUpd:)
			(bear ignoreActors: init: setPri: 11 stopUpd:)
		)
		(drip init: setScript: dripScript)
		(= local49 (Random 0 4))
		(= [local39 0] 144)
		(= [local44 0] 184)
		(= [local39 1] 249)
		(= [local44 1] 221)
		(= [local39 2] 283)
		(= [local44 2] 219)
		(= [local39 3] 88)
		(= [local44 3] 201)
		(= [local39 4] 165)
		(= [local44 4] 168)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(if (not (Btest 161)) (ego illegalBits: (& cWHITE cYELLOW)))
		(switch prevRoomNum
			(15
				(ego posn: 318 145 setMotion: MoveTo 308 151)
				(= local1 20)
				(= local2 12)
			)
			(else 
				(ego setScript: entranceMsg)
				(= local1 110)
				(= local2 40)
			)
		)
	)
	
	(method (dispose)
		(Bset 4)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(DisposeDialog)
				(cond 
					((Said 'look>')
						(cond 
							((Said '/stalactite') (HighPrint 14 0))
							((Said '/stalagmite') (HighPrint 14 1))
							((Said '[<at,around][/!*,cave,room]') (HighPrint 14 2))
							((Said '/wall,fungus,north,west,formation') (HighPrint 14 3))
							((or (Said '<up') (Said '/ceiling')) (HighPrint 14 4) (HighPrint 14 5))
							((or (Said '<down') (Said '/floor')) (HighPrint 14 6) (HighPrint 14 7))
							((Said '/south,entrance,open') (HighPrint 14 8))
							((Said '/east') (HighPrint 14 9))
							((Said '/baron') (HighPrint 14 10))
							((Said '/barnard,man')
								(if (Btest 161)
									(HighPrint 14 11)
								else
									(HighPrint 14 12)
								)
							)
							((Said '/bear,animal,creature,monster')
								(cond 
									((Btest 161) (HighPrint 14 11))
									((or local9 (Btest 160)) (HighPrint 14 13))
									(local8 (HighPrint 14 14))
									(local6 (HighPrint 14 15))
									((or (== local0 0) (== local0 2)) (HighPrint 14 16))
									(else (HighPrint 14 17))
								)
							)
							((Said '/leg,chain,manacle,feet,hasp')
								(= local4 (ego distanceTo: bear))
								(cond 
									((Btest 161) (HighPrint 14 18))
									((>= local4 local1) (HighPrint 14 19))
									(else (HighPrint 14 20))
								)
							)
							(else (HighPrint 14 21))
						)
					)
					((Said 'get>')
						(cond 
							((Said '/fungus') (HighPrint 14 22))
							((Said '/bear,stalactite,stalagmite') (HighPrint 14 23))
							(
							(and (not (Btest 161)) (Said '/dagger,dagger')) (HighPrint 14 24))
						)
					)
					((Said 'throw/dagger,dagger')
						(AnimateThrowingDagger (if (Btest 161) 0 else bear))
						(Bclear 160)
						(= local9 0)
					)
					((Said 'throw/boulder') (HighPrint 14 25))
					((Said 'throw/food,ration') (HighPrint 14 26))
					((Said 'climb') (HighPrint 14 27))
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC
									(if (Btest 161)
										(HighPrint 14 28)
									else
										(HighPrint 14 29)
									)
								)
								(skDAZZLE
									(cond 
										((Btest 161) (HighPrint 14 30))
										((AnimateDazzle) (= local8 1))
									)
								)
								(skFLAMEDART
									(if (Btest 161)
										(HighPrint 14 30)
									else
										(Bclear 160)
										(= local9 0)
										(dart setScript: flameDart)
									)
								)
								(skCALM
									(cond 
										((Btest 161) (HighPrint 14 30))
										((AnimateCalm) (= local9 1) (AddToScore POINTS_CALMBEAR 5))
									)
								)
								(skOPEN
									(if (Btest 161)
										(HighPrint 14 30)
									else
										(HighPrint 14 31)
									)
								)
								(else  (pEvent claimed: 0))
							)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance dart of Actor
	(properties
		z 25
		view 522
		illegalBits $0000
	)
)

(instance puff of Prop
	(properties
		z 25
		view 522
		loop 3
	)
)

(instance bear of TargActor
	(properties
		y 144
		x 273
		view 420
		targDeltaY -5
	)
	
	(method (doit)
		(= local4 (ego distanceTo: self))
		(cond 
			((or local3 (== local0 4) (== local0 5)))
			(local8
				(if (== (-- local8) 0)
					(bear startUpd:)
				else
					(localproc_07b2)
				)
			)
			((or (Btest 160) local9)
				(localproc_07b2)
				(if (or (== local0 3) (== local0 1))
					(bear setScript: bearDrop)
				)
			)
			((> local4 local1)
				(if (not local7)
					(switch local0
						(1 (bear setScript: bearDrop))
						(3 (bear setScript: bearDrop))
					)
				)
			)
			((and (>= local1 local4) (>= local4 local2))
				(if (and (not local7) (== local0 0))
					(bear setScript: bearUp)
				)
			)
			((> (+ (ego y?) 15) (bear y?))
				(cond 
					((< (ego x?) (- (bear x?) 15))
						(if (not local3)
							(++ local3)
							(bear setScript: bearKills)
						)
					)
					((not local3) (++ local3) (bear setScript: bearKillsRm15))
				)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'pat/bear,animal') (HighPrint 14 32))
					((Said 'chat/bear,animal')
						(if (Btest 312)
							(HighPrint 14 33)
						else
							(Bset 312)
							(HighPrint 14 34)
						)
					)
					(
					(or (Said 'feed/bear') (Said 'gave/food,ration[/bear]'))
						(cond 
							(local7 (HighPrint 14 35))
							((ego has: invFoodRation)
								(if
								(not (if (> (ego x?) 180) (> (ego y?) 132)))
									(PrintNotCloseEnough)
								else
									(ego use: invFoodRation)
									(HighPrint 14 36)
									(Bset 160)
									(AddToScore POINTS_CALMBEAR 5)
								)
							)
							(else (PrintDontHaveIt))
						)
					)
					((Said 'kill,chop,beat,fight') (curRoom newRoom: 420))
					(
						(or
							(Said
								'free,unlock/bear,animal,creature,chain,manacle,chain'
							)
							(Said 'use/key')
						)
						(if (ego has: invLargeBrassKey)
							(if
								(and
									(or local8 local9 (Btest 160))
									(ego
										inRect: [local50 0] [local50 1] [local50 2] [local50 3]
									)
								)
								(AddToScore POINTS_FREEBEAR 25)
								(self setScript: useKey)
							else
								(PrintNotCloseEnough)
							)
						else
							(HighPrint 14 37)
						)
					)
					((Said 'lockpick/hasp,manacle,chain') (HighPrint 14 38))
				)
			)
		)
		(super handleEvent: pEvent)
	)
	
	(method (getHurt param1)
		(if
		(<= (= gMonsterHealth (- gMonsterHealth param1)) 0)
			(Bset 169)
			(curRoom newRoom: 171)
		)
	)
)

(instance drip of Prop
	(properties
		y 204
		x 79
		view 15
	)
)

(instance entranceMsg of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego posn: 57 189 setMotion: MoveTo 60 178)
				(= cycles 15)
			)
			(1 (ego loop: 0) (= cycles 5))
			(2
				(if (and (not (Btest 161)) (not (Btest 175)))
					(HighPrint 14 39)
					(Bset 175)
				)
				(UnlockEgo)
			)
		)
	)
)

(instance bearUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0)
				(= local0 1)
				(bear setCycle: EndLoop self)
			)
			(1
				(if (and (not local7) (not (Btest 167)))
					(HighPrint 14 40)
					(Bset 167)
				)
				(= local0 3)
			)
		)
	)
)

(instance bearDrop of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== local0 1)
					(= local0 2)
					(bear setCycle: BegLoop self)
				else
					(= local0 2)
					(bear setLoop: 0 cel: local5 setCycle: BegLoop self)
				)
			)
			(1 (= local0 0))
		)
	)
)

(instance flameDart of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(++ local7)
				(TestSkill skMP 0 5)
				(TestSkill skFLAMEDART 0 5)
				(ego
					view: 522
					setLoop: (if (< (ego x?) (bear x?)) 0 else 1)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(egoShoots play:)
				(ego setCycle: EndLoop)
				(= local10 (Random 0 300))
				(if
					(or
						(< local10 (= local4 (ego distanceTo: bear)))
						(== local0 1)
						(== local0 2)
					)
					(dart setScript: bouncer)
					(self changeState: 5)
				else
					(dart
						setLoop: 2
						setStep: 18 12
						setPri: 12
						ignoreActors: 1
						posn: (ego x?) (ego y?)
						show:
						setCycle: Forward
						startUpd:
					)
					(++ local6)
					(bear getHurt: (+ 5 (/ [skills skSTRENGTH] 10)))
					(if (== local0 0)
						(dart
							setMotion:
								MoveTo
								(- (bear x?) (Random 24 49))
								(+ (bear y?) (Random 5 15))
								self
						)
					else
						(dart
							setMotion:
								MoveTo
								(+ (bear x?) (- (Random 0 10) 10))
								(+ (bear y?) (- (Random 0 17) 19))
								self
						)
					)
				)
			)
			(2
				(magicHit play:)
				(dart setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(3
				(if (not (if (== local0 1) else (== local0 3)))
					(bear setScript: bearUp)
					(self cue:)
				else
					(self cue:)
				)
			)
			(4
				(= local0 3)
				(bear setLoop: 1 cel: 0 setCycle: EndLoop self)
			)
			(5
				(StopEgo)
				(ego illegalBits: (& cWHITE cYELLOW))
				(FaceObject ego bear)
				(UnlockEgo)
				(if (or (== local0 0) (== local0 2))
					(bear setScript: bearUp)
				)
				(ego setScript: 0)
			)
		)
	)
)

(instance bouncer of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(= [local17 0] 253)
		(= [local28 0] 101)
		(= [local17 1] 295)
		(= [local28 1] 64)
		(= [local17 2] 149)
		(= [local28 2] 19)
		(= [local17 3] 226)
		(= [local28 3] 164)
		(= [local17 4] 284)
		(= [local28 4] 152)
		(= [local17 5] 319)
		(= [local28 5] 103)
		(= [local17 6] 93)
		(= [local28 6] 91)
		(= [local17 7] 152)
		(= [local28 7] 61)
		(= [local17 8] 223)
		(= [local28 8] 58)
		(= [local17 9] 29)
		(= [local28 9] 130)
		(= [local17 10] 65)
		(= [local28 10] 54)
	)
	
	(method (doit)
		(if
		(and local15 (not (dart inRect: 10 35 310 205)))
			(= local15 0)
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local16 (Random 3 5))
				(dart posn: (ego x?) (ego y?))
				(self cue:)
			)
			(1
				(= local15 1)
				(localproc_1002)
				(dart
					show:
					setLoop: 2
					setStep: 18 12
					setPri: 12
					ignoreActors:
					setCycle: Forward
					startUpd:
					setMotion: MoveTo local13 local14
				)
			)
			(2
				(puff
					ignoreActors:
					cel: 0
					setPri: 12
					posn: (dart x?) (dart y?)
					setCycle: EndLoop
				)
				(= local16 (+ local16 (Random 1 3)))
				(dart
					setMotion: MoveTo [local17 local16] [local28 local16] self
				)
			)
			(3
				(if (< local16 10)
					(self changeState: 2)
				else
					(self cue:)
				)
			)
			(4
				(dart setLoop: 3 cel: 0 setMotion: 0 setCycle: EndLoop self)
			)
			(5 (dart setScript: 0))
		)
	)
)

(instance bearKills of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (LockEgo) (= cycles 3))
			(1
				(bear loop: 2 cel: 0 setCycle: EndLoop)
				(= cycles 1)
			)
			(2
				(bear loop: 3 cel: 0 setCycle: EndLoop)
				(ego
					view: 516
					loop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 12))
			(4
				(Die 14 41 80 {OH NOOOOOOO!} 82 800 0 0)
			)
		)
	)
)

(instance bearKillsRm15 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego ignoreActors: 1 setMotion: MoveTo 235 (ego y?) self)
			)
			(1
				(bear loop: 2 cel: 0 setCycle: EndLoop self)
			)
			(2
				(bear loop: 3 cel: 0 setCycle: EndLoop)
				(ego
					view: 516
					loop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 15))
			(4
				(Die 14 42 80 {OH NOOOOOOO!} 82 800 0 0)
			)
		)
	)
)

(instance useKey of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego use: invLargeBrassKey)
				(LockEgo)
				(= local0 5)
				(bear setCycle: EndLoop self)
			)
			(1
				(ego
					ignoreActors:
					illegalBits: 0
					setMotion: MoveTo 209 149 self
				)
			)
			(2
				(bear stopUpd:)
				(ego setMotion: MoveTo (- (bear x?) 22) (bear y?) self)
			)
			(3
				(ego view: 510 loop: 0 cel: 0 setCycle: EndLoop self)
			)
			(4
				(HighPrint 14 43)
				(StopEgo)
				(Bset 170)
				(= global321 2)
				(curRoom newRoom: 171)
			)
		)
	)
)

(instance dripScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(drip
					posn: [local39 local49] [local44 local49]
					setCycle: EndLoop
				)
				(= cycles (Random 20 40))
			)
			(1
				(= local49 (Random 0 4))
				(self changeState: 0)
			)
		)
	)
)
