;;; Sierra Script 1.0 - (do not remove this comment)
(script# 93)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateCalm)
(use AnimateOpen)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm93 0
	minotaur 1
	gate 2
	openGate 3
	bell 4
	archer1 5
	archer2 6
	archer3 7
	archer4 8
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8 =  5
	local9
	local10
	local11
)
(procedure (localproc_001c &tmp temp0)
	(= temp0 1)
	(switch local3
		(0
			(if (< (+ (minotaur x?) local8) (ego x?))
				(= temp0 0)
			)
		)
		(1
			(if (< (ego x?) (- (minotaur x?) local8))
				(= temp0 0)
			)
		)
		(2
			(if (< (+ (minotaur y?) local8) (ego y?))
				(= temp0 0)
			)
		)
		(else 
			(if (< (ego y?) (- (minotaur y?) local8))
				(= temp0 0)
			)
		)
	)
	(return temp0)
)

(instance rm93 of Room
	(properties
		picture 93
		style $0008
	)
	
	(method (init)
		(LoadMany 128 93 550 5 523 510 538 426 503 524)
		(LoadMany
			132
			23
			(GetSongNumber 35)
			(GetSongNumber 39)
			(GetSongNumber 31)
		)
		(LoadMany 130 103 102 101)
		(if (ego knows: 23)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(if (ego knows: 20)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: 22)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: 17)
			(Load rsVIEW 521)
			(Load rsSCRIPT 105)
		)
		(cSound priority: 1 number: 23 loop: -1 play:)
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures: onBell onSign onDoor onBush onRock onFort
		)
		(StatusLine enable:)
		(StopEgo)
		(LockEgo)
		(gateSign setPri: 6 init: addToPic:)
		(bell setPri: 6 init: stopUpd:)
		(bush init: stopUpd:)
		(if (Btest 238)
			(gate setCel: 3 setPri: 6 ignoreActors: init: stopUpd:)
			(ego illegalBits: cWHITE)
		else
			(gate setCel: 0 setPri: 6 init: stopUpd:)
			(ego illegalBits: (& cWHITE cLRED))
		)
		(if (not (Btest 237))
			(= global332 425)
			(= gMonsterHealth 186)
		)
		(switch prevRoomNum
			(89
				(= local0 1)
				(if (not (Btest 237))
					(Load rsVIEW 425)
					(= local4 1)
					(= local3 0)
					(minotaur illegalBits: 0 init: setScript: patrol)
				)
				(ego posn: 2 123 init: setScript: (ScriptID 271 0))
			)
			(94
				(if (not (Btest 237))
					(Load rsVIEW 425)
					(= local4 0)
					(= local3 1)
					(minotaur
						setLoop: 1
						posn: 145 162
						illegalBits: 0
						init:
						setScript: patrol
					)
				)
				(if (Btest 238)
					(ego posn: 174 98 init: setScript: (ScriptID 272 0))
				else
					(ego posn: 143 108 init: setScript: (ScriptID 275 0))
				)
			)
			(425
				(Load rsVIEW 519)
				(Load rsVIEW 426)
				(Bset 237)
				(minotaur
					view: 426
					setLoop: 0
					setCel: 0
					init:
					posn: 230 145
				)
				(ego posn: 235 158 init: setScript: (ScriptID 274 0))
			)
			(else 
				(if (not (Btest 237))
					(Load rsVIEW 425)
					(= local4 0)
					(= local3 1)
					(minotaur illegalBits: 0 init: setScript: patrol)
				)
				(ego posn: 235 188 init: setScript: (ScriptID 273 0))
			)
		)
	)
	
	(method (doit)
		(cond 
			((and local1 (== (ego edgeHit?) 4))
				(Bset 83)
				(= global332 (= gMonsterHealth 0))
				(curRoom newRoom: 89)
			)
			((and local1 (& (ego onControl: origin) cLRED))
				(Bset 83)
				(= global332 (= gMonsterHealth 0))
				(curRoom newRoom: 94)
			)
			(
			(or (== (ego edgeHit?) 3) (== (ego edgeHit?) 2))
				(Bset 83)
				(= global332 (= gMonsterHealth 0))
				(curRoom newRoom: 91)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl ego pEvent 3) (HighPrint 93 0))
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'rest,nap') (Die 93 1 80 {Z-Z-Z-Z-Z-Z-Z-Z-Z-Z} 82 800 0 0))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/place,area]') (HighPrint 93 2))
							((Said '[<at]/boulder') (HighPrint 93 3))
							((Said '[<at]/cliff') (HighPrint 93 4))
							((Said '[<at]/log,gate') (HighPrint 93 5))
							((or (Said '<up') (Said '/sky')) (HighPrint 93 6))
							((or (Said '<down') (Said '/ground,grass')) (HighPrint 93 7))
							((Said '/bush') (if local0 (HighPrint 93 8) else (HighPrint 93 9)))
							((Said '/west')
								(if local0
									(HighPrint 93 10)
								else
									(HighPrint 93 11)
								)
							)
							((Said '/north') (HighPrint 93 12))
							((Said '/east') (HighPrint 93 13))
							((Said '/south') (HighPrint 93 14))
							((Said '/bell') (HighPrint 93 15))
							((Said '/sign')
								(if (ego inRect: 150 92 250 140)
									(HighPrint 93 16)
								else
									(HighPrint 93 17)
								)
							)
						)
					)
					((Said 'cast>')
						(= local5 (SaidCast pEvent))
						(if (CastSpell local5)
							(switch local5
								(skDETECTMAGIC (HighPrint 93 18))
								(skDAZZLE
									(cond 
										((or (Btest 237) local6 local9) (HighPrint 93 19))
										((AnimateDazzle ego minotaurDazzled) (minotaur setScript: minotaurDazzled))
									)
								)
								(skFLAMEDART
									(cond 
										(
											(or
												(ego inRect: 47 141 90 163)
												(ego inRect: 0 119 35 126)
												(ego inRect: 238 0 330 106)
											)
											(HighPrint 93 20)
										)
										((Btest 237) (AnimateThrowingFlameDart 0))
										(else
											(if (< (ego x?) 160)
												(minotaur targDeltaX: -25)
											else
												(minotaur targDeltaX: 25)
											)
											(AnimateThrowingFlameDart minotaur)
											(if (or local6 local7) (minotaur setScript: patrol))
										)
									)
								)
								(skCALM
									(cond 
										((or (Btest 237) local6) (HighPrint 93 19))
										((AnimateCalm ego minotaurCalmed) (minotaur setScript: minotaurCalmed))
									)
								)
								(skOPEN
									(if (or local2 (Btest 238))
										(HighPrint 93 19)
									else
										(AnimateOpenSpell ego openMess)
										(gate setScript: openMess)
									)
								)
								(else  (HighPrint 93 19))
							)
						)
					)
					((Said 'throw/dagger,dagger')
						(cond 
							(
								(or
									(ego inRect: 47 141 90 163)
									(ego inRect: 0 119 35 126)
									(ego inRect: 238 0 330 106)
								)
								(HighPrint 93 20)
							)
							((Btest 237) (AnimateThrowingDagger 0))
							(else
								(if (< (ego x?) 160)
									(minotaur targDeltaX: -25)
								else
									(minotaur targDeltaX: 25)
								)
								(AnimateThrowingDagger minotaur)
								(if (or local6 local7) (minotaur setScript: patrol))
							)
						)
					)
					((Said 'throw/boulder')
						(if
						(and (AnimateThrowingRock minotaur) (or local6 local7))
							(minotaur setScript: patrol)
						)
					)
					((Said 'get/boulder') (ego setScript: (ScriptID 103 0)))
					((Said 'climb')
						(cond 
							((ego inRect: 92 95 214 107) (HighPrint 93 21))
							((ego inRect: 269 120 303 151) (HighPrint 93 22))
							((and (< (ego x?) 97) (< (ego y?) 108)) (ego setScript: (ScriptID 277 0)))
							((ego inRect: 238 0 330 106)
								(if (TestSkill skCLIMBING 65)
									(ego setScript: (ScriptID 276 0))
								else
									(HighPrint 93 23)
								)
							)
							((ego inRect: 47 141 90 163) (HighPrint 93 24))
							(else (HighPrint 93 25))
						)
					)
					((Said 'open[/gate,door]')
						(cond 
							((Btest 238) (HighPrint 93 26))
							((and local2 (ego inRect: 128 95 186 106)) (ego setScript: openGate))
							(local2 (HighPrint 93 27))
							(else (HighPrint 93 28))
						)
					)
					((Said 'close,close[/gate,door]')
						(cond 
							((and (ego inRect: 128 95 186 106) (Btest 238)) (ego setScript: closeGate))
							((Btest 238) (HighPrint 93 27))
							(else (HighPrint 93 29))
						)
					)
					((Said 'break,force,beat/gate,door')
						(cond 
							((Btest 238) (HighPrint 93 30))
							(
								(and
									(< 95 (ego x?))
									(< (ego x?) 230)
									(< (ego y?) 150)
								)
								(ego setScript: (ScriptID 278 0))
							)
							(else (HighPrint 93 27))
						)
					)
					((Said 'knock/door,gate') (HighPrint 93 31))
					((or (Said 'look/sign') (Said 'read/sign'))
						(if (ego inRect: 150 92 250 140)
							(HighPrint 93 16)
						else
							(HighPrint 93 17)
						)
					)
					((Said 'ring/bell')
						(if (ego inRect: 150 92 250 140)
							(bell setScript: (ScriptID 279 0))
						else
							(HighPrint 93 32)
						)
					)
				)
			)
		)
	)
	
	(method (notify param1)
		(switch param1
			(0 (= local1 1))
			(1 (= local1 0))
			(2 (= local9 1))
			(3 (= local9 0))
		)
	)
)

(instance gate of Prop
	(properties
		y 95
		x 129
		view 93
	)
)

(instance bell of Prop
	(properties
		y 69
		x 197
		z 1
		view 93
		loop 1
	)
)

(instance gateSign of Prop
	(properties
		y 57
		x 197
		z 1
		view 93
		loop 2
	)
)

(instance bush of Prop
	(properties
		y 128
		x 23
		view 93
		loop 3
	)
	
	(method (doit)
		(if
			(and
				(not (if (== egoWalkMode MOVE_SNEAK) (>= [skills skSTEALTH] 50)))
				(ego inRect: 8 119 35 126)
				(== (bush script?) 0)
			)
			(bush setScript: jerkBush)
		)
		(super doit:)
	)
)

(instance archer1 of Actor
	(properties
		y 57
		x 247
		view 93
		loop 4
		priority 5
	)
)

(instance archer2 of Actor
	(properties
		y 56
		x 207
		view 93
		loop 4
		priority 5
	)
)

(instance archer3 of Actor
	(properties
		y 56
		x 109
		view 93
		loop 5
		priority 5
	)
)

(instance archer4 of Actor
	(properties
		y 56
		x 69
		view 93
		loop 5
		priority 5
	)
)

(instance lockSound of Sound
	(properties
		number 35
		priority 3
	)
)

(instance onBell of RFeature
	(properties
		nsTop 56
		nsLeft 193
		nsBottom 68
		nsRight 202
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBell pEvent 3) (HighPrint 93 33))
		)
	)
)

(instance onSign of RFeature
	(properties
		nsTop 48
		nsLeft 191
		nsBottom 55
		nsRight 201
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSign pEvent 3) (HighPrint 93 34))
		)
	)
)

(instance onDoor of RFeature
	(properties
		nsTop 38
		nsLeft 128
		nsBottom 95
		nsRight 186
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onDoor pEvent 3) (HighPrint 93 35))
		)
	)
)

(instance onBush of RFeature
	(properties
		nsTop 85
		nsLeft 9
		nsBottom 128
		nsRight 34
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBush pEvent 3) (HighPrint 93 36))
		)
	)
)

(instance onRock of RFeature
	(properties
		nsTop 125
		nsLeft 47
		nsBottom 159
		nsRight 94
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRock pEvent 3) (HighPrint 93 37))
		)
	)
)

(instance onFort of RFeature
	(properties
		nsBottom 24
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFort pEvent 3) (HighPrint 93 38))
		)
	)
)

(instance minotaur of TargActor
	(properties
		y 162
		x 60
		view 425
		targDeltaX 25
		targDeltaY -15
	)
	
	(method (doit)
		(if
			(not
				(if
					(or
						local6
						(ego inRect: 0 120 31 130)
						(ego inRect: 238 0 330 106)
						(ego inRect: 61 153 82 154)
						(> (ego distanceTo: minotaur) 100)
						(and
							(== egoWalkMode MOVE_SNEAK)
							(>= [skills skSTEALTH] 50)
							(localproc_001c)
						)
						(== (self script?) minotaurLooks)
						(== local9 1)
					)
				else
					(Btest 237)
				)
			)
			(self setScript: minotaurLooks)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl minotaur pEvent 3) (HighPrint 93 39))
				)
			)
			(evSAID
				(cond 
					((Said 'search[/bull,body,flail]')
						(cond 
							(local6 (HighPrint 93 40) (curRoom newRoom: 425))
							((Btest 237)
								(if local10
									(HighPrint 93 41)
								else
									(= local10 1)
									(HighPrint 93 42)
									(HighPrint 93 43)
									(HighPrint 93 44)
									(HighPrint 93 45)
									(HighPrint 93 46)
									(ego get: invSilverCoin 50)
								)
							)
							(else (HighPrint 93 47))
						)
					)
					((Said 'look/bull,monster,creature')
						(if (Btest 237)
							(HighPrint 93 48)
						else
							(HighPrint 93 49)
						)
					)
					((Said 'kill,chop,beat/bull,monster,creature')
						(if (Btest 237)
							(HighPrint 93 50)
						else
							(HighPrint 93 51)
						)
						(curRoom newRoom: 425)
					)
				)
			)
		)
	)
	
	(method (getHurt param1)
		(cond 
			(
			(<= (= gMonsterHealth (- gMonsterHealth param1)) 0) (self setScript: minotaurDies) (Bset 237))
			((not local6) (rm93 setScript: delayLook))
		)
	)
)

(instance delayLook of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(minotaur setScript: minotaurLooks)
			)
		)
	)
)

(instance minotaurLooks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(minotaur
					setLoop: 2
					setCel: 0
					setMotion: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(1
				(= local3 2)
				(if (localproc_001c)
					(minotaur setLoop: 3 setCel: 1)
					(= cycles 1)
				else
					(self changeState: 3)
				)
			)
			(2
				(minotaur setCel: 2)
				(= local3 3)
				(= cycles 1)
			)
			(3
				(if
					(or
						(ego inRect: 0 120 31 130)
						(ego inRect: 238 0 330 106)
						(ego inRect: 61 153 82 154)
					)
					(if (< 5 local11) (= local11 0) else (++ local11))
					(switch local11
						(0 (HighPrint 93 52))
						(1 (HighPrint 93 53))
						(2 (HighPrint 93 54))
						(3 (HighPrint 93 55))
						(4 (HighPrint 93 56))
						(5 (HighPrint 93 57))
					)
					(client setScript: patrol)
				else
					(curRoom newRoom: 425)
				)
			)
		)
	)
)

(instance jerkBush of Script
	(properties)
	
	(method (doit)
		(if (and (== egoWalkMode MOVE_SNEAK) (>= [skills skSTEALTH] 50))
			(self dispose:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (bush setCycle: EndLoop self))
			(1
				(if (and (not (Btest 237)) (not local6))
					(minotaur setScript: minotaurLooks)
				)
				(= seconds 17)
			)
			(2 (self dispose:))
		)
	)
)

(instance openGate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(gate
					ignoreActors:
					cycleSpeed: 3
					setPri: 4
					setCycle: EndLoop self
				)
			)
			(1
				(Bset 238)
				(ego illegalBits: cWHITE)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance closeGate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(gate
					ignoreActors: 1
					setCel: 3
					cycleSpeed: 3
					setCycle: BegLoop self
				)
			)
			(1
				(Bclear 238)
				(ego illegalBits: (& cWHITE cLRED))
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance openMess of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(= local9 1)
				(HighPrint 93 58)
				(lockSound number: (GetSongNumber 35) init: play:)
				(= local2 1)
				(= cycles 1)
			)
			(2
				(lockSound dispose:)
				(= seconds 3)
			)
			(3
				(= local9 0)
				(self dispose:)
			)
		)
	)
)

(instance patrol of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(minotaur moveSpeed: 1 cycleSpeed: 1 setCycle: 0)
				(if local6
					(self changeState: 5)
				else
					(= local9 0)
					(switch local3
						(0 (self changeState: 10))
						(1 (self changeState: 14))
						(2
							(if local4
								(self changeState: 17)
							else
								(self changeState: 13)
							)
						)
						(3
							(if local4
								(self changeState: 3)
							else
								(self changeState: 1)
							)
						)
					)
				)
			)
			(1
				(= local4 0)
				(= local3 1)
				(minotaur view: 425 setLoop: 3 setCel: 0)
				(= cycles 1)
			)
			(2 (self changeState: 14))
			(3
				(= local4 1)
				(= local3 0)
				(minotaur view: 425 setLoop: 3 setCel: 1)
				(= cycles 1)
			)
			(4 (self changeState: 10))
			(5
				(minotaur cycleSpeed: 4 setCycle: BegLoop self)
			)
			(6
				(= local6 0)
				(= local3 2)
				(self changeState: 0)
			)
			(10
				(= local4 1)
				(= local3 0)
				(minotaur
					view: 425
					setLoop: 0
					setCel: 0
					setCycle: Forward
					setMotion: MoveTo 279 (minotaur y?) self
				)
			)
			(11
				(= local4 0)
				(minotaur setLoop: 2 setCel: 3)
				(= cycles 1)
			)
			(12
				(minotaur setLoop: 2 setCel: 2)
				(= cycles 1)
			)
			(13
				(= local3 1)
				(minotaur view: 425 setLoop: 2 setCel: 1)
				(= cycles 1)
			)
			(14
				(= local4 0)
				(= local3 1)
				(minotaur
					view: 425
					setLoop: 1
					setCel: 0
					setCycle: Forward
					setMotion: MoveTo 60 (minotaur y?) self
				)
			)
			(15
				(= local4 1)
				(minotaur setLoop: 2 setCel: 1)
				(= cycles 1)
			)
			(16
				(minotaur setLoop: 2 setCel: 2)
				(= cycles 1)
			)
			(17
				(= local3 0)
				(minotaur view: 425 setLoop: 2 setCel: 3)
				(= cycles 1)
			)
			(18 (self changeState: 10))
		)
	)
)

(instance minotaurCalmed of Script
	(properties)
	
	(method (doit)
		(if (and (not (ego script?)) (not isEgoLocked))
			(LockEgo)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local9 1)
				(LockEgo)
				(minotaur setCycle: 0 setMotion: 0)
			)
			(1
				(switch local3
					(0 (self changeState: 3))
					(1 (self changeState: 8))
					(2 (self changeState: 10))
					(3 (self changeState: 2))
				)
			)
			(2
				(minotaur setLoop: 0 setCel: 0)
				(= cycles 1)
			)
			(3
				(minotaur setLoop: 2 setCel: 3)
				(= cycles 1)
			)
			(4
				(minotaur setLoop: 2 setCel: 2)
				(= cycles 1)
			)
			(5 (self changeState: 10))
			(8
				(= local4 1)
				(minotaur setLoop: 2 setCel: 1)
				(= cycles 1)
			)
			(9
				(minotaur setLoop: 2 setCel: 2)
				(= cycles 1)
			)
			(10
				(minotaur
					setLoop: 4
					setCel: 0
					cycleSpeed: 8
					setCycle: EndLoop self
				)
			)
			(11
				(client setScript: minotaurSleeps)
			)
		)
	)
)

(instance minotaurDazzled of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local9 1)
				(minotaur setCycle: 0 setMotion: 0)
			)
			(1
				(minotaur setLoop: 4 setCel: 1)
				(= cycles 5)
			)
			(2
				(minotaur setCel: 0)
				(= cycles 5)
			)
			(3
				(minotaur setCel: 1)
				(= cycles 2)
			)
			(4
				(minotaur setCel: 0)
				(= cycles 2)
			)
			(5
				(minotaur setCel: 1)
				(= local7 1)
				(UnlockEgo)
				(= seconds 12)
			)
			(6
				(= local7 0)
				(= local9 0)
				(client setScript: patrol)
			)
		)
	)
)

(instance minotaurSleeps of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (< (minotaur x?) 79)
					(minotaur
						setLoop: 0
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: Walk
						setMotion: MoveTo 79 162 self
					)
				else
					(minotaur
						setLoop: 1
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: Walk
						setMotion: MoveTo 79 162 self
					)
				)
			)
			(1
				(= local6 1)
				(minotaur
					view: 426
					setLoop: 0
					cel: 0
					cycleSpeed: 4
					illegalBits: 0
					setCycle: CycleTo 3 1 self
				)
			)
			(2
				(= local9 0)
				(minotaur stopUpd:)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance minotaurDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(minotaur
					view: 426
					setLoop: 0
					cel: 0
					setMotion: 0
					cycleSpeed: 4
					illegalBits: 0
					setCycle: EndLoop self
				)
			)
			(1
				(minotaur stopUpd:)
				(self dispose:)
			)
		)
	)
)
