;;; Sierra Script 1.0 - (do not remove this comment)
(script# 97)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateCalm)
(use AnimateOpen)
(use AnimateDazzle)
(use Interface)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm97 0
)

(local
	local0
	local1
	local2
	local3
	local4
)
(procedure (localproc_000c param1 &tmp [temp0 4] [temp4 400])
	(DisposeDialog)
	(Format @temp4 &rest)
	(TextSize @[temp0 0] @temp4 userFont 0)
	(Print
		@temp4
		#at
		-1
		12
		#width
		(if (> [temp0 2] 24) 300 else 0)
		#mode
		1
		#title
		param1
	)
)

(instance rm97 of Room
	(properties
		picture 97
		style $0002
	)
	
	(method (init)
		(LoadMany 128 97 465 503)
		(LoadMany 132 88 66)
		(if (ego knows: skFLAMEDART)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(if (ego knows: skDAZZLE)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: skCALM)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: skOPEN)
			(Load rsVIEW 521)
			(Load rsSCRIPT 105)
		)
		(cSound fade:)
		(super init:)
		(AddToScore POINTS_ENTERBRIGANDLEADERROOM 12)
		(StatusLine enable:)
		(StopEgo)
		(dragon init: setPri: 0 addToPic:)
		(mula init: setPri: 11 addToPic:)
		(carpet init: addToPic:)
		(falcon init: setPri: 8 addToPic:)
		(vase init: addToPic:)
		(oscar init: setPri: 8 addToPic:)
		(book init: setPri: 9 addToPic:)
		(mirror setPri: 9 init: stopUpd:)
		(door init: stopUpd:)
		(eyes init: setPri: 1)
		(torchL init: setCycle: Forward)
		(torchR init: setCycle: Forward)
		(eyes init: setScript: blink)
		(switch prevRoomNum
			(172
				(LockEgo)
				(if (Btest 273)
					(= local3 1)
					(leader
						init:
						setLoop: 5
						setCel: 0
						setPri: 11
						posn: 129 142
						setScript: elsaIsBack
					)
					(ego init: loop: 1 posn: 237 159)
					(yorick init: illegalBits: 0 posn: 316 142)
				else
					(= local2 1)
					(leader
						setLoop: 3
						setCel: 0
						init:
						setPri: 9
						posn: 129 142
						setScript: elsaKillsEgo
					)
					(ego init: loop: 1 setPri: 10 posn: 178 141)
					(yorick init: posn: 316 142)
				)
			)
			(else 
				(= local2 1)
				(leader
					init:
					setPri: 11
					illegalBits: 0
					setScript: leaderVaults
				)
				(ego init: setScript: egoEnters)
				(elsaSong init:)
			)
		)
	)
	
	(method (doit)
		(if (== (ego edgeHit?) 2)
			(if (ego has: invMagicMirror)
				(curRoom newRoom: 84)
			else
				(curRoom newRoom: 600)
			)
		)
	)
	
	(method (dispose)
		(Bset 87)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl ego pEvent 3) (HighPrint 97 0))
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'rest,nap') (Die 97 1 80 {Z-Z-Z-Z-Z-Z-Z-Z-Z-Z} 82 800 0 0))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/place,area]') (HighPrint 97 2))
							((Said '/falcon,statue') (HighPrint 97 3))
							((Said '/west,east,south') (HighPrint 97 4))
							((Said '/north,desk') (HighPrint 97 5))
							((Said '/yorick') (if local4 (HighPrint 97 6) else (HighPrint 97 7)))
							((Said '/carpet') (HighPrint 97 8))
							((Said '/female,man')
								(cond 
									(local2 (HighPrint 97 9))
									(local3 (HighPrint 97 10) (HighPrint 97 11))
									(else (HighPrint 97 12))
								)
							)
							(else (HighPrint 97 2) (pEvent claimed: 1))
						)
					)
					(
						(or
							(Said
								'cast,use,throw,splash/disenchant,potion[<disenchant]'
							)
							(Said 'disenchant')
						)
						(if (ego has: invDispelPotion)
							(Bset 273)
							(ego use: invDispelPotion)
							(HighPrint 97 13)
						else
							(HighPrint 97 14)
						)
					)
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC
									(if local2 (HighPrint 97 15))
									(if (not (ego has: invMagicMirror)) (HighPrint 97 16))
									(HighPrint 97 17)
								)
								(skDAZZLE (AnimateDazzle))
								(skFLAMEDART
									(AnimateThrowingFlameDart 0)
								)
								(skCALM (AnimateCalm))
								(skOPEN (AnimateOpenSpell))
								(else  (HighPrint 97 18))
							)
						)
					)
					((Said 'throw/dagger') (AnimateThrowingDagger 0))
					((Said 'throw/boulder') (AnimateThrowingRock 0))
					((Said 'get/boulder') (HighPrint 97 19))
					((Said 'open[/gate,door]') (HighPrint 97 20))
					((Said 'get,get/mirror')
						(cond 
							(
							(and (ego inRect: 100 108 233 135) (not (ego has: invMagicMirror)))
								(HighPrint 97 21)
								(AddToScore POINTS_TAKEMAGICMIRROR 10)
								(ego get: invMagicMirror)
								(mirror dispose:)
							)
							((ego has: invMagicMirror) (HighPrint 97 22))
							(else (HighPrint 97 23))
						)
					)
					((Said 'get,get/potion')
						(cond 
							(
							(and (ego inRect: 100 108 233 135) (not local1))
								(HighPrint 97 24)
								(ego get: invHealingPotion)
								(ego get: invHealingPotion)
								(= local1 1)
							)
							((ego inRect: 100 108 233 135) (HighPrint 97 25))
							(else (PrintNotCloseEnough))
						)
					)
					((Said 'search/desk')
						(if (ego inRect: 100 108 233 135)
							(cond 
								((and (ego has: invMagicMirror) local1) (HighPrint 97 26))
								(local1 (HighPrint 97 27))
								((ego has: invMagicMirror) (HighPrint 97 28))
								(else (HighPrint 97 29))
							)
						else
							(PrintNotCloseEnough)
						)
					)
					((Said 'get')
						(= local0 1)
						(if (and (ego has: invHealingPotion) (ego has: invMagicMirror))
							(HighPrint 97 30)
						else
							(HighPrint 97 31)
						)
					)
				)
			)
		)
	)
)

(instance dragon of View
	(properties
		y 92
		x 159
		view 97
	)
)

(instance mula of View
	(properties
		y 144
		x 285
		view 97
		cel 1
		priority 11
	)
)

(instance carpet of View
	(properties
		y 164
		x 273
		view 97
		cel 2
		priority 12
	)
)

(instance falcon of View
	(properties
		y 92
		x 256
		view 97
		cel 3
		priority 8
	)
)

(instance vase of View
	(properties
		y 151
		x 298
		view 97
		cel 4
		priority 11
	)
)

(instance oscar of View
	(properties
		y 81
		x 65
		view 97
		cel 5
		priority 10
	)
)

(instance book of View
	(properties
		y 108
		x 160
		view 97
		cel 6
		priority 9
	)
)

(instance mirror of View
	(properties
		y 109
		x 125
		view 97
		cel 7
		priority 9
	)
)

(instance eyes of Prop
	(properties
		y 75
		x 159
		view 97
		loop 1
		cel 1
		priority 1
	)
)

(instance torchL of Prop
	(properties
		y 76
		x 91
		view 97
		loop 2
		cel 4
	)
)

(instance door of Prop
	(properties
		y 190
		x 232
		view 97
		loop 8
	)
)

(instance torchR of Prop
	(properties
		y 76
		x 225
		view 97
		loop 2
		cel 2
	)
)

(instance leader of Actor
	(properties
		y 123
		x 164
		view 97
		loop 4
	)
)

(instance yorick of Actor
	(properties
		y 142
		x 316
		view 97
		loop 6
	)
)

(instance brig1 of Actor
	(properties
		view 465
	)
)

(instance brig2 of Actor
	(properties
		view 465
	)
)

(instance brig3 of Actor
	(properties
		view 465
	)
)

(instance elsaSong of Sound
	(properties
		number 88
		priority 1
	)
)

(instance tromp of Sound
	(properties
		number 66
		priority 3
	)
)

(instance egoEnters of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					posn: 230 195
					illegalBits: 0
					setMotion: MoveTo 197 141 self
				)
			)
			(1
				(StopEgo)
				(ego loop: 1 illegalBits: (& cWHITE cGREEN))
				(self dispose:)
			)
		)
	)
)

(instance blink of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 5 10)))
			(1
				(eyes setCycle: Forward)
				(= cycles (Random 2 9))
			)
			(2
				(eyes setCycle: BegLoop)
				(self changeState: 0)
			)
		)
	)
)

(instance leaderVaults of Script
	(properties)
	
	(method (doit)
		(if
		(and (== state 1) (== (elsaSong prevSignal?) 10))
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(leader setLoop: 4 setCel: 1 posn: 164 122)
				(= seconds 5)
			)
			(1 (elsaSong play:))
			(2
				(User canInput: 1)
				(leader setCel: 2 posn: 164 120)
				(= cycles 2)
			)
			(3
				(leader setCel: 3 posn: 158 123)
				(= cycles 2)
			)
			(4
				(leader setCel: 4 posn: 152 126)
				(= cycles 2)
			)
			(5
				(leader setCel: 5 posn: 146 129)
				(= cycles 2)
			)
			(6
				(leader setCel: 6 posn: 140 132)
				(= cycles 2)
			)
			(7
				(leader setCel: 7 posn: 134 135)
				(= cycles 2)
			)
			(8
				(leader setCel: 8 illegalBits: cWHITE posn: 128 138)
				(= cycles 2)
			)
			(9
				(leader setCel: 9 setPri: -1 posn: 122 141)
				(= seconds 5)
			)
			(10
				(curRoom newRoom: 172)
				(self dispose:)
			)
		)
	)
)

(instance elsaIsBack of Script
	(properties)
	
	(method (doit)
		(if (and (<= 8 state) (<= state 9) local0)
			(self changeState: 10)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 10))
			(1
				(localproc_000c {Elsa} 97 32)
				(localproc_000c {Elsa} 97 33)
				(localproc_000c {Elsa} 97 34)
				(localproc_000c {Elsa} 97 35)
				(localproc_000c {Elsa} 97 36)
				(= cycles 1)
			)
			(2
				(yorick
					setLoop: 6
					setCel: 0
					setCycle: Walk
					cycleSpeed: 2
					setMotion: MoveTo 258 142 self
				)
				(= local4 1)
			)
			(3
				(localproc_000c {Yorick} 97 37)
				(localproc_000c {Yorick} 97 38)
				(localproc_000c {Yorick} 97 39)
				(= cycles 2)
			)
			(4
				(localproc_000c {Elsa} 97 40)
				(localproc_000c {Elsa} 97 41)
				(localproc_000c {Elsa} 97 42)
				(localproc_000c {Elsa} 97 43)
				(= cycles 2)
			)
			(5
				(tromp number: (GetSongNumber 66) init: loop: 4 play:)
				(localproc_000c {Yorick} 97 44)
				(= cycles 2)
			)
			(6
				(leader setCycle: EndLoop self)
				(= local3 0)
			)
			(7
				(leader ignoreActors:)
				(yorick setLoop: 7 setCel: 0 setCycle: EndLoop self)
				(UnlockEgo)
				(tromp loop: 4 play:)
				(= local4 0)
			)
			(8
				(HighPrint 97 45)
				(yorick dispose:)
				(tromp loop: 6 play:)
				(= seconds 20)
			)
			(9
				(tromp loop: 6 play:)
				(= seconds 15)
			)
			(10
				(LockEgo)
				(door setCel: 1)
				(brig1
					init:
					setCycle: Walk
					posn: 259 230
					setMotion: MoveTo 259 202
				)
				(brig2
					init:
					setCycle: Walk
					posn: 242 247
					setMotion: MoveTo 242 214
				)
				(brig3
					init:
					setCycle: Walk
					posn: 278 250
					setMotion: MoveTo 278 214 self
				)
			)
			(11
				(Die 97 46 82 516 0 9 80 {Wearing out your welcome.})
			)
		)
	)
)

(instance elsaKillsEgo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(leader cycleSpeed: 1 setCycle: EndLoop self)
			)
			(1 (= cycles 6))
			(2
				(leader cycleSpeed: 1 setCycle: BegLoop)
				(= cycles 16)
			)
			(3
				(ego
					view: 503
					setLoop: 0
					setCel: 0
					cycleSpeed: 4
					setCycle: EndLoop self
				)
			)
			(4
				(yorick
					setLoop: 6
					setCel: 0
					setCycle: Walk
					cycleSpeed: 2
					setMotion: MoveTo 258 142
				)
				(= cycles 32)
			)
			(5
				(localproc_000c {Yorick} 97 47)
				(= cycles 1)
			)
			(6
				(Die 97 48 82 503 0 7 80 {One thrust...and that's it???})
			)
		)
	)
)
