;;; Sierra Script 1.0 - (do not remove this comment)
(script# 37)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm37 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
	local10
	local11
	local12
)
(procedure (localproc_000c &tmp temp0)
	(cond 
		((not local1) (guard setScript: guardStopToTalk) (= temp0 0))
		(local4 (= temp0 1))
		(1 (= local4 1) (= temp0 1))
		(else (HighPrint 37 0) (= temp0 0))
	)
	(return temp0)
)

(instance rm37 of Room
	(properties
		picture 37
		style $0000
	)
	
	(method (init)
		(super init:)
		(if isNightTime (Load rsVIEW 503) (Load rsVIEW 517))
		(Load rsVIEW 37)
		(Load rsSOUND (GetSongNumber 90))
		(lBush init: addToPic:)
		(rBush init: addToPic:)
		(portSound number: (GetSongNumber 90) init:)
		(gMouseHandler add: self)
		(self
			setFeatures: onCastle onCastleGate onLGateHouse onMountain
		)
		(StatusLine enable:)
		(StopEgo)
		(LockEgo)
		(switch prevRoomNum
			(39
				(if isNightTime
					(castleGate init: stopUpd:)
					(ego setScript: egoClimbsDown)
				else
					(portSound play:)
					(castleBars x: 160 y: 127 init: stopUpd:)
					(= local0 1)
					(= local3 4)
					(guard loop: 4 cel: 1 illegalBits: 0 x: 158 y: 77 init:)
					(ego setScript: egoLeavesCastle)
				)
			)
			(else 
				(if isNightTime
					(castleGate init: stopUpd:)
				else
					(if
					(or (and (Btest 170) (not (Btest 189))) (Btest 273))
						(= local12 1)
						(guard init: setScript: guardGreets)
						(Bset 189)
					else
						(guard init: setScript: guardPatrols)
					)
					(castleBars init: stopUpd:)
				)
				(ego posn: 161 233 init: setScript: normalEntry)
			)
		)
	)
	
	(method (doit)
		(if (and (< (ego y?) 190) (not local9)) (= local9 1))
		(cond 
			((and (Btest 273) local0 (< (ego y?) 163)) (curRoom newRoom: 600))
			((and local0 (< (ego y?) 163)) (curRoom newRoom: 39))
			((and local9 (> (ego y?) 190)) (curRoom newRoom: 54))
		)
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'open,lift/gate,portcullis,door') (HighPrint 37 1))
					((Said 'climb,climb[/gate,wall,gatehouse]')
						(if isNightTime
							(cond 
								((< [skills skCLIMBING] 10) (HighPrint 37 2))
								((> [skills skCLIMBING] 35)
									(if
										(or
											(and
												(<= 78 (ego x?))
												(<= (ego x?) 114)
												(<= 160 (ego y?))
												(<= (ego y?) 182)
											)
											(and
												(<= 34 (ego x?))
												(<= (ego x?) 65)
												(<= 160 (ego y?))
												(<= (ego y?) 182)
											)
										)
										(= local8 0)
										(self setScript: egoClimbsWall)
									else
										(HighPrint 37 3)
									)
								)
								(
									(or
										(and
											(<= 78 (ego x?))
											(<= (ego x?) 114)
											(<= 160 (ego y?))
											(<= (ego y?) 182)
										)
										(and
											(<= 34 (ego x?))
											(<= (ego x?) 65)
											(<= 160 (ego y?))
											(<= (ego y?) 182)
										)
									)
									(= local8 (+ local8 1))
									(self setScript: egoClimbsWall)
								)
								(else (HighPrint 37 3))
							)
						else
							(HighPrint 37 4)
						)
					)
					((Said 'look>')
						(cond 
							((Said '[<at,around][/castle,building]') (HighPrint 37 5))
							((Said '[<at,around]/gate,gatehouse,wall') (HighPrint 37 6))
							((Said '[<at,around]/tower') (HighPrint 37 7))
							((or (Said '<up') (Said '/sky')) (HighPrint 37 8))
							((or (Said '<down') (Said '/ground,grass')) (HighPrint 37 9))
							((Said '/south') (HighPrint 37 10))
							((Said '/east,west') (HighPrint 37 11))
						)
					)
				)
			)
		)
	)
)

(instance guardPatrols of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local1 0)
				(guard
					loop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo 277 77 self
				)
				(= local3 4)
			)
			(1 (= cycles 2))
			(2
				(guard loop: 2 cel: 0 cycleSpeed: 3 setCycle: EndLoop self)
			)
			(3 (= cycles 1))
			(4
				(guard
					loop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: Forward
					setMotion: MoveTo 43 77 self
				)
				(= local3 5)
			)
			(5 (= cycles 2))
			(6
				(guard loop: 2 cel: 2 cycleSpeed: 3 setCycle: BegLoop self)
			)
			(7 (= cycles 1))
			(8 (self changeState: 0))
		)
	)
)

(instance guardGreets of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local3 4)
				(guard
					loop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo 161 77 self
				)
			)
			(1
				(guard setMotion: 0 setCycle: 0)
				(= cycles 3)
			)
			(2
				(guard
					loop: local3
					cel: 0
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 2))
			(4
				(HighPrint 37 12)
				(= local1 1)
				(= cycles 2)
			)
			(5
				(castleBars setScript: openGate)
				(= seconds 3)
			)
			(6
				(if (Btest 273)
					(curRoom newRoom: 600)
				else
					(UnlockEgo)
					(client setScript: timeout)
				)
			)
		)
	)
)

(instance guardStopToTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(guard setMotion: 0 setCycle: 0)
				(= cycles 3)
			)
			(1
				(guard
					loop: local3
					cel: 0
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(2 (= cycles 2))
			(3
				(UnlockEgo)
				(FaceObject ego guard)
				(if (or (> (ego y?) 170) local2)
					(HighPrint 37 13)
					(= local2 0)
				else
					(HighPrint 37 14)
					(= local2 1)
				)
				(= local1 1)
				(client setScript: timeout)
			)
		)
	)
)

(instance timeout of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (and local2 (> (ego y?) 172))
			(client setScript: guardStopToTalk)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 12))
			(1
				(= local2 0)
				(if local4
					(= local4 0)
					(self changeState: 0)
				else
					(self cue:)
				)
			)
			(2
				(if local0
					(HighPrint 37 15)
					(= local5 1)
					(= seconds 5)
				else
					(client setScript: guardResumesPatrol)
				)
			)
			(3
				(if local4
					(= local4 0)
					(self changeState: 0)
				else
					(= local5 1)
					(client setScript: guardResumesPatrol)
				)
			)
		)
	)
)

(instance guardResumesPatrol of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if local0
					(castleBars setScript: closeGate)
				else
					(self cue:)
				)
			)
			(1
				(= local6 local3)
				(guard
					loop: local6
					cel: 1
					cycleSpeed: 4
					setCycle: BegLoop self
				)
			)
			(2
				(if (== local6 4)
					(guard
						loop: 0
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
						illegalBits: 0
						setMotion: MoveTo 277 77 self
					)
					(= local3 4)
				else
					(guard
						loop: 1
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
						setMotion: MoveTo 43 77 self
					)
					(= local3 5)
				)
				(= local1 0)
				(UnlockEgo)
			)
			(3 (= cycles 2))
			(4
				(if (== local6 4)
					(guard loop: 2 cel: 0 cycleSpeed: 3 setCycle: EndLoop self)
				else
					(guard loop: 2 cel: 2 cycleSpeed: 3 setCycle: BegLoop self)
				)
			)
			(5 (= cycles 1))
			(6
				(if (== local6 4)
					(guard
						loop: 1
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
						setMotion: MoveTo 43 77 self
					)
					(= local3 5)
				else
					(client setScript: guardPatrols)
				)
			)
			(7 (= cycles 2))
			(8
				(guard loop: 2 cel: 2 cycleSpeed: 3 setCycle: BegLoop self)
			)
			(9 (= cycles 1))
			(10
				(client setScript: guardPatrols)
			)
		)
	)
)

(instance openGate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(cond 
					((and (< 123 (guard x?)) (< (guard x?) 198)) (self changeState: 3))
					((< (guard x?) 160) (guard loop: 4 cel: 1 cycleSpeed: 4 setCycle: BegLoop self))
					(else (guard loop: 5 cel: 1 cycleSpeed: 4 setCycle: BegLoop self))
				)
			)
			(1
				(if (< (guard x?) 160)
					(guard
						loop: 0
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
						illegalBits: 0
						setMotion: MoveTo 160 77 self
					)
					(= local3 4)
				else
					(guard
						loop: 1
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
						setMotion: MoveTo 160 77 self
					)
					(= local3 5)
				)
			)
			(2
				(guard
					loop: local3
					cel: 0
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 2))
			(4
				(portSound play:)
				(castleBars
					illegalBits: 0
					setLoop: 7
					xStep: 1
					yStep: 1
					moveSpeed: 1
					setMotion: MoveTo (castleBars x?) 127 self
				)
			)
			(5
				(= local0 1)
				(castleBars stopUpd:)
				(UnlockEgo)
			)
		)
	)
)

(instance closeGateSafe of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 8))
			(1
				(portSound play:)
				(castleBars
					illegalBits: 0
					setLoop: 7
					xStep: 1
					yStep: 1
					moveSpeed: 1
					setMotion: MoveTo (castleBars x?) 155 self
				)
			)
			(2
				(UnlockEgo)
				(castleBars stopUpd:)
				(= local0 0)
				(guardResumesPatrol cue:)
			)
		)
	)
)

(instance closeGate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(and
						(< 145 (ego x?))
						(< (ego x?) 175)
						(< 0 (ego y?))
						(< (ego y?) 173)
					)
					(LockEgo)
					(ego setMotion: MoveTo 160 166 self)
				else
					(client setScript: closeGateSafe)
				)
			)
			(1
				(StopEgo)
				(ego loop: 2)
				(= cycles 1)
			)
			(2
				(portSound play:)
				(castleBars
					illegalBits: 0
					setLoop: 7
					xStep: 1
					yStep: 1
					moveSpeed: 1
					setMotion: MoveTo (castleBars x?) 160 self
				)
				(ego
					view: 503
					loop: 0
					cel: 0
					illegalBits: 0
					moveSpeed: 3
					cycleSpeed: 4
					xStep: 1
					yStep: 1
					setCycle: EndLoop
				)
			)
			(3
				(castleBars stopUpd:)
				(= local0 0)
				(if local7
					(HighPrint 37 16)
				else
					(HighPrint 37 17)
				)
				(self cue:)
			)
			(4
				(castleBars
					illegalBits: 0
					setLoop: 7
					xStep: 1
					yStep: 1
					moveSpeed: 1
					setMotion: MoveTo (castleBars x?) 127 self
				)
			)
			(5
				(= local0 1)
				(castleBars stopUpd:)
				(self cue:)
			)
			(6 (= seconds 3))
			(7
				(if local7
					(Die 37 18 80 {OH NOOOOOOO!} 82 800 0 0)
				else
					(ego
						view: 503
						loop: 4
						cel: 0
						illegalBits: 0
						moveSpeed: 1
						setCycle: EndLoop self
					)
					(= local7 1)
				)
			)
			(8
				(HighPrint 37 19)
				(StopEgo)
				(ego loop: 2)
				(UnlockEgo)
				(self cue:)
			)
			(9 (= seconds 5))
			(10 (self changeState: 0))
		)
	)
)

(instance egoClimbsWall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo (ego x?) 173 self)
			)
			(1
				(ego
					view: 517
					setLoop: 0
					cel: 0
					setPri: 13
					xStep: 0
					yStep: 8
					cycleSpeed: 2
					moveSpeed: 2
					setCycle: Forward
					illegalBits: 0
					setMotion: MoveTo (ego x?) 114 self
				)
			)
			(2
				(ego
					view: 517
					setLoop: 1
					cel: 0
					setPri: 13
					illegalBits: 0
					x: (- (ego x?) 12)
					y: (- (ego y?) 33)
					xStep: 0
					yStep: 4
					cycleSpeed: 3
					moveSpeed: 3
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 10))
			(4
				(if local8
					(ego
						view: 517
						setLoop: 2
						cel: 0
						setPri: 13
						xStep: 0
						yStep: 5
						cycleSpeed: 3
						moveSpeed: 0
						setCycle: EndLoop
						illegalBits: 0
						setMotion: MoveTo (ego x?) 145 self
					)
				else
					(curRoom newRoom: 39)
				)
			)
			(5
				(if (not (ReduceHP 10))
					(Die
						37
						20
						82
						517
						2
						5
						80
						{Your figure remains still and silent.}
					)
				else
					(ego
						view: 503
						setLoop: 4
						cel: 0
						x: (+ (ego x?) 19)
						y: (+ (ego y?) 18)
						setPri: 13
						illegalBits: cWHITE
						setCycle: 0
					)
					(switch local10
						(0 (HighPrint 37 21))
						(1 (HighPrint 37 22))
						(2 (HighPrint 37 23))
						(3 (HighPrint 37 24))
						(4 (HighPrint 37 25))
						(else  (HighPrint 37 26))
					)
					(++ local10)
					(self cue:)
				)
			)
			(6
				(ego moveSpeed: 1 setCycle: EndLoop self)
			)
			(7 (UnlockEgo) (StopEgo))
		)
	)
)

(instance egoClimbsDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 517
					setLoop: 0
					cel: 0
					setPri: 13
					x: 91
					y: 114
					init:
					illegalBits: 0
				)
				(= cycles 2)
			)
			(1
				(ego
					xStep: 0
					yStep: 8
					cycleSpeed: 2
					moveSpeed: 2
					setCycle: Forward
					setMotion: MoveTo (ego x?) 170 self
				)
			)
			(2
				(StopEgo)
				(ego
					illegalBits: 0
					loop: 3
					setMotion: MoveTo (ego x?) 180 self
				)
			)
			(3
				(StopEgo)
				(UnlockEgo)
				(HighPrint 37 27)
			)
		)
	)
)

(instance egoLeavesCastle of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego init: posn: 161 169 setMotion: MoveTo 161 187)
				(= cycles 20)
			)
			(1
				(UnlockEgo)
				(guard setScript: guardResumesPatrol)
			)
		)
	)
)

(instance guard of Actor
	(properties
		y 77
		x 43
		view 37
		cycleSpeed 1
		xStep 2
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl guard pEvent 3)
					(HighPrint 37 28)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					(
						(or
							(Said 'ask/gate<open<to')
							(Said 'open,lift/gate,portcullis,door')
						)
						(if (localproc_000c)
							(cond 
								(local0 (HighPrint 37 29))
								(local2 (HighPrint 37 30))
								(else (HighPrint 37 31) (castleBars setScript: openGate))
							)
						)
					)
					((Said 'close,close,lower/gate,portcullis,door')
						(if (localproc_000c)
							(if local0
								(HighPrint 37 32)
								(castleBars setScript: closeGate)
							else
								(HighPrint 37 33)
							)
						)
					)
					(local12 (HighPrint 37 34) (pEvent claimed: 1))
					((Said '/hey') (if (localproc_000c) (HighPrint 37 35)))
					(
					(or (Said '/hello') (Said 'call/guard,man,gatekeeper')) (if (localproc_000c) (HighPrint 37 36)))
					((Said 'say') (if (localproc_000c) (HighPrint 37 37)))
					((Said 'affirmative')
						(if (localproc_000c)
							(if local5
								(HighPrint 37 38)
							else
								(HighPrint 37 39)
							)
						)
					)
					((Said 'n')
						(if (localproc_000c)
							(HighPrint 37 40)
							(guard setScript: guardResumesPatrol)
						)
					)
					((Said 'look/guard,man') (HighPrint 37 28))
					((Said 'chat[<to]/guard,man') (HighPrint 37 41))
					((Said 'chat,ask>')
						(= local11 (localproc_000c))
						(cond 
							((Said '/name,handle')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 42)
								)
							)
							((Said '/karl')
								(if (localproc_000c)
									(= local11 0)
								else
									(HighPrint 37 43)
								)
							)
							(
								(or
									(Said 'in<go,come')
									(Said '/portcullis,gate<open,lift')
								)
								(if (localproc_000c)
									(= local11 0)
									(if local0
										(HighPrint 37 29)
									else
										(HighPrint 37 31)
										(castleBars setScript: openGate)
									)
								)
							)
							((Said '/gate,portcullis')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 44)
								)
							)
							((Said '/castle,building') (if (localproc_000c) (HighPrint 37 45)))
							((Said '/lord,baron,hamlet')
								(if (localproc_000c)
									(if (Btest 170)
										(HighPrint 37 46)
									else
										(HighPrint 37 47)
									)
								)
							)
							((Said '/loss')
								(if (localproc_000c)
									(HighPrint 37 48)
									(HighPrint 37 49)
								)
							)
							((Said '/barnard,barnard')
								(if (localproc_000c)
									(if (Btest 170)
										(HighPrint 37 50)
									else
										(HighPrint 37 51)
										(HighPrint 37 52)
									)
								)
							)
							((Said '/daughter,elsa')
								(if (localproc_000c)
									(HighPrint 37 53)
									(HighPrint 37 54)
									(HighPrint 37 55)
									(HighPrint 37 56)
								)
							)
							((Said '/job,labor,labor') (if (localproc_000c) (HighPrint 37 57)))
							((Said '/stable') (if (localproc_000c) (HighPrint 37 58)))
							((Said '/misfortune,curse')
								(if (localproc_000c)
									(HighPrint 37 59)
									(HighPrint 37 60)
								)
							)
							((Said '/jester,yorick') (if (localproc_000c) (HighPrint 37 61)))
							((Said '/baba') (if (localproc_000c) (HighPrint 37 62)))
							((Said '/prize')
								(if (localproc_000c)
									(HighPrint 37 63)
									(HighPrint 37 64)
								)
							)
							((Said '/warlock[<bandit,about]') (if (localproc_000c) (HighPrint 37 65)))
							((Said '/leader[<bandit,about]') (if (localproc_000c) (HighPrint 37 66)))
							((Said '/bandit') (if (localproc_000c) (HighPrint 37 67)))
							((Said '/loot,robbery,stealing') (if (localproc_000c) (HighPrint 37 68)))
							((Said '/cemetery,cemetery') (if (localproc_000c) (HighPrint 37 69)))
							((Said '/protection') (if (localproc_000c) (HighPrint 37 70)))
							((Said '/hero') (if (localproc_000c) (HighPrint 37 71)))
							((Said '/monster,creature,animal') (if (localproc_000c) (HighPrint 37 72)))
							((Said '/valley') (if (localproc_000c) (HighPrint 37 73)))
							((Said '/hut') (if (localproc_000c) (HighPrint 37 74)))
							((Said '/baroness')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 75)
								)
							)
							((Said '/guard')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 76)
								)
							)
							((Said '/gatehouse')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 77)
								)
							)
							((Said '/weather')
								(if (localproc_000c)
									(= local11 0)
									(HighPrint 37 78)
								)
							)
							((Said '/(master[<weapon,about]),fight,practice') (if (localproc_000c) (HighPrint 37 79)))
							((and (Said '/*') (localproc_000c)) (= local11 0) (HighPrint 37 80))
						)
						(if local11 (AddToScore POINTS_TALKTOGATEKEEPER 5))
					)
				)
			)
		)
	)
)

(instance castleBars of Actor
	(properties
		y 155
		x 160
		view 37
		loop 7
	)
)

(instance castleGate of View
	(properties
		y 167
		x 160
		view 37
		loop 6
	)
)

(instance lBush of View
	(properties
		y 189
		x 10
		view 37
		loop 8
	)
)

(instance rBush of View
	(properties
		y 189
		x 310
		view 37
		loop 9
	)
)

(instance onCastleGate of RFeature
	(properties
		nsTop 122
		nsLeft 133
		nsBottom 168
		nsRight 184
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCastleGate pEvent 3)
				(cond 
					(isNightTime (HighPrint 37 81))
					(local0 (HighPrint 37 82))
					(else (HighPrint 37 83))
				)
			)
		)
	)
)

(instance onCastle of RFeature
	(properties
		nsTop 16
		nsLeft 85
		nsBottom 70
		nsRight 234
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCastle pEvent 3) (HighPrint 37 84))
		)
	)
)

(instance onLGateHouse of RFeature
	(properties
		nsTop 35
		nsBottom 125
		nsRight 59
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onLGateHouse pEvent 3)
					(IsObjectOnControl onRGateHouse pEvent 3)
				)
				(cond 
					(isNightTime (HighPrint 37 85))
					(local0 (HighPrint 37 86))
					(else (HighPrint 37 6))
				)
			)
		)
	)
)

(instance onRGateHouse of RFeature
	(properties
		nsTop 41
		nsLeft 255
		nsBottom 126
		nsRight 318
	)
)

(instance onMountain of RFeature
	(properties
		nsTop 31
		nsLeft 60
		nsBottom 54
		nsRight 83
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onMountain pEvent 3)
					(IsObjectOnControl onM1 pEvent 3)
					(IsObjectOnControl onM2 pEvent 3)
					(IsObjectOnControl onM3 pEvent 3)
				)
				(HighPrint 37 87)
			)
		)
	)
)

(instance onM1 of RFeature
	(properties
		nsTop 35
		nsLeft 235
		nsBottom 55
		nsRight 253
	)
)

(instance onM2 of RFeature
	(properties
		nsTop 29
		nsLeft 254
		nsBottom 37
		nsRight 280
	)
)

(instance onM3 of RFeature
	(properties
		nsTop 21
		nsLeft 281
		nsBottom 30
		nsRight 315
	)
)

(instance portSound of Sound
	(properties
		number 90
		priority 8
	)
)

(instance normalEntry of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 161 187)
				(= cycles 30)
			)
			(1 (UnlockEgo) (self dispose:))
		)
	)
)
