;;; Sierra Script 1.0 - (do not remove this comment)
(script# 40)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use incGameTime)
(use Extra)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Menu)
(use Actor)
(use System)

(public
	rm40 0
)

(local
	[local0 10]
	[local10 10]
	local20
	local21
	local22
	local23
	local24
	local25
	local26
	local27
	local28
	local29
)
(procedure (localproc_0428 &tmp temp0)
	(= temp0 0)
	(while (< temp0 10)
		(if (not [local10 temp0])
			(= [local10 temp0] (Clone aDustScript))
		)
		(if (not [local0 temp0])
			((= [local0 temp0] (Clone aDustCloud))
				setLoop: 9
				setPri: 9
				setStep: 6 4
				cel: 0
				cycleSpeed: 1
				illegalBits: 0
				ignoreActors:
				posn: 0 1000
				init:
			)
		)
		(++ temp0)
	)
)

(procedure (localproc_0497 &tmp temp0)
	(= temp0 0)
	(while (< temp0 10)
		(if [local10 temp0]
			([local10 temp0] dispose:)
			(= [local10 temp0] 0)
		)
		(if [local0 temp0]
			([local0 temp0] dispose:)
			(= [local0 temp0] 0)
		)
		(++ temp0)
	)
)

(procedure (localproc_04fc)
	(PrintTimedMessage 6 40 0)
)

(instance rakeMusic of Sound
	(properties
		number 77
		priority 1
		loop -1
	)
)

(instance horse of Prop
	(properties
		view 40
		loop 1
		cel 1
	)
)

(instance horseHead of Extra
	(properties
		view 40
		loop 6
		cycleSpeed 3
		cycleType 1
		minPause 50
		maxPause 110
		minCycles 1
		maxCycles 1
	)
)

(instance horseTail of Extra
	(properties
		view 40
		loop 5
		cycleSpeed 2
		cycleType 1
		minPause 60
		maxPause 100
		minCycles 1
		maxCycles 2
	)
)

(instance frame of View
	(properties
		y 63
		x 27
		view 40
		loop 1
	)
)

(instance manure1 of View
	(properties
		y 113
		x 92
		view 140
		loop 6
	)
)

(instance manure2 of View
	(properties
		y 117
		x 65
		view 140
		loop 6
	)
)

(instance manure3 of View
	(properties
		y 138
		x 112
		view 140
		loop 6
	)
)

(instance glass of Prop
	(properties
		y 54
		x 27
		view 40
	)
)

(instance sand of Prop
	(properties
		y 46
		x 27
		view 40
		loop 2
	)
)

(instance aDustCloud of Actor
	(properties
		view 40
	)
)

(instance dust of Actor
	(properties
		y 130
		x 150
		view 40
	)
)

(instance stableMan of Actor
	(properties
		view 40
	)
)

(instance rm40 of Room
	(properties
		picture 40
		style $0003
		horizon 60
	)
	
	(method (init &tmp egoY)
		(super init: &rest)
		(StatusLine enable:)
		(if (not isNightTime)
			(stableMan
				setLoop: 3
				cel: 0
				illegalBits: 0
				posn: 188 144
				init:
				cycleSpeed: 1
				stopUpd:
			)
			(horse
				posn: (Random 55 90) (Random 95 110)
				setPri: 5
				init:
				cycleSpeed: 1
				stopUpd:
				setScript: horseEats
			)
			(horseHead
				posn: (+ (horse x?) 8) (- (horse y?) 23)
				setPri: 6
				init:
			)
			(horseTail
				posn: (- (horse x?) 13) (- (horse y?) 12)
				setPri: 6
				init:
			)
			(manure1
				setPri: 4
				setCel: (if (Btest 217) 1 else 0)
				ignoreActors:
				init:
				stopUpd:
			)
			(manure2
				setPri: 4
				setCel: (if (Btest 217) 1 else 0)
				ignoreActors:
				init:
				stopUpd:
			)
			(manure3
				setPri: 4
				setCel: (if (Btest 217) 1 else 0)
				ignoreActors:
				init:
				stopUpd:
			)
			(dust
				setLoop: 9
				illegalBits: 0
				ignoreActors:
				cycleSpeed: 1
				init:
			)
		)
		(= countdownAwaitingResponse 0)
		(= egoY (ego y?))
		(StopEgo)
		(if (== prevRoomNum SYSTEM)
			(ego posn: 148 132 init: setScript: sleepyIntro)
		else
			(ego
				posn: 1 egoY
				init:
				setMotion: MoveTo 15 (if (< egoY 115) 115 else egoY)
			)
		)
		(self setLocales: 807)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if (== (ego edgeHit?) 4)
			(if (> (ego y?) 125)
				(curRoom newRoom: 39)
			else
				(= temp0 (- (ego y?) 98))
				(ego y: (+ (* temp0 3) 106))
				(curRoom newRoom: 41)
			)
		)
		(cond 
			(
				(or
					(and
						(== (ego onControl: origin) cYELLOW)
						(not local24)
						(not local23)
					)
					(and local24 (ego inRect: 95 145 319 189) (not local23))
				)
				(= local23 1)
			)
			(
				(or
					(and
						local23
						(not (== (ego onControl: origin) cYELLOW))
						(not local24)
					)
					(and
						local23
						local24
						(or
							(not (ego inRect: 95 145 319 189))
							(== (ego onControl: origin) cYELLOW)
						)
					)
				)
				(= local23 0)
			)
		)
		(if
			(and
				(not isNightTime)
				(!= prevRoomNum SYSTEM)
				(or
					(ego inRect: 95 145 319 189)
					(== (ego onControl: origin) cYELLOW)
				)
				(not local25)
			)
			(= local25 1)
			(stableMan setScript: intro)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/stable,shed,hut,building]')
								(cond 
									((Btest 217) (HighPrint 40 1))
									((== (ego onControl: origin) cYELLOW) (HighPrint 40 2))
									(else (HighPrint 40 3))
								)
							)
							((Said '/horse,animal') (HighPrint 40 4))
							(
							(or (Said '<up') (Said '/sky,cloud,star,moon'))
								(if isNightTime
									(HighPrint 40 5)
								else
									(HighPrint 40 6)
								)
							)
							(
							(or (Said '<down') (Said '/ground,floor,hay,crap,crap'))
								(if (Btest 217)
									(HighPrint 40 7)
								else
									(HighPrint 40 8)
								)
							)
							((Said '/north,castle') (HighPrint 40 9))
							((Said '/east') (HighPrint 40 10))
							((Said '/south,pit') (HighPrint 40 11))
							((Said '/west') (HighPrint 40 12))
							((Said '/fence,corral') (HighPrint 40 13))
							((Said '/man,stablekeeper,keeper')
								(if local23
									(HighPrint 40 14)
								else
									(HighPrint 40 15)
								)
							)
						)
					)
					((Said 'chat/man,stablekeeper')
						(if local23
							(HighPrint 40 16)
						else
							(HighPrint 40 17)
						)
					)
					((or (Said 'nap') (Said 'go[<to]/nap'))
						(cond 
							((and (< 750 currentTime) (< currentTime 2550)) (HighPrint 40 18))
							((not (== (ego onControl: origin) cYELLOW)) (HighPrint 40 19))
							((not (Btest 217)) (HighPrint 40 20))
							((ego script?) (HighPrint 40 21))
							(else (ego setScript: sleeper))
						)
					)
					((Said 'ask>')
						(cond 
							((not local23) (HighPrint 40 17) (pEvent claimed: 1))
							((Said '/nap') (HighPrint 40 22))
							((Said '/horse,animal') (HighPrint 40 23))
							((Said '/baron,barnard,castle,hamlet,valley') (HighPrint 40 24))
							((Said '/magic,baba,zara,erasmus,spell,potion') (HighPrint 40 25))
							((Said '/monster,troll,cheetaur,saurus') (HighPrint 40 26))
							((Said '/antwerp') (HighPrint 40 27))
							((Said '/labor,hoe,crap')
								(if (Btest 217)
									(localproc_04fc)
								else
									(HighPrint 40 28)
									(ego setScript: goToWork)
								)
							)
							((Said '/*') (HighPrint 40 29))
						)
					)
					((Said 'buy,get/horse') (HighPrint 40 30))
					((Said '/horse') (HighPrint 40 31))
				)
			)
		)
	)
)

(instance horseEats of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local21 0)
				(= seconds (Random 10 30))
			)
			(1
				(horseHead hide:)
				(horseTail hide:)
				(horse setLoop: 7 cel: 0 setCycle: EndLoop self)
			)
			(2
				(++ local21)
				(if (> (ego distanceTo: horse) 50)
					(horse loop: 8 cycleSpeed: 3 setCycle: Forward)
					(= cycles (Random 15 24))
				else
					(self cue:)
				)
			)
			(3
				(horse setCycle: 0)
				(= cycles (Random 12 24))
			)
			(4
				(if (< local21 (Random 3 6))
					(self changeState: 2)
				else
					(self cue:)
				)
			)
			(5
				(horse setLoop: 7 cel: 3 cycleSpeed: 1 setCycle: BegLoop self)
			)
			(6
				(horse setLoop: 1 cel: 1 stopUpd:)
				(horseHead show:)
				(horseTail show:)
				(self changeState: 0)
			)
		)
	)
)

(instance sandsOfTime of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(frame setPri: 2 init: stopUpd:)
				(glass setPri: 3 setCel: 0 init: stopUpd:)
				(sand setPri: 1 init: setCycle: Forward startUpd:)
				(= cycles 39)
			)
			(1
				(++ local22)
				(glass setCel: (+ (glass cel?) 1))
				(= cycles 39)
			)
			(2
				(if (> local22 6)
					(glass setCel: 8)
					(sand setCycle: 0)
					(= cycles 10)
				else
					(self changeState: 1)
				)
			)
			(3
				(= local22 0)
				(frame dispose:)
				(glass dispose:)
				(sand dispose:)
				(client setScript: 0)
			)
		)
	)
)

(instance goToWork of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(setHighSpeedHero 0)
				(Bset 345)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(if (== (ego onControl: origin) cYELLOW)
					(self cue:)
				else
					(ego setMotion: MoveTo 110 132 self)
				)
			)
			(1
				(ego illegalBits: 0 setMotion: MoveTo 146 132 self)
			)
			(2
				(AddToScore POINTS_WORKINSTABLES 5)
				(client setScript: egoRakes)
			)
		)
	)
)

(instance egoRakes of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(rakeMusic init: play:)
		(gKeyHandler add: self)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(== (ego cel?) 1)
					(or (== (self state?) 0) (== (self state?) 4))
				)
				(= local26 1)
			)
			((and local26 (== (ego cel?) 2))
				(= local26 0)
				([local0 (if (== (++ local20) 10) (= local20 0))]
					posn:
						(if local27
							(- (ego x?) (Random 15 30))
						else
							(+ (ego x?) (Random 15 30))
						)
						(ego y?)
					setScript: [local10 local20]
				)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not local28) (rm40 setScript: sandsOfTime))
				(LockEgo)
				(localproc_0428)
				(ego
					view: 140
					setLoop: 0
					cel: 0
					posn: 150 132
					setStep: (if local28 1 else 2) 1
					setPri: 8
					illegalBits: 0
					cycleSpeed: (if local28 1 else 0)
					setCycle: Forward
					setMotion: MoveTo 80 132 self
				)
			)
			(1
				(ego setLoop: 2 setCycle: Forward)
				(= cycles 30)
			)
			(2
				(if local28
					(ego setLoop: 3 setCycle: EndLoop)
					(= local20 0)
					(rakeMusic pause: 1)
					(= cycles 15)
				else
					(self cue:)
				)
			)
			(3
				(localproc_0497)
				(= local20 0)
				(if local28
					(ego setLoop: 4 cycleSpeed: 2 setCycle: EndLoop)
					(= cycles 10)
				else
					(self cue:)
				)
			)
			(4
				(if local28 (rakeMusic pause: 0))
				(= local27 1)
				(localproc_0428)
				(ego
					posn: 85 132
					setLoop: 1
					cel: 0
					cycleSpeed: (if local28 1 else 0)
					setCycle: Forward
					setMotion: MoveTo 155 132 self
				)
			)
			(5
				(localproc_0497)
				(= local20 0)
				(= cycles 3)
			)
			(6
				(= local27 0)
				(if local28
					(= local28 0)
					(manure3 setCel: 1)
					(ego posn: 146 132)
					(StopEgo)
					(rakeMusic dispose:)
					(gKeyHandler release:)
					(client setScript: endRake)
				else
					(= local28 1)
					(manure1 setCel: 1)
					(manure2 setCel: 1)
					(self changeState: 0)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(== (pEvent type?) evKEYBOARD)
				(== KEY_RETURN (pEvent message?))
				(== client ego)
			)
			(pEvent claimed: 1)
			(= local28 1)
			(= local20 0)
			(StopEgo)
			(sandsOfTime changeState: 3)
			(localproc_0497)
			(manure1 setCel: 1)
			(manure2 setCel: 1)
			(manure3 setCel: 1)
			(self changeState: 6)
			(gKeyHandler release:)
		else
			(pEvent claimed: 1)
		)
	)
)

(instance endRake of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(IncrementGameTime 3)
				(if isNightTime (curRoom drawPic: 40))
				(ego setMotion: MoveTo 110 132 self)
			)
			(1
				(ego
					view: 140
					setLoop: 5
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(2
				(Bset 217)
				(StopEgo)
				(ego x: (- (ego x?) 2) loop: 2)
				(UseSkill skSTRENGTH 25)
				(UseSkill skVITALITY 40)
				(client setScript: getPaid)
			)
		)
	)
)

(instance getPaid of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(stableMan
					posn: 187 144
					setLoop: 3
					setCel: 0
					setMotion: MoveTo 171 144 self
				)
				(= local24 1)
			)
			(1
				(PrintTimedMessage 3 40 32)
				(stableMan setLoop: 4 cel: 0 setCycle: Forward)
				(= cycles 8)
			)
			(2
				(client setMotion: MoveTo 134 166 self)
			)
			(3
				(client illegalBits: 0 setMotion: MoveTo 152 166 self)
			)
			(4
				(PrintTimedMessage 5 40 33)
				(ego get: invSilverCoin 5)
				(= seconds 5)
			)
			(5
				(if isNightTime
					(stableMan
						setLoop: 3
						setCel: 1
						setMotion: MoveTo 188 144 self
					)
				else
					(stableMan setCycle: BegLoop)
				)
				(Bclear 345)
				(UnlockEgo)
				(client illegalBits: cWHITE setScript: 0)
			)
		)
	)
)

(instance sleeper of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(ego hide:)
				(HighPrint 40 34)
				(self cue:)
			)
			(1
				(if local24
					(stableMan
						setLoop: 3
						setCel: 1
						setMotion: MoveTo 188 144 self
					)
				else
					(self cue:)
				)
			)
			(2
				(if (not isNightTime)
					(= defaultPalette 1)
					(curRoom drawPic: 40 6)
					(horse hide: setScript: 0)
					(horseHead hide:)
					(horseTail hide:)
					(manure1 hide:)
					(manure2 hide:)
					(manure3 hide:)
					(= seconds 4)
				else
					(self cue:)
				)
			)
			(3
				(PrintTimedMessage 4 40 35)
				(= seconds 4)
			)
			(4
				(if isNightTime
					(SleepUntil 5 0)
					(= curRoomNum SYSTEM)
					(= prevRoomNum SYSTEM)
					(curRoom newRoom: 40)
				else
					(UnlockEgo)
					(SleepUntil 5 0)
					(= defaultPalette 0)
					(curRoom drawPic: 40 7)
					(horse
						loop: 1
						cel: 1
						setCycle: 0
						show:
						setScript: horseEats
					)
					(horseHead show:)
					(horseTail show:)
					(manure1 setCel: 0 show:)
					(manure2 setCel: 0 show:)
					(manure3 setCel: 0 show:)
					(ego show:)
					(client setScript: sleepyIntro)
				)
			)
		)
	)
)

(instance sleepyIntro of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 40 36)
				(= cycles 2)
			)
			(1
				(HighPrint 40 37)
				(= cycles 10)
			)
			(2 (client setScript: goToWork))
		)
	)
)

(instance aDustScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					setMotion:
						MoveTo
						(if local27
							(+ (ego x?) (Random 70 130))
						else
							(- (ego x?) (Random 70 130))
						)
						(- (+ (ego y?) 10) (Random 0 25))
					setCycle: EndLoop self
				)
			)
			(1
				(client posn: 0 1000 setMotion: 0 setCycle: 0)
			)
		)
	)
)

(instance intro of Script
	(properties)
	
	(method (doit)
		(cond 
			((> countdownAwaitingResponse 1) (-- countdownAwaitingResponse))
			((== countdownAwaitingResponse 1)
				(= countdownAwaitingResponse 0)
				(PrintTimedMessage 5 40 38)
				(self changeState: 5)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego inRect: 95 145 319 189)
					(stableMan
						posn: 187 144
						setLoop: 3
						setCel: 0
						setMotion: MoveTo 171 144 self
					)
					(= local24 1)
				else
					(self cue:)
				)
			)
			(1
				(cond 
					((Btest 217)
						(if
						(and (== timeZone TIME_SUNSET) (== (ego onControl: origin) cYELLOW))
							(client setScript: 0)
						else
							(localproc_04fc)
							(LockEgo)
						)
					)
					((Btest 229)
						(PrintTimedMessage 3 40 42)
						(= countdownAwaitingResponse 120)
						(LockEgo)
						(User canInput: 1)
					)
					(else
						(Bset 229)
						(LockEgo)
						(User canInput: 1)
						(if (== (ego onControl: origin) cYELLOW)
							(HighPrint 40 43)
							(PrintTimedMessage 3 40 44)
						else
							(PrintTimedMessage 3 40 44)
						)
						(= countdownAwaitingResponse 120)
					)
				)
				(stableMan setLoop: 4 cel: 0 setCycle: Forward)
				(if (Btest 217) (= seconds 6) else (= seconds 3))
			)
			(2
				(if (Btest 217)
					(self changeState: 5)
				else
					(stableMan setCycle: BegLoop stopUpd:)
				)
			)
			(3
				(PrintTimedMessage 3 40 45)
				(stableMan setCycle: Forward)
				(= seconds 3)
			)
			(4 (stableMan setCycle: 0))
			(5
				(if local24
					(stableMan
						setLoop: 3
						setCel: 1
						setMotion: MoveTo 188 144 self
					)
				else
					(self cue:)
				)
			)
			(6
				(if (not (ego script?)) (UnlockEgo))
				(= local24 0)
				(client setScript: 0)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if
		(and (== (pEvent type?) evSAID) (> countdownAwaitingResponse 1))
			(cond 
				((super handleEvent: pEvent))
				((Said 'affirmative')
					(= countdownAwaitingResponse 0)
					(HighPrint 40 39)
					(ego setScript: goToWork)
					(self changeState: 5)
				)
				((Said 'n')
					(= countdownAwaitingResponse 0)
					(HighPrint 40 40)
					(self changeState: 5)
				)
				((Said 'ask/labor,hoe,crap') (HighPrint 40 41))
				(else (pEvent claimed: 1) (self changeState: 3))
			)
		)
	)
)
