;;; Sierra Script 1.0 - (do not remove this comment)
(script# 204)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use System)

(public
	theCharSheet 0
)

(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 25)
		(= [lastViewedSkills temp0] [skills temp0])
		(++ temp0)
	)
)

(procedure (localproc_0026 param1 param2 &tmp temp0)
	(= temp0 (if (< colourCount 16) 0 else 1))
	;CI: NOTE: SCICompanion will not compile if a #define is immediately after a &rest modifier
	(Display &rest 100 param1 param2 p_mode teJustLeft p_font 300 p_color temp0) 
)

(procedure (localproc_0052 param1 param2 param3)
	(Display
		&rest
		100 param1 param2 ;CI: NOTE: SCICompanion will not compile if a #define is immediately after a &rest modifier
		p_mode teJustLeft
		p_font 300
		p_color param3
		p_back vBLACK
	)
)

(procedure (localproc_0070 param1)
	(return
		(if (== [skills param1] [lastViewedSkills param1])
			statColour
		else
			statColourNew
		)
	)
)

(procedure (localproc_0084 param1 param2 param3 param4 &tmp temp0 [temp1 6])
	(= temp0
		(if param4 (localproc_0070 param3) else statColour)
	)
	(localproc_0052
		param1
		param2
		temp0
		(Format @temp1 204 0 [skills param3])
		p_width 22
	)
)

(class CharSheet of Object
	(properties
		nsTop 0
		nsLeft 0
		nsBottom 189
		nsRight 320
		theWindow 0
		useWindow 0
		showBars 0
	)
	
	(method (init &tmp temp0)
		(super init:)
		(Load rsVIEW 802)
		(if useWindow
			(= theWindow
				(NewWindow nsTop nsLeft nsBottom nsRight {} 0 15 0 15)
			)
		)
		(= temp0 26)
		(if (!= heroType CLASS_FIGHTER) (= temp0 (+ temp0 3)))
		(DrawCel 802 2 0 10 23 -1)
		(DrawCel 802 0 heroType temp0 32 -1)
		(if (== heroType CLASS_MAGICUSER) (DrawCel 802 1 0 40 52 -1))
		(localproc_0026 10 8 204 1)
		(localproc_0026 83 35 204 2)
		(localproc_0026 83 47 204 3)
		(localproc_0026 83 59 204 4)
		(localproc_0026 83 71 204 5)
		(localproc_0026 83 83 204 6)
		(if showBars
			(localproc_0026 10 112 204 7)
			(localproc_0026 10 124 204 8)
		)
		(localproc_0026 10 148 204 9)
		(localproc_0026 10 160 204 10)
		(localproc_0026 10 172 204 11)
		(localproc_0026 207 28 204 12)
		(localproc_0026 207 40 204 13)
		(localproc_0026 207 52 204 14)
		(localproc_0026 207 64 204 15)
		(localproc_0026 207 76 204 16)
		(localproc_0026 207 88 204 17)
		(localproc_0026 207 100 204 18)
		(localproc_0026 207 112 204 19)
		(self update:)
	)
	
	(method (doit &tmp newEvent newEventType)
		(= newEventType 0)
		(while (not newEventType)
			(GlobalToLocal (= newEvent (Event new:)))
			(= newEventType (newEvent type?))
			(newEvent dispose:)
		)
		(self dispose:)
	)
	
	(method (dispose)
		(localproc_000c)
		(if theWindow (DisposeWindow theWindow))
		(super dispose:)
		(DisposeScript 204)
	)
	
	(method (update &tmp temp0 [temp1 20])
		(if showBars
			(Display
				@userName 106 260
				p_at 58 8
				p_mode teJustLeft 
				p_font 300
				p_color statColour
			)
		)
		(localproc_0084 170 35 0 showBars)
		(localproc_0084 170 47 1 showBars)
		(localproc_0084 170 59 2 showBars)
		(localproc_0084 170 71 3 showBars)
		(localproc_0084 170 83 4 showBars)
		(if showBars
			(= temp0
				(if (== score lastViewedScore)
					statColour
				else
					statColourNew
				)
			)
			(= lastViewedScore score)
			(localproc_0052
				103
				112
				temp0
				(Format @temp1 204 0 score)
				p_width 50
			)
			(localproc_0052
				103
				124
				(localproc_0070 13)
				(Format @temp1 204 0 [skills skEXPERIENCE])
				p_width 50
			)
		)
		(= temp0
			(if showBars (localproc_0070 14) else statColour)
		)
		(localproc_0052
			103
			148
			temp0
			(Format
				@temp1
				204
				20
				(/ (+ [skills skHP] 1) 2)
				(/ (+ (GetMaxHealth) 1) 2)
			)
			p_width 60
		)
		(= temp0
			(if showBars (localproc_0070 15) else statColour)
		)
		(localproc_0052
			103
			160
			temp0
			(Format
				@temp1
				204
				20
				(/ (+ [skills skSP] 3) 4)
				(/ (+ (GetMaxStamina) 3) 4)
			)
			p_width 60
		)
		(= temp0
			(if showBars (localproc_0070 16) else statColour)
		)
		(localproc_0052
			103
			172
			temp0
			(Format @temp1 204 20 [skills skMP] (GetMaxMana))
			p_width 60
		)
		(localproc_0084 288 28 5 showBars)
		(localproc_0084 288 40 6 showBars)
		(localproc_0084 288 52 7 showBars)
		(localproc_0084 288 64 8 showBars)
		(localproc_0084 288 76 9 showBars)
		(localproc_0084 288 88 10 showBars)
		(localproc_0084 288 100 11 showBars)
		(localproc_0084 288 112 12 showBars)
	)
)

(instance theCharSheet of CharSheet
	(properties)
)
