;;; Sierra Script 1.0 - (do not remove this comment)
(script# CHASE) ;CHASE = 972
(include system.sh) (include sci2.sh) (include game.sh)
(use Motion)


(class Chase of Motion
	;;; Try to catch a particular Actor.
	
	(properties
		;properties from Motion
		client 		0
		caller 		0
		x 			0
		y 			0
		dx 			0
		dy 			0
		b-moveCnt 	0
		b-i1 		0
		b-i2 		0
		b-di 		0
		b-xAxis 	0
		b-incr 		0
		completed 	0
		
		who 		NULL	;who to chase
		distance 	0		;how close to 'who' is considered a 'catch'
	)
	
	(method (init actor whom howClose whoCares)
		(if (>= argc 1) 			(= client actor)
			(if (>= argc 2) 		(= who whom)
				(if (>= argc 3) 	(= distance howClose)
					(if (>= argc 4) (= caller whoCares))
				)
			)
		)
		(super init: client (who x?) (who y?) caller)
;		(super doit:)
	)
	
	(method (doit)
		(if (<= (client distanceTo: who) distance)
			(self moveDone:)
		else
			(super doit:)
			(if (== b-moveCnt 0)
				(super init: client (who x?) (who y?) caller)
			)
		)
	)
	
	(method (setTarget)
		(cond 
			(argc (super setTarget: &rest))
			((not (self onTarget:)) (super setTarget: (who x?) (who y?)))
		)
	)
	
	(method (onTarget)
		(return (<= (client distanceTo: who) distance))
	)
)
