;;; Sierra Script 1.0 - (do not remove this comment)
(script# 298)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Game)
(use User)
(use Actor)
(use System)

(public
	debugRm 0
)

(instance debugRm of Locale
	(properties)
	
	(method (init)
		(super init:)
		(gMouseHandler add: self)
		(gKeyHandler add: self)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(gKeyHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp newEvent temp1 [temp2 2] gCastFirst temp5 [temp6 40])
		(if
		(or (not razzleDazzleRootBeer) (pEvent claimed?))
			(return)
		)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (& (pEvent modifiers?) emSHIFT)
					(= temp1
						(Print
							(Format @temp6 298 0 (pEvent x?) (pEvent y?))
							#at
							150
							100
							#font
							ARROW_CURSOR
							#dispose
						)
					)
					(while (!= 2 ((= newEvent (Event new:)) type?))
						(newEvent dispose:)
					)
					(temp1 dispose:)
					(newEvent dispose:)
				)
			)
			(evKEYBOARD
				(pEvent claimed: 1)
				(switch (pEvent message?)
					(KEY_QUESTION
						(Print 298 1)
						; Key commands:
						; ALT-S Show cast
						; ALT-M Show Memory
						; ALT-T Teleport
						; ALT-V Visual
						; ALT-P Priority
						; ALT-C Control
						; ALT-I Get InvItem
						; ALT-B Set Ego's Bucks
						; ALT-K Set one of Ego's sKills
						; ALT-X Make Ego eXtra special
					)
					(KEY_ALT_s
						(= gCastFirst (gCast first:))
						(while gCastFirst
							(= temp1 (NodeValue gCastFirst))
							(Print
								(Format
									@temp6
									298
									2
									(temp1 view?)
									(temp1 x?)
									(temp1 y?)
									(if (& (temp1 signal?) $0004) {stopUpd:\n} else {})
									(if (& (temp1 signal?) $4000) {ignoreActors:\n} else {})
									(if
										(or
											(== (temp1 superClass?) Actor)
											(== (temp1 superClass?) Ego)
										)
										(temp1 illegalBits?)
									else
										-1
									)
								)
								#title
								(temp1 name?)
								#icon
								(temp1 view?)
								(temp1 loop?)
								(temp1 cel?)
							)
							(= gCastFirst (gCast next: gCastFirst))
						)
					)
					(KEY_ALT_e
						(Format
							@temp6
							298
							3
							(ego x?)
							(ego y?)
							(ego loop?)
							(ego cel?)
						)
						(Print @temp6 #icon (ego view?) 6 0 7 0)
					)
					(KEY_ALT_i
						(= gCastFirst (GetNumber {ID number of the object?}))
						(ego get: gCastFirst)
					)
					(KEY_ALT_t
						(curRoom newRoom: (GetNumber {Which room number?}))
					)
					(KEY_ALT_v (Show 1))
					(KEY_ALT_p (Show 2))
					(KEY_ALT_c (Show 4))
					(KEY_ALT_m (theGame showMem:))
					(KEY_ALT_b
						(Print (Format @temp6 298 4 [invNum invSilverCoin]))
						(= [invNum invSilverCoin] (GetNumber {Enter Silvers.}))
					)
					(KEY_ALT_k
						(= temp5 (GetNumber {Change which Stat/Skill?}))
						(= [skills temp5]
							(GetNumber {Enter new value:} [skills temp5])
						)
					)
					(KEY_ALT_x
						(= temp5 0)
						(while (< temp5 25)
							(= [skills temp5] 80)
							(++ temp5)
						)
						(= [skills skEXPERIENCE] 1900)
						(= [skills skHP] (GetMaxHealth))
						(= [skills skSP] (GetMaxStamina))
						(= [skills skMP] (GetMaxMana))
						(Print 298 5)
						; Why, you feel better already!
					)
					(else  (pEvent claimed: 0))
				)
			)
		)
	)
)
