;;; Sierra Script 1.0 - (do not remove this comment)
(script# 76)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm76 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
)
(procedure (localproc_000c)
	(if (and local1 (< (ego distanceTo: acorn) 80))
		(HighPrint 76 0)
	else
		(HighPrint 76 1)
	)
	(ego setScript: pickEmUp)
)

(procedure (localproc_0041)
	(HighPrint 76 2)
)

(procedure (localproc_0049)
	(LockEgo)
	(if (Btest 198)
		(HighPrint 76 3)
	else
		(HighPrint 76 4)
		(HighPrint 76 5)
	)
	(dryad setScript: intoTree)
)

(instance miscSound of Sound
	(properties
		number 97
		priority 1
	)
)

(instance spitSound of Sound
	(properties
		number 18
		priority 1
	)
)

(instance gulpSound of Sound
	(properties
		number 27
		priority 1
	)
)

(instance bush of View
	(properties
		y 141
		x 80
		view 77
	)
)

(instance acorn of Prop
	(properties
		y 132
		x 130
		view 77
		loop 2
	)
)

(instance stag of TargActor
	(properties
		view 78
	)
	
	(method (getHurt)
		(= global271 (+ global271 global272))
		(= global272 0)
		(HighPrint 76 6)
		;The stag looks more surprised than hurt.
	)
)

(instance seed of Actor
	(properties
		view 16
	)
)

(instance dryad of Actor
	(properties
		y 116
		x 96
		view 76
		illegalBits $0000
	)
)

(instance rm76 of Room
	(properties
		picture 76
		style $0008
	)
	
	(method (init)
		(if (not isNightTime)
			(LoadMany 128 76 79)
			(if (or (Btest 137) (Btest 138) (Btest 139))
				(Load rsVIEW 16)
				(LoadMany 132 (GetSongNumber 18) (GetSongNumber 27))
			)
		else
			(Load rsSCRIPT 7)
			(Load rsVIEW 16)
		)
		(LoadMany 128 77 510)
		(LoadMany 132 97 98)
		(if (Btest 202) (Load rsVIEW 78))
		(super init:)
		(bush ignoreActors: init: stopUpd: addToPic:)
		(StatusLine enable:)
		(StopEgo)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(= countdownAwaitingResponse 0)
		(if (not isNightTime)
			(spitSound number: (GetSongNumber 18) init:)
			(gulpSound number: (GetSongNumber 27) init:)
			(seed
				illegalBits: 0
				setLoop: 4
				init:
				ignoreActors:
				setCycle: Forward
				stopUpd:
				hide:
			)
		)
		(if (and (not isNightTime) (Btest 202))
			(stag
				view: 78
				x: 318
				y: 145
				setScript: stagEntrance
				init:
				illegalBits: 0
			)
		else
			(ego posn: 318 130 init: setMotion: MoveTo 290 130)
			(Bclear 202)
			(= local0 1)
		)
		(miscSound init: play:)
	)
	
	(method (doit)
		(cond 
			(
			(and local4 (not (ego script?)) (< (stag x?) 50))
				(= local4 0)
				(HighPrint 76 7)
				(stag setScript: stagBolts)
			)
			(
				(and
					local3
					(not (ego script?))
					(not (stag script?))
					(not (dryad script?))
					(== local0 2)
				)
				(= local3 0)
				(dryad setScript: egoToStag)
			)
		)
		(cond 
			((> countdownAwaitingResponse 1) (-- countdownAwaitingResponse))
			((== countdownAwaitingResponse 1) (= countdownAwaitingResponse 0) (localproc_0049))
		)
		(cond 
			((and (== (ego edgeHit?) 2) (>= local0 1)) (Bclear 202) (curRoom newRoom: 77))
			(
				(and
					(< (ego x?) 200)
					(== local0 1)
					(not isNightTime)
					(or
						local6
						(not (Btest 201))
						(Btest 203)
						(Btest 137)
						(Btest 138)
						(Btest 139)
					)
				)
				(= local0 2)
				(dryad init: setScript: outOfTree)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 66)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(switch (pEvent type?)
			(evSAID
				(if (> countdownAwaitingResponse 0)
					(cond 
						((Said 'affirmative')
							(= countdownAwaitingResponse 0)
							(LockEgo)
							(if (Btest 198)
								(HighPrint 76 8)
								(dryad x: (+ (dryad x?) 6) setLoop: 4 setCycle: EndLoop)
								(if (ego has: invSpireaSeed)
									(dryad setScript: hasSeed)
								else
									(HighPrint 76 9)
									(HighPrint 76 10)
									(dryad setScript: intoTree)
								)
							else
								(AddToScore POINTS_AGREETOHELPDRYAD 1)
								(HighPrint 76 11)
								(HighPrint 76 12)
								(HighPrint 76 13)
								(Bset 198)
								(if (ego has: invSpireaSeed)
									(HighPrint 76 14)
									(= countdownAwaitingResponse 150)
									(User canInput: 1)
								else
									(dryad setScript: intoTree)
								)
							)
						)
						((Said 'n') (= countdownAwaitingResponse 0) (localproc_0049))
						(else (pEvent claimed: 1) (HighPrint 76 15))
					)
				)
				(cond 
					((super handleEvent: pEvent))
					((or (Said 'nap') (Said 'go[<to]/nap'))
						(if (not (NeedSleep))
							(HighPrint 76 16)
							(DisposeScript 7)
						else
							(ego setScript: goToSleep)
						)
					)
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0)
									(if (== local0 2)
										(HighPrint 76 17)
									else
										(HighPrint 76 18)
									)
								)
							)
							(skDAZZLE
								(if (CastSpell temp0)
									(if (and (Btest 202) (< (stag x?) 50)) (= local4 1))
									(if (== local0 2) (= local3 1))
									(AnimateDazzle)
								)
							)
							(skFLAMEDART
								(if (CastSpell temp0)
									(if (== local0 2) (= local3 1))
									(if (Btest 202) (= local4 1))
									(if (gCast contains: stag)
										(FaceObject ego stag)
										(SetUpEgo)
									)
									(if
									(and (gCast contains: stag) (not (ego script?)))
										(AnimateThrowingFlameDart stag)
									else
										(AnimateThrowingFlameDart 0)
									)
									(= local6 1)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(= temp1 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingDagger temp1)
							(if (== local0 2) (= local3 1))
							(if (Btest 202) (= local4 1) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'throw/boulder')
						(= temp1 (if (gCast contains: stag) stag else 0))
						(if (AnimateThrowingRock temp1)
							(if (== local0 2) (= local3 1))
							(if (Btest 202) (= local4 1) (Bset 203))
							(if (gCast contains: stag)
								(FaceObject ego stag)
								(SetUpEgo)
							)
						)
					)
					((Said 'eat/acorn,nut')
						(if (ego has: invMagicAcorn)
							(localproc_0041)
							(ego use: invMagicAcorn)
							(AddToScore POINTS_EATACORN -5)
						else
							(= local2 1)
							(localproc_000c)
						)
					)
					((Said 'climb,ride/buck')
						(if (Btest 202)
							(HighPrint 76 19)
						else
							(HighPrint 76 20)
						)
					)
					((Said 'climb>')
						(cond 
							((Said '/tree,oak') (HighPrint 76 21))
							((Said '/boulder') (HighPrint 76 22))
						)
					)
					(
					(or (Said 'ask/date') (Said 'ask/dryad,girl/date')) (HighPrint 76 23))
					((Said 'chat/dryad')
						(if 2
							(HighPrint 76 24)
						else
							(HighPrint 76 25)
							(HighPrint 76 26)
							(HighPrint 76 27)
						)
					)
					((Said 'lockpick<up/acorn,nut') (localproc_000c))
					((Said 'burn,torch/tree,oak')
						(if (== local0 2)
							(HighPrint 76 28)
							(dryad setScript: egoToStag)
						else
							(HighPrint 76 29)
						)
					)
					((Said 'fight,kill,beat,chop>')
						(cond 
							((Said '/buck')
								(if (Btest 202)
									(= local4 1)
									(if (== local0 2)
										(HighPrint 76 28)
										(dryad setScript: egoToStag)
									else
										(Bset 203)
									)
								else
									(HighPrint 76 19)
									(Bset 203)
								)
							)
							((Said '/dryad,girl,female')
								(if (== local0 2)
									(HighPrint 76 28)
									(dryad setScript: egoToStag)
								else
									(HighPrint 76 30)
								)
							)
							((Said '/tree,oak')
								(if (== local0 2)
									(HighPrint 76 28)
									(dryad setScript: egoToStag)
								else
									(HighPrint 76 31)
								)
							)
						)
					)
					((Said 'get>')
						(cond 
							((Said '/acorn,nut') (localproc_000c))
							((Said '/dryad,girl,female')
								(if (== local0 2)
									(HighPrint 76 32)
								else
									(pEvent claimed: 0)
								)
							)
							((Said '/buck')
								(if (Btest 202)
									(HighPrint 76 33)
								else
									(pEvent claimed: 0)
								)
							)
						)
					)
					((Said 'look>')
						(cond 
							((Said '/dryad,girl,female')
								(if (== local0 2)
									(HighPrint 76 34)
								else
									(HighPrint 76 35)
								)
							)
							((Said '/tree,oak') (HighPrint 76 36))
							((Said '/boulder') (HighPrint 76 37))
							((Said '/buck')
								(if (Btest 202)
									(HighPrint 76 38)
								else
									(HighPrint 76 39)
								)
							)
							((Said '/acorn,nut')
								(if local1
									(HighPrint 76 40)
								else
									(HighPrint 76 41)
								)
							)
							((Said '/west') (HighPrint 76 42))
							((Said '/south') (HighPrint 76 43))
							((Said '/north') (HighPrint 76 44))
							((Said '/east') (HighPrint 76 45))
							((Said '/bush') (HighPrint 76 46))
						)
					)
				)
			)
		)
	)
)

(instance stagEntrance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(stag
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					xStep: 5
					moveSpeed: 1
					posn: 319 150
					setCycle: Forward
					setMotion: MoveTo 200 140 self
				)
			)
			(1
				(stag setLoop: 5 cel: 0 setCycle: EndLoop self)
			)
			(2
				(stag setLoop: 7 cycleSpeed: 3 setCycle: Forward)
				(= cycles 30)
			)
			(3 (stag setCycle: EndLoop self))
			(4
				(stag setLoop: 5 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
			)
			(5
				(stag
					setLoop: 1
					cel: 0
					setCycle: Forward
					setMotion: MoveTo 130 140 self
				)
				(ego posn: 319 130 init: setMotion: MoveTo 290 130)
				(= local0 1)
			)
			(6
				(if (not (Btest 66))
					(HighPrint 76 47)
				else
					(HighPrint 76 48)
				)
				(stag
					setLoop: 9
					cel: 0
					xStep: 9
					setCycle: EndLoop
					setMotion: MoveTo 50 140 self
				)
			)
			(7
				(stag
					setLoop: 1
					cel: 0
					xStep: 5
					cycleSpeed: 1
					setCycle: Walk
					setMotion: MoveTo 30 140 self
				)
			)
			(8
				(if (not (Btest 66))
					(HighPrint 76 49)
				else
					(HighPrint 76 50)
				)
				(stag setLoop: 3 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(9
				(UnlockEgo)
				(stag setLoop: 4 cel: 0 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(10
				(stag loop: 6 cycleSpeed: 3 setCycle: Forward)
				(= cycles (Random 20 90))
			)
			(11 (stag setCycle: EndLoop self))
			(12
				(stag loop: 4 cel: 7 cycleSpeed: 1 setCycle: BegLoop self)
			)
			(13 (= cycles (Random 5 35)))
			(14 (self changeState: 9))
		)
	)
)

(instance outOfTree of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(miscSound stop: number: 98 play:)
				(dryad cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 25)
			)
			(1
				(dryad setLoop: 1 cel: 0 setCycle: CycleTo 2 1 self)
			)
			(2
				(dryad
					moveSpeed: 1
					setStep: 5 3
					setCycle: EndLoop
					setMotion: MoveTo 124 130 self
				)
			)
			(3
				(cond 
					((or local6 (Btest 203)) (dryad setLoop: 6 cel: 6 forceUpd: setScript: egoToStag))
					((Btest 198)
						(HighPrint 76 51)
						(= countdownAwaitingResponse 150)
						(User canInput: 1)
					)
					((or (Btest 137) (Btest 138) (Btest 139)) (dryad setLoop: 6 cel: 6 forceUpd: setScript: egoToPlant))
					((Btest 197)
						(HighPrint 76 52)
						(= countdownAwaitingResponse 150)
						(User canInput: 1)
					)
					(else
						(HighPrint 76 53)
						(= countdownAwaitingResponse 150)
						(User canInput: 1)
					)
				)
				(Bset 197)
			)
		)
	)
)

(instance intoTree of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(dryad
					setLoop: 1
					cel: 9
					moveSpeed: 1
					setStep: 5 3
					setCycle: CycleTo 2 -1
					setMotion: MoveTo 96 116 self
				)
			)
			(1 (dryad setCycle: BegLoop self))
			(2
				(dryad cycleSpeed: 1 setLoop: 0 cel: 5 setCycle: BegLoop self)
			)
			(3
				(if (Btest 201)
					(acorn init: setCycle: EndLoop)
					(= local1 1)
					(HighPrint 76 54)
				)
				(UnlockEgo)
				(= local0 3)
				(dryad setScript: 0)
			)
		)
	)
)

(instance hasSeed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego ignoreActors: setMotion: MoveTo 154 132 self)
			)
			(1
				(ego setLoop: 3)
				(= cycles 2)
			)
			(2
				(ego view: 77 setLoop: 1 cel: 1 forceUpd:)
				(= cycles 15)
			)
			(3
				(ego cycleSpeed: 1 setCycle: CycleTo 3 1)
				(= cycles 10)
			)
			(4
				(HighPrint 76 55)
				(AddToScore POINTS_GIVESEED 7)
				(ego use: invSpireaSeed setCycle: EndLoop self)
			)
			(5
				(if (or (Btest 137) (Btest 138) (Btest 139))
					(HighPrint 76 56)
					(dryad setScript: oMyGod)
				else
					(StopEgo)
					(ego loop: 1 forceUpd:)
					(dryad setCycle: BegLoop self)
				)
			)
			(6
				(HighPrint 76 57)
				(self cue:)
			)
			(7
				(HighPrint 76 58)
				(HighPrint 76 59)
				(HighPrint 76 60)
				(HighPrint 76 61)
				(HighPrint 76 62)
				(HighPrint 76 63)
				(HighPrint 76 64)
				(HighPrint 76 65)
				(HighPrint 76 66)
				(HighPrint 76 67)
				(Bset 201)
				(Bclear 198)
				(dryad setScript: intoTree)
			)
		)
	)
)

(instance pickEmUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (and local1 (< (ego distanceTo: acorn) 80))
					(ego setMotion: MoveTo 147 135 self)
				else
					(self cue:)
				)
			)
			(1
				(ego
					view: 510
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(2
				(cond 
					((and local1 (< (ego distanceTo: acorn) 80))
						(= local1 0)
						(ego get: invMagicAcorn)
						(AddToScore POINTS_GETACORN 1)
						(acorn dispose:)
					)
					(local2 (HighPrint 76 68))
					(else (HighPrint 76 69))
				)
				(ego setCycle: BegLoop self)
			)
			(3
				(if local2 (= local2 0) (localproc_0041))
				(StopEgo)
				(ego setScript: 0)
				(UnlockEgo)
			)
		)
	)
)

(instance stagBolts of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(stag setLoop: 4 cel: 7 cycleSpeed: 0 setCycle: BegLoop self)
			)
			(1
				(stag setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(2
				(stag
					setLoop: 9
					cel: 0
					xStep: 9
					setCycle: EndLoop
					setMotion: MoveTo -20 140 self
				)
			)
			(3
				(Bclear 202)
				(stag dispose:)
			)
		)
	)
)

(instance oMyGod of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(dryad setLoop: 2 cel: 0 forceUpd:)
				(= cycles 10)
			)
			(1
				(HighPrint 76 70)
				(self cue:)
			)
			(2
				(dryad setCycle: CycleTo 3 1)
				(= seconds 3)
			)
			(3 (dryad setCycle: EndLoop self))
			(4
				(dryad setScript: egoToPlant)
			)
		)
	)
)

(instance egoToPlant of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(stag setScript: stagBolts)
				(HighPrint 76 71)
				(HighPrint 76 72)
				(self cue:)
			)
			(1
				(dryad
					setLoop: 3
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 2 1 self
				)
			)
			(2
				(ego
					view: 79
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
				(dryad setCycle: EndLoop)
			)
			(3
				(ego setLoop: 2 cel: 0 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(4
				(ego
					view: 16
					setLoop: 1
					cel: 0
					posn: (+ (ego x?) 6) (+ (ego y?) 5)
					forceUpd:
				)
				(= seconds 2)
			)
			(5
				(++ local5)
				(ego setLoop: 1 setCycle: EndLoop self)
			)
			(6
				(seed
					posn: (ego x?) (- (ego y?) 29)
					yStep: 10
					startUpd:
					show:
				)
				(self cue:)
			)
			(7
				(spitSound play:)
				(ego setCycle: BegLoop)
				(seed
					setMotion: MoveTo (seed x?) (- (seed y?) 30) self
				)
			)
			(8
				(ego setLoop: 2 setCycle: EndLoop)
				(seed
					yStep: 10
					setMotion: MoveTo (seed x?) (+ (seed y?) 17) self
				)
			)
			(9
				(gulpSound play:)
				(seed hide:)
				(ego setCycle: BegLoop self)
			)
			(10
				(if (< local5 4)
					(self changeState: 5)
				else
					(self cue:)
				)
			)
			(11
				(Die 76 73 80 {Plant it, fella!} 82 79 2 6)
			)
		)
	)
)

(instance egoToStag of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(stag setScript: stagBolts)
				(cond 
					((Btest 203) (HighPrint 76 74) (HighPrint 76 75))
					(local6 (HighPrint 76 76) (HighPrint 76 77))
					(else (HighPrint 76 78))
				)
				(self cue:)
			)
			(1
				(dryad
					setLoop: 3
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 2 1 self
				)
			)
			(2
				(ego
					view: 79
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
				(dryad setCycle: EndLoop)
			)
			(3
				(ego setLoop: 1 cel: 0 setCycle: EndLoop self)
			)
			(4
				(Die 76 79 80 {Oh, deer!} 82 79 1 5)
			)
		)
	)
)

(instance goToSleep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 201 132 self)
			)
			(1
				(= defaultPalette 1)
				(curRoom drawPic: 76 6)
				(ego view: 16 setLoop: 6 setCel: 0)
				(= seconds 3)
			)
			(2
				(PrintTimedMessage 5 76 80)
				(= seconds 5)
			)
			(3
				(UnlockEgo)
				(SleepUntil 6 0)
				(= defaultPalette 0)
				(bush ignoreActors: init: stopUpd: addToPic:)
				(curRoom drawPic: 76 7)
				(ego posn: 201 132 setLoop: 2)
				(StopEgo)
				(client setScript: 0)
			)
		)
	)
)
