;;; Sierra Script 1.0 - (do not remove this comment)
(script# 10)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use Extra)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm10 0
)

(local
	local0
	local1
	gEgoObjX
	gEgoObjY
	local4
)
(procedure (localproc_000c)
	(HighPrint 10 0)
)

(procedure (localproc_0014)
	(cond 
		((Btest 141) (HighPrint 10 1))
		((not local1) (HighPrint 10 2))
		((not (ego inRect: 92 126 150 149)) (PrintNotCloseEnough))
		(else
			(HighPrint 10 3)
			(Bset 141)
			(ego get: invPieceOfPaper 1)
			(ego learn: skCALM 10)
			(AddToScore POINTS_LEARNCALM 4 CLASS_MAGICUSER)
		)
	)
)

(procedure (localproc_0088)
	(HighPrint 10 4)
	;Your hunger has been totally satisfied.  You don't need another piece of fruit.
)

(procedure (localproc_0091)
	(switch local4
		(1 (HighPrint 10 5))
		(2 (HighPrint 10 6))
		(else  (HighPrint 10 7))
	)
	(return (++ local4))
)

(procedure (localproc_00c3)
	(HighPrint 10 8)
)

(procedure (localproc_00cc)
	(HighPrint 10 9)
)

(instance rm10 of Room
	(properties
		picture 10
		style $0000
		south 12
	)
	
	(method (init)
		(Load rsVIEW 10)
		(Load rsSOUND (GetSongNumber 24))
		(super init:)
		(StatusLine enable:)
		(StopEgo)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(ego posn: 160 188 init: setMotion: MoveTo 160 170)
		(magicStone posn: 109 145 init:)
		(fruit1 init: setPri: 5)
		(fruit2 init: setPri: 5)
		(fruit3 init: setPri: 5)
		(fruit4 init: setPri: 5)
		(fruit5 init: setPri: 5)
		(fruit6 init: setPri: 5)
		(fruit7 init: setPri: 5)
		(fruit8 init: setPri: 5)
		(fruit9 init: setPri: 5)
		(fruit10 init: setPri: 5)
		(fruit11 init: setPri: 5)
		(fruit12 init: setPri: 5)
		(fruit13 init: setPri: 5)
		(fruit14 init: setPri: 5)
		(cSound
			stop:
			number: (GetSongNumber 24)
			loop: -1
			play:
		)
	)
	
	(method (dispose)
		(Bset 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '[<at,around][/scenery,clearing]')
								(HighPrint 10 10)
								(HighPrint 10 11)
								(HighPrint 10 12)
							)
							((Said '/flower,grass')
								(if (ego has: invBeautifulFlower)
									(pEvent claimed: 0)
								else
									(HighPrint 10 13)
								)
							)
							((or (Said '<up') (Said '/sky,cloud,star'))
								(HighPrint 10 14)
								(if isNightTime
									(HighPrint 10 15)
								else
									(HighPrint 10 16)
								)
							)
							((or (Said '<down') (Said '/ground')) (HighPrint 10 13))
							((Said '/tree,bush') (HighPrint 10 17))
							((Said '/blossom') (HighPrint 10 18))
							((Said '/apple')
								(if isNightTime
									(HighPrint 10 19)
								else
									(HighPrint 10 20)
								)
							)
							((Said '/hill,north,dragon,smoke,peak') (HighPrint 10 21))
							((Said '/cliff,cliff,east,west') (HighPrint 10 22))
							((Said '/ice') (HighPrint 10 23))
							((Said '/south,forest') (HighPrint 10 24))
							((Said '/boulder,brick')
								(if local1
									(HighPrint 10 25)
								else
									(HighPrint 10 26)
								)
							)
							((Said '/word,carving,mark')
								(if (< (ego distanceTo: magicStone) 50)
									(localproc_0091)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said '/rune')
								(if (< (ego distanceTo: magicStone) 50)
									(localproc_00c3)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said '/scroll') (localproc_0014))
							((Said '/chasm')
								(cond 
									((not local1) (HighPrint 10 27))
									((not (Btest 141)) (localproc_000c))
									((ego inRect: 80 115 160 160) (HighPrint 10 28))
									(else (PrintNotCloseEnough))
								)
							)
						)
					)
					((Said 'read>')
						(cond 
							((Said '/boulder,brick,word,carving,mark')
								(if (< (ego distanceTo: magicStone) 50)
									(localproc_0091)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said '/rune')
								(if (< (ego distanceTo: magicStone) 50)
									(localproc_00c3)
								else
									(PrintNotCloseEnough)
								)
							)
							((Said '/scroll') (localproc_0014))
						)
					)
					((Said 'open,force,move/brick,boulder') (localproc_00cc))
					((Said 'eat/apple')
						(cond 
							((> mealsPreEaten 2) (localproc_0088))
							((not (ego inRect: 109 88 223 106)) (HighPrint 10 29))
							(else
								(HighPrint 10 30)
								(= mealsPreEaten 4)
								(Bclear 124)
								(Bclear 125)
								(AddToScore POINTS_EATERANAFRUIT 2)
							)
						)
					)
					((Said 'lockpick,get>')
						(cond 
							((Said '/blossom') (HighPrint 10 31))
							((Said '/apple')
								(cond 
									((not (ego inRect: 109 88 223 106)) (PrintNotCloseEnough))
									((> mealsPreEaten 2) (localproc_0088))
									(else (HighPrint 10 32))
								)
							)
							((Said '/grass') (HighPrint 10 33))
							((Said '/boulder,brick') (localproc_00cc))
							((Said '/scroll') (localproc_0014))
							((Said '/flower')
								(if (Btest 140)
									(HighPrint 10 34)
								else
									(HighPrint 10 35)
								)
								(Bset 140)
								(ego get: invBeautifulFlower 5)
							)
						)
					)
					((Said 'odor/flower,blossom,grass,clearing') (HighPrint 10 36))
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skOPEN
								(cond 
									(local1 (HighPrint 10 37))
									((CastSpell temp0) (ego setScript: moveStoneAway))
								)
							)
							(skDETECTMAGIC
								(if (CastSpell temp0) (HighPrint 10 38))
							)
							(else  (pEvent claimed: 0))
						)
					)
					((or (Said 'nap') (Said 'go[<to]/nap'))
						(if (not (NeedSleep))
							(HighPrint 10 39)
							(DisposeScript 7)
						else
							(AddToScore POINTS_SLEEPERANA 5 CLASS_MAGICUSER)
							(ego setScript: goToSleep)
						)
					)
					((Said 'climb') (HighPrint 10 40))
					((Said 'throw') (HighPrint 10 41))
				)
			)
		)
	)
)

(instance goToSleep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= gEgoObjX (ego x?))
				(= gEgoObjY (ego y?))
				(= defaultPalette 1)
				(curRoom drawPic: 10 6)
				(ego view: 10 setLoop: 4 setCel: 0)
				(= seconds 3)
			)
			(1
				(PrintTimedMessage 3 10 42)
				(= seconds 3)
			)
			(2
				(SleepUntil 6 0)
				(= defaultPalette 0)
				(curRoom drawPic: 10 7)
				(ego posn: gEgoObjX gEgoObjY setLoop: 2)
				(magicStone forceUpd:)
				(UnlockEgo)
				(StopEgo)
				(self dispose:)
			)
		)
	)
)

(instance moveStoneAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego view: 521 loop: 0 cel: 0 cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 15)
			)
			(1
				(++ local0)
				(if (> (ego y?) 140)
					(magicStone
						posn: (+ (magicStone x?) 5) (- (magicStone y?) 2)
					)
				else
					(magicStone
						posn: (- (magicStone x?) 5) (+ (magicStone y?) 2)
					)
				)
				(= cycles 1)
			)
			(2
				(if (== local0 6)
					(= local0 0)
					(UnlockEgo)
					(= local1 1)
					(if (not (Btest 141)) (localproc_000c))
					(StopEgo)
					(ego loop: 2 setScript: 0)
				else
					(self changeState: 1)
				)
			)
		)
	)
)

(instance fruit1 of Extra
	(properties
		y 43
		x 166
		view 10
		loop 3
		cycleType 1
		minPause 50
		maxPause 100
		minCycles 1
		maxCycles 1
	)
)

(instance fruit2 of Extra
	(properties
		y 60
		x 139
		view 10
		loop 1
		cycleType 1
		minPause 60
		maxPause 110
		minCycles 1
		maxCycles 1
	)
)

(instance fruit3 of Extra
	(properties
		y 49
		x 154
		view 10
		loop 2
		cycleType 1
		minPause 70
		maxPause 120
		minCycles 1
		maxCycles 1
	)
)

(instance fruit4 of Extra
	(properties
		y 50
		x 175
		view 10
		loop 3
		cycleType 1
		minPause 80
		maxPause 130
		minCycles 1
		maxCycles 1
	)
)

(instance fruit5 of Extra
	(properties
		y 43
		x 184
		view 10
		loop 1
		cycleType 1
		minPause 90
		maxPause 140
		minCycles 1
		maxCycles 1
	)
)

(instance fruit6 of Extra
	(properties
		y 60
		x 191
		view 10
		loop 2
		cycleType 1
		minPause 100
		maxPause 150
		minCycles 1
		maxCycles 1
	)
)

(instance fruit7 of Extra
	(properties
		y 66
		x 208
		view 10
		loop 1
		cycleType 1
		minPause 40
		maxPause 90
		minCycles 1
		maxCycles 1
	)
)

(instance fruit8 of Extra
	(properties
		y 48
		x 136
		view 10
		loop 3
		cycleType 1
		minPause 30
		maxPause 80
		minCycles 1
		maxCycles 1
	)
)

(instance fruit9 of Extra
	(properties
		y 71
		x 163
		view 10
		loop 3
		cycleType 1
		minPause 20
		maxPause 70
		minCycles 1
		maxCycles 1
	)
)

(instance fruit10 of Extra
	(properties
		y 49
		x 208
		view 10
		loop 2
		cycleType 1
		maxPause 60
		minCycles 1
		maxCycles 1
	)
)

(instance fruit11 of Extra
	(properties
		y 80
		x 190
		view 10
		loop 3
		cycleType 1
		minPause 20
		maxPause 70
		minCycles 1
		maxCycles 1
	)
)

(instance fruit12 of Extra
	(properties
		y 43
		x 148
		view 10
		loop 1
		cycleType 1
		minPause 30
		maxPause 80
		minCycles 1
		maxCycles 1
	)
)

(instance fruit13 of Extra
	(properties
		y 70
		x 128
		view 10
		loop 2
		cycleType 1
		minPause 40
		maxPause 90
		minCycles 1
		maxCycles 1
	)
)

(instance fruit14 of Extra
	(properties
		y 79
		x 145
		view 10
		loop 1
		cycleType 1
		minPause 50
		maxPause 100
		minCycles 1
		maxCycles 1
	)
)

(instance magicStone of View
	(properties
		view 10
	)
)
