;;; Sierra Script 1.0 - (do not remove this comment)
(script# 28)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm28 0
)

(local
	local0
	local1
)
(instance redSign of Prop
	(properties
		view 28
	)
)

(instance greenSign of Prop
	(properties
		view 28
		loop 1
	)
)

(instance Magic of Prop
	(properties
		view 530
		cycleSpeed 2
	)
)

(instance rm28 of Room
	(properties
		picture 28
		horizon 115
		north 29
		west 27
	)
	
	(method (init)
		(Load rsVIEW 28)
		(Load rsVIEW 530)
		(rm28 style:
		(switch prevRoomNum
			(27 3)
			(else  16)
		))
		(super init:)
		(cSound fade:)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(switch prevRoomNum
			(27
				(ego posn: 1 160 setMotion: MoveTo 15 160)
			)
			(else 
				(if (not (Btest 142))
					(ego posn: 254 123 setMotion: MoveTo 254 130)
				)
			)
		)
		(if (Btest 142)
			(Magic
				posn: 98 160
				setPri: (+ (ego priority?) 1)
				ignoreActors:
				init:
			)
			(ego setScript: teleport)
		)
		(greenSign posn: 219 141 init:)
		(redSign setPri: 3 z: 23 posn: 251 124 init:)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(== (ego loop?) 0)
					(not local0)
					(== (ego onControl: origin) cLRED)
				)
				(= local0 1)
				(greenSign setScript: showGreenSign)
			)
			(
				(and
					(!= (ego loop?) 2)
					(not local1)
					(== (ego onControl: origin) cLCYAN)
				)
				(= local1 1)
				(redSign setScript: showRedSign)
			)
			((and (== (ego onControl: origin) cYELLOW) local1) (= local1 0))
			(
				(and
					local0
					(or
						(== (ego onControl: origin) cLMAGENTA)
						(== (ego onControl: origin) cYELLOW)
					)
				)
				(showGreenSign cue:)
			)
			((and (== (ego onControl: origin) cBLACK) local0) (= local0 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 18)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'spit') (Bset 142))
					((Said 'look>')
						(cond 
							((Said '<at,around[/!*]') (HighPrint 28 0))
							((Said '/path,road') (HighPrint 28 1))
							((Said '/hill,peak') (HighPrint 28 2))
							((Said '/ice') (HighPrint 28 3))
							((Said '/north,mansion,house') (HighPrint 28 4))
							((Said '/forest,west') (HighPrint 28 5))
							((Said '/east,south') (HighPrint 28 6))
							((or (Said '<up') (Said '/cloud,sky')) (HighPrint 28 7))
							((or (Said '<down') (Said '/ground')) (HighPrint 28 8))
						)
					)
					((Said 'throw/') (HighPrint 28 9))
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0) (HighPrint 28 10))
							)
							(skDAZZLE
								(if (CastSpell temp0) (HighPrint 28 11))
							)
							(skFLAMEDART
								(if (CastSpell temp0) (HighPrint 28 12))
							)
							(else  (pEvent claimed: 0))
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance showGreenSign of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(greenSign ignoreActors: 0 setCycle: EndLoop self)
			)
			(1
				(if (not (Btest 156)) (HighPrint 28 13))
				(switch (Random 1 3)
					(1 (HighPrint 28 14))
					(2 (HighPrint 28 15))
					(3 (HighPrint 28 16))
				)
				(Bset 156)
			)
			(2
				(greenSign ignoreActors: setCycle: BegLoop setScript: 0)
			)
		)
	)
)

(instance showRedSign of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(redSign ignoreActors: 0 setCycle: EndLoop self)
			)
			(1
				(ego setMotion: 0)
				(if (not (Btest 155)) (HighPrint 28 17))
				(switch (Random 1 3)
					(1 (HighPrint 28 18))
					(2 (HighPrint 28 19))
					(3 (HighPrint 28 20))
				)
				(Bset 155)
				(redSign ignoreActors: setCycle: BegLoop setScript: 0)
			)
		)
	)
)

(instance teleport of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego posn: 98 160 loop: 2 cel: 1 hide:)
				(Magic setCycle: CycleTo 6 1 self)
			)
			(1
				(ego show:)
				(Magic setCycle: EndLoop self)
			)
			(2
				(Bclear 142)
				(ego setScript: 0)
				(UnlockEgo)
			)
		)
	)
)
