;;; Sierra Script 1.0 - (do not remove this comment)
(script# 29)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use InputComparer)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm29 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
	local10
)
(procedure (localproc_000c param1 param2 &tmp [temp0 400])
	(Format @temp0 &rest)
	(Print
		@temp0
		#at
		-1
		12
		#mode
		1
		#width
		param2
		#dispose
		#time
		param1
	)
)

(procedure (localproc_0037)
	(= local5 1)
	(= local7 1)
	(Bset 143)
)

(procedure (localproc_0047)
	(= local5 5)
	(= local7 1)
)

(instance Magic of Prop
	(properties
		view 530
		cycleSpeed 2
	)
)

(instance leftDoor of Prop
	(properties
		view 29
	)
)

(instance rightDoor of Prop
	(properties
		view 29
		loop 1
	)
)

(instance gargoyle of Prop
	(properties
		view 29
		loop 2
	)
)

(instance gargoyleHead of Prop
	(properties
		view 29
		loop 5
		cel 1
		cycleSpeed 1
	)
)

(instance rm29 of Room
	(properties
		picture 29
		style $0008
		horizon 157
		north 30
	)
	
	(method (init)
		(Load rsVIEW 29)
		(Load rsVIEW 530)
		(Load rsTEXT 257)
		(super init:)
		(gKeyHandler add: self)
		(StatusLine enable:)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(gargoyle cycleSpeed: 2 posn: 155 88 init: stopUpd:)
		(gargoyleHead
			ignoreActors:
			posn: 156 75
			setPri: 15
			setCycle: Forward
			init:
			hide:
			stopUpd:
		)
		(leftDoor
			cel: (if (== prevRoomNum 30) 2 else 0)
			posn: 144 156
			init:
			stopUpd:
		)
		(rightDoor
			cel: (if (== prevRoomNum 30) 2 else 0)
			posn: 167 156
			init:
			stopUpd:
		)
		(self setScript: walkIn)
	)
	
	(method (doit)
		(cond 
			(local7
				(= local7 0)
				(gargoyle setScript: 0)
				(self setScript: teleportOut)
			)
			((and local0 (== (ego edgeHit?) 3)) (curRoom newRoom: 28))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 19)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 [temp2 10])
		(if
			(and
				4
				(or
					(== (pEvent message?) (User echo?))
					(and
						(<= KEY_SPACE (pEvent message?))
						(<= (pEvent message?) 127)
					)
				)
				(not isEgoLocked)
				local10
				(!= (pEvent message?) KEY_ESCAPE)
			)
			(pEvent claimed: 1)
			(if (User getInput: pEvent)
				(cond 
					((StringEquals (User inputLineAddr?) {look})
						(pEvent type: 128)
						(pEvent claimed: 0)
						(Parse (User inputLineAddr?) pEvent)
					)
					(
						(or
							(StringEquals (User inputLineAddr?) {ask})
							(StringEquals (User inputLineAddr?) {where})
						)
						(= local5 2)
						(= local7 1)
						(Bset 143)
					)
					(else
						(switch local9
							(1
								(if
								(StringEquals (User inputLineAddr?) @userName)
									(askQuestions changeState: 0)
								else
									(localproc_0037)
								)
							)
							(2
								(switch local8
									(1
										(if
											(or
												(StringEquals (User inputLineAddr?) {purple})
												(StringEquals (User inputLineAddr?) {red})
												(StringEquals (User inputLineAddr?) {pink})
											)
											(askQuestions changeState: 0)
										else
											(localproc_0037)
										)
									)
									(2
										(if
											(or
												(StringEquals (User inputLineAddr?) {hero})
												(StringEquals (User inputLineAddr?) {wizard})
											)
											(askQuestions changeState: 0)
										else
											(localproc_0037)
										)
									)
									(3
										(if
											(or
												(StringEquals (User inputLineAddr?) {fenrus})
												(StringEquals (User inputLineAddr?) {erasmus})
												(StringEquals (User inputLineAddr?) {wizard})
											)
											(askQuestions changeState: 0)
										else
											(localproc_0037)
										)
									)
								)
							)
							(3
								(if (Btest 154)
									(switch local8
										(1
											(if
												(or
													(StringEquals (User inputLineAddr?) {african})
													(StringEquals (User inputLineAddr?) {european})
												)
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
										(2
											(if
												(or
													(StringEquals (User inputLineAddr?) {42})
													(StringEquals (User inputLineAddr?) {forty two})
													(StringEquals (User inputLineAddr?) {forty-two})
												)
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
										(3
											(if (StringEquals (User inputLineAddr?) {yes})
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
										(4
											(if (StringEquals (User inputLineAddr?) {maybe})
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
									)
								else
									(switch local8
										(1
											(if (StringEquals (User inputLineAddr?) {stefan})
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
										(2
											(if (StringEquals (User inputLineAddr?) {erana})
												(askQuestions changeState: 0)
											else
												(localproc_0037)
											)
										)
										(3
											(= temp1 0)
											(while (<= temp1 6)
												(if
													(StringEquals
														(User inputLineAddr?)
														(Format @temp2 257 temp1)
													)
													(break)
												)
												(++ temp1)
											)
											(if (<= temp1 6)
												(= local5 3)
												(= local7 1)
												(Bset 143)
											else
												(= local6 1)
												(askQuestions changeState: 0)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '/house,mansion,north') (HighPrint 29 0))
							((Said '/gargoyle,creature') (HighPrint 29 1))
							((Said '/cliff,boulder') (HighPrint 29 2))
							((Said '/hill,peak,east') (HighPrint 29 3))
							((Said '/ice') (HighPrint 29 4))
							((or (Said '<up') (Said '/sky')) (HighPrint 29 5))
							(
							(or (Said '<down') (Said '/ground,path,south')) (HighPrint 29 6))
							((Said '/castle,west,forest') (HighPrint 29 7))
							((Said '/window') (HighPrint 29 8))
							((Said '/door')
								(if local4
									(HighPrint 29 9)
								else
									(HighPrint 29 10)
								)
							)
						)
					)
					((Said 'throw,attack,kill,beat') (localproc_0047))
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0) (HighPrint 29 11))
							)
							(skDAZZLE
								(if (CastSpell temp0) (localproc_0047))
							)
							(skFLAMEDART
								(if (CastSpell temp0) (localproc_0047))
							)
							(skOPEN
								(if (CastSpell temp0)
									(if local4 (HighPrint 29 12) else (localproc_0047))
								)
							)
						)
					)
					((or (Said 'nap[/!*]') (Said 'go[<to]/nap')) (= local5 4) (= local7 1))
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance walkIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ReduceSP 30)
				(cond 
					((< [skills skSP] 20) (= local2 1))
					((< [skills skSP] 60) (= local1 1))
				)
				(= local10 1)
				(cond 
					(local2
						(ego
							cycleSpeed: 2
							moveSpeed: 2
							view: 515
							setLoop: 2
							posn: 142 233
							setMotion: MoveTo 148 183 self
						)
					)
					(local1
						(ego
							cycleSpeed: 1
							moveSpeed: 1
							view: 515
							setLoop: 2
							posn: 142 233
							setMotion: MoveTo 148 183 self
						)
					)
					(else (ego posn: 135 213 setMotion: MoveTo 152 180 self))
				)
				(ego init:)
			)
			(1
				(cond 
					(local2 (ego setLoop: 1 cel: 0 setCycle: EndLoop) (= cycles 30))
					(local1
						(ego
							cycleSpeed: 2
							moveSpeed: 2
							setLoop: 0
							cel: 0
							setCycle: CycleTo 5 1
						)
						(= cycles 20)
					)
					(else (self cue:))
				)
			)
			(2
				(cond 
					(local2 (ego setCycle: BegLoop self))
					(local1 (ego setCycle: EndLoop self))
					(else (self cue:))
				)
			)
			(3
				(if local2
					(ego setLoop: 0 cel: 7 forceUpd:)
					(= cycles 5)
				else
					(self cue:)
				)
			)
			(4
				(= local0 1)
				(cond 
					((not (Btest 19))
						(HighPrint 29 13)
						(HighPrint 29 14)
						(HighPrint 29 15)
						(self cue:)
					)
					(local2 (HighPrint 29 16) (self cue:))
					(local1 (HighPrint 29 17) (self cue:))
					(else (HighPrint 29 18) (self cue:))
				)
			)
			(5
				(LockEgo)
				(gargoyle cel: 1 forceUpd:)
				(= cycles 5)
			)
			(6
				(gargoyleHead show: startUpd:)
				(cond 
					(isNightTime (localproc_000c 4 210 29 19))
					(local2 (localproc_000c 4 160 29 20))
					(local1 (localproc_000c 4 210 29 21))
					((Btest 19) (localproc_000c 4 140 29 22))
					(else (localproc_000c 4 110 29 23))
				)
				(= seconds 4)
			)
			(7
				(cond 
					(isNightTime (= local7 1) (gargoyleHead stopUpd: hide:))
					(local2 (localproc_000c 4 230 29 24))
					((Btest 354) (localproc_000c 4 230 29 25))
					(else (Bset 354) (localproc_000c 4 280 29 26))
				)
				(= seconds 4)
			)
			(8
				(gargoyleHead hide: stopUpd:)
				(= cycles 5)
			)
			(9
				(rm29 setScript: askQuestions)
			)
		)
	)
)

(instance teleportOut of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch local5
					(0 (localproc_000c 4 100 29 27))
					(1 (localproc_000c 4 60 29 28))
					(2 (localproc_000c 4 140 29 29))
					(3 (localproc_000c 4 180 29 30))
					(4 (localproc_000c 4 140 29 31))
					(5 (localproc_000c 4 180 29 32))
				)
				(LockEgo)
				(gargoyleHead show: startUpd:)
				(= seconds 4)
			)
			(1
				(if 2 (gargoyleHead hide: stopUpd:))
				(gargoyle setLoop: 4 setCycle: EndLoop self)
			)
			(2
				(gargoyle cel: 0 setCycle: EndLoop self)
			)
			(3
				(gargoyle setLoop: 3 cel: 0 setCycle: Forward)
				(Magic
					ignoreActors:
					setPri: (+ (ego priority?) 1)
					posn:
						(if
						(and (== (ego view?) 515) (== (ego loop?) 0))
							(+ (ego x?) 5)
						else
							(ego x?)
						)
						(ego y?)
					init:
					setCycle: CycleTo 6 1 self
				)
			)
			(4
				(ego hide:)
				(Magic setCycle: EndLoop self)
			)
			(5
				(Bset 142)
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 16)
				(self cue:)
			)
			(6 (curRoom newRoom: 28))
		)
	)
)

(instance askQuestions of Script
	(properties)
	
	(method (doit)
		(if (and (== state 1) (< (ego y?) 175)) (= local7 1))
		(if local3
			(= local3 0)
			(rm29 setScript: letHimIn)
			(gargoyle setScript: 0)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(gargoyleHead show: startUpd:)
				(switch (++ local9)
					(1
						(localproc_000c 4 170 29 33)
						(StopEgo)
						(ego loop: 3)
					)
					(2
						(switch (Random 1 3)
							(1
								(= local8 1)
								(localproc_000c 4 260 29 34)
							)
							(2
								(= local8 2)
								(localproc_000c 4 160 29 35)
							)
							(3
								(= local8 3)
								(localproc_000c 4 180 29 36)
							)
						)
					)
					(3
						(if (Btest 154)
							(switch (Random 1 4)
								(1
									(= local8 1)
									(localproc_000c 4 230 29 37)
								)
								(2
									(= local8 2)
									(localproc_000c 4 260 29 38)
								)
								(3
									(= local8 3)
									(localproc_000c 4 230 29 39)
								)
								(4
									(= local8 4)
									(localproc_000c 4 240 29 40)
								)
							)
						else
							(switch (Random 1 3)
								(1
									(= local8 1)
									(localproc_000c 4 280 29 41)
								)
								(2
									(= local8 2)
									(localproc_000c 4 280 29 42)
								)
								(3
									(= local8 3)
									(localproc_000c 4 280 29 43)
								)
							)
						)
					)
					(else  (= local3 1))
				)
				(= seconds 4)
			)
			(1
				(UnlockEgo)
				(gargoyleHead hide: stopUpd:)
			)
		)
	)
)

(instance letHimIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gargoyleHead show: startUpd:)
				(= local10 0)
				(if local6
					(localproc_000c 3 240 29 44)
				else
					(localproc_000c 3 140 29 45)
				)
				(= seconds 3)
			)
			(1
				(localproc_000c 4 230 29 46)
				(= seconds 4)
			)
			(2
				(localproc_000c 4 220 29 47)
				(= seconds 4)
			)
			(3
				(gargoyleHead hide: stopUpd:)
				(gargoyle setLoop: 3 cel: 0 setCycle: Forward)
				(= seconds 2)
			)
			(4
				(= local4 1)
				(leftDoor setCycle: EndLoop)
				(rightDoor setCycle: EndLoop self)
			)
			(5
				(leftDoor ignoreActors: stopUpd:)
				(rightDoor ignoreActors: stopUpd:)
				(UnlockEgo)
				(StopEgo)
				(ego loop: 3)
				(gargoyle setLoop: 2 setCel: 0 stopUpd:)
			)
		)
	)
)
