;;; Sierra Script 1.0 - (do not remove this comment)
(script# 53)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Extra)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm53 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
)
(procedure (localproc_000c param1)
	(if (!= local4 param1)
		(= local4 param1)
		(head cel: param1 forceUpd:)
	)
)

(instance tail of Extra
	(properties
		view 54
		loop 2
		cycleType 1
		minPause 40
		maxPause 90
		minCycles 1
		maxCycles 1
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					(
						(or
							(Said 'ride,fight,beat,chop,kill[/*]')
							(Said 'pull/tail')
						)
						(HighPrint 53 0)
					)
					((Said 'look>')
						(cond 
							((Said '/centaur,farmer') (if local0 (HighPrint 53 1) else (HighPrint 53 2)))
							((Said '/horse') (HighPrint 53 3))
							((Said '/man') (HighPrint 53 4))
							((Said '/hoe') (HighPrint 53 5))
						)
					)
					((Said 'buy,get/apple,carrot,produce')
						(if (not local0)
							(centaur setScript: standStill)
							(= local1 1)
							(pEvent claimed: 1)
						else
							(HighPrint 53 6)
						)
					)
					((Said 'chat/man,horse,centaur')
						(if (not local0)
							(centaur setScript: standStill)
							(= local1 1)
							(pEvent claimed: 1)
						else
							(HighPrint 53 7)
						)
					)
					((Said 'ask>')
						(if (not local0)
							(centaur setScript: standStill)
							(= local1 1)
							(pEvent claimed: 1)
						else
							(= local7 1)
							(cond 
								((Said '/farmer,name,heinrich') (HighPrint 53 8))
								(
								(Said '/elsa,baron,barnard,(barnard,daughter<baron)') (HighPrint 53 9))
								((Said '/filly,daughter') (HighPrint 53 10))
								((Said '/centaur') (HighPrint 53 11))
								((Said '/seed,pod') (HighPrint 53 12))
								((Said '/carrot,produce') (HighPrint 53 13))
								(
									(or
										(Said '/farm,field,field,harvest,crop,farming,job,labor')
										(Said '/time<harvest')
									)
									(HighPrint 53 14)
								)
								((Said '/bandit,robbery,attack')
									(HighPrint 53 15)
									(HighPrint 53 16)
									(HighPrint 53 17)
								)
								((Said '/leader,intervention,death')
									(AddToScore POINTS_TALKTOFARMERABOUTLEADER 3)
									(HighPrint 53 18)
									(HighPrint 53 19)
									(HighPrint 53 20)
								)
								((Said '/heal,potion,healer') (HighPrint 53 21))
								((Said '/weather,offseason') (HighPrint 53 22))
								((Said '/hoe,implement,broom') (HighPrint 53 23))
								((Said '/market,street,stand,hamlet') (HighPrint 53 24))
								((Said '/tree,orchard,apple,beet') (HighPrint 53 25))
								(else (= local7 0) (pEvent claimed: 1) (HighPrint 53 26))
							)
							(if (and local7 (pEvent claimed?)) (AddToScore POINTS_TALKTOFARMER 1))
						)
					)
				)
			)
		)
	)
)

(instance head of View
	(properties
		view 54
		loop 5
	)
)

(instance centaur of Actor
	(properties
		view 53
		cycleSpeed 2
		moveSpeed 2
	)
)

(instance rm53 of Room
	(properties
		picture 53
		horizon 105
		north 36
		east 54
		west 52
	)
	
	(method (init)
		(if (not isNightTime)
			(Load rsVIEW 53)
			(Load rsVIEW 54)
		)
		(= style
			(switch prevRoomNum
				(52 3)
				(54 2)
				(36 5)
				(else  13)
			)
		)
		(super init:)
		(cSound fade:)
		(StatusLine enable:)
		(if (Btest 323) (Bclear 323) else (Bset 323))
		(if (not isNightTime)
			(if (Btest 323)
				(centaur posn: 250 135)
			else
				(centaur posn: 120 135)
			)
			(centaur illegalBits: 0 init: setStep: 1 2 setCycle: Walk)
			(if (Btest 323)
				(centaur setMotion: MoveTo 120 135)
			else
				(centaur setMotion: MoveTo 250 135)
			)
			(tail init: setPri: 9 ignoreActors: hide:)
			(head init: setPri: 9 ignoreActors: hide:)
		)
		(StopEgo)
		(ego init:)
		(switch prevRoomNum
			(36
				(ego posn: 140 106 setMotion: MoveTo 140 110)
			)
			(52
				(ego posn: 1 140 setMotion: MoveTo 15 140)
			)
			(54
				(ego posn: 318 140 setMotion: MoveTo 300 140)
			)
			(else 
				(ego posn: 160 188 setMotion: MoveTo 160 170)
			)
		)
	)
	
	(method (doit)
		(cond 
			((and (not local6) (< (ego y?) 134)) (= local6 1) (ego setPri: 8))
			((and local6 (>= (ego y?) 134)) (= local6 0) (ego setPri: -1))
		)
		(if
			(or
				(and
					(> (centaur x?) 249)
					(not (Btest 323))
					(not local0)
					(not isNightTime)
				)
				(and
					(< (centaur x?) 121)
					(Btest 323)
					(not local0)
					(not isNightTime)
				)
				(and
					(< (ego distanceTo: centaur) 50)
					(< 130 (ego y?))
					(< (ego y?) 150)
					(not local0)
					(not isNightTime)
				)
			)
			(centaur setScript: standStill)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 43)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'climb,climb[/wall]')
						(if isNightTime
							(if (> (ego y?) 150)
								(if (TestSkill skCLIMBING 35 0)
									(curRoom newRoom: 334)
								else
									(HighPrint 53 27)
								)
							else
								(HighPrint 53 28)
							)
						else
							(HighPrint 53 29)
						)
					)
					((Said 'look>')
						(cond 
							((Said '[<up][/sky,cloud,star,moon]')
								(if isNightTime
									(HighPrint 53 30)
								else
									(HighPrint 53 31)
								)
							)
							(
								(or
									(Said '[<at,around][/field,garden]')
									(Said '[<down][/ground]')
								)
								(cond 
									(local0 (HighPrint 53 32))
									(isNightTime (HighPrint 53 33))
									(else (HighPrint 53 34))
								)
							)
							((Said '/tree,orchard,apple') (HighPrint 53 35))
							((Said '/forest,birch') (HighPrint 53 36))
							((Said '/plant,grass') (HighPrint 53 37))
							((Said '/wall,south') (HighPrint 53 38))
							((Said '/east') (HighPrint 53 39))
							((Said '/west') (HighPrint 53 40))
							((Said '/north') (HighPrint 53 41))
						)
					)
				)
			)
		)
	)
)

(instance standStill of Script
	(properties)
	
	(method (doit)
		(cond 
			((<= (ego x?) (- (centaur x?) 50)) (localproc_000c 0))
			((<= (ego x?) (- (centaur x?) 15)) (localproc_000c 1))
			((<= (ego x?) (+ (centaur x?) 15)) (localproc_000c 2))
			((<= (ego x?) (+ (centaur x?) 60)) (localproc_000c 3))
			(else (localproc_000c 4))
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local0 1)
				(if (< (centaur cel?) 4)
					(centaur setCycle: EndLoop self)
				else
					(self cue:)
				)
			)
			(1
				(centaur
					view: 54
					setLoop: (if (Btest 323) 1 else 0)
					cel: 0
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			(2
				(centaur
					setLoop: 4
					setCel: (if (Btest 323) 1 else 0)
					stopUpd:
				)
				(tail
					setLoop: (if (Btest 323) 3 else 2)
					posn:
						(if (Btest 323)
							(+ (centaur x?) 14)
						else
							(- (centaur x?) 16)
						)
						(- (centaur y?) 30)
					show:
				)
				(head
					posn:
						(if (Btest 323)
							(- (centaur x?) 8)
						else
							(+ (centaur x?) 5)
						)
						(- (centaur y?) 39)
					show:
				)
				(= cycles 2)
			)
			(3
				(cond 
					(local1
						(if (not local2)
							(= local2 1)
							(HighPrint 53 42)
						else
							(HighPrint 53 43)
						)
					)
					((not local3) (= local3 1) (HighPrint 53 44))
				)
				(UnlockEgo)
			)
		)
	)
)
