;;; Sierra Script 1.0 - (do not remove this comment)
(script# 218)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Skilled)
(use Inventory)

(public
	fighter 0
)

(class Fighter of Skilled
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits cWHITE
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		health 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		opponent 0
		fightLeft 0
		fighterView 501
		endFight 0
		baseX 187
		baseY 150
	)
	
	(method (init)
		(= strength 	[skills skSTRENGTH])
		(= intell 		[skills skINTELLIGENCE])
		(= agil 		[skills skAGILITY])
		(= vit 			[skills skVITALITY])
		(= luck 		[skills skLUCK])
		(= weap 		[skills skWEAPONUSE])
		(= parry 		[skills skPARRY])
		(= dodge 		[skills skDODGE])
		(= magic 		[skills skMAGIC])
		(= stamina 		[skills skSP])
		(= health 		[skills skHP])
		(= mana 		[skills skMP])
		(super init: &rest)
	)
	
	(method (tryAttack param1 &tmp temp0)
		(cond 
			(
				(>
					(= temp0
						(+ (- (self attackLevel:) (param1 defenseLevel:)) 50)
					)
					95
				)
				(= temp0 95)
			)
			((< temp0 5) (= temp0 5))
		)
		(return (if (>= temp0 (RollDice)) (return 1) else (return 0)))
	)
	
	(method (getTired param1 param2)
		(if (<= (= stamina (- stamina param1)) 0)
			(= stamina 0)
			(self endFight: 1)
			(self setScript: param2)
		)
		(= [skills 15] stamina)
	)
	
	(method (drawWeapons)
		(= baseX (opponent warriorX?))
		(= baseY (opponent warriorY?))
		(if (ego has: invShield) (= shieldValue 10))
		(= armorEnc (/ (GetTotalWeight) 2))
		(= armorValue 0)
		(cond 
			((ego has: invChainmailArmor) (= armorValue 5))
			((ego has: invLeatherArmor) (= armorValue 3))
		)
		(self weapValue: 8)
		(self
			ignoreActors: 1
			view: fighterView
			posn: baseX baseY
			stopUpd:
		)
	)
	
	(method (getHit)
		(if fightLeft
			(self x: (+ (self x?) 3))
			((self opponent?) x: (+ ((self opponent?) x?) 3))
		else
			(self x: (- (self x?) 3))
			((self opponent?) x: (- ((self opponent?) x?) 3))
		)
	)
	
	(method (gotBeat param1)
		(self endFight: 1)
		(self setScript: param1)
	)
)

(instance fighter of Fighter
	(properties)
)
