;;; Sierra Script 1.0 - (do not remove this comment)
(script# 11)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm11 0
)

(instance rm11 of EncRoom
	(properties
		picture 704
		style $0008
		east 12
		south 17
		encChance 30
		entrances 6
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(StopEgo)
		(self setLocales: 804)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(12
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(17
				(ego posn: 275 188 setMotion: MoveTo 275 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 1)
		(super dispose:)
	)
)
