;;; Sierra Script 1.0 - (do not remove this comment)
(script# 27)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm27 0
)

(instance rm27 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		east 28
		west 26
		encChance 20
		entrances 10
		illBits (& cWHITE cLRED)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(Load rsVIEW 702)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(28
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(26
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
		)
		(gAddToPics
			add: northBush southBush snow1 snow2 snow5 snow6 snow7
			eachElementDo: #init
			doit:
		)
		(snow3 setPri: 15 ignoreActors: init: addToPic:)
		(snow4 setPri: 1 ignoreActors: init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 17)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (and (Said 'look>') (Said '/ice'))
					(HighPrint 27 0)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance northBush of PicView
	(properties
		y 71
		x 136
		view 700
		loop 2
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 153
		view 700
		loop 2
		cel 1
		priority 15
	)
)

(instance snow1 of PicView
	(properties
		y 40
		x 263
		view 702
		priority 15
	)
)

(instance snow2 of PicView
	(properties
		y 76
		x 256
		view 702
		loop 1
		priority 15
	)
)

(instance snow3 of View
	(properties
		y 134
		x 268
		view 702
		loop 2
	)
)

(instance snow4 of View
	(properties
		y 125
		x 284
		view 702
		loop 3
	)
)

(instance snow5 of PicView
	(properties
		y 26
		x 185
		view 702
		loop 4
		priority 15
	)
)

(instance snow6 of PicView
	(properties
		y 44
		x 179
		view 702
		loop 4
		cel 1
		priority 15
	)
)

(instance snow7 of PicView
	(properties
		y 83
		x 194
		view 702
		loop 5
	)
)
