;;; Sierra Script 1.0 - (do not remove this comment)
(script# 43)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm43 0
)

(instance rm43 of EncRoom
	(properties
		picture 705
		style $0008
		south 57
		west 42
		encChance 20
		entrances 12
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(42
				(ego posn: 0 140 setMotion: MoveTo 320 140)
			)
			(57
				(ego posn: 45 189 setMotion: MoveTo 45 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 33)
		(super dispose:)
	)
)
