;;; Sierra Script 1.0 - (do not remove this comment)
(script# 52)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Game)

(public
	rm52 0
)

(instance rm52 of Room
	(properties
		picture 700
		style $0008
		horizon 90
		north 35
		east 53
		south 64
		west 51
	)
	
	(method (init)
		(if isNightTime (Load rsSCRIPT 805))
		(super init: &rest)
		(StatusLine enable:)
		(self setLocales: 804)
		(if isNightTime
			(switch (Random 1 5)
				(1
					((ScriptID 805 5) init: setScript: (ScriptID 805 0))
				)
				(2
					((ScriptID 805 6) init: setScript: (ScriptID 805 1))
				)
				(3
					((ScriptID 805 7) init: setScript: (ScriptID 805 4))
				)
				(4
					((ScriptID 805 5) init: setScript: (ScriptID 805 0))
				)
				(5
					((ScriptID 805 7) init: setScript: (ScriptID 805 3))
				)
			)
		)
		(StopEgo)
		(ego init:)
		(switch prevRoomNum
			(35
				(ego posn: 140 92 setMotion: MoveTo 140 190)
			)
			(51
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(64
				(ego posn: 160 188 setMotion: MoveTo 160 0)
			)
			(53
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
		(self setRegions: 806)
	)
	
	(method (dispose)
		(Bset 42)
		(super dispose:)
	)
)
