;;; Sierra Script 1.0 - (do not remove this comment)
(script# 71)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use User)
(use System)

(public
	rm71 0
)

(instance rm71 of EncRoom
	(properties
		picture 703
		style $0008
		horizon 90
		north 63
		east 72
		south 78
		west 70
		encChance 15
	)
	
	(method (init)
		(if (and isNightTime (== prevRoomNum 70))
			(Load rsSCRIPT 295)
		)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(63
				(ego posn: 190 92 setMotion: MoveTo 190 190)
			)
			(72
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(70
				(ego posn: 1 140 setMotion: MoveTo 50 140)
				(if (Btest 188)
					(User canControl: 0)
					(User canInput: 0)
					(Bclear 188)
					(self setScript: (ScriptID 295 0))
				)
			)
			(78
				(ego posn: 200 188 setMotion: MoveTo 200 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 61)
		(super dispose:)
	)
)
