;;; Sierra Script 1.0 - (do not remove this comment)
(script# 74)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm74 0
)

(instance rm74 of EncRoom
	(properties
		picture 700
		style $0008
		horizon 90
		north 65
		east 75
		south 81
		west 73
		encChance 15
		ambushX 100
		ambushY 120
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 240)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(65
				(ego posn: 140 92 setMotion: MoveTo 140 190)
			)
			(73
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(81
				(ego posn: 160 188 setMotion: MoveTo 160 0)
			)
			(75
				(ego posn: 318 140 setMotion: MoveTo 0 120)
			)
		)
		(eyes setPri: 5 init: stopUpd: setScript: peekABooScript)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 64)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (Said 'look/eye') (HighPrint 74 0))
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance peekABooScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 6 25)))
			(1 (eyes setCycle: EndLoop self))
			(2 (self changeState: 0))
		)
	)
)

(instance eyes of Prop
	(properties
		y 67
		x 305
		view 240
		cycleSpeed 1
	)
)
