;;; Sierra Script 1.0 - (do not remove this comment)
(script# 92)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm92 0
)

(instance rm92 of EncRoom
	(properties
		picture 707
		style $0008
		west 91
		encChance 50
		entrances 9
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (Bset 84) (Bset 348))
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(86
				(ego posn: 160 30 setMotion: MoveTo 160 190)
			)
			(91
				(ego posn: 1 100 setMotion: MoveTo 320 100)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (doit)
		(if
		(and (== (ego onControl: origin) cLRED) (== (ego loop?) 3))
			(curRoom newRoom: 86)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 82)
		(super dispose:)
	)
)
