;;; Sierra Script 1.0 - (do not remove this comment)
(script# 804)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Game)

(public
	Forest 0
)

(local
	local0
)
(instance Forest of Locale
	(properties)
	
	(method (init &tmp curRoomPicture temp1)
		(super init: &rest)
		(Load rsVIEW 510)
		(LoadMany 130 103 102)
		(if
			(and
				(>= (= curRoomPicture (curRoom picture?)) 704)
				(<= curRoomPicture 707)
			)
			(= local0 1)
		)
		(= temp1 (if isNightTime 32 else 25))
		(if
			(or
				(== (cSound state?) 0)
				(!= (cSound number?) temp1)
			)
			(cSound
				stop:
				number: temp1
				loop: -1
				priority: 0
				play:
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (pEvent claimed?) (return))
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							(
							(Said '[<at,around][/!*,forest,greenery,clearing]')
								(if local0
									(HighPrint 804 0)
								else
									(HighPrint 804 1)
								)
							)
							((Said '[<down][/ground,needle,moss,grass]')
								(if local0
									(HighPrint 804 2)
								else
									(HighPrint 804 3)
								)
							)
							((Said '[<up][/sky,cloud,star,moon]')
								(if isNightTime
									(HighPrint 804 4)
								else
									(HighPrint 804 5)
								)
							)
							((Said '/birch,tree') (HighPrint 804 6))
							((Said '/bush') (HighPrint 804 7))
							((Said '/boulder')
								(if local0
									(HighPrint 804 8)
								else
									(HighPrint 804 9)
								)
							)
							((Said '/hill,cliff,peak,pass')
								(if local0
									(HighPrint 804 8)
								else
									(HighPrint 804 10)
								)
							)
							((Said '/cave') (HighPrint 804 11))
						)
					)
					((Said 'climb') (HighPrint 804 12))
					(
						(or
							(Said 'get/boulder,brick')
							(Said 'lockpick<up,boulder,brick')
						)
						(ego setScript: (ScriptID 103 0))
					)
					((Said 'kiss/tree') (HighPrint 804 13))
				)
			)
		)
	)
)
