;;; Sierra Script 1.0 - (do not remove this comment)
(script# 1)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use User)
(use Menu)

(public
	SetGameInit 0
	SetGraphicsSoundInit 1
)

(procedure (SetGameInit &tmp [temp0 21])
	(User alterEgo: ego)
	(User prompt: {} blocks: 0 y: 160)
	(= showStyle HSHUTTER)
	(= razzleDazzleRootBeer FALSE)
	(TheMenuBar init:)
	(= thievesGuildPassword (Random 0 6))
	(= possibleScore 500)
	(= userFont 300)
	(= smallFont ARROW_CURSOR)
	(= bigFont 300)
	(= spRefreshCountdown 20)
	(= hpRefreshCountdown 15)
	(= manaRefreshCountdown 5)
	(SetGraphicsSoundInit)
	(SetGameTime 11)
	(DoSound sndVOLUME 15)
	(UnlockEgo)
	(if (HaveMouse)
		(theGame setCursor: normalCursor 1)
	else
		(theGame setCursor: normalCursor 1 304 174)
	)
	(Bset EVENT_SAVEENABLED)
	(Joystick 12 0)
	(if (GameIsRestarting)
		(= startingRoom 9)	;if restarting, go to the Game Select Screen
	else
		(= startingRoom 2)	;otherwise, go to the PIRACY notice screen
	)
	(theGame newRoom: 299)	;but first, we initialize in the speedCheck room.
)

(procedure (SetGraphicsSoundInit)
	(= musicChannels (DoSound sndCHECK_DRIVER))
	(if (< (= colourCount (Graph grGET_COLOURS)) 16)
		;CGA
		(= hpStatusView 804)
		(= hpFontColour vWHITE)
		(= statColour vBLACK)
		(= statColourNew vRED)
	else
		;EGA
		(= hpStatusView 803)
		(= hpFontColour vLCYAN)
		(= statColour vLBLUE)
		(= statColourNew vLRED)
	)
)
