;;; Sierra Script 1.0 - (do not remove this comment)
(script# 301)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm301 0
	shameen 1
	shema 2
	lickIt 3
	rmDoor 4
	swDoor 5
	innMusic 6
	food 7
	chair 8
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
)
(procedure (localproc_001c)
	(HighPrint 301 0)
	(HighPrint 301 1)
	(HighPrint 301 2)
	(HighPrint 301 3)
	(shema setScript: (ScriptID 169 0))
)

(instance rm301 of Room
	(properties
		picture 301
		south 300
	)
	
	(method (init)
		(LoadMany 128 301 303 304 302)
		(LoadMany 130 165 166 167 168 169 170)
		(LoadMany 132 21 50)
		(rm301 style: (if (== prevRoomNum 302) 16 else 2))
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onSleepDoor
				onLargeTable
				onFireplace
				onKitchenDoor
				onPlates
				onTable
		)
		(StatusLine enable:)
		(self setLocales: 801)
		(= local2 5)
		(= local3 1)
		(= local4 3)
		(Bclear 254)
		(Bclear 303)
		(Bclear 112)
		(Bclear 302)
		(Bclear 300)
		(Bclear 301)
		(Bclear 111)
		(= countdownAwaitingResponse 0)
		(StopEgo)
		(ego init:)
		(tools init:)
		(shamLeg init:)
		(gAddToPics add: tools shamLeg doit:)
		(chair init: stopUpd:)
		(swDoor init: stopUpd:)
		(rmDoor
			cel: (if (== prevRoomNum 302) 2 else 0)
			setPri: 8
			init:
			ignoreActors:
			stopUpd:
		)
		(fire init: setCycle: Forward startUpd:)
		(if
			(and
				(or (== timeZone TIME_SUNSET) (== timeZone TIME_NIGHT))
				(or (not (Btest 115)) (== (Random 0 1) 0))
			)
			(Bset 115)
			((ScriptID 166 0) init:)
			(gCast delete: (ScriptID 166 0))
			(gCast addToFront: (ScriptID 166 0))
		)
		(shameen init:)
		(switch prevRoomNum
			(302
				(ego posn: 50 130 setMotion: MoveTo 70 130)
				(rmDoor setCycle: BegLoop)
			)
			(else 
				(ego posn: 200 188 setMotion: MoveTo 200 175)
			)
		)
		(innMusic init: play:)
	)
	
	(method (dispose)
		(Bset 89)
		(gMouseHandler delete: self)
		((ScriptID 166 0) dispose:)
		(super dispose:)
		(DisposeScript 165)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					(
						(or
							(Said 'nap,rent,get,pay,buy/room,lodging')
							(Said 'go/nap')
						)
						(if (not (ego inRect: 200 120 319 160))
							(HighPrint 301 4)
						)
					)
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,room,building,hotel]') (HighPrint 301 5))
							(
								(Said
									'/shameen,cat,katta,creature,owner,innkeeper,keeper'
								)
								(HighPrint 301 6)
							)
							((Said '/shema,hostess,girl,female')
								(if (Btest 301)
									(HighPrint 301 7)
								else
									(HighPrint 301 8)
								)
							)
							((Said '/man,abdulla')
								(if (gCast contains: (ScriptID 166 0))
									(HighPrint 301 9)
								else
									(HighPrint 301 10)
								)
							)
							((Said '/table') (HighPrint 301 11) (HighPrint 301 12))
							((Said '/chair') (HighPrint 301 13))
							((Said '/door') (HighPrint 301 14))
							((Said '/wall') (HighPrint 301 15))
							((or (Said '<up') (Said '/ceiling,beam')) (HighPrint 301 16))
							((or (Said '<down') (Said '/floor,carpet')) (HighPrint 301 17))
							((Said '/mantle') (HighPrint 301 18))
							((Said '/andiron,implement') (HighPrint 301 19))
							((Said '/cup,mug,drink,beverage,tea,coffee')
								(switch teaOrdered
									(mealATTABLE (HighPrint 301 20))
									(mealFINISHED (HighPrint 301 21))
									(else  (HighPrint 301 22))
								)
							)
							(
							(Said '/plate,bowl,food,breakfast,lamb,chicken,soup')
								(switch foodOrdered
									(mealATTABLE (HighPrint 301 23))
									(mealFINISHED (HighPrint 301 24))
									(else  (HighPrint 301 25))
								)
							)
						)
					)
					((Said 'open/door')
						(cond 
							((== (ego onControl: origin) cYELLOW) (HighPrint 301 26))
							((== (ego onControl: origin) cLMAGENTA) (HighPrint 301 27))
							(else (pEvent claimed: 0))
						)
					)
					((Said 'chat/man') (PrintNotCloseEnough))
					((Said 'pay[/man,shameen,abdulla,shema]') (HighPrint 301 28))
					((Said 'odor/food,lamb,chicken,soup,spice,aroma') (HighPrint 301 29))
					((Said 'stand')
						(if (Btest 254)
							(HighPrint 301 30)
						else
							(pEvent claimed: 0)
						)
					)
					((or (Said 'sat<down') (Said 'sat[/chair]'))
						(if (not (Btest 254))
							(if (ego inRect: 100 135 175 180)
								(ego setScript: (ScriptID 170 0))
								(shameen setScript: (ScriptID 165 1))
							else
								(HighPrint 301 31)
							)
						else
							(HighPrint 301 32)
						)
					)
					((Said 'eat')
						(switch foodOrdered
							(mealNOTHING
								(if (Btest 254)
									(HighPrint 301 33)
								else
									(HighPrint 301 34)
								)
							)
							(mealORDERED (HighPrint 301 35))
							(mealATTABLE
								(cond 
									((Btest 125) (Bclear 125) (Bclear 124))
									((Btest 124) (Bclear 124) (= mealsPreEaten 1))
									(else (= mealsPreEaten 2))
								)
								(AddToScore POINTS_EATKATTAFOOD 1)
								(ego setScript: eatIt)
							)
							(mealFINISHED (HighPrint 301 36))
						)
					)
					((Said 'drink')
						(switch teaOrdered
							(mealNOTHING
								(if (Btest 254)
									(HighPrint 301 37)
								else
									(HighPrint 301 38)
								)
							)
							(mealORDERED (HighPrint 301 35))
							(mealATTABLE (ego setScript: eatIt))
							(mealFINISHED (HighPrint 301 39))
						)
					)
					(
					(or (Said '/hostess') (Said 'order,get/food,drink'))
						(if (Btest 254)
							(cond 
								(
								(or (Btest 112) (== foodOrdered mealORDERED) (== foodOrdered mealATTABLE)) (HighPrint 301 40))
								((> mealsPreEaten 1) (HighPrint 301 41))
								(mealsPreEaten (HighPrint 301 42))
								((not (gCast contains: (ScriptID 301 2)))
									(= foodOrdered mealNOTHING)
									(= teaOrdered mealNOTHING)
									((ScriptID 301 2) init:)
									(gCast delete: (ScriptID 301 2))
									(gCast addToFront: (ScriptID 301 2))
								)
								((and 0 (not ((ScriptID 301 2) script?)))
									(= foodOrdered mealNOTHING)
									(= teaOrdered mealNOTHING)
									((ScriptID 301 2) setScript: (ScriptID 168 0))
								)
								(else (HighPrint 301 43))
							)
						else
							(HighPrint 301 34)
						)
					)
				)
			)
		)
	)
)

(instance shameen of Prop
	(properties
		view 302
		loop 4
	)
	
	(method (init)
		(self posn: 238 119 setPri: 9 ignoreActors:)
		(self setScript: (ScriptID 165 0))
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl shameen pEvent 3)
					(HighPrint 301 6)
				)
			)
			(evSAID
				(cond 
					((Said 'chat/man,cat,katta,shameen') (HighPrint 301 44))
					(
						(or
							(Said 'nap,rent,get,pay,buy[/room]')
							(Said 'go/nap')
						)
						(cond 
							((and (< 750 currentTime) (< currentTime 2550)) (HighPrint 301 45))
							((Btest 125) (HighPrint 301 46))
							((not (ego inRect: 200 120 319 160)) (HighPrint 301 4))
							((GiveSilverCoins local2) (Bset 122) (shameen setScript: (ScriptID 167 0)))
							(else (HighPrint 301 47))
						)
					)
					((Said 'ask>')
						(= local5 1)
						(cond 
							((Said '/tavern,bar') (HighPrint 301 48))
							((Said '/abenteuer,hall[<club,about]') (HighPrint 301 49))
							((Said '/zara,magic,shop') (HighPrint 301 50))
							((Said '/hotel,(fable<hero),replace,journey') (HighPrint 301 51) (HighPrint 301 52))
							((Said '/room,bed,nap,rest,lodging,cost') (HighPrint 301 53))
							(
								(Said
									'/food,lamb,chicken,soup,drink,breakfast,coffee,tea'
								)
								(HighPrint 301 44)
							)
							(
							(Said '/weapon,blade,dagger,shield,equipment,armor') (HighPrint 301 54))
							((Said '/abdulla,man')
								(if (gCast contains: (ScriptID 166 0))
									(HighPrint 301 55)
								else
									(HighPrint 301 56)
								)
							)
							((Said '/monster,ogre,goon,centaur') (HighPrint 301 57))
							((Said '/hamlet,valley') (HighPrint 301 58))
							((Said '/ale,sweat,breath,wine') (HighPrint 301 59))
							((Said '/robbery,loss,alm,gold,silver') (HighPrint 301 60))
							((Said '/loot,caravan,destiny') (HighPrint 301 61))
							((Said '/spice') (HighPrint 301 62))
							((Said '/home,desert,south,land') (HighPrint 301 63))
							((Said '/labor,hero,adventure,hall,abenteuer') (HighPrint 301 64))
							((Said '/bandit') (HighPrint 301 65))
							((Said '/name') (HighPrint 301 66))
							((Said '/shema,companion') (HighPrint 301 67))
							((Said '/katta,cat,people,sand') (HighPrint 301 68))
							((Said '/shameen,keeper,innkeeper,owner') (HighPrint 301 69))
							((Said '/magic,spell,potion,wand,scroll') (HighPrint 301 70))
							((Said '/*')
								(= local5 0)
								(switch local0
									(0 (HighPrint 301 71))
									(1 (HighPrint 301 72))
									(2 (HighPrint 301 73))
								)
								(if (== local0 2) (= local0 0) else (++ local0))
							)
						)
						(if local5 (AddToScore POINTS_TALKTOSHAMEEN 1))
					)
				)
			)
		)
	)
)

(instance lickIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(++ local1)
				(shameen
					setLoop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(if (< local1 (Random 2 5))
					(self changeState: 0)
				else
					(= local1 0)
					(shameen setLoop: 4 cel: 0 cycleSpeed: 0 stopUpd:)
					(= seconds (Random 5 15))
				)
			)
			(2 (self changeState: 0))
		)
	)
)

(instance shema of Actor
	(properties
		view 303
	)
	
	(method (init)
		(super init:)
		(self
			illegalBits: 0
			ignoreActors:
			posn: 155 99
			setCycle: Walk
			setScript: (ScriptID 168 0)
		)
	)
	
	(method (doit)
		(if (> countdownAwaitingResponse 1)
			(-- countdownAwaitingResponse)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl self pEvent 3)
					(HighPrint 301 74)
					;Shema, mate of Shameen the innkeeper.
				)
			)
			(evSAID
				(if
					(and
						(Btest 301)
						(< ((ScriptID 301 2) distanceTo: ego) 30)
					)
					(cond 
						((Said 'chat/shema,girl,katta,cat,hostess')
							(HighPrint 301 75)
							;"It is my pleasure to serve you."
						)
						((Said 'affirmative')
							(if countdownAwaitingResponse
								(HighPrint 301 76)
								;"Then you shall order food or drink."
								(= countdownAwaitingResponse 0)
							else
								(HighPrint 301 77)
								;"I am so sorry.  I do not understand."
							)
						)
						((Said 'n')
							(if countdownAwaitingResponse
								(HighPrint 301 78)
								;"Then please enjoy our table and our fire."
								(= countdownAwaitingResponse 0)
								(shema setScript: (ScriptID 169 0))
							else
								(HighPrint 301 77)
								;"I am so sorry.  I do not understand."
							)
						)
						((Said 'ask>')
							(cond 
								((Said '/food,breakfast,lamb,chicken,soup') (HighPrint 301 79))
								((Said '/drink,coffee,tea') (HighPrint 301 80) (HighPrint 301 81))
								((Said '/ale,wine,sweat,breath') (HighPrint 301 82))
								((Said '/spice') (HighPrint 301 62))
								((Said '/name,shema') (HighPrint 301 83))
								((Said '/shameen') (HighPrint 301 84))
								((Said '/katta,desert,people,home,sand,sun,south') (HighPrint 301 85))
								((Said '/*') (HighPrint 301 86))
							)
						)
						((Said 'pay[/food,drink,shema]')
							(if (or (== foodOrdered mealATTABLE) (== teaOrdered mealATTABLE))
								(HighPrint 301 87)
							else
								(HighPrint 301 88)
							)
						)
						((Said 'buy,order,get>')
							(cond 
								((or (== foodOrdered mealORDERED) (== foodOrdered mealATTABLE))
									(HighPrint 301 40)
									;You have already ordered.
								)
								((Said '/food,breakfast,lamb,chicken,soup,plate,bowl')
									(cond 
										((not (GiveSilverCoins local4))
											(localproc_001c)
										)
										((and (== teaOrdered foodOrdered) (== foodOrdered mealNOTHING))
											(HighPrint 301 89)
											;"With great pleasure will I serve you a fine meal."
											(= serveFoodCountdown 100)
											(= foodOrdered mealORDERED)
											(= teaOrdered mealORDERED)
											(shema setScript: (ScriptID 169 0))
										)
										(else 
											(HighPrint 301 43)
										)
									)
								)
								((Said '/drink,coffee,tea,cup,cup')
									(cond 
										((not (GiveSilverCoins local3))
											(localproc_001c)
										)
										((and (== teaOrdered foodOrdered) (== foodOrdered mealNOTHING))
											(HighPrint 301 90)
											(= serveFoodCountdown 100)
											(= teaOrdered mealORDERED)
											(shema setScript: (ScriptID 169 0))
										)
									)
								)
								((Said '/nothing')
									(HighPrint 301 91)
									(shema setScript: (ScriptID 169 0))
								)
								((Said '*')
									(HighPrint 301 92)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance food of View
	(properties
		y 136
		x 127
		view 301
		loop 5
		cel 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl self pEvent 3)
				(switch foodOrdered
					(mealATTABLE (HighPrint 301 23))
					(mealFINISHED (HighPrint 301 24))
				)
			)
		)
	)
)

(instance eatIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (gCast contains: food) (food setCel: 5))
				(= cycles 2)
			)
			(1
				(if (== foodOrdered mealATTABLE)
					(HighPrint 301 93)
					(= foodOrdered mealFINISHED)
				)
				(self cue:)
			)
			(2
				(if (== teaOrdered mealATTABLE)
					(HighPrint 301 94)
					(= teaOrdered mealFINISHED)
				)
				(Bset 302)
				(ego setScript: (ScriptID 170 0))
			)
		)
	)
)

(instance swDoor of Prop
	(properties
		y 107
		x 168
		view 301
		loop 1
		cycleSpeed 1
	)
)

(instance rmDoor of Prop
	(properties
		y 140
		x 30
		view 301
		loop 4
	)
)

(instance fire of Prop
	(properties
		y 137
		x 285
		view 301
		loop 3
		cycleSpeed 1
	)
)

(instance chair of Prop
	(properties
		y 154
		x 141
		view 301
		loop 5
		cel 4
	)
)

(instance tools of PicView
	(properties
		y 154
		x 287
		view 301
		loop 5
	)
)

(instance shamLeg of PicView
	(properties
		y 129
		x 238
		view 302
		loop 3
		cel 1
		priority 9
	)
)

(instance innMusic of Sound
	(properties
		number 21
	)
)

(instance onTable of RFeature
	(properties
		nsTop 129
		nsLeft 64
		nsBottom 140
		nsRight 135
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTable pEvent 3) (HighPrint 301 11))
		)
	)
)

(instance onKitchenDoor of RFeature
	(properties
		nsTop 58
		nsLeft 168
		nsBottom 108
		nsRight 201
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKitchenDoor pEvent 3) (HighPrint 301 95))
		)
	)
)

(instance onPlates of RFeature
	(properties
		nsTop 41
		nsLeft 65
		nsBottom 82
		nsRight 247
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(not (IsObjectOnControl onKitchenDoor pEvent 3))
					(IsObjectOnControl onPlates pEvent 3)
				)
				(HighPrint 301 96)
			)
		)
	)
)

(instance onFireplace of RFeature
	(properties
		nsTop 81
		nsLeft 265
		nsBottom 140
		nsRight 291
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onFireplace pEvent 3)
					(Said 'look/fire,log,chimney,brick')
				)
				(HighPrint 301 97)
			)
		)
	)
)

(instance onLargeTable of RFeature
	(properties
		nsTop 84
		nsLeft 91
		nsBottom 95
		nsRight 140
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLargeTable pEvent 3) (HighPrint 301 98))
		)
	)
)

(instance onSleepDoor of RFeature
	(properties
		nsTop 73
		nsLeft 29
		nsBottom 126
		nsRight 45
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSleepDoor pEvent 3) (HighPrint 301 99))
		)
	)
)
