;;; Sierra Script 1.0 - (do not remove this comment)
(script# 302)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use Game)
(use System)

(public
	rm302 0
)

(local
	local0
)
(procedure (localproc_000c &tmp temp0)
	(while (not ((= temp0 (Event new: 5)) type?))
		(temp0 dispose:)
	)
	(temp0 dispose:)
)

(instance rm302 of Room
	(properties
		picture 400
		style $0009
	)
	
	(method (init)
		(LockEgo)
		(super init:)
		(StatusLine enable:)
		(ego view: 800 loop: 0 cel: 2 posn: 160 75 init:)
		(self setScript: rm302Script)
	)
	
	(method (dispose)
		(super dispose:)
	)
)

(instance rm302Script of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(SleepUntil 6 0)
				(= temp0
					{Asleep at the Hero's Tale Inn.\nThe sleep heals and refreshes you.}
				)
				(= temp1 (if (< colourCount 16) 15 else 13))
				(Display temp0 p_font 300 p_width 200 p_at 80 133 p_color temp1)
				(localproc_000c)
				(= cycles 2)
			)
			(2 (curRoom newRoom: 301))
		)
	)
)
