;;; Sierra Script 1.0 - (do not remove this comment)
(script# 67)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateOpen)
(use TargActor)
(use LoadMany)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm67 0
)

(local
	[local0 10] = [205 180 243 73 103 67 74 72 54 25]
	local10
	local11
	local12
	local13
	local14
	local15
	local16
	local17
	local18
)
(instance rm67 of Room
	(properties
		picture 67
		style $0008
		horizon 90
		north 57
		east 68
		west 66
	)
	
	(method (init)
		(LoadMany 128 700 240 510)
		(super init:)
		(self setLocales: 804)
		(StatusLine enable:)
		(southBush setPri: 15 init: addToPic:)
		(if
		(and (Btest 176) (Btest 177) (not (Btest 207)))
			(= local12 1)
			(Bset 207)
			(Load rsVIEW 67)
			(Load rsVIEW 68)
			(fox init: setScript: foxCallForHelp)
			(Load rsVIEW 522)
			(Load rsVIEW 518)
			(HighPrint 67 0)
		)
		(if (not local12)
			(eyes1
				setPri: 5
				init:
				stopUpd:
				setScript: peekABooScript1
			)
			(eyes2
				setPri: 5
				init:
				stopUpd:
				setScript: peekABooScript2
			)
		)
		(if (Btest 176) (Bset 177))
		(Bset 176)
		(StopEgo)
		(ego init:)
		(switch prevRoomNum
			(57
				(ego posn: 140 92 setMotion: MoveTo 140 190)
			)
			(66
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(68
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
	)
	
	(method (doit)
		(if
			(and
				(< (= local18 (ego distanceTo: fox)) 75)
				(not local16)
				(not (fox script?))
				(not (ego script?))
				local12
			)
			(= local16 1)
			(fox setScript: foxExplains)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 57)
		(= gGEgoObjY (ego y?))
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '<at,around[/!*,road]') (HighPrint 67 1))
							((Said '/eye') (HighPrint 67 2))
							(
								(or
									(Said '/trap,hasp,chain')
									(and (Said '<down') (ego inRect: 55 111 120 120))
								)
								(cond 
									(local12 (HighPrint 67 3))
									(local15 (HighPrint 67 4))
									((not (ego inRect: 55 111 120 120)) (pEvent claimed: 0))
									(else (HighPrint 67 5))
								)
							)
							((Said '/fox')
								(if local12
									(HighPrint 67 6)
								else
									(HighPrint 67 7)
								)
							)
						)
					)
					((Said 'get>')
						(if (Said '/trap,hasp,chain')
							(cond 
								(local12 (HighPrint 67 8))
								(local15
									(if (ego inRect: 55 111 120 120)
										(ego setScript: getTrap)
									else
										(HighPrint 67 9)
									)
								)
								(else (HighPrint 67 10))
							)
						)
					)
					((Said 'ask>')
						(if (Said '/help,trap')
							(if (not local16)
								(HighPrint 67 11)
								(= local16 1)
							else
								(HighPrint 67 12)
							)
						else
							(HighPrint 67 12)
							(pEvent claimed: 1)
						)
					)
					(
						(or
							(Said 'free,free/fox,animal')
							(Said 'open,get/trap')
						)
						(if local12
							(if
								(and
									(< (ego y?) 112)
									(< 60 (ego x?))
									(< (ego x?) 112)
								)
								(HighPrint 67 13)
							else
								(AddToScore POINTS_FREEFOX 10)
								(ego setScript: foxFreed)
							)
						else
							(HighPrint 67 7)
						)
					)
					((Said 'fight/fox,animal')
						(if local12
							(fox setScript: foxWillNotFight)
						else
							(HighPrint 67 14)
						)
					)
					((Said 'kill,attack,fight/fox,animal')
						(if local12
							(cond 
								((not (ego has: invBroadsword)) (HighPrint 67 15))
								((ego inRect: 55 111 120 120) (fox setScript: foxDies))
								(else (PrintNotCloseEnough))
							)
						else
							(HighPrint 67 14)
						)
					)
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0)
									(if local12
										(HighPrint 67 16)
									else
										(HighPrint 67 17)
									)
								)
							)
							(skDAZZLE
								(if local12
									(HighPrint 67 18)
								else
									(HighPrint 67 19)
								)
							)
							(skFLAMEDART
								(if (CastSpell temp0)
									(if local12
										(if local17
											(dart init: setScript: flameDartFox)
										else
											(HighPrint 67 20)
											(= local17 1)
										)
									else
										(HighPrint 67 19)
									)
								)
							)
							(skCALM
								(if local12
									(HighPrint 67 21)
								else
									(HighPrint 67 19)
								)
							)
							(skOPEN
								(if local12
									(if (TestSkill skOPEN 25)
										(= local13 1)
										(AddToScore POINTS_FREEFOX 10)
									else
										(= local14 1)
									)
									(ego setScript: foxFreed)
								else
									(HighPrint 67 19)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance foxCallForHelp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(LockEgo)
				(fox setCycle: EndLoop self)
			)
			(2
				(DisposeDialog)
				(PrintTimedMessage 6 67 22)
				(fox loop: 1 cel: 0 setCycle: Forward)
				(= seconds 2)
			)
			(3
				(fox setCycle: EndLoop)
				(UnlockEgo)
				(= seconds 8)
			)
			(4
				(fox loop: 1 cel: 0 setCycle: Forward)
				(DisposeDialog)
				(PrintTimedMessage 6 67 23)
				(= seconds 2)
			)
			(5 (fox setCycle: EndLoop self))
			(6
				(fox setScript: thrashAndWait)
			)
		)
	)
)

(instance foxWillNotFight of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DisposeDialog)
				(PrintTimedMessage 7 67 24)
				(fox loop: 1 cel: 0 setCycle: Forward)
				(= seconds 5)
			)
			(1
				(fox setCycle: EndLoop)
				(= cycles 5)
			)
			(2 (HighPrint 67 25))
		)
	)
)

(instance foxExplains of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(DisposeDialog)
				(PrintTimedMessage 9 67 11)
				(fox loop: 1 cel: 0 setCycle: Forward)
				(= seconds 3)
			)
			(1
				(fox setCycle: EndLoop)
				(= cycles 5)
			)
			(2
				(UnlockEgo)
				(client setScript: thrashAndWait)
			)
		)
	)
)

(instance distantFoxDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local15 1)
				(= local12 0)
				(fox loop: 2 cel: 0 cycleSpeed: 2 setCycle: EndLoop)
				(= seconds 7)
			)
			(1
				(AddToScore POINTS_KILLFOX -10)
				(= global272 0)
				(UnlockEgo)
				(HighPrint 67 26)
				;That was strange, no sooner did you kill the fox than it vanishes.
				(client dispose:)
			)
		)
	)
)

(instance foxDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local15 1)
				(= local12 0)
				(if (ego inRect: 41 109 111 138)
					(self cue:)
				else
					(ego
						ignoreActors:
						illegalBits: 0
						setMotion: MoveTo 120 130 self
					)
				)
			)
			(1
				(ego
					ignoreActors:
					setMotion: MoveTo (+ (fox x?) 20) (+ (fox y?) 2) self
				)
			)
			(2
				(ego view: 518 setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(3
				(ego setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(4 (ego setCycle: BegLoop self))
			(5
				(StopEgo)
				(fox loop: 2 cel: 0 cycleSpeed: 2 setCycle: EndLoop)
				(= seconds 7)
			)
			(6
				(AddToScore POINTS_KILLFOX -10)
				(UnlockEgo)
				(= global272 0)
				(HighPrint 67 26)
				;That was strange, no sooner did you kill the fox than it vanishes.
				(client dispose:)
			)
		)
	)
)

(instance foxFreed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (or local13 local14)
					(AnimateOpenSpell rm67 self)
				else
					(self cue:)
				)
			)
			(1
				(fox setScript: thrashAndWait)
				(ego ignoreActors: illegalBits: 0)
				(if (ego inRect: 41 109 111 138)
					(self cue:)
				else
					(ego setMotion: MoveTo 112 130 self)
				)
			)
			(2
				(ego
					setMotion: MoveTo (- (fox x?) 29) (+ (fox y?) 3) self
				)
			)
			(3
				(ego view: 510 loop: 0 cel: 0 setCycle: EndLoop self)
			)
			(4
				(cond 
					(local14 (HighPrint 67 27))
					(local13 (HighPrint 67 28))
					(else (HighPrint 67 29))
				)
				(self cue:)
			)
			(5 (ego setCycle: BegLoop self))
			(6
				(if local14
					(= local14 0)
					(StopEgo)
					(UnlockEgo)
					(fox setScript: foxExplains)
				else
					(= local15 1)
					(= local12 0)
					(= cycles 8)
				)
			)
			(7
				(fox setScript: 0 setCycle: Forward)
				(= seconds 2)
			)
			(8
				(PrintWarning 67 30)
				(self cue:)
			)
			(9
				(PrintWarning 67 31)
				(self cue:)
			)
			(10
				(fox
					setLoop: 3
					setCel: 0
					cycleSpeed: 1
					setStep: 6 6
					moveSpeed: 1
					setCycle: CycleTo 4 1 self
				)
			)
			(11
				(trap init: stopUpd:)
				(fox
					setMotion: MoveTo (+ (fox x?) 18) (+ (fox y?) 0)
					setCycle: EndLoop self
				)
			)
			(12
				(fox
					setLoop: 4
					setCel: 0
					cycleSpeed: 0
					setStep: 6 6
					moveSpeed: 0
					setCycle: Forward
					setMotion: MoveTo (+ (fox x?) 250) (+ (fox y?) 5)
				)
				(ego view: 68 loop: 0 cel: 0 setCycle: EndLoop)
				(= cycles 35)
			)
			(13
				(StopEgo)
				(UnlockEgo)
				(fox dispose:)
			)
		)
	)
)

(instance flameDartFox of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local15 1)
				(= local12 0)
				(fox setScript: 0)
				(ego
					view: 522
					setLoop: (if (< (ego x?) (fox x?)) 0 else 1)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(ego setCycle: EndLoop)
				(dart
					setLoop: 2
					setStep: 18 12
					setPri: 12
					ignoreActors: 1
					posn: (ego x?) (ego y?)
					show:
					setCycle: Forward
					startUpd:
				)
				(dart setMotion: MoveTo (+ (fox x?) 3) (fox y?) self)
			)
			(2
				(dart setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(3
				(fox loop: 2 cel: 0 cycleSpeed: 2 setCycle: EndLoop self)
			)
			(4
				(UnlockEgo)
				(StopEgo)
				(HighPrint 67 26)
				(= seconds 2)
			)
		)
	)
)

(instance getTrap of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego ignoreActors: illegalBits: 0)
				(if (ego inRect: 41 109 111 138)
					(self cue:)
				else
					(ego setMotion: MoveTo 112 130 self)
				)
			)
			(1
				(ego setMotion: MoveTo 58 113 self)
			)
			(2
				(ego view: 510 loop: 0 cel: 0 setCycle: EndLoop self)
			)
			(3
				(HighPrint 67 32)
				(self cue:)
			)
			(4 (= cycles 8))
			(5 (ego setCycle: BegLoop self))
			(6 (StopEgo) (UnlockEgo))
		)
	)
)

(instance thrashAndWait of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fox setLoop: 0 setCycle: EndLoop self)
			)
			(1
				(fox cel: 0)
				(= seconds (Random 3 8))
			)
			(2 (self changeState: 0))
		)
	)
)

(instance peekABooScript1 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 12 30)))
			(1
				(while (== (= local10 (Random 0 4)) local11)
				)
				(self cue:)
			)
			(2
				(client
					x: [local0 local10]
					y: [local0 (+ local10 5)]
					setCycle: EndLoop self
				)
			)
			(3 (self changeState: 0))
		)
	)
)

(instance peekABooScript2 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 12 30)))
			(1
				(while (== (= local10 (Random 0 4)) local11)
				)
				(self cue:)
			)
			(2
				(client
					x: [local0 local11]
					y: [local0 (+ local11 5)]
					setCycle: EndLoop self
				)
			)
			(3 (self changeState: 0))
		)
	)
)

(instance eyes1 of Prop
	(properties
		y 67
		x 205
		view 240
		cycleSpeed 1
	)
)

(instance eyes2 of Prop
	(properties
		y 74
		x 180
		view 240
		loop 1
		cycleSpeed 1
	)
)

(instance southBush of View
	(properties
		y 207
		x 162
		view 700
		loop 2
		cel 1
	)
)

(instance fox of TargActor
	(properties
		y 110
		x 90
		view 67
		cycleSpeed 3
		targDeltaY 10
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'pat/fox') (HighPrint 67 33))
					((Said 'throw/dagger,dagger') (AnimateThrowingDagger self))
					((Said 'throw/boulder') (AnimateThrowingRock self))
					((Said 'look,ask/feet') (HighPrint 67 34))
				)
			)
		)
	)
	
	(method (getHurt)
		(self setScript: distantFoxDies)
	)
)

(instance dart of Actor
	(properties
		y 500
		x 1000
		z 12
		view 522
		illegalBits $0000
	)
)

(instance trap of View
	(properties
		y 110
		x 92
		view 67
		loop 2
		cel 14
		priority 7
	)
)
