;;; Sierra Script 1.0 - (do not remove this comment)
(script# 210)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateCalm)
(use AnimateDazzle)
(use TargActor)
(use Chase)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use System)

(public
	Encounter 0
	smallMonster 1
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	theSmallMonster
	local7
	local8
	local9
	local10
	local11
	[local12 12] = [500 40 40 40 40 50 30 35 40 50 30 40]
	[theGMonsterHealth 12] = [10000 133 186 53 86 113 60 140 93 186 60 100]
	[local36 12] = ['/aardvark' '/bear' '/bull,bull' '/saurus' '/mantray' '/cheetaur' '/goblin' '/troll' '/ogre,giant' '/dragon,(rex[<saurus])' '/bandit,man' '/leader,female']
	local48
)
(procedure (localproc_000e param1 &tmp temp0)
	(return
		(if (and (<= 420 param1) (<= param1 470))
			(return (+ 1 (/ (- param1 420) 5)))
		else
			(return 0)
		)
	)
)

(procedure (localproc_0035)
	(cond 
		((> gGEgoObjX 310) (= local3 2))
		((< gGEgoObjX 10) (= local3 4))
		((< gGEgoObjY 100) (= local3 1))
		((> gGEgoObjY 180) (= local3 3))
	)
)

(procedure (localproc_0071 param1)
	(Bclear 351)
	(ChangeEgoWalk MOVE_WALK FALSE)
	(= local9 1)
	(= local10 1)
	(if param1 ((= theSmallMonster smallMonster) init:))
	(= local7 (+ global332 1))
	(UseSkill
		4
		(/ [theGMonsterHealth (localproc_000e global332)] 12)
	)
	(UnlockEgo)
	(StopEgo)
	(if param1
		(ego posn: 160 160)
		(theSmallMonster posn: 115 150)
	)
	(ego loop: 1 illegalBits: (curRoom illBits?) init:)
	(theSmallMonster
		view: local7
		setLoop: 0
		cel: 0
		ignoreActors: 0
		setMotion: 0
		cycleSpeed: 1
	)
	(if (!= global332 445) (theSmallMonster setCycle: EndLoop))
)

(procedure (localproc_0124 param1)
	(param1
		illegalBits: 0
		setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
	)
	(= local48 1)
	(param1 setScript: 0)
)

(procedure (localproc_0bd0 param1 &tmp temp0 temp1)
	(if (and argc param1)
		(= temp1 param1)
	else
		(cond 
			((< [skills skEXPERIENCE] 1000) (= temp0 (Random 0 3)))
			((< [skills skEXPERIENCE] 2000) (= temp0 (Random 0 6)))
			(else (= temp0 (Random 2 6)))
		)
		(if isNightTime (= temp0 (+ temp0 2)))
		(= temp1
			(switch temp0
				(0 445)
				(1 430)
				(2 445)
				(3 465)
				(4 435)
				(5 440)
				(6 460)
				(else  450)
			)
		)
	)
	(if (OneOf curRoomNum 85 86 92)
		(if (or (<= temp0 4) (not isNightTime))
			(= temp1 465)
		else
			(= temp1 450)
		)
	)
	(return temp1)
)

(procedure (localproc_0cba param1 param2 &tmp curRoomAmbushX curRoomAmbushY temp2 temp3 temp4)
	(= temp2 (& (curRoom entrances?) $000a))
	(= temp4 (& (curRoom entrances?) $0008))
	(= temp3 (& (curRoom entrances?) $0002))
	(param2 view: param1)
	(if (!= param1 435)
		(param2 xStep: 6 yStep: 4 cel: 0)
		(switch param1
			(430
				(param2 xStep: 5 yStep: 3 setCycle: Forward)
			)
			(450
				(param2 xStep: 5 yStep: 3 setCycle: Walk)
			)
			(440
				(param2 xStep: 6 yStep: 3 setCycle: Forward)
			)
			(445
				(param2 xStep: 4 yStep: 2 setCycle: Walk)
			)
			(465
				(param2 xStep: 3 yStep: 2 setCycle: Walk)
			)
			(460
				(param2 xStep: 8 yStep: 5 setCycle: Forward)
			)
		)
	)
	(cond 
		(local4
			(if (== global332 435)
				(theSmallMonster
					setCycle: Walk
					ignoreHorizon:
					z: 25
					xStep: (Random 4 8)
					yStep: (Random 3 5)
				)
			)
			(= local48 1)
			(switch local3
				(1
					(ego setMotion: MoveTo gGEgoObjX (- gGEgoObjY 2))
					(theSmallMonster
						posn:
							(+ (ego x?) (Random 20 40))
							(+
								(ego y?)
								[local12 (localproc_000e global332)]
								(Random 20 30)
							)
						setCel: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
				(3
					(ego setMotion: MoveTo gGEgoObjX (+ gGEgoObjY 2))
					(theSmallMonster
						posn:
							(- (ego x?) (Random 30 50))
							(-
								(ego y?)
								(+ [local12 (localproc_000e global332)] (Random 20 30))
							)
						setCel: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
				(2
					(ego setMotion: MoveTo 320 gGEgoObjY)
					(theSmallMonster
						posn:
							(-
								(ego x?)
								(+ [local12 (localproc_000e global332)] (Random 25 40))
							)
							(ego y?)
						setCel: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
				(4
					(ego setMotion: MoveTo 0 gGEgoObjY)
					(theSmallMonster
						posn:
							(+
								(ego x?)
								[local12 (localproc_000e global332)]
								(Random 25 40)
							)
							(ego y?)
						setCel: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
			)
			(User canControl: 1)
		)
		(local5
			(if (== global332 435)
				(theSmallMonster
					setCycle: Walk
					ignoreHorizon:
					z: 25
					xStep: (Random 4 8)
					yStep: (Random 3 5)
				)
			)
			(= local48 1)
			(switch local3
				(1
					(= local48 0)
					(ego setMotion: MoveTo gGEgoObjX 190)
					(if
						(or
							(== global332 445)
							(== global332 435)
							(== global332 450)
							(== global332 465)
						)
						(theSmallMonster setScript: northDelay)
					else
						(= global332 (= gMonsterHealth 0))
						(theSmallMonster dispose:)
					)
				)
				(3
					(ego setMotion: MoveTo gGEgoObjX 0)
					(if
						(or
							(== global332 445)
							(== global332 435)
							(== global332 450)
							(== global332 465)
						)
						(theSmallMonster
							ignoreActors:
							posn:
								gGEgoObjX
								(if (== global332 435) 235 else (- gGEgoObjY monsterDistY))
							setCel: -1
							setLoop: -1
							setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
						)
					else
						(= global332 (= gMonsterHealth 0))
						(theSmallMonster dispose:)
						(= local48 0)
					)
				)
				(2
					(ego setMotion: MoveTo 0 gGEgoObjY)
					(theSmallMonster
						posn: (- gGEgoObjX monsterDistX) (+ gGEgoObjY monsterDistY)
						loop: 1
						setCel: -1
						setLoop: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
				(4
					(ego setMotion: MoveTo 320 gGEgoObjY)
					(theSmallMonster
						posn: (- gGEgoObjX monsterDistX) (+ gGEgoObjY monsterDistY)
						loop: 0
						setCel: -1
						setLoop: -1
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
				)
			)
		)
		((== param1 435) (theSmallMonster setScript: (ScriptID 436 2)))
		((== temp2 10)
			(switch (= temp2 (if (< (Random 0 1000) 500) 8 else 2))
				(2 (param2 setScript: inEast))
				(8 (param2 setScript: inWest))
			)
		)
		(temp3 (param2 setScript: inEast))
		(temp4 (param2 setScript: inWest))
		(else
			(= curRoomAmbushX (curRoom ambushX?))
			(= curRoomAmbushY (curRoom ambushY?))
			(param2
				posn: curRoomAmbushX curRoomAmbushY
				ignoreActors:
				setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
			)
		)
	)
)

(class EncRoom of Room
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 0
		style $ffff
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY -30000
		encChance 0
		entrances 15
		ambushX 160
		ambushY 100
		illBits cWHITE
	)
)

(instance smallMonster of TargActor
	(properties
		illegalBits $0000
		targDeltaY -20
	)
	
	(method (getHurt param1)
		(= gMonsterHealth (- gMonsterHealth param1))
	)
)

(instance Encounter of Region
	(properties)
	
	(method (init &tmp curRoomEncChance)
		(Load rsSCRIPT CHASE)
		(super init: &rest)
		(= local5 0)
		(= local4 0)
		(= theSmallMonster 0)
		(localproc_0035)
		(cond 
			(
				(not
					(OneOf
						prevRoomNum
						420
						425
						430
						435
						440
						445
						455
						450
						460
						465
						470
					)
				)
				(if global332
					(if (and (== global332 450) (not isNightTime))
						(ego illegalBits: (curRoom illBits?) init:)
						(ChangeEgoWalk MOVE_RUN FALSE)
						(= global332 (= gMonsterHealth 0))
						(HighPrint 210 0)
					else
						(= local5 1)
						(ego illegalBits: (curRoom illBits?) init:)
						(= local8 (= local9 0))
						(localproc_0bd0 global332)
					)
				else
					(= curRoomEncChance (curRoom encChance?))
					(if isNightTime
						(= curRoomEncChance (* curRoomEncChance 2))
					)
					(if (Btest 87)
						(= curRoomEncChance (* curRoomEncChance 2))
					)
					(if (<= (RollDice) curRoomEncChance)
						(= global332 (localproc_0bd0 0))
						(= gMonsterHealth
							[theGMonsterHealth (localproc_000e global332)]
						)
						(= local8 (= local9 0))
					)
					(ego illegalBits: (curRoom illBits?))
				)
			)
			((<= gMonsterHealth 0) (localproc_0071 1))
			(else
				(= local8 (= local9 0))
				(ChangeEgoWalk MOVE_RUN FALSE)
				(= local4 1)
				(StopEgo)
				(ego illegalBits: (curRoom illBits?) posn: 160 140 init:)
				(localproc_0bd0 global332)
			)
		)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(not local8)
					(not local9)
					global332
					(or local5 (== (ego onControl: origin) cLCYAN))
				)
				(= local8 1)
				((= theSmallMonster smallMonster) posn: 0 1000 init:)
				(localproc_0cba global332 theSmallMonster)
			)
			((and (== global332 435) (Btest 351)) (localproc_0071 0))
			(
				(and
					local8
					global332
					(not local10)
					(<= gMonsterHealth 0)
					(not (Btest 351))
				)
				(localproc_0071 0)
			)
		)
		(super doit: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0 theTheSmallMonster)
		(if (pEvent claimed?) (return))
		(switch (pEvent type?)
			(evSAID
				(if (Said 'nap,rest')
					(if (and local8 (> gMonsterHealth 0))
						(HighPrint 210 3)
					else
						(pEvent claimed: 0)
					)
				)
				(cond 
					(local9
						(cond 
							((super handleEvent: pEvent))
							((Said 'kill,fight,beat,beat') (PrintAlreadyDoneThat))
							((Said 'eat') (HighPrint 210 4))
							((Said 'look>')
								(if
									(or
										(Said '/monster,creature')
										(Said [local36 (localproc_000e global332)])
									)
									(HighPrint 210 5)
									(HighPrint 210 6)
								else
									(pEvent claimed: 0)
								)
							)
							((Said 'odor>')
								(if
									(or
										(Said '/monster,creature')
										(Said [local36 (localproc_000e global332)])
									)
									(HighPrint 210 7)
								else
									(HighPrint 210 8)
									(pEvent claimed: 1)
								)
							)
							((Said 'get>')
								(cond 
									((Said '/claw[<cheetaur]')
										(if (== global332 440)
											(if local0
												(PrintAlreadyDoneThat)
											else
												(HighPrint 210 9)
												(= local0 1)
												(ego get: invCheetaurClaw (Random 4 10))
											)
										else
											(HighPrint 210 10)
										)
									)
									((Said '/beard[<troll]')
										(cond 
											(local1 (HighPrint 210 11))
											((== global332 450) (HighPrint 210 12) (= local1 1) (ego get: invTrollBeard))
											(else (HighPrint 210 13))
										)
									)
								)
							)
							((Said 'search>')
								(if
									(or
										(Said '/monster,creature,body,enemy')
										(Said [local36 (localproc_000e global332)])
									)
									(if local2
										(PrintAlreadyDoneThat)
									else
										(= local2 1)
										(ego setScript: (ScriptID 197 0) 0 theSmallMonster)
									)
								else
									(HighPrint 210 14)
									(pEvent claimed: 1)
								)
							)
						)
					)
					((super handleEvent: pEvent))
					((Said 'look>')
						(if
							(or
								(Said '/monster,creature')
								(Said [local36 (localproc_000e global332)])
							)
							(switch global332
								(445 (HighPrint 210 15))
								(465 (HighPrint 210 16))
								(430 (HighPrint 210 17))
								(460 (HighPrint 210 18))
								(440 (HighPrint 210 19))
								(455 (HighPrint 210 20))
								(450 (HighPrint 210 21))
								(435 (HighPrint 210 22))
								(else  (HighPrint 210 23))
							)
						)
					)
					((Said 'fight')
						(if (and local8 global332)
							(curRoom newRoom: global332)
						else
							(HighPrint 210 24)
						)
					)
					((Said 'cast>')
						(if
							(not
								(OneOf
									curRoomNum
									420
									425
									430
									435
									440
									445
									455
									450
									460
									465
									470
								)
							)
							(= temp0 (SaidCast pEvent))
							(if (CastSpell temp0)
								(switch temp0
									(skCALM
										(if local48
											(if (AnimateCalm)
												(if (== global332 435)
													(HighPrint 210 25)
												else
													(theSmallMonster setScript: spellDelay 0 22)
												)
											)
										else
											(HighPrint 210 26)
										)
									)
									(skOPEN (HighPrint 210 27))
									(skDETECTMAGIC
										(if local8
											(HighPrint 210 28)
										else
											(pEvent claimed: 0)
										)
									)
									(skDAZZLE
										(if local48
											(if (AnimateDazzle)
												(if (== global332 435)
													(HighPrint 210 25)
												else
													(theSmallMonster setScript: spellDelay 0 20)
												)
											)
										else
											(HighPrint 210 26)
										)
									)
									(skZAP
										(= zapMeleeBonus (+ 1 (/ [skills skZAP] 10)))
										(if (or (ego has: invDagger) (ego has: invBroadsword))
											(HighPrint 210 29)
										else
											(HighPrint 210 30)
										)
									)
									(skFLAMEDART
										(= theTheSmallMonster 0)
										(if local8
											(FaceObject ego theSmallMonster)
											(= theTheSmallMonster theSmallMonster)
										)
										(AnimateThrowingFlameDart theTheSmallMonster)
									)
									(skFETCH
										(if local8
											(HighPrint 210 31)
										else
											(HighPrint 210 32)
										)
									)
									(else  (pEvent claimed: 0))
								)
							)
						)
					)
					((Said 'throw/dagger,dagger')
						(= theTheSmallMonster 0)
						(if local8
							(FaceObject ego theSmallMonster)
							(= theTheSmallMonster theSmallMonster)
						)
						(AnimateThrowingDagger theTheSmallMonster)
					)
					((Said 'throw/boulder')
						(= theTheSmallMonster 0)
						(if local8
							(FaceObject ego theSmallMonster)
							(= theTheSmallMonster theSmallMonster)
						)
						(AnimateThrowingRock theTheSmallMonster)
					)
				)
			)
		)
	)
	
	(method (cue &tmp temp0)
		(= temp0 1)
		(if (and global332 (> gMonsterHealth 0))
			(ChangeEgoWalk MOVE_WALK FALSE)
			(if (and temp0 (or local4 local5))
				(= temp0 0)
				(HighPrint 210 1)
			else
				(HighPrint 210 2)
			)
			(curRoom newRoom: global332)
		)
	)
	
	(method (newRoom newRoomNumber)
		(LockEgo)
		(if
			(or
				local9
				(> monsterDistX 180)
				(> monsterDistY 80)
				(and
					(not
						(OneOf
							newRoomNumber
							420
							425
							430
							435
							440
							445
							455
							450
							460
							465
							470
						)
					)
					(not
						(OneOf
							newRoomNumber
							11
							17
							18
							19
							23
							24
							25
							26
							27
							33
							34
							35
							36
							42
							43
							44
							51
							56
							57
							61
							62
							69
							71
							74
							75
							79
							80
							81
							85
							86
							92
						)
					)
				)
			)
			(= global332 (= gMonsterHealth 0))
			(= brigandHead 0)
		)
		(if local8
			(= monsterDistX (- (ego x?) (theSmallMonster x?)))
			(= monsterDistY (- (ego y?) (theSmallMonster y?)))
		)
		(super newRoom: newRoomNumber &rest)
	)
)

(instance inWest of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					setLoop: 0
					ignoreActors:
					posn: -100 140
					setMotion: MoveTo 0 140 self
				)
			)
			(1 (localproc_0124 client))
		)
	)
)

(instance inEast of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					setLoop: 1
					ignoreActors:
					posn: 400 140
					setMotion: MoveTo 319 140 self
				)
			)
			(1 (localproc_0124 client))
		)
	)
)

(instance northDelay of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 6))
			(1
				(theSmallMonster
					ignoreHorizon:
					ignoreActors:
					posn:
						gGEgoObjX
						(cond 
							((> (curRoom horizon?) (- gGEgoObjY monsterDistY))
								(- (curRoom horizon?) 20)
							)
							((== global332 435)
								-10
							)
							(else 
								(- gGEgoObjY monsterDistY)
							)
						)
					setCel: -1
					setLoop: -1
					setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
				)
				(= local48 1)
				(client setScript: 0)
			)
		)
	)
)

(instance spellDelay of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local48 0)
				(theSmallMonster setCycle: 0 setMotion: 0 ignoreActors: 0)
				(if (== register 22)
					(= seconds (+ 10 (/ [skills skCALM] 10)))
				else
					(= seconds (+ 5 (/ [skills skDAZZLE] 10)))
				)
			)
			(1
				(if (not local10)
					(if
						(or
							(== global332 445)
							(== global332 450)
							(== global332 465)
							(and
								(< -15 (- (ego x?) (theSmallMonster x?)))
								(< (- (ego x?) (theSmallMonster x?)) 15)
							)
						)
						(theSmallMonster setCycle: Walk)
					else
						(theSmallMonster setCycle: Forward)
					)
					(theSmallMonster
						ignoreActors:
						setMotion: Chase ego [local12 (localproc_000e global332)] Encounter
					)
					(= local48 1)
				)
				(self dispose:)
			)
		)
	)
)
