;;; Sierra Script 1.0 - (do not remove this comment)
(script# 292)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Jump)
(use Motion)
(use System)

(public
	getRock 0
	youMissed 1
	heCaughtIt 2
	climbDown 3
)

(instance getRock of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 292)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					setMotion:
						MoveTo
						(ego x?)
						(if (> (ego y?) 175)
							(- (ego y?) 5)
						else
							(+ (ego y?) 5)
						)
				)
				(= cycles 5)
			)
			(1
				(ego
					view: 510
					setLoop: (Random 0 1)
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(2
				(HighPrint 292 0)
				(ego setCycle: BegLoop self)
			)
			(3
				(ego get: invSmallRock 10)
				(UnlockEgo)
				(ego loop: 3 setScript: 0)
				(StopEgo)
			)
		)
	)
)

(instance youMissed of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 292)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 16 2)
					setStep: 30 20
					setMotion: MoveTo 0 (- ((ScriptID 16 2) y?) 100) self
				)
			)
			(1
				((ScriptID 16 2)
					setMotion: JumpTo (Random 130 160) (Random 145 160) self
				)
			)
			(2
				(UnlockEgo)
				((ScriptID 16 2) hide: setScript: 0)
			)
		)
	)
)

(instance climbDown of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 292)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (== global326 1)
					(self changeState: 3)
				else
					(self cue:)
				)
			)
			(1
				(if (== global326 4) ((ScriptID 16 1) dispose:))
				(= global326 0)
				(ego
					view: 0
					setCycle: Walk
					cycleSpeed: 1
					moveSpeed: 1
					setPri: 4
					setLoop: 0
					setMotion: MoveTo 157 90 self
				)
			)
			(2
				(ego setLoop: 2 setPri: -1 setMotion: MoveTo 148 96 self)
			)
			(3
				(ego view: 517 setLoop: 1 cel: 6 posn: 144 105)
				(= cycles 5)
			)
			(4
				(ego cycleSpeed: 2 moveSpeed: 0 setCycle: BegLoop self)
			)
			(5 (= cycles 2))
			(6
				(StopEgo)
				(ego posn: 139 137 loop: 3 setScript: 0)
				(UnlockEgo)
			)
		)
	)
)

(instance heCaughtIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCel: 1)
				((ScriptID 16 1) posn: 144 49)
				(= cycles 1)
			)
			(1
				((ScriptID 16 1) hide:)
				(ego setCycle: CycleTo 3 1 self)
			)
			(2
				(ego setCel: 4)
				((ScriptID 16 1) posn: 142 56 show:)
				(= seconds 4)
			)
			(3
				(PrintTimedMessage 4 292 1)
				(= global327 2)
				(= global328 2)
				(= seconds 4)
			)
			(4
				(AddToScore POINTS_GETSEED 8)
				(ego get: invSpireaSeed)
				(= global326 4)
				(Bset 136)
				(ego setScript: climbDown)
				(Bset 192)
			)
		)
	)
)
