;;; Sierra Script 1.0 - (do not remove this comment)
(script# 130)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Actor)
(use System)

(public
	throwDagger 0
)

(local
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
)
(instance dagger of Actor
	(properties
		z 25
		view 524
		illegalBits $0000
	)
)

(instance throwDagger of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 130)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= roomDaggersDropped curRoomNum)
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(TestSkill skTHROWING 0 5)
				(TestSkill skWEAPONUSE 0 5)
				(TestSkill skAGILITY 0 5)
				(TestSkill skSTRENGTH 0 5)
				(ego
					view: 524
					setLoop: (if (> (ego x?) ((ScriptID 15 1) x?)) 1 else 0)
					cel: 0
					setCycle: CycleTo 9 1 self
				)
			)
			(1
				(ego setCycle: EndLoop)
				(dagger
					posn: (ego x?) (ego y?)
					ignoreActors:
					illegalBits: 0
					init:
					setLoop: 2
					setCel: 0
					setStep: 15 10
				)
				(if
					(TestSkill
						skTHROWING
						0
						(- 50 (/ (ego distanceTo: (ScriptID 15 1)) 5))
					)
					(Bset 346)
				)
				(if (Btest 346)
					(dagger
						setMotion: MoveTo ((ScriptID 15 1) x?) ((ScriptID 15 1) y?) self
					)
				else
					(dagger
						setMotion:
							MoveTo
							(if (< (ego x?) ((ScriptID 15 1) x?))
								(+ ((ScriptID 15 1) x?) 50)
							else
								(- ((ScriptID 15 1) x?) 50)
							)
							(- ((ScriptID 15 1) y?) 20)
							self
					)
				)
			)
			(2
				(ego drop: invDagger 1)
				(dagger hide:)
				(= cycles 2)
			)
			(3
				(dagger dispose: delete:)
				(StopEgo)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(ego
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(if (< koboldStatus 2) (Bset 297) (Bset 147))
				(if
					(and
						(Btest 346)
						(not ((ScriptID 15 1) script?))
						(not (Btest 297))
					)
					(Bset 282)
				)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)
