;;; Sierra Script 1.0 - (do not remove this comment)
(script# 100)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingFlameDart 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
	newSound
)
(procedure (AnimateThrowingFlameDart param1 &tmp temp0 temp1)
	(LoadMany 132 (GetSongNumber 33) (GetSongNumber 45))
	(Load rsVIEW 522)
	(if param1
		(FaceObject ego param1)
		(= local3 (+ (param1 x?) (param1 targDeltaX?)))
		(= local4 (+ (param1 y?) (param1 targDeltaY?)))
		(= temp0 (- local3 (ego x?)))
		(= temp1 (- local4 (- (ego y?) 20)))
		(while
			(and
				(< 0 local3)
				(< local3 319)
				(< 0 local4)
				(< local4 189)
			)
			(= local3 (+ local3 temp0))
			(= local4 (+ local4 temp1))
		)
		(if
			(not
				(TestSkill skMAGIC 0 (- 50 (/ (ego distanceTo: param1) 5)))
			)
			(if (< local4 0)
				(= local4 (+ local4 (Random 30 100)))
			else
				(= local4 (- local4 (Random 30 100)))
			)
		)
	)
	(if (not param1)
		(UseSkill skTHROWING (/ [skills skAGILITY] 10))
		(= local3 (if (== (ego loop?) 1) -10 else 330))
		(= local4 (Random 20 80))
	)
	((= newSound (Sound new:))
		number: (GetSongNumber 33)
		priority: 15
		init:
	)
	(= local0 param1)
	((= newAct (Actor new:))
		view: 522
		setLoop: 2
		setCel: 0
		illegalBits: 0
		ignoreActors:
		ignoreHorizon:
		z: 20
		posn: (ego x?) (- (ego y?) 6)
		setStep: 12 8
		init:
		hide:
		setScript: dartScript 0 param1
	)
	(return 1)
)

(instance dartScript of Script
	(properties)
	
	(method (doit)
		(asm
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_01eb
			pushi    #x
			pushi    0
			send     4
			jmp      code_01ed
code_01eb:
			lal      local3
code_01ed:
			sub     
			sal      local1
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_020f
			pushi    #y
			pushi    0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			jmp      code_0211
code_020f:
			lal      local4
code_0211:
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_029a
			pushi    65511
			lal      local1
			lt?     
			bnt      code_023a
			pprev   
			ldi      25
			lt?     
			bnt      code_023a
			pushi    65511
			lal      local2
			lt?     
			bnt      code_023a
			pprev   
			ldi      25
			lt?     
			bt       code_0264
code_023a:
			pushi    0
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_024b
			pprev   
			ldi      319
			lt?     
code_024b:
			not     
			bt       code_0264
			pushi    0
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_0260
			pprev   
			ldi      189
			lt?     
code_0260:
			not     
			bnt      code_029a
code_0264:
			pToa     register
			bnt      code_028e
			pushi    65511
			lal      local1
			lt?     
			bnt      code_028e
			pprev   
			ldi      25
			lt?     
			bnt      code_028e
			pushi    65511
			lal      local2
			lt?     
			bnt      code_028e
			pprev   
			ldi      25
			lt?     
			bnt      code_028e
			ldi      1
			sal      local5
			jmp      code_0292
code_028e:
			ldi      0
			sal      local5
code_0292:
			pushi    #cue
			pushi    0
			self     4
			jmp      code_02a0
code_029a:
			pushi    #doit
			pushi    0
			super    Script,  4
code_02a0:
			ret     
		)
	)
	
	(method (dispose)
		(newSound dispose:)
		(UnlockEgo)
		(if local5 (register getHurt: (/ [skills skFLAMEDART] 2)))
		(super dispose:)
		(DisposeScript 100)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(ego
					view: 522
					setLoop: (if (or (== (ego loop?) 1) (== (ego loop?) 3))
						1
					else
						0
					)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(ego setCycle: EndLoop)
				(newSound play:)
				(client
					x: (if (== (ego loop?) 1)
						(- (ego x?) 19)
					else
						(+ (ego x?) 19)
					)
					show:
					setCycle: Forward
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(if (and register local5)
					(newSound stop: number: (GetSongNumber 45) play:)
					(client setLoop: 3 cel: 0 setMotion: 0 setCycle: EndLoop self)
				else
					(client hide:)
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(client dispose:)
			)
		)
	)
)
