;;; Sierra Script 1.0 - (do not remove this comment)
(script# 102)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingRock 0
)

(local
	local0
	local1
	local2
	local3
	local4
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
	newSound
	local10
)
(procedure (AnimateThrowingRock param1 &tmp temp0 temp1)
	(return
		(if (not (ego has: invSmallRock))
			(HighPrint 102 0)
			(DisposeScript 102)
			(return 0)
		else
			(ego use: invSmallRock 1)
			(Load rsSOUND (GetSongNumber 58))
			(if param1
				(FaceObject ego param1)
				(= local3 (+ (param1 x?) (param1 targDeltaX?)))
				(= local4 (+ (param1 y?) (param1 targDeltaY?)))
				(= temp0 (- local3 (ego x?)))
				(= temp1 (- local4 (- (ego y?) 34)))
				(while
					(and
						(< 0 local3)
						(< local3 319)
						(< 0 local4)
						(< local4 189)
					)
					(= local3 (+ local3 temp0))
					(= local4 (+ local4 temp1))
				)
				(if
					(not
						(TestSkill skTHROWING 0 (- 50 (/ (ego distanceTo: param1) 5)))
					)
					(if (< local4 0)
						(= local4 (+ local4 (Random 30 100)))
					else
						(= local4 (- local4 (Random 30 100)))
					)
				)
			)
			(if (not param1)
				(UseSkill skTHROWING (/ [skills skAGILITY] 10))
				(= local3 (if (& (ego loop?) $0001) -10 else 330))
				(= local4 (Random 20 80))
			)
			(= local0 param1)
			((= newAct (Actor new:))
				view: 510
				setLoop: 4
				setCel: 0
				illegalBits: 0
				ignoreActors:
				ignoreHorizon:
				z: 20
				posn: (- (ego x?) 10) (- (ego y?) 12)
				setStep: 20 8
				init:
				hide:
				setPri: 15
				setScript: rockScript 0 param1
			)
			(return 1)
		)
	)
)

(instance rockScript of Script
	(properties)
	
	(method (doit)
		(asm
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_01e9
			pushi    #x
			pushi    0
			send     4
			jmp      code_01eb
code_01e9:
			lal      local3
code_01eb:
			sub     
			sal      local1
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_020d
			pushi    #y
			pushi    0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			jmp      code_020f
code_020d:
			lal      local4
code_020f:
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_026a
			pushi    65521
			lal      local1
			lt?     
			bnt      code_0238
			pprev   
			ldi      15
			lt?     
			bnt      code_0238
			pushi    65521
			lal      local2
			lt?     
			bnt      code_0238
			pprev   
			ldi      15
			lt?     
			bt       code_0262
code_0238:
			pushi    0
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_0249
			pprev   
			ldi      319
			lt?     
code_0249:
			not     
			bt       code_0262
			pushi    0
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_025e
			pprev   
			ldi      189
			lt?     
code_025e:
			not     
			bnt      code_026a
code_0262:
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0270
code_026a:
			pushi    #doit
			pushi    0
			super    Script,  4
code_0270:
			ret     
		)
	)
	
	(method (dispose)
		(newSound dispose:)
		(UnlockEgo)
		(if local10 (register getHurt: 1))
		(super dispose:)
		(DisposeScript 102)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(ego
					view: 510
					cycleSpeed: 1
					setLoop: (if (& (ego loop?) $0001) 2 else 3)
					cel: 0
					setCycle: CycleTo 3 1 self
				)
				((= newSound (Sound new:))
					number: (GetSongNumber 58)
					priority: 15
					init:
				)
			)
			(1
				(ego setCycle: EndLoop)
				(client
					x: (if (== (ego loop?) 2)
						(- (ego x?) 10)
					else
						(+ (ego x?) 10)
					)
					show:
					setCycle: Forward
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(client hide:)
				(if
					(and
						register
						(< -15 local1)
						(< local1 15)
						(< -15 local2)
						(< local2 15)
					)
					(= local10 1)
					(newSound play: self)
				else
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(client dispose:)
			)
		)
	)
)
