;;; Sierra Script 1.0 - (do not remove this comment)
(script# 311)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Door)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm311 0
)

(local
	newProp
	newDoor
	newView
	newProp_2
	local4
	local5
	local6
	local7
	local8
	local9
	local10
	local11
)
(procedure (localproc_000c)
	(HighPrint 311 0)
)

(procedure (localproc_0015 &tmp temp0 [temp1 200])
	(= temp0 local10)
	(if (not (Btest 127)) (++ temp0))
	(if (ego inRect: 190 115 250 124)
		(if (< local10 0)
			(HighPrint 311 1)
			(= local10 0)
			(return)
		)
		(AddToScore POINTS_READLOGBOOK 4)
		(switch temp0
			(0
				(Format @temp1 311 2 @userName)
				(HighPrint @temp1)
			)
			(1
				(Format
					@temp1
					311
					3
					(if (Btest 127) {previous} else {last})
				)
				(HighPrint @temp1)
			)
			(else 
				(HighPrint 311 4)
				(= local10 2)
			)
		)
	else
		(localproc_000c)
	)
)

(procedure (localproc_00cc)
	(if (not (ego inRect: 190 115 250 124))
		(localproc_000c)
	)
	(ego inRect: 190 115 250 124)
)

(procedure (localproc_00fc)
	(if (ego inRect: 100 110 167 126)
		(AddToScore POINTS_READNOTICEBOARD 6)
		(curRoom newRoom: 318)
	else
		(localproc_000c)
	)
)

(procedure (localproc_012e)
	(HighPrint 311 5)
)

(procedure (localproc_0138)
	(HighPrint 311 6)
)

(procedure (localproc_0142)
	(HighPrint 311 7)
)

(procedure (localproc_014c)
	(HighPrint 311 8)
)

(procedure (localproc_0156)
	(HighPrint 311 9)
)

(procedure (localproc_0160)
	(HighPrint 311 10)
)

(procedure (localproc_016a)
	(HighPrint 311 11)
)

(procedure (localproc_0174)
	(HighPrint 311 12)
)

(procedure (localproc_017e)
	(HighPrint 311 13)
)

(procedure (localproc_0188)
	(HighPrint 311 14)
	(HighPrint 311 15)
)

(instance rm311 of Room
	(properties
		picture 311
		style $0002
	)
	
	(method (init)
		(Load rsVIEW 311)
		(Load rsVIEW 312)
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onDragon
				onCheetaur
				onTroll
				onGryphon
				onAntwerp
				onSaurus
				onMoose
				onGuildMaster
				onFireplace
				onLog
				onQuestBoard
		)
		(self setLocales: 801)
		(StatusLine enable:)
		(master init:)
		(StopEgo)
		(ego loop: 1 posn: 276 148 init:)
		(if (== prevRoomNum 318) (ego posn: 133 118))
		((= newProp (Prop new:))
			view: 311
			loop: 1
			posn: 11 160
			init:
			setCycle: Forward
			cycleSpeed: 1
			startUpd:
		)
		((= newDoor (Door new:))
			view: 311
			loop: 0
			posn: 315 158
			doorControl: cYELLOW
			entranceTo: 310
			init:
			ignoreActors:
			setPri: 11
		)
		((View new:)
			view: 311
			loop: 2
			cel: 0
			posn: 135 73
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 1
			posn: 209 92
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 2
			posn: 194 87
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 3
			posn: 244 67
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 4
			posn: 25 81
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 5
			posn: 204 66
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 6
			posn: 110 66
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 7
			posn: 163 70
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 8
			posn: 74 69
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 311
			loop: 2
			cel: 9
			posn: 302 83
			init:
			stopUpd:
			addToPic:
		)
		(if (not (Btest 91)) (localproc_0188))
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 91)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 3])
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'get') (HighPrint 311 16))
					((Said 'turn,preceding/page') (++ local10) (localproc_0015))
					((Said 'next[/page]') (-- local10) (localproc_0015))
					(
						(or
							(Said 'look<in/desk,drawer')
							(Said 'open/desk,drawer')
						)
						(if (localproc_00cc) (HighPrint 311 17))
					)
					((Said 'close/desk') (HighPrint 311 18))
					((Said 'look,read>')
						(cond 
							((Said '/page<first') (= local10 2) (localproc_0015))
							((Said '/page<last') (= local10 0) (localproc_0015))
							((Said '/page<next') (++ local10) (localproc_0015))
							((Said 'page<preceding') (-- local10) (localproc_0015))
							((Said '/registration,register,log,book,page') (localproc_0015))
							((Said '/desk') (if (localproc_00cc) (HighPrint 311 19)))
							((Said '/feather,pen,ink,bottle') (HighPrint 311 20))
							((Said '/message,quest,(board[<bulletin,quest])') (localproc_00fc))
							(
							(Said '[<at,around][/!*,room,building,hall,club]') (localproc_0188))
							((Said '/moose,(head<moose)') (localproc_0142))
							((Said '/saurus,(head<saurus)') (localproc_014c))
							((Said '/troll,(head<troll)') (localproc_0156))
							((Said '/griffin,(head<griffin)') (localproc_0160))
							((Said '/dragon,(head<dragon)') (localproc_016a))
							((Said '/cheetaur,(head<cheetaur)') (localproc_0174))
							((Said '/antwerp,(head<antwerp)') (localproc_017e))
							((Said '/monster,trophy,head') (HighPrint 311 21) (HighPrint 311 22))
							((Said '/desk') (HighPrint 311 23))
							(
							(Said '/abenteuer,master,man,adventurer,guildmaster') (localproc_012e))
							((Said '/fire,chimney') (localproc_0138))
						)
					)
					(
						(or
							(Said 'sign,register[/name,book,register,log]')
							(Said 'write,enter/name,quest[/book,register,log]')
						)
						(cond 
							((Btest 127) (HighPrint 311 24))
							((ego inRect: 190 115 250 124) (HighPrint 311 25) (AddToScore POINTS_SIGNLOGBOOK 1) (Bset 127))
							(else (PrintNotCloseEnough))
						)
					)
				)
			)
		)
	)
)

(instance master of Prop
	(properties
		view 312
	)
	
	(method (init)
		(super init:)
		(self
			posn: 76 137
			setPri: 12
			ignoreActors:
			startUpd:
			setScript: masterScript
		)
		((= newView (View new:))
			view: 312
			loop: 0
			cel: 0
			posn: 82 153
			init:
			stopUpd:
		)
		((= newProp_2 (Prop new:))
			view: 312
			loop: 3
			cel: 0
			posn: 72 130
			init:
			cycleSpeed: 1
			setPri: 12
			stopUpd:
			hide:
		)
	)
	
	(method (doit)
		(cond 
			((> local9 1) (-- local9))
			((== local9 1) (= local9 0) (if local7 (= local8 1)))
		)
		(if (== (master loop?) 2)
			(cond 
				((< (ego x?) 100) (if (== (master cel?) 1) (master cel: 0)))
				((== (master cel?) 0) (master cel: 1))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
	)
)

(instance masterScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local7 0)
				(= local4 5)
				(master loop: 1 cel: 0 cycleSpeed: 0)
				(= cycles 3)
			)
			(1
				(master cel: 1)
				(= cycles 3)
			)
			(2
				(master cel: 2)
				(= cycles 3)
			)
			(3
				(master cel: 3)
				(= cycles 3)
			)
			(4
				(master cel: 1)
				(= cycles 1)
			)
			(5
				(master cel: 0)
				(-- local4)
				(= cycles 1)
			)
			(6
				(if (> local4 0)
					(self changeState: 4)
				else
					(self changeState: 0)
				)
			)
			(7
				(HighPrint 311 64)
				(master
					loop: 2
					cel: (if (> (ego x?) 100) 1 else 0)
					posn: 80 134
				)
				(newView cel: 1)
				(newProp_2 show:)
				(= cycles 5)
			)
			(8
				(if local6
					(HighPrint 297 (Random 21 25))
				else
					(= local6 1)
					(HighPrint 311 65)
				)
				(= local9 100)
				(= local5 (Random 1 4))
				(= local7 1)
				(= cycles 2)
			)
			(9
				(newProp_2 setCycle: EndLoop self)
			)
			(10
				(newProp_2 setCycle: BegLoop self)
			)
			(11
				(if (> local5 0)
					(-- local5)
					(self changeState: 9)
				else
					(= cycles (Random 30 60))
				)
			)
			(12
				(= local5 (Random 1 4))
				(if local8 (self cue:) else (self changeState: 9))
			)
			(13
				(= local8 0)
				(= local7 0)
				(= local9 0)
				(master loop: 4 cel: 0 cycleSpeed: 2 setCycle: EndLoop self)
			)
			(14 (self changeState: 0))
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					(
						(Said
							'awaken[<up]/adventurer,master,abenteuer,man,guildmaster'
						)
						(if local7
							(HighPrint 311 26)
						else
							(self changeState: 7)
						)
					)
					((Said 'chat/adventurer,master,abenteuer,man')
						(if (ego inRect: 0 132 106 195)
							(= local9 100)
							(if local7
								(HighPrint 311 27)
							else
								(self changeState: 7)
							)
						else
							(PrintNotCloseEnough)
						)
					)
					(
					(and (Said 'ask>') (ego inRect: 0 132 106 195))
						(= local9 100)
						(cond 
							(local7
								(= local11 1)
								(cond 
									((Said '/curse') (HighPrint 311 28))
									((Said '/baron') (HighPrint 311 29))
									((Said '/barnard,barnard') (HighPrint 311 30))
									((Said '/elsa,daughter')
										(HighPrint 311 31)
										(HighPrint 311 32)
										(HighPrint 311 33)
									)
									((Said '/jester,yorick') (HighPrint 311 34))
									((Said '/baba') (HighPrint 311 35) (HighPrint 311 36))
									((Said '/adventure,adventurer,adventuring') (HighPrint 311 37))
									((Said '/meisterson') (HighPrint 311 38))
									((Said '/hall,club') (HighPrint 311 39) (HighPrint 311 40))
									((Said 'board,bulletin') (HighPrint 311 39))
									((Said '/monster,head') (HighPrint 311 41))
									((Said '/bandit') (HighPrint 311 42))
									((Said '/saurus') (HighPrint 311 43))
									((Said '/troll') (HighPrint 311 44))
									((Said '/cheetaur') (HighPrint 311 45))
									((Said '/griffin') (HighPrint 311 46))
									((Said '/dragon')
										(HighPrint 311 47)
										(HighPrint 311 48)
										(HighPrint 311 49)
									)
									((Said '/antwerp') (HighPrint 311 50))
									((Said '/moose') (HighPrint 311 51))
									((Said '/tourist') (HighPrint 311 52))
									((Said '/andromeda') (HighPrint 311 53))
									((Said '/halfwitten') (HighPrint 311 54))
									((Said '/ogre') (HighPrint 311 55))
									((Said '/goon,otto,bouncer') (HighPrint 311 56))
									((Said '/abenteuer,master,name') (HighPrint 311 57))
									((Said '/hero') (HighPrint 311 58))
									(
										(or
											(Said '/ring,warlock,spell,leader')
											(Said '/component[<spell,about]')
										)
										(HighPrint 311 59)
									)
									((Said '/castle') (HighPrint 311 60))
									((Said '/heal,house') (HighPrint 311 61))
									((Said '/*')
										(= local11 0)
										(HighPrint 311 62)
										(HighPrint 311 63)
										(= local8 1)
									)
								)
								(if local11 (AddToScore POINTS_TALKTOGUILDMASTER 1))
							)
							((Said '/*') (masterScript changeState: 7))
						)
					)
				)
			)
		)
	)
)

(instance onDragon of RFeature
	(properties
		nsTop 55
		nsBottom 80
		nsRight 50
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onDragon pEvent 3) (localproc_016a))
		)
	)
)

(instance onCheetaur of RFeature
	(properties
		nsTop 55
		nsLeft 65
		nsBottom 70
		nsRight 80
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCheetaur pEvent 3) (localproc_0174))
		)
	)
)

(instance onTroll of RFeature
	(properties
		nsTop 40
		nsLeft 98
		nsBottom 65
		nsRight 122
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTroll pEvent 3) (localproc_0156))
		)
	)
)

(instance onGryphon of RFeature
	(properties
		nsTop 40
		nsLeft 145
		nsBottom 68
		nsRight 180
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onGryphon pEvent 3) (localproc_0160))
		)
	)
)

(instance onAntwerp of RFeature
	(properties
		nsTop 40
		nsLeft 192
		nsBottom 65
		nsRight 215
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onAntwerp pEvent 3) (localproc_017e))
		)
	)
)

(instance onSaurus of RFeature
	(properties
		nsTop 54
		nsLeft 221
		nsBottom 67
		nsRight 245
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSaurus pEvent 3) (localproc_014c))
		)
	)
)

(instance onMoose of RFeature
	(properties
		nsTop 57
		nsLeft 279
		nsBottom 85
		nsRight 314
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onMoose pEvent 3) (localproc_0142))
		)
	)
)

(instance onGuildMaster of RFeature
	(properties
		nsTop 124
		nsLeft 62
		nsBottom 150
		nsRight 80
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onGuildMaster pEvent 3) (localproc_012e))
		)
	)
)

(instance onFireplace of RFeature
	(properties
		nsTop 119
		nsLeft 1
		nsBottom 155
		nsRight 28
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFireplace pEvent 3) (localproc_0138))
		)
	)
)

(instance onLog of RFeature
	(properties
		nsTop 81
		nsLeft 197
		nsBottom 94
		nsRight 219
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLog pEvent 3) (localproc_0015))
		)
	)
)

(instance onQuestBoard of RFeature
	(properties
		nsTop 73
		nsLeft 106
		nsBottom 92
		nsRight 162
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onQuestBoard pEvent 3) (localproc_00fc))
		)
	)
)
