;;; Sierra Script 1.0 - (do not remove this comment)
(script# 313)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use SmoothLooper)
(use Chase)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm313 0
)

(local
	newProp
	newProp_2
	newView
	newView_5
	newView_4
	newView_2
	newView_3
	newView_6
	newView_7
	local9
	local10
	local11
	local12
	local13
	local14
	local15
	local16
	local17
)
(procedure (localproc_000c)
	(HighPrint 313 0)
	(HighPrint 313 1)
)

(procedure (localproc_001d)
	(AddToScore POINTS_PETLOLCAT 3 CLASS_THIEF)
	(cond 
		(
		(or (== (catWalk state?) 6) (== (catWalk state?) 7)) (= local12 0) (catWalk changeState: 8))
		((& (ego onControl: origin) cYELLOW) (HighPrint 313 2))
		(else (PrintNotCloseEnough))
	)
)

(procedure (localproc_0078)
	(cond 
		((Btest 132) (PrintAlreadyDoneThat))
		((< (ego distanceTo: newView_4) 15)
			(HighPrint 313 3)
			(ego get: invSilverCoin 20)
			(Bset 132)
			(AddToScore POINTS_SEARCHLOLPURSE 1 CLASS_THIEF)
		)
		(else (PrintNotCloseEnough))
	)
)

(procedure (localproc_00c7)
	(cond 
		((Btest 131) (PrintAlreadyDoneThat))
		((< (ego distanceTo: newView_5) 15)
			(HighPrint 313 4)
			(ego get: invStringOfPearls)
			(Bset 131)
			(AddToScore POINTS_SEARCHLOLBASKET 1 CLASS_THIEF)
		)
		(else (PrintNotCloseEnough))
	)
)

(procedure (localproc_0115)
	(cond 
		((Btest 134) (HighPrint 313 5))
		((ego inRect: 22 131 53 152) (AddToScore POINTS_SEARCHLOLDESK 1 CLASS_THIEF) (ego setScript: deskOpen))
		(else (PrintNotCloseEnough))
	)
)

(procedure (localproc_015e)
	(cond 
		((Btest 135) (PrintAlreadyDoneThat))
		((< (ego distanceTo: newProp) 25) (ego setScript: birdieSings))
		(else (PrintNotCloseEnough))
	)
)

(instance cat of Actor
	(properties)
)

(instance catTurn of SmoothLooper
	(properties
		vChangeDir 637
	)
)

(instance rm313 of Room
	(properties
		picture 313
		style $0002
	)
	
	(method (init)
		(LoadMany 128 313 635 636 525)
		(Load rsSOUND 8)
		(Load rsSOUND (GetSongNumber 52))
		(super init:)
		(AddToScore POINTS_ENTERLOLHOUSE 5 CLASS_THIEF)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(StopEgo)
		(ego posn: 159 189 init: setMotion: MoveTo 159 170)
		(= cSoundDeath (GetSongNumber 52))
		(cat
			view: 635
			loop: 4
			posn: 280 165
			init:
			moveSpeed: 1
			setStep: 3 1
			setCycle: Walk
			setScript: catWalk
		)
		((= newProp (Prop new:))
			view: 313
			loop: 2
			cel: 0
			posn: 209 110
			z: 22
			init:
			stopUpd:
		)
		((= newProp_2 (Prop new:))
			view: 313
			loop: 1
			cel: 0
			posn: 31 135
			init:
			setPri: 10
			stopUpd:
		)
		((= newView (View new:))
			view: 313
			loop: 2
			cel: 2
			posn: 279 95
			stopUpd:
			addToPic:
		)
		((= newView_2 (View new:))
			view: 313
			loop: 2
			cel: 3
			posn: 71 116
			stopUpd:
			addToPic:
		)
		((= newView_3 (View new:))
			view: 313
			loop: 2
			cel: 4
			posn: 28 124
			setPri: 11
			stopUpd:
			addToPic:
		)
		((= newView_4 (View new:))
			view: 313
			loop: 2
			cel: 6
			posn: 81 141
			z: 12
			init:
			setPri: 10
			stopUpd:
		)
		((= newView_5 (View new:))
			view: 313
			loop: 2
			cel: 5
			posn: 172 136
			setPri: 10
			init:
			stopUpd:
		)
		((View new:)
			view: 313
			loop: 0
			cel: 0
			posn: 117 149
			ignoreActors:
			setPri: 12
			init:
			stopUpd:
			addToPic:
		)
		(if (not (Btest 133))
			((= newView_6 (View new:))
				view: 313
				loop: 2
				cel: 1
				posn: 87 148
				ignoreActors:
				setPri: 12
				init:
				stopUpd:
			)
			((= newView_7 (View new:))
				view: 313
				loop: 2
				cel: 1
				posn: 142 148
				ignoreActors:
				setPri: 12
				init:
				stopUpd:
			)
		)
		(self setLocales: 801)
		(self setScript: first313Script)
		(sillyThief init: play:)
	)
	
	(method (doit)
		(cond 
			((> (ego y?) 189) (= dayLOLBarredDoor currentDay) (curRoom newRoom: 310))
			(
				(and
					(& (ego onControl: origin) cLMAGENTA)
					(== (ego loop?) 1)
					(!= local9 1)
				)
				(= local9 1)
				(ego setScript: climbUp1)
			)
			(
				(and
					(& (ego onControl: origin) cLRED)
					(== (ego loop?) 1)
					(!= local9 2)
				)
				(= local9 2)
				(ego setScript: climbUp2)
			)
			(
				(and
					(& (ego onControl: origin) cLCYAN)
					(== (ego loop?) 1)
					(!= local9 3)
				)
				(= local9 3)
				(ego setScript: climbUp3)
			)
			((and (< (ego y?) 103) (== (ego loop?) 0)) (ego setScript: climbDown))
			((== (ego onControl: origin) cLGREEN) (= local9 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 92)
		(= cSoundDeath (GetSongNumber 26))
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'search,(look<in)>')
				(cond 
					((Said '/purse') (localproc_0078))
					((Said '/bag,basket') (localproc_00c7))
					((Said '/birdcage,birdcage') (localproc_015e))
					((Said '/couch')
						(cond 
							((Btest 130) (HighPrint 313 6))
							((ego inRect: 80 125 150 145)
								(HighPrint 313 7)
								(ego get: invSilverCoin 3)
								(Bset 130)
								(AddToScore POINTS_SEARCHLOLCOUCH 1 CLASS_THIEF)
							)
							(else (PrintNotCloseEnough))
						)
					)
					((Said '/desk,drawer') (localproc_0115))
					((Said '/plant')
						(if
							(or
								(< (ego distanceTo: newView_2) 15)
								(ego inRect: 22 131 53 152)
							)
							(HighPrint 313 8)
						else
							(PrintNotCloseEnough)
						)
					)
					(else (pEvent claimed: 0))
				)
			)
			((Said 'open>')
				(cond 
					((Said '/desk,drawer') (localproc_0115))
					((Said '/purse') (localproc_0078))
					((Said '/bag,basket') (localproc_00c7))
					((Said '/birdcage,birdcage') (localproc_015e))
				)
			)
			((Said 'get>')
				(cond 
					((Said '/candlestick,stick,holder,candle')
						(cond 
							((Btest 133) (PrintAlreadyDoneThat))
							((ego inRect: 62 145 166 165)
								(HighPrint 313 9)
								(ego get: invSilverCandlesticks 2)
								(newView_6 dispose:)
								(newView_7 dispose:)
								(Bset 133)
								(AddToScore POINTS_TAKECANDLESTICKS 1 CLASS_THIEF)
							)
							(else (PrintNotCloseEnough))
						)
					)
					((Said '/purse') (localproc_0078))
					((Said '/bag,basket') (localproc_00c7))
					((Said '/couch') (HighPrint 313 10))
				)
			)
			(
				(or
					(Said 'lift,get/cover')
					(Said 'uncover/birdcage,birdcage')
				)
				(localproc_015e)
			)
			((Said 'look[<at,around][/!*,room,building]') (localproc_000c))
			((or (Said 'look<up') (Said 'look/ceiling')) (HighPrint 313 11))
			((or (Said 'look<down') (Said 'look/floor')) (HighPrint 313 12))
			((Said 'look/dust') (HighPrint 313 13))
			(
				(or
					(IsObjectOnControl onRug pEvent 3)
					(Said 'look/carpet')
				)
				(HighPrint 313 14)
			)
			((Said 'look/ladder,door') (HighPrint 313 15))
			((IsObjectOnControl onDoor pEvent 3) (HighPrint 313 16))
			((Said 'look/wall') (HighPrint 313 17))
			(
				(or
					(IsObjectOnControl onFireplace pEvent 3)
					(Said 'look/chimney')
				)
				(HighPrint 313 18)
			)
			(
				(or
					(IsObjectOnControl onFireplace pEvent 3)
					(Said 'look/chimney')
				)
				(HighPrint 313 18)
			)
			(
				(or
					(IsObjectOnControl onPurse pEvent 3)
					(Said 'look/purse')
				)
				(HighPrint 313 19)
			)
			(
				(or
					(IsObjectOnControl onLamp pEvent 3)
					(Said 'look/mantle')
				)
				(HighPrint 313 20)
			)
			(
				(or
					(IsObjectOnControl onLCandle pEvent 3)
					(IsObjectOnControl onRCandle pEvent 3)
					(Said 'look/candle,candlestick')
				)
				(if (not (ego has: invSilverCandlesticks)) (HighPrint 313 21))
			)
			((Said 'look/table')
				(if (ego has: invSilverCandlesticks)
					(HighPrint 313 22)
				else
					(HighPrint 313 23)
				)
			)
			(
				(or
					(IsObjectOnControl onDoily pEvent 3)
					(Said 'look/doily')
				)
				(HighPrint 313 24)
			)
			(
				(or
					(IsObjectOnControl onCage pEvent 3)
					(Said 'look/birdcage,birdcage,stand,cover')
				)
				(HighPrint 313 25)
			)
			((Said 'look/bird')
				(if local17
					(HighPrint 313 26)
				else
					(HighPrint 313 27)
				)
			)
			(
			(or (IsObjectOnControl cat pEvent 3) (Said 'look/cat')) (HighPrint 313 28))
			(
				(or
					(IsObjectOnControl onDesk pEvent 3)
					(Said 'look/desk')
				)
				(HighPrint 313 29)
			)
			((IsObjectOnControl onRubberPlant pEvent 3) (HighPrint 313 30))
			((IsObjectOnControl onColeusPlant pEvent 3) (HighPrint 313 31))
			((Said 'look/plant') (HighPrint 313 32))
			((Said 'look/pan') (HighPrint 313 33))
			((Said 'look/railing') (HighPrint 313 34))
			(
				(or
					(IsObjectOnControl onBag pEvent 3)
					(Said 'look/bag,basket')
				)
				(HighPrint 313 35)
			)
			((Said 'look/collar') (HighPrint 313 36))
		)
	)
)

(instance birdieSings of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 135)
				(= local17 1)
				(newProp setLoop: 3 setCycle: Forward startUpd:)
				(= seconds 6)
			)
			(1
				(Print 313 37 #at -1 15 #title {Little Birdie})
				(Print 313 38 #at -1 15 #title {Little Old Lady})
				(HighPrint 313 39)
				(self cue:)
				; Kitty, you'd better not be bothering the little birdie again!
			)
			(2
				(newProp setLoop: 2 setCel: 0 stopUpd:)
				(= cycles 2)
			)
			(3
				(HighPrint 313 40)
				(= local17 0)
				(ego setScript: 0)
			)
		)
	)
)

(instance deskOpen of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(newProp_2 setCycle: EndLoop self)
			)
			(1
				(HighPrint 313 41)
				(ego get: invSilverCoin 1)
				(Bset 134)
				(self cue:)
			)
			(2
				(newProp_2 setCycle: BegLoop)
				(ego setScript: 0)
				(UnlockEgo)
			)
		)
	)
)

(instance first313Script of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(if (or (not (Btest 92)) (!= prevRoomNum 0))
					(localproc_000c)
				)
				(client setScript: 0)
			)
		)
	)
)

(instance catWalk of Script
	(properties)
	
	(method (doit)
		(cond 
			(local13 (= local13 0) (cat setScript: getReady))
			(
				(and
					(& (ego onControl: origin) cYELLOW)
					(> (ego distanceTo: cat) 17)
					(not local10)
				)
				(self changeState: 5)
			)
			(
				(and
					(>= state 5)
					(== local9 0)
					(not (& (ego onControl: origin) cYELLOW))
				)
				(= local10 0)
				(self changeState: 0)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cat setLoop: 4 setMotion: 0 cycleSpeed: 4)
				(if (and (not local10) (not local14)) (= seconds 4))
			)
			(1
				(if (not (cat looper?)) (cat setLoop: catTurn))
				(cat
					loop: 0
					cel: 0
					cycleSpeed: 1
					moveSpeed: 1
					xStep: 3
					yStep: 1
					setMotion: MoveTo 240 123 self
				)
			)
			(2
				(cat setMotion: MoveTo 180 123 self)
			)
			(3
				(cat setMotion: MoveTo 220 165 self)
			)
			(4
				(= state 0)
				(cat setMotion: MoveTo 280 165 self)
			)
			(5
				(= local10 1)
				(= seconds 0)
				(if (not (cat looper?)) (cat setLoop: catTurn))
				(cat
					loop: 0
					cel: 0
					cycleSpeed: 1
					setMotion: Chase ego 15 self
				)
			)
			(6
				(LockEgo)
				(= local10 0)
				(++ local12)
				(cat loop: 4 setMotion: 0 cycleSpeed: 4)
				(if (== local12 2) (= cycles 2) else (UnlockEgo))
			)
			(7
				(= local12 0)
				(++ local11)
				(UnlockEgo)
				(switch local11
					(1 (HighPrint 313 43))
					(2 (HighPrint 313 44))
					(3
						(LockEgo)
						(PrintTimedMessage 6 313 42)
						(cat setScript: gonnaGetYou)
					)
				)
			)
			(8
				(LockEgo)
				(FaceObject ego cat)
				(= cycles 2)
			)
			(9
				(if local15
					(switch local11
						(0 (HighPrint 313 45))
						(1 (HighPrint 313 46))
						(2 (HighPrint 313 47))
					)
				)
				(if local16
					(switch local11
						(0 (HighPrint 313 48))
						(1 (HighPrint 313 49))
						(2
							(if (ego has: invFoodRation)
								(ego use: invFoodRation 1)
								(HighPrint 313 50)
							else
								(HighPrint 313 51)
							)
						)
					)
				)
				(= local16 0)
				(= local15 0)
				(if (< local11 3) (HighPrint 313 52))
				(if (> local11 0)
					(if local16 (= local11 0) else (-- local11))
				)
				(UnlockEgo)
				(= state 7)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'pat[/cat]') (= local15 1) (localproc_001d))
					((Said 'feed/cat') (= local16 1) (localproc_001d))
					((Said 'beat,kill/cat')
						(if
						(or (== (catWalk state?) 6) (== (catWalk state?) 7))
							(LockEgo)
							(PrintTimedMessage 6 313 42)
							(cat setScript: gonnaGetYou)
						else
							(PrintNotCloseEnough)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance gonnaGetYou of Script
	(properties)
	
	(method (doit)
		(cond 
			(
				(and
					(== (ego x?) 194)
					(== (ego y?) 144)
					(== (cat x?) 260)
					(== (cat y?) 142)
				)
				(cat illegalBits: cWHITE setScript: 0)
				(ego setScript: catAttack)
			)
			((and (== (ego x?) 194) (== (ego y?) 144))
				(if
				(not (if (== (cat x?) 260) (== (cat y?) 142)))
					(ego view: 525 loop: 0 cel: 0)
				)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (cat looper?)) (cat setLoop: catTurn))
				(cat
					loop: 0
					setStep: 3 1
					cycleSpeed: 1
					illegalBits: 0
					setMotion: MoveTo 260 142
				)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 194 144
				)
			)
		)
	)
)

(instance getReady of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (cat looper?)) (cat setLoop: catTurn))
				(cat loop: 0 cycleSpeed: 1 setMotion: MoveTo 260 142 self)
			)
			(1
				(cat setMotion: 0 loop: 4 cycleSpeed: 4)
			)
		)
	)
)

(instance catAttack of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local14
					(ego setMotion: MoveTo 194 144 self)
				else
					(self cue:)
				)
			)
			(1
				(if local14 (ego view: 525 setLoop: 0 cel: 0))
				(cat
					illegalBits: 0
					ignoreActors:
					looper: 0
					setLoop: 5
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(2
				(ego cycleSpeed: 1 setCycle: EndLoop self)
			)
			(3
				(ego setLoop: 1 cel: 0)
				(= cycles 4)
			)
			(4
				(ego
					cycleSpeed: 0
					setCycle: Forward
					setMotion: MoveTo 160 144 self
				)
				(cat loop: 6 cel: 0 cycleSpeed: 1 setCycle: Forward)
			)
			(5
				(ego setCycle: 0)
				(cat loop: 7 cel: 0 setCycle: EndLoop self)
			)
			(6
				(cat posn: 243 141)
				(= cycles 1)
			)
			(7
				(cat posn: 226 140)
				(ego view: 636 setLoop: 0 setCel: 0)
				(= cycles 1)
			)
			(8
				(cat posn: 209 139)
				(ego setCel: 1)
				(= cycles 1)
			)
			(9
				(cat hide:)
				(ego setCel: 2)
				(= cycles 1)
			)
			(10
				(ego setLoop: 1 setCel: 0)
				(cat
					view: 636
					loop: 2
					cel: 0
					setPri: 12
					posn: 134 126
					setCycle: Forward
					show:
				)
				(= cycles 40)
			)
			(11
				(if local14
					(Die
						313
						53
						80
						{ Better stay downstairs next time._}
						82
						637
						1
						0
					)
				else
					(Die 313 54 80 { What a cute little kitty!_} 82 637 1 0)
				)
			)
		)
	)
)

(instance climbUp1 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local13 1)
				(ego
					setLoop: 1
					illegalBits: 0
					setMotion: MoveTo 177 101 self
				)
			)
			(1
				(UnlockEgo)
				(ego setLoop: -1 illegalBits: cWHITE)
				(Print 313 55 #at 78 101)
				(ego setScript: 0)
				; SQUEEEEAK!
			)
		)
	)
)

(instance climbUp2 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					setLoop: 1
					setMotion: MoveTo 160 90 self
				)
			)
			(1
				(UnlockEgo)
				(ego setLoop: -1 illegalBits: cWHITE)
				(Print 313 56 #at 62 92)
				(ego setScript: 0)
				; CREEEEAAK!
			)
		)
	)
)

(instance climbUp3 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					setLoop: 1
					setMotion: MoveTo 146 74 self
				)
			)
			(1
				(UnlockEgo)
				(ego setLoop: -1 illegalBits: cWHITE)
				(Print 313 57 #at 41 88)
				(HighPrint 313 58)
				(Print 313 59 #at -1 20 #mode 1 #title {Little Old Lady})
				(= local14 1)
				(ego setScript: climbDown)
				; Help! Burglars! Sheriff! Help!
; Kitty! Kitty!
			)
		)
	)
)

(instance climbDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local9 0)
				(ego
					illegalBits: 0
					setLoop: 0
					setMotion: MoveTo 194 107 self
				)
			)
			(1
				(if local14
					(Print 313 60 #at -1 15 #title {L.O.L.})
					(ego setLoop: -1 setScript: catAttack)
					(cat setScript: 0)
					; KITTY!!!
				else
					(UnlockEgo)
					(ego setLoop: -1 illegalBits: cWHITE)
					(ego setScript: 0)
					(cat setScript: catWalk)
				)
			)
		)
	)
)

(instance onPurse of RFeature
	(properties
		nsTop 119
		nsLeft 75
		nsBottom 129
		nsRight 85
	)
)

(instance onBag of RFeature
	(properties
		nsTop 122
		nsLeft 165
		nsBottom 135
		nsRight 177
	)
)

(instance onCage of RFeature
	(properties
		nsTop 69
		nsLeft 202
		nsBottom 88
		nsRight 214
	)
)

(instance onCouch of RFeature
	(properties
		nsTop 112
		nsLeft 86
		nsBottom 131
		nsRight 152
	)
)

(instance onRubberPlant of RFeature
	(properties
		nsTop 77
		nsLeft 63
		nsBottom 115
		nsRight 76
	)
)

(instance onColeusPlant of RFeature
	(properties
		nsTop 107
		nsLeft 19
		nsBottom 123
		nsRight 33
	)
)

(instance onDoor of RFeature
	(properties
		nsTop 6
		nsLeft 70
		nsBottom 50
		nsRight 105
	)
)

(instance onFireplace of RFeature
	(properties
		nsTop 93
		nsLeft 259
		nsBottom 143
		nsRight 288
	)
)

(instance onLamp of RFeature
	(properties
		nsTop 73
		nsLeft 274
		nsBottom 94
		nsRight 284
	)
)

(instance onDesk of RFeature
	(properties
		nsTop 124
		nsLeft 19
		nsBottom 137
		nsRight 43
	)
)

(instance onDoily of RFeature
	(properties
		nsTop 144
		nsLeft 97
		nsBottom 150
		nsRight 130
	)
)

(instance onLCandle of RFeature
	(properties
		nsTop 133
		nsLeft 83
		nsBottom 149
		nsRight 91
	)
)

(instance onRCandle of RFeature
	(properties
		nsTop 133
		nsLeft 137
		nsBottom 149
		nsRight 146
	)
)

(instance onRug of RFeature
	(properties
		nsTop 136
		nsLeft 163
		nsBottom 158
		nsRight 223
	)
)

(instance sillyThief of Sound
	(properties
		number 8
		loop -1
	)
)
