;;; Sierra Script 1.0 - (do not remove this comment)
(script# 332)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Menu)
(use Actor)
(use System)

(public
	rm332 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	[local9 2] = [{Mighty careless of you to walk right in front of that knife!__Or did the Chief Thief hit you on purpose?__Or did you just discover an obscure bug in the program???__Maybe you'll never really know._} {You can't believe the Chief Thief's reflexes as he instantly reacts to your intention to pull a fast one.__A dagger flies like lightning and...._}]
	[local11 2] = [{Trouble with sharp, pointy objects} {These guys are MEAN!}]
	[local13 7] = [250 40 75 30 25 100 35]
)
(procedure (localproc_000c)
	(HighPrint 332 0)
	(HighPrint 332 1)
	(HighPrint 332 2)
)

(procedure (localproc_0025)
	(HighPrint 332 3)
)

(procedure (localproc_002f)
	(return
		(if local2
			(return 0)
		else
			(knifeScript changeState: 1)
			(return 1)
		)
	)
)

(instance rm332 of Room
	(properties
		picture 332
		style $0005
	)
	
	(method (init)
		(LoadMany 128 332 338 509 503)
		(LoadMany
			132
			(GetSongNumber 31)
			(GetSongNumber 29)
			(GetSongNumber 30)
		)
		(super init:)
		(gMouseHandler add: self)
		(AddToScore POINTS_ENTERTHIEVESGUILD 5 CLASS_THIEF)
		(dagMusic number: (GetSongNumber 31) init:)
		(self setLocales: 801)
		(StatusLine enable:)
		(StopEgo)
		(= local3 100)
		(= local4 7)
		(= perspective 70)
		(gAddToPics add: board Boris eachElementDo: #init doit:)
		(chiefThief init:)
		(throwingArm init:)
		(chair init: setPri: 12 hide:)
		(crusher init: stopUpd:)
		(foot init: setScript: footScript)
		(knife
			ignoreActors:
			init:
			setPri: 13
			setLoop: 7
			setCycle: Forward
			stopUpd:
			hide:
			setScript: knifeScript
		)
		(if (== prevRoomNum 340)
			(ego posn: 230 139 loop: 2 init:)
			(chiefThief setScript: chiefBored)
		else
			(self setScript: rm332EntranceScript)
		)
	)
	
	(method (doit)
		(cond 
			(local2
				(if
					(<=
						(= local3
							(GetDistance
								(ego x?)
								(- (ego y?) 30)
								(knife x?)
								(knife y?)
								perspective
							)
						)
						local4
					)
					(ego setScript: deathScript)
				)
			)
			(
			(and local7 (not local0) (== (knifeScript state?) 0)) (= local0 1) (localproc_002f))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 99)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 theGInventory [temp3 60])
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'fight,beat,chop,kill[/*]')
					(Said 'throw/boulder,dagger')
					(Said 'cast')
				)
				(LockEgo)
				(= local7 1)
			)
			((Said 'help,rule') (__proc341_0))
			(
				(or
					(Said 'bet,dagnabit')
					(Said 'play/!*,game,dagnabit,dagger,dart')
				)
				(curRoom newRoom: 340)
			)
			((Said 'climb,done') (self setScript: leaveRoomScript))
			((Said 'rest,nap') (HighPrint 332 4) (self setScript: throwEgoOut))
			((Said 'open/door')
				(if (ego inRect: 150 115 205 125)
					(HighPrint 332 5)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'lockpick') (HighPrint 332 6))
			((Said 'chat>')
				(cond 
					((Said '/man,people,thief')
						(cond 
							((ego inRect: 75 113 140 140) (HighPrint 332 7))
							((ego inRect: 150 115 205 125)
								(if (not (ego has: invThiefGuideLicense))
									(HighPrint 332 8)
								else
									(HighPrint 332 9)
								)
							)
							(else (HighPrint 332 10))
						)
					)
					((Said '/bouncer,goon,ogre') (HighPrint 332 7))
					((Said '/boris,fence,cashier,item,creature')
						(cond 
							((not (ego inRect: 150 115 205 125)) (HighPrint 332 11))
							((not (ego has: invThiefGuideLicense)) (HighPrint 332 8))
							(else (HighPrint 332 9))
						)
					)
					((not (ego has: invThiefGuideLicense)) (localproc_0025))
					((Said '/boss,master') (HighPrint 332 10))
				)
			)
			(
				(or
					(IsObjectOnControl chiefThief pEvent 3)
					(Said 'look/man,boss,master,thief')
				)
				(HighPrint 332 12)
			)
			(
				(or
					(IsObjectOnControl crusher pEvent 3)
					(Said 'look/bouncer,ogre,goon')
				)
				(HighPrint 332 13)
			)
			(
				(or
					(IsObjectOnControl onGrate pEvent 3)
					(Said 'look/window,door,gate,grate')
				)
				(HighPrint 332 14)
			)
			(
				(or
					(IsObjectOnControl onLadder pEvent 3)
					(Said 'look/ladder,step')
				)
				(HighPrint 332 15)
			)
			(
				(or
					(IsObjectOnControl onBoard pEvent 3)
					(Said 'look/board,game,dagnabit,daggerboard')
				)
				(HighPrint 332 16)
				(if (> local6 5) (HighPrint 332 17))
			)
			((Said 'look>')
				(cond 
					((Said '/fence,boris,door') (HighPrint 332 18))
					((or (Said '/floor') (Said '<down')) (HighPrint 332 19))
					((Said '/wall,plaster') (HighPrint 332 20))
					((Said '/ceiling,roof,up,ale,spill,mark') (HighPrint 332 21))
					((Said '/dart,dagger') (HighPrint 332 22))
					((Said '[<at,around][/!*,room,building]') (localproc_000c))
				)
			)
			((IsObjectOnControl onMug pEvent 3) (HighPrint 332 23))
			((IsObjectOnControl ego pEvent 3) (HighPrint 332 24))
			((Said 'get/dagger,dagger,target') (HighPrint 332 25))
			(
			(or (Said 'pay,join') (Said 'buy,get/certificate'))
				(cond 
					((not (ego inRect: 150 115 205 125)) (HighPrint 332 26))
					((ego has: invThiefGuideLicense) (HighPrint 332 27))
					((GiveSilverCoins 25) (ego get: invThiefGuideLicense) (HighPrint 332 28) (AddToScore POINTS_BUYTHIEFLICENSE 3 CLASS_THIEF))
					(else (HighPrint 332 29) (pEvent claimed: 1))
				)
			)
			((Said 'buy,get>')
				(cond 
					((not (ego inRect: 150 115 205 125)) (HighPrint 332 26) (pEvent claimed: 1))
					((not (ego has: invThiefGuideLicense)) (HighPrint 332 30) (pEvent claimed: 1))
					((Said '/lockpick')
						(if (GiveSilverCoins 15)
							(HighPrint 332 31)
							(ego get: invLockPick)
							(= lockPickBonus 10)
						else
							(HighPrint 332 32)
						)
					)
					((Said '/kit[<thief,implement]')
						(if (GiveSilverCoins 100)
							(ego get: invThiefToolKit)
							(= lockPickBonus 35)
							(AddToScore POINTS_BUYTHIEFTOOLKIT 3 CLASS_THIEF)
							(HighPrint 332 31)
						else
							(HighPrint 332 32)
						)
					)
					(else (pEvent claimed: 1) (HighPrint 332 33))
				)
			)
			((Said 'fence,sell>')
				(= theGInventory
					[invNum (= temp1 (SaidGet pEvent))]
				)
				(cond 
					((not (ego inRect: 150 115 205 125)) (HighPrint 332 26))
					((not (ego has: invThiefGuideLicense)) (HighPrint 332 34))
					((or (not theGInventory) (not temp1)) (HighPrint 332 35))
					((or (< temp1 invGlowingGem) (> temp1 invGoldRing)) (HighPrint 332 36))
					(else
						(= temp0 (* theGInventory [local13 (- temp1 invGlowingGem)]))
						(= [invNum temp1] 0)
						(= [invNum invSilverCoin] (+ [invNum invSilverCoin] temp0))
						(HighPrint 332 37)
						(HighPrint (Format @temp3 332 38 temp0))
						(HighPrint
							(Format @temp3 332 39 [invNum invGoldCoin] [invNum invSilverCoin])
						)
						(AddToScore POINTS_FENCEGOODS 3 CLASS_THIEF)
					)
				)
			)
		)
	)
)

(instance chiefThief of Actor
	(properties
		y 164
		x 233
		view 332
		loop 2
		priority 13
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (Said 'ask>')
					(cond 
						((not (ego has: invThiefGuideLicense)) (pEvent claimed: 1) (localproc_0025))
						((Said '/dagger,throw') (HighPrint 332 40))
						((Said '/board') (HighPrint 332 41))
						((Said '/game,dagnabit,practice,play,rule') (__proc341_0))
						((Said '/bet') (HighPrint 332 42))
						((Said '/thief,grab,stealing') (HighPrint 332 43))
						((Said '/club,club,member') (HighPrint 332 44) (HighPrint 332 45))
						((Said '/fink') (HighPrint 332 46))
						((Said '/due,due,cost') (HighPrint 332 8))
						((Said '/advice') (HighPrint 332 47))
						((Said '/secret') (HighPrint 332 48))
						((Said '/fence,sale,loot,item') (HighPrint 332 49))
						((Said '/boris') (HighPrint 332 50))
						((Said '/bouncer,goon') (HighPrint 332 51))
						((Said '/otto') (HighPrint 332 52))
						((Said '/meisterson') (HighPrint 332 53))
						((Said '/name,boss,master') (HighPrint 332 54))
						((Said '/bandit') (HighPrint 332 55))
						((Said '/spy') (HighPrint 332 56))
						((Said '/hamlet,hamlet') (HighPrint 332 57))
						((Said '/stealing,stealing,labor') (HighPrint 332 58))
						((Said '/hasp,lockpick,implement,kit') (HighPrint 332 59))
						(else (pEvent claimed: 1) (HighPrint 332 60))
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance rm332EntranceScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(setHighSpeedHero 0)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(ego
					illegalBits: 0
					view: 509
					setLoop: 3
					cel: 0
					posn: 77 143
					init:
				)
				(if (not (Btest 99)) (localproc_000c))
				(ego cycleSpeed: 2 setCycle: EndLoop self)
			)
			(1
				(localproc_002f)
				(ego
					view: 0
					loop: 0
					cel: 0
					setCycle: Walk
					cycleSpeed: 0
					setMotion: MoveTo 150 145 self
				)
			)
			(2
				(if (Btest 99) (self changeState: 40))
				(ego setMotion: MoveTo 220 130 self)
			)
			(3
				(throwingArm hide:)
				(knife hide:)
				(chiefThief setLoop: 2 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(4
				(ego view: 509 setLoop: 0 cel: 0)
				(head
					posn: 220 97
					setPri: 11
					setCel: 2
					ignoreActors:
					init:
				)
				(chair show:)
				(chiefThief
					setLoop: 1
					cycleSpeed: 1
					moveSpeed: 1
					setCycle: Forward
					setMotion: MoveTo 220 164 self
				)
			)
			(5
				(head setCel: 1)
				(PrintTimedMessage 5 332 61)
				(chiefThief setMotion: MoveTo 180 164 self)
			)
			(6
				(head setCel: 0)
				(chiefThief setMotion: MoveTo 150 164 self)
			)
			(7
				(chiefThief setLoop: 0 setMotion: MoveTo 190 164 self)
			)
			(8
				(PrintTimedMessage 10 332 62)
				(chiefThief setLoop: 1 setMotion: MoveTo 120 164 self)
			)
			(9
				(chiefThief setLoop: 0 setMotion: MoveTo 190 164 self)
			)
			(10
				(chiefThief setMotion: MoveTo 233 164 self)
			)
			(11
				(head setCel: 1)
				(chair hide:)
				(chiefThief
					setLoop: 2
					cycleSpeed: 1
					cel: -1
					setCycle: BegLoop self
				)
			)
			(12
				(throwingArm show:)
				(chiefThief cycleSpeed: 0 moveSpeed: 0)
				(localproc_002f)
				(head dispose:)
				(ego loop: 2 cel: 0)
				(UnlockEgo)
				(StopEgo)
				(= seconds 3)
			)
			(13
				(HighPrint 332 63)
				(self changeState: 40)
			)
			(40
				(StopEgo)
				(UnlockEgo)
				(chiefThief setScript: chiefBored)
				(client setScript: 0)
			)
		)
	)
)

(instance leaveRoomScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 80 146 self)
			)
			(1
				(ego
					view: 509
					setLoop: 3
					cel: -1
					cycleSpeed: 2
					posn: 77 143
					setCycle: BegLoop self
				)
			)
			(2
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 15)
				(curRoom newRoom: 331)
			)
		)
	)
)

(instance throwEgoOut of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(foot hide: stopUpd:)
				(crusher
					view: 338
					setLoop: 1
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(crusher cel: 2)
				(= cycles 3)
			)
			(2 (crusher setCycle: EndLoop self))
			(3
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 16)
				(self cue:)
			)
			(4
				(Bset 117)
				(curRoom newRoom: 330)
			)
		)
	)
)

(instance chiefBored of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 3 8)))
			(1
				(localproc_002f)
				(self changeState: 0)
			)
		)
	)
)

(instance footScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local1 (Random 3 6))
				(foot cycleSpeed: local1 setCycle: Forward)
				(= seconds (Random 2 5))
			)
			(1
				(foot setCycle: 0 cel: 0)
				(= seconds (Random 5 10))
			)
			(2 (self changeState: 0))
		)
	)
)

(instance knifeScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(throwingArm cel: 5)
				(knife cel: 0 posn: 223 133)
				(chiefThief setLoop: 2 cel: 0)
			)
			(1
				(chiefThief setLoop: 5 cel: 0)
				(= cycles 1)
			)
			(2
				(throwingArm cel: 0 cycleSpeed: 2 setCycle: CycleTo 3 1 self)
			)
			(3
				(knife show:)
				(throwingArm cel: 4)
				(= cycles 1)
			)
			(4
				(= local2 1)
				(throwingArm cel: 5)
				(dagMusic number: (GetSongNumber 31) play:)
				(if local7
					(knife setMotion: MoveTo (ego x?) (- (ego y?) 30))
				else
					(knife
						setMotion: MoveTo (Random 130 146) (Random 78 92) self
					)
				)
			)
			(5
				(dagMusic stop:)
				(dagMusic
					number: (if (Random 0 1)
						(GetSongNumber 30)
					else
						(GetSongNumber 29)
					)
					play:
				)
				(= local2 0)
				(if (< local8 12)
					((View new:)
						view: 332
						loop: 3
						cel: 4
						setPri: 8
						posn: (knife x?) (knife y?)
						init:
						stopUpd:
						addToPic:
					)
					(++ local8)
				)
				(knife hide:)
				(= cycles 2)
			)
			(6 (self changeState: 0))
		)
	)
)

(instance deathScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(knife setMotion: 0 hide:)
				(ego
					view: 503
					posn: (+ (ego x?) 5) (ego y?)
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: CycleTo 5 1
				)
				(= cycles 15)
			)
			(1 (ego setCycle: EndLoop self))
			(2
				(Die [local9 local7] 80 [local11 local7] 82 800 0 0)
			)
		)
	)
)

(instance throwingArm of Prop
	(properties
		y 137
		x 234
		view 332
		loop 6
		cel 5
		priority 12
	)
)

(instance board of PicView
	(properties
		y 85
		x 138
		view 332
		loop 3
		cel 3
		priority 6
	)
)

(instance crusher of Prop
	(properties
		y 122
		x 111
		view 332
		loop 3
		cel 1
	)
)

(instance Boris of PicView
	(properties
		y 89
		x 176
		view 332
		loop 3
		cel 2
	)
)

(instance foot of Prop
	(properties
		y 120
		x 118
		view 332
		loop 4
	)
)

(instance knife of Actor
	(properties
		y 120
		x 118
		yStep 7
		view 332
		loop 7
		cycleSpeed 1
		illegalBits $0000
		xStep 6
	)
)

(instance chair of View
	(properties
		y 164
		x 233
		view 332
		loop 3
	)
)

(instance head of View
	(properties
		view 509
		loop 1
		cel 1
	)
)

(instance onBoard of RFeature
	(properties
		nsTop 77
		nsLeft 126
		nsBottom 93
		nsRight 147
	)
)

(instance onGrate of RFeature
	(properties
		nsTop 69
		nsLeft 163
		nsBottom 89
		nsRight 189
	)
)

(instance onLadder of RFeature
	(properties
		nsTop 33
		nsLeft 56
		nsBottom 146
		nsRight 75
	)
)

(instance onMug of RFeature
	(properties
		nsTop 139
		nsLeft 214
		nsBottom 146
		nsRight 222
	)
)

(instance dagMusic of Sound
	(properties
		number 31
	)
)
