;;; Sierra Script 1.0 - (do not remove this comment)
(script# 215)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Inventory)
(use Actor)
(use System)

(public
	closeCombat 0
	aSpell 1
)

(local
	local0
	local1
	local2
	local3
	local4
	local5 =  2
)
(instance aSpell of Prop
	(properties
		view 535
	)
)

(instance closeCombat of Script
	(properties)
	
	(method (init)
		(LoadMany 130 146 147 148 149 150 151 152 153 154 155)
		(Load rsVIEW 540)
		(if (not (ego has: invShield)) (Load rsVIEW 535))
		(= egoCanFight TRUE)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client drawWeapons:)
				(= local3 ((= local1 (ScriptID 213 0)) egoShield?))
				(= local2 (local1 egoHand?))
				(= local4 (local1 egosBack?))
				(gDirHandler addToFront: client)
				(gMouseHandler addToFront: client)
				(if (and (local1 noWeapon?) (not local3))
					(local2 setLoop: 1 setCel: 2)
				)
				(= cycles 1)
			)
			(1
				(if (local1 noWeapon?)
					(self changeState: 3)
				else
					(client
						canFight: 1
						action: 0
						cycleSpeed: 0
						moveSpeed: 0
						view: (local1 weaponView?)
						setLoop: 2
						cel: 0
						stopUpd:
					)
				)
			)
			(2
				(UnlockEgo)
				(self changeState: 1)
			)
			(3
				(Die
					215
					7
					80
					{Bare Hands vs. Teeth and Claws, etc.}
					82
					516
					0
					9
				)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 temp2)
		(if (or (not (client canFight?)) (not egoCanFight))
			(pEvent claimed: 1)
			(return)
		)
		(if script
			(if
				(and
					(== (pEvent type?) evJOYSTICK)
					(!= (pEvent message?) JOY_UP)
				)
				(script cue:)
			else
				(pEvent claimed: 1)
				(return)
			)
		)
		(switch (pEvent type?)
			(evSAID
				(DisposeDialog)
				(cond 
					((super handleEvent: pEvent))
					((Said 'look') (HighPrint 215 0))
					((Said 'escape,escape,run')
						(if
							(or
								(== prevRoomNum 14)
								(== prevRoomNum 171)
								(== prevRoomNum 88)
								(== prevRoomNum 89)
								(== prevRoomNum 93)
								(== prevRoomNum 73)
								(== prevRoomNum 91)
							)
							(HighPrint 215 1)
						else
							((ScriptID curRoomNum) escaped: 1)
						)
					)
					((and local3 (Said 'cast')) (HighPrint 215 2))
					((Said 'cast>')
						(= local0 (SaidCast pEvent))
						(if (CastSpell local0)
							(client setEgoMP: [skills skMP])
							(if
								(or
									(== local0 skFLAMEDART)
									(== local0 skZAP)
									(== local0 skDAZZLE)
									(== local0 skCALM)
								)
								(LockEgo)
								(self setScript: (ScriptID 146 0) self local0)
							else
								(HighPrint 215 3)
								(pEvent claimed: 1)
							)
						)
					)
					(
						(or
							(Said 'fight,kill,beat,chop')
							(Said 'use/blade,dagger,weapon,shield')
						)
						(HighPrint 215 4)
					)
					((Said 'throw') (HighPrint 215 5))
					(else (HighPrint 215 6) (pEvent claimed: 1))
				)
			)
			(evMOUSEBUTTON
				(= temp0 (pEvent x?))
				(= temp1 (pEvent y?))
				(pEvent claimed: 1)
			)
			(evJOYSTICK
				(LockEgo)
				(switch (pEvent message?)
					(JOY_UP
						(= local5 2)
						(self setScript: (ScriptID 151 0) self local5)
					)
					(JOY_LEFT
						(= local5 0)
						(self setScript: (ScriptID 154 0) self local5)
					)
					(JOY_RIGHT
						(= local5 1)
						(self setScript: (ScriptID 154 0) self local5)
					)
					(JOY_DOWN
						(= local5 2)
						(cond 
							(local3 (self setScript: (ScriptID 152 0) self local5))
							((not (ego has: invBroadsword)) (self setScript: (ScriptID 153 0) self local5))
							(else
								(= local5 (Random 0 1))
								(self setScript: (ScriptID 154 0) self local5)
							)
						)
					)
				)
				(pEvent claimed: 1)
			)
		)
	)
)
