;;; Sierra Script 1.0 - (do not remove this comment)
(script# 294)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Chase)
(use Motion)
(use User)
(use System)

(public
	nextWitch 0
)

(local
	local0
)
(instance nextWitch of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 294)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 120 152 self)
			)
			(1
				((ScriptID 21 1) setLoop: 6 posn: 168 122 init:)
				((ScriptID 21 2)
					posn: ((ScriptID 21 1) x?) (- ((ScriptID 21 1) y?) 34)
					init:
					setPri: 15
					setCycle: Forward
				)
				((ScriptID 21 8) play:)
				(= cycles 5)
			)
			(2
				(PrintTimedMessage 5 294 0)
				((ScriptID 21 3) setCycle: EndLoop)
				((ScriptID 21 4) startUpd:)
				(= local0 1)
				(= seconds 3)
			)
			(3
				(ego loop: 0)
				((ScriptID 21 2) setCycle: 0)
				(= seconds 2)
			)
			(4
				((ScriptID 21 3) setCycle: 0)
				((ScriptID 21 4) setCycle: 0)
				(Print
					294
					1
					#at
					-1
					12
					#width
					140
					#mode
					1
					#dispose
					#time
					10
				)
				((ScriptID 21 2) setCycle: Forward)
				(= seconds 7)
				; "Spirits of Mist
; And Creatures of Bog:
; Transform my guest
; To the shape of a Frog."
			)
			(5
				(= local0 0)
				((ScriptID 21 1) setCycle: EndLoop)
				(= seconds 2)
			)
			(6
				(ego view: 19 loop: 3 cel: 0 setCycle: EndLoop)
				((ScriptID 21 8) play:)
				((ScriptID 21 2) setCycle: 0 hide:)
				(= cycles 15)
			)
			(7
				((ScriptID 21 4) setCycle: 0)
				((ScriptID 21 1)
					setLoop: 8
					setCycle: Forward
					setMotion: Chase ego 20 self
				)
			)
			(8
				((ScriptID 21 1) setCycle: 0)
				((ScriptID 21 2)
					posn: ((ScriptID 21 1) x?) (- ((ScriptID 21 1) y?) 34)
					setPri: (+ ((ScriptID 21 1) priority?) 1)
					setCycle: Forward
					show:
				)
				(= cycles 2)
			)
			(9
				(= local0 1)
				(PrintTimedMessage 7 294 2)
				(= seconds 4)
			)
			(10
				(= local0 0)
				((ScriptID 21 2) setCycle: 0)
				((ScriptID 21 1) setLoop: 6 cel: 0 setCycle: EndLoop)
				(= seconds 3)
			)
			(11
				(= local0 1)
				(PrintTimedMessage 8 294 3)
				(= seconds 8)
			)
			(12
				((ScriptID 21 2) setCycle: Forward)
				(PrintTimedMessage 6 294 4)
				(= seconds 5)
			)
			(13
				((ScriptID 21 2) setCycle: 0)
				((ScriptID 21 3) setLoop: 5 setCycle: Forward)
				((ScriptID 21 4) setCycle: Forward)
				(= seconds 4)
			)
			(14
				((ScriptID 21 3) setCycle: 0)
				((ScriptID 21 4) setCycle: 0)
				((ScriptID 21 2) setCycle: Forward)
				(PrintTimedMessage 8 294 5)
				(= seconds 5)
			)
			(15
				(= local0 (= seconds 0))
				(= global324 3)
				((ScriptID 21 2) setCycle: 0)
				((ScriptID 21 1) setScript: (ScriptID 21 7))
				(= countdownAwaitingResponse 100)
				(User canInput: 1)
			)
			(16
				(= local0 1)
				(Print
					294
					6
					#at
					-1
					130
					#width
					250
					#mode
					1
					#dispose
					#time
					8
				)
				(= seconds 8)
				; As you make a feeble croaking sound, you try to nod your head.
			)
			(17
				((ScriptID 21 2) setCycle: Forward)
				(PrintTimedMessage 5 294 7)
				(= seconds 3)
			)
			(18
				((ScriptID 21 2) setCycle: 0)
				(= seconds 5)
			)
			(19
				((ScriptID 21 2) setLoop: 5 setCycle: Forward)
				(PrintTimedMessage 7 294 8)
				(= seconds 5)
			)
			(20
				((ScriptID 21 3) setCycle: Forward)
				((ScriptID 21 4) setCycle: Forward)
				((ScriptID 21 2) setCycle: 0)
				(= seconds 3)
			)
			(21
				((ScriptID 21 3) setCycle: 0)
				((ScriptID 21 4) setCycle: 0)
				((ScriptID 21 2) setLoop: 4 setCycle: Forward)
				(PrintTimedMessage 14 294 9)
				(= seconds 12)
			)
			(22
				((ScriptID 21 2) setCycle: 0)
				(= seconds 2)
			)
			(23
				((ScriptID 21 2) setCycle: Forward)
				(Print
					294
					10
					#at
					-1
					12
					#width
					160
					#mode
					1
					#dispose
					#time
					12
				)
				(= seconds 9)
				; "Creatures of Bog
; And Spirits of Fog:
; Return the true form
; To this rather dumb Frog."
			)
			(24
				(= local0 0)
				((ScriptID 21 2) setCycle: 0)
				((ScriptID 21 1) setCycle: EndLoop)
				(= seconds 3)
			)
			(25
				((ScriptID 21 8) play:)
				(ego setCycle: BegLoop self)
			)
			(26
				(StopEgo)
				(ego loop: 0)
				((ScriptID 21 2) setCycle: Forward)
				(= local0 1)
				(PrintTimedMessage 6 294 11)
				(= seconds 5)
			)
			(27
				(= local0 0)
				((ScriptID 21 2) hide:)
				((ScriptID 21 1) setMotion: Chase ego 10)
				(= cycles 5)
			)
			(28
				(if (ego has: invMandrakeRoot)
					((ScriptID 21 1) setPri: 9)
					((ScriptID 21 2)
						posn: ((ScriptID 21 1) x?) (- ((ScriptID 21 1) y?) 34)
						setPri: 10
						setCycle: Forward
						show:
					)
					(= local0 1)
					(AddToScore POINTS_GIVEMANDRAKEROOT 3)
					(PrintTimedMessage 5 294 12)
					(ego use: invMandrakeRoot)
					(Bclear 326)
					(= seconds 5)
				else
					((ScriptID 21 0) setScript: (ScriptID 21 6))
				)
			)
			(29
				((ScriptID 21 3) setCycle: Forward)
				((ScriptID 21 4) setCycle: Forward)
				((ScriptID 21 2) setLoop: 5)
				(PrintTimedMessage 5 294 13)
				(= seconds 4)
			)
			(30
				(= local0 0)
				((ScriptID 21 2) setCycle: 0)
				(= seconds 2)
			)
			(31
				((ScriptID 21 3) setCycle: 0)
				((ScriptID 21 4) setCycle: 0)
				((ScriptID 21 2) hide:)
				((ScriptID 21 1)
					setPri: -1
					setMotion:
						MoveTo
						(+ ((ScriptID 21 1) x?) 10)
						(- ((ScriptID 21 1) y?) 5)
						self
				)
			)
			(32
				((ScriptID 21 2)
					posn: ((ScriptID 21 1) x?) (- ((ScriptID 21 1) y?) 34)
					setPri: (+ ((ScriptID 21 1) priority?) 1)
					setLoop: 4
					setCycle: Forward
					show:
				)
				(= local0 1)
				(PrintTimedMessage 10 294 14)
				(= seconds 10)
			)
			(33
				((ScriptID 21 3) setCycle: Forward)
				((ScriptID 21 4) setCycle: Forward)
				((ScriptID 21 2) setLoop: 5)
				(PrintTimedMessage 4 294 15)
				(= seconds 4)
			)
			(34
				((ScriptID 21 2) setCycle: 0)
				(= seconds 3)
			)
			(35
				((ScriptID 21 2) setCycle: Forward)
				(PrintTimedMessage 10 294 16)
				(= seconds 12)
			)
			(36
				((ScriptID 21 2) setLoop: 4)
				(PrintTimedMessage 10 294 17)
				(= seconds 8)
			)
			(37
				((ScriptID 21 2) setCycle: 0 hide:)
				(= seconds 2)
			)
			(38
				(= local0 0)
				((ScriptID 21 1) setLoop: 6 cel: 0 setCycle: EndLoop self)
				((ScriptID 21 2)
					setLoop: 4
					posn: ((ScriptID 21 1) x?) (- ((ScriptID 21 1) y?) 34)
					setPri: (+ ((ScriptID 21 1) priority?) 1)
					show:
					setCycle: Forward
				)
				(PrintTimedMessage 4 294 18)
			)
			(39
				((ScriptID 21 2) hide:)
				((ScriptID 21 5)
					posn: (ego x?) (ego y?)
					setPri: 15
					init:
					setCycle: CycleTo 6 1 self
				)
				((ScriptID 21 8) play:)
			)
			(40
				(ego hide:)
				((ScriptID 21 5) setCycle: EndLoop)
				(= cycles 15)
			)
			(41
				(client setScript: 0)
				(curRoom newRoom: 22)
			)
		)
	)
)
