;;; Sierra Script 1.0 - (do not remove this comment)
(script# 336)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Motion)
(use User)
(use Actor)
(use System)

(public
	drinkDown 0
)

(instance drinkDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: EndLoop)
				(= cycles 10)
			)
			(1
				(switch drinkInHand
					(drinkALE
						(switch numberOfAlesDrunk
							(1
								(HighPrint 336 0)
								(= cycles 5)
							)
							(2
								(HighPrint 336 1)
								(= cycles 5)
							)
							(3
								(HighPrint 336 2)
								(client setScript: tooDrunk)
							)
						)
					)
					(drinkTROLLSWEAT
						(HighPrint 336 3)
						(client setScript: tooDrunk)
					)
					(drinkDRAGONBREATH
						(HighPrint 336 4)
						(client setScript: breathDeath)
					)
				)
			)
			(2
				(ego setCycle: BegLoop)
				(= drinkInHand drinkNOTHING)
				(User canInput: 1)
				(client setScript: 0)
				(DisposeScript 336)
			)
		)
	)
)

(instance tooDrunk of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 336)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: BegLoop)
				(= cycles 15)
			)
			(1
				(ego loop: 6 cel: 0)
				(deadMug init:)
				(gAddToPics add: deadMug doit:)
				(= cycles 2)
			)
			(2
				(switch drinkInHand
					(drinkALE (HighPrint 336 5))
					(drinkTROLLSWEAT (HighPrint 336 6))
				)
				(= cycles 2)
			)
			(3
				(ego cycleSpeed: 2 setCycle: CycleTo 6 1)
				(= cycles 25)
			)
			(4
				(ego cycleSpeed: 0 setCycle: EndLoop)
				(= cycles 20)
			)
			(5
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 16)
				(self cue:)
			)
			(6
				(AddToScore POINTS_GOTDRUNK -5)
				(Bset 118)
				(curRoom newRoom: 330)
			)
		)
	)
)

(instance breathDeath of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 336)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(Print 336 7)
				(ego loop: 5 cel: 0 cycleSpeed: 2 setCycle: CycleTo 12 1 self)
				; Ohhhhhhhhh woooowwwwwww!!!
			)
			(1
				(dust init:)
				(gAddToPics add: dust doit:)
				(ego setCycle: EndLoop self)
			)
			(2
				(Die 336 8 80 { Talk about a "fiery brew"._} 82 331 0 0)
			)
		)
	)
)

(instance deadMug of PicView
	(properties
		y 80
		x 165
		view 331
		cel 2
		priority 12
	)
)

(instance dust of PicView
	(properties
		y 89
		x 149
		view 504
		loop 2
		cel 4
		priority 15
	)
)
