;;; Sierra Script 1.0 - (do not remove this comment)
(script# 190)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	fallRug 0
)

(instance fallRug of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 190)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (== (ego loop?) 3) (ego setLoop: 1))
				(= cycles 5)
			)
			(1
				(ego setLoop: 2)
				(= cycles 5)
			)
			(2
				(ego
					view: 537
					setLoop: 0
					cel: 0
					setPri: 9
					yStep: 6
					posn: (ego x?) (+ (ego y?) 3)
				)
				((ScriptID 94 12) setCel: 1)
				(= cycles 5)
			)
			(3
				((ScriptID 94 12) dispose:)
				((ScriptID 94 0) notify: 8)
				(ego
					setPri: 9
					cycleSpeed: 5
					posn: (ego x?) (+ (ego y?) 3)
					setCycle: EndLoop self
				)
			)
			(4
				(ego posn: (ego x?) (+ (ego y?) 5))
				(= cycles 1)
			)
			(5
				(ego posn: (ego x?) (+ (ego y?) 8))
				(= cycles 1)
			)
			(6
				(ego posn: (ego x?) (+ (ego y?) 12))
				(= cycles 1)
			)
			(7
				(ego posn: (ego x?) (+ (ego y?) 13))
				(= cycles 1)
			)
			(8
				(ego posn: (ego x?) (+ (ego y?) 13))
				(= cycles 1)
			)
			(9
				(if ((ScriptID 94 0) notify: 0)
					((ScriptID 94 1) setScript: (ScriptID 94 5))
					((ScriptID 94 2) setScript: (ScriptID 94 6))
					((ScriptID 94 3) setScript: (ScriptID 94 7))
					((ScriptID 94 4) setScript: (ScriptID 94 8))
				)
				(= cycles 20)
			)
			(10
				(Die
					190
					0
					82
					536
					0
					2
					80
					{The old "rug over the pit" trick.}
				)
				(self dispose:)
			)
		)
	)
)
