;;; Sierra Script 1.0 - (do not remove this comment)
(script# 225)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	fallUpscreen 0
	fallDownscreen 1
)

(instance fallUpscreen of Script
	(properties)
	
	(method (dispose)
		(Bset 267)
		(super dispose:)
		(DisposeScript 225)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (not (Btest 259))
					((ScriptID 96 6) setCel: 3)
					((ScriptID 96 5)
						setLoop: 4
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
					)
				)
				(ego view: 536 setLoop: 0 cel: 0 setCycle: CycleTo 3 1 self)
			)
			(1
				((ScriptID 96 16)
					number: (GetSongNumber 9)
					loop: 1
					priority: 2
					play:
				)
				(ego
					setPri: (- (ego priority?) 1)
					yStep: 6
					illegalBits: 0
					setCycle: EndLoop
					setMotion: MoveTo (ego x?) 220 self
				)
			)
			(2
				(if (not (ReduceHP 5))
					(Die 225 0 80 {You're the Fall Guy again.} 82 517 2 5)
				else
					(Bclear 258)
					(Bclear 257)
					(Bset 260)
					(if (Btest 256)
						(Bclear 256)
						(ego setScript: (ScriptID 226 0))
						(if (== client (ScriptID 96 4))
							(client setPri: (+ (client priority?) 1))
						)
						(client setCel: 0 setScript: 0)
					else
						(ego setScript: (ScriptID 226 0))
					)
				)
			)
		)
	)
)

(instance fallDownscreen of Script
	(properties)
	
	(method (dispose)
		(Bset 267)
		(super dispose:)
		(DisposeScript 225)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (not (Btest 259))
					((ScriptID 96 6) setCel: 3)
					((ScriptID 96 5)
						setLoop: 4
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
					)
				)
				(ego view: 537 setLoop: 0 cel: 0 setCycle: EndLoop self)
			)
			(1
				((ScriptID 96 16)
					number: (GetSongNumber 9)
					loop: 1
					priority: 2
					play:
				)
				(ego
					setPri: (+ (ego priority?) 1)
					yStep: 12
					illegalBits: 0
					setMotion: MoveTo (ego x?) 220 self
				)
			)
			(2
				(if (not (ReduceHP 5))
					(Die 225 1 80 {You're the Fall Guy again.} 82 517 2 5)
				else
					(Bclear 258)
					(Bclear 257)
					(Bset 260)
					(if (Btest 256)
						(Bclear 256)
						(ego setScript: (ScriptID 226 0))
						(client setCel: 0 setScript: 0)
					else
						(ego setScript: (ScriptID 226 0))
					)
				)
			)
		)
	)
)
