;;; Sierra Script 1.0 - (do not remove this comment)
(script# 230)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	talksAlot 0
	knockout 1
)

(instance talksAlot of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 230)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 43 188 self)
			)
			(1 (ego loop: 2) (= cycles 2))
			(2
				(HighPrint 230 0)
				(ego setMotion: MoveTo 43 179 self)
			)
			(3
				(ego illegalBits: cWHITE)
				(HighPrint 230 1)
				(HighPrint 230 2)
				(HighPrint 230 3)
				(HighPrint 230 4)
				(HighPrint 230 5)
				(HighPrint 230 6)
				(HighPrint 230 7)
				(self cue:)
			)
			(4 (UnlockEgo) (self dispose:))
		)
	)
)

(instance knockout of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 230)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 73 117 self)
			)
			(1
				(ego view: 296 setLoop: 7 setCel: 0)
				(= cycles 8)
			)
			(2
				((ScriptID 96 7)
					setPri: (+ (ego priority?) 1)
					setCel: 1
				)
				(= cycles 2)
			)
			(3
				((ScriptID 96 7)
					setPri: (- ((ScriptID 96 7) priority?) 1)
					setCel: 2
				)
				(ego setCel: 1)
				(= cycles 2)
				(if (not (Btest 259))
					((ScriptID 96 6) setCel: 3)
					((ScriptID 96 5)
						setLoop: 4
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
					)
				)
			)
			(4
				((ScriptID 96 16)
					number: (GetSongNumber 85)
					loop: 1
					priority: 2
					play:
				)
				((ScriptID 96 7) setCel: 3)
				(ego posn: 91 111 setCel: 2)
				(= cycles 2)
			)
			(5
				((ScriptID 96 7) setCel: 4)
				(ego posn: 109 107 setCel: 3)
				(= cycles 2)
			)
			(6
				((ScriptID 96 7) setCel: 5)
				(ego setPri: 7 posn: 126 119 setCel: 4)
				(= cycles 2)
			)
			(7
				((ScriptID 96 7) setCel: 0 stopUpd:)
				(ego posn: 137 137)
				(= cycles 2)
			)
			(8
				(ego posn: 152 161)
				(= cycles 2)
			)
			(9
				(ego posn: 160 189)
				(if (not (ReduceHP 5))
					(Die 230 8 80 {You're the Fall Guy again} 82 517 2 5)
				else
					(= cycles 10)
				)
			)
			(10
				(Bclear 258)
				(Bclear 257)
				(Bset 260)
				(ego setScript: (ScriptID 226 0))
				(client setScript: 0)
			)
		)
	)
)
