;;; Sierra Script 1.0 - (do not remove this comment)
(script# 216)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use System)

(public
	egoFight 0
)

(instance egoFight of Script
	(properties)
	
	(method (doit)
		(if
			(or
				(and (client fightLeft?) (> (client x?) 300))
				(and (not (client fightLeft?)) (< (client x?) 20))
			)
			(client gotBeat: (ScriptID 223 1))
		else
			(super doit:)
		)
	)
	
	(method (dispose)
		(gDirHandler release:)
		(super dispose:)
		(DisposeScript 216)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client drawWeapons:)
				(gDirHandler addToFront: client)
				(= cycles 1)
			)
			(1
				(client
					canFight: 1
					action: 0
					cycleSpeed: 0
					moveSpeed: 0
					stopUpd:
					getTired: 4 (ScriptID 223 1)
				)
			)
			(2
				(if ((client opponent?) endFight?)
					(client setScript: 0)
				else
					(= cycles 5)
				)
			)
			(3
				(ego hide:)
				(self changeState: 1)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (or script (not (client canFight?)))
			(pEvent claimed: 1)
			(return)
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look') (HighPrint 216 0))
					((Said 'escape,escape,run') (HighPrint 216 1))
					((Said 'cast') (HighPrint 216 2))
					((Said 'chat,ask') (HighPrint 216 3))
					((Said 'fight,use[/blade]') (HighPrint 216 4))
					((Said 'kill,chop') (HighPrint 216 5))
					(else (HighPrint 216 6) (pEvent claimed: 1))
				)
			)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP
						(if (client canFight?)
							(client canFight: 0)
							(switch (Random 0 1)
								(0
									(self setScript: (Clone (ScriptID 217 2)) self client)
								)
								(1
									(self setScript: (Clone (ScriptID 217 3)) self client)
								)
							)
							(TestSkill skWEAPONUSE 0 20)
							(if (client tryAttack: (client opponent?))
								((client opponent?) getHit:)
							)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_LEFT
						(if (client canFight?)
							(TestSkill skDODGE 0 20)
							(client canFight: 0)
							(self setScript: (Clone (ScriptID 217 0)) self client)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_RIGHT
						(if (client canFight?)
							(TestSkill skDODGE 0 20)
							(client canFight: 0)
							(self setScript: (Clone (ScriptID 217 1)) self client)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_DOWN
						(if (client canFight?)
							(client canFight: 0)
							(TestSkill skPARRY 0 20)
							(if (== ((client opponent?) action?) 2)
								(self setScript: (Clone (ScriptID 217 5)) self client)
							else
								(self setScript: (Clone (ScriptID 217 4)) self client)
							)
						else
							(pEvent claimed: 1)
						)
					)
				)
				(pEvent claimed: 1)
			)
		)
	)
)
