;;; Sierra Script 1.0 - (do not remove this comment)
(script# 132)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ErasmusTower)
(use Motion)
(use System)

(public
	openTalk 0
	fetchTalk 1
	triggerTalk 2
	dazzleTalk 3
	trapTalk 4
	goGame 5
)

(instance openTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 132 0)
			)
			(1 (ErasmusPrint 7 132 1))
			(2 (FenrusPrint 5 132 2))
			(3 (ErasmusPrint 4 132 3))
			(4 (FenrusPrint 4 132 4))
			(5
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(6
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance fetchTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 132 5)
			)
			(1 (ErasmusPrint 5 132 6))
			(2 (FenrusPrint 4 132 7))
			(3 (ErasmusPrint 6 132 8))
			(4 (FenrusPrint 5 132 9))
			(5 (ErasmusCastTeleport))
		)
	)
)

(instance triggerTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 9 132 10)
			)
			(1 (ErasmusPrint 9 132 11))
			(2 (ErasmusPrint 6 132 12))
			(3 (ErasmusPrint 7 132 13))
			(4 (ErasmusPrint 7 132 14))
			(5 (ErasmusCastTeleport))
		)
	)
)

(instance dazzleTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 5 132 15)
			)
			(1 (ErasmusPrint 6 132 16))
			(2 (ErasmusPrint 10 132 17))
			(3 (ErasmusCastTeleport))
		)
	)
)

(instance trapTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 8 132 18)
			)
			(1 (ErasmusPrint 9 132 19))
			(2 (FenrusPrint 7 132 20))
			(3
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 12)
			)
			(4
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
				(ego setCel: 2)
				(ErasmusPrint 5 132 21)
			)
			(5 (ErasmusCastTeleport))
		)
	)
)

(instance goGame of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 132)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				((ScriptID 31 3)
					cycleSpeed: 0
					cel: 0
					posn: 160 102
					setPri: 14
					setCycle: EndLoop self
				)
			)
			(1
				(ego setCel: 0)
				((ScriptID 31 9)
					setLoop: 0
					setCel: 0
					setMotion: MoveTo 143 119
					startUpd:
				)
				((ScriptID 31 10)
					setLoop: 0
					setCel: 0
					setMotion: MoveTo 178 119 self
					startUpd:
				)
			)
			(2 (curRoom newRoom: 32))
		)
	)
)
