;;; Sierra Script 1.0 - (do not remove this comment)
(script# 133)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ErasmusTower)
(use Motion)
(use System)

(public
	eranaTalk 0
	peaceTalk 1
	zaraTalk 2
	babaTalk 3
	curseTalk 4
	counterCurseTalk 5
	fenrusTalk 6
	hermitTalk 7
	initiationTalk 8
)

(instance eranaTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 5 133 0)
			)
			(1 (ErasmusPrint 9 133 1))
			(2 (ErasmusPrint 9 133 2))
			(3 (FenrusPrint 8 133 3))
			(4
				(= global311 1)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 6)
			)
			(5
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
				(ErasmusPrint 10 133 4)
			)
			(6
				(= global312 1)
				(client setScript: 0)
			)
		)
	)
)

(instance peaceTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 9 133 5)
			)
			(1 (ErasmusPrint 9 133 6))
			(2 (ErasmusPrint 5 133 7))
			(3 (FenrusPrint 4 133 8))
			(4
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(5
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance zaraTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 9 133 9)
			)
			(1 (ErasmusPrint 6 133 10))
			(2 (FenrusPrint 8 133 11))
			(3 (FenrusPrint 5 133 12))
			(4
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(5
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance babaTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 9 133 13)
			)
			(1 (ErasmusPrint 6 133 14))
			(2 (FenrusPrint 4 133 15))
			(3 (ErasmusPrint 7 133 16))
			(4 (FenrusPrint 5 133 17))
			(5
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(6
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance curseTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 133 18)
			)
			(1 (ErasmusPrint 10 133 19))
			(2 (ErasmusPrint 7 133 20))
			(3 (ErasmusCastTeleport))
		)
	)
)

(instance counterCurseTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 10 133 21)
			)
			(1 (ErasmusPrint 8 133 22))
			(2 (HeroPrint 133 23))
			(3 (HeroPrint 133 24))
			(4 (HeroPrint 133 25))
			(5 (HeroPrint 133 26))
			(6 (ErasmusPrint 11 133 27))
			(7 (FenrusPrint 8 133 28))
			(8 (ErasmusCastTeleport))
		)
	)
)

(instance fenrusTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(FenrusPrint 9 133 29)
			)
			(1 (ErasmusPrint 6 133 30))
			(2 (ErasmusCastTeleport))
		)
	)
)

(instance hermitTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 133 31)
			)
			(1 (FenrusPrint 6 133 32))
			(2 (ErasmusPrint 8 133 33))
			(3 (ErasmusPrint 5 133 34))
			(4 (FenrusPrint 5 133 35))
			(5 (ErasmusCastTeleport))
		)
	)
)

(instance initiationTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 133)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 133 36)
			)
			(1 (ErasmusCastTeleport))
		)
	)
)
