;;; Sierra Script 1.0 - (do not remove this comment)
(script# 134)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ErasmusTower)
(use Motion)
(use System)

(public
	mirrorTalk 0
	wizardTalk 1
	poopTalk 2
	deadTalk 3
	magicTalk 4
	gameTalk 5
)

(instance mirrorTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 10 134 0)
			)
			(1 (FenrusPrint 5 134 1))
			(2 (ErasmusPrint 5 134 2))
			(3 (FenrusPrint 6 134 3))
			(4
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 12)
			)
			(5
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
				(ego setCel: 2)
				(ErasmusPrint 11 134 4)
			)
			(6 (ErasmusPrint 8 134 5))
			(7 (FenrusPrint 8 134 6))
			(8 (ErasmusPrint 4 134 7))
			(9 (ErasmusPrint 8 134 8))
			(10 (ErasmusCastTeleport))
		)
	)
)

(instance wizardTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 7 134 9)
			)
			(1 (ErasmusPrint 10 134 10))
			(2 (ErasmusPrint 5 134 11))
			(3 (ErasmusPrint 7 134 12))
			(4 (FenrusPrint 5 134 13))
			(5 (ErasmusPrint 5 134 14))
			(6 (FenrusPrint 6 134 15))
			(7
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 12)
			)
			(8
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
				(ego setCel: 2)
				(ErasmusCastTeleport)
			)
		)
	)
)

(instance poopTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 5 134 16)
			)
			(1 (FenrusPrint 5 134 17))
			(2
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(3
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance deadTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(FenrusPrint 7 134 18)
			)
			(1 (ErasmusPrint 5 134 19))
			(2 (ErasmusPrint 6 134 20))
			(3 (FenrusPrint 5 134 21))
			(4 (ErasmusPrint 7 134 22))
			(5 (FenrusPrint 4 134 23))
			(6 (FenrusPrint 4 134 24))
			(7
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(8
				(ErasmusCastTeleport)
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
			)
		)
	)
)

(instance magicTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 6 134 25)
			)
			(1 (FenrusPrint 8 134 26))
			(2 (ErasmusPrint 3 134 27))
			(3 (ErasmusPrint 6 134 28))
			(4 (FenrusPrint 5 134 29))
			(5 (ErasmusPrint 9 134 30))
			(6 (FenrusPrint 7 134 31))
			(7 (ErasmusPrint 6 134 32))
			(8 (FenrusPrint 3 134 33))
			(9 (ErasmusPrint 4 134 34))
			(10 (FenrusPrint 4 134 35))
			(11
				(= global311 1)
				(ego setCel: 3)
				((ScriptID 31 4)
					cycleSpeed: 0
					setLoop: 6
					setCel: -1
					setCycle: Forward
				)
				(= cycles 8)
			)
			(12
				(= global311 0)
				((ScriptID 31 4)
					cycleSpeed: 1
					setLoop: 5
					setCel: 0
					setCycle: 0
				)
				(ErasmusCastTeleport)
			)
		)
	)
)

(instance gameTalk of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 134)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global312 0)
				(ErasmusPrint 11 134 36)
			)
			(1 (FenrusPrint 5 134 37))
			(2 (ErasmusPrint 5 134 38))
			(3 (ErasmusPrint 9 134 39))
			(4 (ErasmusPrint 9 134 40))
			(5 (ErasmusCastTeleport))
		)
	)
)
