;;; Sierra Script 1.0 - (do not remove this comment)
(script# 166)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Actor)
(use System)

(public
	merchant 0
)

(local
	local0
	local1
	local2
)
(procedure (localproc_000c)
	(HighPrint 166 0)
)

(instance merchant of Prop
	(properties
		view 302
		loop 1
	)
	
	(method (init)
		(self posn: 109 129 setPri: 12 ignoreActors: stopUpd:)
		(mLegs init:)
		(mMug init:)
		(gAddToPics add: mLegs mMug doit:)
		(super init:)
	)
	
	(method (doit)
		(if
		(and (ego inRect: 40 135 160 180) (not local0))
			(= local0 1)
			(merchant setScript: emotionalMerchant)
		)
		(super doit:)
	)
	
	(method (dispose)
		(mLegs dispose:)
		(mMug dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl self pEvent 3)
					(HighPrint 166 1)
				)
			)
			(evSAID
				(if (ego inRect: 40 135 160 180)
					(if
						(not
							(if (Btest 301)
								(< ((ScriptID 301 2) distanceTo: ego) 30)
							)
						)
						(cond 
							((Said 'gave,offer/breakfast,food,ration')
								(cond 
									((== foodOrdered mealATTABLE)
										(AddToScore POINTS_GIVEABDULAFOOD 2)
										(= local2 8)
										(= foodOrdered mealFINISHED)
										(HighPrint 166 2)
										(= teaOrdered mealFINISHED)
										(HighPrint 166 3)
										(emotionalMerchant changeState: 1)
									)
									((ego has: invFoodRation)
										(AddToScore POINTS_GIVEABDULAFOOD 2)
										(HighPrint 166 4)
										(-- [invNum invFoodRation])
										(= local2 8)
										(emotionalMerchant changeState: 1)
									)
									(else (HighPrint 166 5))
								)
							)
							((Said 'gave,offer/drink')
								(if (== teaOrdered mealATTABLE)
									(AddToScore POINTS_GIVEABDULAFOOD 2)
									(= local2 8)
									(= teaOrdered mealFINISHED)
									(HighPrint 166 6)
									(emotionalMerchant changeState: 1)
								else
									(HighPrint 166 5)
								)
							)
							((Said 'gave,offer/alm,silver,gold')
								(if (GiveSilverCoins 1)
									(GiveSilverCoins 9)
									(AddToScore POINTS_GIVEABDULAFOOD 2)
									(= local2 8)
									(emotionalMerchant changeState: 1)
								)
							)
							((Said 'chat/man,abdulla') (HighPrint 166 0))
							((Said 'look/turban') (HighPrint 166 7))
							((Said 'look/hat') (HighPrint 166 8))
							((Said 'ask>')
								(= local1 1)
								(cond 
									((Said '/bandit,robbery') (= local2 1) (emotionalMerchant changeState: 1))
									(
									(or (Said '/leader') (Said '/face,voice<leader')) (HighPrint 166 9))
									((Said '/cloak') (HighPrint 166 10))
									((Said '/warlock,mage') (HighPrint 166 11))
									((Said '/wizard') (HighPrint 166 12))
									((Said '/turban') (= local1 0) (HighPrint 166 13))
									((Said '/hat') (= local1 0) (HighPrint 166 14))
									((Said '/name,abdulla') (HighPrint 166 15))
									((Said '/friend') (HighPrint 166 16))
									((Said '/ali,dad,grandfather') (HighPrint 166 17))
									((Said '/desert,home,sand,sun') (= local2 4) (emotionalMerchant changeState: 1))
									((Said '/danger,time') (HighPrint 166 18))
									((Said '/drygoods,possession') (HighPrint 166 19))
									((Said '/valley,pass') (HighPrint 166 20))
									(
										(Said
											'/katta,cat,shema,shameen,kindness,innkeeper,owner,keeper'
										)
										(HighPrint 166 21)
									)
									((Said '/magic') (= local2 6) (emotionalMerchant changeState: 1))
									((Said '/guard,assistant') (= local2 7) (emotionalMerchant changeState: 1))
									((or (Said '/bull,bull') (Said '/head<bull')) (HighPrint 166 22))
									((Said '/*') (= local1 0) (localproc_000c))
								)
								(if local1 (AddToScore POINTS_TALKTOABDULA 5))
							)
						)
					)
				)
			)
		)
	)
)

(instance emotionalMerchant of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(merchant setLoop: 1 cel: 0 setCycle: EndLoop self)
			)
			(1
				(merchant setLoop: 0 cel: 0 setCycle: EndLoop)
				(= cycles 5)
			)
			(2
				(merchant setLoop: 0 cel: 2)
				(= cycles 2)
			)
			(3
				(merchant setLoop: 0 cel: 3)
				(= cycles 2)
			)
			(4
				(merchant setCycle: BegLoop self)
			)
			(5
				(merchant setLoop: 1 cel: 4 stopUpd:)
				(= cycles 2)
			)
			(6
				(switch local2
					(0 (self changeState: 7))
					(1
						(HighPrint 166 23)
						(++ local2)
						(self changeState: 1)
					)
					(2
						(HighPrint 166 24)
						(++ local2)
						(self changeState: 1)
					)
					(3 (HighPrint 166 25))
					(4
						(HighPrint 166 26)
						(++ local2)
						(self changeState: 1)
					)
					(5 (HighPrint 166 27))
					(6 (HighPrint 166 28))
					(7 (HighPrint 166 29))
					(8
						(HighPrint 166 30)
						(if (not (Btest 347))
							(= local2 9)
							(Bset 347)
							(self changeState: 1)
						)
					)
					(9
						(HighPrint 166 31)
						(= local2 10)
						(self changeState: 1)
					)
					(10 (HighPrint 166 32))
				)
			)
			(7
				(merchant stopUpd:)
				(if (not (Btest 116))
					(Bset 116)
					(HighPrint 166 33)
				else
					(HighPrint 166 34)
				)
			)
		)
	)
)

(instance mLegs of PicView
	(properties
		y 148
		x 110
		view 302
		loop 3
	)
)

(instance mMug of PicView
	(properties
		y 131
		x 96
		view 301
		loop 5
		cel 3
		priority 12
	)
)
