;;; Sierra Script 1.0 - (do not remove this comment)
(script# 120)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Chase)
(use Motion)
(use System)

(public
	bouncer 0
	bounceBack 1
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	[local6 11]
	[local17 11]
)
(procedure (localproc_000e)
	(= local0 (- ((ScriptID 15 1) x?) (ego x?)))
	(= local1 (- ((ScriptID 15 1) y?) (ego y?)))
	(= local2 (+ (ego x?) (* local0 10)))
	(= local3 (+ (ego y?) (* local1 10)))
)

(instance bouncer of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(= [local6 0] 17)
		(= [local17 0] 47)
		(= [local6 1] 44)
		(= [local17 1] 155)
		(= [local6 2] 17)
		(= [local17 2] 134)
		(= [local6 3] 244)
		(= [local17 3] 51)
		(= [local6 4] 283)
		(= [local17 4] 124)
		(= [local6 5] 316)
		(= [local17 5] 212)
		(= [local6 6] 101)
		(= [local17 6] 47)
		(= [local6 7] 183)
		(= [local17 7] 145)
		(= [local6 8] 102)
		(= [local17 8] 161)
		(= [local6 9] 251)
		(= [local17 9] 186)
		(= [local6 10] 169)
		(= [local17 10] 55)
	)
	
	(method (doit)
		(if
			(and
				local4
				(not ((ScriptID 15 6) inRect: 10 35 310 205))
			)
			(= local4 0)
			(self cue:)
		)
		(if (ego script?) (self dispose:))
		(super doit:)
	)
	
	(method (dispose)
		((ScriptID 15 6) setCycle: 0 posn: 0 1000)
		(super dispose:)
		(DisposeScript 120)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local5 (Random 3 5))
				(if (not (Btest 152))
					((ScriptID 15 6) posn: (ego x?) (ego y?))
				)
				(self cue:)
			)
			(1
				(if (not (Btest 152))
					(= local4 1)
					(localproc_000e)
					((ScriptID 15 6)
						show:
						setLoop: 2
						setStep: 24 16
						setCycle: Forward
						startUpd:
						setMotion: MoveTo local2 local3
					)
				else
					(self cue:)
				)
			)
			(2
				(if (not (Btest 152))
					(self cue:)
				else
					(localproc_000e)
					(= local4 1)
					((ScriptID 15 6) setMotion: MoveTo local2 local3)
				)
			)
			(3
				((ScriptID 15 5)
					ignoreActors:
					cel: 0
					setPri: 12
					posn: ((ScriptID 15 6) x?) ((ScriptID 15 6) y?)
					setCycle: EndLoop
				)
				(= local5 (+ local5 (Random 1 3)))
				((ScriptID 15 6)
					setMotion: MoveTo [local6 local5] [local17 local5] self
				)
			)
			(4
				(if (< local5 10)
					(self changeState: 3)
				else
					(self cue:)
				)
			)
			(5
				((ScriptID 15 6)
					setLoop: 3
					cel: 0
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			(6
				((ScriptID 15 6) setScript: 0)
			)
		)
	)
)

(instance bounceBack of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 120)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 15 6)
					posn: (ego x?) (ego y?)
					show:
					setLoop: 2
					setStep: 24 16
					setCycle: Forward
					startUpd:
					setMotion: Chase (ScriptID 15 1) 0 self
				)
			)
			(1
				((ScriptID 15 6) setMotion: Chase ego 0 self)
			)
			(2
				((ScriptID 15 6)
					view: 532
					setLoop: 4
					cel: 0
					setMotion: 0
					setCycle: EndLoop self
				)
				((ScriptID 15 12) play:)
			)
			(3
				((ScriptID 15 6) view: 522 setLoop: 3 cel: 4)
				(if (not (ego script?)) (Bset 290))
				(client setScript: 0)
			)
		)
	)
)
