;;; Sierra Script 1.0 - (do not remove this comment)
(script# 127)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use System)

(public
	Dodge 0
	Duck 1
	Thrust 2
)

(instance Dodge of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 127)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 1 else 0)
					setCel: 1
					setMotion: 0
					setCycle: 0
				)
				(= cycles 10)
			)
			(1
				(Bset 318)
				(ego setCel: 0)
				(self dispose:)
			)
		)
	)
)

(instance Duck of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(Bset 318)
		(DisposeScript 127)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 1 else 0)
					setCel: 2
					setMotion: 0
					setCycle: 0
				)
				(= cycles 10)
			)
			(1
				(ego setCel: 0)
				(self dispose:)
			)
		)
	)
)

(instance Thrust of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(Bset 318)
		(DisposeScript 127)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 3 else 2)
					setCel: 0
					setMotion: 0
					setCycle: 0
				)
				(= cycles 2)
			)
			(1
				(ego setCel: 1)
				(if
					(and
						(>= global344 (RollDice))
						(!= ((ScriptID 15 1) script?) (ScriptID 118 1))
					)
					(Bset 319)
					(= global343 (- global343 global345))
				)
				(= cycles 2)
			)
			(2
				(ego setCel: 0)
				(= cycles 2)
			)
			(3
				(ego setLoop: (if (Btest 149) 1 else 0) setCel: 0)
				(self dispose:)
			)
		)
	)
)
