;;; Sierra Script 1.0 - (do not remove this comment)
(script# 121)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use User)
(use System)

(public
	drawWeapon 0
	putWeaponAway 1
)

(instance drawWeapon of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(Bclear 350)
		(DisposeScript 121)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 350)
				(UnlockEgo)
				(User canControl: 0 canInput: 0)
				(if (< (ego y?) 105)
					(ego illegalBits: 0 setMotion: MoveTo 172 94 self)
				else
					(ego illegalBits: 0 setMotion: MoveTo 160 (ego y?) self)
				)
			)
			(1
				(if (< (ego x?) 172)
					(ego setMotion: MoveTo 172 94 self)
				else
					(self cue:)
				)
			)
			(2
				(cond 
					((ego has: invBroadsword) (if (Btest 149) (ego setLoop: 1) else (ego setLoop: 0)))
					((Btest 149) (ego setLoop: 3))
					(else (ego setLoop: 2))
				)
				(ego view: 502 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(3
				(if (ego has: invBroadsword)
					(ego
						view: 501
						setLoop: (if (Btest 149) 1 else 0)
						setCel: 0
						cycleSpeed: 0
						stopUpd:
					)
				else
					(ego
						view: 512
						setLoop: (if (Btest 149) 1 else 0)
						cel: 0
						cycleSpeed: 0
						stopUpd:
					)
				)
				(= cycles 2)
			)
			(4 (Bset 308) (self dispose:))
		)
	)
)

(instance putWeaponAway of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(UnlockEgo)
		(DisposeScript 121)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego view: 502)
				(cond 
					((ego has: invBroadsword) (if (Btest 149) (ego setLoop: 1) else (ego setLoop: 0)))
					((Btest 149) (ego setLoop: 3))
					(else (ego setLoop: 2))
				)
				(ego cel: (- (NumCels ego) 1) setCycle: BegLoop self)
			)
			(1
				(if (and (< [skills skMAGIC] 10) (not (ego has: invBroadsword)))
					(ego setLoop: (if (Btest 149) 5 else 4))
					(ego
						cel: (- (NumCels ego) 1)
						cycleSpeed: 1
						setCycle: BegLoop self
					)
				else
					(self cue:)
				)
			)
			(2 (Bclear 315) (= cycles 2))
			(3
				(StopEgo)
				(ego loop: (if (Btest 149) 1 else 0))
				(self dispose:)
			)
		)
	)
)
