;;; Sierra Script 1.0 - (do not remove this comment)
(script# 124)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Actor)
(use System)

(public
	egoFetch 0
)

(instance lasso of Actor
	(properties
		view 520
		illegalBits $0000
	)
)

(instance egoFetch of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 124)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego view: 520 setLoop: 1 cel: 0)
				(= cycles 5)
			)
			(1 (ego setCycle: EndLoop self))
			(2
				(lasso
					ignoreActors:
					illegalBits: 0
					posn: (+ (ego x?) 2) (- (ego y?) 36)
					setLoop: 5
					setPri: 7
					setStep: 20 10
					setCycle: Forward
					init:
					setMotion:
						MoveTo
						((ScriptID 15 2) x?)
						(- ((ScriptID 15 2) y?) 10)
						self
				)
			)
			(3
				(lasso
					setPri: 11
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 36) self
				)
				((ScriptID 15 7)
					ignoreActors:
					illegalBits: 0
					posn: ((ScriptID 15 2) x?) (- ((ScriptID 15 2) y?) 10)
					init:
					setLoop: 7
					setCel: 0
					setPri: 11
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 36)
				)
			)
			(4 (= seconds 2))
			(5
				(lasso hide:)
				((ScriptID 15 7) hide:)
				(ego setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(6
				(HighPrint 124 0)
				(Bset 165)
				(StopEgo)
				(ego get: invLargeBrassKey loop: 1)
				(= global321 2)
				(AddToScore POINTS_TAKEKOBOLDKEY 7)
				(= cycles 2)
			)
			(7
				(lasso dispose:)
				((ScriptID 15 7) hide:)
				(= cycles 2)
			)
			(8 (UnlockEgo) (self dispose:))
		)
	)
)
