;;; Sierra Script 1.0 - (do not remove this comment)
(script# 126)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use User)
(use System)

(public
	egoFight 0
)

(instance egoFight of Script
	(properties)
	
	(method (doit)
		(cond 
			(
			(and (Btest 318) (Btest 313) (not (self script?)))
				(Bclear 318)
				(if (ego has: invBroadsword)
					(self setScript: (ScriptID 114 1))
				else
					(self setScript: (ScriptID 114 0))
				)
			)
			(
				(and
					global343
					(Btest 319)
					(not ((ScriptID 15 1) script?))
					(not (self script?))
				)
				(Bclear 319)
				(if (Btest 149) (Bset 320) else (Bclear 320))
				(Bset 285)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gDirHandler release:)
		(ego illegalBits: cWHITE)
		(super dispose:)
		(DisposeScript 126)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego illegalBits: 0)
				(User canInput: 1)
				(gDirHandler addToFront: client)
				(= cycles 2)
			)
			(1
				(Bset 318)
				(client cycleSpeed: 0 moveSpeed: 0)
			)
			(2
				(if (<= global343 0)
					(Bset 283)
					(Bset 311)
					(ego illegalBits: cWHITE)
					(self dispose:)
				else
					(= cycles 5)
				)
			)
			(3
				(Bclear 316)
				(self changeState: 1)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (or script ((ScriptID 15 1) script?))
			(pEvent claimed: 1)
			(return)
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look/kobold,creature,monster,man,wizard') (HighPrint 126 0))
					((Said 'look') (HighPrint 126 1))
					((Said 'escape,escape,run') (HighPrint 126 2))
					((Said 'cast') (pEvent claimed: 0))
					((Said 'ask') (HighPrint 126 3))
					((Said 'fight,kill,beat,chop') (HighPrint 126 4))
					((Said 'use/blade,dagger,shield') (HighPrint 126 5))
					((Said 'throw') (HighPrint 126 6))
					(else (HighPrint 126 7) (pEvent claimed: 1))
				)
			)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP
						(if ((ScriptID 15 4) script?)
							((ScriptID 15 4) setScript: 0)
						)
						(if
							(and
								(Btest 318)
								(not (Btest 314))
								(not (self script?))
							)
							(Bclear 318)
							(Bset 316)
							(if (ego has: invBroadsword)
								(switch (Random 0 1)
									(0
										(self setScript: (ScriptID 127 2) self client)
									)
									(1
										(self setScript: (ScriptID 113 0) self client)
									)
								)
							else
								(self setScript: (ScriptID 128 3) self client)
							)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_LEFT
						(if ((ScriptID 15 4) script?)
							((ScriptID 15 4) setScript: 0)
						)
						(if
							(and
								(Btest 318)
								(not (Btest 314))
								(not (self script?))
							)
							(Bclear 318)
							(Bset 316)
							(if (ego has: invBroadsword)
								(self setScript: (ScriptID 127 0) self client)
							else
								(self setScript: (ScriptID 128 0) self client)
							)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_RIGHT
						(if ((ScriptID 15 4) script?)
							((ScriptID 15 4) setScript: 0)
						)
						(if
							(and
								(Btest 318)
								(not (Btest 314))
								(not (self script?))
							)
							(Bclear 318)
							(Bset 316)
							(if (ego has: invBroadsword)
								(self setScript: (ScriptID 127 1) self client)
							else
								(self setScript: (ScriptID 128 1) self client)
							)
						else
							(pEvent claimed: 1)
						)
					)
					(JOY_DOWN
						(if ((ScriptID 15 4) script?)
							((ScriptID 15 4) setScript: 0)
						)
						(if
							(and
								(Btest 318)
								(not (Btest 314))
								(not (self script?))
							)
							(Bclear 318)
							(Bset 316)
							(if (ego has: invBroadsword)
								(self setScript: (ScriptID 113 1) self client)
							else
								(self setScript: (ScriptID 128 2) self client)
							)
						else
							(pEvent claimed: 1)
						)
					)
				)
				(pEvent claimed: 1)
			)
		)
	)
)
