;;; Sierra Script 1.0 - (do not remove this comment)
(script# 119)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Chase)
(use Motion)
(use System)

(public
	flameDart 0
)

(local
	local0
	local1
)
(instance flameDart of Script
	(properties)
	
	(method (init &tmp [temp0 100])
		(if ((ScriptID 15 6) script?)
			((ScriptID 15 6) setScript: 0)
		)
		(super init: &rest)
		(= local0
			(TestSkill
				skMAGIC
				0
				(- 30 (/ (ego distanceTo: (ScriptID 15 1)) 5))
			)
		)
	)
	
	(method (dispose)
		(if
			(and
				(not ((ScriptID 15 6) script?))
				(== ((ScriptID 15 6) loop?) 2)
			)
			(Bset 287)
		)
		(super dispose:)
		(DisposeScript 119)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					view: 522
					setLoop: (if (< (ego x?) ((ScriptID 15 1) x?)) 0 else 1)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(ego setCycle: EndLoop)
				((ScriptID 15 10) play:)
				(cond 
					((Btest 153) (= local1 0))
					((or (Btest 157) local0) (= local1 1))
					(else (= local1 2))
				)
				(switch local1
					(0
						(Bset 288)
						(self changeState: 3)
					)
					(1
						((ScriptID 15 6)
							setLoop: 2
							posn: (ego x?) (ego y?)
							show:
							setCycle: Forward
							startUpd:
						)
						(if (< koboldStatus 2)
							((ScriptID 15 6)
								setMotion:
									MoveTo
									((ScriptID 15 2) x?)
									(+ ((ScriptID 15 2) y?) 10)
									self
							)
						else
							((ScriptID 15 6)
								setMotion: Chase (ScriptID 15 1) 0 self
							)
						)
					)
					(2
						(Bset 287)
						(self changeState: 3)
					)
				)
			)
			(2
				(if
					(or
						(== ((ScriptID 15 1) script?) (ScriptID 123 1))
						(not ((ScriptID 15 1) script?))
					)
					(DisposeScript 123)
					(Bclear 216)
					(Bclear 152)
					((ScriptID 15 12) play:)
					((ScriptID 15 6)
						view: 532
						setLoop: 0
						cel: 0
						setCycle: EndLoop self
					)
					(if (Btest 157)
						(= koboldStatus 2)
						(Bset 297)
					else
						(Bset 282)
					)
				else
					(Bset 152)
					(Bset 287)
					(self cue:)
				)
			)
			(3
				(if (not (Btest 152))
					((ScriptID 15 6) view: 522 setLoop: 3 cel: 4)
				)
				(StopEgo)
				(FaceObject ego (ScriptID 15 1))
				(if local1 (UnlockEgo))
				(if
					(and
						(not ((ScriptID 15 1) script?))
						(not ((ScriptID 15 4) script?))
						(Btest 157)
					)
					(= koboldStatus 2)
					(Bset 297)
				)
				(client setScript: 0)
			)
		)
	)
)
