;;; Sierra Script 1.0 - (do not remove this comment)
(script# 115)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Chase)
(use Motion)
(use User)
(use System)

(public
	lightning 0
)

(instance lightning of Script
	(properties)
	
	(method (init)
		(if ((ScriptID 15 4) script?)
			((ScriptID 15 4) setScript: 0)
		)
		(super init: &rest)
		(Bset 314)
		(= global347
			(- 80 (/ (ego distanceTo: (ScriptID 15 1)) 6))
		)
	)
	
	(method (dispose)
		(if
			(and
				(not ((ScriptID 15 4) script?))
				(== ((ScriptID 15 4) loop?) 5)
			)
			(Bset 281)
		)
		(super dispose:)
		(Bclear 314)
		(DisposeScript 115)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canInput: 0)
				((ScriptID 15 1)
					view: 177
					setMotion: 0
					cycleSpeed: 0
					setCycle: EndLoop self
				)
			)
			(1
				(if (Btest 307) (Bclear 307) (HighPrint 115 0))
				((ScriptID 15 1) stopUpd:)
				((ScriptID 15 11) play:)
				(if (>= global347 (RollDice)) (Bset 339))
				(if (and (Btest 339) (not (Btest 317)))
					((ScriptID 15 4)
						setLoop: 5
						posn:
							(switch ((ScriptID 15 1) loop?)
								(0
									(- ((ScriptID 15 1) x?) 24)
								)
								(1
									(+ ((ScriptID 15 1) x?) 24)
								)
								(2
									(- ((ScriptID 15 1) x?) 17)
								)
								(3
									(+ ((ScriptID 15 1) x?) 17)
								)
								(4 (- ((ScriptID 15 1) x?) 5))
							)
							(switch ((ScriptID 15 1) loop?)
								(0 (+ ((ScriptID 15 1) y?) 6))
								(1 (+ ((ScriptID 15 1) y?) 6))
								(2
									(+ ((ScriptID 15 1) y?) 10)
								)
								(3
									(+ ((ScriptID 15 1) y?) 10)
								)
								(4
									(+ ((ScriptID 15 1) y?) 13)
								)
							)
						show:
						forceUpd:
					)
					(self cue:)
				else
					(Bset 281)
					(Bset 344)
				)
			)
			(2
				(User canInput: 1)
				(if (not ((ScriptID 15 4) script?))
					((ScriptID 15 4)
						setCycle: Forward
						startUpd:
						setMotion: Chase ego 0 self
					)
				else
					(self cue:)
				)
			)
			(3
				(if (and (ego script?) (not (Btest 315)))
					(Bset 151)
					(Bset 281)
					((ScriptID 15 1)
						view: 175
						cycleSpeed: 3
						setCycle: Forward
						startUpd:
						setScript: 0
					)
				else
					((ScriptID 15 12) play:)
					(Bclear 151)
					((ScriptID 15 4) setLoop: 7 cel: 0 setCycle: EndLoop self)
					(if (or (not (ego script?)) (Btest 315)) (Bset 290))
				)
			)
			(4 (Bset 344) (self dispose:))
		)
	)
)
