;;; Sierra Script 1.0 - (do not remove this comment)
(script# 129)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use System)

(public
	openSpell 0
	unlockChest 1
)

(local
	local0
)
(instance blowUp of Sound
	(properties
		number 62
		priority 1
	)
)

(instance openSpell of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 129)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego view: 521 setLoop: 0 cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 12)
			)
			(1
				(Bset 166)
				(blowUp number: (GetSongNumber 36) init: play:)
				((ScriptID 15 8)
					setLoop: 2
					cel: 0
					cycleSpeed: 0
					setCycle: CycleTo 4 1 self
				)
			)
			(2
				(blowUp number: (GetSongNumber 62) loop: 1 play:)
				((ScriptID 15 8) setCycle: EndLoop)
				(if (< koboldStatus 2) (= koboldStatus 2) (Bset 297))
				(if (< (ego distanceTo: (ScriptID 15 8)) 20)
					(if (not (ReduceHP 20)) (= local0 1))
					(ego
						view: 513
						loop:
							(cond 
								(local0 (if (Btest 149) 1 else 0))
								((Btest 149) 3)
								(else 2)
							)
						cel: 0
						illegalBits: 0
						cycleSpeed: 1
						setCycle: EndLoop self
					)
				)
				(= cycles 10)
			)
			(3
				(blowUp dispose:)
				(cond 
					(local0 (Die 129 0 80 {Smithereens} 82 800 0 0))
					((< (ego distanceTo: (ScriptID 15 8)) 20) (HighPrint 129 1) (= global319 2) (= cycles 5))
					(else (self cue:))
				)
			)
			(4
				(= global322 3)
				((ScriptID 15 8) stopUpd:)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(UnlockEgo)
				(StopEgo)
				(ego loop: 2 forceUpd:)
				(client setScript: 0)
			)
		)
	)
)

(instance unlockChest of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 129)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					view: 510
					setLoop: (if (< ((ScriptID 15 8) x?) (ego x?)) 1 else 0)
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(1
				(cond 
					(
					(and (TestSkill skLOCKPICKING 70 lockPickBonus) (not (Btest 342)))
						(HighPrint 129 2)
						(HighPrint 129 3)
						(= global322 2)
						(AddToScore POINTS_TAKEKOBOLDMONEY 5)
						(ego get: invSilverCoin 60)
						(ego get: invGoldCoin 10 setCycle: BegLoop self)
					)
					((Btest 342)
						(if (TestSkill skSTRENGTH 50)
							(HighPrint 129 4)
							(if (not (ReduceHP 20)) (= local0 1))
						else
							(Bset 343)
							(HighPrint 129 5)
							(if (< koboldStatus 2) (= koboldStatus 2) (Bset 297))
							(ChangeEgoWalk MOVE_WALK FALSE)
						)
					)
					(else
						(HighPrint 129 6)
						(if (not (ReduceHP 20)) (= local0 1))
					)
				)
				(= cycles 2)
			)
			(2
				(if (or (== global322 2) (Btest 343))
					(Bclear 343)
					(StopEgo)
					(UnlockEgo)
					(client setScript: 0)
				else
					(blowUp number: (GetSongNumber 36) init: play:)
					((ScriptID 15 8)
						setLoop: 2
						cel: 0
						cycleSpeed: 0
						setCycle: CycleTo 4 1 self
					)
				)
			)
			(3
				(blowUp number: (GetSongNumber 62) loop: 1 play:)
				((ScriptID 15 8) setCycle: EndLoop)
				(if (< koboldStatus 2) (= koboldStatus 2) (Bset 297))
				(ego
					view: 513
					loop:
						(cond 
							(local0 (if (Btest 149) 1 else 0))
							((Btest 149) 3)
							(else 2)
						)
					cel: 0
					illegalBits: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(4
				(blowUp dispose:)
				(if local0
					(Die 129 0 80 {Smithereens} 82 800 0 0)
				else
					(HighPrint 129 1)
					(= global322 3)
					(= global319 2)
					(= cycles 5)
					(StopEgo)
				)
			)
			(5
				(ChangeEgoWalk MOVE_WALK FALSE)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)
