;;; Sierra Script 1.0 - (do not remove this comment)
(script# 118)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	reversal 0
	teleport 1
)

(instance reversal of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 118)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 15 1)
					view: 176
					setLoop: 1
					cel: 0
					cycleSpeed: 1
				)
				(= cycles 8)
			)
			(1
				(HighPrint 118 0)
				((ScriptID 15 1) setCycle: EndLoop)
				(= cycles 10)
			)
			(2
				(Bset 153)
				(Bset 344)
				(self dispose:)
			)
		)
	)
)

(instance teleport of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 118)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 15 1)
					view: 176
					setLoop: 0
					setMotion: 0
					cel: 0
					cycleSpeed: 0
					setCycle: EndLoop self
				)
			)
			(1
				(Bset 313)
				((ScriptID 15 1)
					view: 176
					posn: (if (Btest 149) 229 else 52) (if (Btest 149) 85 else 84)
					setCycle: BegLoop self
				)
			)
			(2
				(if (Btest 149) (Bclear 149) else (Bset 149))
				(= cycles 2)
			)
			(3
				(Bset 344)
				(Bclear 313)
				(self dispose:)
			)
		)
	)
)
