;;; Sierra Script 1.0 - (do not remove this comment)
(script# 809)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Motion)
(use Inventory)
(use User)

(public
	EnterKoboldRoom 0
	SaidKoboldRoom 1
	SendKoboldSaidEvent 2
)

(procedure (EnterKoboldRoom param1)
	(cond 
		(
		(or (== egoWalkMode MOVE_SNEAK) ((ScriptID 15 0) script?)))
		((< koboldStatus 1)
			(ego setMotion: 0)
			(= koboldStatus 1)
			(Bset 296)
			(param1 claimed: 1)
		)
		(
			(and
				(< koboldStatus 2)
				(not ((ScriptID 15 1) script?))
			)
			(= koboldStatus 2)
			(Bset 297)
		)
	)
)

(procedure (SaidKoboldRoom param1 &tmp temp0)
	(cond 
		((Said 'cast>')
			(switch (= temp0 (SaidCast param1))
				(skOPEN
					(if (and (not (ego script?)) (!= global319 3))
						(ChangeEgoWalk MOVE_WALK FALSE)
						(Bset 166)
						(if (and (== global322 0) (CastSpell temp0))
							(Bset 291)
						else
							(PrintWarning 809 0)
						)
					else
						(PrintWarning 809 1)
					)
				)
				(skDETECTMAGIC
					(if (and (!= koboldStatus 2) (CastSpell temp0))
						(Bset 166)
						(Bset 299)
					else
						(PrintWarning 809 2)
					)
				)
				(skTRIGGER
					(if (and (not (ego script?)) (!= global319 3))
						(ChangeEgoWalk MOVE_WALK FALSE)
						(Bset 166)
						(if (< koboldStatus 2) (Bset 297))
						(if (and (== global322 0) (CastSpell temp0))
							(Bset 291)
						else
							(PrintWarning 809 3)
						)
					else
						(PrintWarning 809 2)
					)
				)
				(skDAZZLE
					(if (< global319 2) (= global319 2))
					(cond 
						((Btest 216) (PrintWarning 809 4))
						((== global319 3) (PrintWarning 809 2))
						(else
							(ChangeEgoWalk MOVE_WALK FALSE)
							(if (< koboldStatus koboldDead)
								(if (CastSpell temp0) (Bset 293))
							else
								(PrintWarning 809 5)
							)
						)
					)
				)
				(skCALM
					(if (== global319 3)
						(PrintWarning 809 2)
					else
						(ChangeEgoWalk MOVE_WALK FALSE)
						(if (CastSpell temp0)
							(Bset 349)
							(Bset 307)
						else
							(param1 claimed: 0)
						)
					)
				)
				(skZAP (param1 claimed: 0))
				(skFLAMEDART
					(if (< global319 2) (= global319 2))
					(cond 
						((== global319 3) (PrintWarning 809 1) (param1 claimed: 1))
						((== koboldStatus koboldDead) (PrintWarning 809 5))
						(else
							(if
								(and
									(!= koboldStatus 2)
									(not ((ScriptID 15 1) script?))
								)
								(ChangeEgoWalk MOVE_WALK FALSE)
								(Bset 157)
							)
							(if (not (ego script?))
								(if (CastSpell temp0) (Bset 286))
							else
								(PrintWarning 809 6)
							)
						)
					)
				)
				(skFETCH
					(if (not (Btest 165))
						(switch koboldStatus
							(0
								(if (CastSpell temp0) (Bset 295) (ChangeEgoWalk MOVE_WALK FALSE))
							)
							(koboldDead
								(if (== global321 2)
									(param1 claimed: 0)
								else
									(PrintWarning 809 7)
								)
							)
							(else 
								(if (CastSpell temp0) (PrintWarning 809 8))
							)
						)
					else
						(param1 claimed: 0)
					)
				)
			)
		)
		((Said 'throw>')
			(cond 
				((Said '/boulder')
					(if (not (ego has: invSmallRock)) (PrintDontHaveIt) (return))
					(switch koboldStatus
						(0 
							(PrintWarning 809 9)
							;Shhhh!  You'll probably just wake up the Kobold.
						)
						(1 
							(PrintWarning 809 10)
							;It'd just make the Kobold madder.
						)
						(2 
							(PrintWarning 809 11)
							;Perhaps something more potent than a rock is in order.
						)
						(koboldDead 
							(PrintWarning 809 12)
							;What for?
						)
					)
				)
				((Said '/dagger')
					(cond 
						((not (ego has: invDagger)) (PrintDontHaveIt))
						((== koboldStatus koboldDead) (PrintWarning 809 12))
						((< (ego distanceTo: (ScriptID 15 1)) 50) (PrintWarning 809 13))
						((not (ego script?)) (Bset 324))
						(else (PrintWarning 809 1) (param1 claimed: 1))
					)
				)
				(else (PrintWarning 809 14) (param1 claimed: 1))
			)
		)
		((Said 'kill,chop,fight')
			(if (and (not (ego has: invDagger)) (not (ego has: 6)))
				(PrintWarning 809 15)
				(return)
			)
			(switch global319
				(4 (PrintWarning 809 16))
				(3 (PrintWarning 809 17))
				(else 
					(ChangeEgoWalk MOVE_WALK FALSE)
					(= global319 3)
				)
			)
			(if (< koboldStatus 3)
				(Bset 147)
				(switch koboldStatus
					(0
						(= koboldStatus 1)
						(Bset 296)
					)
					(1
						(= koboldStatus 2)
						(Bset 297)
						(Bset 289)
					)
					(2 (Bset 289))
				)
			)
		)
		((Said 'ask,chat,awaken')
			(ChangeEgoWalk MOVE_WALK FALSE)
			(cond 
				((< koboldStatus 1) (= koboldStatus 1) (Bset 296))
				((< koboldStatus 2) (Bset 298))
				((< koboldStatus koboldDead) (PrintWarning 809 18))
				(else (PrintWarning 809 19))
			)
		)
		((or (Said '[use]/stealth') (Said 'sneak'))
			(cond 
				((== koboldStatus koboldDead) (PrintWarning 809 20))
				((>= koboldStatus 1) (PrintWarning 809 21))
				((!= egoWalkMode MOVE_SNEAK)
					(if (TestSkill skSTEALTH 40 0)
						(ChangeEgoWalk MOVE_SNEAK FALSE)
					else
						(PrintWarning 809 22)
					)
				)
			)
		)
		((Said 'look>')
			(cond 
				((Said '/stalactite') (PrintWarning 809 23))
				((Said '/stalagmite') (PrintWarning 809 24))
				((Said '[<at,around][/!*,cave,room,east]')
					(PrintWarning 809 25)
					(switch koboldStatus
						(0
							(PrintWarning 809 26)
							;Resting on a rocky platform above the cave floor is a Kobold, one of the race of ugly, miserly magicians.
							(PrintWarning 809 27)
							;There seems to be a crude table at the base of the platform.
						)
						(2 
							(PrintWarning 809 28)
							;There is a lot of activity at present.
						)
						(1 
							(PrintWarning 809 29)
							;The Kobold seems agitated.
						)
					)
				)
				((or (Said '<up') (Said '/ceiling,roof')) (PrintWarning 809 30) (PrintWarning 809 31))
				((or (Said '<down') (Said '/floor,ground')) (PrintWarning 809 32) (PrintWarning 809 33))
				((Said '/wall,fungus,north,south,formation') (PrintWarning 809 34))
				((Said '/west,open,entrance') (PrintWarning 809 35))
				((Said '/table') (PrintWarning 809 36))
				((Said 'look/mushroom,toadstool') (PrintWarning 809 37))
				((Said '/gold,silver,alm,loot,chest,box')
					(cond 
						((== global322 1)
							(if (< (ego distanceTo: (ScriptID 15 8)) 20)
								(HighPrint 809 38)
							else
								(PrintNotCloseEnough)
							)
						)
						((== global322 3) (HighPrint 809 39))
						((Btest 166) (Print 809 40) ; The chest is invisible.
						)
						(else (Print 809 41) ; You don't see anything like that.
						)
					)
				)
				((Said '/key')
					(cond 
						((ego has: invLargeBrassKey) (param1 claimed: 0))
						((Btest 165) (PrintWarning 809 42))
						((== global321 0)
							(PrintWarning 809 43)
							((ScriptID 15 9)
								posn: ((ScriptID 15 1) x?) (- ((ScriptID 15 1) y?) 22)
								setCycle: EndLoop
							)
						)
						((== global321 1) (PrintWarning 809 44))
						((== global321 2) (PrintWarning 809 45))
					)
				)
				((Said '/kobold,man,creature,wizard')
					(switch koboldStatus
						(0
							(PrintWarning 809 46)
							;The strange creature is wearing ragged clothes.
							(if (not (ego has: invLargeBrassKey)) (PrintWarning 809 47))
							((ScriptID 15 9) setCycle: EndLoop)
						)
						(1 
							(PrintWarning 809 48)
							;The creature does not seem pleased to see you.
						)
						(2 
							(PrintWarning 809 49)
							;This creature is DANGEROUS!
						)
						(else  (PrintWarning 809 50))
					)
				)
			)
		)
		((Said 'use/key')
			(if (Btest 166)
				(HighPrint 809 51)
			else
				(HighPrint 809 52)
			)
		)
		((Said 'open/box,chest')
			(if (< (ego distanceTo: (ScriptID 15 8)) 20)
				(HighPrint 809 53)
			else
				(PrintNotCloseEnough)
			)
		)
		((Said 'break,pry,force/box,chest,hasp,lid')
			(cond 
				((not (Btest 166)) (HighPrint 809 54))
				((> global322 0) (HighPrint 809 52))
				((< (ego distanceTo: (ScriptID 15 8)) 20) (HighPrint 809 55) (Bset 342) (Bset 292))
				(else (PrintNotCloseEnough))
			)
		)
		((Said 'unlock,lockpick/box,chest,hasp')
			(cond 
				((not (Btest 166)) (HighPrint 809 56))
				((> global322 0) (HighPrint 809 52))
				((not (HasLockPickTools)) (HighPrint 809 57))
				((< (ego distanceTo: (ScriptID 15 8)) 20) (HighPrint 809 58) (Bclear 342) (Bset 292))
				(else (PrintNotCloseEnough))
			)
		)
		((Said 'get,lockpick[<up]>')
			(cond 
				((Said '/key')
					(cond 
						((ego pickUp: invLargeBrassKey) (HighPrint 809 59))
						((Btest 165) (PrintAlreadyDoneThat))
						((== global321 2) (PrintWarning 809 60))
						((== egoWalkMode MOVE_SNEAK)
							(if (< (ego distanceTo: (ScriptID 15 1)) 50)
								(PrintWarning 809 61)
								((ScriptID 15 9) setCycle: EndLoop)
								(ego get: invLargeBrassKey)
								(= global321 2)
								(Bset 165)
								(AddToScore POINTS_TAKEKOBOLDKEY 7)
								((ScriptID 15 7) hide:)
							else
								(PrintNotCloseEnough)
							)
						)
						((or (== koboldStatus 0) (== koboldStatus 1)) (PrintWarning 809 62))
						((== koboldStatus 2) (PrintWarning 809 63))
						((== koboldStatus koboldDead)
							(if (< (ego distanceTo: (ScriptID 15 7)) 40)
								(PrintWarning 809 64)
								(ego get: invLargeBrassKey)
								(= global321 2)
								(Bset 165)
								(AddToScore POINTS_TAKEKOBOLDKEY 7)
								((ScriptID 15 7) hide:)
							else
								(PrintNotCloseEnough)
							)
						)
					)
				)
				((Said '/fungus') (PrintWarning 809 65))
				((Said '/kobold,creature,stalactite,stalagmite') (PrintWarning 809 66))
				((Said '/mushroom,toadstool')
					(if (ego inRect: 178 113 250 143)
						(PrintWarning 809 67)
						(ego get: invMushroom 3)
						(Bset 174)
					else
						(PrintNotCloseEnough)
					)
				)
				((Said '/box,chest')
					(cond 
						((not (Btest 166)) (HighPrint 809 54))
						((< global322 2)
							(if (< (ego distanceTo: (ScriptID 15 8)) 20)
								(HighPrint 809 68)
							else
								(PrintNotCloseEnough)
							)
						)
						(else (HighPrint 809 69))
					)
				)
				((Said '/alm,gold,silver,loot')
					(cond 
						((== global322 0) (HighPrint 809 70))
						((or (== global322 1) (== global322 3))
							(if (< (ego distanceTo: (ScriptID 15 8)) 20)
								(HighPrint 809 71)
								(ego get: invSilverCoin 60)
								(ego get: invGoldCoin 10)
								(AddToScore POINTS_TAKEKOBOLDMONEY 5)
								(= global322 4)
								((ScriptID 15 8) setCel: 0)
							else
								(PrintNotCloseEnough)
							)
						)
						((== global322 4) (PrintAlreadyDoneThat))
						((== global322 5) (HighPrint 809 72))
					)
				)
			)
		)
	)
)

(procedure (SendKoboldSaidEvent param1 param2)
	(param1 type: 128 claimed: 0)
	(Parse param2 param1)
	(User said: param1)
)
