;;; Sierra Script 1.0 - (do not remove this comment)
(script# 144)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use TalkObj)
(use System)

(public
	sErasmus 0
	sFenrus 1
	sGame 2
	sBrigs 3
	sWarlock 4
	sMirror 5
)

(instance sErasmus of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 0)
			)
			(1
				(TalkObjMessages (ScriptID 83 1) 144 1)
			)
			(2
				(TalkObjMessages (ScriptID 83 1) 144 2)
			)
			(3
				(TalkObjMessages (ScriptID 83 1) 144 3)
			)
			(4
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)

(instance sFenrus of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 4)
			)
			(1
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)

(instance sGame of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 5)
			)
			(1
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)

(instance sBrigs of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 6)
			)
			(1
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)

(instance sWarlock of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 7)
			)
			(1
				(TalkObjMessages (ScriptID 83 1) 144 8)
			)
			(2
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)

(instance sMirror of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 144)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 83 1) caller: self)
				(LockEgo)
				(TalkObjMessages (ScriptID 83 1) 144 9)
			)
			(1
				(client setScript: (ScriptID 83 2))
				(UnlockEgo)
			)
		)
	)
)
