;;; Sierra Script 1.0 - (do not remove this comment)
(script# 221)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Skilled)
(use Motion)
(use System)

(public
	theMaster 0
)

(local
	local0
	local1
	local2
)
(procedure (localproc_000c)
	(HighPrint 221 0)
)

(procedure (localproc_0015)
	(cond 
		((not [skills skPARRY]) (HighPrint 221 1) (HighPrint 221 2))
		((Btest 321) (localproc_006c))
		(else
			(Bset 321)
			(HighPrint 221 1)
			(HighPrint 221 3)
			(HighPrint 221 4)
			(= countdownAwaitingResponse 100)
			(= local2 1)
		)
	)
)

(procedure (localproc_006c)
	(= local2 0)
	(if (GiveSilverCoins 10)
		(HighPrint 221 5)
		(= dayLastFoughtWeaponMaster currentDay)
		(AddToScore POINTS_FIGHTWEAPONMASTER 3 CLASS_FIGHTER)
		((ScriptID 39 0) setScript: (ScriptID 222 2))
	else
		(HighPrint 221 6)
		(localproc_000c)
	)
)

(class WeaponMaster of Skilled
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits cWHITE
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		strength 65
		intell 90
		agil 90
		vit 50
		luck 90
		weap 90
		parry 90
		dodge 90
		magic 0
		stamina 0
		health 0
		mana 0
		armorValue 3
		armorEnc 0
		shieldValue 10
		weapValue 5
		canFight 0
		action 0
		opponent 0
		fightLeft 0
		warriorX 187
		warriorY 150
		endFight 0
	)
	
	(method (getHit)
		(if fightLeft
			(self x: (+ (self x?) 3))
			((self opponent?) x: (+ ((self opponent?) x?) 3))
		else
			(self x: (- (self x?) 3))
			((self opponent?) x: (- ((self opponent?) x?) 3))
		)
	)
	
	(method (gotBeat param1)
		(self endFight: 1)
		(self setScript: param1)
	)
)

(instance theMaster of WeaponMaster
	(properties
		view 639
	)
	
	(method (doit)
		(cond 
			((> countdownAwaitingResponse 1) (-- countdownAwaitingResponse))
			((== countdownAwaitingResponse 1) (= countdownAwaitingResponse 0) (= local2 0) (localproc_000c))
		)
		(cond 
			(
				(and
					(< (ego distanceTo: (ScriptID 221 0)) 40)
					(not local0)
					(not (Btest 304))
				)
				(= local0 1)
			)
			(
				(and
					(not (< (ego distanceTo: (ScriptID 221 0)) 40))
					local0
					(not (Btest 304))
				)
				(= local0 0)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					(script (pEvent claimed: 0))
					((super handleEvent: pEvent))
					((> countdownAwaitingResponse 1)
						(cond 
							((Said 'affirmative')
								(= countdownAwaitingResponse 0)
								(if local2 (localproc_006c) else (localproc_0015))
							)
							((Said 'pay')
								(= countdownAwaitingResponse 0)
								(if local2 (localproc_006c) else (localproc_0015))
							)
							((Said 'n')
								(= countdownAwaitingResponse 0)
								(if local2 (= local2 0))
								(localproc_000c)
							)
							(else
								(pEvent claimed: 1)
								(HighPrint 221 7)
								(if local2
									(HighPrint 221 8)
									(= countdownAwaitingResponse 80)
								else
									(HighPrint 221 9)
									(= countdownAwaitingResponse 80)
								)
							)
						)
					)
					((Said 'pay')
						(= countdownAwaitingResponse 0)
						(= local2 0)
						(if [skills skPARRY]
							(localproc_006c)
						else
							(HighPrint 221 10)
						)
					)
					((Said 'look>')
						(cond 
							((Said '/man,master[<weapon]') (HighPrint 221 11))
							((Said '/blade') (HighPrint 221 12))
						)
					)
					((Said 'chat/man,swordsman,master')
						(if (not local0)
							(ego setScript: comeBackLittleEgo)
						else
							(HighPrint 221 13)
						)
					)
					((Said 'chat,ask>')
						(if (not local0)
							(ego setScript: comeBackLittleEgo)
							(pEvent claimed: 1)
						else
							(= local1 1)
						)
						(cond 
							(
							(Said '/fight,art,skill,strength,strength,agility')
								(HighPrint 221 14)
								(HighPrint 221 15)
								(HighPrint 221 16)
								(HighPrint 221 17)
								(if [skills skPARRY]
									(HighPrint 221 18)
									(= countdownAwaitingResponse 100)
								else
									(HighPrint 221 19)
								)
							)
							((Said '/blade,weapon') (HighPrint 221 20))
							((Said '/name,man,master') (HighPrint 221 21))
							((Said '/guard') (HighPrint 221 22))
							((Said '/baron') (HighPrint 221 23))
							((Said '/barnard') (HighPrint 221 24))
							((Said '/shield,armor') (HighPrint 221 25))
							((Said '/teach,learn,lesson,practice') (HighPrint 221 26) (localproc_0015))
							(else
								(= local1 0)
								(pEvent claimed: 1)
								(if (not (ego script?)) (HighPrint 221 13))
							)
						)
						(if (and local1 (pEvent claimed?)) (AddToScore POINTS_TALKTOWEAPONMASTER 1))
					)
					(
						(or
							(Said 'practice,fight,learn')
							(Said 'buy,get/lesson')
						)
						(localproc_0015)
					)
				)
			)
		)
	)
)

(instance comeBackLittleEgo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(HighPrint 221 27)
				(if (< (ego x?) ((ScriptID 221 0) x?))
					(theMaster loop: 5)
				else
					(theMaster loop: 4)
				)
				(ego
					ignoreActors:
					setMotion:
						MoveTo
						(if (< (ego x?) ((ScriptID 221 0) x?))
							(- (theMaster x?) 35)
						else
							(+ (theMaster x?) 35)
						)
						(theMaster y?)
						self
				)
			)
			(1
				(FaceObject ego theMaster)
				(= local0 1)
				(ego ignoreActors: 0)
				(client setScript: 0)
				(UnlockEgo)
			)
		)
	)
)
