;;; Sierra Script 1.0 - (do not remove this comment)
(script# 223)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	tooGood 0
	tooTired 1
)

(instance tooGood of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 223)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 304)
				((ScriptID 39 1) stop:)
				(= cycles 2)
			)
			(1
				(HighPrint 223 0)
				((ScriptID 221 0)
					view: 639
					setLoop: (if (client fightLeft?) 5 else 4)
					setCel: 0
				)
				(= cycles 6)
			)
			(2
				(UseSkill skLUCK 50)
				(if (== heroType CLASS_FIGHTER) (AddToScore POINTS_DEFEATWEAPONMASTER 10))
				(HighPrint 223 1)
				(HighPrint 223 2)
				((ScriptID 221 0)
					setLoop: (if (== ((ScriptID 221 0) loop?) 4) 1 else 0)
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: Walk
					setMotion:
						MoveTo
						(if ((ScriptID 221 0) fightLeft?) 340 else -20)
						((ScriptID 221 0) y?)
						self
				)
				(Bclear 239)
				(Bset 249)
			)
			(3
				(Bclear 304)
				(StopEgo)
				(ego
					posn: ((client opponent?) x?) ((client opponent?) y?)
					loop: (if ((ScriptID 221 0) fightLeft?) 0 else 1)
					cel: 0
					show:
				)
				(UnlockEgo)
				((client opponent?) dispose:)
				(client dispose:)
			)
		)
	)
)

(instance tooTired of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 223)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(Bset 304)
				((ScriptID 39 1) stop:)
				(= cycles 2)
			)
			(1
				(client
					view: 514
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: Forward
					startUpd:
				)
				(= cycles 15)
			)
			(2
				(if (< [skills skSP] 2)
					(HighPrint 223 3)
				else
					(HighPrint 223 4)
				)
				(= cycles 15)
			)
			(3
				(client setLoop: 1 cel: 0 setCycle: EndLoop)
				(= cycles 20)
			)
			(4
				(client view: 503 setLoop: 4 cel: 0 setCycle: EndLoop self)
			)
			(5
				(if (client endFight?)
					((client opponent?) setScript: (ScriptID 224 0))
				)
				(ego
					loop: (if (client fightLeft?) 1 else 0)
					posn: (client x?) (client y?)
					show:
				)
				(StopEgo)
				(Bclear 304)
				(client dispose:)
			)
		)
	)
)
