;;; Sierra Script 1.0 - (do not remove this comment)
(script# 239)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use CursorCoords)
(use System)

(public
	chooseSpell 0
)

(local
	[local0 4] = [48 122 198 274]
)
(procedure (localproc_000c param1 param2 param3 param4 param5 param6)
	(return
		(if
			(and
				(<= param3 param1)
				(< param1 param5)
				(<= param4 param2)
			)
			(< param2 param6)
		else
			0
		)
	)
)

(procedure (localproc_002a)
	(button1 init:)
	((ScriptID 32 1) add: button1)
	(button2 init:)
	((ScriptID 32 1) add: button2)
	(button3 init:)
	((ScriptID 32 1) add: button3)
	(button4 init:)
	((ScriptID 32 1) add: button4)
)

(instance chooseSpell of Script
	(properties)
	
	(method (dispose)
		((ScriptID 32 1) empty:)
		(super dispose:)
		(DisposeScript 239)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetCursor theCursor 1 [local0 magesMazeButtonIndex] 23)
				((ScriptID 32 1) empty:)
				(localproc_002a)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp [temp0 3] temp3 temp4)
		(if
			(and
				(== (pEvent message?) KEY_RETURN)
				(== (pEvent type?) evKEYBOARD)
			)
			(pEvent type: 1)
		)
		(cond 
			((super handleEvent: pEvent))
			((== (pEvent type?) evJOYSTICK) ((ScriptID 32 1) handleEvent: pEvent))
			((== (pEvent type?) evMOUSEBUTTON)
				(= temp3 (pEvent x?))
				(= temp4 (pEvent y?))
				(pEvent claimed: 1)
				(cond 
					((localproc_000c temp3 temp4 17 18 79 29) (= magesMazeButtonIndex 0) (= magesMazeCommand 2) (self dispose:))
					((localproc_000c temp3 temp4 91 18 153 29) (= magesMazeButtonIndex 1) (= magesMazeCommand 3) (self dispose:))
					((localproc_000c temp3 temp4 167 18 229 29) (= magesMazeButtonIndex 2) (= magesMazeCommand 4) (self dispose:))
					((localproc_000c temp3 temp4 243 18 305 29) (= magesMazeButtonIndex 3) (= magesMazeCommand 5) (self dispose:))
					(else (pEvent claimed: 0))
				)
			)
			((!= (pEvent type?) evSAID))
			((Said 'drink') (pEvent claimed: 0))
			((or (Said 'cast/fetch') (Said 'fetch,get')) (= magesMazeButtonIndex 0) (= magesMazeCommand 2) (self dispose:))
			((or (Said 'cast/open') (Said 'open')) (= magesMazeButtonIndex 1) (= magesMazeCommand 3) (self dispose:))
			((or (Said 'cast/trigger') (Said '/trigger')) (= magesMazeButtonIndex 2) (= magesMazeCommand 4) (self dispose:))
			(
				(or
					(Said 'cast/dart,flame,fire')
					(Said '/flame,fire,torch')
				)
				(= magesMazeButtonIndex 3)
				(= magesMazeCommand 5)
				(self dispose:)
			)
			(
			(or (Said 'resign,quit,done,cease') (Said '/bye[<bye]'))
				(= magesMazeCommand 0)
				(Bset 337)
				((ScriptID 32 0) cue:)
				(self dispose:)
			)
			((Said 'throw')
				(Print 239 0)
				; Your bug doesn't have any hands.  This makes throwing anything out of the question.
			)
			((Said 'run,sneak') (Print 239 1) ; Looks like all you can do is wriggle.
			)
			((Said 'drink') (pEvent claimed: 0))
			(else
				(Print 239 2)
				(pEvent claimed: 1)
				; Better concentrate on the game.
			)
		)
	)
)

(instance button1 of CursorCoords
	(properties
		cursorX 48
		cursorY 23
	)
)

(instance button2 of CursorCoords
	(properties
		cursorX 122
		cursorY 23
	)
)

(instance button3 of CursorCoords
	(properties
		cursorX 198
		cursorY 23
	)
)

(instance button4 of CursorCoords
	(properties
		cursorX 274
		cursorY 23
	)
)
