;;; Sierra Script 1.0 - (do not remove this comment)
(script# 318)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Game)
(use User)
(use Actor)

(public
	rm318 0
)

(local
	newView
	newView_2
	newView_3
	newView_4
	newView_5
	newView_6
	newView_7
	newView_8
	newView_9
	newView_10
	local10
)
(procedure (localproc_000c param1 param2)
	(Print param2 #at -1 12 #mode 1 #width param1)
)

(procedure (localproc_0022)
	(switch local10
		(1
			(newView_10 cel: 0 posn: 60 108 stopUpd:)
		)
		(2
			(newView_10 cel: 1 posn: 120 105 stopUpd:)
		)
		(3
			(newView_10 cel: 0 posn: 197 106 stopUpd:)
		)
		(4
			(newView_10 cel: 2 posn: 100 154 stopUpd:)
		)
		(5
			(newView_10 cel: 0 posn: 176 155 stopUpd:)
		)
		(6
			(newView_10 cel: 3 posn: 263 146 stopUpd:)
		)
		(7
			(newView_10 cel: 4 posn: 247 187 stopUpd:)
		)
	)
)

(procedure (localproc_00ff &tmp [temp0 4] [temp4 400])
	(switch local10
		(1
			(Format @temp4 318 0)
			(localproc_000c 185 @temp4)
		)
		(2
			(Format @temp4 318 1)
			(localproc_000c 260 @temp4)
		)
		(3
			(Format @temp4 318 2)
			(localproc_000c 200 @temp4)
		)
		(4
			(Format @temp4 318 3)
			(localproc_000c 300 @temp4)
		)
		(5
			(Format @temp4 318 4)
			(localproc_000c 200 @temp4)
		)
		(6
			(Bset 355)
			(Format @temp4 318 5)
			(localproc_000c 280 @temp4)
		)
		(7 (curRoom newRoom: 311))
	)
)

(instance rm318 of Room
	(properties
		picture 318
		style $0007
	)
	
	(method (init)
		(Load rsVIEW 318)
		(super init:)
		(gMouseHandler add: self)
		(gKeyHandler add: self)
		(gDirHandler add: self)
		(StatusLine enable:)
		(User canControl: 0)
		((= newView (View new:))
			view: 318
			loop: 0
			cel: 1
			posn: 60 76
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_2 (View new:))
			view: 318
			loop: 0
			cel: 1
			posn: 120 70
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_3 (View new:))
			view: 318
			loop: 0
			cel: 1
			posn: 197 74
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_4 (View new:))
			view: 318
			loop: 0
			cel: 0
			posn: 100 124
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_5 (View new:))
			view: 318
			loop: 0
			cel: 2
			posn: 175 123
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_6 (View new:))
			view: 318
			loop: 0
			cel: 1
			posn: 263 104
			setPri: 0
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_7 (View new:))
			view: 318
			loop: 1
			cel: 0
			posn: 119 84
			setPri: 1
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_8 (View new:))
			view: 318
			loop: 1
			cel: 1
			posn: 262 120
			setPri: 1
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		((= newView_9 (View new:))
			view: 318
			loop: 0
			cel: 0
			posn: 100 124
			setPri: 1
			init:
			ignoreActors:
			stopUpd:
			addToPic:
		)
		(= local10 1)
		((= newView_10 (View new:))
			view: 318
			loop: 2
			cel: 0
			posn: 60 108
			setPri: 1
			init:
			ignoreActors:
			stopUpd:
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(gKeyHandler delete: self)
		(gDirHandler delete: self)
		(User canControl: 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(= temp1 0)
				(switch (= temp0 (OnControl 4 (pEvent x?) (pEvent y?)))
					(cBLUE (= temp1 1))
					(cGREEN (= temp1 2))
					(cCYAN (= temp1 3))
					(cRED (= temp1 4))
					(cMAGENTA (= temp1 5))
					(cBROWN (= temp1 6))
					(cYELLOW
						(= local10 7)
						(localproc_0022)
						(SetUpEgo)
						(pEvent claimed: 1)
						(curRoom newRoom: 311)
					)
				)
				(pEvent claimed: 1)
				(localproc_0022)
				(if temp1
					(= local10 temp1)
					(localproc_0022)
					(SetUpEgo)
					(localproc_00ff)
				)
			)
			(evSAID
				(cond 
					((Said 'cease,done,done,done') (pEvent claimed: 1) (curRoom newRoom: 311))
					((Said 'look') (pEvent claimed: 1) (localproc_00ff))
				)
			)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP
						(if (< (= local10 (- local10 3)) 1)
							(= local10 (+ local10 7))
						)
					)
					(JOY_RIGHT
						(if (> (++ local10) 7) (= local10 1))
					)
					(JOY_DOWN
						(if (> (= local10 (+ local10 3)) 7)
							(= local10 (- local10 7))
						)
					)
					(JOY_LEFT
						(if (< (-- local10) 1) (= local10 7))
					)
				)
				(pEvent claimed: 1)
				(localproc_0022)
			)
			(evKEYBOARD
				(if (== (pEvent message?) KEY_RETURN)
					(pEvent claimed: 1)
					(localproc_00ff)
					(if (> (++ local10) 7) (= local10 1))
					(localproc_0022)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)
