;;; Sierra Script 1.0 - (do not remove this comment)
(script# 94)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateOpen)
(use AnimateDazzle)
(use brigandCourtyardActions)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm94 0
	archer1 1
	archer2 2
	archer3 3
	archer4 4
	archer1Start 5
	archer2Start 6
	archer3Start 7
	archer4Start 8
	unSafeBridge 9
	antwerp 10
	jackCycle 11
	rug 12
	rugs 13
	jack1 14
	jackCycle 15
	jackSound 16
	door 17
	openMess 18
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	theTheRegister
	gEgoObjLoop
	theTheRegister_2
	[theRegister 28]
	local37
	local38
	local39
	local40 =  1
)
(procedure (localproc_0030 param1 param2 param3)
	(= local38 0)
	(if local5
		(= local37 6)
	else
		(switch param1
			(0
				(switch param2
					(0
						(if param3
							(= local37 0)
							(= local38 6)
						else
							(= local37 3)
						)
					)
					(1
						(if param3
							(= local38 -6)
							(= local37 3)
						else
							(= local37 0)
						)
					)
					(else  (= local37 6))
				)
			)
			(1
				(switch param2
					(0
						(if param3
							(= local37 3)
						else
							(= local38 6)
							(= local37 0)
						)
					)
					(1
						(if param3
							(= local37 0)
						else
							(= local38 -6)
							(= local37 3)
						)
					)
					(else  (= local37 6))
				)
			)
			(2
				(switch param2
					(2
						(if param3 (= local37 0) else (= local37 3))
					)
					(3
						(if param3 (= local37 3) else (= local37 0))
					)
					(else  (= local37 6))
				)
			)
			(else 
				(switch param2
					(2
						(if param3 (= local37 3) else (= local37 0))
					)
					(3
						(if param3 (= local37 0) else (= local37 3))
					)
					(else  (= local37 6))
				)
			)
		)
	)
)

(procedure (localproc_015e param1 param2 param3 param4 &tmp temp0 temp1)
	(= temp0
		(localproc_0283
			param1
			param2
			(ego x?)
			(- (ego y?) 30)
			(ego x?)
			(- (ego y?) 15)
		)
	)
	(if
		(==
			temp0
			(= temp1
				(localproc_0283
					param3
					param4
					(ego x?)
					(- (ego y?) 30)
					(ego x?)
					(- (ego y?) 15)
				)
			)
		)
		(return 0)
	)
	(= temp0
		(localproc_0283
			(ego x?)
			(- (ego y?) 30)
			param1
			param2
			param3
			param4
		)
	)
	(return
		(if
			(==
				temp0
				(= temp1
					(localproc_0283
						(ego x?)
						(- (ego y?) 15)
						param1
						param2
						param3
						param4
					)
				)
			)
			(return 0)
		else
			(= theTheRegister
				(-
					(/
						(+
							(* param4 (ego x?))
							(- (* param4 param1))
							(- (* param2 (ego x?)))
							(* param2 param3)
						)
						(- param3 param1)
					)
					(ego y?)
				)
			)
			(= gEgoObjLoop (ego loop?))
			(if (< (ego x?) param1)
				(= theTheRegister_2 1)
			else
				(= theTheRegister_2 0)
			)
			(return 1)
		)
	)
)

(procedure (localproc_0283 param1 param2 param3 param4 param5 param6)
	(return
		(if
			(>
				(+
					(* param6 param3)
					(- (* param5 param4))
					(* param1 (- param4 param6))
					(* param2 (- param5 param3))
				)
				0
			)
			(return 1)
		else
			(return 0)
		)
	)
)

(procedure (localproc_02b5 param1)
	(if (or param1 (rm94 notify: 0))
		(archer1 setScript: archer1Start)
		(archer2 setScript: archer2Start)
		(archer3 setScript: archer3Start)
		(archer4 setScript: archer4Start)
	)
)

(class Archer of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		archerStop 0
		fequencyA 3
		fequencyB 10
		arrowsShot 0
		maxArrows 30
		minArrows 15
		clientP 0
		startCel 0
		shootX 0
		shootY 0
		hideX 0
		hideY 0
		arrowV 0
		arrowL 0
		arrowC 0
		arrowP 0
		startX 0
		startY 0
		A1 0
		B1 0
		X1 0
		Y1 0
		A2 0
		B2 0
		X2 0
		Y2 0
		A3 0
		B3 0
		X3 0
		Y3 0
		A4 0
		B4 0
		X4 0
		Y4 0
		A5 0
		B5 0
		X5 0
		Y5 0
		A6 0
		B6 0
		X6 0
		Y6 0
		begX 0
		begY 0
		endX 0
		endY 0
		archDeltaX 0
		archDeltaY 0
	)
	
	(method (doit)
		(if archerStop (-- archerStop))
		(cond 
			(
				(and
					(< state 3)
					(or
						(> arrowsShot maxArrows)
						(and archerStop (!= state 10))
						(and
							(< -20 (- startX (ego x?)))
							(< (- startX (ego x?)) 20)
							(!= state 10)
							(< -20 (- startY (ego y?)))
							(< (- startY (ego y?)) 20)
						)
					)
				)
				(self changeState: 10)
			)
			(
			(and (<= arrowsShot maxArrows) (not archerStop))
				(if
					(and
						(not
							(if (< -50 (- startX (ego x?)))
								(< (- startX (ego x?)) 50)
							)
						)
						(== state 11)
					)
					(self changeState: 0)
				)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp [temp0 40])
		(switch (= state newState)
			(0
				(client
					setCel: startCel
					illegalBits: 0
					ignoreActors:
					setPri: clientP
					setMotion: MoveTo shootX shootY self
				)
			)
			(1
				(= cycles (Random fequencyA fequencyB))
			)
			(2
				(if (self archerShoot:)
					(self arrowPath:)
					((= arrowP (Prop new:))
						view: arrowV
						setLoop: arrowL
						setCel: arrowC
						setPri: 15
						ignoreActors:
						hide:
						init:
					)
					(client setCel: 0 setCycle: CycleTo startCel 1 self)
				else
					(self changeState: 1)
				)
			)
			(3
				(self nextPath:)
				(if
					(and
						(== (ego script?) 0)
						(localproc_015e begX begY endX endY)
					)
					(arrowP hide:)
					(ego setScript: egoHit 0 arrowP)
					(self changeState: 1)
				else
					(arrowP show: posn: endX endY)
				)
				(client stopUpd:)
				(= cycles 2)
			)
			(4
				(self nextPath:)
				(if
					(and
						(== (ego script?) 0)
						(localproc_015e begX begY endX endY)
					)
					(arrowP hide:)
					(ego setScript: egoHit 0 arrowP)
					(self changeState: 1)
				else
					(arrowP posn: endX endY)
					(= cycles 2)
				)
			)
			(5
				(self nextPath:)
				(if
					(and
						(== (ego script?) 0)
						(localproc_015e begX begY endX endY)
					)
					(arrowP hide:)
					(ego setScript: egoHit 0 arrowP)
					(self changeState: 1)
				else
					(arrowP posn: endX endY)
					(= cycles 2)
				)
			)
			(6
				(self nextPath:)
				(if
					(and
						(== (ego script?) 0)
						(localproc_015e begX begY endX endY)
					)
					(arrowP hide:)
					(ego setScript: egoHit 0 arrowP)
					(self changeState: 1)
				else
					(arrowP posn: endX endY)
					(= cycles 2)
				)
			)
			(7
				(self nextPath:)
				(if
					(and
						(== (ego script?) 0)
						(localproc_015e begX begY endX endY)
					)
					(arrowP hide:)
					(ego setScript: egoHit 0 arrowP)
					(self changeState: 1)
				else
					(arrowP posn: endX endY)
					(= cycles 2)
				)
			)
			(8
				(++ arrowsShot)
				(if (< arrowsShot minArrows)
					(arrowP addToPic:)
				else
					(arrowP dispose:)
				)
				(self changeState: 1)
			)
			(10
				(client
					setCel: startCel
					setMotion: MoveTo hideX hideY self
				)
			)
			(11 (client stopUpd:))
		)
	)
	
	(method (archerShoot)
		(return
			(cond 
				(
					(and
						(<= 90 (ego y?))
						(<= (ego y?) 100)
						(< A1 (ego x?))
						(< (ego x?) B1)
					)
					(= endX (- X1 (Random 2 8)))
					(= endY (- Y1 (Random 4 16)))
					(return 1)
				)
				(
					(and
						(<= 100 (ego y?))
						(<= (ego y?) 110)
						(< A2 (ego x?))
						(< (ego x?) B2)
					)
					(= endX (- X2 (Random 2 8)))
					(= endY (- Y2 (Random 4 16)))
					(return 1)
				)
				(
					(and
						(<= 110 (ego y?))
						(<= (ego y?) 120)
						(< A3 (ego x?))
						(< (ego x?) B3)
					)
					(= endX (- X3 (Random 2 8)))
					(= endY (- Y3 (Random 4 16)))
					(return 1)
				)
				(
					(and
						(<= 120 (ego y?))
						(<= (ego y?) 130)
						(< A4 (ego x?))
						(< (ego x?) B4)
					)
					(= endX (- X4 (Random 2 8)))
					(= endY (- Y4 (Random 4 16)))
					(return 1)
				)
				(
					(and
						(<= 130 (ego y?))
						(<= (ego y?) 140)
						(< A5 (ego x?))
						(< (ego x?) B5)
					)
					(= endX (- X5 (Random 2 8)))
					(= endY (- Y5 (Random 4 16)))
					(return 1)
				)
				(
					(and
						(<= 140 (ego y?))
						(<= (ego y?) 150)
						(< A6 (ego x?))
						(< (ego x?) B6)
					)
					(= endX (- X6 (Random 2 8)))
					(= endY (- Y6 (Random 4 16)))
					(return 1)
				)
				(else (return 0))
			)
		)
	)
	
	(method (arrowPath)
		(= archDeltaX (- endX startX))
		(= archDeltaX (/ archDeltaX 5))
		(= archDeltaY (- endY startY))
		(= archDeltaY (/ archDeltaY 5))
		(= endX startX)
		(= endY startY)
		(= begX startX)
		(= begY startY)
	)
	
	(method (nextPath)
		(= endX (+ (= begX endX) archDeltaX))
		(= endY (+ (= begY endY) archDeltaY))
	)
)

(instance rm94 of Room
	(properties
		picture 94
		style $0008
	)
	
	(method (init)
		(LoadMany 128 94 194 590 3 515 536 537)
		(LoadMany
			132
			(GetSongNumber 73)
			(GetSongNumber 35)
			(GetSongNumber 81)
		)
		(LoadMany
			130
			186
			187
			188
			189
			190
			191
			192
			193
			194
			195
			103
			102
		)
		(if (ego knows: 23)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(if (ego knows: 20)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: 22)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: 17)
			(Load rsVIEW 521)
			(Load rsSCRIPT 105)
		)
		(cSound number: (GetSongNumber 73) loop: -1 play:)
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onSacks
				onKegs
				onRug
				onRugs
				onWire1
				onUnSafeBridge
				onSafeBridge
				onChasm
				onDoor
				onWindow
				onRCabinet
				onLCabinet
				onLumber1
				onLitter1
		)
		(AddToScore POINTS_ENTERBRIGANDFORTRESS 8)
		(StatusLine enable:)
		(StopEgo)
		(rug ignoreActors: 1 setPri: 11 init: stopUpd:)
		(rugs ignoreActors: 1 setPri: 11 init: stopUpd:)
		(unSafeBridge ignoreActors: 1 setPri: 6 init: stopUpd:)
		(safeBridge ignoreActors: 1 setPri: 6 init: addToPic:)
		(jackCycle init: hide:)
		(archer1 init: stopUpd:)
		(archer2 init: stopUpd:)
		(archer3 init: stopUpd:)
		(archer4 init: stopUpd:)
		(= local2 1)
		(if (and (not (Btest 348)) (Btest 237))
			(Bset 84)
			(= local2 0)
			(localproc_02b5 1)
		)
		(switch prevRoomNum
			(95
				(door setCel: 2 setPri: 1 init:)
				(= local3 1)
				(ego posn: 223 76 init: setMotion: MoveTo 190 76)
			)
			(else 
				(door setPri: 1 init:)
				(ego posn: 157 188 init: setMotion: MoveTo 157 172)
			)
		)
	)
	
	(method (doit)
		(asm
			lal      local5
			not     
			bnt      code_0d60
			pushi    #inRect
			pushi    4
			pushi    90
			pushi    106
			pushi    116
			pushi    112
			lag      ego
			send     12
			bnt      code_0d60
			ldi      1
			sal      local5
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    186
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0eae
code_0d60:
			lal      local5
			not     
			bnt      code_0da8
			pushi    215
			pushi    #x
			pushi    0
			lag      ego
			send     4
			le?     
			bnt      code_0d79
			pprev   
			ldi      235
			le?     
code_0d79:
			not     
			bnt      code_0da8
			pushi    108
			pushi    #y
			pushi    0
			lag      ego
			send     4
			le?     
			bnt      code_0da8
			pprev   
			ldi      111
			le?     
			bnt      code_0da8
			ldi      1
			sal      local5
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    187
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0eae
code_0da8:
			pushi    #inRect
			pushi    4
			pushi    154
			pushi    76
			pushi    167
			pushi    83
			lag      ego
			send     12
			bnt      code_0def
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0def
			lal      local4
			not     
			bnt      code_0def
			lal      local5
			not     
			bnt      code_0def
			ldi      1
			sal      local5
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    188
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0eae
code_0def:
			pushi    #inRect
			pushi    4
			pushi    282
			pushi    156
			pushi    293
			pushi    162
			lag      ego
			send     12
			bnt      code_0e42
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0e42
			lal      local4
			not     
			bnt      code_0e42
			pushi    #script
			pushi    0
			lag      ego
			send     4
			push    
			pushi    2
			pushi    189
			pushi    0
			callk    ScriptID,  4
			ne?     
			bnt      code_0e42
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    189
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0eae
code_0e42:
			pushi    #inRect
			pushi    4
			pushi    139
			pushi    145
			pushi    169
			pushi    152
			lag      ego
			send     12
			bnt      code_0e7c
			lal      local5
			not     
			bnt      code_0e7c
			ldi      1
			sal      local5
			pushi    #setPri
			pushi    1
			pushi    11
			pushi    122
			pushi    1
			pushi    2
			pushi    190
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     12
			jmp      code_0eae
code_0e7c:
			pushi    #inRect
			pushi    4
			pushi    140
			pushi    145
			pushi    187
			pushi    152
			lag      ego
			send     12
			bnt      code_0eae
			lal      local5
			not     
			bnt      code_0eae
			ldi      1
			sal      local5
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    191
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
code_0eae:
			lal      local3
			bnt      code_0ed0
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cBLUE
			and     
			bnt      code_0ed0
			pushi    #newRoom
			pushi    1
			pushi    95
			lag      curRoom
			send     6
			jmp      code_0eef
code_0ed0:
			pushi    #edgeHit
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0eef
			lal      local5
			not     
			bnt      code_0eef
			pushi    #newRoom
			pushi    1
			pushi    93
			lag      curRoom
			send     6
code_0eef:
			pushi    #doit
			pushi    0
			super    Room,  4
			ret     
		)
	)
	
	(method (dispose)
		(super dispose:)
		(LoadMany 0 186 187 188 189 190 191 192 193 194 195)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl ego pEvent 3) (HighPrint 94 0))
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'rest,nap') (Die 94 1 80 {Z-Z-Z-Z-Z-Z-Z-Z-Z-Z} 82 800 0 0))
					((Said 'cast>')
						(= local0 (SaidCast pEvent))
						(if (CastSpell local0)
							(switch local0
								(skDETECTMAGIC (HighPrint 94 2))
								(skDAZZLE
									(if (not (rm94 notify: 0))
										(if (AnimateDazzle) (rm94 notify: 2))
									else
										(HighPrint 94 3)
									)
								)
								(skFLAMEDART
									(AnimateThrowingFlameDart 0)
									(localproc_02b5 0)
								)
								(skCALM
									(if (rm94 notify: 0)
										(HighPrint 94 3)
									else
										(HighPrint 94 4)
									)
								)
								(skOPEN
									(if (rm94 notify: 1)
										(HighPrint 94 5)
									else
										(rm94 setScript: openMess)
										(if (AnimateOpenSpell ego openMess)
											(jackCycle setScript: (ScriptID 192 0))
										else
											(openMess changeState: 2)
										)
									)
								)
								(else  (HighPrint 94 5))
							)
						)
					)
					((Said 'throw/boulder') (if (AnimateThrowingRock 0) (localproc_02b5 0)))
					((Said 'throw/dagger') (if (AnimateThrowingDagger 0) (localproc_02b5 0)))
					(
					(Said 'step,hop,climb[/above,rope,string,string]')
						(cond 
							((ego inRect: 145 72 175 100) (ego setScript: (ScriptID 195 0)))
							((ego inRect: 275 152 298 170) (ego setScript: (ScriptID 195 1)))
							(else (HighPrint 94 6))
						)
					)
					((Said 'open[/gate,door]')
						(cond 
							(local3 (HighPrint 94 7))
							((ego inRect: 193 0 320 74) (door setScript: (ScriptID 194 0)))
							(else (HighPrint 94 8))
						)
					)
					((Said 'say,ask') (HighPrint 94 9))
					(local2 (SaidEndGameCourtyard pEvent))
					(else (pEvent claimed: 1) (HighPrint 94 10))
				)
			)
		)
	)
	
	(method (notify param1)
		(return
			(switch param1
				(0
					(if (== local2 1)
						(= local2 0)
						(return 1)
					else
						(return 0)
					)
				)
				(1
					(if (== local1 1)
						(return 1)
					else
						(= local1 1)
						(return 0)
					)
				)
				(2
					(archer1Start archerStop: 100)
					(archer2Start archerStop: 100)
					(archer3Start archerStop: 100)
					(archer4Start archerStop: 100)
				)
				(3
					(if (== local3 1) (return 1) else (return 0))
				)
				(4 (= local3 1))
				(5 (= local3 0))
				(6 (= local4 1))
				(7 (= local4 0))
				(8 (= local40 0))
			)
		)
	)
)

(instance rug of Prop
	(properties
		y 163
		x 153
		view 94
		priority 9
	)
)

(instance rugs of Prop
	(properties
		y 163
		x 180
		view 94
		loop 1
		priority 12
	)
)

(instance unSafeBridge of Prop
	(properties
		y 118
		x 101
		view 94
		loop 2
		priority 8
	)
)

(instance safeBridge of Prop
	(properties
		y 118
		x 227
		view 94
		loop 3
		priority 8
	)
)

(instance door of Prop
	(properties
		y 59
		x 208
		view 94
		loop 4
		priority 1
	)
)

(instance jack1 of View
	(properties
		y 149
		x 307
		view 94
		loop 5
		priority 13
	)
)

(instance jackCycle of Prop
	(properties
		y 151
		x 307
		view 94
		loop 6
		priority 13
	)
)

(instance jackSound of Sound
	(properties
		number 81
		priority 3
	)
)

(instance archer1 of Actor
	(properties
		y 78
		x 16
		view 194
		priority 4
	)
	
	(method (doit)
		(= local39 0)
		(while (<= local39 24)
			(if (!= [theRegister local39] 0)
				(localproc_0030
					[theRegister (+ local39 1)]
					(ego loop?)
					[theRegister (+ local39 2)]
				)
				([theRegister (+ local39 3)]
					setCel: local37
					setPri: (ego priority?)
					posn: (+ (ego x?) local38) (+ (ego y?) [theRegister local39])
				)
			)
			(= local39 (+ local39 4))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl archer1 pEvent 3) (HighPrint 94 11))
		)
	)
)

(instance archer2 of Actor
	(properties
		y 80
		x 296
		view 194
		priority 4
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl archer1 pEvent 3) (HighPrint 94 12))
		)
	)
)

(instance archer3 of Actor
	(properties
		y 106
		x -23
		view 194
		priority 7
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl archer1 pEvent 3) (HighPrint 94 13))
		)
	)
)

(instance archer4 of Actor
	(properties
		y 110
		x 343
		view 194
		priority 7
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl archer1 pEvent 3) (HighPrint 94 14))
		)
	)
)

(instance antwerp of Actor
	(properties
		view 590
		loop 7
		priority 4
	)
)

(instance onSacks of RFeature
	(properties
		nsTop 61
		nsLeft 72
		nsBottom 84
		nsRight 140
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSacks pEvent 3) (HighPrint 94 15))
		)
	)
)

(instance onKegs of RFeature
	(properties
		nsTop 61
		nsLeft 179
		nsBottom 84
		nsRight 243
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKegs pEvent 3) (HighPrint 94 16))
		)
	)
)

(instance onRug of RFeature
	(properties
		nsTop 139
		nsLeft 130
		nsBottom 159
		nsRight 174
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRug pEvent 3) (HighPrint 94 17))
		)
	)
)

(instance onRugs of RFeature
	(properties
		nsTop 139
		nsLeft 175
		nsBottom 161
		nsRight 197
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRugs pEvent 3) (HighPrint 94 18))
		)
	)
)

(instance onWire1 of RFeature
	(properties
		nsTop 156
		nsLeft 278
		nsBottom 156
		nsRight 297
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onWire1 pEvent 3)
					(IsObjectOnControl onWire2 pEvent 3)
				)
				(HighPrint 94 19)
			)
		)
	)
)

(instance onWire2 of RFeature
	(properties
		nsTop 77
		nsLeft 142
		nsBottom 77
		nsRight 176
	)
)

(instance onUnSafeBridge of RFeature
	(properties
		nsTop 104
		nsLeft 89
		nsBottom 116
		nsRight 110
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onUnSafeBridge pEvent 3) (HighPrint 94 20))
		)
	)
)

(instance onSafeBridge of RFeature
	(properties
		nsTop 104
		nsLeft 213
		nsBottom 116
		nsRight 240
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSafeBridge pEvent 3) (HighPrint 94 21))
		)
	)
)

(instance onChasm of RFeature
	(properties
		nsTop 104
		nsLeft 36
		nsBottom 116
		nsRight 291
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(not (IsObjectOnControl onSafeBridge pEvent 3))
					(not (IsObjectOnControl onUnSafeBridge pEvent 3))
					(IsObjectOnControl onChasm pEvent 3)
				)
				(HighPrint 94 22)
			)
		)
	)
)

(instance onDoor of RFeature
	(properties
		nsTop 29
		nsLeft 208
		nsBottom 58
		nsRight 237
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onDoor pEvent 3) (HighPrint 94 23))
		)
	)
)

(instance onWindow of RFeature
	(properties
		nsTop 29
		nsLeft 167
		nsBottom 47
		nsRight 197
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onWindow pEvent 3) (HighPrint 94 24))
		)
	)
)

(instance onRCabinet of RFeature
	(properties
		nsTop 141
		nsLeft 299
		nsBottom 175
		nsRight 318
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRCabinet pEvent 3) (HighPrint 94 25))
		)
	)
)

(instance onLCabinet of RFeature
	(properties
		nsTop 143
		nsBottom 178
		nsRight 12
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLCabinet pEvent 3) (HighPrint 94 26))
		)
	)
)

(instance onLumber1 of RFeature
	(properties
		nsTop 129
		nsLeft 44
		nsBottom 157
		nsRight 124
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onLumber1 pEvent 3)
					(IsObjectOnControl onLumber2 pEvent 3)
				)
				(HighPrint 94 27)
			)
		)
	)
)

(instance onLumber2 of RFeature
	(properties
		nsTop 131
		nsLeft 200
		nsBottom 157
		nsRight 276
	)
)

(instance onLitter1 of RFeature
	(properties
		nsTop 170
		nsLeft 274
		nsBottom 175
		nsRight 287
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onLitter1 pEvent 3)
					(IsObjectOnControl onLitter2 pEvent 3)
					(IsObjectOnControl onLitter3 pEvent 3)
					(IsObjectOnControl onLitter4 pEvent 3)
					(IsObjectOnControl onLitter5 pEvent 3)
				)
				(HighPrint 94 28)
			)
		)
	)
)

(instance onLitter2 of RFeature
	(properties
		nsTop 122
		nsLeft 275
		nsBottom 128
		nsRight 287
	)
)

(instance onLitter3 of RFeature
	(properties
		nsTop 73
		nsLeft 244
		nsBottom 79
		nsRight 251
	)
)

(instance onLitter4 of RFeature
	(properties
		nsTop 83
		nsLeft 53
		nsBottom 92
		nsRight 63
	)
)

(instance onLitter5 of RFeature
	(properties
		nsTop 116
		nsLeft 18
		nsBottom 124
		nsRight 27
	)
)

(instance archer1Start of Archer
	(properties
		fequencyA 5
		fequencyB 15
		clientP 4
		startCel 4
		shootX 49
		shootY 78
		hideX 16
		hideY 78
		arrowV 194
		arrowL 6
		arrowC 3
		startX 84
		startY 65
		B1 320
		X1 260
		Y1 84
		B2 320
		X2 276
		Y2 97
		B3 320
		X3 294
		Y3 113
		A4 160
		B4 320
		X4 315
		Y4 133
		A5 240
		B5 320
		X5 321
		Y5 141
		A6 1
	)
)

(instance archer2Start of Archer
	(properties
		fequencyA 5
		fequencyB 15
		clientP 4
		startCel 4
		shootX 275
		shootY 80
		hideX 296
		hideY 80
		arrowV 194
		arrowL 6
		startX 250
		startY 67
		B1 320
		X1 67
		Y1 77
		B2 320
		X2 47
		Y2 97
		B3 170
		X3 25
		Y3 116
		B4 150
		X4 9
		Y4 132
		B5 145
		X5 5
		Y5 142
		A6 1
	)
)

(instance archer3Start of Archer
	(properties
		fequencyA 5
		fequencyB 15
		clientP 7
		startCel 4
		shootX 10
		shootY 106
		hideX -23
		hideY 106
		arrowV 194
		arrowL 6
		arrowC 3
		startX 35
		startY 93
		A1 200
		B1 320
		X1 262
		Y1 85
		A2 200
		B2 320
		X2 273
		Y2 95
		B3 320
		X3 287
		Y3 105
		B4 320
		X4 296
		Y4 111
		B5 320
		X5 306
		Y5 130
		A6 200
		B6 320
		X6 320
		Y6 142
	)
)

(instance archer4Start of Archer
	(properties
		fequencyA 5
		fequencyB 15
		clientP 7
		startCel 4
		shootX 313
		shootY 110
		hideX 343
		hideY 110
		arrowV 194
		arrowL 6
		startX 288
		startY 97
		B1 120
		X1 75
		Y1 67
		B2 140
		X2 68
		Y2 86
		B3 200
		X3 36
		Y3 104
		B4 320
		X4 23
		Y4 120
		B5 320
		X5 16
		Y5 123
		B6 320
		X6 7
		Y6 135
	)
)

(instance egoHit of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(register show:)
				(cond 
					((ego has: invChainmailArmor) (ReduceHP 15))
					((ego has: invLeatherArmor) (ReduceHP 30))
					(else (ReduceHP 45))
				)
				(cond 
					((== [theRegister 0] 0)
						(= [theRegister 0] theTheRegister)
						(= [theRegister 1] gEgoObjLoop)
						(= [theRegister 2] theTheRegister_2)
						(= [theRegister 3] register)
					)
					((== [theRegister 4] 0)
						(= [theRegister 4] theTheRegister)
						(= [theRegister 5] gEgoObjLoop)
						(= [theRegister 6] theTheRegister_2)
						(= [theRegister 7] register)
					)
					((== [theRegister 8] 0)
						(= [theRegister 8] theTheRegister)
						(= [theRegister 9] gEgoObjLoop)
						(= [theRegister 10] theTheRegister_2)
						(= [theRegister 11] register)
					)
					((== [theRegister 12] 0)
						(= [theRegister 12] theTheRegister)
						(= [theRegister 13] gEgoObjLoop)
						(= [theRegister 14] theTheRegister_2)
						(= [theRegister 15] register)
					)
					((== [theRegister 16] 0)
						(= [theRegister 16] theTheRegister)
						(= [theRegister 17] gEgoObjLoop)
						(= [theRegister 18] theTheRegister_2)
						(= [theRegister 19] register)
					)
					((== [theRegister 20] 0)
						(= [theRegister 20] theTheRegister)
						(= [theRegister 21] gEgoObjLoop)
						(= [theRegister 22] theTheRegister_2)
						(= [theRegister 23] register)
					)
					((== [theRegister 24] 0)
						(= [theRegister 24] theTheRegister)
						(= [theRegister 25] gEgoObjLoop)
						(= [theRegister 26] theTheRegister_2)
						(= [theRegister 27] register)
					)
					(else (register dispose:))
				)
				(if (<= [skills skHP] 0)
					(= cycles 3)
				else
					(self dispose:)
				)
			)
			(1
				(Die
					94
					29
					82
					516
					0
					9
					80
					{You knew this job was dangerous....}
				)
			)
		)
	)
)

(instance openMess of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(HighPrint 94 30)
				(lockSound number: (GetSongNumber 35) init: play:)
				(= cycles 8)
			)
			(2
				(lockSound dispose:)
				(self dispose:)
			)
		)
	)
)

(instance lockSound of Sound
	(properties
		number 35
		priority 3
	)
)
