;;; Sierra Script 1.0 - (do not remove this comment)
(script# 95)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use AnimateOpen)
(use brigandDiningActions)
(use LoadMany)
(use GControl)
(use Motion)
(use Game)
(use Menu)
(use Actor)
(use System)

(public
	rm95 0
	bDoor 1
	lDoor 2
	rDoor 3
	chandelier 4
	candelabra 5
	rope 6
	chair 7
	flames 8
	brig1 9
	brig2 10
	brig3 11
	brig4 12
	brig5 13
	brig6 14
	moe 15
	moeHead 16
	curly 17
	curlyHead 18
	larry 19
	larryHead 20
	finalEntry 21
	stars 22
	sBrigBlocked 23
	sChandFall 24
	tryOpenSpell 25
	openBDoor 26
	barFDoor 27
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6 =  1
	local7 =  1
	local8 =  1
	local9
	local10
	local11
	local12
	local13
	local14
	local15
	local16
)
(instance rm95 of Room
	(properties
		picture 95
		style $0008
		horizon 80
	)
	
	(method (init)
		(LoadMany 128 95 465 196 295 188 187 186 510 195 525)
		(LoadMany 130 156 157 158 159 160)
		(if (ego knows: 23)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(if (ego knows: 20)
			(Load rsVIEW 521)
			(Load rsSCRIPT 106)
		)
		(if (ego knows: 22)
			(Load rsVIEW 521)
			(Load rsSCRIPT 104)
		)
		(if (ego knows: 17)
			(Load rsVIEW 521)
			(Load rsSCRIPT 105)
		)
		(super init:)
		(self
			setFeatures: onDrunk onSign onRope onCandelabra onChandelier
		)
		(gMouseHandler add: self)
		(AddToScore POINTS_ENTERBRIGANDDININGROOM 8)
		(StatusLine enable:)
		(StopEgo)
		(setHighSpeedHero 0)
		(Bset 345)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(brigSign init: setPri: 3 addToPic:)
		(chairs init: setPri: 6 addToPic:)
		(rDoor init: stopUpd:)
		(lDoor init: stopUpd:)
		(candelabra init: stopUpd:)
		(drunk init: setPri: 12 stopUpd:)
		(chandelier init: setPri: 5 stopUpd:)
		(rope init: setPri: 3)
		(ropeHolder init: setPri: 3 addToPic:)
		(flames init: setPri: 6 setCycle: Forward)
		(chair init: stopUpd:)
		(brig1 init: hide:)
		(brig4 init: hide:)
		(moe init:)
		((ScriptID 95 16) init:)
		((ScriptID 95 17) init:)
		((ScriptID 95 18) init:)
		((ScriptID 95 19) init:)
		((ScriptID 95 20) init:)
		(bDoor init: setPri: 1 stopUpd:)
		(fDoor setCel: 1 init: setPri: 14 stopUpd:)
		(= local3 0)
		(ego posn: 302 194 init: setScript: egoEntersSouth)
	)
	
	(method (doit)
		(if (and local0 (& (ego onControl: origin) cLRED))
			(curRoom newRoom: 94)
		)
		(if
			(and
				local6
				(or (< (ego x?) 210) (< (ego y?) 135))
				(== (brig1 script?) 0)
			)
			(brig1 setScript: (ScriptID 157 0))
		)
		(if
			(and
				local7
				(not local2)
				(< (ego x?) 250)
				(== (brig4 script?) 0)
				(not local2)
			)
			(brig4 setScript: (ScriptID 159 2))
		)
		(if (and local3 local2 local8)
			(= local8 0)
			(moe setScript: (ScriptID 156 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclear 345)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl ego pEvent 3) (HighPrint 95 0))
				)
			)
			(evSAID
				(if (Said 'rest,nap')
					(Die 95 1 80 {Z-Z-Z-Z-Z-Z-Z-Z-Z-Z} 82 800 0 0)
				)
				(cond 
					(
						(or
							(Said 'climb,hop[/table]')
							(Said 'use,swing,get,grab/rope,chandelier')
							(Said 'get/table')
						)
						(cond 
							(local16 (HighPrint 95 2))
							((ego inRect: 100 108 217 120) (ego setScript: (ScriptID 158 1)))
							(else (HighPrint 95 3))
						)
					)
					((and local4 (not local16)) (HighPrint 95 4) (pEvent claimed: 1))
					((not (super handleEvent: pEvent)) (SaidEndGameBrigands pEvent))
				)
			)
		)
	)
	
	(method (notify param1)
		(return
			(switch param1
				(0 (= local0 1))
				(1
					(if local4 (return 1) else (return 0))
				)
				(2 (= local4 1))
				(3
					(if local3 (return 1) else (return 0))
				)
				(4
					(if local2 (return 1) else (return 0))
				)
				(5 (= local2 1))
				(6
					(if local5 (return 1) else (return 0))
				)
				(7 (= local5 0))
				(8 (= local5 1))
				(9
					(if local6 (return 1) else (return 0))
				)
				(10 (= local6 0))
				(11 (= local7 0))
				(12
					(if local12 (return 1) else (return 0))
				)
				(13 (= local12 1))
				(14
					(if local11 (return 1) else (return 0))
				)
				(15 (= local11 1))
				(16
					(if local9 (return 1) else (return 0))
				)
				(17 (= local9 1))
				(18
					(if local13 (return 1) else (return 0))
				)
				(19 (= local13 1))
				(20
					(if local14 (return 1) else (return 0))
				)
				(21 (= local14 1))
				(22
					(if local15 (return 1) else (return 0))
				)
				(23 (= local15 1))
				(24
					(if local16 (return 1) else (return 0))
				)
				(25 (= local16 1))
			)
		)
	)
)

(instance brigSign of View
	(properties
		y 54
		x 154
		view 95
	)
)

(instance chairs of View
	(properties
		y 76
		x 160
		view 95
		cel 1
	)
)

(instance rDoor of Prop
	(properties
		y 93
		x 290
		view 95
		loop 1
	)
)

(instance lDoor of Prop
	(properties
		y 93
		x 15
		view 95
		loop 2
	)
)

(instance bDoor of Prop
	(properties
		y 83
		x 46
		view 95
		loop 3
	)
)

(instance fDoor of Prop
	(properties
		y 178
		x 274
		view 95
		loop 8
	)
)

(instance candelabra of Prop
	(properties
		y 93
		x 239
		view 95
		loop 4
	)
)

(instance chandelier of Prop
	(properties
		y 48
		x 155
		view 95
		loop 5
	)
)

(instance rope of Prop
	(properties
		y 63
		x 211
		view 195
		loop 4
	)
)

(instance ropeHolder of Prop
	(properties
		y 48
		x 208
		view 95
		cel 2
	)
)

(instance drunk of View
	(properties
		y 138
		x 61
		view 95
		loop 9
	)
)

(instance flames of Prop
	(properties
		y 29
		x 160
		view 95
		loop 6
	)
)

(instance chair of Prop
	(properties
		y 104
		x 306
		view 95
		loop 7
		cel 1
	)
)

(instance brig1 of Actor
	(properties
		view 465
	)
)

(instance brig2 of Actor
	(properties
		view 465
	)
)

(instance brig3 of Actor
	(properties
		view 465
	)
)

(instance brig4 of Actor
	(properties
		view 465
	)
)

(instance brig5 of Actor
	(properties
		view 465
	)
)

(instance brig6 of Actor
	(properties
		view 465
	)
)

(instance curly of Actor
	(properties
		view 196
	)
)

(instance moe of Actor
	(properties
		view 196
	)
)

(instance larry of Actor
	(properties
		view 196
	)
)

(instance curlyHead of Prop
	(properties
		z 29
		view 188
	)
	
	(method (doit)
		(self
			posn: (curly x?) (curly y?)
			setPri: (curly priority?)
			setCel: (curly cel?)
			setLoop: (curly loop?)
		)
		(super doit:)
	)
)

(instance moeHead of Prop
	(properties
		z 29
		view 187
	)
	
	(method (doit)
		(self
			posn: (moe x?) (moe y?)
			setPri: (moe priority?)
			setCel: (moe cel?)
			setLoop: (moe loop?)
		)
		(super doit:)
	)
)

(instance larryHead of Prop
	(properties
		z 29
		view 186
	)
	
	(method (doit)
		(self
			posn: (larry x?) (larry y?)
			setPri: (larry priority?)
			setCel: (larry cel?)
			setLoop: (larry loop?)
		)
		(super doit:)
	)
)

(instance stars of Prop
	(properties
		view 295
		loop 2
	)
)

(instance onDrunk of RFeature
	(properties
		nsTop 114
		nsLeft 47
		nsBottom 138
		nsRight 72
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onDrunk pEvent 3) (HighPrint 95 5))
		)
	)
)

(instance onSign of RFeature
	(properties
		nsTop 45
		nsLeft 104
		nsBottom 52
		nsRight 196
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSign pEvent 3) (HighPrint 95 6))
		)
	)
)

(instance onRope of RFeature
	(properties
		nsTop 45
		nsLeft 204
		nsBottom 61
		nsRight 213
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onRope pEvent 3) (HighPrint 95 7))
		)
	)
)

(instance onCandelabra of RFeature
	(properties
		nsTop 48
		nsLeft 233
		nsBottom 92
		nsRight 261
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCandelabra pEvent 3) (HighPrint 95 8))
		)
	)
)

(instance onChandelier of RFeature
	(properties
		nsTop 19
		nsLeft 133
		nsBottom 41
		nsRight 174
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onChandelier pEvent 3) (HighPrint 95 9))
		)
	)
)

(instance egoEntersSouth of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: cWHITE setMotion: MoveTo 302 170 self)
			)
			(1
				((ScriptID 95 0) notify: 0)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance openBDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(bDoor setCel: 1)
				(= cycles 4)
			)
			(1
				(ego
					setPri: 2
					illegalBits: 0
					setMotion: MoveTo 66 79 self
				)
			)
			(2
				(StopEgo)
				(curRoom newRoom: 96)
			)
		)
	)
)

(instance tryOpenSpell of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (LockEgo) (= cycles 1))
			(1 (AnimateOpenSpell self self))
			(2
				(client setScript: openBDoor)
			)
		)
	)
)

(instance barFDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fDoor setScript: closeFDoor self)
			)
			(1
				(LockEgo)
				(ego
					setPri: 14
					illegalBits: 0
					setMotion: MoveTo 295 175 self
				)
			)
			(2
				(ego loop: 2)
				(HighPrint 95 10)
				(= cycles 1)
			)
			(3
				(StopEgo)
				(ego illegalBits: (& cWHITE cLRED))
				(= local3 1)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance closeFDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					setPri: 12
					illegalBits: 0
					setMotion: MoveTo 284 182 self
				)
			)
			(1
				(ego loop: 2 setPri: 14)
				(fDoor setPri: 15 ignoreActors: 1 setCel: 0 stopUpd:)
				(= cycles 2)
			)
			(2
				(StopEgo)
				(ego illegalBits: (& cWHITE cLRED))
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance finalEntry of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 80))
			(1
				(lDoor setCel: 1)
				(brig1
					show:
					setPri: 3
					posn: 31 90
					ignoreActors: 1
					illegalBits: 0
					setCycle: Walk
					setMotion: MoveTo 55 90
				)
				(= cycles 4)
			)
			(2
				(brig2
					init:
					setPri: 3
					ignoreActors:
					illegalBits: 0
					posn: 31 90
					setCycle: Walk
					setMotion: MoveTo 46 92
				)
				(= cycles 3)
			)
			(3
				(brig3
					init:
					setPri: 3
					ignoreActors:
					illegalBits: 0
					posn: 31 90
					setCycle: Walk
					setMotion: MoveTo 40 94 self
				)
			)
			(4
				(Die 95 11 82 516 0 9 80 {Molasses in January.})
			)
		)
	)
)

(instance sBrigBlocked of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(client setScript: (ScriptID 158 0))
			)
		)
	)
)

(instance sChandFall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(= local16 1)
				(client setScript: (ScriptID 156 1))
			)
		)
	)
)
