;;; Sierra Script 1.0 - (do not remove this comment)
(script# 96)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Wander)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm96 0
	trap1 1
	trap2 2
	trap3 3
	trap4 4
	yorick 5
	head 6
	door3 7
	door7 8
	door11 9
	door12 10
	door13 11
	behindDoor7 12
	behindDoor11 13
	chain 14
	arrow 15
	effect 16
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
	[local10 6]
	[local16 6] = [160 164 160 167 151 155]
	[local22 6] = [14 21 9 12 13 21]
)
(procedure (localproc_002c)
	(if (Btest 259)
		(HighPrint 96 0)
	else
		(HighPrint 96 1)
	)
)

(procedure (localproc_0f76 &tmp temp0)
	(= temp0 0)
	(while (< temp0 6)
		([local10 temp0]
			ignoreActors:
			posn: [local16 temp0] [local22 (= [local10 temp0] (Clone aFly))]
			init:
			setLoop: 9
			setPri: 15
		)
		(if (< detailLevel 2)
			([local10 temp0] stopUpd: addToPic:)
		else
			([local10 temp0] setCycle: Forward setMotion: Wander)
		)
		(++ temp0)
	)
)

(instance roomMusic of Sound
	(properties
		number 82
		priority 1
		loop -1
	)
)

(instance effect of Sound
	(properties
		number 86
		priority 3
	)
)

(instance isScript of Code
	(properties)
	
	(method (doit param1)
		(if (param1 respondsTo: #script) (param1 script?))
	)
)

(instance Door1 of RFeature
	(properties
		nsTop 64
		nsLeft 2
		nsBottom 132
		nsRight 12
	)
)

(instance Door2 of RFeature
	(properties
		nsTop 24
		nsLeft 36
		nsBottom 76
		nsRight 50
	)
)

(instance Door6 of RFeature
	(properties
		nsTop 62
		nsLeft 65
		nsBottom 102
		nsRight 84
	)
)

(instance polkaDots of RFeature
	(properties
		nsTop 53
		nsLeft 243
		nsBottom 133
		nsRight 319
	)
)

(instance littleButton of RFeature
	(properties
		nsTop 91
		nsLeft 55
		nsBottom 97
		nsRight 59
	)
)

(instance littleSign of RFeature
	(properties
		nsTop 93
		nsLeft 265
		nsBottom 101
		nsRight 275
	)
)

(instance doorSign of RPicView
	(properties
		y 46
		x 13
		view 96
		loop 7
		priority 14
	)
)

(instance MESign of RPicView
	(properties
		y 53
		x 161
		view 96
		loop 7
		cel 1
		priority 14
	)
)

(instance yorick of Prop
	(properties
		y 95
		x 161
		view 297
	)
	
	(method (doit)
		(cond 
			((> local4 1) (-- local4))
			((== local4 1)
				(= local4 local3)
				(if
					(and
						(Btest 267)
						(not (gCast firstTrue: #perform isScript))
						(not (Btest 263))
						(not isEgoLocked)
						(< (ego x?) 295)
						(!= (ego onControl: origin) cYELLOW)
						(!= (ego onControl: origin) cLMAGENTA)
						(not local2)
					)
					(Bset 265)
					(self setScript: (ScriptID 229 0))
				)
			)
		)
		(if (Btest 259)
			(cond 
				(
					(<
						(= local1
							(GetAngle (yorick x?) (yorick y?) (ego x?) (ego y?))
						)
						112
					)
					(if (!= (yorick cel?) 4) (yorick setCel: 4))
				)
				((< local1 145) (if (!= (yorick cel?) 3) (yorick setCel: 3)))
				((< local1 220) (if (!= (yorick cel?) 2) (yorick setCel: 2)))
				((< local1 253) (if (!= (yorick cel?) 1) (yorick setCel: 1)))
				((!= (yorick cel?) 0) (yorick setCel: 0))
			)
		)
		(cond 
			((and (Btest 268) (not local7) (not local8))
				(AddToScore POINTS_TALKTOJESTERABOUTELSA 8)
				(= local7 1)
				(head dispose:)
				(self view: 298 setLoop: 0 setCel: 0)
			)
			((and local7 (ego mover?))
				(StopEgo)
				(= local7 0)
				(= local8 1)
				(arrow setScript: (ScriptID 231 1))
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast')
				(if (ego script?)
					(HighPrint 96 2)
				else
					(HighPrint 96 3)
					(arrow setScript: (ScriptID 231 1))
				)
			)
			((Said 'throw>')
				(cond 
					((ego script?) (HighPrint 96 4) (pEvent claimed: 1))
					((Said '/dagger,boulder') (HighPrint 96 5) (arrow setScript: (ScriptID 231 1)))
					(else (HighPrint 96 6) (pEvent claimed: 1))
				)
			)
			((Said 'chat>')
				(cond 
					((Btest 267) (localproc_002c) (pEvent claimed: 1))
					((Said '/yorick')
						(if (not (Btest 268))
							(AddToScore POINTS_TALKTOJESTER 2)
							(Bset 268)
							(HighPrint 96 7)
						else
							(HighPrint 96 8)
						)
					)
					((Said '/man,warlock,mage,bandit') (HighPrint 96 9))
				)
			)
			((Said 'ask>')
				(if (Btest 267)
					(localproc_002c)
					(pEvent claimed: 1)
				else
					(= local9 1)
					(cond 
						((Said '/elsa')
							(if (not (Btest 268))
								(Bset 268)
								(HighPrint 96 10)
								(HighPrint 96 11)
							)
							(HighPrint 96 12)
							(HighPrint 96 13)
							(HighPrint 96 14)
						)
						((Said '/enchantment,disenchantment,spell,curse')
							(if (not (Btest 268)) (Bset 268) (HighPrint 96 15))
							(HighPrint 96 16)
							(HighPrint 96 17)
							(HighPrint 96 18)
							(HighPrint 96 19)
						)
						((Said '/yorick')
							(if (not (Btest 268)) (Bset 268) (HighPrint 96 7))
							(HighPrint 96 20)
							(HighPrint 96 21)
							(HighPrint 96 22)
							(HighPrint 96 23)
						)
						((Said '/i') (HighPrint 96 24) (HighPrint 96 25))
						((Said '/warlock,caravan') (HighPrint 96 26))
						((Said '/powder,banana,trick') (HighPrint 96 27))
						((Said '/jester') (HighPrint 96 28))
						((Said '/leader[<bandit,your,about]') (HighPrint 96 29))
						((Said '/potion<disenchant')
							(if (not (Btest 268)) (Bset 268) (HighPrint 96 15))
							(HighPrint 96 30)
						)
						((Said '/potion') (= local9 0) (HighPrint 96 31))
						((Said '/swordy,lordy')
							(HighPrint 96 32)
							(HighPrint 96 33)
							(HighPrint 96 34)
							(HighPrint 96 35)
						)
						((Said '/done,door') (HighPrint 96 36) (HighPrint 96 37))
						((Said '/room,maze,path,aisle') (HighPrint 96 38) (HighPrint 96 39))
						((Said '/leer,(mirror[<magic,leer,about])') (HighPrint 96 40) (HighPrint 96 41))
						((Said '/bull,toro,bull') (HighPrint 96 42) (HighPrint 96 43))
						((Said '/castle') (HighPrint 96 44))
						((Said '/baron,(dad[<leader,elsa,about])') (HighPrint 96 45))
						((Said '/*')
							(= local9 0)
							(if (Btest 268)
								(HighPrint 96 46)
							else
								(switch (Random 0 3)
									(0 (HighPrint 96 47))
									(1 (HighPrint 96 48))
									(2 (HighPrint 96 49))
									(3 (HighPrint 96 50))
								)
							)
						)
					)
					(if local9 (AddToScore POINTS_TALKTOJESTER 2))
				)
			)
		)
	)
)

(instance head of Prop
	(properties
		y 76
		x 161
		view 297
		loop 6
		cel 1
	)
	
	(method (doit)
		(= local1
			(GetAngle (yorick x?) (yorick y?) (ego x?) (ego y?))
		)
		(if (and (== (head loop?) 6) (!= (head cel?) 3))
			(cond 
				((< local1 135) (if (!= (head cel?) 2) (head setCel: 2)))
				((< local1 225) (if (!= (head cel?) 1) (head setCel: 1)))
				((!= (head cel?) 0) (head setCel: 0))
			)
		)
		(super doit:)
	)
)

(instance secretSign of RPicView
	(properties
		y 48
		x 282
		view 96
		loop 7
		cel 2
	)
)

(instance exitSign of RPicView
	(properties
		y 52
		x 70
		view 96
		loop 7
		cel 3
		priority 7
	)
)

(instance behindDoor11 of View
	(properties
		y 94
		x 215
		view 96
		loop 7
		cel 4
	)
)

(instance door11 of Prop
	(properties
		y 94
		x 225
		view 96
	)
	
	(method (doit)
		(cond 
			((> local5 1)
				(if (== (ego onControl: origin) cLGREEN)
					(= local5 0)
					(self setScript: (ScriptID 228 1))
				else
					(-- local5)
				)
			)
			((== local5 1) (= local5 0) (= local6 0) (self setCycle: BegLoop))
		)
		(super doit:)
	)
)

(instance behindDoor7 of Prop
	(properties
		y 96
		x 95
		view 96
		loop 2
	)
)

(instance door7 of Prop
	(properties
		y 95
		x 93
		view 96
		loop 1
	)
)

(instance arrow of Prop
	(properties
		y 76
		x 160
		view 96
		loop 3
	)
)

(instance door3 of Prop
	(properties
		y 108
		x 36
		view 96
		loop 4
	)
)

(instance door13 of Prop
	(properties
		y 68
		x 253
		view 96
		loop 5
	)
	
	(method (doit)
		(if (and (Btest 269) (not script))
			(Bclear 269)
			(Bset 257)
			(ego
				setPri: (+ (ego priority?) 1)
				setScript: (ScriptID 234 0)
			)
		)
		(super doit:)
	)
)

(instance door12 of Prop
	(properties
		y 105
		x 242
		view 96
		loop 6
		cel 2
	)
)

(instance globe of Prop
	(properties
		y 26
		x 161
		view 96
		loop 8
	)
)

(instance chain of View
	(properties
		y 48
		x 45
		view 96
		loop 7
		cel 6
	)
)

(instance trap1 of Prop
	(properties
		y 110
		x 57
		view 296
	)
)

(instance trap2 of Prop
	(properties
		y 150
		x 269
		view 296
		loop 1
	)
)

(instance trap3 of Prop
	(properties
		y 138
		x 160
		view 296
		loop 2
	)
)

(instance trap4 of Prop
	(properties
		y 115
		x 159
		view 296
		loop 3
	)
	
	(method (doit)
		(if (and (Btest 270) (not script))
			(Bclear 270)
			(self setScript: (ScriptID 225 0))
		)
		(super doit:)
	)
)

(instance aFly of Actor
	(properties
		view 96
		loop 9
	)
)

(instance rm96 of Room
	(properties
		picture 96
		style $0002
	)
	
	(method (init)
		(LoadMany RES_VIEW 297 298 96 296 536 537 517 538 516)
		(LoadMany RES_SCRIPT REVERSE JUMP CHASE WANDER 225 226 227 228 229 230 231 232 233 234)
		(LoadMany RES_SOUND
			82
			(GetSongNumber 86)
			(GetSongNumber 85)
			(GetSongNumber 84)
			(GetSongNumber 83)
			(GetSongNumber 87)
		)
		(cSound stop:)
		(super init: &rest)
		(gMouseHandler add: self)
		(AddToScore POINTS_ENTERBRIGANDJESTERROOM 8)
		(StatusLine enable:)
		(gAddToPics
			add: doorSign MESign secretSign exitSign
			eachElementDo: #init
			doit:
		)
		(= local4 (= local3 50))
		(roomMusic init: play:)
		(effect init:)
		(localproc_0f76)
		(= countdownAwaitingResponse 0)
		(yorick init: stopUpd:)
		(head setPri: 7 init:)
		(trap1 ignoreActors: setPri: 7 init: stopUpd:)
		(trap2 ignoreActors: setPri: 10 init: stopUpd:)
		(trap3 ignoreActors: setPri: 9 init: stopUpd:)
		(trap4 ignoreActors: setPri: 7 init: stopUpd:)
		(chain ignoreActors: setPri: 7 init: stopUpd:)
		(door11
			ignoreActors:
			cycleSpeed: 1
			setPri: 6
			init:
			stopUpd:
		)
		(door7
			ignoreActors:
			cycleSpeed: 1
			setPri: 5
			init:
			stopUpd:
		)
		(door3
			ignoreActors:
			cycleSpeed: 1
			setPri: 7
			init:
			stopUpd:
		)
		(door12
			ignoreActors:
			cycleSpeed: 1
			setPri: 5
			init:
			stopUpd:
		)
		(door13
			ignoreActors:
			cycleSpeed: 1
			setPri: 8
			init:
			stopUpd:
		)
		(arrow
			ignoreActors:
			cycleSpeed: 1
			setPri: 4
			init:
			stopUpd:
		)
		(if (< detailLevel 2)
			(globe init: stopUpd: addToPic:)
		else
			(globe init: cycleSpeed: 2 setCycle: Forward)
		)
		(StopEgo)
		(ego posn: 43 198 init: setScript: (ScriptID 230 0))
	)
	
	(method (doit)
		(if
			(and
				(!= (ego onControl: origin) cBLACK)
				(not (Btest 257))
				(not (Btest 260))
				(not (Btest 271))
			)
			(Bset 257)
			(switch (ego onControl: origin)
				(cMAGENTA
					(Bset 256)
					(if local6 (= local5 1))
					(trap1 setScript: (ScriptID 234 1))
				)
				(cLBLUE
					(Bset 256)
					(if local6 (= local5 1))
					(trap2 setScript: (ScriptID 234 1))
				)
				(cBROWN
					(Bset 256)
					(if local6 (= local5 1))
					(ego setPri: (+ (ego priority?) 1))
					(trap3 setScript: (ScriptID 234 1))
				)
				(cLGREY
					(Bset 256)
					(if local6 (= local5 1))
					(trap3 setScript: (ScriptID 234 1))
				)
				(cLCYAN
					(Bset 256)
					(if local6 (= local5 1))
					(trap4 setScript: (ScriptID 234 1))
				)
				(cGREEN
					(if local6 (= local5 1))
					(ego setScript: (ScriptID 225 0))
				)
				(cBLUE
					(if local6 (= local5 1))
					(ego setScript: (ScriptID 225 1))
				)
				(cRED
					(Bset 258)
					(if local6 (= local5 1))
					(if (> (ego y?) 107)
						(ego setScript: (ScriptID 234 0))
					else
						(ego setScript: (ScriptID 225 1))
					)
				)
				(cCYAN
					(if local6 (= local5 1))
					(if (> (ego y?) 107)
						(ego setScript: (ScriptID 234 0))
					else
						(ego setScript: (ScriptID 225 1))
					)
				)
				(else  (Bclear 257))
			)
		)
		(if (and (not (Btest 263)) (not (Btest 257)))
			(cond 
				((== (ego edgeHit?) 2)
					(if (not (Btest 260))
						(Bset 263)
						(ego setScript: (ScriptID 228 0))
					)
				)
				((and (== (ego edgeHit?) 4) (< (ego y?) 150))
					(Bset 263)
					(if (< (ego y?) 100)
						(ego setPri: -1 setScript: (ScriptID 228 3))
					else
						(ego setScript: (ScriptID 228 2))
					)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 86)
		(= countdownAwaitingResponse 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/chandelier,firefly,fly,bowl,globe')
					(IsObjectOnControl globe pEvent 3)
				)
				(HighPrint 96 51)
			)
			(
				(or
					(Said 'look/man,yorick,warlock,bandit,i')
					(and
						(IsObjectOnControl head pEvent 3)
						(not (IsObjectOnControl arrow pEvent 3))
					)
					(IsObjectOnControl yorick pEvent 3)
				)
				(HighPrint 96 52)
			)
			(
				(or
					(IsObjectOnControl arrow pEvent 3)
					(IsObjectOnControl MESign pEvent 3)
				)
				(HighPrint 96 53)
			)
			((IsObjectOnControl Door1 pEvent 3) (HighPrint 96 54))
			((IsObjectOnControl Door6 pEvent 3) (HighPrint 96 55))
			((IsObjectOnControl Door2 pEvent 3) (HighPrint 96 56))
			((IsObjectOnControl doorSign pEvent 3) (HighPrint 96 57))
			((IsObjectOnControl secretSign pEvent 3) (HighPrint 96 58))
			(
				(or
					(Said 'look/entrance,done')
					(IsObjectOnControl exitSign pEvent 3)
				)
				(HighPrint 96 59)
			)
			((IsObjectOnControl door11 pEvent 3) (HighPrint 96 60))
			((IsObjectOnControl door7 pEvent 3) (HighPrint 96 61))
			(
				(or
					(Said 'look/button')
					(IsObjectOnControl littleButton pEvent 3)
				)
				(HighPrint 96 62)
			)
			(
				(or
					(Said 'look/box')
					(IsObjectOnControl door3 pEvent 3)
				)
				(HighPrint 96 63)
			)
			((IsObjectOnControl door12 pEvent 3) (HighPrint 96 64))
			((IsObjectOnControl littleSign pEvent 3)
				(if
				(and (== (ego onControl: origin) cGREY) (> (ego x?) 100))
					(door13 setScript: (ScriptID 227 0))
				else
					(HighPrint 96 65)
				)
			)
			(
				(or
					(Said 'look/ladder')
					(IsObjectOnControl trap4 pEvent 3)
				)
				(HighPrint 96 66)
			)
			(
				(or
					(Said 'look/face[<happy]')
					(IsObjectOnControl door13 pEvent 3)
				)
				(HighPrint 96 67)
			)
			(
				(or
					(Said 'look/dot[<polka]')
					(IsObjectOnControl polkaDots pEvent 3)
				)
				(HighPrint 96 68)
			)
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((or (Said '<up') (Said '/ceiling,ladder')) (HighPrint 96 69))
							(
							(or (Said '<down') (Said '/ground,floor,pit,aisle')) (HighPrint 96 70))
							((Said '/wall') (HighPrint 96 71))
							((Said '/chain,rope,handle') (HighPrint 96 72))
							((Said '/sign') (HighPrint 96 73))
							((Said '/arrow') (HighPrint 96 74))
						)
					)
					((Said 'get/i/leader') (HighPrint 96 75))
					((Said 'rest') (HighPrint 96 76))
					((Said 'cast') (HighPrint 96 77))
					((Said 'throw') (HighPrint 96 78))
					((Said 'nap') (Die 96 79 #icon 800 0 0 #title {He who hesitates...}))
					((Said 'read/sign')
						(if
						(and (== (ego onControl: origin) cGREY) (> (ego x?) 100))
							(door13 setScript: (ScriptID 227 0))
						)
					)
					((Said 'force/button,door,box')
						(if (ego inRect: 31 107 86 125)
							(Bset 257)
							(door3 setScript: (ScriptID 230 1))
						else
							(HighPrint 96 80)
						)
					)
					((Said 'pull[/chain,rope,handle]')
						(if (== (ego onControl: origin) cLMAGENTA)
							(= local6 1)
							(= local5 200)
							(door11 setScript: (ScriptID 231 0))
						else
							(HighPrint 96 81)
						)
					)
					((Said 'open,unbar,unlock[/door]')
						(cond 
							((ego inRect: 10 150 120 189) (HighPrint 96 82))
							((== (ego onControl: origin) cLRED)
								(if (Btest 264)
									(ego setScript: (ScriptID 232 1))
								else
									(User canInput: 0)
									(door7 setScript: (ScriptID 232 0))
								)
							)
							((== (ego onControl: origin) cLGREEN) (door11 setScript: (ScriptID 233 0)))
							(else (HighPrint 96 83))
						)
					)
					((Said 'unlock') (HighPrint 96 84))
				)
			)
		)
	)
)
