;;; Sierra Script 1.0 - (do not remove this comment)
(script# 141)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use TalkObj)
(use GControl)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm141 0
)

(local
	local0
	local1
	local2
)
(instance baronWin of SysWindow
	(properties
		color 1
		title {Baron von Spielburg says:}
	)
	
	(method (open &tmp temp0)
		(= top (+ top (= temp0 (- 188 bottom))))
		(= bottom (+ bottom temp0))
		(super open: &rest)
	)
)

(instance sonWin of SysWindow
	(properties
		color 8
		title {The Baronet says:}
	)
	
	(method (open &tmp temp0)
		(= top (+ top (= temp0 (- 188 bottom))))
		(= bottom (+ bottom temp0))
		(super open: &rest)
	)
)

(instance baronTalk of TalkObj
	(properties
		tLoop 3
		cSpeed 2
		isHead 1
	)
)

(instance sonTalk of TalkObj
	(properties
		tLoop 5
		cSpeed 2
		isHead 1
	)
)

(instance baron of Actor
	(properties
		y 65
		x 159
		view 141
		loop 2
		cel 1
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/baron,dad')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 0)
			)
		)
	)
)

(instance son of Actor
	(properties
		y 85
		x 234
		view 141
		loop 4
		cel 2
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/barnard,barnard,bear,barnard')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 1)
			)
		)
	)
)

(instance egoHead of View
	(properties
		y 79
		x 160
		view 508
		loop 1
	)
)

(instance baronHead of Prop
	(properties
		y 54
		x 159
		view 141
		loop 3
		cycleSpeed 2
	)
	
	(method (doit)
		(baronTalk doit:)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(baronTalk handleEvent: pEvent)
	)
)

(instance sonHead of Prop
	(properties
		y 51
		x 234
		view 141
		loop 5
		cycleSpeed 2
	)
	
	(method (doit)
		(sonTalk doit:)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(sonTalk handleEvent: pEvent)
	)
)

(instance cupboard of PicView
	(properties
		y 67
		x 68
		view 141
		priority 3
	)
)

(instance onCupboard of RFeature
	(properties
		nsTop 37
		nsLeft 41
		nsBottom 84
		nsRight 96
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/cabinet')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 2)
			)
		)
	)
)

(instance arms of PicView
	(properties
		y 47
		x 159
		view 141
		cel 1
		priority 1
	)
)

(instance onArms of RFeature
	(properties
		nsTop 33
		nsLeft 135
		nsBottom 49
		nsRight 183
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/(arm[<coat]),design,crest')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 3)
			)
		)
	)
)

(instance grate of PicView
	(properties
		y 79
		x 245
		view 141
		cel 2
		priority 4
	)
)

(instance onGrate of RFeature
	(properties
		nsTop 42
		nsLeft 224
		nsBottom 80
		nsRight 264
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/grate,fire,chimney')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 4)
			)
		)
	)
)

(instance lGuard of PicView
	(properties
		y 73
		x 106
		view 141
		loop 1
		priority 3
	)
)

(instance onLGuard of RFeature
	(properties
		nsTop 30
		nsLeft 97
		nsBottom 74
		nsRight 113
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/guard')
					(IsObjectOnControl self pEvent 3)
					(IsObjectOnControl onRGuard pEvent 3)
				)
				(PrintWarning 141 5)
			)
		)
	)
)

(instance rGuard of PicView
	(properties
		y 73
		x 213
		view 141
		loop 1
		cel 1
		priority 3
	)
)

(instance onRGuard of RFeature
	(properties
		nsTop 30
		nsLeft 204
		nsBottom 74
		nsRight 220
	)
)

(instance onTable1 of RFeature
	(properties
		nsTop 63
		nsLeft 107
		nsBottom 85
		nsRight 210
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/table,bench')
					(IsObjectOnControl self pEvent 3)
					(IsObjectOnControl onTable2 pEvent 3)
					(IsObjectOnControl onTable3 pEvent 3)
				)
				(PrintWarning 141 6)
			)
		)
	)
)

(instance onTable2 of RFeature
	(properties
		nsTop 102
		nsLeft 84
		nsBottom 152
		nsRight 129
	)
)

(instance onTable3 of RFeature
	(properties
		nsTop 102
		nsLeft 182
		nsBottom 152
		nsRight 250
	)
)

(instance onDoor of RFeature
	(properties
		nsTop 50
		nsLeft 2
		nsBottom 96
		nsRight 16
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/door')
					(IsObjectOnControl self pEvent 3)
				)
				(PrintWarning 141 7)
			)
		)
	)
)

(instance rm141 of Room
	(properties
		picture 141
		style $0008
	)
	
	(method (init)
		(Load rsVIEW 141)
		(super init:)
		(AddToScore POINTS_MEETBARON 10)
		(StatusLine enable:)
		(gMouseHandler add: self baronHead sonHead)
		(gKeyHandler add: baronHead sonHead)
		(gAddToPics
			add: cupboard arms grate lGuard rGuard
			eachElementDo: #init
			doit:
		)
		(self
			setFeatures: onDoor onLGuard onArms onCupboard onGrate onTable1
		)
		(baron setPri: 5 init:)
		(son setPri: 5 init:)
		(baronHead
			setPri: (+ (baron priority?) 1)
			ignoreActors:
			init:
			stopUpd:
			hide:
		)
		(sonHead
			setPri: (+ (son priority?) 1)
			ignoreActors:
			init:
			stopUpd:
			hide:
		)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(egoHead hide:)
		(baronTalk tWindow: baronWin actor: baronHead init:)
		(sonTalk tWindow: sonWin actor: sonHead init:)
		(if (< colourCount 16) (sonWin color: 4))
		(= mealsPreEaten 1)
		(self setScript: egoEnters)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== (pEvent type?) evSAID)
				(cond 
					((or (Said '[use]/stealth') (Said 'run,sneak')) (PrintWarning 141 8))
					((Said 'kill,fight,chop,beat,damage,cast') (PrintWarning 141 9))
					((Said 'look/floor') (PrintWarning 141 10))
					(
					(Said 'look[<at,around][/!*,room,building,hall]') (PrintWarning 141 11))
				)
			)
			(
				(and
					(== (pEvent type?) evMOUSEBUTTON)
					(IsObjectOnControl ego pEvent 3)
				)
				(PrintWarning 141 12)
			)
		)
	)
)

(instance egoEnters of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego init: posn: 0 108 setMotion: MoveTo 154 108 self)
			)
			(1
				(FaceObject ego baron)
				(= seconds 3)
			)
			(2
				(ego
					view: 508
					loop: 0
					cel: 0
					cycleSpeed: 2
					forceUpd:
					setCycle: EndLoop
				)
				(= seconds 2)
			)
			(3
				(egoHead
					ignoreActors:
					setPri: (+ (ego priority?) 1)
					init:
					hide:
				)
				(client setScript: openingSpeech)
			)
		)
	)
)

(instance openingSpeech of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baronTalk caller: self)
				(sonTalk caller: self)
				(baron setCel: 1)
				(egoHead hide:)
				(TalkObjMessages baronTalk 141 13 141 14 141 15)
			)
			(1 (= seconds 2))
			(2
				(egoHead hide:)
				(baron setCel: 0)
				(TalkObjMessages baronTalk 141 16)
			)
			(3
				(egoHead show:)
				(son setCel: 1)
				(TalkObjMessages sonTalk 141 17)
			)
			(4
				(if (Btest 231)
					(egoHead hide:)
					(baron setCel: 2)
					(TalkObjMessages baronTalk 141 18 141 19)
				else
					(client setScript: becomeHero)
				)
			)
			(5 (= seconds 2))
			(6
				(egoHead hide:)
				(baron setCel: 0)
				(TalkObjMessages baronTalk 141 16)
			)
			(7
				(egoHead show:)
				(son setCel: 0)
				(TalkObjMessages sonTalk 141 20)
			)
			(8
				(client setScript: becomeHero)
			)
		)
	)
)

(instance becomeHero of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baronTalk caller: self)
				(sonTalk caller: self)
				(egoHead hide:)
				(baron setCel: 2)
				(TalkObjMessages baronTalk 141 21 141 22)
			)
			(1 (= seconds 2))
			(2
				(egoHead hide:)
				(baron setCel: 0)
				(TalkObjMessages baronTalk 141 16)
			)
			(3
				(egoHead show:)
				(son setCel: 2)
				(TalkObjMessages sonTalk 141 23)
			)
			(4
				(egoHead hide:)
				(baron setCel: 1)
				(TalkObjMessages baronTalk 141 24 141 25)
			)
			(5
				(cSound fade:)
				(= seconds 2)
			)
			(6
				(egoHead hide:)
				(TalkObjMessages baronTalk 141 26)
			)
			(7 (client setScript: answerQs))
		)
	)
)

(instance answerQs of Script
	(properties)
	
	(method (init)
		(baronTalk caller: self)
		(sonTalk caller: self)
		(egoHead dispose: delete:)
		(StopEgo)
		(FaceObject ego baron)
		(UnlockEgo)
		(super init: &rest)
	)
	
	(method (doit)
		(super doit:)
		(if (& (ego onControl: origin) cLBLUE)
			(client setScript: leaveRoom)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(if (not local1)
					(self changeState: 0)
				else
					(client setScript: leaveRoom)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(DisposeDialog)
		(cond 
			(local1 (baronTalk endTalk:) (client setScript: leaveRoom))
			((super handleEvent: pEvent))
			((Said 'chat,affirmative') (TalkObjMessages baronTalk 141 27))
			((Said 'n')
				(LockEgo)
				(TalkObjMessages baronTalk 141 28)
				(= local1 1)
			)
			((Said 'ask>')
				(= local2 1)
				(cond 
					((Said '/curse') (TalkObjMessages baronTalk 141 29 141 30 141 31))
					((Said '/prediction') (TalkObjMessages baronTalk 141 32 141 33))
					((Said '/ogress,baba,baba,baba') (TalkObjMessages baronTalk 141 34))
					((Said '/magic,wizard,zara,erasmus,erana') (TalkObjMessages baronTalk 141 35))
					((Said '/hill,zauberberg') (TalkObjMessages baronTalk 141 36))
					((Said '/elsa,daughter') (TalkObjMessages baronTalk 141 37 141 38 141 39))
					((Said '/baroness') (TalkObjMessages baronTalk 141 40 141 41))
					((Said '/bandit') (TalkObjMessages baronTalk 141 42 141 43 141 44 141 45))
					((Said '/yorick,jester') (TalkObjMessages baronTalk 141 46))
					((Said '/prize') (TalkObjMessages baronTalk 141 47))
					((Said '/leader') (TalkObjMessages baronTalk 141 48 141 49))
					((Said '/warlock') (TalkObjMessages baronTalk 141 50))
					((Said '/castle') (TalkObjMessages baronTalk 141 51))
					((Said '/kobold,cave')
						(son setCel: 1)
						(TalkObjMessages sonTalk 141 52 141 53 141 54 141 55)
					)
					((Said '/bear') (son setCel: 0) (TalkObjMessages sonTalk 141 56))
					((Said '/barnard,barnard,barnard') (TalkObjMessages baronTalk 141 57))
					(else
						(= local2 0)
						(pEvent claimed: 1)
						(switch (++ local0)
							(1
								(TalkObjMessages baronTalk 141 58)
							)
							(2
								(TalkObjMessages baronTalk 141 59)
							)
							(else 
								(LockEgo)
								(TalkObjMessages baronTalk 141 28)
								(= local1 1)
							)
						)
					)
				)
				(if (and local2 (pEvent claimed?)) (AddToScore POINTS_TALKTOBARON 3))
			)
		)
	)
)

(instance leaveRoom of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(baronTalk caller: self)
				(= [invNum invGoldCoin] (+ [invNum invGoldCoin] 50))
				(TalkObjMessages baronTalk 141 60)
			)
			(1
				(= currentTime 2800)
				(curRoom newRoom: 41)
			)
		)
	)
)
