;;; Sierra Script 1.0 - (do not remove this comment)
(script# 41)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm41 0
)

(local
	local0 =  1
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
)
(instance rm41 of Room
	(properties
		picture 41
		style $0005
	)
	
	(method (init &tmp egoX egoY)
		(Load rsVIEW 41)
		(cSound fade:)
		(super init: &rest)
		(StatusLine enable:)
		(= local9 (== prevRoomNum 141))
		(if
		(and (Btest 170) (not local9) (not (Btest 215)))
			(self horizon: 130)
		)
		(gMouseHandler add: self)
		(self setFeatures: onTrees1 onWeed1 onCastle onStones)
		(= egoX (ego x?))
		(= egoY (ego y?))
		(StopEgo)
		(ego init:)
		(if (not isNightTime)
			(rGuard init: stopUpd:)
			(lGuard init: stopUpd:)
			(if
			(and (Btest 170) (not local9) (not (Btest 215)))
				(LockEgo)
				(cSound prevSignal: 0)
				(lGuard setScript: lGuardTrumpets)
				(rGuard setScript: rGuardTrumpets)
			)
		)
		(door1 init: stopUpd:)
		(door2 init: stopUpd:)
		(switch prevRoomNum
			(38
				(if (and (Btest 170) (not (Btest 215)))
					(ego posn: 43 168 setMotion: MoveTo 160 168)
				else
					(if (< egoY 110) (= egoY 110))
					(ego posn: 1 egoY setMotion: MoveTo 15 egoY)
				)
			)
			(39
				(if (and (Btest 170) (not (Btest 215)))
					(ego posn: 160 186 setMotion: MoveTo 160 168)
				else
					(ego posn: egoX 189)
					(cond 
						((< egoX 10) (ego setMotion: MoveTo (+ egoX 25) 175))
						((> egoX 310) (ego setMotion: MoveTo (- egoX 25) 175))
						(else (ego setMotion: MoveTo egoX 175))
					)
				)
			)
			(40
				(if (and (Btest 170) (not (Btest 215)))
					(ego posn: 283 168 setMotion: MoveTo 160 168)
				else
					(if (< egoY 110) (= egoY 110))
					(ego posn: 319 egoY setMotion: MoveTo 305 egoY)
				)
			)
			(141 (ego setScript: leaveHall))
			(else 
				(ego posn: 160 189 setMotion: MoveTo 160 170)
			)
		)
		(self setLocales: 807)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(switch (ego edgeHit?)
			(2
				(= gGEgoObjY (+ (/ (= temp0 (- (ego y?) 105)) 3) 98))
				(curRoom newRoom: 40)
			)
			(3
				(= gGEgoObjX (+ (/ (ego x?) 3) 102))
				(curRoom newRoom: 39)
			)
			(4
				(= gGEgoObjY (+ (/ (= temp0 (- (ego y?) 105)) 2) 84))
				(curRoom newRoom: 38)
			)
		)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 31)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl ego pEvent 3)
					(HighPrint 41 0)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '[/!*]') (HighPrint 41 1))
							((Said '/castle') (HighPrint 41 2))
							((Said '/north') (HighPrint 41 3))
							((Said '/east') (HighPrint 41 4))
							((Said '/south') (HighPrint 41 5))
							((Said '/west') (HighPrint 41 6))
							((Said '/door')
								(if isNightTime
									(HighPrint 41 7)
								else
									(HighPrint 41 8)
								)
							)
						)
					)
					((Said 'climb[/castle,wall]') (HighPrint 41 9))
					((Said 'knock,knock,force/door') (HighPrint 41 10))
					((Said 'open,lockpick/door,hasp')
						(if isNightTime
							(HighPrint 41 11)
						else
							(HighPrint 41 8)
						)
					)
					((or (Said 'nap') (Said 'go[<to]/nap'))
						(HighPrint 41 12)
						(if (and (< 750 currentTime) (< currentTime 2550))
							(SetGameTime 21)
						)
						(curRoom newRoom: 37)
					)
				)
			)
		)
	)
)

(instance lGuard of Prop
	(properties
		y 119
		x 120
		view 41
		loop 1
	)
	
	(method (doit)
		(if (or (not (Btest 170)) (Btest 215))
			(if
				(and
					(not local8)
					(< (ego y?) 142)
					(< 99 (ego x?))
					(< (ego x?) 209)
				)
				(= local8 1)
				(= local3 12)
				(lGuard setScript: lGuardTalks)
			)
			(if
				(or
					(< (ego x?) 78)
					(< 228 (ego x?))
					(> (ego y?) 155)
				)
				(= local8 0)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl lGuard pEvent 3)
					(HighPrint 41 13)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'climb[/castle,wall]') (HighPrint 41 14))
					((Said 'fight,kill/guard,man,gatekeeper')
						(Die
							41
							15
							80
							{Getting into the castle the hard way.}
							82
							800
							0
							0
						)
					)
					((Said 'look/horn') (HighPrint 41 16))
					((Said 'look/guard') (HighPrint 41 17))
					((Said 'chat[<to]/guard,man,gatekeeper') (HighPrint 41 18))
					((Said 'chat,ask/moustache')
						(= local4 11)
						(self setScript: rGuardTalks)
						(= local2 0)
						(= local6 0)
					)
					((Said 'open/door') (= local3 12) (self setScript: lGuardTalks))
					(local2
						(cond 
							(local6
								(pEvent claimed: 1)
								(= local6 0)
								(= local3 11)
								(self setScript: lGuardTalks)
							)
							((Said 'chat,ask>') (pEvent claimed: 1) (HighPrint 41 19))
							(else (pEvent claimed: 0))
						)
					)
					((Said '/hey') (= local3 2) (self setScript: lGuardTalks))
					((Said 'call/guard,man,gatekeeper')
						(if local5
							(= local3 3)
							(self setScript: lGuardTalks)
						else
							(= local4 2)
							(self setScript: rGuardTalks)
						)
					)
					((Said 'say') (= local3 4) (self setScript: lGuardTalks))
					((Said 'chat,ask>')
						(cond 
							((Said '/consent') (= local4 3) (self setScript: rGuardTalks))
							((Said '/baron,baron,hamlet') (= local4 4) (self setScript: rGuardTalks))
							((Said '/castle') (= local3 5) (self setScript: lGuardTalks))
							((Said '/barnard,barnard,barnard') (= local4 5) (self setScript: rGuardTalks))
							((Said '/daughter,elsa') (= local3 6) (self setScript: lGuardTalks))
							((Said '/stable') (= local4 6) (self setScript: rGuardTalks))
							((or (Said '/guard') (Said '/name,handle')) (= local3 7) (self setScript: lGuardTalks))
							((Said '/barrack') (= local3 8) (self setScript: lGuardTalks))
							((Said '/place[<bald]')
								(= local3 9)
								(self setScript: lGuardTalks)
								(= local2 300)
								(= local6 1)
							)
							((Said '/place') (= local4 9) (self setScript: rGuardTalks))
							((Said '/karl') (= local3 13) (self setScript: lGuardTalks))
							((Said '[/*]')
								(if local5
									(= local3 10)
									(self setScript: lGuardTalks)
								else
									(= local4 8)
									(self setScript: rGuardTalks)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance rGuard of Prop
	(properties
		y 119
		x 197
		view 41
	)
	
	(method (doit)
		(if (or (not (Btest 170)) (Btest 215))
			(if
				(and
					(not local7)
					(< (ego y?) 126)
					(< 99 (ego x?))
					(< (ego x?) 209)
				)
				(= local7 1)
				(= local4 13)
				(rGuard setScript: rGuardTalks)
			)
			(if
				(or
					(< (ego x?) 78)
					(< 228 (ego x?))
					(> (ego y?) 140)
				)
				(= local7 0)
			)
			(if local2 (-- local2))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl rGuard pEvent 3)
					(HighPrint 41 20)
				)
			)
		)
	)
)

(instance rGuardHead of Prop
	(properties
		y 86
		x 204
		view 41
		loop 2
		cycleSpeed 2
	)
)

(instance lGuardHead of Prop
	(properties
		y 85
		x 112
		view 41
		loop 5
		cycleSpeed 2
	)
)

(instance door1 of Prop
	(properties
		y 117
		x 138
		view 41
		loop 3
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if
					(or
						(and local0 (IsObjectOnControl door1 pEvent 3))
						(and local0 (IsObjectOnControl door2 pEvent 3))
						(and
							(IsObjectOnControl door1 pEvent 3)
							(not (IsObjectOnControl torch pEvent 3))
						)
						(and
							(IsObjectOnControl door2 pEvent 3)
							(not (IsObjectOnControl torch pEvent 3))
						)
					)
					(HighPrint 41 21)
				)
			)
		)
	)
)

(instance door2 of Prop
	(properties
		y 117
		x 178
		view 41
		loop 4
	)
)

(instance torch of Prop
	(properties
		y 82
		x 158
		view 41
		loop 6
		cycleSpeed 3
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if
				(and (not local0) (IsObjectOnControl torch pEvent 3))
					(HighPrint 41 22)
				)
			)
		)
	)
)

(instance onTrees1 of RFeature
	(properties
		nsTop 42
		nsLeft 5
		nsBottom 120
		nsRight 83
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl onTrees1 pEvent 3)
					(IsObjectOnControl onTrees2 pEvent 3)
				)
				(HighPrint 41 23)
			)
		)
	)
)

(instance onTrees2 of RFeature
	(properties
		nsTop 52
		nsLeft 233
		nsBottom 112
		nsRight 307
	)
)

(instance onWeed1 of RFeature
	(properties
		nsTop 136
		nsLeft 82
		nsBottom 143
		nsRight 93
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(not (IsObjectOnControl ego pEvent 3))
					(or
						(IsObjectOnControl onWeed1 pEvent 3)
						(IsObjectOnControl onWeed2 pEvent 3)
						(IsObjectOnControl onWeed3 pEvent 3)
						(IsObjectOnControl onWeed4 pEvent 3)
						(IsObjectOnControl onWeed5 pEvent 3)
					)
				)
				(HighPrint 41 24)
			)
			(else (pEvent claimed: 0))
		)
	)
)

(instance onWeed2 of RFeature
	(properties
		nsTop 174
		nsLeft 132
		nsBottom 180
		nsRight 141
	)
)

(instance onWeed3 of RFeature
	(properties
		nsTop 137
		nsLeft 220
		nsBottom 142
		nsRight 227
	)
)

(instance onWeed4 of RFeature
	(properties
		nsTop 176
		nsLeft 274
		nsBottom 187
		nsRight 287
	)
)

(instance onWeed5 of RFeature
	(properties
		nsTop 182
		nsLeft 53
		nsBottom 188
		nsRight 64
	)
)

(instance onCastle of RFeature
	(properties
		nsBottom 41
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onCastle pEvent 3) (HighPrint 41 25))
		)
	)
)

(instance onStones of RFeature
	(properties
		nsTop 142
		nsLeft 65
		nsBottom 189
		nsRight 278
	)
	
	(method (handleEvent pEvent)
		(asm
			pushi    #handleEvent
			pushi    1
			lsp      pEvent
			super    RFeature,  6
			bnt      code_0ece
			jmp      code_0fa7
code_0ece:
			pushi    3
			lofsa    onStones
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bnt      code_0f9f
			pushi    3
			lsg      ego
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bt       code_0f39
			pushi    3
			lofsa    onWeed1
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bt       code_0f39
			pushi    3
			lofsa    onWeed2
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bt       code_0f39
			pushi    3
			lofsa    onWeed3
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bt       code_0f39
			pushi    3
			lofsa    onWeed4
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
			bt       code_0f39
			pushi    3
			lofsa    onWeed5
			push    
			lsp      pEvent
			pushi    3
			callb    IsObjectOnControl,  6
code_0f39:
			not     
			bnt      code_0f9f
			lsl      local1
			dup     
			ldi      0
			eq?     
			bnt      code_0f53
			pushi    2
			pushi    41
			pushi    26
			callb    HighPrint,  4
			+al      local1
			jmp      code_0f9b
code_0f53:
			dup     
			ldi      1
			eq?     
			bnt      code_0f67
			pushi    2
			pushi    41
			pushi    27
			callb    HighPrint,  4
			+al      local1
			jmp      code_0f9b
code_0f67:
			dup     
			ldi      2
			eq?     
			bnt      code_0f7b
			pushi    2
			pushi    41
			pushi    28
			callb    HighPrint,  4
			+al      local1
			jmp      code_0f9b
code_0f7b:
			dup     
			ldi      3
			eq?     
			bnt      code_0f8f
			pushi    2
			pushi    41
			pushi    29
			callb    HighPrint,  4
			+al      local1
			jmp      code_0f9b
code_0f8f:
			pushi    2
			pushi    41
			pushi    30
			callb    HighPrint,  4
			ldi      0
			sal      local1
code_0f9b:
			toss    
			jmp      code_0fa7
code_0f9f:
			pushi    #claimed
			pushi    1
			pushi    0
			lap      pEvent
			send     6
code_0fa7:
			ret     
		)
	)
)

(instance lGuardTrumpets of Script
	(properties)
	
	(method (doit)
		(if (== (cSound prevSignal?) 10) (self cue:))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(lGuard
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
		)
	)
)

(instance rGuardTrumpets of Script
	(properties)
	
	(method (doit)
		(if (== (cSound prevSignal?) 20)
			(self changeState: 7)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 4))
			(1
				(cSound number: 96 loop: -1 priority: 5 play:)
				(rGuard
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(2 (= seconds 1))
			(3
				(PrintTimedMessage 6 41 31)
				(= cycles 30)
			)
			(4
				(torch init: setCycle: Forward)
				(door1 setCycle: EndLoop self)
				(door2 setCycle: EndLoop)
			)
			(5
				(door1 stopUpd:)
				(door2 stopUpd:)
				(= seconds 2)
			)
			(6
				(ego illegalBits: 0 setMotion: MoveTo 158 100)
			)
			(7 (curRoom newRoom: 141))
		)
	)
)

(instance lGuardTalks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(lGuardHead setPri: 8 init: setCycle: Forward)
				(= cycles 25)
			)
			(1
				(= local5 0)
				(UnlockEgo)
				(switch local3
					(1 (HighPrint 41 32))
					(2 (HighPrint 41 33))
					(3 (HighPrint 41 34))
					(4 (HighPrint 41 35))
					(5 (HighPrint 41 36))
					(6 (HighPrint 41 37))
					(7
						(HighPrint 41 38)
						(= local4 7)
						(self setScript: rGuardTalks)
					)
					(8 (HighPrint 41 39))
					(9 (HighPrint 41 40))
					(10
						(HighPrint 41 41)
						(= local4 10)
						(self setScript: rGuardTalks)
					)
					(11
						(HighPrint 41 42)
						(= local4 12)
						(self setScript: rGuardTalks)
					)
					(12 (HighPrint 41 32))
					(13 (HighPrint 41 43))
				)
				(lGuardHead dispose:)
			)
		)
	)
)

(instance rGuardTalks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(rGuardHead setPri: 8 init: setCycle: Forward)
				(= cycles 25)
			)
			(1
				(= local5 1)
				(UnlockEgo)
				(switch local4
					(1 (HighPrint 41 44))
					(2 (HighPrint 41 45))
					(3 (HighPrint 41 46))
					(4
						(if (Btest 170)
							(HighPrint 41 47)
						else
							(HighPrint 41 44)
						)
					)
					(5
						(if (Btest 170)
							(HighPrint 41 48)
						else
							(HighPrint 41 49)
						)
					)
					(6 (HighPrint 41 50))
					(7
						(HighPrint 41 51)
						(= local5 0)
					)
					(8 (HighPrint 41 52))
					(9 (HighPrint 41 53))
					(10
						(HighPrint 41 54)
						(= local5 0)
					)
					(11 (HighPrint 41 55))
					(12
						(HighPrint 41 56)
						(= local5 0)
					)
					(13 (HighPrint 41 44))
				)
				(rGuardHead dispose:)
			)
		)
	)
)

(instance leaveHall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					ignoreActors:
					illegalBits: 0
					posn: 159 120
					setMotion: MoveTo 159 150 self
				)
				(= curRoomNum 141)
				(SetGameTime 22)
				(SleepUntil 7 30)
				(= curRoomNum 41)
			)
			(1
				(ego ignoreActors: 0 illegalBits: cWHITE)
				(PrintTimedMessage 10 41 57)
				(UnlockEgo)
				(Bset 215)
				(= local9 0)
				(client setScript: 0)
			)
		)
	)
)
