;;; Sierra Script 1.0 - (do not remove this comment)
(script# 800)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Actor)


(class Door of Prop
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		entranceTo 0
		locked 0
		openSnd 0
		closeSnd 0
		doorControl 0
		doorState 0
		facingLoop 0
		code 0
		illegalBits $0000
	)
	
	(method (init)
		(= doorState (if (== prevRoomNum entranceTo) 2 else 0))
		(= cel
			(if (== doorState 0) 0 else (- (NumCels self) 1))
		)
		(super init:)
		(self stopUpd: ignoreActors:)
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(& (ego onControl: origin) doorControl)
				(or (== facingLoop -1) (== (ego loop?) facingLoop))
			)
			(self open:)
		else
			(self close:)
		)
	)
	
	(method (cue)
		(self stopUpd:)
		(= doorState (if (== doorState 1) 0 else 2))
		(if (and (== doorState 2) entranceTo)
			(curRoom newRoom: entranceTo)
		)
	)
	
	(method (open)
		(if
		(and (not locked) (!= doorState 3) (!= doorState 2))
			(= doorState 3)
			(self setCycle: EndLoop self)
			(if openSnd (openSnd doit:))
		)
	)
	
	(method (close)
		(if (and (!= doorState 1) (!= doorState 0))
			(= doorState 1)
			(self setCycle: BegLoop self)
			(if closeSnd (closeSnd doit:))
		)
	)
)
