;;; Sierra Script 1.0 - (do not remove this comment)
(script# 5)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Inventory)

(public
	Drink 0
)

(procedure (Drink param1 param2 &tmp temp0)
	(if param2
		(= temp0 param2)
	else
		(= temp0 (SaidGet param1))
	)
	(cond 
		((not temp0)
			(param1 claimed: 0)
			(cond 
				((Said '/water')
					(if (ego has: invFlyingWater)
						(ego use: invFlyingWater 1)
						(ego get: invEmptyFlask)
						(cond 
							((not (ego has: invFlyingWater)) (Bclear 330) (Bclear 329))
							((Btest 330) (Bclear 330))
							((Btest 329) (Bclear 329))
						)
						(HighPrint 5 0)
						(HighPrint 5 1)
					)
				)
				((Said '/potion')
					(= temp0 0)
					(= param2 invHealingPotion)
					(while (<= param2 invUndeadUnguent)
						(cond 
							((and [invNum param2] (not temp0)) (= temp0 param2))
							((and temp0 [invNum param2]) (= temp0 -1) (break))
						)
						(++ param2)
					)
					(switch temp0
						(-1 (HighPrint 5 2))
						(0 (HighPrint 5 3))
						(else  (Drink param1 temp0))
					)
				)
				(else (param1 claimed: 1) (HighPrint 5 4))
			)
		)
		((or (< temp0 invHealingPotion) (> temp0 invUndeadUnguent))
			(param1 claimed: 0)
			(if (Said 'drink')
				(HighPrint 5 5)
			else
				(HighPrint 5 6)
			)
			(param1 claimed: 1)
		)
		((not [invNum temp0]) (HighPrint 5 7))
		((== temp0 invHealingPotion)
			(HighPrint 5 8)
			(ReduceHP (- (/ (GetMaxHealth) 2)))
			(ego use: invHealingPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invManaPotion)
			(HighPrint 5 9)
			(ReduceMP (- (/ (GetMaxMana) 2)))
			(ego use: invManaPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invVigorPotion)
			(HighPrint 5 10)
			(ReduceSP (- (GetMaxStamina)))
			(ego use: invVigorPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invDispelPotion)
			(HighPrint 5 11)
			(ego use: invDispelPotion)
			(ego get: invEmptyFlask)
			(param1 claimed: 1)
		)
		((== temp0 invUndeadUnguent)
			(if (ego has: invUndeadUnguent)
				(HighPrint 5 12)
				(Bset 168)
				(= undeadUnguentTimer 150)
				(ego use: invUndeadUnguent)
				(ego get: invEmptyFlask)
			else
				(HighPrint 5 13)
			)
		)
	)
	(DisposeScript 5)
)
