;;; Sierra Script 1.0 - (do not remove this comment)
(script# 30)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use GControl)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm30 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
)
(procedure (localproc_000c param1)
	(if
	(and (!= local3 param1) (== (fenrus loop?) 1))
		(= local3 param1)
		(fenrus cel: param1 forceUpd:)
	)
)

(procedure (localproc_0036)
	(HighPrint 30 0)
)

(procedure (localproc_003e)
	(HighPrint 30 1)
)

(procedure (localproc_0046)
	(HighPrint 30 2)
)

(procedure (localproc_004e)
	(HighPrint 30 3)
	(localproc_003e)
)

(procedure (localproc_005c)
	(HighPrint 30 4)
	(localproc_0046)
)

(procedure (localproc_006a)
	(HighPrint 30 5)
)

(procedure (localproc_0073)
	(HighPrint 30 6)
	(HighPrint 30 7)
)

(instance Magic of Prop
	(properties
		view 530
		cycleSpeed 2
	)
)

(instance rm30 of Room
	(properties
		picture 30
		style $0000
	)
	
	(method (init)
		(LoadMany 128 530 30 199)
		(super init:)
		(gMouseHandler add: self)
		(AddToScore POINTS_ENTERERASMUSCASTLE 3)
		(StatusLine enable:)
		(StopEgo)
		(ego posn: 160 189 init: setScript: intro)
		(gAddToPics
			add: frame bigChair smChair hang1 hang2 lunk plane armor mummy shelf
			eachElementDo: #init
			doit:
		)
		(theDunker
			setPri: 14
			posn: 112 160
			init:
			startUpd:
			setScript: dunker
		)
		(peacock posn: 186 122 init: stopUpd:)
		(dragon posn: 282 116 init: stopUpd:)
		(theLight
			setPri: 9
			posn: 161 102
			init:
			setCycle: Forward
			startUpd:
			setScript: lightBulb
		)
		(theWiz setPri: 5 posn: 146 72 init: stopUpd:)
		(fenrus setPri: 1 posn: 82 50 init: stopUpd:)
	)
	
	(method (doit)
		(if local2 (= local2 0) (self setScript: teleportOut))
		(cond 
			(
				(and
					(== (ego onControl: origin) cLMAGENTA)
					(== (ego loop?) 0)
					(not local0)
				)
				(= local0 1)
				(ego setScript: intoTheTower)
			)
			((and (== (ego edgeHit?) 3) (not local5)) (= local5 1) (= local2 1))
			(
			(and (== (ego onControl: origin) cLRED) (not local4)) (= local4 1) (= local2 1))
		)
		(cond 
			((<= (ego x?) 120) (localproc_000c 0))
			((<= (ego x?) 180) (localproc_000c 1))
			(else (localproc_000c 2))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 20)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/dragon,head,trophy')
					(IsObjectOnControl dragon pEvent 3)
				)
				(HighPrint 30 8)
			)
			(
				(or
					(Said 'look/chandelier,ball')
					(IsObjectOnControl theLight pEvent 3)
				)
				(HighPrint 30 9)
			)
			(
				(or
					(Said 'look/peacock,bird')
					(IsObjectOnControl peacock pEvent 3)
				)
				(if (> (peacock cel?) 0)
					(HighPrint 30 10)
					(showFeathers changeState: 2)
				else
					(HighPrint 30 11)
					(showFeathers changeState: 0)
				)
			)
			(
				(or
					(Said 'look/toy,(dragon<little),drink')
					(IsObjectOnControl theDunker pEvent 3)
				)
				(HighPrint 30 12)
				(HighPrint 30 13)
			)
			(
				(or
					(Said 'look/desk')
					(IsObjectOnControl onDesk pEvent 3)
				)
				(HighPrint 30 14)
			)
			(
				(or
					(Said 'look/armor,chainmail')
					(IsObjectOnControl armor pEvent 3)
				)
				(HighPrint 30 15)
			)
			(
				(or
					(Said 'look/airplane')
					(IsObjectOnControl plane pEvent 3)
				)
				(HighPrint 30 16)
			)
			(
				(or
					(Said 'look/mummy,coffin')
					(IsObjectOnControl mummy pEvent 3)
				)
				(HighPrint 30 17)
				(HighPrint 30 18)
				(Print 30 19 80 {The Picture.} 82 30 6 4)
			)
			(
				(or
					(Said 'look/onklunk')
					(IsObjectOnControl lunk pEvent 3)
				)
				(HighPrint 30 20)
			)
			(
				(or
					(Said 'look/painting,portrait,wizard,erasmus')
					(IsObjectOnControl frame pEvent 3)
				)
				(if (Btest 21)
					(HighPrint 30 21)
				else
					(HighPrint 30 22)
					(HighPrint 30 23)
				)
			)
			(
				(or
					(Said 'look/chest')
					(IsObjectOnControl onChest pEvent 3)
				)
				(HighPrint 30 24)
			)
			(
				(or
					(Said 'look/table')
					(IsObjectOnControl onTable pEvent 3)
				)
				(HighPrint 30 25)
			)
			(
				(or
					(Said 'look/bookcase,case,book,shelf')
					(IsObjectOnControl onBookcase pEvent 3)
				)
				(HighPrint 30 26)
				(HighPrint 30 27)
			)
			((IsObjectOnControl onWest pEvent 3) (localproc_0046))
			(
				(and
					(IsObjectOnControl onEast pEvent 3)
					(not (IsObjectOnControl dragon pEvent 3))
				)
				(localproc_003e)
			)
			(
				(or
					(Said 'look/shield')
					(IsObjectOnControl onShield pEvent 3)
				)
				(HighPrint 30 28)
			)
			((IsObjectOnControl fenrus pEvent 3) (HighPrint 30 29))
			((IsObjectOnControl onTapestry pEvent 3) (HighPrint 30 30))
			(128
				(cond 
					((Said 'look>')
						(cond 
							((Said '[<around,at][/room,house,foyer,!*]') (localproc_0036))
							((or (Said '/east') (Said '/wall<east')) (localproc_004e))
							((or (Said '/west') (Said '/wall<west')) (localproc_005c))
							((or (Said '/north') (Said '/wall<north')) (localproc_0073))
							((or (Said '/south') (Said '/wall<south')) (localproc_006a))
							((Said '/wall')
								(switch (ego loop?)
									(0 (localproc_004e))
									(1 (localproc_005c))
									(2 (localproc_006a))
									(3 (localproc_0073))
								)
							)
							((Said '/chair') (HighPrint 30 31))
							((Said '/trunk,box') (HighPrint 30 32))
							((Said '/door') (HighPrint 30 33) (localproc_003e) (localproc_0046))
							((Said '/ladder,staircase') (HighPrint 30 34))
							((Said '/tapestry,hang') (HighPrint 30 35))
							(
							(or (Said '/ceiling,roof,sconce') (Said '<up')) (HighPrint 30 36))
							((or (Said '/floor') (Said '<down')) (HighPrint 30 37))
						)
					)
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp0) (HighPrint 30 38))
							)
							(skDAZZLE
								(if (CastSpell temp0) (HighPrint 30 39))
							)
							(skFLAMEDART
								(if (CastSpell temp0)
									(if local1
										(= local2 1)
									else
										(dragon setScript: warning)
									)
								)
							)
							(skOPEN
								(if (CastSpell temp0)
									(if local1
										(= local2 1)
									else
										(dragon setScript: warning)
									)
								)
							)
						)
					)
					(
						(or
							(Said 'open/desk,drawer,chest,box,bookcase')
							(Said 'sat,get,throw,grab')
						)
						(if local1
							(= local2 1)
						else
							(dragon setScript: warning)
						)
					)
					((or (Said 'nap[/!*]') (Said 'go[<to]/nap')) (HighPrint 30 40) (= local2 1))
				)
			)
		)
	)
)

(instance showFeathers of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (peacock setCycle: EndLoop self))
			(1 (peacock stopUpd:))
			(2 (peacock setCycle: BegLoop self))
			(3 (peacock stopUpd:))
		)
	)
)

(instance dunker of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 5))
			(1
				(theDunker setLoop: 4 cel: 0 setCycle: EndLoop self)
			)
			(2 (= seconds 5))
			(3
				(theDunker setLoop: 5 cel: 0 setCycle: EndLoop self)
			)
			(4 (self changeState: 0))
		)
	)
)

(instance lightBulb of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(theLight y: 102)
				(= cycles 16)
			)
			(1
				(theLight y: 103)
				(= cycles 16)
			)
			(2 (self changeState: 0))
		)
	)
)

(instance intro of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 160 189 setMotion: MoveTo 160 184 self)
			)
			(1
				(if (not (Btest 20)) (localproc_0036))
				(ego setScript: 0)
			)
		)
	)
)

(instance intoTheTower of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 112 112 self)
			)
			(1
				(ego setMotion: MoveTo 205 70 self)
			)
			(2
				(ego setMotion: MoveTo 215 70 self)
			)
			(3
				(ego setMotion: MoveTo 215 67 self)
			)
			(4
				(fenrus setLoop: 0 cycleSpeed: 2 setCycle: EndLoop)
				(ego setPri: 1 setMotion: MoveTo 189 62 self)
			)
			(5
				(theWiz setCycle: EndLoop)
				(= seconds 3)
			)
			(6 (curRoom newRoom: 31))
		)
	)
)

(instance warning of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(dragon setCel: -1 setCycle: Forward)
				(Print 30 41 #at 215 43 #width 75 #dispose #time 4)
				(= seconds 3)
				; I wouldn't do that if I were you!
			)
			(1
				(= local1 1)
				(UnlockEgo)
				(dragon setCycle: 0 setCel: 0 stopUpd: setScript: 0)
			)
		)
	)
)

(instance teleportOut of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (< (fenrus cel?) 2)
					(fenrus setCycle: CycleTo 2 1 self)
				else
					(self cue:)
				)
			)
			(1
				(fenrus setLoop: 2 setCycle: Forward)
				(= cycles 2)
			)
			(2
				(Magic
					ignoreActors:
					setPri: (ego priority?)
					posn: (ego x?) (ego y?)
					init:
					setCycle: CycleTo 6 1 self
				)
			)
			(3
				(dragon setCel: -1 setCycle: Forward)
				(cond 
					(local4
						(Print 30 42 #at 215 43 #width 90 #dispose #time 3)
						; "Those rooms are forbidden!"
					)
					(local5
						(Print 30 43 #at 215 43 #width 90 #dispose #time 3)
						; "Since you're leaving anyway..."
					)
					(else
						(Print 30 44 #at 215 43 #width 90 #dispose #time 3)
						; "That'll learn ya!"
					)
				)
				(ego hide:)
				(Magic setCycle: EndLoop)
				(= seconds 4)
			)
			(4
				(Bset 142)
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 16)
				(self cue:)
			)
			(5 (curRoom newRoom: 28))
		)
	)
)

(instance theDunker of Prop
	(properties
		view 30
		loop 4
		cycleSpeed 2
	)
)

(instance peacock of Prop
	(properties
		view 30
		loop 7
		cycleSpeed 1
	)
)

(instance dragon of Prop
	(properties
		view 30
		loop 2
		cycleSpeed 2
	)
)

(instance theLight of Prop
	(properties
		view 30
		loop 1
		cycleSpeed 1
	)
)

(instance theWiz of Prop
	(properties
		view 30
		loop 8
		cycleSpeed 2
	)
)

(instance fenrus of Prop
	(properties
		view 199
		loop 1
	)
)

(instance bigChair of PicView
	(properties
		y 151
		x 210
		view 30
		loop 3
	)
)

(instance smChair of PicView
	(properties
		y 182
		x 248
		view 30
		loop 3
		cel 1
	)
)

(instance hang1 of PicView
	(properties
		y 48
		x 115
		view 30
		loop 3
		cel 2
	)
)

(instance hang2 of PicView
	(properties
		y 48
		x 176
		view 30
		loop 3
		cel 3
		priority 4
	)
)

(instance frame of RPicView
	(properties
		y 75
		x 146
		view 30
	)
)

(instance lunk of RPicView
	(properties
		y 109
		x 222
		view 30
		loop 6
	)
)

(instance plane of RPicView
	(properties
		y 183
		x 102
		view 30
		loop 6
		cel 1
		priority 14
	)
)

(instance armor of RPicView
	(properties
		y 110
		x 83
		view 30
		loop 6
		cel 2
	)
)

(instance mummy of RPicView
	(properties
		y 166
		x 20
		view 30
		loop 6
		cel 3
	)
)

(instance shelf of PicView
	(properties
		y 54
		x 81
		view 30
		loop 3
		cel 4
	)
)

(instance onDesk of RFeature
	(properties
		nsTop 130
		nsLeft 266
		nsBottom 189
		nsRight 319
	)
)

(instance onChest of RFeature
	(properties
		nsTop 151
		nsBottom 189
		nsRight 82
	)
)

(instance onTable of RFeature
	(properties
		nsTop 116
		nsLeft 125
		nsBottom 136
		nsRight 175
	)
)

(instance onBookcase of RFeature
	(properties
		nsTop 78
		nsLeft 237
		nsBottom 147
		nsRight 258
	)
)

(instance onShield of RFeature
	(properties
		nsTop 19
		nsLeft 263
		nsBottom 55
		nsRight 275
	)
)

(instance onEast of RFeature
	(properties
		nsTop 60
		nsLeft 264
		nsBottom 129
		nsRight 275
	)
)

(instance onWest of RFeature
	(properties
		nsTop 61
		nsLeft 43
		nsBottom 150
		nsRight 53
	)
)

(instance onTapestry of RFeature
	(properties
		nsTop 14
		nsLeft 10
		nsBottom 95
		nsRight 28
	)
)
