;;; Sierra Script 1.0 - (do not remove this comment)
(script# 31)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use GControl)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm31 0
	wizard 1
	egoChair 2
	poof 3
	fenrus 4
	ErasmusPrint 5
	FenrusPrint 6
	HeroPrint 7
	ErasmusCastTeleport 8
	door1 9
	door2 10
)

(local
	local0
	local1
	theSeconds
	[local3 251]
	local254
	local255
	local256
	local257
	local258
	local259
	local260
	local261
	local262
	local263
)
(procedure (ErasmusPrint param1)
	(= theSeconds (+ param1 5))
	(Format @local3 31 0 &rest)
	(wizard setScript: 0)
	(DisposeDialog)
	(wizard setScript: wizPrint)
)

(procedure (FenrusPrint param1)
	(= theSeconds (+ param1 5))
	(Format @local3 31 0 &rest)
	(fenrus setScript: 0)
	(DisposeDialog)
	(fenrus setScript: ratPrint)
)

(procedure (HeroPrint)
	(Format @local3 31 0 &rest)
	(ego setScript: 0)
	(DisposeDialog)
	(ego setScript: egoPrint)
)

(procedure (ErasmusCastTeleport)
	(= global312 1)
	(ego setCel: 2)
	(rm31 setScript: 0)
)

(procedure (localproc_00bc)
	(= local254 1)
	(HeroPrint 31 1)
)

(procedure (localproc_00c9)
	(= local254 4)
	(fenrus setLoop: 6 setCel: 0)
	(HeroPrint 31 2)
)

(procedure (localproc_00e6)
	(= local254 0)
	(HeroPrint 31 3)
)

(procedure (localproc_00f4)
	(= local254 0)
	(HeroPrint 31 4)
)

(procedure (localproc_0102)
	(= local254 2)
	(HeroPrint 31 5)
)

(procedure (localproc_0110)
	(= local254 1)
	(if local255 (HeroPrint 31 6) else (HeroPrint 31 7))
)

(procedure (localproc_012f)
	(= local254 4)
	(HeroPrint 31 8)
)

(procedure (localproc_013d)
	(= local254 3)
	(HeroPrint 31 9)
)

(procedure (localproc_014b)
	(= local254 2)
	(HeroPrint 31 10)
)

(procedure (localproc_0159)
	(= local254 2)
	(HeroPrint 31 11)
)

(instance rm31 of Room
	(properties
		picture 31
		style $0004
	)
	
	(method (init)
		(LockEgo)
		(gMouseHandler add: self)
		(gKeyHandler add: self)
		(LoadMany 130 131 132 133 134 135)
		(LoadMany 131 131 132 133 134 135)
		(LoadMany 128 31 199 530)
		(StatusLine enable:)
		(super init:)
		(StopEgo)
		(ego init:)
		(= local258 (Random 50 100))
		(= local259 100)
		(= local260 (Random 1 7))
		(gAddToPics add: table shelf eachElementDo: #init doit:)
		(if (== prevRoomNum 32)
			(door1 posn: 144 119)
			(door2 posn: 177 119)
		)
		(door1 ignoreActors: init: setPri: 1 stopUpd:)
		(door2 ignoreActors: init: setPri: 1 stopUpd:)
		(wizBody init: setPri: 5 stopUpd:)
		(teacup init: setPri: 7 stopUpd:)
		(egoChair init: setPri: 5 ignoreActors: stopUpd:)
		(fenrus init: setPri: 9 ignoreActors:)
		(poof init: setPri: 14 ignoreActors:)
		(wizard
			init:
			setPri: 15
			ignoreActors:
			illegalBits: 0
			stopUpd:
		)
		(wizDrinking
			init:
			setPri: 14
			ignoreActors:
			illegalBits: 0
			stopUpd:
		)
		(if (== prevRoomNum 32)
			(ego
				view: 31
				setLoop: 4
				setCel: 0
				illegalBits: 0
				posn: 186 121
				stopUpd:
			)
			(self setScript: entryDelay 0 (ScriptID 131 1))
		else
			(ego illegalBits: 0 setPri: 8 posn: 200 208)
			(self setScript: entryDelay 0 (ScriptID 131 0))
		)
	)
	
	(method (doit)
		(cond 
			((and global312 (> local258 1)) (-- local258))
			((== local258 1)
				(= local258 (Random 150 250))
				(wizDrinking setScript: drinkTea)
			)
		)
		(cond 
			((> local259 1) (-- local259))
			((== local259 1)
				(= local259 (Random 200 300))
				(if
					(and
						(== (rm31 script?) (wizDrinking script?))
						(== (wizDrinking script?) (fenrus script?))
						(== (fenrus script?) (wizard script?))
						(== (wizard script?) (ego script?))
						(== (ego script?) 0)
					)
					(if (== local260 7) (= local260 0) else (++ local260))
					(self setScript: (ScriptID 135 local260))
				)
			)
		)
		(if local0 (= local0 0) (self setScript: teleportOut))
		(super doit:)
	)
	
	(method (dispose)
		(Bset 21)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((or global310 global311) (pEvent claimed: 1))
					((IsObjectOnControl wizBody pEvent 3) (localproc_00bc))
					((IsObjectOnControl onRat pEvent 3) (localproc_00c9))
					((IsObjectOnControl onLWindow pEvent 3) (localproc_00e6))
					(
						(and
							(IsObjectOnControl onRWindow pEvent 3)
							(not (IsObjectOnControl onCheese pEvent 3))
						)
						(localproc_00f4)
					)
					(
						(and
							(IsObjectOnControl onTable pEvent 3)
							(not (IsObjectOnControl teacup pEvent 3))
						)
						(localproc_0102)
					)
					(
					(and (IsObjectOnControl teacup pEvent 3) (not local256)) (localproc_0110))
					((IsObjectOnControl onCheese pEvent 3) (localproc_012f))
					((IsObjectOnControl ego pEvent 3) (localproc_013d))
					((IsObjectOnControl onCeiling pEvent 3) (localproc_014b))
					((IsObjectOnControl onStairs pEvent 3) (localproc_0159))
				)
			)
			(evKEYBOARD
				(cond 
					((== KEY_RETURN (pEvent message?))
						(DisposeDialog)
						(if global310 (wizPrint changeState: 2))
						(if global311 (ratPrint changeState: 2))
					)
					((or global310 global311) (pEvent claimed: 1))
				)
			)
			(evSAID
				(cond 
					(global313
						(cond 
							((Said 'affirmative')
								(if (== (++ local262) 4)
									(ErasmusCastTeleport)
									(= local1 2)
									(= local0 1)
								else
									(= global314 1)
									((rm31 script?) cue:)
								)
							)
							((Said 'n') ((rm31 script?) cue:))
							((Said 'chuckle') (HighPrint 31 12))
							(else (pEvent claimed: 1) (HighPrint 31 13))
						)
					)
					((Said 'chuckle')
						(switch (Random 0 5)
							(0 (HighPrint 31 14))
							(1 (HighPrint 31 15))
							(2 (HighPrint 31 16))
							(3 (HighPrint 31 17))
							(4 (HighPrint 31 18))
							(5 (HighPrint 31 19))
						)
					)
					((or (Said 'nap[/!*]') (Said 'go[<to]/nap')) (= local1 6) (= local0 1))
					((Said 'fight,beat,chop,kill,throw[/*]') (= local1 3) (Bset 154) (= local0 1))
					((Said 'cast[/*]') (= local1 4) (Bset 154) (= local0 1))
					(
					(or (Said 'stand,done,go,done') (Said 'get<up,out')) (= local1 5) (= local0 1))
					((Said 'look>')
						(cond 
							((Said '/wizard,erasmus') (localproc_00bc))
							((Said '/fenrus,familiar') (localproc_00c9))
							((Said '/window') (localproc_00e6) (localproc_00f4))
							((Said '/table,desk') (localproc_0102))
							((Said '/tea,cup,teacup') (localproc_0110))
							((Said '/cheese') (localproc_012f))
							((Said '/chair') (= local254 2) (HeroPrint 31 20))
							((or (Said '<up') (Said '/ceiling')) (localproc_014b))
							(
							(or (Said '<down') (Said '/floor,ladder,staircase')) (localproc_0159))
						)
					)
					((Said 'play/game,maze')
						(if (>= [skills skMAGIC] 20)
							(self setScript: (ScriptID 132 5))
						else
							(ErasmusPrint 4 31 21)
						)
					)
					((Said 'ask>')
						(if local256
							(HeroPrint 31 22)
							(pEvent claimed: 1)
						else
							(= local263 1)
							(cond 
								((or (Said '/open') (Said '/spell<open')) (self setScript: (ScriptID 132 0)))
								((or (Said '/fetch') (Said '/spell<fetch')) (self setScript: (ScriptID 132 1)))
								((or (Said '/trigger') (Said '/spell<trigger')) (self setScript: (ScriptID 132 2)))
								((or (Said '/dazzle') (Said '/spell<dazzle')) (self setScript: (ScriptID 132 3)))
								((Said '/trap') (self setScript: (ScriptID 132 4)))
								((Said '/erana') (self setScript: (ScriptID 133 0)))
								(
									(or
										(Said '/protection,peace,hamlet')
										(Said '/spell<protection,peace,erana')
									)
									(self setScript: (ScriptID 133 1))
								)
								((Said '/zara') (self setScript: (ScriptID 133 2)))
								((Said '/baba') (self setScript: (ScriptID 133 3)))
								((Said '/curse') (self setScript: (ScriptID 133 4)))
								((Said '/countercurse') (self setScript: (ScriptID 133 5)))
								((Said '/fenrus,familiar') (self setScript: (ScriptID 133 6)))
								((Said '/enry,enry,ermit,ermit') (self setScript: (ScriptID 133 7)))
								((Said '/initiate,institute') (self setScript: (ScriptID 133 8)))
								((Said '/mirror') (self setScript: (ScriptID 134 0)))
								((Said '/wizard,user,caster,mage,mage') (self setScript: (ScriptID 134 1)))
								((Said '/nincompoop') (self setScript: (ScriptID 134 2)))
								((Said '/necromancer') (self setScript: (ScriptID 134 3)))
								((Said '/magic,technocery') (self setScript: (ScriptID 134 4)))
								((Said '/game,maze') (self setScript: (ScriptID 134 5)))
								((Said '/warlock') (ErasmusPrint 5 31 23))
								((Said '/spell,scroll') (ErasmusPrint 7 31 24))
								((Said '/bandit') (ErasmusPrint 9 31 25))
								((Said '/erasmus') (ErasmusPrint 4 31 26))
								((Said '/*')
									(= local263 0)
									(if (== (++ local261) 6)
										(= local1 1)
										(= local0 1)
									else
										(ErasmusPrint 4 31 27)
									)
								)
							)
							(if (and local263 (pEvent claimed?))
								(AddToScore POINTS_TALKTOERASMUS 1)
							)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance wizPrint of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global310 1)
				(if (< (wizDrinking cel?) 4) (wizard setCycle: Forward))
				(cond 
					((> (ego cel?) 1) (ego setCycle: CycleTo 1 -1 self))
					((< (ego cel?) 1) (ego setCycle: CycleTo 1 1 self))
					(else (self cue:))
				)
			)
			(1
				(if (!= theSeconds 0)
					(Print
						@local3
						#at
						3
						25
						#width
						82
						#mode
						1
						#title
						{ Erasmus_}
						#dispose
						#time
						theSeconds
					)
					(= seconds theSeconds)
				else
					(Print @local3 #at 3 25 #width 82 #mode 1)
					(self cue:)
				)
			)
			(2
				(wizard setCycle: 0 setCel: 0 setScript: 0)
				(= global310 0)
			)
		)
	)
)

(instance ratPrint of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global311 1)
				(fenrus setLoop: 5 setCycle: Forward)
				(if (< (ego cel?) 4)
					(ego setCycle: CycleTo 4 1 self)
				else
					(self cue:)
				)
			)
			(1
				(if (!= theSeconds 0)
					(Print
						@local3
						#at
						225
						85
						#width
						90
						#mode
						1
						#title
						{ Fenrus_}
						#dispose
						#time
						theSeconds
					)
					(= seconds theSeconds)
				else
					(Print @local3 #at 225 85 #width 90 #mode 1)
					(self cue:)
				)
			)
			(2
				(fenrus setCycle: 0 setLoop: 5 setCel: 0 setScript: 0)
				(= global311 0)
			)
		)
	)
)

(instance egoPrint of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch local254
					(0
						(if (> (ego cel?) 0)
							(ego setCycle: CycleTo 0 -1 self)
						else
							(self cue:)
						)
					)
					(1
						(if (> (ego cel?) 1)
							(ego setCycle: CycleTo 1 -1 self)
						else
							(ego setCel: 1)
							(= cycles 1)
						)
					)
					(2
						(cond 
							((< (ego cel?) 2) (ego setCycle: CycleTo 2 1 self))
							((> (ego cel?) 2) (ego setCycle: CycleTo 2 -1 self))
							(else (self cue:))
						)
					)
					(3
						(if (< (ego cel?) 3)
							(ego setCycle: CycleTo 3 1 self)
						else
							(ego setCel: 3)
							(= cycles 1)
						)
					)
					(4
						(if (< (ego cel?) 4)
							(ego setCycle: CycleTo 4 1 self)
						else
							(fenrus setLoop: 6)
							(= cycles 2)
						)
					)
				)
			)
			(1
				(Print @local3 #at -1 15)
				(if (== (fenrus loop?) 6) (fenrus setLoop: 5))
				(ego setScript: 0)
			)
		)
	)
)

(instance drinkTea of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local256 1)
				(wizard hide:)
				(teacup hide:)
				(self cue:)
			)
			(1
				(wizDrinking setCycle: EndLoop self)
			)
			(2 (= cycles 8))
			(3
				(wizDrinking setCycle: BegLoop self)
			)
			(4
				(= local256 0)
				(wizard show:)
				(teacup show:)
				(wizDrinking setCel: 0 setScript: 0)
			)
		)
	)
)

(instance teleportOut of Script
	(properties)
	
	(method (doit)
		(if (and (not global310) (not global311)) (self cue:))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if global313 (= global313 0))
				(= local258 0)
				(User canInput: 0)
				(switch local1
					(1 (ErasmusPrint 4 31 28))
					(2 (ErasmusPrint 8 31 29))
					(3 (ErasmusPrint 6 31 30))
					(4 (ErasmusPrint 4 31 31))
					(5 (ErasmusPrint 4 31 32))
					(6 (ErasmusPrint 4 31 31))
				)
			)
			(1
				(= global310 1)
				(wizard hide:)
				(wizDrinking setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(2
				(Magic
					ignoreActors:
					setPri: (+ (ego priority?) 1)
					posn: (egoChair x?) (egoChair y?)
					init:
					setCycle: CycleTo 6 1 self
				)
			)
			(3
				(ego hide:)
				(egoChair setLoop: 0 setCel: 3)
				(Magic setCycle: EndLoop self)
			)
			(4
				(Bset 142)
				(gCast eachElementDo: #dispose)
				(curRoom drawPic: 400 16)
				(self cue:)
			)
			(5 (curRoom newRoom: 28))
		)
	)
)

(instance table of PicView
	(properties
		y 149
		x 152
		view 31
		cel 1
		priority 6
	)
)

(instance shelf of PicView
	(properties
		y 123
		x 201
		view 31
		cel 8
		priority 7
	)
)

(instance door1 of Actor
	(properties
		y 119
		x 153
		view 31
		illegalBits $0000
		xStep 1
	)
)

(instance door2 of Actor
	(properties
		y 119
		x 168
		view 31
		illegalBits $0000
		xStep 1
	)
)

(instance egoChair of View
	(properties
		y 151
		x 183
		view 31
		cel 3
	)
)

(instance teacup of View
	(properties
		y 123
		x 147
		view 31
		cel 5
	)
)

(instance wizBody of View
	(properties
		y 148
		x 131
		view 31
		cel 6
	)
)

(instance wizard of Actor
	(properties
		y 122
		x 129
		view 31
		loop 2
		cycleSpeed 1
	)
)

(instance wizDrinking of Actor
	(properties
		y 128
		x 136
		view 31
		loop 1
		cycleSpeed 1
	)
)

(instance fenrus of Prop
	(properties
		y 113
		x 206
		view 199
		loop 4
	)
)

(instance poof of Prop
	(properties
		y 108
		x 204
		view 199
		loop 3
		cel 5
		cycleSpeed 1
	)
)

(instance Magic of Prop
	(properties
		view 530
		cycleSpeed 2
	)
)

(instance onCheese of RFeature
	(properties
		nsTop 101
		nsLeft 192
		nsBottom 108
		nsRight 197
	)
)

(instance onRat of RFeature
	(properties
		nsTop 91
		nsLeft 198
		nsBottom 114
		nsRight 210
	)
)

(instance onLWindow of RFeature
	(properties
		nsTop 88
		nsLeft 119
		nsBottom 100
		nsRight 131
	)
)

(instance onRWindow of RFeature
	(properties
		nsTop 90
		nsLeft 187
		nsBottom 111
		nsRight 197
	)
)

(instance onStairs of RFeature
	(properties
		nsTop 156
		nsLeft 161
		nsBottom 166
		nsRight 197
	)
)

(instance onTable of RFeature
	(properties
		nsTop 118
		nsLeft 138
		nsBottom 149
		nsRight 168
	)
)

(instance onCeiling of RFeature
	(properties
		nsLeft 97
		nsBottom 90
		nsRight 224
	)
)

(instance entryDelay of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1 (client setScript: register))
		)
	)
)
