;;; Sierra Script 1.0 - (do not remove this comment)
(script# 17)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm17 0
)

(instance rm17 of EncRoom
	(properties
		picture 703
		style $0008
		horizon 90
		north 11
		east 18
		south 25
		west 16
		encChance 30
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(11
				(ego posn: 188 91 setMotion: MoveTo 190 190)
			)
			(16
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(18
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(25
				(ego posn: 160 188 setMotion: MoveTo 160 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 7)
		(super dispose:)
	)
)
