;;; Sierra Script 1.0 - (do not remove this comment)
(script# 18)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm18 0
)

(instance rm18 of EncRoom
	(properties
		picture 700
		style $0008
		horizon 90
		east 19
		west 17
		encChance 30
		entrances 10
		illBits (& cWHITE cLRED)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(ego illegalBits: (& cWHITE cLRED))
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(17
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(19
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
		(gAddToPics
			add: northBush southBush
			eachElementDo: #init
			doit:
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 8)
		(super dispose:)
	)
)

(instance northBush of PicView
	(properties
		y 86
		x 133
		view 700
		loop 2
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 162
		view 700
		loop 2
		cel 1
		priority 15
	)
)
