;;; Sierra Script 1.0 - (do not remove this comment)
(script# 25)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm25 0
)

(instance rm25 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		north 17
		south 36
		west 24
		encChance 30
		entrances 13
		illBits (& cWHITE cLMAGENTA)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(24
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(17
				(ego posn: 130 92 setMotion: MoveTo 130 190)
			)
			(36
				(ego posn: 120 188 setMotion: MoveTo 120 0)
			)
		)
		(eastBush ignoreActors: setPri: 6 init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 15)
		(super dispose:)
	)
)

(instance eastBush of View
	(properties
		y 147
		x 278
		view 700
		loop 1
	)
)
