;;; Sierra Script 1.0 - (do not remove this comment)
(script# 26)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm26 0
)

(instance rm26 of EncRoom
	(properties
		picture 700
		style $0008
		horizon 90
		north 19
		east 27
		south 42
		encChance 20
		entrances 7
		illBits (& cWHITE cYELLOW)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(19
				(ego posn: 140 92 setMotion: MoveTo 140 190)
			)
			(42
				(ego posn: 160 188 setMotion: MoveTo 160 0)
			)
			(27
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
		(westBush setPri: 7 ignoreActors: init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 16)
		(super dispose:)
	)
)

(instance westBush of View
	(properties
		y 167
		x 32
		view 700
	)
)
