;;; Sierra Script 1.0 - (do not remove this comment)
(script# 33)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm33 0
)

(instance tromp of Sound
	(properties
		number 66
		priority 1
	)
)

(instance rm33 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		north 22
		east 34
		south 45
		encChance 35
		entrances 7
		illBits (& cWHITE cYELLOW)
	)
	
	(method (init)
		(Load rsVIEW 700)
		(if (== prevRoomNum 22)
			(Load rsSOUND (GetSongNumber 66))
		)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(22
				(if (Btest 172) (LockEgo))
				(ego posn: 130 91 setMotion: MoveTo 130 190)
			)
			(34
				(ego posn: 319 140 setMotion: MoveTo 0 140)
			)
			(45
				(ego posn: 120 189 setMotion: MoveTo 120 0)
			)
		)
		(westBush setPri: 7 ignoreActors: init: addToPic:)
		(if (and (Btest 172) (not (Btest 173)))
			(Bclear 172)
			(self setScript: hutUp)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 23)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl ego pEvent 3) (HighPrint 33 0))
		)
	)
)

(instance westBush of View
	(properties
		y 176
		x 24
		view 700
	)
)

(instance hutUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 6))
			(1
				(tromp number: (GetSongNumber 66) init: play:)
				(ShakeScreen 3)
				(= cycles 5)
			)
			(2
				(HighPrint 33 1)
				(self cue:)
			)
			(3 (= cycles 5))
			(4
				(tromp play:)
				(ShakeScreen 3)
				(Bclear 172)
				(UnlockEgo)
				(rm33 setScript: 0)
			)
		)
	)
)
