;;; Sierra Script 1.0 - (do not remove this comment)
(script# 34)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm34 0
)

(instance rm34 of EncRoom
	(properties
		picture 700
		style $0008
		horizon 90
		north 23
		east 35
		south 51
		west 33
		encChance 20
	)
	
	(method (init)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(23
				(ego posn: 140 92 setMotion: MoveTo 140 190)
			)
			(33
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(51
				(ego posn: 160 188 setMotion: MoveTo 160 0)
			)
			(35
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 24)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl ego pEvent 3) (HighPrint 34 0))
		)
	)
)
