;;; Sierra Script 1.0 - (do not remove this comment)
(script# 42)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm42 0
)

(instance rm42 of EncRoom
	(properties
		picture 703
		style $0008
		horizon 90
		north 26
		east 43
		south 56
		encChance 20
		entrances 7
		illBits (& cWHITE cLMAGENTA)
	)
	
	(method (init)
		(super init:)
		(Load rsVIEW 700)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(26
				(ego posn: 190 92 setMotion: MoveTo 190 190)
			)
			(43
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(56
				(ego posn: 200 188 setMotion: MoveTo 200 0)
			)
		)
		(westBush setPri: 6 ignoreActors: init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 32)
		(super dispose:)
	)
)

(instance westBush of View
	(properties
		y 150
		x 35
		view 700
	)
)
