;;; Sierra Script 1.0 - (do not remove this comment)
(script# 51)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use System)

(public
	rm51 0
)

(instance rm51 of EncRoom
	(properties
		picture 703
		style $0008
		horizon 90
		north 34
		east 52
		south 63
		west 45
		encChance 15
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(34
				(ego posn: 190 92 setMotion: MoveTo 190 190)
			)
			(52
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(45
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(63
				(ego posn: 200 188 setMotion: MoveTo 200 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 41)
		(super dispose:)
	)
)
