;;; Sierra Script 1.0 - (do not remove this comment)
(script# 62)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use User)
(use System)

(public
	rm62 0
)

(instance rm62 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		north 45
		east 63
		south 70
		west 61
		encChance 15
	)
	
	(method (init)
		(if (and isNightTime (== prevRoomNum 70))
			(Load rsSCRIPT 295)
		)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(45
				(ego posn: 130 92 setMotion: MoveTo 130 190)
			)
			(63
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(61
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(70
				(ego posn: 120 188 setMotion: MoveTo 120 175)
				(if (Btest 188)
					(Bclear 188)
					(User canControl: 0)
					(User canInput: 0)
					(self setScript: (ScriptID 295 0))
				)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 52)
		(super dispose:)
	)
)
