;;; Sierra Script 1.0 - (do not remove this comment)
(script# 69)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm69 0
)

(instance rm69 of EncRoom
	(properties
		picture 701
		style $0008
		horizon 90
		north 61
		east 70
		encChance 20
		entrances 3
		illBits (& cWHITE cLMAGENTA cLRED)
	)
	
	(method (init)
		(Load rsVIEW 700)
		(if (and isNightTime (== prevRoomNum 70))
			(Load rsSCRIPT 295)
		)
		(super init:)
		(self setLocales: 804)
		(StatusLine enable:)
		(StopEgo)
		(if (not global332) (ego illegalBits: (& cWHITE cLMAGENTA) init:))
		(switch prevRoomNum
			(70
				(ego posn: 318 140 setMotion: MoveTo 265 140)
				(if (Btest 188)
					(User canControl: 0)
					(User canInput: 0)
					(Bclear 188)
					(self setScript: (ScriptID 295 0))
				)
			)
			(61
				(ego posn: 180 92 setMotion: MoveTo 180 190)
			)
		)
		(southBush init:)
		(gAddToPics add: southBush doit:)
		(westBush ignoreActors: setPri: 7 init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 59)
		(super dispose:)
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 158
		view 700
		loop 2
		cel 1
		priority 15
	)
)

(instance westBush of View
	(properties
		y 173
		x 30
		view 700
	)
)
