;;; Sierra Script 1.0 - (do not remove this comment)
(script# 79)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm79 0
)

(instance rm79 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		north 72
		east 80
		west 78
		encChance 20
		entrances 11
		illBits (& cWHITE cLRED)
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(80
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(78
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(72
				(ego posn: 130 92 setMotion: MoveTo 130 190)
			)
		)
		(gAddToPics add: southBush eachElementDo: #init doit:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 69)
		(super dispose:)
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 158
		view 700
		loop 2
		cel 1
		priority 15
	)
)
