;;; Sierra Script 1.0 - (do not remove this comment)
(script# 81)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm81 0
)

(instance rm81 of EncRoom
	(properties
		picture 703
		style $0008
		horizon 80
		north 74
		east 82
		south 87
		west 80
		encChance 20
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(hollowLog init: stopUpd:)
		(switch prevRoomNum
			(74
				(ego posn: 190 92 setMotion: MoveTo 190 190)
			)
			(82
				(ego posn: 318 140 setMotion: MoveTo 0 140)
			)
			(80
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
			(87
				(ego posn: 200 188 setMotion: MoveTo 200 0)
			)
		)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 71)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look[<around,at][/forest,area]') (HighPrint 81 0))
					(
						(or
							(IsObjectOnControl hollowLog pEvent 3)
							(Said 'look/log')
						)
						(HighPrint 81 1)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance hollowLog of View
	(properties
		y 91
		x 281
		view 181
	)
)
