;;; Sierra Script 1.0 - (do not remove this comment)
(script# 86)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm86 0
)

(instance rm86 of EncRoom
	(properties
		picture 702
		style $0008
		horizon 90
		south 92
		west 85
		encChance 100
		entrances 12
		illBits (& cWHITE cLMAGENTA)
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(if (not global332) (ego init:))
		(switch prevRoomNum
			(92
				(ego posn: 120 188 setMotion: MoveTo 120 0)
			)
			(85
				(ego posn: 1 140 setMotion: MoveTo 320 140)
			)
		)
		(northBush init:)
		(gAddToPics add: northBush doit:)
		(eastBush ignoreActors: setPri: 6 init: addToPic:)
		(if
			(not
				(OneOf
					prevRoomNum
					420
					425
					430
					435
					440
					445
					455
					450
					460
					465
					470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset 76)
		(super dispose:)
	)
)

(instance northBush of PicView
	(properties
		y 71
		x 136
		view 700
		loop 2
	)
)

(instance eastBush of View
	(properties
		y 147
		x 278
		view 700
		loop 1
	)
)
