;;; Sierra Script 1.0 - (do not remove this comment)
(script# 55)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use LoadMany)
(use GControl)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm55 0
)

(local
	local0
	local1
	local2
	local3
	local4
	theCycles
	local6
)
(procedure (localproc_000c)
	(cond 
		((Btest 224) (HighPrint 55 0))
		((Btest 223) (HighPrint 55 1))
		((Btest 334) (localproc_004e))
		(else (HighPrint 55 2))
	)
)

(procedure (localproc_004e &tmp [temp0 200])
	(if (and (not (Btest 223)) (not (Btest 224)))
		(cond 
			(
				(and
					(Btest 218)
					(Btest 219)
					(Btest 220)
					(Btest 221)
					(Btest 222)
				)
				(rm55 setScript: waitForHealer)
				(Bset 223)
				(Bclear 224)
				(Bclear 218)
				(Bclear 219)
				(Bclear 220)
				(Bclear 221)
				(Bclear 222)
			)
			((Btest 334)
				(HighPrint
					(Format
						@temp0
						55
						3
						(if (Btest 218) {} else { \nFairy Dust})
						(if (Btest 219) {} else { \nGreen Fur})
						(if (Btest 220) {} else { \nFlowers from Erana's Peace})
						(if (Btest 221) {} else { \nMagic Acorn})
						(if (Btest 222) {} else { \nFlying Water})
					)
				)
			)
		)
	)
)

(procedure (localproc_01b4)
	(Print &rest #width 305 #mode 0 #window healerWin)
)

(procedure (localproc_01cb param1 param2)
	(return
		(if (GiveSilverCoins param2)
			(HighPrint 55 4)
			(HighPrint 55 5)
			(ego get: param1 1)
			(return 1)
		else
			(HighPrint 55 6)
			(return 0)
		)
	)
)

(instance healerWin of SysWindow
	(properties
		color 1
	)
	
	(method (open &tmp temp0)
		(= top (+ top (= temp0 (- 188 bottom))))
		(= bottom (+ bottom temp0))
		(super open:)
	)
)

(instance rm55 of Room
	(properties
		picture 55
		style $0008
	)
	
	(method (init)
		(LoadMany 128 57 56 523 525)
		(Load rsSOUND 42)
		(super init:)
		(gMouseHandler add: self)
		(kettle init: setCycle: Forward)
		(gAddToPics
			add: rmTable rmStuff1 rmStuff2 rmStuff3 rmBin rmShelf1 rmShelf2 rmLamp
			eachElementDo: #init
			doit:
		)
		(self
			setFeatures:
				onKettle
				onBird
				onMaps
				onLadder
				onTable
				onLitterBox
				onLamp
				onWindow
				onThings
				onStores
				onBins
		)
		(StatusLine enable:)
		(StopEgo)
		(bird setScript: preening)
		(self setScript: egoEnters)
	)
	
	(method (doit)
		(if (& (ego onControl: origin) cLBLUE)
			(if (and (not (Btest 225)) (not (Btest 230)))
				(HighPrint 55 7)
			)
			(Bset 225)
			(curRoom newRoom: 54)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 45)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if (IsObjectOnControl ego pEvent 3)
			(HighPrint 55 8)
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/room,hut,building]') (HighPrint 55 9) (HighPrint 55 10))
							((Said '/healer,female') (HighPrint 55 11))
							((Said '/creature,animal,bird,lizard') (HighPrint 55 12))
							((Said '/potion') (HighPrint 55 13))
							((Said '/pan,caldron,fire') (HighPrint 55 14))
							((Said '/soup') (HighPrint 55 15))
							((Said '/ladder') (HighPrint 55 16))
						)
					)
					((Said 'eat,get/soup') (HighPrint 55 17))
					((or (Said 'nap') (Said 'go[<to]/nap')) (HighPrint 55 18))
					((Said 'climb/ladder') (HighPrint 55 19))
					((Said '/bin,icicle,cheesecloth') (HighPrint 55 20))
				)
			)
		)
	)
)

(instance healer of Actor
	(properties
		view 57
		illegalBits $0000
	)
	
	(method (doit)
		(if
			(and
				local4
				(!= script healerKisses)
				(> (+ (* (ego y?) 3) (ego x?) -615) 0)
			)
			(healer setScript: healerKisses)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((== evMOUSEBUTTON (pEvent type?))
				(cond 
					((super handleEvent: pEvent))
					((IsObjectOnControl healer pEvent 3) (HighPrint 55 21))
				)
			)
			((== evSAID (pEvent type?))
				(cond 
					((super handleEvent: pEvent))
					((Said 'chat,ask>')
						(= local6 1)
						(cond 
							((Said '/ring<faerie,faerie') (HighPrint 55 22))
							((Said '/ring')
								(if (Btest 230)
									(HighPrint 55 23)
								else
									(HighPrint 55 23)
									(HighPrint 55 24)
								)
							)
							((Said '/prize')
								(if (Btest 230)
									(HighPrint 55 25)
								else
									(HighPrint 55 26)
								)
							)
							((Said '/component,material') (HighPrint 55 27))
							((Said '/herb') (HighPrint 55 28))
							(
							(or (Said '/potion<healing') (Said '/healing')) (HighPrint 55 29))
							((Said '/potion<vigor') (HighPrint 55 30))
							((Said '/potion<magic') (HighPrint 55 31))
							((Said '/potion<disenchant') (localproc_000c))
							(
							(or (Said '/potion<healing') (Said '/healing')) (HighPrint 55 32))
							((Said '/potion') (HighPrint 55 33) (localproc_01b4 55 34))
							((Said '/grease,grease,ghoul') (HighPrint 55 35))
							((Said '/zombie') (HighPrint 55 36))
							((Said '/ghost') (HighPrint 55 37))
							((Said '/stamina') (HighPrint 55 38))
							((Said '/fur') (HighPrint 55 39))
							((Said '/faerie,dust') (HighPrint 55 40))
							((Said '/flower')
								(HighPrint 55 41)
								;"I use flowers from Erana's Peace to the north in nearly all my potions.  They have some of the magic of the place even when they are dried."
								(if (>= 1 flowersSold) 
									(HighPrint 55 42)
									;"I will pay you five silvers for a flask full of flowers."
								)
							)
							((Said '/mushroom')
								(HighPrint 55 43)
								;"I use the mushrooms from a fairy ring to make Magic Potions."
								(if (>= 2 mushroomsSold) 
									(HighPrint 55 44)
									;"I will pay you one gold for some."
								)
							)
							((Said '/claw,cheetaur') (HighPrint 55 45))
							((Said '/beard,troll') (HighPrint 55 46))
							((Said '/dryad') (HighPrint 55 47))
							((Said '/water<fly') (HighPrint 55 48))
							((Said '/acorn[<magic,about]') (HighPrint 55 49))
							((Said '/bottle') (HighPrint 55 50))
							(
							(or (Said '/name,handle') (Said '/female,healer')) (HighPrint 55 51))
							((Said '/bird,creature,lizard') (HighPrint 55 52))
							((Said '/lizard') (HighPrint 55 53))
							((Said '/baron') (HighPrint 55 54))
							((Said '/barnard,barnard') (HighPrint 55 55))
							((Said '/elsa,daughter') (HighPrint 55 56))
							((Said '/bandit') (HighPrint 55 57))
							((Said '/centaur,farmer,heinrich') (HighPrint 55 58))
							((Said '/(peace<erana),erana') (HighPrint 55 59))
							((Said '/magic') (HighPrint 55 60))
							((Said '/mandrake,root') (HighPrint 55 61))
							(else (= local6 0) (HighPrint 55 62) (pEvent claimed: 1))
						)
						(if local6 (AddToScore POINTS_TALKTOHEALER 2))
					)
					((Said 'gave,offer,sell,display>')
						(cond 
							((Said '/ring')
								(if (ego has: invGoldRing)
									(if
									(> (+ (* (ego y?) 8) (* (ego x?) 3) -1822) 0)
										(PrintNotCloseEnough)
									else
										(Bset 230)
										(ego use: invGoldRing)
										(AddToScore POINTS_RETURNRING 10)
										(HighPrint 55 63)
										(= [invNum invGoldCoin] (+ [invNum invGoldCoin] 6))
										(ego get: invHealingPotion)
										(ego get: invHealingPotion)
										(if (<= (+ (* (ego y?) 3) (ego x?) -615) 0)
											(= theCycles 20)
											(healer setScript: healerPleased)
										)
										(= local4 1)
									)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/flower')
								(if (ego has: invBeautifulFlower)
									(if (> flowersSold 2)
										(HighPrint 55 64)
										;Thank you, but I have all the flowers I need.
									else
										(= theCycles 10)
										(healer setScript: healerPleased)
										(HighPrint 55 65)
										(GiveSilverCoins -5)
										(Bset 220)
										(localproc_004e)
										(++ flowersSold)
										(ego use: invBeautifulFlower 5)
										(AddToScore POINTS_SELLFLOWERS 1)
									)
								else
									(HighPrint 55 66)
								)
							)
							((Said '/mushroom')
								(if (ego has: invMushroom)
									(cond 
										((< 2 mushroomsSold) 
											(HighPrint 55 67)
											;Thank you, but I have enough mushrooms.
										)
										((Btest 174) (HighPrint 55 68))
										(else
											(= theCycles 10)
											(healer setScript: healerPleased)
											(PrintTimedMessage 8 55 69)
											(GiveSilverCoins -10)
											(++ mushroomsSold)
											(ego use: invMushroom 3)
											(AddToScore POINTS_SELLMUSHROOM 1)
										)
									)
								else
									(HighPrint 55 66)
								)
							)
							((Said '/claw,cheetaur')
								(if (= local1 (ego has: invCheetaurClaw))
									(= theCycles 10)
									(healer setScript: healerPleased)
									(PrintTimedMessage 8 55 70)
									(ego get: invSilverCoin (mod (* local1 5) 10))
									(ego get: invGoldCoin (/ (* local1 5) 10))
									(ego use: invCheetaurClaw local1)
									(AddToScore POINTS_SELLCHEETAURCLAW 2)
								else
									(HighPrint 55 66)
								)
							)
							((Said '/beard,troll')
								(if (ego has: invTrollBeard)
									(= theCycles 10)
									(healer setScript: healerPleased)
									(PrintTimedMessage 8 55 71)
									(ego use: invTrollBeard)
									(ego get: invHealingPotion)
									(ego get: invHealingPotion)
									(AddToScore POINTS_SELLTROLLBEARD 2)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/dust[<faerie]')
								(if (ego has: invFairyDust)
									(= theCycles 10)
									(healer setScript: healerPleased)
									(if (and (not (Btest 223)) (Btest 334))
										(HighPrint 55 72)
									else
										(HighPrint 55 73)
									)
									(ego use: invFairyDust)
									(Bset 218)
									(AddToScore POINTS_GIVEFAIRYDUST 2)
									(localproc_004e)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/water[<floating]')
								(cond 
									((not (ego has: invFlyingWater)) (PrintDontHaveIt))
									(flyingWaterGiven 
										(HighPrint 55 74)
										;"I don't need any more Flying Water.  Thank you anyway."
									)
									((not (Btest 334)) (HighPrint 55 75))
									((not (Btest 329)) (HighPrint 55 76) (HighPrint 55 77))
									(else
										(if (> [invNum invFlyingWater] 1)
											(HighPrint 55 78)
										else
											(HighPrint 55 79)
										)
										(= theCycles 10)
										(healer setScript: healerPleased)
										(HighPrint 55 80)
										;"Flying Water. how clever."
										(++ flyingWaterGiven)
										(ego use: invFlyingWater)
										(Bset 222)
										(AddToScore POINTS_GIVEFLYINGWATER 2)
										(localproc_004e)
									)
								)
							)
							((Said '/fur')
								(if (ego has: invMeepGreenFur)
									(= theCycles 10)
									(healer setScript: healerPleased)
									(if (Btest 334)
										(HighPrint 55 81)
									else
										(HighPrint 55 82)
									)
									(ego use: invMeepGreenFur)
									(Bset 219)
									(AddToScore POINTS_GIVEGREENFUR 2)
									(localproc_004e)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/acorn')
								(if (ego has: invMagicAcorn)
									(= theCycles 10)
									(healer setScript: healerPleased)
									(HighPrint 55 83)
									(ego use: invMagicAcorn)
									(Bset 221)
									(AddToScore POINTS_GIVEMAGICACORN 5)
									(localproc_004e)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/bottle')
								(if (ego has: invEmptyFlask)
									(= theCycles 6)
									(healer setScript: healerPleased)
									(PrintTimedMessage 8 55 84)
									(ego use: invEmptyFlask)
									(ego get: invSilverCoin 1)
								else
									(PrintDontHaveIt)
								)
							)
							((Said '/root,plant[<mandrake]') (HighPrint 55 85))
						)
					)
					((Said 'buy,buy,get,get>')
						(cond 
							((Said '/potion[<!*]') (HighPrint 55 86))
							((Said '/potion<vigor') (localproc_01cb invVigorPotion 20))
							((Said '/potion<healing') (localproc_01cb invHealingPotion 40))
							((Said '/potion<magic') (localproc_01cb invManaPotion 60))
							((Said '/grease[<ghost,ghoul]') (localproc_01cb invUndeadUnguent 100))
							((Said '/potion<disenchant') (localproc_000c))
							((Said '/bottle') (HighPrint 55 87))
							((Said '/root,plant[<mandrake]') (HighPrint 55 88))
						)
					)
					((Said 'grab/potion,herb')
						(cond 
							((Btest 226) (HighPrint 55 89))
							(local2 (HighPrint 55 90) (ego get: invHealingPotion 2) (Bset 226))
							(else (HighPrint 55 91))
						)
					)
					(
					(or (Said 'kill,fight') (Said 'cast/flame,dart,spell')) (HighPrint 55 92))
					((Said 'throw') (HighPrint 55 93))
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(if (== temp0 skDETECTMAGIC)
								(HighPrint 55 94)
							else
								(pEvent claimed: 0)
							)
						)
					)
				)
			)
		)
	)
)

(instance kettle of Prop
	(properties
		y 114
		x 209
		view 56
		cycleSpeed 1
	)
)

(instance bird of Prop
	(properties
		y 82
		x 75
		view 57
		loop 8
		cycleSpeed 2
	)
)

(instance rmStuff1 of PicView
	(properties
		y 108
		x 244
		view 56
		loop 1
		signal $4000
	)
)

(instance rmStuff2 of PicView
	(properties
		y 121
		x 242
		view 56
		loop 1
		cel 1
		signal $4000
	)
)

(instance rmStuff3 of PicView
	(properties
		y 138
		x 242
		view 56
		loop 1
		cel 2
		priority 10
		signal $4000
	)
)

(instance rmBin of PicView
	(properties
		y 154
		x 209
		view 56
		loop 2
		priority 14
		signal $4000
	)
)

(instance rmShelf1 of PicView
	(properties
		y 118
		x 150
		view 56
		loop 3
		signal $4000
	)
)

(instance rmShelf2 of PicView
	(properties
		y 135
		x 85
		view 56
		loop 4
		signal $4000
	)
)

(instance rmTable of PicView
	(properties
		y 136
		x 152
		z 1
		view 56
		loop 5
		priority 11
		signal $4000
	)
)

(instance rmLamp of PicView
	(properties
		y 92
		x 222
		view 56
		loop 6
		signal $4000
	)
)

(instance onKettle of RFeature
	(properties
		nsTop 111
		nsLeft 190
		nsBottom 126
		nsRight 207
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKettle pEvent 3) (HighPrint 55 14))
		)
	)
)

(instance onBird of RFeature
	(properties
		nsTop 73
		nsLeft 65
		nsBottom 82
		nsRight 87
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBird pEvent 3) (HighPrint 55 95))
		)
	)
)

(instance onMaps of RFeature
	(properties
		nsTop 85
		nsLeft 72
		nsBottom 134
		nsRight 92
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onMaps pEvent 3) (HighPrint 55 96))
		)
	)
)

(instance onLadder of RFeature
	(properties
		nsTop 51
		nsLeft 168
		nsBottom 119
		nsRight 181
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLadder pEvent 3) (HighPrint 55 97))
		)
	)
)

(instance onTable of RFeature
	(properties
		nsTop 130
		nsLeft 133
		nsBottom 135
		nsRight 173
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTable pEvent 3) (HighPrint 55 98))
		)
	)
)

(instance onLitterBox of RFeature
	(properties
		nsTop 109
		nsLeft 96
		nsBottom 124
		nsRight 129
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLitterBox pEvent 3) (HighPrint 55 99))
		)
	)
)

(instance onLamp of RFeature
	(properties
		nsTop 83
		nsLeft 219
		nsBottom 91
		nsRight 224
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLamp pEvent 3) (HighPrint 55 100))
		)
	)
)

(instance onWindow of RFeature
	(properties
		nsTop 84
		nsLeft 94
		nsBottom 102
		nsRight 131
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onWindow pEvent 3) (HighPrint 55 101))
		)
	)
)

(instance onThings of RFeature
	(properties
		nsTop 94
		nsLeft 232
		nsBottom 136
		nsRight 253
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onThings pEvent 3) (HighPrint 55 102))
		)
	)
)

(instance onStores of RFeature
	(properties
		nsTop 86
		nsLeft 143
		nsBottom 118
		nsRight 156
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStores pEvent 3) (HighPrint 55 103))
		)
	)
)

(instance onBins of RFeature
	(properties
		nsTop 144
		nsLeft 183
		nsBottom 155
		nsRight 231
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBins pEvent 3) (HighPrint 55 104))
		)
	)
)

(instance egoEnters of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego init: posn: 124 160)
				(healer
					loop: 0
					init:
					posn: 110 145
					setCycle: Walk
					setMotion: MoveTo 107 141 self
				)
			)
			(1
				(if (not (Btest 225)) (HighPrint 55 105))
				(healer setMotion: MoveTo 139 139 self)
				(ego setMotion: MoveTo 155 160)
			)
			(2
				(if
					(and
						(Btest 225)
						(not (Btest 223))
						(or (not (Btest 201)) (Btest 334))
					)
					(HighPrint 55 106)
				)
				(if (not (Btest 225))
					(HighPrint 55 107)
					(HighPrint 55 108)
					(HighPrint 55 109)
				)
				(if (and (Btest 201) (not (Btest 334)))
					(HighPrint 55 110)
					(Bset 334)
				)
				(if (Btest 223)
					(HighPrint 55 111)
					(ego get: invDispelPotion)
					(Bclear 223)
					(Bset 224)
					(AddToScore POINTS_GETDISPELPOTION 7)
				)
				(UnlockEgo)
				(healer setLoop: 5 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(3
				(healer setLoop: 5 setCycle: Forward)
				(healer setScript: healerPuttering)
			)
		)
	)
)

(instance preening of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bird init: cel: 2 setCycle: EndLoop)
				(= cycles (Random 9 27))
			)
			(1 (bird setCycle: EndLoop self))
			(2 (= cycles (Random 100 200)))
			(3 (self changeState: 0))
		)
	)
)

(instance healerPuttering of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (Random 90 200)))
			(1
				(if (> (ego y?) 149)
					(healer
						setLoop: 4
						cel: 2
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: BegLoop self
					)
				else
					(self changeState: 0)
				)
			)
			(2
				(= local2 1)
				(switch (= local3 (Random 0 1))
					(0
						(healer
							loop: 1
							setCycle: Walk
							setMotion: MoveTo 87 138 self
						)
					)
					(1
						(healer
							loop: 3
							setCycle: Walk
							setMotion: MoveTo 155 123 self
						)
					)
				)
			)
			(3
				(switch local3
					(0 (healer loop: 3))
					(1 (healer loop: 1))
				)
				(= seconds 3)
			)
			(4
				(= local2 0)
				(switch local3
					(0
						(healer
							setLoop: 0
							setCycle: Walk
							setMotion: MoveTo 139 139 self
						)
					)
					(1
						(healer
							setLoop: 2
							setCycle: Walk
							setMotion: MoveTo 139 139 self
						)
					)
				)
			)
			(5
				(healer
					setLoop: 4
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(6
				(healer setLoop: 5 cel: 0 setCycle: Forward)
				(self changeState: 0)
			)
		)
	)
)

(instance healerPleased of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(healer setMotion: 0 loop: 2)
				(= cycles 2)
			)
			(1
				(healer setLoop: 6 cel: 0 setCycle: EndLoop self)
			)
			(2 (= cycles theCycles))
			(3
				(switch local3
					(0
						(healer
							setLoop: -1
							setCycle: Walk
							setMotion: MoveTo 139 139 self
						)
					)
					(1
						(healer
							setLoop: 2
							setCycle: Walk
							setMotion: MoveTo 139 139 self
						)
					)
				)
			)
			(4
				(healer setLoop: 5 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(5
				(healer setLoop: 5 setCycle: Forward)
				(healer setScript: healerPuttering)
			)
		)
	)
)

(instance healerKisses of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if
					(not
						(if
							(and
								(<= 138 (healer x?))
								(<= (healer x?) 140)
								(<= 138 (healer y?))
							)
							(<= (healer y?) 140)
						)
					)
					(switch local3
						(0
							(healer
								setLoop: -1
								setCycle: Walk
								illegalBits: 0
								setMotion: MoveTo 139 139 self
							)
						)
						(1
							(healer
								setLoop: 2
								setCycle: Walk
								setMotion: MoveTo 139 139 self
							)
						)
					)
				else
					(= cycles 2)
				)
			)
			(1
				(healer setLoop: 2)
				(ego illegalBits: 0 setMotion: MoveTo 171 152 self)
			)
			(2
				(ego setLoop: 1)
				(= cycles 2)
			)
			(3
				(HighPrint 55 112)
				(healer loop: 7 cel: 0 setCycle: CycleTo 4 1 self)
			)
			(4
				(healer setCycle: EndLoop)
				(ego
					view: 523
					loop: 0
					setPri: 11
					setCycle: EndLoop
					setMotion: MoveTo 166 144 self
				)
			)
			(5
				(kiss init: play:)
				(= seconds 3)
			)
			(6
				(healer loop: 2)
				(ego
					cycleSpeed: 1
					setCycle: BegLoop
					setMotion: MoveTo 166 155 self
				)
			)
			(7
				(ego view: 0 setLoop: 3 setMotion: MoveTo 163 163)
				(healer
					setLoop: -1
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: Walk
					setMotion: MoveTo 153 126 self
				)
			)
			(8
				(healer
					cycleSpeed: 0
					moveSpeed: 0
					setMotion: MoveTo 197 141 self
				)
			)
			(9
				(healer loop: 1)
				(ego view: 4 loop: 0)
				(= cycles 2)
			)
			(10
				(HighPrint 55 113)
				(= cycles 2)
			)
			(11
				(ego
					view: 525
					setLoop: 0
					cycleSpeed: 1
					moveSpeed: 1
					setCycle: EndLoop self
				)
			)
			(12
				(ego
					setLoop: 1
					cycleSpeed: 1
					moveSpeed: 1
					setCycle: Forward
					setMotion: MoveTo 100 155 self
				)
			)
		)
	)
)

(instance waitForHealer of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 10))
			(1
				(HighPrint 55 114)
				(self dispose:)
			)
		)
	)
)

(instance kiss of Sound
	(properties
		number 42
		priority 5
	)
)
