;;; Sierra Script 1.0 - (do not remove this comment)
(script# 54)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowRock)
(use AnimateDazzle)
(use Door)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm54 0
	rock 1
	nest 2
	bird 3
	nestDown 4
	flyAway 5
	treeFall 6
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
)
(instance fireDart of Actor
	(properties
		view 522
		illegalBits $0000
	)
)

(instance magicLasso of Actor
	(properties
		view 520
		illegalBits $0000
	)
)

(instance rock of Actor
	(properties
		view 510
		illegalBits $0000
	)
)

(instance healerSign of PicView
	(properties
		y 72
		x 212
		view 55
		loop 2
		priority 10
	)
)

(instance ring of Prop
	(properties
		y 64
		x 79
		view 55
		loop 6
	)
	
	(method (handleEvent pEvent)
		(asm
			pushi    1
			lofsa    'look/glimmer,reflection,chandelier'
			push    
			callk    Said,  2
			bnt      code_01be
			pushi    1
			pushi    210
			callb    Btest,  2
			not     
			bnt      code_01b3
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_01a2
			pushi    1
			pushi    278
			callb    Btest,  2
			not     
			bnt      code_01a2
			pushi    2
			pushi    54
			pushi    0
			callb    HighPrint,  4
			jmp      code_0303
code_01a2:
			pushi    2
			pushi    54
			pushi    1
			callb    HighPrint,  4
			pushi    1
			pushi    209
			callb    Bset,  2
			jmp      code_0303
code_01b3:
			pushi    #claimed
			pushi    1
			pushi    0
			lap      pEvent
			send     6
			jmp      code_0303
code_01be:
			pushi    1
			lofsa    'look/ring'
			push    
			callk    Said,  2
			bnt      code_01e8
			pushi    1
			pushi    209
			callb    Btest,  2
			bnt      code_01dd
			pushi    2
			pushi    54
			pushi    2
			callb    HighPrint,  4
			jmp      code_0303
code_01dd:
			pushi    #claimed
			pushi    1
			pushi    0
			lap      pEvent
			send     6
			jmp      code_0303
code_01e8:
			pushi    1
			lofsa    'get/ring'
			push    
			callk    Said,  2
			bnt      code_029b
			pushi    #pickUp
			pushi    1
			pushi    19
			lag      ego
			send     6
			bnt      code_020b
			pushi    2
			pushi    54
			pushi    3
			callb    HighPrint,  4
			jmp      code_0303
code_020b:
			pushi    1
			pushi    210
			callb    Btest,  2
			bnt      code_021c
			pushi    0
			callb    PrintAlreadyDoneThat,  0
			jmp      code_0303
code_021c:
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_024e
			pushi    1
			pushi    278
			callb    Btest,  2
			not     
			bnt      code_023b
			pushi    2
			pushi    54
			pushi    4
			callb    HighPrint,  4
			jmp      code_0303
code_023b:
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    237
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0303
code_024e:
			lsg      nestCondition
			ldi      nestBurnt
			eq?     
			bnt      code_0285
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cLMAGENTA
			eq?     
			bt       code_0276
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cYELLOW
			eq?     
code_0276:
			not     
			bnt      code_0285
			pushi    2
			pushi    54
			pushi    5
			callb    HighPrint,  4
			jmp      code_0303
code_0285:
			pushi    1
			pushi    209
			callb    Btest,  2
			not     
			bnt      code_0303
			pushi    2
			pushi    54
			pushi    6
			callb    HighPrint,  4
			jmp      code_0303
code_029b:
			pushi    1
			lofsa    'climb/branch'
			push    
			callk    Said,  2
			bnt      code_0303
			pushi    1
			pushi    210
			callb    Btest,  2
			bnt      code_02b7
			pushi    0
			callb    PrintAlreadyDoneThat,  0
			jmp      code_0303
code_02b7:
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_02e9
			pushi    1
			pushi    278
			callb    Btest,  2
			not     
			bnt      code_02d6
			pushi    2
			pushi    54
			pushi    7
			callb    HighPrint,  4
			jmp      code_0303
code_02d6:
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    237
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0303
code_02e9:
			lsg      nestCondition
			ldi      nestBurnt
			eq?     
			bt       code_02fb
			lsg      nestCondition
			ldi      nestOnGround
			eq?     
			bnt      code_0303
code_02fb:
			pushi    2
			pushi    54
			pushi    8
			callb    HighPrint,  4
code_0303:
			ret     
		)
	)
)

(instance healerDoor of Door
	(properties
		y 127
		x 209
		view 55
		loop 1
		entranceTo 55
		locked 1
		doorControl cLRED
	)
)

(instance bird of Actor
	(properties
		y 66
		x 71
		view 55
		loop 5
		illegalBits $0000
	)
	
	(method (init)
		(super init:)
		(gMouseHandler add: self)
	)
	
	(method (handleEvent pEvent)
		(cond 
			(
				(or
					(Said 'look/bird,creature,lizard')
					(IsObjectOnControl bird pEvent 3)
				)
				(HighPrint 54 9)
			)
			((Said 'eat,get,kill,fight,chop,beat/bird') (HighPrint 54 10))
		)
	)
)

(instance nest of Actor
	(properties
		y 69
		x 73
		view 55
	)
	
	(method (handleEvent pEvent)
		(cond 
			(
				(or
					(Said 'look/nest')
					(IsObjectOnControl nest pEvent 3)
				)
				(cond 
					((not (Btest 212)) (HighPrint 54 11) (HighPrint 54 12))
					((== nestCondition nestInTree)
						(HighPrint 54 13)
						(if (Btest 278)
							(if (not (Btest 210))
								(HighPrint 54 14)
								(Bset 209)
							else
								(HighPrint 54 15)
							)
						)
					)
					((== nestCondition nestOnGround) (HighPrint 54 16))
					((== nestCondition nestBurnt) (HighPrint 54 17))
				)
			)
			((Said 'get/nest')
				(switch nestCondition
					(nestInTree
						(if (Btest 278)
							(HighPrint 54 18)
						else
							(HighPrint 54 19)
						)
					)
					(nestOnGround (HighPrint 54 20))
					(nestBurnt (HighPrint 54 21))
				)
			)
		)
	)
)

(instance whoosh of Sound
	(properties)
)

(instance rm54 of Room
	(properties
		picture 54
		style $0008
		east 56
		south 65
		west 53
	)
	
	(method (init)
		(LoadMany 128 55 510)
		(if (ego knows: skFLAMEDART)
			(Load rsVIEW 522)
			(Load rsSOUND (GetSongNumber 33))
		)
		(if (ego knows: skFETCH) (Load rsVIEW 520))
		(if (ego knows: skDAZZLE) (Load rsVIEW 521))
		(LoadMany 130 103 235 236 237)
		(super init:)
		(cSound fade:)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(UnlockEgo)
		(gAddToPics add: healerSign eachElementDo: #init doit:)
		(healerDoor setPri: 8 init: stopUpd:)
		(if (not (Btest 210)) (ring init: setPri: 15))
		(if (not (Btest 211))
			(if (== nestCondition nestInTree)
				(nest
					illegalBits: 0
					ignoreActors:
					setPri: 13
					cycleSpeed: 1
					init:
					stopUpd:
				)
			else
				(nest init: hide: stopUpd:)
			)
			(if (not (Btest 212))
				(bird
					ignoreActors:
					init:
					cycleSpeed: 1
					stopUpd:
					setScript: flutter
				)
			)
		)
		(switch prevRoomNum
			(37
				(ego setLoop: 2 setPri: 4 posn: 130 100)
				(= local0 1)
				(Bset 44)
			)
			(53
				(ego posn: 10 135 setMotion: MoveTo 72 135)
			)
			(55
				(curRoom setScript: outOfHouse)
			)
			(56
				(ego posn: 318 153 setMotion: MoveTo 295 153)
			)
			(else 
				(ego posn: 160 188 setMotion: MoveTo 160 170)
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(local0 (= local0 0) (ego setScript: (ScriptID 235 0)))
			((not (Btest 44)) (Bset 44) (curRoom setScript: (ScriptID 235 1)))
		)
		(cond 
			(
				(and
					(not local1)
					(!= nestCondition nestOnGround)
					(not (Btest 210))
					(== (ego onControl: origin) cYELLOW)
				)
				(= local1 1)
				(ring cel: 0 setCycle: EndLoop)
			)
			((and local1 (!= (ego onControl: origin) cYELLOW)) (= local1 0))
		)
		(if
			(and
				(== nestCondition nestBurnt)
				(not (Btest 210))
				(not (Btest 211))
				(not local5)
				(or
					(== (ego onControl: origin) cLMAGENTA)
					(== (ego onControl: origin) cYELLOW)
				)
			)
			(= local5 1)
			(ego setScript: pickItUp)
		)
		(if
			(and
				(<= (ego y?) 87)
				(not (Btest 277))
				(not (ego script?))
			)
			(LockEgo)
			(ego setScript: overTheHill)
		)
	)
	
	(method (dispose)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(asm
			pushi    #type
			pushi    0
			lap      pEvent
			send     4
			push    
			dup     
			ldi      128
			eq?     
			bnt      code_0ff1
			pushi    #handleEvent
			pushi    1
			lsp      pEvent
			super    Room,  6
			bnt      code_0944
			jmp      code_0ff1
code_0944:
			pushi    1
			pushi    278
			callb    Btest,  2
			bnt      code_0972
			pushi    1
			lofsa    'throw,run,walk,sneak'
			push    
			callk    Said,  2
			bnt      code_0972
			pushi    3
			pushi    4
			pushi    54
			pushi    22
			callb    PrintTimedMessage,  6
			pushi    #setScript
			pushi    1
			lofsa    treeFall
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0972:
			pushi    1
			lofsa    'wear/ring'
			push    
			callk    Said,  2
			bt       code_0993
			pushi    1
			lofsa    'put[<on]/ring,finger'
			push    
			callk    Said,  2
			bt       code_0993
			pushi    1
			lofsa    'put/ring/finger'
			push    
			callk    Said,  2
			bnt      code_09b2
code_0993:
			pushi    #has
			pushi    1
			pushi    19
			lag      ego
			send     6
			bnt      code_09ab
			pushi    2
			pushi    54
			pushi    23
			callb    HighPrint,  4
			jmp      code_0ff1
code_09ab:
			pushi    0
			callb    PrintDontHaveIt,  0
			jmp      code_0ff1
code_09b2:
			pushi    1
			lofsa    'cast>'
			push    
			callk    Said,  2
			bnt      code_0ada
			pushi    1
			pushi    278
			callb    Btest,  2
			bnt      code_09e5
			pushi    2
			pushi    54
			pushi    24
			callb    HighPrint,  4
			pushi    #setScript
			pushi    1
			lofsa    treeFall
			push    
			lag      ego
			send     6
			pushi    #claimed
			pushi    1
			pushi    1
			lap      pEvent
			send     6
			jmp      code_0ff1
code_09e5:
			pushi    1
			lsp      pEvent
			calle    SaidCast,  2
			sat      temp0
			pushi    1
			push    
			callb    CastSpell,  2
			bnt      code_0ff1
			lst      temp0
			dup     
			ldi      20
			eq?     
			bnt      code_0a22
			pushi    1
			lsg      ego
			calle    AnimateDazzle,  2
			pushi    1
			pushi    212
			callb    Btest,  2
			not     
			bnt      code_0ad6
			pushi    #setScript
			pushi    1
			lofsa    flyAway
			push    
			lofsa    bird
			send     6
			jmp      code_0ad6
code_0a22:
			dup     
			ldi      23
			eq?     
			bnt      code_0a69
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_0a40
			pushi    #setScript
			pushi    1
			lofsa    nestBurn
			push    
			lag      ego
			send     6
			jmp      code_0ad6
code_0a40:
			pushi    #inRect
			pushi    4
			pushi    182
			pushi    0
			pushi    319
			pushi    106
			lag      ego
			send     12
			bnt      code_0a60
			pushi    2
			pushi    54
			pushi    25
			callb    HighPrint,  4
			jmp      code_0ad6
code_0a60:
			pushi    1
			pushi    0
			calle    AnimateThrowingFlameDart,  2
			jmp      code_0ad6
code_0a69:
			dup     
			ldi      24
			eq?     
			bnt      code_0ace
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_0ac3
			pushi    1
			pushi    210
			callb    Btest,  2
			not     
			bnt      code_0ac3
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cLMAGENTA
			eq?     
			bt       code_0aa6
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cYELLOW
			eq?     
			bnt      code_0ab8
code_0aa6:
			ldi      1
			sal      local4
			pushi    #setScript
			pushi    1
			lofsa    throwIt
			push    
			lag      ego
			send     6
			jmp      code_0ad6
code_0ab8:
			pushi    2
			pushi    54
			pushi    26
			callb    HighPrint,  4
			jmp      code_0ad6
code_0ac3:
			pushi    2
			pushi    54
			pushi    27
			callb    HighPrint,  4
			jmp      code_0ad6
code_0ace:
			pushi    #claimed
			pushi    1
			pushi    0
			lap      pEvent
			send     6
code_0ad6:
			toss    
			jmp      code_0ff1
code_0ada:
			pushi    1
			lofsa    'open/door'
			push    
			callk    Said,  2
			bnt      code_0b08
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cLRED
			eq?     
			bnt      code_0b01
			pushi    2
			pushi    54
			pushi    28
			callb    HighPrint,  4
			jmp      code_0ff1
code_0b01:
			pushi    0
			callb    PrintNotCloseEnough,  0
			jmp      code_0ff1
code_0b08:
			pushi    1
			lofsa    'lockpick,unlock/hasp,door'
			push    
			callk    Said,  2
			bnt      code_0b3e
			pushi    3
			pushi    9
			pushi    10
			pushi    0
			callb    TestSkill,  6
			bnt      code_0b2b
			pushi    2
			pushi    54
			pushi    29
			callb    HighPrint,  4
			jmp      code_0ff1
code_0b2b:
			pushi    2
			pushi    54
			pushi    30
			callb    HighPrint,  4
			pushi    2
			pushi    54
			pushi    31
			callb    HighPrint,  4
			jmp      code_0ff1
code_0b3e:
			pushi    1
			lofsa    'knock[/door]'
			push    
			callk    Said,  2
			bnt      code_0c2a
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cLRED
			eq?     
			not     
			bnt      code_0b62
			pushi    0
			callb    PrintNotCloseEnough,  0
			jmp      code_0ff1
code_0b62:
			lag      isNightTime
			bnt      code_0b72
			pushi    2
			pushi    54
			pushi    32
			callb    HighPrint,  4
			jmp      code_0ff1
code_0b72:
			pushi    1
			pushi    226
			callb    Btest,  2
			bnt      code_0bdc
			lsg      prevRoomNum
			ldi      55
			ne?     
			bnt      code_0b97
			pushi    2
			pushi    54
			pushi    33
			callb    HighPrint,  4
			pushi    2
			pushi    54
			pushi    34
			callb    HighPrint,  4
			jmp      code_0ff1
code_0b97:
			pushi    #setLoop
			pushi    1
			pushi    3
			lag      ego
			send     6
			pushi    2
			pushi    54
			pushi    35
			callb    HighPrint,  4
			pushi    2
			pushi    54
			pushi    36
			callb    HighPrint,  4
			pushi    0
			callb    LockEgo,  0
			pushi    337
			pushi    1
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0bcc
			ldi      3
			jmp      code_0bce
code_0bcc:
			ldi      0
code_0bce:
			push    
			pushi    332
			pushi    1
			pushi    0
			lofsa    healerDoor
			send     12
			jmp      code_0ff1
code_0bdc:
			pushi    #setLoop
			pushi    1
			pushi    3
			lag      ego
			send     6
			pushi    2
			pushi    54
			pushi    35
			callb    HighPrint,  4
			pushi    2
			pushi    54
			pushi    36
			callb    HighPrint,  4
			pushi    0
			callb    LockEgo,  0
			pushi    #setPri
			pushi    1
			pushi    9
			lag      ego
			send     6
			pushi    337
			pushi    1
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0c1a
			ldi      3
			jmp      code_0c1c
code_0c1a:
			ldi      0
code_0c1c:
			push    
			pushi    332
			pushi    1
			pushi    0
			lofsa    healerDoor
			send     12
			jmp      code_0ff1
code_0c2a:
			pushi    1
			lofsa    'throw>'
			push    
			callk    Said,  2
			bnt      code_0ccd
			pushi    1
			lofsa    '/boulder[/nest]'
			push    
			callk    Said,  2
			bnt      code_0cba
			pushi    #has
			pushi    1
			pushi    21
			lag      ego
			send     6
			not     
			bnt      code_0c59
			pushi    2
			pushi    54
			pushi    37
			callb    HighPrint,  4
			jmp      code_0ff1
code_0c59:
			lsg      nestCondition
			ldi      nestInTree
			ne?     
			bt       code_0c85
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cLMAGENTA
			eq?     
			bt       code_0c81
			pushi    #onControl
			pushi    1
			pushi    1
			lag      ego
			send     6
			push    
			ldi      cYELLOW
			eq?     
code_0c81:
			not     
			bnt      code_0c96
code_0c85:
			pushi    2
			pushi    54
			pushi    38
			callb    HighPrint,  4
			pushi    1
			pushi    0
			calle    AnimateThrowingRock,  2
			jmp      code_0ff1
code_0c96:
			pushi    #script
			pushi    0
			lofsa    rock
			send     4
			bnt      code_0cac
			pushi    2
			pushi    54
			pushi    39
			callb    HighPrint,  4
			jmp      code_0ff1
code_0cac:
			pushi    #setScript
			pushi    1
			lofsa    throwIt
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0cba:
			pushi    2
			pushi    54
			pushi    40
			callb    HighPrint,  4
			pushi    #claimed
			pushi    1
			pushi    1
			lap      pEvent
			send     6
			jmp      code_0ff1
code_0ccd:
			pushi    1
			lofsa    'climb>'
			push    
			callk    Said,  2
			bnt      code_0de3
			pushi    1
			lofsa    '/tree,oak'
			push    
			callk    Said,  2
			bt       code_0cee
			pushi    1
			lofsa    '<up'
			push    
			callk    Said,  2
			bnt      code_0d71
code_0cee:
			pushi    #inRect
			pushi    4
			pushi    0
			pushi    103
			pushi    78
			pushi    147
			lag      ego
			send     12
			bnt      code_0d0d
			pushi    2
			pushi    54
			pushi    41
			callb    HighPrint,  4
			jmp      code_0ff1
code_0d0d:
			pushi    #inRect
			pushi    4
			pushi    0
			pushi    167
			pushi    112
			pushi    189
			lag      ego
			send     12
			bnt      code_0d55
			pushi    3
			pushi    11
			pushi    30
			pushi    0
			callb    TestSkill,  6
			bnt      code_0d42
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    236
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0d42:
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    236
			pushi    1
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0d55:
			pushi    1
			pushi    278
			callb    Btest,  2
			bnt      code_0d6a
			pushi    2
			pushi    54
			pushi    42
			callb    HighPrint,  4
			jmp      code_0ff1
code_0d6a:
			pushi    0
			callb    PrintNotCloseEnough,  0
			jmp      code_0ff1
code_0d71:
			pushi    1
			lofsa    '<down'
			push    
			callk    Said,  2
			bnt      code_0da4
			pushi    1
			pushi    278
			callb    Btest,  2
			bnt      code_0d99
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    237
			pushi    1
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0d99:
			pushi    2
			pushi    54
			pushi    43
			callb    HighPrint,  4
			jmp      code_0ff1
code_0da4:
			pushi    1
			lofsa    '/branch'
			push    
			callk    Said,  2
			bnt      code_0dba
			pushi    2
			pushi    54
			pushi    8
			callb    HighPrint,  4
			jmp      code_0ff1
code_0dba:
			pushi    1
			lofsa    '[/!*]'
			push    
			callk    Said,  2
			bnt      code_0dd0
			pushi    2
			pushi    54
			pushi    44
			callb    HighPrint,  4
			jmp      code_0ff1
code_0dd0:
			pushi    2
			pushi    54
			pushi    45
			callb    HighPrint,  4
			pushi    #claimed
			pushi    1
			pushi    1
			lap      pEvent
			send     6
			jmp      code_0ff1
code_0de3:
			pushi    1
			lofsa    'grab,get,lockpick/herb,flower,plant'
			push    
			callk    Said,  2
			bnt      code_0df9
			pushi    2
			pushi    54
			pushi    46
			callb    HighPrint,  4
			jmp      code_0ff1
code_0df9:
			pushi    1
			lofsa    'get>'
			push    
			callk    Said,  2
			bnt      code_0e4d
			pushi    1
			lofsa    '/boulder'
			push    
			callk    Said,  2
			bnt      code_0e21
			pushi    #setScript
			pushi    1
			pushi    2
			pushi    103
			pushi    0
			callk    ScriptID,  4
			push    
			lag      ego
			send     6
			jmp      code_0ff1
code_0e21:
			pushi    1
			lofsa    '/bird,lizard,creature'
			push    
			callk    Said,  2
			bnt      code_0e37
			pushi    2
			pushi    54
			pushi    47
			callb    HighPrint,  4
			jmp      code_0ff1
code_0e37:
			pushi    1
			lofsa    '/nest'
			push    
			callk    Said,  2
			bnt      code_0ff1
			pushi    2
			pushi    54
			pushi    47
			callb    HighPrint,  4
			jmp      code_0ff1
code_0e4d:
			pushi    1
			lofsa    'look>'
			push    
			callk    Said,  2
			bnt      code_0ff1
			pushi    1
			lofsa    '/bird,creature,lizard'
			push    
			callk    Said,  2
			bnt      code_0e6e
			pushi    2
			pushi    54
			pushi    47
			callb    HighPrint,  4
			jmp      code_0ff1
code_0e6e:
			pushi    1
			lofsa    '/nest'
			push    
			callk    Said,  2
			bnt      code_0e84
			pushi    2
			pushi    54
			pushi    48
			callb    HighPrint,  4
			jmp      code_0ff1
code_0e84:
			pushi    1
			lofsa    '[<at,around][/road]'
			push    
			callk    Said,  2
			bnt      code_0ea2
			pushi    2
			pushi    54
			pushi    49
			callb    HighPrint,  4
			pushi    2
			pushi    54
			pushi    50
			callb    HighPrint,  4
			jmp      code_0ff1
code_0ea2:
			pushi    1
			lofsa    '/house,hut'
			push    
			callk    Said,  2
			bnt      code_0eb8
			pushi    2
			pushi    54
			pushi    51
			callb    HighPrint,  4
			jmp      code_0ff1
code_0eb8:
			pushi    1
			lofsa    '/sign'
			push    
			callk    Said,  2
			bnt      code_0ece
			pushi    2
			pushi    54
			pushi    52
			callb    HighPrint,  4
			jmp      code_0ff1
code_0ece:
			pushi    1
			lofsa    '/tree,oak'
			push    
			callk    Said,  2
			bnt      code_0ef4
			pushi    2
			pushi    54
			pushi    53
			callb    HighPrint,  4
			lsg      nestCondition
			ldi      nestInTree
			eq?     
			bnt      code_0ff1
			pushi    2
			pushi    54
			dup     
			callb    HighPrint,  4
			jmp      code_0ff1
code_0ef4:
			pushi    1
			lofsa    'branch'
			push    
			callk    Said,  2
			bnt      code_0f0a
			pushi    2
			pushi    54
			pushi    55
			callb    HighPrint,  4
			jmp      code_0ff1
code_0f0a:
			pushi    1
			lofsa    '/roof'
			push    
			callk    Said,  2
			bnt      code_0f20
			pushi    2
			pushi    54
			pushi    56
			callb    HighPrint,  4
			jmp      code_0ff1
code_0f20:
			pushi    1
			lofsa    '/garden,flower,plant,herb'
			push    
			callk    Said,  2
			bnt      code_0f36
			pushi    2
			pushi    54
			pushi    57
			callb    HighPrint,  4
			jmp      code_0ff1
code_0f36:
			pushi    1
			lofsa    '/window,bottle,pan,curtain'
			push    
			callk    Said,  2
			bnt      code_0f9c
			pushi    #inRect
			pushi    4
			pushi    182
			pushi    0
			pushi    319
			pushi    112
			lag      ego
			send     12
			bt       code_0f7a
			pushi    #inRect
			pushi    4
			pushi    287
			pushi    0
			pushi    319
			pushi    150
			lag      ego
			send     12
			bnt      code_0f95
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			ldi      3
			eq?     
			bnt      code_0f95
code_0f7a:
			lag      isNightTime
			bnt      code_0f8a
			pushi    2
			pushi    54
			pushi    58
			callb    HighPrint,  4
			jmp      code_0ff1
code_0f8a:
			pushi    2
			pushi    54
			pushi    59
			callb    HighPrint,  4
			jmp      code_0ff1
code_0f95:
			pushi    0
			callb    PrintNotCloseEnough,  0
			jmp      code_0ff1
code_0f9c:
			pushi    1
			lofsa    '/east,forest'
			push    
			callk    Said,  2
			bnt      code_0fb2
			pushi    2
			pushi    54
			pushi    60
			callb    HighPrint,  4
			jmp      code_0ff1
code_0fb2:
			pushi    1
			lofsa    '/west,field'
			push    
			callk    Said,  2
			bnt      code_0fc8
			pushi    2
			pushi    54
			pushi    61
			callb    HighPrint,  4
			jmp      code_0ff1
code_0fc8:
			pushi    1
			lofsa    '/north,castle'
			push    
			callk    Said,  2
			bnt      code_0fde
			pushi    2
			pushi    54
			pushi    62
			callb    HighPrint,  4
			jmp      code_0ff1
code_0fde:
			pushi    1
			lofsa    '/south,crossroad'
			push    
			callk    Said,  2
			bnt      code_0ff1
			pushi    2
			pushi    54
			pushi    63
			callb    HighPrint,  4
code_0ff1:
			toss    
			ret     
		)
	)
)

(instance overTheHill of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setPri: 4
					setLoop: 3
					setCycle: Forward
					setMotion: MoveTo (ego x?) 100 self
				)
			)
			(1 (curRoom newRoom: 37))
		)
	)
)

(instance flyAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bird setLoop: 3 cel: 0 posn: 73 64)
				(= cycles 1)
			)
			(1 (bird setCycle: EndLoop self))
			(2
				(bird
					setPri: 10
					setCycle: 0
					setStep: 5 3
					setMotion: MoveTo 31 77 self
				)
			)
			(3 (Bset 212) (bird dispose:))
		)
	)
)

(instance nestBurn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (not (Btest 212)) (bird setScript: flyAway))
				(ego
					view: 522
					setLoop: (if (< (ego x?) 73) 0 else 1)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(whoosh
					number: (GetSongNumber 33)
					loop: 1
					priority: 3
					init:
					play:
				)
				(ego setCycle: EndLoop)
				(fireDart
					posn: (ego x?) (- (ego y?) 25)
					init:
					setLoop: 2
					setStep: 24 10
					ignoreActors:
					setCycle: Forward
					setMotion: MoveTo (nest x?) (nest y?) self
				)
			)
			(2
				(whoosh dispose:)
				(nest setScript: burnUp)
				(fireDart setLoop: 3 setPri: 13 setCycle: EndLoop self)
			)
			(3
				(fireDart dispose:)
				(StopEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance burnUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(nest setPri: 12 setCycle: CycleTo 3 1 self)
			)
			(1
				(++ local3)
				(nest
					posn: (nest x?) (+ (nest y?) 6)
					cel: (if (== (nest cel?) 3) 4 else 3)
				)
				(= cycles 1)
			)
			(2
				(if (< local3 15)
					(self changeState: 1)
				else
					(self cue:)
				)
			)
			(3
				(nest
					posn: (nest x?) (+ (nest y?) 3)
					cel: (if (== (nest cel?) 3) 4 else 3)
				)
				(= cycles 1)
			)
			(4 (nest setCycle: EndLoop self))
			(5
				(if (Btest 210)
					(UnlockEgo)
					(nest hide: setScript: 0)
					(ring hide:)
				else
					(= seconds 3)
				)
			)
			(6
				(ring
					posn: (nest x?) (nest y?)
					setPri: 12
					setCycle: EndLoop self
				)
			)
			(7
				(= nestCondition nestBurnt)
				(UnlockEgo)
				(nest stopUpd: setScript: 0)
			)
		)
	)
)

(instance throwIt of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo 235 170 self)
			)
			(1
				(ego
					view: (if local4 520 else 510)
					cycleSpeed: 1
					setLoop: (if local4 0 else 2)
					cel: 0
				)
				(= cycles 2)
			)
			(2
				(if local4
					(ego setCycle: EndLoop self)
				else
					(ego setCycle: CycleTo 4 1 self)
				)
				(if (not (Btest 212)) (bird setScript: flyAway))
			)
			(3
				(if local4
					(magicLasso
						ignoreActors:
						posn: (+ (ego x?) 2) (- (ego y?) 36)
						setLoop: 5
						setStep: 20 10
						setCycle: Forward
						init:
						setScript: lassoNest
					)
					(client setScript: 0)
				else
					(rock
						setLoop: 4
						setPri: 15
						setStep: 25 10
						ignoreActors:
						ignoreHorizon:
						illegalBits: 0
						setCycle: Forward
						posn: (- (ego x?) 13) (- (ego y?) 34)
						init:
						forceUpd:
					)
					(ego setCycle: EndLoop self)
					(if (TestSkill skTHROWING 25 0)
						(rock setScript: (ScriptID 235 2))
					else
						(UnlockEgo)
						(rock setScript: (ScriptID 235 3))
					)
				)
			)
			(4
				(StopEgo)
				(ego use: invSmallRock 1 loop: 1)
				(client setScript: 0)
			)
		)
	)
)

(instance pickItUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local5
					(LockEgo)
					(if (not (Btest 210))
						(HighPrint 54 64)
					else
						(HighPrint 54 65)
					)
					(ego illegalBits: 0 setMotion: MoveTo 115 170 self)
				else
					(self cue:)
				)
			)
			(1
				(StopEgo)
				(ego
					illegalBits: 0
					setMotion: MoveTo (+ (nest x?) 15) 164 self
				)
			)
			(2
				(ego
					view: 510
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(3
				(if (not (Btest 210))
					(HighPrint 54 66)
					(ring hide:)
				)
				(if (== (nest loop?) 7)
					(nest setCel: 1)
				else
					(nest hide:)
				)
				(ego setCycle: BegLoop self)
			)
			(4
				(StopEgo)
				(ego
					illegalBits: 0
					setMotion: MoveTo (+ (ego x?) 20) (ego y?) self
				)
			)
			(5
				(ego illegalBits: cWHITE)
				(if (not (Btest 210))
					(ego get: invGoldRing)
					(Bset 210)
					(AddToScore POINTS_GETGOLDRING 3)
				)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance lassoNest of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(magicLasso setMotion: MoveTo (nest x?) (nest y?) self)
			)
			(1
				(magicLasso
					setPri: 11
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 36) self
				)
				(nest
					setPri: 11
					setStep: 6 4
					setMotion: MoveTo (+ (ego x?) 2) (- (ego y?) 38)
				)
			)
			(2 (= seconds 3))
			(3
				(magicLasso hide:)
				(nest hide:)
				(ego setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(4
				(if (Btest 210)
					(HighPrint 54 67)
				else
					(HighPrint 54 68)
					(HighPrint 54 69)
					(Bset 210)
					(ego get: invGoldRing)
					(ring hide:)
					(AddToScore POINTS_GETGOLDRING 3)
				)
				(ego loop: 1)
				(= nestCondition nestOnGround)
				(nest setLoop: 7 setCel: 0 posn: 242 163 setPri: -1 show:)
				(StopEgo)
				(UnlockEgo)
				(= cycles 2)
			)
			(5 (magicLasso dispose:))
		)
	)
)

(instance nestDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(nest
					setLoop: 4
					setStep: 15 7
					cel: 0
					setCycle: EndLoop
					setMotion: MoveTo (nest x?) (+ (nest y?) 42) self
				)
			)
			(1
				(if (< (nest y?) 150)
					(self changeState: 0)
				else
					(self cue:)
				)
			)
			(2
				(nest
					setLoop: 7
					setCel: 0
					setPri: -1
					posn: (nest x?) (+ (nest y?) 9)
					stopUpd:
				)
				(= nestCondition nestOnGround)
				(= seconds 1)
			)
			(3
				(if (Btest 210)
					(self cue:)
				else
					(ring
						posn: (- (nest x?) 1) (nest y?)
						setPri: 12
						setCycle: EndLoop self
					)
				)
			)
			(4
				(if (not (Btest 210))
					(HighPrint 54 64)
					(ego setScript: pickItUp)
				else
					(HighPrint 54 70)
					(ego setScript: 0)
					(UnlockEgo)
				)
				(nest setScript: 0)
			)
		)
	)
)

(instance treeFall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 517
					setLoop: 2
					cel: 0
					x: (- (ego x?) 12)
					setStep: 0 5
					cycleSpeed: 3
					moveSpeed: 0
					setCycle: EndLoop
					setMotion: MoveTo (ego x?) 170 self
				)
			)
			(1
				(if (not (ReduceHP 8))
					(Die
						54
						71
						82
						517
						2
						5
						80
						{Your figure remains still and silent.}
					)
				else
					(ego
						view: 503
						setLoop: 4
						cel: 0
						x: (+ (ego x?) 11)
						y: (+ (ego y?) 18)
						setPri: 13
						illegalBits: cWHITE
					)
					(switch (= local6 (Random 1 5))
						(0 (HighPrint 54 72))
						(1 (HighPrint 54 73))
						(2 (HighPrint 54 74))
						(3 (HighPrint 54 75))
						(else  (HighPrint 54 76))
					)
					(++ local6)
					(self cue:)
				)
			)
			(2
				(ego cycleSpeed: 1 setCycle: EndLoop self)
			)
			(3
				(if (not local8) (= local8 1) (HighPrint 54 77))
				(Bclear 278)
				(UnlockEgo)
				(StopEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance flutter of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 5 25)))
			(1 (bird setCycle: EndLoop self))
			(2 (bird setCycle: BegLoop self))
			(3
				(bird stopUpd:)
				(self changeState: 0)
			)
		)
	)
)

(instance outOfHouse of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego posn: 207 132 setMotion: MoveTo 189 132 self)
			)
			(1
				(UnlockEgo)
				(curRoom setScript: 0)
			)
		)
	)
)
