;;; Sierra Script 1.0 - (do not remove this comment)
(script# 83)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use Rest)
(use TalkObj)
(use LoadMany)
(use GControl)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm83 0
	hermitTalk 1
	dummy 2
)

(local
	local0
	local1
)
(instance pfSnd of Sound
	(properties
		priority 8
	)
)

(instance poof of Prop
	(properties
		view 83
		loop 5
	)
)

(instance scroll of Prop
	(properties
		y 162
		x 194
		view 83
	)
)

(instance hermitWin of SysWindow
	(properties
		color 8
		title {Hermit:}
	)
	
	(method (open &tmp temp0)
		(= top (- top (= temp0 (- top 12))))
		(= bottom (- bottom temp0))
		(super open:)
	)
)

(instance hermitTalk of TalkObj
	(properties
		tLoop 3
		cSpeed 1
	)
)

(instance bed of RPicView
	(properties
		y 164
		x 67
		view 83
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/bed,hay')
				)
				(HighPrint 83 0)
			)
		)
	)
)

(instance table of RPicView
	(properties
		y 180
		x 189
		view 83
		loop 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/table')
				)
				(HighPrint 83 1)
			)
		)
	)
)

(instance chair of RPicView
	(properties
		y 167
		x 159
		view 83
		loop 1
		cel 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/chair')
				)
				(HighPrint 83 2)
			)
		)
	)
)

(instance cot of RPicView
	(properties
		y 168
		x 227
		view 83
		loop 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (IsObjectOnControl self pEvent 3) (Said 'look/cot')) (HighPrint 83 3))
		)
	)
)

(instance candle of Prop
	(properties
		y 155
		x 185
		view 83
		loop 4
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/candle,flame')
				)
				(HighPrint 83 4)
			)
		)
	)
)

(instance hermit of Prop
	(properties
		y 162
		x 227
		view 83
		loop 3
	)
	
	(method (doit)
		(hermitTalk doit:)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/ermit,man')
				)
				(HighPrint 83 5)
			)
			(else (hermitTalk handleEvent: pEvent))
		)
	)
)

(instance rm83 of Room
	(properties
		picture 83
		style $0002
	)
	
	(method (init)
		(super init:)
		(StatusLine enable:)
		(StopEgo)
		(Load rsSOUND 41)
		(LoadMany 130 143 144 145)
		(AddToScore POINTS_MEETHERMIT 5)
		(ego loop: 0 posn: 143 185 init:)
		(bed priority: 0)
		(gAddToPics
			add: bed table chair cot
			eachElementDo: #init
			doit:
		)
		(gFeatures add: bed table chair cot)
		(candle init: setPri: 14 cycleSpeed: 1 setCycle: Forward)
		(hermit init:)
		(hermitTalk tWindow: hermitWin actor: hermit init:)
		(cSound stop: number: 41 loop: -1 play:)
		(gKeyHandler add: hermit)
		(pfSnd number: (GetSongNumber 28))
		(if (Btest 73)
			(TalkObjMessages hermitTalk 83 6)
		else
			(self setScript: (ScriptID 143 0))
		)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			((or local0 isEgoLocked) (if (User canControl:) (User canControl: 0)))
			((not (User canControl:)) (User canControl: 1))
		)
		(if
			(and
				(== (ego edgeHit?) 3)
				(!= (self script?) sLeaving)
			)
			(if (not (Btest 73))
				(self setScript: sLeaving)
			else
				(curRoom newRoom: 82)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look[<around,at][/room]') (HighPrint 83 7))
					((Said 'look>')
						(cond 
							((Said '/cave,wall') (HighPrint 83 8))
							((Said '/fungus') (HighPrint 83 9))
							((Said '/scroll,spell')
								(if (gCast contains: scroll)
									(HighPrint 83 10)
								else
									(HighPrint 83 11)
								)
							)
						)
					)
					((Said 'read/scroll,spell')
						(if (gCast contains: scroll)
							(HighPrint 83 10)
						else
							(HighPrint 83 11)
						)
					)
					((Said 'ask>')
						(= local1 1)
						(cond 
							((Said '/fall,water') (self setScript: (ScriptID 145 8)))
							((Said '/magic,ladder') (self setScript: (ScriptID 145 7)))
							(
							(or (Said '/trigger') (Said 'ask/spell<trigger')) (self setScript: (ScriptID 145 5)))
							((Said '/spell') (self setScript: (ScriptID 145 6)))
							((Said '/wizard,erasmus') (self setScript: (ScriptID 144 0)))
							((Said '/familiar,fenrus') (self setScript: (ScriptID 144 1)))
							((Said '/game') (self setScript: (ScriptID 144 2)))
							((Said '/bandit') (self setScript: (ScriptID 144 3)))
							((Said '/warlock') (self setScript: (ScriptID 144 4)))
							((Said '/mirror') (self setScript: (ScriptID 144 5)))
							((Said '/cave,home') (self setScript: (ScriptID 145 0)))
							((Said '/ermit') (self setScript: (ScriptID 145 1)))
							((Said '/family,hortense,arry,mama,dad,farther') (self setScript: (ScriptID 145 2)))
							((Said '/enry,name') (self setScript: (ScriptID 145 3)))
							((Said '/cribbage') (self setScript: (ScriptID 145 4)))
							((Said '/nap,bed,hay') (self setScript: sSleep))
							((Said '/scroll')
								(if (Btest 242)
									(if (gCast contains: scroll)
										(HighPrint 83 10)
									else
										(self setScript: sNixScroll)
									)
								else
									(self setScript: sAskScroll)
								)
							)
							(
							(Said '/candle,table,chair,cot,flame,door,hay,food') (self setScript: sMisc))
							(else (= local1 0) (pEvent claimed: 1) (self setScript: sElse))
						)
						(if local1 (AddToScore POINTS_TALKTOHERMIT 2))
					)
					((Said 'buy/') (self setScript: sMisc))
					((Said 'chat/') (self setScript: (ScriptID 145 3)))
					((Said 'gave,gave/ration')
						(if (ego has: invFoodRation)
							(if isNightTime
								(= [invNum invFoodRation] (- [invNum invFoodRation] 1))
								(TalkObjMessages hermitTalk 83 12)
								(Bset 338)
							else
								(TalkObjMessages hermitTalk 83 13)
							)
						else
							(HighPrint 83 14)
						)
					)
					(
						(or
							(Said 'nap/')
							(Said 'go/bed,nap')
							(Said 'get<on/bed,hay')
						)
						(cond 
							(local0 (HighPrint 83 15))
							((> (ego x?) 165) (HighPrint 83 16))
							((or (Btest 338) (>= [invNum invFoodRation] 1))
								(if (NeedSleep)
									(if (Btest 338)
										(Bclear 338)
									else
										(= [invNum invFoodRation] (- [invNum invFoodRation] 1))
									)
									(self setScript: sGoSleep)
								else
									(SleepUntil 5)
								)
							)
							(else (self setScript: sNoSleep))
						)
					)
					((Said 'sat/')
						(if (not local0)
							(if (ego inRect: 140 150 174 174)
								(ego
									view: 83
									setLoop: 8
									ignoreActors: 1
									illegalBits: 0
									posn: 159 167
									stopUpd:
								)
								(= local0 1)
							else
								(HighPrint 83 17)
							)
						else
							(HighPrint 83 18)
						)
					)
					((or (Said 'stand,get<up/') (Said 'stand/'))
						(if local0
							(StopEgo)
							(= local0 0)
							(ego posn: 156 171 loop: 0)
						else
							(HighPrint 83 19)
						)
					)
					((Said 'put,extinguish/candle,flame') (HighPrint 83 20))
					((Said 'search/') (HighPrint 83 21))
					((Said 'play/cribbage')
						(cond 
							((== currentDay dayLastPlayedCribbage) 
								(HighPrint 83 22)
								;Despite your intentions, you can't bring yourself to spend any more time playing with the talkative 'Enry.
							)
							(local0
								(= dayLastPlayedCribbage currentDay)
								(Rest 60 0)
								(HighPrint 83 23)
								;You spend an hour at the game while 'Enry talks.  You've obviously made his day.
							)
							(else (HighPrint 83 24))
						)
					)
					((Said 'get/scroll')
						(if (gCast contains: scroll)
							(scroll dispose:)
							(ego get: invPieceOfPaper)
							(HighPrint 83 25)
							(Bset 262)
							(ego learn: skTRIGGER 10)
							(AddToScore POINTS_LEARNTRIGGER 4 CLASS_MAGICUSER)
						else
							(HighPrint 83 26)
						)
					)
					(
					(or (Said 'cast/detect') (Said 'cast/spell<detect')) (if (CastSpell 18) (HighPrint 83 27)))
					(
					(or (Said 'cast/open') (Said 'cast/spell<open')) (if (CastSpell 17) (HighPrint 83 28)))
					((Said 'get,grab/candle,cot,hay,bed,table,chair')
						(HighPrint 83 29)
						(HighPrint 83 30)
						(Bset 240)
						(self setScript: TPego)
					)
					((Said 'kill,attack,throw,beat,cast,fight/') (HighPrint 83 30) (Bset 240) (self setScript: TPego))
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance sSleep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitTalk caller: self)
				(LockEgo)
				(TalkObjMessages hermitTalk 83 31)
			)
			(1 (UnlockEgo))
		)
	)
)

(instance sAskScroll of Script
	(properties)
	
	(method (changeState newState)
		(if client
			(switch (= state newState)
				(0
					(Bset 242)
					(hermitTalk caller: self)
					(LockEgo)
					(if [skills skMAGIC]
						(TalkObjMessages hermitTalk 83 32)
					else
						(TalkObjMessages hermitTalk 83 33)
						(UnlockEgo)
						(client setScript: 0)
					)
				)
				(1
					(TalkObjMessages hermitTalk 83 34)
				)
				(2
					(User canInput: 1)
					(= seconds 6)
				)
				(3
					(client setScript: sNoScroll)
					(UnlockEgo)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (and (== (pEvent type?) evSAID) (== state 2))
			(= seconds 0)
			(if (Said 'affirmative/')
				(client setScript: sGetScroll)
			else
				(pEvent claimed: 1)
				(client setScript: sNoScroll)
			)
		)
	)
)

(instance sNoScroll of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitTalk caller: self)
				(LockEgo)
				(TalkObjMessages hermitTalk 83 35)
			)
			(1 (UnlockEgo))
		)
	)
)

(instance sNixScroll of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitTalk caller: self)
				(LockEgo)
				(if (Btest 262)
					(TalkObjMessages hermitTalk 83 36)
				else
					(TalkObjMessages hermitTalk 83 37)
				)
			)
			(1
				(User canInput: 1)
				(= seconds 6)
			)
			(2
				(client setScript: sNoScroll)
				(UnlockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (and (== (pEvent type?) evSAID) (== state 1))
			(= seconds 0)
			(if (Said 'affirmative/')
				(client setScript: sGetScroll)
			else
				(pEvent claimed: 1)
				(client setScript: sNoScroll)
			)
		)
	)
)

(instance sGetScroll of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(hermitTalk caller: self)
				(TalkObjMessages hermitTalk 83 38)
			)
			(1
				(TalkObjMessages hermitTalk 83 39)
			)
			(2
				(scroll
					loop: 7
					setPri: 14
					init:
					cycleSpeed: 1
					setCycle: EndLoop self
				)
				(pfSnd init: play:)
			)
			(3
				(scroll setLoop: 2 setCel: 1)
				(TalkObjMessages hermitTalk 83 40)
			)
			(4 (UnlockEgo))
		)
	)
)

(instance sMisc of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitTalk caller: self)
				(LockEgo)
				(TalkObjMessages hermitTalk 83 41)
			)
			(1 (UnlockEgo))
		)
	)
)

(instance sElse of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(hermitTalk caller: self)
				(LockEgo)
				(TalkObjMessages hermitTalk 83 42)
			)
			(1 (UnlockEgo))
		)
	)
)

(instance sLeaving of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 73)
				(hermitTalk caller: self)
				(LockEgo)
				(TalkObjMessages hermitTalk 83 43)
			)
			(1 (curRoom newRoom: 82))
		)
	)
)

(instance TPego of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 73)
				(LockEgo)
				(pfSnd init: play:)
				(poof
					posn: (ego x?) (ego y?)
					setCycle: CycleTo 6 1 self
					cycleSpeed: 4
					init:
				)
			)
			(1
				(ego dispose:)
				(poof setCycle: EndLoop self)
			)
			(2 (= cycles 10))
			(3
				(poof dispose:)
				(curRoom newRoom: 82)
			)
		)
	)
)

(instance sGoSleep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(HighPrint 83 44)
				(ego illegalBits: 0 setMotion: MoveTo 74 150 self)
			)
			(1
				(ego view: 510 setLoop: 1 setCycle: EndLoop self)
			)
			(2
				(ego
					view: 523
					setLoop: 0
					setCel: 2
					posn: 72 168
					setPri: 13
					stopUpd:
				)
				(hermit setLoop: 3 setCycle: Forward)
				(= seconds 6)
			)
			(3
				(HighPrint 83 45)
				(SleepUntil 5)
				(Bset 73)
				(curRoom newRoom: 82)
			)
		)
	)
)

(instance sNoSleep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(hermitTalk caller: self)
				(TalkObjMessages hermitTalk 83 46)
			)
			(1
				(Bset 241)
				(client setScript: TPego)
			)
		)
	)
)

(instance dummy of Script
	(properties)
)
