;;; Sierra Script 1.0 - (do not remove this comment)
(script# 206)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Inventory)
(use System)

(public
	theInvSheet 0
)

(procedure (localproc_000c item x y &tmp invQty [str 40])
	(Display
		(Format @str 206 0 (= invQty [invNum item]))
		p_at (+ x 5) y
		p_mode teJustRight
		p_font smallFont
		p_color vBLUE
		p_width 20
	)
	(Display
		(Format @str 3 (+ item item) (if (> invQty 1) 115 else 0))
		p_at (+ x 30) y
		p_mode teJustLeft
		p_font smallFont
		p_color vBLUE
	)
)

(procedure (localproc_007e spell x y &tmp spellIndex [str 8])
	(= spellIndex (- spell skOPEN))
	(Display
		(Format @str 206 0 [spellCost spellIndex])
		p_at (+ x 7) y
		p_mode teJustLeft
		p_font smallFont
		p_color vBLUE
		p_width 20
	)
	(Display
		4 spellIndex
		p_at (+ x 33) y
		p_mode teJustLeft
		p_font smallFont
		p_color vBLUE
	)
	(Display
		(Format @str 206 0 [skills spell])
		p_at (+ x 105) y
		p_mode teJustLeft
		p_font smallFont
		p_color vBLUE
	)
)

(class InvSheet of Object
	(properties
		nsTop 0
		nsLeft 0
		nsBottom 189
		nsRight 320
		theWindow 0
	)
	
	(method (init &tmp temp0 temp1 temp2 temp3 temp4 [temp5 40])
		(super init:)
		(= theWindow
			(NewWindow nsTop nsLeft nsBottom nsRight {} 0 15 1 15)
		)
		(Display 206 1 p_at 10 8 p_mode teJustLeft p_font 300 p_color vBLUE)
		(= temp4 (GetTotalWeight))
		(= temp0 1)
		(= temp2 24)
		(while (<= temp0 41)
			(if (and (> [invNum temp0] 0) (> temp0 2))
				(if (<= temp2 160) (localproc_000c temp0 10 temp2))
				(= temp2 (+ temp2 9))
			)
			(++ temp0)
		)
		(cond 
			((== temp2 24) (Display 206 2 p_at 40 (+ temp2 5) p_mode teJustLeft p_font 300 p_color vBLUE))
			((>= temp2 174) (Display 206 3 p_at 40 172 p_mode teJustLeft p_font 300 p_color vBLUE))
		)
		(= temp3 (if (< colourCount 16) vRED else vLRED))
		(Display
			(Format @temp5 206 0 [invNum invGoldCoin])
			p_at 180 10
			p_mode teJustRight
			p_font 300
			p_color temp3
			p_width 25
		)
		(Display 206 4 p_at 220 10 p_mode teJustLeft p_font 300 p_color temp3)
		(= temp3 (if (< colourCount 16) vGREY else vLGREY))
		(Display
			(Format @temp5 206 0 [invNum invSilverCoin])
			p_at 180 23
			p_mode teJustRight
			p_font 300
			p_color temp3
			p_width 25
		)
		(Display 206 5 p_at 220 23 p_mode teJustLeft p_font 300 p_color temp3)
		(= temp3
			(cond 
				((< temp4 (/ (* (GetMaxWeight) 90) 100)) 1)
				((< colourCount 16) 4)
				(else 12)
			)
		)
		(Display
			(Format @temp5 206 6 temp4)
			p_at 180 36
			p_mode teJustRight
			p_font 300
			p_color temp3
			p_width 25
		)
		(Display 206 7 p_at 220 36 p_mode teJustLeft p_font 300 p_color temp3)
		(Display
			(Format @temp5 206 6 (GetMaxWeight))
			p_at 180 49
			p_mode teJustRight
			p_font 300
			p_color temp3
			p_width 25
		)
		(Display 206 8 p_at 220 49 p_mode teJustLeft p_font 300 p_color temp3)
		(if [skills skMAGIC]
			(Display 206 9 p_at 185 75 p_mode teJustLeft p_font 300 p_color vBLUE)
			(Display 206 10 p_at 218 75 p_mode teJustLeft p_font 300 p_color vBLUE)
			(Display 206 11 p_at 280 75 p_mode teJustLeft p_font 300 p_color vBLUE)
			(= temp2 91)
			(= temp0 17)
			(= temp2 91)
			(while (< temp0 25)
				(if (> [skills temp0] 0)
					(localproc_007e temp0 185 temp2)
					(= temp2 (+ temp2 9))
				)
				(++ temp0)
			)
		)
	)
	
	(method (doit &tmp newEvent newEventType)
		(= newEventType 0)
		(while (not newEventType)
			(GlobalToLocal (= newEvent (Event new:)))
			(= newEventType (newEvent type?))
			(newEvent dispose:)
		)
		(self dispose:)
	)
	
	(method (dispose)
		(DisposeWindow theWindow)
		(super dispose:)
		(DisposeScript 206)
	)
)

(instance theInvSheet of InvSheet
	(properties)
)
