;;; Sierra Script 1.0 - (do not remove this comment)
(script# 60)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use Interface)
(use LoadMany)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm60 0
)

(local
	local0
	local1
	[local2 8]
	[local10 8]
	[local18 8]
	local26
	local27
	local28
	local29
	local30
	local31
	local32 =  -1
	local33
	local34
	local35
	local36
	local37
	newAct
	local39
	local40
	local41
	local42
	local43
	local44
	local45
	local46
	local47 =  25
	[local48 8] = [11 8 10 6 9 7 11 6]
	[local56 16] = [41 167 65 135 104 157 130 114 180 146 212 125 243 167 269 114]
	[local72 8] = [3 0 2 4 6 7 5 1]
	[local80 16] = [160 105 71 158 134 148 209 137 273 159 299 105 242 117 95 127]
	[local96 4] = [{some fruit} {a baby meep} {some green fur} {a magic spell scroll}]
	[local100 200]
	local300
	local301
)
(procedure (localproc_0418 param1)
	(Print
		&rest
		#at
		-1
		2
		#width
		0
		#mode
		1
		#window
		meepWin
		#dispose
		#time
		param1
	)
)

(procedure (localproc_0438 &tmp temp0)
	(= temp0 0)
	(while (< temp0 8)
		(= [local2 temp0] (Clone aMeep))
		([local2 (= [local18 temp0] (Clone anEye))]
			setLoop: 5
			cel: 0
			setPri: (+ 1 [local48 temp0])
			posn: [local56 (* temp0 2)] (- [local56 (+ (* temp0 2) 1)] 4)
			init:
			stopUpd:
			setScript: [local10 temp0] 0 (= [local10 temp0] (Clone aMeepScript))
		)
		([local18 temp0]
			setLoop: 3
			cel: 0
			setPri: (+ 1 [local48 temp0])
			z: 1
			posn: [local56 (* temp0 2)] (- [local56 (+ (* temp0 2) 1)] 17)
			init:
			stopUpd:
			hide:
		)
		(++ temp0)
	)
)

(instance bossBlock of Block
	(properties
		top 104
		left 117
		bottom 120
		right 144
	)
)

(instance aMeep of Actor
	(properties
		view 60
		loop 5
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(== (pEvent type?) evMOUSEBUTTON)
					(IsObjectOnControl self pEvent 3)
				)
				(cond 
					((not (script state?)) (HighPrint 60 0))
					((== loop 0) (HighPrint 60 1))
					((== loop 1) (HighPrint 60 2))
					((== loop 2) (HighPrint 60 3))
				)
			)
		)
	)
)

(instance anEye of Prop
	(properties
		view 60
		loop 3
		cycleSpeed 1
	)
)

(instance meepHead of Prop
	(properties
		view 61
		loop 3
	)
)

(instance bossRock of Actor
	(properties
		yStep 5
		view 60
		loop 5
		illegalBits $0000
		xStep 5
	)
)

(instance babyMeep of Actor
	(properties
		z 2
		view 61
		loop 7
		illegalBits $0000
	)
)

(instance greenFur of Actor
	(properties
		z 2
		view 61
		loop 8
		illegalBits $0000
	)
)

(instance spellScroll of Actor
	(properties
		z 2
		view 61
		loop 5
		illegalBits $0000
	)
)

(instance meepSound of Sound
	(properties
		number 55
		priority 1
	)
)

(instance babySound of Sound
	(properties
		number 74
		priority 2
	)
)

(instance thudSound of Sound
	(properties
		number 58
		priority 3
	)
)

(instance throwSound of Sound
	(properties
		number 31
		priority 3
	)
)

(instance meepWin of SysWindow
	(properties
		color 2
	)
)

(instance rm60 of Room
	(properties
		picture 60
		style $0000
		east 61
	)
	
	(method (init)
		(LoadMany 128 60 61 518 510 62)
		(LoadMany
			132
			(GetSongNumber 55)
			(GetSongNumber 56)
			(GetSongNumber 57)
			(GetSongNumber 74)
			(GetSongNumber 58)
			(GetSongNumber 75)
			54
			(GetSongNumber 31)
		)
		(if (ego knows: skFLAMEDART)
			(Load rsVIEW 522)
			(Load rsSCRIPT 100)
		)
		(super init:)
		(cSound fade:)
		(StatusLine enable:)
		(StopEgo)
		(ego
			posn: 318 176
			init:
			illegalBits: (& cWHITE cLGREY)
			observeBlocks: bossBlock
			setMotion: MoveTo 306 176
		)
		(= local0
			(switch detailLevel
				(DETAIL_LOW 2)
				(DETAIL_MID 3)
				(DETAIL_HIGH 4)
			))
		(meepSound number: (GetSongNumber 55) init:)
		(babySound number: (GetSongNumber 74) init:)
		(thudSound number: (GetSongNumber 58) init:)
		(throwSound number: (GetSongNumber 31) init:)
		(localproc_0438)
		(gDirHandler addToFront: self)
		(gMouseHandler addToFront: self)
	)
	
	(method (doit &tmp temp0)
		(if (!= local36 (= temp0 (GetTime 1)))
			(= local36 temp0)
			(if
			(and local28 (not local29) (not (-- local43)))
				([local2 3] setScript: bossMad 0 0)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bset 50)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(= temp0 local27)
		(= local27 1)
		(switch (pEvent type?)
			(evSAID
				(cond 
					(
						(or
							(Said
								'chop,beat,fight,kill,damage[/meep,creature,boulder]'
							)
							(Said 'use,draw/blade')
						)
						(cond 
							(local35 (HighPrint 60 4))
							(
								(or
									(< (ego y?) 102)
									(and (< (ego y?) 119) (< (ego x?) 110))
								)
								(HighPrint 60 5)
							)
							(else
								(= local35 1)
								(= local27 0)
								(= local300 1)
								(LockEgo)
								(ego setScript: killMeeps)
								(if local28
									([local2 3] setScript: bossMad killMeeps)
								else
									(killMeeps cue:)
								)
							)
						)
					)
					((Said 'cast>')
						(switch (= temp1 (SaidCast pEvent))
							(skDETECTMAGIC
								(if (CastSpell temp1) (HighPrint 60 6))
							)
							(skDAZZLE
								(if (CastSpell temp1)
									(= local35 1)
									(AnimateDazzle)
									(if local28 ([local2 3] setScript: bossMad))
								)
							)
							(skFLAMEDART
								(if (CastSpell temp1)
									(= local35 1)
									(if local28 ([local2 3] setScript: bossMad))
									(AnimateThrowingFlameDart 0)
								)
							)
							(skOPEN
								(if (CastSpell temp1) (HighPrint 60 7))
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(if (AnimateThrowingDagger 0)
							(= local35 1)
							(if local28 ([local2 3] setScript: bossMad))
						)
					)
					((Said 'throw/boulder')
						(if (ego has: invSmallRock)
							(= local35 1)
							(if local28 ([local2 3] setScript: bossMad))
							(AnimateThrowingRock 0)
						else
							(HighPrint 60 8)
						)
					)
					(
					(Said 'lift,(lockpick<up),get,capture/boulder,meep') (ego setScript: liftRock))
					((Said 'get>')
						(cond 
							((Said '/fur[<green]')
								(if local46
									(if (== (ego onControl: origin) cYELLOW)
										(ego setScript: getThing 0 2)
									else
										(HighPrint 60 9)
									)
								else
									(HighPrint 60 10)
								)
							)
							((Said '/scroll,spell[<magic,spell,about]')
								(if local45
									(if (== (ego onControl: origin) cYELLOW)
										(ego setScript: getThing 0 3)
									else
										(HighPrint 60 9)
									)
								else
									(HighPrint 60 11)
								)
							)
							((Said '/baby,(meep<baby)')
								(if local44
									(if (== (bouncyBaby state?) 0)
										(bouncyBaby seconds: 0 cue:)
									)
									(PrintTimedMessage 4 60 12)
								else
									(HighPrint 60 13)
								)
							)
							((Said '/apple,apple,core') (HighPrint 60 14))
						)
					)
					((Said 'look>')
						(= local27 temp0)
						(cond 
							((Said '[<at,around][/!*,area,area,clearing]') (HighPrint 60 15))
							((Said '/baby,(meep<baby)') (HighPrint 60 16))
							((Said '/(meep,creature,animal)<green')
								(if local35
									(HighPrint 60 17)
								else
									(HighPrint 60 18)
								)
							)
							((Said '/(meep,creature,animal)<(magenta,blue)')
								(if local35
									(HighPrint 60 17)
								else
									(HighPrint 60 19)
								)
							)
							((Said '/meep,creature,animal')
								(if local35
									(HighPrint 60 17)
								else
									(HighPrint 60 20)
								)
							)
							((Said '/boulder,boulder') (HighPrint 60 21))
							((Said '/chasm')
								(if local35
									(HighPrint 60 17)
								else
									(HighPrint 60 22)
								)
							)
							((Said '/bush,tree') (HighPrint 60 23))
							((Said '/hill,hill') (HighPrint 60 24))
							((Said '/ground,down,grass') (HighPrint 60 25))
							((Said '/fur')
								(if local46
									(HighPrint 60 26)
								else
									(HighPrint 60 27)
									(if (ego has: invMeepGreenFur) (pEvent claimed: 0))
								)
							)
							((Said '/scroll,spell')
								(cond 
									(local45 (HighPrint 60 28))
									((Btest 228) (HighPrint 60 29))
									(else (pEvent claimed: 0))
								)
							)
						)
					)
					((Said 'chat>')
						(= local43 30)
						(cond 
							(local35 (pEvent claimed: 1) (HighPrint 60 30))
							(local28 (pEvent claimed: 1) (localproc_0418 5 60 31))
							((== local1 0) (pEvent claimed: 1) (HighPrint 60 32))
							(local33 (pEvent claimed: 1) ([local2 3] setScript: bossRises))
							(else (pEvent claimed: 1) (self setScript: prepAsk))
						)
					)
					((Said 'ask>')
						(= local30 1)
						(= local43 30)
						(cond 
							(
							(and local26 (not local28) (Said '/meep<green')) (= local30 0) ([local2 3] setScript: bossRises))
							((not local28)
								(= local30 0)
								(pEvent claimed: 1)
								(cond 
									(local33 ([local2 3] setScript: bossRises))
									((== local1 0) (pEvent claimed: 1) (HighPrint 60 32))
									(else (self setScript: prepAsk))
								)
							)
							((Said '/boulder') (localproc_0418 5 60 33))
							((Said '/meep,creature,animal') (localproc_0418 5 60 34))
							((Said '/apple,apple,stuff,junk') ([local2 3] setScript: throwThings 0 0))
							((Said '/fur<green')
								(if local46
									(localproc_0418 5 60 35)
								else
									([local2 3] setScript: throwThings 0 2)
								)
							)
							((Said '/fur') (localproc_0418 7 60 36))
							((Said '/scroll,spell,magic,detect')
								(if local45
									(localproc_0418 5 60 35)
								else
									([local2 3] setScript: throwThings 0 3)
								)
							)
							(else
								(= local30 0)
								(pEvent claimed: 1)
								(localproc_0418 5 60 37)
							)
						)
						(if local30 (AddToScore POINTS_TALKTOMEEP 1))
					)
				)
			)
			(evKEYBOARD (= local27 temp0))
			(evMOUSEBUTTON
				(if (& (pEvent modifiers?) emSHIFT)
					(= local27 temp0)
					(if (IsObjectOnControl ego pEvent 3)
						(HighPrint 60 38)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance aMeepScript of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== state 2)
				local27
				(<= (ego distanceTo: client) 80)
			)
			(= cycles 1)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0 (= cycles (Random 20 150)))
			(1
				(cond 
					((and local28 (== detailLevel DETAIL_LOW)) (self changeState: 0))
					((>= local1 local0) (self changeState: 0))
					(local35 (self changeState: 0))
					((and local27 (<= (ego distanceTo: client) 80)) (self changeState: 0))
					(else
						(++ local1)
						(if (== register 3)
							(= local26 1)
							(= temp0 2)
						else
							(= temp0 (Random 0 1))
						)
						(client
							posn: (client x?) (+ (client y?) 4)
							setPri: [local48 register]
							setLoop: temp0
							setCel: -1
							cel: 0
							setCycle: EndLoop
						)
						(= cycles 2)
					)
				)
			)
			(2
				([local18 register]
					setLoop: (+ 3 (Random 0 1))
					show:
					setCycle: Forward
				)
				(if (!= register local32) (= cycles (Random 5 20)))
				(meepSound
					number: (GetSongNumber (+ (Random 0 2) 55))
					play:
				)
			)
			(3
				([local18 register] setCycle: 0 stopUpd: hide:)
				(client setCycle: BegLoop self)
			)
			(4
				(meepSound stop:)
				(client
					posn: (client x?) (- (client y?) 4)
					setPri: (+ 1 [local48 register])
					setLoop: 5
					setCel: 0
					stopUpd:
				)
				(if (== register 3) (= local26 0))
				(-- local1)
				(self changeState: 0)
			)
		)
	)
)

(instance killMeeps of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(self setScript: hackMeep)
		(ChangeEgoWalk MOVE_RUN FALSE)
		(= local31 0)
		(= local34
			(switch detailLevel
				(DETAIL_LOW 4)
				(DETAIL_MID 8)
				(DETAIL_HIGH 16)
			))
		(LockEgo)
		(ego ignoreBlocks: bossBlock)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1 (= cycles 2))
			(2
				(LockEgo)
				(= local35 0)
				(++ local0)
				(= local32 [local72 (/ local31 2)])
				([local10 local32] changeState: 1)
				(-- local0)
				(= local35 1)
				(= cycles 2)
			)
			(3
				(ego
					ignoreActors: 1
					illegalBits: 0
					setMotion: MoveTo [local80 local31] [local80 (+ local31 1)] self
				)
			)
			(4 (script cue:))
			(5
				(if (>= (= local31 (+ local31 2)) local34)
					(self cue:)
				else
					(self changeState: 2)
				)
			)
			(6
				(= local32 -1)
				(ChangeEgoWalk MOVE_WALK FALSE)
				(ego ignoreActors: 0 illegalBits: (& cWHITE cLGREY) loop: 2)
				(= seconds 2)
			)
			(7
				(ego observeBlocks: bossBlock)
				(= local300 0)
				(UnlockEgo)
				(HighPrint 60 39)
				(client setScript: 0)
			)
		)
	)
)

(instance hackMeep of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(ego view: 518 setLoop: 2 cel: 0 setCycle: EndLoop self)
			)
			(2
				(ego setLoop: 3 cel: 0 setCycle: EndLoop self)
				([local10 local32] changeState: 2 seconds: 0 cycles: 3)
			)
			(3 (ego setCycle: BegLoop self))
			(4
				(StopEgo)
				(= state 0)
				(client cue:)
			)
		)
	)
)

(instance prepAsk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local35 1)
				(= seconds 2)
			)
			(1
				(meepSound number: (GetSongNumber 75) loop: -1 play:)
				(PrintTimedMessage 7 60 40)
				(= seconds 7)
			)
			(2
				(meepSound stop: loop: 1)
				([local2 3] setScript: bossRises)
				(client setScript: 0)
			)
		)
	)
)

(instance bossRises of Script
	(properties)
	
	(method (init)
		(= local28 1)
		(super init: &rest)
	)
	
	(method (changeState newState &tmp clientX clientY clientPriority)
		(= clientX (client x?))
		(= clientY (client y?))
		(= clientPriority (client priority?))
		(switch (= state newState)
			(0
				(LockEgo)
				(= local43 30)
				(= local35 1)
				([local18 3] setCycle: 0 stopUpd: hide:)
				(client
					view: 61
					setLoop: 2
					cel: 0
					setPri: -1
					setCycle: EndLoop
					setMotion: MoveTo 130 119 self
				)
				(if (not local39) (bossRock init:) (= local39 1))
				(thudSound number: 54 play:)
				(bossRock
					ignoreActors: 1
					setLoop: 5
					cel: 0
					posn: 130 94
					setCycle: Forward
					setPri: 8
					setMotion: MoveTo 140 54 self
				)
			)
			(2
				(client
					setLoop: 1
					cel: 0
					setPri: 8
					cycleSpeed: 2
					setCycle: Forward
				)
				(bossRock setMotion: MoveTo 145 114 self)
				(if (or local33 (Btest 305))
					(localproc_0418 4 60 41)
				else
					(localproc_0418 4 60 42)
					(Bset 305)
					(= local33 1)
				)
			)
			(3
				(thudSound number: (GetSongNumber 58) play:)
				(bossRock setCycle: 0 setCel: 0 setPri: -1 stopUpd:)
				(= cycles 6)
			)
			(4
				(client setCycle: 0 cel: 3 stopUpd:)
				(if (not local40) (meepHead init:) (= local40 1))
				(meepHead posn: 130 110 z: 1 setPri: 8 setCycle: Forward)
				(= seconds 2)
			)
			(5
				(meepHead setCycle: 0 stopUpd:)
				(= local43 30)
				(= local35 0)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance bossHides of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local40 (= local40 0) (meepHead dispose:))
				([local2 3]
					setLoop: 2
					cel: 0
					setPri: -1
					setCycle: CycleTo 2 1
					setMotion: MoveTo 130 114 self
				)
			)
			(1
				([local2 3] setPri: [local48 3])
				(= seconds 3)
			)
			(2
				([local2 3] setLoop: 0 cel: 0 posn: 130 127)
				(client setScript: 0)
			)
		)
	)
)

(instance bossReturns of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				([local2 3]
					posn: 130 114
					setLoop: 2
					cel: 2
					setPri: -1
					setCycle: CycleTo 0 -1
					setMotion: MoveTo 130 119 self
				)
			)
			(1
				(if (not local40) (meepHead init:) (= local40 1))
				(meepHead posn: 130 110 z: 1 setPri: 8 setCycle: Forward)
				([local2 3] setPri: 8 setLoop: 1 cel: 0 stopUpd:)
				(if local301
					(localproc_0418 4 60 43)
					(= local301 0)
				else
					(localproc_0418 4 60 44)
				)
				(= seconds 4)
			)
			(2
				(meepHead setCycle: 0 stopUpd:)
				(client setScript: 0)
			)
		)
	)
)

(instance throwObj of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 temp2 [temp3 2])
		(switch (= state newState)
			(0
				(throwSound play:)
				(= temp2 (Random 85 235))
				(= temp0 (+ 130 (SinMult temp2 local47)))
				(= temp1 (- 120 (CosMult temp2 local47)))
				(switch register
					(0
						((= newAct (Actor new:)) view: 61 setLoop: 6)
					)
					(1
						(= local44 1)
						(= newAct babyMeep)
					)
					(2
						(= local301 (= local46 1))
						(= newAct greenFur)
					)
					(3
						(= local301 (= local45 1))
						(= newAct spellScroll)
					)
				)
				([local2 3] setCel: 1)
				(newAct
					setLoop: (newAct loop?)
					cel: 0
					setPri: 7
					ignoreActors:
					illegalBits: 0
					posn: 133 110
					init:
					setCycle: 0
					setMotion: MoveTo temp0 temp1 self
				)
				(if (!= register 2) (newAct setCycle: Forward))
			)
			(1
				(newAct setCycle: 0 stopUpd:)
				(switch register
					(0 (newAct addToPic:))
					(1
						(babyMeep setScript: bouncyBaby)
					)
				)
				([local2 3] setCel: 0)
				(client setScript: 0)
			)
		)
	)
)

(instance throwThings of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local29 1)
				(localproc_0418
					6
					(Format
						@local100
						60
						45
						[local96 register]
						[local96 local29]
					)
				)
				(= seconds 2)
			)
			(1
				(self setScript: bossHides self)
			)
			(2
				(if (ego inRect: 100 122 160 136)
					(ego setMotion: MoveTo 165 123)
				)
				(= seconds 2)
			)
			(3
				(ego loop: 1)
				(if
					(or
						(> local42 20)
						(and (== register 2) (or local46 (Btest 227)))
						(and
							(== register 3)
							(or local45 (Btest 228) (not [skills skMAGIC]))
						)
					)
					(localproc_0418 5 60 46)
					(= state 6)
					(= seconds 5)
				else
					(= local41 (Random 2 4))
					(if (== register 0) (= local41 0))
					(= cycles 10)
				)
			)
			(4
				(= temp0
					(switch (Random 0 4)
						(1 (if local44 0 else 1))
						(3
							(if
								(or
									local45
									(== register 3)
									(Btest 228)
									(not [skills skMAGIC])
								)
								0
							else
								3
							)
						)
						(else  0)
					)
				)
				(if local41
					(self setScript: throwObj self temp0)
				else
					(self changeState: 6)
				)
			)
			(5
				(-- local41)
				(++ local42)
				(= state 3)
				(= cycles 5)
			)
			(6
				(-- local47)
				(self setScript: throwObj self register)
			)
			(7
				(self setScript: bossReturns self)
			)
			(8
				(= local29 0)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance bossMad of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local28 0)
				(meepHead setCycle: Forward)
				(client
					setLoop: 4
					cel: 0
					cycleSpeed: 0
					setCycle: CycleTo 3 1 self
				)
			)
			(1
				(if local40 (= local40 0) (meepHead dispose:))
				(thudSound play:)
				(bossRock
					setCel: -1
					setCycle: Forward
					setPri: 8
					setMotion: MoveTo 140 54 self
				)
				(client setCycle: EndLoop)
			)
			(2
				(meepHead dispose:)
				(client
					setLoop: 2
					cel: -1
					setCycle: BegLoop
					setMotion: MoveTo 130 114 self
				)
				(bossRock setCycle: Forward setMotion: MoveTo 140 94)
			)
			(3
				(thudSound play:)
				(bossRock dispose:)
				(= local39 0)
				(client view: 60 setLoop: 2 cel: 2 setCycle: BegLoop self)
				([local18 3]
					setLoop: (+ 3 (Random 0 1))
					show:
					setCycle: Forward
				)
				(= cycles 2)
			)
			(4
				([local18 3] setCycle: 0 stopUpd: hide:)
				(client setCycle: BegLoop self)
			)
			(5
				(if (not local300) (UnlockEgo))
				(client
					setLoop: 5
					cel: 0
					setPri: (+ 1 [local48 3])
					posn: [local56 6] (- [local56 7] 4)
					forceUpd:
					setScript: [local10 3] 0 (= [local10 3] (Clone aMeepScript))
				)
			)
		)
	)
)

(instance bouncyBaby of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client setCycle: Forward)
				(self setScript: babySqueak)
				(= seconds 8)
			)
			(1
				(client setMotion: MoveTo 129 107 self)
			)
			(2 (= cycles 5))
			(3
				(= local44 0)
				(client dispose:)
			)
		)
	)
)

(instance babySqueak of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= cycles (Random 3 8))
				(babySound play:)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance getThing of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(= local300 1)
				(LockEgo)
				(ego ignoreBlocks: bossBlock)
				(if local28
					([local2 3] setScript: bossMad self)
				else
					(self cue:)
				)
			)
			(1
				(= temp0
					(switch register
						(2 greenFur)
						(3 spellScroll)
					)
				)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo (+ (temp0 x?) 12) (temp0 y?) self
				)
			)
			(2
				(ego
					view: 510
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 8)
			)
			(3
				(switch register
					(2
						(greenFur dispose:)
						(ego get: invMeepGreenFur)
						(= local46 0)
						(Bset 227)
					)
					(3
						(spellScroll dispose:)
						(ego get: invPieceOfPaper)
						(= local45 0)
						(Bset 228)
					)
				)
				(ego setCycle: BegLoop self)
			)
			(4
				(StopEgo)
				(ego illegalBits: (& cWHITE cLGREY))
				(FaceObject ego [local2 3])
				(switch register
					(2
						(PrintTimedMessage 5 60 47)
						(AddToScore POINTS_GETGREENFUR 5)
					)
					(3
						(if [skills skMAGIC]
							(PrintTimedMessage 8 60 48)
							(ego learn: skDETECTMAGIC 10)
							(AddToScore POINTS_LEARNDETECTMAGIC 4 CLASS_MAGICUSER)
						else
							(PrintTimedMessage 5 60 49)
						)
					)
				)
				(ego observeBlocks: bossBlock)
				(UnlockEgo)
				(= local300 0)
				(self dispose:)
			)
		)
	)
)

(instance liftRock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local300 1)
				(LockEgo)
				(= local35 1)
				(if local28
					([local2 3] setScript: bossMad self)
				else
					(self cue:)
				)
			)
			(1
				(ego
					ignoreActors: 1
					illegalBits: 0
					ignoreBlocks: bossBlock
					setMotion: MoveTo 130 106 self
				)
			)
			(2
				([local2 3] hide:)
				(ego
					view: 62
					setPri: 4
					setLoop: 0
					setCel: -1
					cel: 0
					cycleSpeed: 4
					setCycle: EndLoop self
				)
			)
			(3
				(ego setCycle: CycleTo 1 -1 self cycleSpeed: 5)
			)
			(4
				(ego setCycle: EndLoop self cycleSpeed: 2)
			)
			(5 (ego cel: 0) (= cycles 2))
			(6
				(thudSound play:)
				(ego setLoop: 1 cel: 0 cycleSpeed: 3 setCycle: EndLoop self)
				(ego posn: 130 103)
				([local2 3] show: view: 60 setLoop: 5 setCel: 0)
			)
			(7
				(StopEgo)
				(FaceObject ego [local2 3])
				([local2 3] setLoop: -1 setCel: -1)
				(= local35 0)
				(ego observeBlocks: bossBlock)
				(UnlockEgo)
				(= local300 0)
				(self dispose:)
			)
		)
	)
)
