;;; Sierra Script 1.0 - (do not remove this comment)
(script# 214)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use StatusBar)
(use Skilled)


(class Monster of Skilled
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits cWHITE
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		health 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		opponent 0
		fightLeft 0
		attackRange 50
		ateEgo 0
		monsterTitle 0
		monsterHP 0
		warriorX 160
		warriorY 190
		flameX 0
		flameY 0
	)
	
	(method (dispose)
		(if monsterTitle
			(monsterHP dispose:)
			(Display 214 0 p_restore monsterTitle)
			(= monsterTitle (= monsterHP 0))
		)
		(super dispose:)
	)
	
	(method (getHurt param1)
		(super getHurt: param1)
		(if (> param1 0) (Bset 233))
		(self setMonsterHP: health)
	)
	
	(method (drawStatus)
		(= opponent (ScriptID 213 0))
		(if (not (= health gMonsterHealth))
			(= health (self calcHealth:))
		)
		(= stamina (self calcStamina:))
		(= mana (self calcMana:))
		(= monsterTitle
			(Display
				214 1
				p_width 120
				p_at 228 13
				p_mode teJustLeft
				p_font 300
				p_color hpFontColour
				p_save
			)
		)
		((= monsterHP (StatusBar new:))
			x: 240
			y: 33
			titleCel: 0
			priority: 1
			max: (self calcHealth:)
			value: health
			init:
		)
	)
	
	(method (setMonsterHP param1)
		(monsterHP value: param1 draw:)
	)
)
