;;; Sierra Script 1.0 - (do not remove this comment)
(script# 68)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Game)

(public
	rm68 0
)

(instance rm68 of Room
	(properties
		picture 68
		style $0008
		horizon 30
		west 67
	)
	
	(method (init)
		(super init:)
		(self setLocales: 804)
		(StatusLine enable:)
		(StopEgo)
		(ego
			posn:
				1
				(if (>= gGEgoObjY 150)
					(= gGEgoObjY (+ gGEgoObjY 14))
				else
					(= gGEgoObjY (+ gGEgoObjY 26))
				)
			init:
			setMotion: MoveTo 320 102
		)
	)
	
	(method (dispose)
		(Bset 58)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,forest,greenery]') (HighPrint 68 0))
							((Said '/ice,road,avalanche') (HighPrint 68 1))
							((Said '[<down][/ground,needle,moss,grass]') (HighPrint 68 2))
							((Said '[<up][/sky,cloud,star]')
								(if isNightTime
									(HighPrint 68 3)
								else
									(HighPrint 68 4)
								)
							)
							((Said '/birch,tree') (HighPrint 68 5))
							((Said '/bush') (HighPrint 68 6))
							((Said '/boulder') (HighPrint 68 7))
							((Said '/hill,cliff,peak,pass') (HighPrint 68 8))
							((Said '/cave') (HighPrint 68 9))
						)
					)
					((Said 'climb') (HighPrint 68 10))
					((Said '/dad') (HighPrint 68 11))
					((Said '/clem') (HighPrint 68 12))
					((Said '/bobpa') (HighPrint 68 13))
					((Said '/sid') (HighPrint 68 14))
				)
			)
		)
		(super handleEvent: pEvent)
	)
)
