;;; Sierra Script 1.0 - (do not remove this comment)
(script# 73)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TalkObj)
(use TargActor)
(use LoadMany)
(use GControl)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm73 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8 =  55
	gEgoObjY
	local10
	local11
	local12
)
(instance dags of Set
	(properties)
)

(instance knife1 of Actor
	(properties
		view 65
	)
)

(instance knife2 of Actor
	(properties
		view 65
	)
)

(instance shield of RPicView
	(properties
		y 132
		x 140
		view 73
		loop 8
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/stuff,shield,spear')
				)
				(HighPrint 73 0)
			)
		)
	)
)

(instance brunoWin of SysWindow
	(properties
		color 8
		title {Bruno:}
	)
	
	(method (open &tmp temp0)
		(= top (- top (= temp0 (- top 12))))
		(= bottom (- bottom temp0))
		(super open:)
	)
)

(instance brutusWin of SysWindow
	(properties
		color 1
		title {Brutus:}
	)
	
	(method (open &tmp temp0)
		(= top (- top (= temp0 (- top 12))))
		(= bottom (- bottom temp0))
		(super open:)
	)
)

(instance brunoTalk of TalkObj
	(properties
		tLoop 4
	)
)

(instance brutusTalk of TalkObj
	(properties
		tLoop 4
		cSpeed 4
	)
)

(instance brutus of TargActor
	(properties
		y 114
		x 136
		view 73
		loop 4
	)
	
	(method (doit)
		(brutusTalk doit:)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			(local11 (pEvent claimed: 1))
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/brutus,man,thief,bandit,body')
					(IsObjectOnControl self pEvent 3)
				)
				(if (Btest 261)
					(HighPrint 73 1)
				else
					(HighPrint 73 2)
				)
			)
			((Said 'get/shield')
				(if (Btest 261)
					(HighPrint 73 3)
				else
					(HighPrint 73 4)
				)
			)
			(
				(or
					(Said 'get/key')
					(Said 'search/bandit,man,thief,brutus,body')
				)
				(if (Btest 261)
					(if (ego inRect: 90 92 230 188)
						(ego setScript: egoSearch)
					else
						(HighPrint 73 5)
					)
				else
					(HighPrint 73 4)
				)
			)
			(else (brutusTalk handleEvent: pEvent))
		)
	)
	
	(method (getHurt param1)
		(if
			(and
				(<= (= gMonsterHealth (- gMonsterHealth param1)) 0)
				(not (Btest 261))
			)
			(= zapMeleeBonus 0)
			(= global332 0)
			(Bset 261)
			(self setScript: brutusDies)
		)
		(= brutusHP gMonsterHealth)
	)
)

(instance bruno of Actor
	(properties
		y 117
		x 102
		view 65
		loop 4
	)
	
	(method (doit)
		(brunoTalk doit:)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'look/bruno')
					(IsObjectOnControl self pEvent 3)
				)
				(HighPrint 73 6)
			)
			(else (brunoTalk handleEvent: pEvent))
		)
	)
)

(instance target of RPicView
	(properties
		y 105
		x 187
		view 74
		priority 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(IsObjectOnControl self pEvent 3)
					(Said 'look/target,board,sign')
				)
				(if local7 (HighPrint 73 7) else (HighPrint 73 8))
			)
		)
	)
)

(instance rm73 of Room
	(properties
		picture 73
		style $0007
		east 74
		south 80
		west 72
	)
	
	(method (init param1)
		(asm
			pushi    #init
			pushi    0
			&rest    param1
			super    Room,  4
			pushi    #enable
			pushi    0
			class    StatusLine
			send     4
			pushi    #setLocales
			pushi    1
			pushi    804
			self     6
			pushi    2
			pushi    128
			pushi    74
			callk    Load,  4
			pushi    5
			pushi    132
			pushi    1
			pushi    35
			callb    GetSongNumber,  2
			push    
			pushi    1
			pushi    39
			callb    GetSongNumber,  2
			push    
			pushi    1
			pushi    31
			callb    GetSongNumber,  2
			push    
			pushi    1
			pushi    66
			callb    GetSongNumber,  2
			push    
			calle    LoadMany,  10
			pushi    2
			pushi    130
			pushi    101
			calle    LoadMany,  4
			pushi    #knows
			pushi    1
			pushi    23
			lag      ego
			send     6
			bnt      code_062e
			pushi    2
			pushi    128
			pushi    522
			callk    Load,  4
			pushi    2
			pushi    130
			pushi    100
			callk    Load,  4
code_062e:
			pushi    #knows
			pushi    1
			pushi    20
			lag      ego
			send     6
			bnt      code_064e
			pushi    2
			pushi    128
			pushi    521
			callk    Load,  4
			pushi    2
			pushi    130
			pushi    106
			callk    Load,  4
code_064e:
			pushi    #knows
			pushi    1
			pushi    22
			lag      ego
			send     6
			bnt      code_066e
			pushi    2
			pushi    128
			pushi    521
			callk    Load,  4
			pushi    2
			pushi    130
			pushi    104
			callk    Load,  4
code_066e:
			pushi    #knows
			pushi    1
			pushi    17
			lag      ego
			send     6
			bnt      code_068e
			pushi    2
			pushi    128
			pushi    521
			callk    Load,  4
			pushi    2
			pushi    130
			pushi    105
			callk    Load,  4
code_068e:
			pushi    1
			pushi    161
			callb    Btest,  2
			bnt      code_06b8
			pushi    1
			pushi    235
			callb    Btest,  2
			not     
			bnt      code_06b8
			lsg      timeZone
			ldi      2
			eq?     
			bnt      code_06b8
			lsg      prevRoomNum
			ldi      72
			eq?     
			bt       code_06b8
			lsg      prevRoomNum
			ldi      74
			eq?     
code_06b8:
			sal      local0
			bnt      code_06e0
			ldi      53
			sag      brutusHP
			sag      gMonsterHealth
			ldi      465
			sag      global332
			pushi    2
			pushi    128
			pushi    65
			callk    Load,  4
			pushi    2
			pushi    128
			pushi    73
			callk    Load,  4
			jmp      code_07a5
code_06e0:
			lag      brunoCountDown
			bnt      code_06ed
			pushi    1
			pushi    261
			callb    Btest,  2
code_06ed:
			sal      local2
			bnt      code_06fe
			pushi    2
			pushi    128
			pushi    73
			callk    Load,  4
			jmp      code_07a5
code_06fe:
			lag      brunoCountDown
			bnt      code_071c
			lsg      prevRoomNum
			ldi      72
			eq?     
			bt       code_0714
			lsg      prevRoomNum
			ldi      74
			eq?     
			bnt      code_071c
code_0714:
			pushi    1
			pushi    261
			callb    Btest,  2
			not     
code_071c:
			sal      local4
			bnt      code_0743
			pushi    2
			pushi    128
			pushi    510
			callk    Load,  4
			pushi    2
			pushi    128
			pushi    73
			callk    Load,  4
			lag      brutusHP
			sag      gMonsterHealth
			ldi      465
			sag      global332
			jmp      code_07a5
code_0743:
			lag      brunoCountDown
			bnt      code_0759
			lsg      prevRoomNum
			ldi      80
			eq?     
			bnt      code_0759
			pushi    1
			pushi    261
			callb    Btest,  2
			not     
code_0759:
			sal      local1
			bnt      code_0789
			pushi    2
			pushi    128
			pushi    73
			callk    Load,  4
			lag      brutusHP
			sag      gMonsterHealth
			ldi      465
			sag      global332
			ldi      6
			sag      brigandHead
			pushi    #posn
			pushi    2
			pushi    134
			pushi    120
			lofsa    brutus
			send     8
			jmp      code_07a5
code_0789:
			lsg      prevRoomNum
			ldi      465
			eq?     
			sal      local3
			bnt      code_07a5
			pushi    1
			pushi    261
			callb    Bset,  2
			pushi    2
			pushi    128
			pushi    466
			callk    Load,  4
code_07a5:
			lal      local4
			bt       code_07b4
			lal      local1
			bt       code_07b4
			lal      local0
			bnt      code_07d5
code_07b4:
			pushi    #init
			pushi    0
			lofsa    shield
			send     4
			pushi    #add
			pushi    1
			lofsa    shield
			push    
			pushi    60
			pushi    0
			lag      gAddToPics
			send     10
			pushi    #add
			pushi    1
			lofsa    shield
			push    
			lag      gFeatures
			send     6
code_07d5:
			pushi    #init
			pushi    0
			lofsa    target
			send     4
			pushi    #add
			pushi    1
			lofsa    target
			push    
			pushi    60
			pushi    0
			lag      gAddToPics
			send     10
			pushi    #add
			pushi    1
			lofsa    target
			push    
			lag      gFeatures
			send     6
			pushi    0
			callb    StopEgo,  0
			pushi    #init
			pushi    0
			lag      ego
			send     4
			ldi      0
			sal      local6
			pushi    #has
			pushi    1
			pushi    33
			lag      ego
			send     6
			bnt      code_0819
			ldi      5
			sal      local6
			jmp      code_082a
code_0819:
			pushi    #has
			pushi    1
			pushi    8
			lag      ego
			send     6
			bnt      code_082a
			ldi      3
			sal      local6
code_082a:
			pushi    338
			pushi    1
			lsl      local5
			dup     
			ldi      1
			eq?     
			bnt      code_083c
			ldi      12
			jmp      code_0845
code_083c:
			dup     
			ldi      65535
			eq?     
			bnt      code_0845
			ldi      65524
code_0845:
			toss    
			push    
			lofsa    brutus
			send     6
			lsg      prevRoomNum
			dup     
			ldi      72
			eq?     
			bnt      code_0875
			pushi    #posn
			pushi    2
			pushi    2
			pushi    160
			pushi    212
			pushi    3
			class    MoveTo
			push    
			pushi    57
			pushi    146
			lag      ego
			send     18
			ldi      65535
			sal      local5
			jmp      code_08e3
code_0875:
			dup     
			ldi      74
			eq?     
			bnt      code_089f
			pushi    #posn
			pushi    2
			pushi    319
			pushi    140
			pushi    212
			pushi    3
			class    MoveTo
			push    
			pushi    276
			pushi    133
			lag      ego
			send     18
			ldi      1
			sal      local5
			jmp      code_08e3
code_089f:
			dup     
			ldi      80
			eq?     
			bnt      code_08c9
			pushi    #posn
			pushi    2
			pushi    160
			pushi    187
			pushi    212
			pushi    3
			class    MoveTo
			push    
			pushi    160
			pushi    170
			lag      ego
			send     18
			ldi      0
			sal      local5
			jmp      code_08e3
code_08c9:
			pushi    #posn
			pushi    2
			pushi    165
			pushi    108
			pushi    212
			pushi    3
			class    MoveTo
			push    
			pushi    165
			pushi    125
			lag      ego
			send     18
code_08e3:
			toss    
			lal      local0
			bnt      code_08f5
			pushi    #setScript
			pushi    1
			lofsa    brigsMeet
			push    
			self     6
			jmp      code_098a
code_08f5:
			lal      local4
			bnt      code_090c
			pushi    #init
			pushi    0
			pushi    122
			pushi    1
			lofsa    brutusThrows
			push    
			lofsa    brutus
			send     10
			jmp      code_098a
code_090c:
			lal      local1
			bnt      code_091d
			pushi    #setScript
			pushi    1
			lofsa    brutusLives
			push    
			self     6
			jmp      code_098a
code_091d:
			lal      local2
			bnt      code_0951
			pushi    #view
			pushi    1
			pushi    466
			pushi    6
			pushi    1
			pushi    0
			pushi    7
			pushi    1
			pushi    7
			pushi    87
			pushi    0
			pushi    197
			pushi    0
			lofsa    brutus
			send     26
			pushi    #add
			pushi    0
			lofsa    dags
			send     4
			pushi    #setScript
			pushi    1
			lofsa    nobodyHere
			push    
			self     6
			jmp      code_098a
code_0951:
			lal      local3
			bnt      code_0979
			ldi      0
			sag      global332
			pushi    #loop
			pushi    1
			pushi    3
			pushi    196
			pushi    2
			pushi    140
			pushi    124
			lag      ego
			send     14
			pushi    #setScript
			pushi    1
			lofsa    brutusDies
			push    
			self     6
			jmp      code_098a
code_0979:
			pushi    #add
			pushi    0
			lofsa    dags
			send     4
			pushi    #setScript
			pushi    1
			lofsa    nobodyHere
			push    
			self     6
code_098a:
			ret     
		)
	)
	
	(method (dispose)
		(dags eachElementDo: #dispose 84 release:)
		(dags dispose:)
		(if (!= newRoomNum 465)
			(= global332 0)
			(= brigandHead 0)
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 theBrutus)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((super handleEvent: pEvent))
					((Said 'look/dagger') (if local7 (HighPrint 73 9) else (pEvent claimed: 0)))
					((Said 'get/spear') (HighPrint 73 10))
					((Said 'hop/bush') (HighPrint 73 11))
					((Said 'search,look/body,bandit,brutus')
						(if (Btest 261)
							(HighPrint 73 12)
						else
							(HighPrint 73 13)
						)
					)
					((Said 'rest[/!*]')
						(if (> brunoCountDown 50)
							(= brunoCountDown (- brunoCountDown 50))
						)
						(pEvent claimed: 0)
					)
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC (HighPrint 73 14))
								(skDAZZLE
									(if (AnimateDazzle)
										(if
										(or (Btest 261) (== (self script?) nobodyHere))
											(HighPrint 73 15)
										else
											(= local12 1)
										)
									)
								)
								(skFLAMEDART
									(if
									(or (Btest 261) (== (self script?) nobodyHere))
										(AnimateThrowingFlameDart 0)
									else
										(AnimateThrowingFlameDart brutus)
									)
								)
								(skCALM
									(HighPrint 73 16)
									(if
									(and (gCast contains: brutus) (not (Btest 261)))
										(HighPrint 73 17)
									)
								)
								(skOPEN
									(HighPrint 73 16)
									(HighPrint 73 18)
								)
								(skZAP
									(= zapMeleeBonus (+ 1 (/ [skills skZAP] 10)))
									(if (or (ego has: invDagger) (ego has: invBroadsword))
										(HighPrint 73 19)
									else
										(HighPrint 73 20)
									)
								)
								(skFETCH
									(if
									(or (Btest 261) (== (self script?) nobodyHere))
										(HighPrint 73 21)
									else
										(HighPrint 73 22)
									)
								)
								(else  (HighPrint 73 23))
							)
						)
					)
					((Said 'throw/dagger,dagger')
						(= theBrutus 0)
						(if
						(and (gCast contains: brutus) (not (Btest 261)))
							(FaceObject ego brutus)
							(= theBrutus brutus)
						)
						(AnimateThrowingDagger theBrutus)
					)
					((Said 'throw/boulder')
						(= theBrutus 0)
						(if
						(and (gCast contains: brutus) (not (Btest 261)))
							(FaceObject ego brutus)
							(= theBrutus brutus)
						)
						(AnimateThrowingRock theBrutus)
					)
					((Said 'climb,climb[/wall]')
						(if isNightTime
							(if (< (ego y?) 135)
								(if (TestSkill skCLIMBING 35 0)
									(HighPrint 73 24)
									(curRoom newRoom: 300)
								else
									(HighPrint 73 25)
								)
							else
								(HighPrint 73 26)
							)
						else
							(HighPrint 73 27)
						)
					)
					((Said 'look/east,south,west,forest,forest') (HighPrint 73 28))
					(
						(Said
							'look[<at,around][/!*,range,clearing,area,hamlet,wall,north,building]'
						)
						(HighPrint 73 29)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance brigsMeet of Script
	(properties)
	
	(method (changeState newState)
		(if client
			(switch (= state newState)
				(0
					(Bset 235)
					(brunoTalk caller: self)
					(brutusTalk caller: self)
					(bruno init:)
					(brutus init:)
					(brunoTalk tWindow: brunoWin actor: bruno init:)
					(brutusTalk tWindow: brutusWin actor: brutus init:)
					(gMouseHandler add: bruno brutus)
					(gKeyHandler add: bruno brutus)
					(= seconds 4)
				)
				(1
					(TalkObjMessages brunoTalk 73 31)
				)
				(2
					(TalkObjMessages brutusTalk 73 32)
				)
				(3
					(TalkObjMessages brunoTalk 73 33)
				)
				(4
					(TalkObjMessages brutusTalk 73 34)
				)
				(5
					(TalkObjMessages brunoTalk 73 35)
				)
				(6
					(TalkObjMessages brutusTalk 73 36 73 37)
				)
				(7
					(TalkObjMessages brunoTalk 73 38)
				)
				(8
					(TalkObjMessages brutusTalk 73 39)
				)
				(9
					(TalkObjMessages brunoTalk 73 40 73 41 73 42)
				)
				(10
					(TalkObjMessages brutusTalk 73 43)
				)
				(11
					(TalkObjMessages brunoTalk 73 44)
				)
				(12
					(TalkObjMessages brutusTalk 73 45)
				)
				(13
					(TalkObjMessages brunoTalk 73 46)
				)
				(14
					(TalkObjMessages brutusTalk 73 47)
				)
				(15
					(TalkObjMessages brunoTalk 73 48)
				)
				(16
					(TalkObjMessages brutusTalk 73 49 73 50)
				)
				(17
					(TalkObjMessages brunoTalk 73 51)
				)
				(18
					(TalkObjMessages brutusTalk 73 52)
				)
				(19
					(TalkObjMessages brunoTalk 73 53 73 54)
				)
				(20
					(TalkObjMessages brutusTalk 73 55)
				)
				(21
					(TalkObjMessages brunoTalk 73 56)
				)
				(22
					(TalkObjMessages brutusTalk 73 57)
				)
				(23
					(TalkObjMessages brunoTalk 73 58)
				)
				(24
					(TalkObjMessages brutusTalk 73 59)
					(AddToScore POINTS_OVERHEARBRUNO 12)
				)
				(25
					(bruno
						illegalBits: 0
						ignoreActors:
						setLoop: -1
						setCycle: Walk
						setMotion: MoveTo 170 226 self
					)
					(User canControl: 0)
				)
				(26
					(bruno dispose:)
					(User canControl: 1)
					(= brunoCountDown 300)
					(client setScript: brutusWaits)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look/man,man,thief,bandit') (HighPrint 73 30))
			((Said 'ask,chat,throw,cast')
				(brunoTalk caller: 0 endTalk:)
				(brutusTalk caller: 0 endTalk:)
				(bruno setMotion: 0)
				(client setScript: egoLoses)
			)
		)
	)
)

(instance egoLoses of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(bruno
					setLoop: (if (> (ego x?) 160) 5 else 6)
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(knife1
					illegalBits: 0
					setLoop: 7
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setPri: (- (ego priority?) 1)
					setCycle: Forward
					posn: (+ (bruno x?) (* local5 41)) (- (bruno y?) 24)
					setMotion: MoveTo (ego x?) (- (ego y?) 22)
				)
				(bruno setCycle: CycleTo 5 1 self)
			)
			(2
				(bruno setCycle: EndLoop)
				(knife2
					illegalBits: 0
					setLoop: 8
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					setPri: (- (ego priority?) 1)
					init:
					setCycle: Forward
					posn: (+ (bruno x?) (* 41 local5)) (- (bruno y?) 27)
					setMotion: MoveTo (ego x?) (- (ego y?) 25) self
				)
				(ego setLoop: 1)
			)
			(3
				(knife1 dispose:)
				(knife2 dispose:)
				(ego
					view: 516
					setLoop: 3
					cycleSpeed: 1
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			(4 (= seconds 4))
			(5
				(Die 73 60 82 516 2 5 80 {Keep your mouth shut.})
			)
		)
	)
)

(instance brutusWaits of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds brunoCountDown))
			(1
				(if (not (Btest 261))
					(brutus
						illegalBits: 0
						ignoreActors:
						setLoop: -1
						loop: 1
						setCycle: Walk
						setMotion: MoveTo 170 224 self
					)
				)
			)
			(2 (brutus dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'ask,chat') (brutus setMotion: 0) (client setScript: brutusThrows))
			(
				(and
					(!= (brutus script?) brutusThrows)
					(not (Btest 261))
					(Said 'throw,cast')
				)
				(brutus setMotion: 0)
				(brutus setScript: brutusThrows)
				(pEvent claimed: 0)
			)
		)
	)
)

(instance brutusDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (== prevRoomNum 465)
					(ego posn: 152 128)
					(brutus view: 466 loop: 0 init:)
				else
					(brutus view: 73 setLoop: 7)
				)
				(brutus
					posn: 139 114
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(UnlockEgo)
				(= local11 0)
				(StopEgo)
				(brutus stopUpd:)
				(dags add:)
				(client setScript: nobodyHere)
			)
		)
	)
)

(instance brutusLives of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(brutus
					init:
					setCycle: Walk
					setMotion: MoveTo (ego x?) (ego y?)
				)
				(brutusTalk actor: 0)
				(HighPrint 73 61)
				(= cycles 11)
			)
			(1 (curRoom newRoom: 465))
		)
	)
)

(instance brutusThrows of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(brutus
					setLoop: (if (> (ego x?) 160) 5 else 6)
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(brutus setCycle: CycleTo 5 1 self)
			)
			(2
				(if local12
					(self cue:)
				else
					(brutus setCycle: EndLoop self)
					(= local11 1)
				)
			)
			(3
				(if local12
					(self cue:)
				else
					(knife1
						illegalBits: 0
						setLoop: 7
						ignoreActors:
						ignoreHorizon:
						xStep: 6
						yStep: 7
						init:
						setPri: (- (ego priority?) 1)
						setCycle: Forward
						posn: (+ (brutus x?) (* local5 32)) (- (brutus y?) 20)
						setMotion: MoveTo (ego x?) (- (ego y?) 22) self
					)
				)
			)
			(4
				(if local12
					(self cue:)
				else
					(knife1 dispose:)
					(if (not (ReduceHP (- 10 local6)))
						(self changeState: 7)
					)
					(ego
						view: 513
						setLoop: (if (== local5 1) 3 else 2)
						cycleSpeed: 1
						setMotion: 0
						setCycle: EndLoop
					)
					(= cycles 12)
				)
			)
			(5
				(StopEgo)
				(FaceObject ego brutus)
				(= local11 0)
				(if local12
					(= seconds 12)
					(= local12 0)
				else
					(= seconds 3)
				)
			)
			(6 (self changeState: 0))
			(7
				(ego
					view: 516
					setLoop: 2
					setCel: -1
					cel: 0
					cycleSpeed: 1
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			(8 (= seconds 3))
			(9
				(Die 73 62 82 516 2 5 80 {Daggered to death.})
			)
		)
	)
)

(instance nobodyHere of Script
	(properties)
	
	(method (changeState newState &tmp newProp temp1 temp2 temp3)
		(switch (= state newState)
			(1
				(LockEgo)
				(= gEgoObjY (ego y?))
				(cond 
					((< (ego x?) 129) (ego setMotion: MoveTo 134 (ego y?) self))
					((> (ego x?) 180) (ego setMotion: MoveTo 173 (ego y?) self))
					((< (ego y?) 110) (ego setMotion: MoveTo (ego x?) 116 self))
					(else (self cue:))
				)
			)
			(2
				(ego setMotion: MoveTo 186 109 self)
			)
			(3
				(dags eachElementDo: #dispose 84 release:)
				(= seconds 2)
			)
			(4
				(dags add:)
				(ego
					setMotion: MoveTo 156 (if (> gEgoObjY 115) gEgoObjY else 115) self
				)
			)
			(5 (ego loop: 3) (UnlockEgo))
			(6
				(LockEgo)
				(ego
					view: 510
					setLoop: 2
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 3 1 self
				)
			)
			(7
				(ego setCycle: EndLoop)
				(TestSkill skTHROWING 0 20)
				(= temp3 (/ (- 120 [skills skTHROWING]) 10))
				(= temp1 (- (Random 0 temp3) (/ temp3 2)))
				(= temp2 (- (Random 0 temp3) (/ temp3 2)))
				(knife1
					illegalBits: 0
					setLoop: 7
					ignoreActors:
					ignoreHorizon:
					xStep: 6
					yStep: 7
					init:
					setPri: (- (ego priority?) 1)
					setCycle: Forward
					posn: (+ (ego x?) 30) (- (ego y?) 24)
					setMotion:
						MoveTo
						(+ (target x?) temp1)
						(+ (- (target y?) 22) temp2)
						self
				)
			)
			(8
				(if (< local7 local8)
					((= newProp (Prop new:))
						init:
						view: 65
						loop: 7
						cel: (Random 0 6)
						posn: (knife1 x?) (knife1 y?)
						stopUpd:
					)
					(dags add: newProp)
				)
				(knife1 dispose:)
				(StopEgo)
				(ego loop: 3)
				(UnlockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'throw/dagger')
				(cond 
					((or (== prevRoomNum 72) (== prevRoomNum 74)) (HighPrint 73 63))
					((< (ego y?) 135) (HighPrint 73 64))
					((ego has: invDagger) (-- [invNum invDagger]) (++ local7) (self changeState: 6))
					(else (HighPrint 73 65))
				)
			)
			((Said 'get/dagger')
				(if local7
					(= [invNum invDagger] (+ [invNum invDagger] local7))
					(= local7 0)
					(self changeState: 1)
				else
					(HighPrint 73 66)
				)
			)
		)
	)
)

(instance egoSearch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					ignoreActors: 1
					illegalBits: 0
					setMotion: MoveTo 145 120 self
				)
			)
			(1
				(FaceObject ego brutus)
				(ego
					loop: (mod (+ (ego loop?) 4) 2)
					view: 510
					setCycle: EndLoop self
				)
			)
			(2
				(if (Btest 245)
					(HighPrint 73 67)
				else
					(HighPrint 73 68)
					(Bset 245)
					(ego get: invLargeBrassKey)
				)
				(StopEgo)
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)
