;;; Sierra Script 1.0 - (do not remove this comment)
(script# 101)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingDagger 0
)

(local
	local0
	local1
	local2
	local3
	local4
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
	newSound
	local10
)
(procedure (AnimateThrowingDagger param1 &tmp temp0 temp1)
	(if (!= curRoomNum roomDaggersDropped)
		(= roomDaggersDropped curRoomNum)
		(= global271 0)
	)
	(return
		(if (not (ego has: invDagger))
			(HighPrint 101 0)
			(DisposeScript 101)
			(return 0)
		else
			(ego use: invDagger 1)
			(Load rsSOUND (GetSongNumber 31))
			(Load rsSOUND (GetSongNumber 29))
			(if param1
				(FaceObject ego param1)
				(= local3 (+ (param1 x?) (param1 targDeltaX?)))
				(= local4 (+ (param1 y?) (param1 targDeltaY?)))
				(= temp0 (- local3 (+ (ego x?) 15)))
				(= temp1 (- local4 (- (ego y?) 40)))
				(while
					(and
						(< 0 local3)
						(< local3 319)
						(< 0 local4)
						(< local4 189)
					)
					(= local3 (+ local3 temp0))
					(= local4 (+ local4 temp1))
				)
				(if
					(not
						(TestSkill skTHROWING 0 (- 50 (/ (ego distanceTo: param1) 5)))
					)
					(if (< local4 0)
						(= local4 (+ local4 (Random 30 100)))
					else
						(= local4 (- local4 (Random 30 100)))
					)
				)
			)
			(if (not param1)
				(UseSkill skTHROWING (/ [skills skAGILITY] 10))
				(= local3 (if (& (ego loop?) $0001) -10 else 330))
				(= local4 (Random 20 80))
			)
			((= newSound (Sound new:))
				number: (GetSongNumber 31)
				priority: 15
				init:
			)
			(= local0 param1)
			((= newAct (Actor new:))
				view: 524
				setLoop: 2
				setCel: 0
				illegalBits: 0
				ignoreActors:
				ignoreHorizon:
				z: 20
				posn: (ego x?) (- (ego y?) 20)
				setStep: 12 8
				init:
				hide:
				setScript: knifeScript 0 param1
			)
			(return 1)
		)
	)
)

(instance knifeScript of Script
	(properties)
	
	(method (doit)
		(asm
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_022b
			pushi    #x
			pushi    0
			send     4
			jmp      code_022d
code_022b:
			lal      local3
code_022d:
			sub     
			sal      local1
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			push    
			lal      local0
			bnt      code_024f
			pushi    #y
			pushi    0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			jmp      code_0251
code_024f:
			lal      local4
code_0251:
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_02ac
			pushi    65521
			lal      local1
			lt?     
			bnt      code_027a
			pprev   
			ldi      15
			lt?     
			bnt      code_027a
			pushi    65521
			lal      local2
			lt?     
			bnt      code_027a
			pprev   
			ldi      15
			lt?     
			bt       code_02a4
code_027a:
			pushi    0
			pushi    #x
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_028b
			pprev   
			ldi      319
			lt?     
code_028b:
			not     
			bt       code_02a4
			pushi    0
			pushi    #y
			pushi    0
			lal      newAct
			send     4
			lt?     
			bnt      code_02a0
			pprev   
			ldi      189
			lt?     
code_02a0:
			not     
			bnt      code_02ac
code_02a4:
			pushi    #cue
			pushi    0
			self     4
			jmp      code_02b2
code_02ac:
			pushi    #doit
			pushi    0
			super    Script,  4
code_02b2:
			ret     
		)
	)
	
	(method (dispose)
		(newSound dispose:)
		(UnlockEgo)
		(if local10
			(register getHurt: (+ 5 (/ [skills skSTRENGTH] 10)))
		)
		(super dispose:)
		(DisposeScript 101)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(ego
					view: 524
					setLoop: (if (& (ego loop?) $0001) 1 else 0)
					cel: 0
					setCycle: CycleTo 9 1 self
				)
				(++ global271)
			)
			(1
				(ego setCycle: EndLoop)
				(newSound play:)
				(client
					x: (if (== (ego loop?) 1)
						(- (ego x?) 15)
					else
						(+ (ego x?) 15)
					)
					show:
					setLoop: (+ (ego loop?) 2)
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(client hide:)
				(if
					(and
						register
						(< -15 local1)
						(< local1 15)
						(< -15 local2)
						(< local2 15)
					)
					(-- global271)
					(++ global272)
					(newSound stop: number: (GetSongNumber 29) play: self)
					(= local10 1)
				else
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(client dispose:)
			)
		)
	)
)
