;;; Sierra Script 1.0 - (do not remove this comment)
(script# 331)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use barLook)
(use InputComparer)
(use LoadMany)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm331 0
	DB 1
	bartender 2
	smoke 3
	barSound 4
	head 5
	trap 6
	crusher 7
	bartenderScript 8
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9 =  1
	local10 =  5
	local11 =  25
)
(procedure (localproc_104c param1)
	(if (GiveSilverCoins param1)
		(HighPrint 331 67)
	else
		(localproc_1067)
	)
)

(procedure (localproc_1067)
	(HighPrint 331 68)
	(HighPrint 331 69)
	(crusher setScript: (ScriptID 337 0))
)

(instance barSound of Sound
	(properties
		number 44
	)
)

(instance rm331 of Room
	(properties
		picture 331
		style $0002
	)
	
	(method (init)
		(Load rsPIC 400)
		(LoadMany 128 331 338 337 336 504)
		(LoadMany 132 (GetSongNumber 43) (GetSongNumber 44))
		(LoadMany 130 339 335 336 337 338 802)
		(Load rsTEXT 257)
		(super init:)
		(gMouseHandler add: self)
		(self setLocales: 801)
		(StatusLine enable:)
		(bartender init:)
		(crusher init:)
		(Bclear 113)
		(cond 
			((>= global134 4)
				(Bset 113)
			)
			((Btest 261)
				(= global134 4)
				(Bset 113)
			)
			((Btest 235)
				(= global134 2)
			)
			((and (Btest 161) (== global134 0))
				(= global134 1)
			)
			(else 
				(Bset 113)
			)
		)
		(if (not (Btest 113)) (curRoom setFeatures: onPaper))
		(curRoom
			setFeatures:
				onButcher
				onBaker
				onGoon
				onTrapDoor
				onTableBottom
				onTableTop
				onStool1
				onStool2
				onStool3
				onKeg1
				onKeg2
				onKeg3
				onFloor
		)
		(Bset 255)
		(Bclear 254)
		(= drinkInHand drinkNOTHING)
		(= drinkOrdered drinkNOTHING)
		(= numberOfAlesDrunk 0)
		(head init: stopUpd: hide:)
		(StopEgo)
		(ego init:)
		(gAddToPics
			add: drag lfTap rtTap ctrStool rtStool guck puddle barb players
			eachElementDo: #init
			doit:
		)
		(if (not (Btest 113)) (paper init: stopUpd:))
		(smoke init: setPri: 4 setCycle: Forward startUpd:)
		(ooze init: setPri: 7 setScript: oozeScript)
		(trap init: setPri: 5 ignoreActors: stopUpd:)
		(DB init: setPri: 9 posn: 159 68 stopUpd:)
		(barSound number: (GetSongNumber 44) init:)
		(switch prevRoomNum
			(330
				(ego posn: 156 188 setMotion: MoveTo 156 175)
			)
			(332
				(ego posn: 120 150 loop: 0)
			)
			(else 
				(Bset 98)
				(ego posn: 156 188 setMotion: MoveTo 156 175)
			)
		)
		(if (not (Btest 98)) (self setScript: rm331Script))
	)
	
	(method (doit)
		(if (> (ego y?) 188) (curRoom newRoom: 330))
		(if (> local5 0) (-- local5))
		(cond 
			(
			(and (ego inRect: 171 140 291 183) (not local3)) (= local3 1) (ego setScript: cardScript))
			(
			(and (not (ego inRect: 171 140 291 183)) local3) (= local3 0) (ego setScript: 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 98)
		(super dispose:)
		(LoadMany 0 335 336 337 338 339)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((!= (pEvent type?) evSAID))
			((Said 'get,lockpick[<up]/note,note')
				(if (ego inRect: 128 106 171 130)
					(if (Btest 113)
						(HighPrint 331 0)
						;There's nothing there.
					else
						(paper hide:)
						(ego get: invPieceOfPaper)
						(Bset 113)
						(= local2 1)
						(++ global134)
						(AddToScore POINTS_PICKUPNOTE 2)
						(HighPrint 331 1)
						;You pick up and read the note.
						(rm331Script changeState: 2)
					)
				else
					(HighPrint 331 2)
					;Where?
				)
			)
			((Said 'look,read/note,note')
				(if local2
					(rm331Script changeState: 2)
				else
					(HighPrint 331 3)
					;You don't have anything like that to look at.
				)
			)
			((Said 'look>') (SaidTavern pEvent))
			((Said 'spit') (HighPrint 331 4))
			((Said 'sat')
				(cond 
					((ego inRect: 192 109 237 130) (TavernLookAtStool 1))
					((ego inRect: 128 106 171 130)
						(if (Btest 254)
							(HighPrint 331 5)
						else
							(ego setScript: (ScriptID 338 0))
						)
					)
					(local0 (HighPrint 331 6))
					(else (HighPrint 331 7))
				)
			)
			((Said 'run,walk,sneak')
				(if (Btest 254)
					(HighPrint 331 8)
				else
					(pEvent claimed: 0)
				)
			)
			(
				(or
					(Said 'get<up,down,off[/barstool,chair]')
					(Said 'stand[<up]')
				)
				(if (Btest 254)
					(cond 
						((and (== drinkInHand drinkNOTHING) (== drinkOrdered drinkNOTHING)) (ego setScript: (ScriptID 338 1)))
						((and (== drinkInHand drinkNOTHING) (> drinkOrdered drinkNOTHING)) (HighPrint 331 9))
						(else (HighPrint 331 10))
					)
				else
					(HighPrint 331 11)
				)
			)
			((Said 'display,made/sign[<thief]')
				(if local1
					(HighPrint 331 12)
				else
					(HighPrint 331 13)
				)
			)
			((Said 'order,buy,ask/drink')
				(if local1
					(if (not (Btest 254))
						(HighPrint 331 14)
					else
						(HighPrint 331 15)
					)
				else
					(HighPrint 331 13)
				)
			)
			((Said '[order,buy,ask]/ale')
				(if local1
					(cond 
						((not (Btest 254)) (HighPrint 331 14))
						((> drinkInHand drinkNOTHING) (HighPrint 331 16))
						(else
							(= drinkOrdered drinkALE)
							(HighPrint 331 17)
							(bartenderScript changeState: 9)
						)
					)
				else
					(HighPrint 331 18)
				)
			)
			((Said '[order,buy,ask]/sweat[<troll]')
				(if local1
					(cond 
						((not (Btest 254)) (HighPrint 331 14))
						((> drinkInHand drinkNOTHING) (HighPrint 331 16))
						(else
							(= drinkOrdered drinkTROLLSWEAT)
							(HighPrint 331 19)
							(bartenderScript changeState: 9)
						)
					)
				else
					(HighPrint 331 20)
				)
			)
			((Said '[order,buy,ask]/breath[<dragon]')
				(if local1
					(cond 
						((not (Btest 254)) (HighPrint 331 14))
						((> drinkInHand drinkNOTHING) (HighPrint 331 16))
						(else
							(= drinkOrdered drinkDRAGONBREATH)
							(HighPrint 331 21)
							(if (GiveSilverCoins local11)
								(HighPrint 331 22)
								(HighPrint 331 23)
								(HighPrint 331 24)
								(bartenderScript changeState: 9)
							else
								(= drinkOrdered drinkNOTHING)
								(HighPrint 331 25)
								(HighPrint 331 26)
							)
						)
					)
				else
					(HighPrint 331 27)
				)
			)
			((Said 'pay')
				(if local1
					(HighPrint 331 28)
				else
					(HighPrint 331 29)
				)
			)
			((Said 'drink>')
				(cond 
					((Said '/ale')
						(switch drinkInHand
							(drinkNOTHING (HighPrint 331 30))
							(drinkALE
								(++ numberOfAlesDrunk)
								(ego setScript: (ScriptID 336 0))
							)
							(else  (HighPrint 331 31))
						)
					)
					((Said '/sweat[<troll]')
						(switch drinkInHand
							(drinkNOTHING (HighPrint 331 30))
							(drinkTROLLSWEAT
								(ego setScript: (ScriptID 336 0))
							)
							(else  (HighPrint 331 32))
						)
					)
					((Said '/breath[<dragon]')
						(switch drinkInHand
							(drinkNOTHING (HighPrint 331 30))
							(drinkDRAGONBREATH
								(ego setScript: (ScriptID 336 0))
							)
							(else  (HighPrint 331 33))
						)
					)
					((Said '[/!*]')
						(switch drinkInHand
							(drinkNOTHING (HighPrint 331 30))
							(drinkALE
								(++ numberOfAlesDrunk)
								(ego setScript: (ScriptID 336 0))
							)
							(else 
								(ego setScript: (ScriptID 336 0))
							)
						)
					)
				)
			)
		)
	)
)

(instance rm331Script of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 
				(= cycles 10)
			)
			(1 
				(TavernLookAround 1 1)
			)
			(2
				(HighPrint 331 34 #draw)
				;You smooth out the piece of paper and read:
				(if (== global134 2)
					(HighPrint 331 35 #draw)
					;"B. - Meet me at the old archery range south of town at noon -- urgent! - B."
				else
					(HighPrint 331 36 #draw)
					;"B. - That new adventurer is getting too nosy.  Deal with him. - B."
					(HighPrint 331 37)
					;Oh, isn't that nice!  Sounds like you're going to be invited to a card game.
				)
			)
		)
	)
)

(instance oozeScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ooze stopUpd:)
				(= cycles (Random 30 90))
			)
			(1
				(= state -1)
				(ooze setCycle: EndLoop self)
			)
		)
	)
)

(instance bartender of Actor
	(properties
		view 336
		loop 2
		illegalBits $0000
	)
	
	(method (init)
		(self posn: 162 80 stopUpd:)
		(self setScript: bartenderScript)
		(super init:)
	)
	
	(method (doit)
		(cond 
			(
			(and (< (ego y?) 113) (not (Btest 254)) (not local0)) (= local0 1) (bartenderScript changeState: 6))
			((and (> (ego y?) 113) local0) (= local0 0) (bartenderScript changeState: 0))
			((or local0 (Btest 254)) (= local1 1))
			((and (not local0) (not (Btest 254))) (= local1 0))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl bartender pEvent 3)
					(HighPrint 331 38)
				)
			)
			(evSAID
				(if local1
					(cond 
						((Said 'affirmative')
							(if (> local5 0)
								(HighPrint 331 39)
								(crusher setScript: (ScriptID 337 0))
							else
								(HighPrint 331 40)
							)
						)
						((Said 'n')
							(if (> local5 0)
								(HighPrint 331 41)
							else
								(HighPrint 331 42)
							)
						)
						((Said 'chat>')
							(cond 
								((Said '/man,bartender') (HighPrint 331 43))
								((Said '/bum,barber') (HighPrint 331 44))
							)
						)
						((Said 'ask>')
							(cond 
								((or (Said '/thief') (Said '/club<thief')) (HighPrint 331 45) (= local5 40))
								((Said '/drink,cost')
									(HighPrint 331 46)
									(HighPrint 331 47)
									(HighPrint 331 48)
								)
								((Said '/sweat[<troll,about]') (HighPrint 331 47))
								((Said '/ale') (HighPrint 331 46))
								((Said '/breath[<dragon,about]') (HighPrint 331 48))
								((Said '/mama,tattoo') (HighPrint 331 49))
								((Said '/bouncer,goon') (HighPrint 331 50))
								((Said '/*') (HighPrint 331 51))
							)
						)
					)
				)
			)
		)
	)
)

(instance cardScript of Script
	(properties)
	
	(method (changeState newState &tmp [temp0 10])
		(switch (= state newState)
			(0 (= cycles (Random 20 40)))
			(1
				(HighPrint (Format @temp0 331 57 (Random 1 1000)))
				(= cycles (Random 10 20))
			)
			(2
				(HighPrint 331 58)
				(self changeState: 0)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'ask>')
						(cond 
							((Said '/fish,trout,south,lake,river,water')
								(if local4
									(HighPrint 331 52)
									(= local4 0)
								else
									(HighPrint 331 53)
									(= local4 1)
								)
							)
							((Said '/*') (HighPrint 331 54))
						)
					)
					(
					(Said 'chat/man,man,butcher,baker,player,gambler') (HighPrint 331 55))
					((Said 'look/card,deck,player,butcher,baker') (HighPrint 331 56))
				)
			)
		)
	)
)

(instance crusher of Actor
	(properties
		view 338
	)
	
	(method (init)
		(super init:)
		(gKeyHandler add: self)
		(self posn: 92 153 stopUpd:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 10])
		(return
			(cond 
				((super handleEvent: pEvent))
				((not (ego inRect: 0 125 140 170)))
				(
					(EventEqualsString
						pEvent
						(Format @temp0 257 thievesGuildPassword)
					)
					(if (and (not [skills skSTEALTH]) (not [skills skLOCKPICKING]))
						(HighPrint 331 59)
						(self setScript: (ScriptID 337 0))
					else
						(self setScript: (ScriptID 337 1))
					)
				)
				((!= (pEvent type?) evSAID))
				((Said 'display,made/sign[<thief]') (HighPrint 331 60))
				((Said 'ask/thief,club') (HighPrint 331 61) (self setScript: (ScriptID 337 0)))
				((Said '[say,gave,use]/password') (HighPrint 331 62))
				((Said '[say]/swordfish') (HighPrint 331 63) (self setScript: (ScriptID 337 0)))
				(
				(or (Said 'chat/man,goon,bouncer') (Said 'ask/*'))
					(switch local6
						(0 (HighPrint 331 64))
						(1 (HighPrint 331 65))
						(2
							(HighPrint 331 66)
							(self setScript: (ScriptID 337 0))
						)
					)
					(++ local6)
				)
			)
		)
	)
)

(instance bartenderScript of Script
	(properties)
	
	(method (doit)
		(cond 
			((> local7 1)
				(-- local7)
				(if local8
					((ScriptID 331 2)
						posn: ((ScriptID 331 2) x?) (- ((ScriptID 331 2) y?) 2)
					)
				else
					((ScriptID 331 2)
						posn: ((ScriptID 331 2) x?) (+ ((ScriptID 331 2) y?) 2)
					)
				)
			)
			((== local7 1)
				(= local7 0)
				(self cue:)
				(if local8 (= local8 0) else (= local8 1))
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (Random 20 80)))
			(1
				(= cycles 0)
				((ScriptID 331 2)
					setCycle: Walk
					loop: 0
					setMotion: MoveTo 195 80 self
				)
			)
			(2
				((ScriptID 331 2) loop: (Random 2 3) stopUpd:)
				(= cycles (Random 50 100))
			)
			(3
				((ScriptID 331 2)
					loop: 1
					cel: -1
					setMotion: MoveTo 124 80 self
				)
			)
			(4
				((ScriptID 331 2) loop: (Random 2 3) stopUpd:)
				(= cycles (Random 50 100))
			)
			(5 (self changeState: 1))
			(6
				(= cycles 0)
				(LockEgo)
				(if (> ((ScriptID 331 2) distanceTo: ego) 15)
					((ScriptID 331 2)
						loop: (if (< (ego x?) ((ScriptID 331 2) x?)) 1 else 0)
						cel: -1
						setMotion:
							MoveTo
							(if (Btest 254) (+ (ego x?) 20) else (ego x?))
							80
							self
					)
				else
					(self cue:)
				)
			)
			(7
				((ScriptID 331 2) loop: 2 stopUpd:)
				(if (Btest 254) ((ScriptID 331 5) setCel: 2))
				(= cycles 2)
			)
			(8
				(HighPrint 331 70 83)
				(if (Btest 254) (User canInput: 1) else (UnlockEgo))
			)
			(9
				(if (== (ego loop?) 3)
					(ego loop: 2 cel: 0 stopUpd:)
					((ScriptID 331 5) show:)
				)
				(switch drinkOrdered
					(drinkTROLLSWEAT
						((ScriptID 331 2)
							setLoop: (if (Btest 255) 1 else 6)
							setCycle: Walk
							setMotion: MoveTo 124 80 self
						)
					)
					(else 
						((ScriptID 331 2)
							setLoop: (if (Btest 255) 0 else 5)
							setCycle: Walk
							setMotion: MoveTo 195 80 self
						)
					)
				)
			)
			(10
				(Bclear 255)
				((ScriptID 331 2) setLoop: 4 cel: 0 setPri: 5)
				(= local7 7)
			)
			(11
				((ScriptID 331 2) cel: 1)
				(= local7 8)
			)
			(12
				(switch drinkOrdered
					(drinkALE (self cue:))
					(drinkTROLLSWEAT (self cue:))
					(drinkDRAGONBREATH
						((ScriptID 331 1) setScript: (ScriptID 335 0))
					)
				)
			)
			(13
				((ScriptID 331 2)
					posn: (if (== drinkOrdered drinkTROLLSWEAT) 124 else 195) 80
					setLoop: (if (== drinkOrdered drinkTROLLSWEAT) 6 else 5)
					cel: 0
				)
				(= cycles 2)
			)
			(14
				((ScriptID 331 2) setLoop: 3)
				(= cycles 20)
			)
			(15
				((ScriptID 331 2)
					setLoop: (if (== drinkOrdered drinkTROLLSWEAT) 5 else 6)
					setPri: -1
					setMotion:
						MoveTo
						(if (== drinkOrdered drinkTROLLSWEAT)
							(+ (ego x?) 10)
						else
							(+ (ego x?) 20)
						)
						80
						self
				)
			)
			(16
				((ScriptID 331 2)
					setLoop: (if (== drinkOrdered drinkTROLLSWEAT) 0 else 1)
					cel: 0
				)
				(HighPrint 331 71)
				(if (< drinkOrdered drinkDRAGONBREATH)
					(switch drinkOrdered
						(drinkALE (localproc_104c local9))
						(drinkTROLLSWEAT (localproc_104c local10))
					)
				)
				(= drinkInHand drinkOrdered)
				(= drinkOrdered drinkNOTHING)
				(= cycles 5)
			)
			(17
				(if (Btest 254)
					(ego loop: 3 cel: 0)
					((ScriptID 331 5) hide:)
				)
				((ScriptID 331 2)
					setLoop: -1
					setMotion: MoveTo 180 80 self
				)
			)
			(18
				((ScriptID 331 2) loop: 2 stopUpd:)
			)
		)
	)
)

(instance drag of PicView
	(properties
		y 56
		x 160
		view 331
	)
)

(instance lfTap of PicView
	(properties
		y 72
		x 125
		view 331
		cel 1
	)
)

(instance rtTap of PicView
	(properties
		y 72
		x 195
		view 331
		cel 1
	)
)

(instance ctrStool of PicView
	(properties
		y 111
		x 149
		view 331
		loop 3
	)
)

(instance rtStool of PicView
	(properties
		y 113
		x 216
		view 331
		loop 3
	)
)

(instance guck of PicView
	(properties
		y 89
		x 214
		view 331
		loop 3
		cel 3
		priority 8
	)
)

(instance puddle of PicView
	(properties
		y 116
		x 222
		view 331
		loop 3
		cel 2
	)
)

(instance barb of PicView
	(properties
		y 113
		x 108
		view 331
		loop 3
		cel 1
	)
)

(instance players of PicView
	(properties
		y 172
		x 224
		view 331
		loop 5
	)
)

(instance paper of View
	(properties
		y 111
		x 145
		view 331
		cel 3
	)
)

(instance smoke of Prop
	(properties
		y 45
		x 160
		view 331
		loop 1
		cycleSpeed 1
	)
)

(instance ooze of Prop
	(properties
		y 91
		x 222
		view 331
		loop 4
		cycleSpeed 2
	)
)

(instance trap of Prop
	(properties
		y 155
		x 92
		view 331
		loop 2
		cycleSpeed 2
	)
)

(instance DB of Prop
	(properties
		view 337
		loop 3
		cel 12
		cycleSpeed 1
	)
)

(instance head of View
	(properties
		y 73
		x 150
		view 504
		loop 2
		cel 3
	)
)

(instance onPaper of RFeature
	(properties
		nsTop 108
		nsLeft 141
		nsBottom 113
		nsRight 148
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPaper pEvent 3) (HighPrint 331 72))
		)
	)
)

(instance onButcher of RFeature
	(properties
		nsTop 126
		nsLeft 197
		nsBottom 144
		nsRight 215
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onButcher pEvent 3) (if (Btest 254) (head setCel: 2)) (HighPrint 331 73))
		)
	)
)

(instance onBaker of RFeature
	(properties
		nsTop 117
		nsLeft 238
		nsBottom 145
		nsRight 252
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBaker pEvent 3) (if (Btest 254) (head setCel: 2)) (HighPrint 331 74))
		)
	)
)

(instance onGoon of RFeature
	(properties
		nsTop 108
		nsLeft 75
		nsBottom 140
		nsRight 93
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onGoon pEvent 3) (HighPrint 331 75))
		)
	)
)

(instance onTableTop of RFeature
	(properties
		nsTop 146
		nsLeft 196
		nsBottom 156
		nsRight 247
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTableTop pEvent 3) (HighPrint 331 76))
		)
	)
)

(instance onTrapDoor of RFeature
	(properties
		nsTop 139
		nsLeft 65
		nsBottom 155
		nsRight 96
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTrapDoor pEvent 3) (HighPrint 331 77))
		)
	)
)

(instance onTableBottom of RFeature
	(properties
		nsTop 163
		nsLeft 209
		nsBottom 170
		nsRight 237
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTableBottom pEvent 3) (HighPrint 331 78))
		)
	)
)

(instance onStool1 of RFeature
	(properties
		nsTop 70
		nsLeft 101
		nsBottom 106
		nsRight 113
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStool1 pEvent 3) (if (Btest 254) (head setCel: 1)) (HighPrint 331 79))
		)
	)
)

(instance onStool2 of RFeature
	(properties
		nsTop 85
		nsLeft 142
		nsBottom 107
		nsRight 152
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStool2 pEvent 3)
				(if (Btest 254)
					(HighPrint 331 80)
				else
					(HighPrint 331 7)
				)
			)
		)
	)
)

(instance onStool3 of RFeature
	(properties
		nsTop 87
		nsLeft 210
		nsBottom 116
		nsRight 226
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStool3 pEvent 3) (HighPrint 331 81))
		)
	)
)

(instance onKeg1 of RFeature
	(properties
		nsTop 42
		nsLeft 114
		nsBottom 76
		nsRight 136
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg1 pEvent 3) (HighPrint 331 82))
		)
	)
)

(instance onKeg2 of RFeature
	(properties
		nsTop 12
		nsLeft 140
		nsBottom 76
		nsRight 175
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg2 pEvent 3) (HighPrint 331 83))
		)
	)
)

(instance onKeg3 of RFeature
	(properties
		nsTop 43
		nsLeft 180
		nsBottom 76
		nsRight 208
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg3 pEvent 3) (HighPrint 331 84))
		)
	)
)

(instance onFloor of RFeature
	(properties
		nsTop 116
		nsLeft 106
		nsBottom 172
		nsRight 189
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFloor pEvent 3) (HighPrint 331 85))
		)
	)
)
