;;; Sierra Script 1.0 - (do not remove this comment)
(script# 310)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Door)
(use GControl)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm310 0
)

(local
	newDoor
	newProp_2
	local2
	newDoor_2
	newProp
	local5
	local6
	local7
)
(procedure (localproc_000c param1 param2)
	(if (or (!= local5 param1) (!= local6 param2))
		(= local5 param1)
		(= local6 param2)
		(newProp posn: param1 param2)
	)
)

(instance rm310 of Room
	(properties
		picture 310
		style $0002
	)
	
	(method (init)
		(if (and (>= timeZone TIME_SUNSET) [skills skLOCKPICKING])
			(Load rsSOUND (GetSongNumber 35))
		)
		(Load rsSOUND (GetSongNumber 46))
		(Load rsSOUND (GetSongNumber 28))
		(Load rsVIEW 310)
		(Load rsVIEW 515)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(StopEgo)
		(ego
			illegalBits: (if (> timeZone TIME_SUNSET) cWHITE else (& cWHITE cLCYAN))
			init:
		)
		(flameSound number: (GetSongNumber 46) init:)
		(teleport number: (GetSongNumber 28) init:)
		(= local5 252)
		(= local6 52)
		((= newProp (Prop new:))
			view: 310
			loop: 3
			posn: local5 local6
			init:
			setPri: 10
		)
		((View new:)
			view: 310
			loop: 4
			cel: 0
			posn: 252 25
			setPri: 6
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 310
			loop: 7
			cel: 0
			posn: 35 43
			init:
			stopUpd:
			addToPic:
		)
		(flames init:)
		(if (< timeZone TIME_SUNSET)
			(LOL init: cycleSpeed: 10 setCycle: Forward startUpd:)
		)
		(= newProp_2 (Prop new:))
		(newProp_2
			view: 310
			loop: 0
			cel: (if (== prevRoomNum 314)
				(- (NumCels newProp_2) 1)
			else
				0
			)
			posn: 253 114
			init:
			ignoreActors:
			stopUpd:
			setPri: 8
			cycleSpeed: 2
		)
		((= newDoor (Door new:))
			view: 310
			loop: 1
			posn: 137 38
			doorControl: cYELLOW
			entranceTo: 313
			locked: 1
			facingLoop: 3
			setPri: 5
			init:
		)
		((= newDoor_2 (Door new:))
			view: 310
			loop: 2
			posn: 6 148
			doorControl: cLRED
			entranceTo: 311
			facingLoop: 1
			setPri: 9
			illegalBits: 0
			locked: (if isNightTime 1 else 0)
			init:
		)
		(switch prevRoomNum
			(0
				(ego posn: 318 177 setMotion: MoveTo 305 170)
			)
			(300
				(ego posn: 318 177 setMotion: MoveTo 305 170)
			)
			(311
				(ego posn: 35 141 loop: 0)
				(newDoor_2 close:)
			)
			(313
				(ego posn: 154 91)
				(newDoor close:)
			)
			(314
				(teleport play:)
				(ego posn: 252 119)
				(newProp_2
					setCel: (- (NumCels newProp_2) 1)
					setCycle: BegLoop
				)
			)
			(SYSTEM
				(ego
					view: 515
					setLoop: 3
					cel: 5
					init:
					setScript: egoWakes
				)
			)
		)
	)
	
	(method (doit &tmp egoX egoY temp2 temp3)
		(super doit:)
		(cond 
			((> (ego x?) 318) 
				(= global113 0)
				(curRoom newRoom: 300)
			)
			(
				(and
					(== (ego onControl: origin) cLMAGENTA)
					(not local2)
					(== (ego loop?) 3)
				)
				(= local2 1)
				(newProp_2 setScript: magicDoorScript)
			)
		)
		(= egoX (ego x?))
		(= egoY (ego y?))
		(= temp2 local5)
		(= temp3 local6)
		(cond 
			((<= egoY 125) (= temp3 54))
			((<= egoY 140) (= temp3 53))
			(else (= temp3 52))
		)
		(cond 
			((<= egoX 160) (= temp2 246) (= temp3 52))
			((<= egoX 200) (= temp2 248) (= temp3 52))
			((<= egoX 240) (= temp2 250))
			((<= egoX 270) (= temp2 252))
			((<= egoX 290) (= temp2 254))
			(else (= temp2 256))
		)
		(localproc_000c temp2 temp3)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 90)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'look/lol,female') (HighPrint 310 4))
			((Said 'look/hasp')
				(cond 
					((== (ego onControl: origin) cLMAGENTA) (HighPrint 310 5))
					((== (ego onControl: origin) cYELLOW) (HighPrint 310 6))
					(else (PrintNotCloseEnough))
				)
			)
			((Said 'knock,open/door')
				(cond 
					(
						(and
							(== (ego onControl: origin) cLMAGENTA)
							(not local2)
							(!= (ego loop?) 3)
						)
						(HighPrint 310 7)
					)
					((== (ego onControl: origin) cYELLOW)
						(if (< timeZone TIME_SUNSET)
							(HighPrint 310 8)
						else
							(HighPrint 310 9)
						)
					)
					((== (ego onControl: origin) cLRED)
						(if isNightTime
							(HighPrint 310 10)
						else
							(HighPrint 310 7)
						)
					)
					(else (pEvent claimed: 0))
				)
			)
			(
			(Said 'look[<at,around][/!*,hamlet,street,building]') (HighPrint 310 11))
			(
				(or
					(IsObjectOnControl newProp_2 pEvent 3)
					(Said 'look/shop,shop[<magic]')
				)
				(HighPrint 310 12)
			)
			(
				(or
					(IsObjectOnControl newDoor pEvent 3)
					(Said 'look/house[<lol,female]')
				)
				(HighPrint 310 13)
			)
			(
				(or
					(IsObjectOnControl newDoor_2 pEvent 3)
					(Said 'look/hall[<club]')
				)
				(if isNightTime
					(HighPrint 310 14)
				else
					(HighPrint 310 15)
				)
			)
			((Said 'look/fence') (HighPrint 310 16))
			(
				(or
					(IsObjectOnControl onEye pEvent 3)
					(Said 'look/eye')
				)
				(HighPrint 310 17)
			)
			((IsObjectOnControl onMagicSign pEvent 3) (HighPrint 310 18))
			((IsObjectOnControl onGuildSign pEvent 3) (HighPrint 310 19))
			((Said 'look/sign')
				(if (> (ego x?) 200)
					(HighPrint 310 18)
				else
					(HighPrint 310 19)
				)
			)
			(
				(or
					(and
						(not (IsObjectOnControl onMagicSign pEvent 3))
						(IsObjectOnControl flames pEvent 3)
					)
					(Said 'look/flame')
				)
				(if (> (flameScript state?) 0)
					(HighPrint 310 20)
				else
					(HighPrint 310 21)
				)
			)
		)
	)
	
	(method (notify param1)
		(cond 
			((!= param1 1))
			((not (newDoor locked?)) (HighPrint 310 0))
			((not (TestSkill skLOCKPICKING 30 lockPickBonus)) (HighPrint 310 1))
			((and (Btest 92) (< dayLOLBarredDoor currentDay)) (HighPrint 310 2))
			(else
				(lockSound number: (GetSongNumber 35) init: play:)
				(HighPrint 310 3)
				(newDoor facingLoop: (ego loop?) locked: 0)
			)
		)
	)
)

(instance magicDoorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(teleport play:)
				(newProp_2 setCycle: EndLoop self)
			)
			(1
				(ego illegalBits: 0 setMotion: MoveTo 254 108 self)
			)
			(2 (curRoom newRoom: 314))
		)
	)
)

(instance flames of Prop
	(properties
		y 34
		x 253
		view 310
		loop 5
		cycleSpeed 2
	)
	
	(method (init)
		(super init: &rest)
		(self setScript: flameScript)
	)
)

(instance flameScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client stopUpd:)
				(= register (Random 1 3))
				(= cycles (Random 60 150))
			)
			(1
				(client setCycle: EndLoop self)
				(= cycles 3)
			)
			(2 (flameSound loop: 1 play:))
			(3
				(if (-- register)
					(self changeState: 1)
				else
					(self changeState: 0)
				)
			)
		)
	)
)

(instance onMagicSign of RFeature
	(properties
		nsTop 1
		nsLeft 216
		nsBottom 19
		nsRight 280
	)
)

(instance onGuildSign of RFeature
	(properties
		nsTop 22
		nsLeft 3
		nsBottom 38
		nsRight 71
	)
)

(instance onEye of RFeature
	(properties
		nsTop 44
		nsLeft 234
		nsBottom 59
		nsRight 269
	)
)

(instance lockSound of Sound
	(properties
		number 35
	)
)

(instance flameSound of Sound
	(properties
		priority 10
	)
)

(instance teleport of Sound
	(properties
		priority 12
	)
)

(instance egoWakes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setCycle: BegLoop self)
			)
			(1
				(StopEgo)
				(HighPrint 310 22)
				(= [invNum invSilverCoin] 0)
				(= [invNum invGoldCoin] 0)
				(UnlockEgo)
			)
		)
	)
)

(instance LOL of Prop
	(properties
		y 125
		x 167
		view 310
		loop 6
	)
	
	(method (handleEvent pEvent)
		(cond 
			(
				(or
					(IsObjectOnControl LOL pEvent 3)
					(Said 'look/lol,female')
				)
				(HighPrint 310 23)
			)
			((Said 'look/rocker,chair') (HighPrint 310 24))
			((Said 'awaken/lol,female') (HighPrint 310 25))
			((Said 'ask,chat')
				(HighPrint 310 26)
				(HighPrint 310 27)
				(HighPrint 310 26)
			)
			(
				(or
					(IsObjectOnControl newDoor pEvent 3)
					(Said 'look/house[<lol,female]')
				)
				(HighPrint 310 28)
			)
		)
	)
)
