;;; Sierra Script 1.0 - (do not remove this comment)
(script# 322)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm322 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
)
(procedure (localproc_000c param1 param2 &tmp temp0)
	(if (and (== param1 invChainmailArmor) (ego has: invLeatherArmor))
		(= param2 (- param2 50))
	)
	(if (GiveSilverCoins param2)
		(= temp0 (if (== param1 invFoodRation) 5 else 1))
		(if (== param1 invChainmailArmor)
			(if (ego has: invLeatherArmor) (HighPrint 322 0) (ego use: invLeatherArmor))
			(if (== heroType CLASS_FIGHTER) (AddToScore POINTS_BUYCHAINMAIL 3))
		)
		(ego get: param1 temp0)
		(Bset 120)
		(HighPrint 322 1)
	else
		(HighPrint 322 2)
	)
)

(instance rm322 of Room
	(properties
		picture 322
		style $0002
		south 320
	)
	
	(method (init)
		(Load rsVIEW 322)
		(super init:)
		(gMouseHandler add: self)
		(self
			setFeatures:
				onKeg1
				onKeg2
				onKeg3
				onKeg4
				onStove
				onFlask
				onShield
				onTeaPot
				onEggs
				onLinen
				onFlour
				onPigsFeet
				onBeets
				onTea2
				onSalt
				onSugar
				onSaltPork
				onPepper
				onHoney
		)
		(self setLocales: 801)
		(StatusLine enable:)
		(proprietor init:)
		(StopEgo)
		(ego posn: 163 188 init: setMotion: MoveTo 163 170)
		((View new:)
			view: 322
			loop: 0
			cel: 0
			posn: 84 141
			init:
			setPri: 9
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 2
			posn: 94 97
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 0
			posn: 232 141
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 0
			posn: 244 146
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 0
			posn: 239 123
			setPri: 11
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 3
			cel: 1
			posn: 68 159
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 0
			posn: 107 94
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 1
			posn: 113 94
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 1
			posn: 213 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 1
			posn: 205 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 2
			posn: 200 109
			init:
			setPri: 9
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 3
			posn: 123 94
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 4
			posn: 133 81
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 4
			posn: 130 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 4
			posn: 137 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 5
			posn: 133 109
			init:
			setPri: 9
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 5
			posn: 144 109
			init:
			setPri: 9
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 5
			posn: 115 70
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 5
			posn: 129 70
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 6
			posn: 109 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 6
			posn: 166 69
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 6
			posn: 158 70
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 6
			posn: 152 69
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 7
			posn: 119 82
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 8
			posn: 194 94
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 8
			posn: 207 94
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 9
			posn: 207 69
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 9
			posn: 184 69
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 322
			loop: 2
			cel: 10
			posn: 197 70
			init:
			stopUpd:
			addToPic:
		)
	)
	
	(method (doit)
		(cond 
			((and (< (ego y?) 140) (not local0)) (= local0 1))
			((and (> (ego y?) 140) local0)
				(= local0 0)
				(if local2 (= local2 0))
				(if (and local1 local3)
					(proprietor setCycle: BegLoop)
					(= local3 0)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset 96)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'deposit/*') (HighPrint 322 3))
					((Said 'look>')
						(cond 
							((Said '[<at,around][/!*,room,building,shop]') (HighPrint 322 4))
							((Said '/stove,coal') (HighPrint 322 5))
							((Said '/man,shopkeeper,keeper,owner,kaspar') (HighPrint 322 6))
							((Said '/barrel') (HighPrint 322 7))
							((Said '/can,(drygoods<canned)') (HighPrint 322 8))
							((Said '<behind/counter')
								(if local0
									(HighPrint 322 9)
								else
									(HighPrint 322 10)
								)
							)
							((Said '/counter,shelf,item,drygoods') (HighPrint 322 11))
							(
							(Said '/armor,leather,chain,chainmail,chainmail') (HighPrint 322 12))
							((Said '/odd,end,stuff,item') (HighPrint 322 13))
							((Said '/equipment') (HighPrint 322 14))
						)
					)
				)
			)
		)
	)
)

(instance proprietor of Actor
	(properties
		view 322
		loop 4
		illegalBits $0000
	)
	
	(method (init)
		(self posn: 172 112)
		(self setScript: proprietorScript)
		(super init:)
	)
	
	(method (doit)
		(if (and local0 local1 (not local3))
			(self setCycle: EndLoop)
			(= local3 1)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (IsObjectOnControl self pEvent 3)
					(HighPrint 322 6)
				)
			)
			(evSAID
				(cond 
					((Said 'affirmative')
						(if local2
							(proprietorScript changeState: 3)
						else
							(HighPrint 322 15)
						)
					)
					((Said 'n')
						(if local2
							(proprietorScript changeState: 4)
						else
							(HighPrint 322 15)
						)
					)
					((Said '/hello')
						(if (and (not local1) local0)
							(proprietorScript cue:)
						else
							(HighPrint 322 16)
						)
					)
					((Said 'chat/man') (HighPrint 322 17))
					((or (Said 'chat>') (Said 'ask>'))
						(cond 
							((and (not local1) local0) (proprietorScript cue:) (pEvent claimed: 1))
							((not local0) (HighPrint 322 16) (pEvent claimed: 1))
							(else
								(= local6 1)
								(cond 
									((Said '/weapon,equipment') (HighPrint 322 18) (HighPrint 322 19))
									((Said '/armor,chain,chainmail,chainmail') (HighPrint 322 20))
									((Said '/dagger,dagger') (HighPrint 322 21))
									((Said '/food,ration,breakfast') (HighPrint 322 22))
									((Said '/ale,ale,wine') (HighPrint 322 23))
									((Said '/bottle') (HighPrint 322 24))
									((Said '/book') (HighPrint 322 25))
									(
										(Said
											'/pig,feet,broom,hoe,handle,pan,teapot,egg,cheesecloth,flour,bag,tea,salt,pepper,honey,honey,beet,sauerkraut,saurus,drygoods'
										)
										(= local6 0)
										(HighPrint 322 26)
									)
									((Said '/meisterson,otto,goon') (HighPrint 322 27))
									((Said '/man,shopkeeper,kaspar') (HighPrint 322 28))
									((Said '/filly') (HighPrint 322 29))
									(
										(or
											(Said
												'/bandit,baron,barnard,female,zara,ermit,baba,barnard,elsa,hamlet'
											)
											(Said
												'/erasmus,erana,monster,brauggi,giant,meep,healer,bouncer,master,ermit'
											)
										)
										(HighPrint 322 30)
									)
									((Said '/food,drygoods') (HighPrint 322 31))
									(else
										(= local6 0)
										(pEvent claimed: 1)
										(HighPrint 322 32)
										(HighPrint 322 33)
									)
								)
								(if local6 (AddToScore POINTS_TALKTOSHOPKEEPER 1))
							)
						)
					)
					((Said 'buy,get>')
						(cond 
							((not local1) (pEvent claimed: 1) (proprietorScript cue:))
							((Said '/bottle') (= local4 invEmptyFlask) (= local5 2))
							((Said '/food,ration,breakfast') (= local4 invFoodRation) (= local5 5))
							((Said '/dagger') (= local4 invDagger) (= local5 20))
							((Said '/armor,chain,chainmail,chainmail') (= local4 invChainmailArmor) (= local5 500))
							(else (pEvent claimed: 1) (= local4 (= local5 0)))
						)
						(cond 
							((not local1) (pEvent claimed: 1) (proprietorScript cue:))
							(local4 (localproc_000c local4 local5))
							(else (pEvent claimed: 1) (HighPrint 322 34))
						)
					)
				)
			)
		)
	)
)

(instance proprietorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(proprietor cycleSpeed: 1 stopUpd:)
			)
			(1
				(proprietor setCycle: EndLoop self)
				(= local3 1)
			)
			(2
				(HighPrint 322 35)
				(cond 
					((Btest 120) (HighPrint 322 36))
					((Btest 119) (HighPrint 322 37))
					(else (HighPrint 322 38) (HighPrint 322 39))
				)
				(= local1 1)
				(= local2 1)
				(Bset 119)
			)
			(3
				(= local2 0)
				(HighPrint 322 40)
				(HighPrint 322 41)
				(if local4
					(localproc_000c local4 local5)
				else
					(HighPrint 322 42)
				)
			)
			(4
				(= local2 0)
				(HighPrint 322 43)
			)
		)
	)
)

(instance onKeg1 of RFeature
	(properties
		nsTop 120
		nsLeft 61
		nsBottom 154
		nsRight 75
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg1 pEvent 3) (HighPrint 322 44))
		)
	)
)

(instance onKeg2 of RFeature
	(properties
		nsTop 121
		nsLeft 223
		nsBottom 141
		nsRight 234
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg2 pEvent 3) (HighPrint 322 7))
		)
	)
)

(instance onKeg3 of RFeature
	(properties
		nsTop 123
		nsLeft 235
		nsBottom 145
		nsRight 251
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg3 pEvent 3) (HighPrint 322 7))
		)
	)
)

(instance onKeg4 of RFeature
	(properties
		nsTop 99
		nsLeft 230
		nsBottom 120
		nsRight 246
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onKeg4 pEvent 3) (HighPrint 322 7))
		)
	)
)

(instance onStove of RFeature
	(properties
		nsTop 112
		nsLeft 76
		nsBottom 141
		nsRight 93
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onStove pEvent 3) (HighPrint 322 5))
		)
	)
)

(instance onFlask of RFeature
	(properties
		nsTop 86
		nsLeft 187
		nsBottom 95
		nsRight 210
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFlask pEvent 3) (HighPrint 322 45))
		)
	)
)

(instance onShield of RFeature
	(properties
		nsTop 81
		nsLeft 89
		nsBottom 95
		nsRight 97
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onShield pEvent 3) (HighPrint 322 46))
		)
	)
)

(instance onTeaPot of RFeature
	(properties
		nsTop 103
		nsLeft 194
		nsBottom 110
		nsRight 207
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTeaPot pEvent 3) (HighPrint 322 47))
		)
	)
)

(instance onEggs of RFeature
	(properties
		nsTop 102
		nsLeft 128
		nsBottom 110
		nsRight 148
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onEggs pEvent 3) (HighPrint 322 48))
		)
	)
)

(instance onLinen of RFeature
	(properties
		nsTop 63
		nsLeft 175
		nsBottom 71
		nsRight 215
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onLinen pEvent 3) (HighPrint 322 49))
		)
	)
)

(instance onFlour of RFeature
	(properties
		nsTop 61
		nsLeft 148
		nsBottom 70
		nsRight 170
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onFlour pEvent 3) (HighPrint 322 50))
		)
	)
)

(instance onPigsFeet of RFeature
	(properties
		nsTop 63
		nsLeft 109
		nsBottom 70
		nsRight 132
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPigsFeet pEvent 3) (HighPrint 322 51))
		)
	)
)

(instance onBeets of RFeature
	(properties
		nsTop 74
		nsLeft 201
		nsBottom 83
		nsRight 216
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onBeets pEvent 3) (HighPrint 322 52))
		)
	)
)

(instance onTea2 of RFeature
	(properties
		nsTop 86
		nsLeft 109
		nsBottom 94
		nsRight 115
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onTea2 pEvent 3) (HighPrint 322 53))
		)
	)
)

(instance onSalt of RFeature
	(properties
		nsTop 74
		nsLeft 104
		nsBottom 83
		nsRight 112
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSalt pEvent 3) (HighPrint 322 54))
		)
	)
)

(instance onSugar of RFeature
	(properties
		nsTop 74
		nsLeft 113
		nsBottom 83
		nsRight 123
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSugar pEvent 3) (HighPrint 322 55))
		)
	)
)

(instance onSaltPork of RFeature
	(properties
		nsTop 74
		nsLeft 124
		nsBottom 83
		nsRight 139
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onSaltPork pEvent 3) (HighPrint 322 56))
		)
	)
)

(instance onPepper of RFeature
	(properties
		nsTop 87
		nsLeft 104
		nsBottom 94
		nsRight 109
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onPepper pEvent 3) (HighPrint 322 57))
		)
	)
)

(instance onHoney of RFeature
	(properties
		nsTop 87
		nsLeft 116
		nsBottom 94
		nsRight 127
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((IsObjectOnControl onHoney pEvent 3) (HighPrint 322 58))
		)
	)
)
