;;; Sierra Script 1.0 - (do not remove this comment)
(script# 88)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm88 0
)

(local
	local0
	local1
	local2
	[local3 4]
	local7
	local8
	local9
	[local10 4]
)
(instance magicHit of Sound
	(properties
		number 45
		priority 1
	)
)

(instance egoShoots of Sound
	(properties
		number 33
		priority 2
	)
)

(instance rm88 of Room
	(properties
		picture 88
		style $0002
		east 89
	)
	
	(method (init)
		(super init:)
		(pile init: addToPic:)
		(drip init: setScript: dripScript)
		(= local9 (Random 0 5))
		(= [local7 0] 36)
		(= [local8 0] 133)
		(= [local7 1] 94)
		(= [local8 1] 146)
		(= [local7 2] 135)
		(= [local8 2] 158)
		(= [local7 3] 212)
		(= [local8 3] 160)
		(= [local7 4] 292)
		(= [local8 4] 161)
		(= [local7 5] 67)
		(= [local8 5] 153)
		(StatusLine enable:)
		(StopEgo)
		(ego init:)
		(if
			(==
				(= local0
					(cond 
						((Btest 250)
							(troll
								view: 451
								posn: 80 158
								setLoop: 0
								setCel: 10
								init:
								addToPic:
							)
							4
						)
						((Btest 251) 0)
						(else 1)
					)
				)
				1
			)
			(Load rsVIEW 450)
			(Load rsSCRIPT CHASE)
			(if (ego knows: skFLAMEDART)
				(Load rsVIEW 522)
				(Load rsSOUND (GetSongNumber 33))
				(Load rsSOUND (GetSongNumber 45))
				(egoShoots number: (GetSongNumber 33) init:)
				(magicHit number: (GetSongNumber 45) init:)
			)
		)
		(switch prevRoomNum
			(450
				(ego posn: 135 160 loop: 1)
				(= global332 0)
				(self setScript: trollDies)
			)
			(else 
				(ego posn: 318 150 setMotion: MoveTo 255 150)
				(if (not (Btest 78)) (HighPrint 88 0))
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(if (< (ego x?) 140)
			(switch local0
				(1 (self setScript: trollOut))
			)
		)
	)
	
	(method (dispose)
		(Bset 78)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '/down,ground,floor,stalactite') (HighPrint 88 1))
							((Said '/up,ceiling,stalagmite') (HighPrint 88 2))
							((Said '[<at,around][/!*,cave,room]') (HighPrint 88 0))
							((Said '/water') (HighPrint 88 3))
							((Said '/collection,item,bone,armor') (HighPrint 88 4))
							((Said '/troll,monster,creature')
								(switch local0
									(2 (HighPrint 88 5))
									(3 (HighPrint 88 6))
									(4 (HighPrint 88 7))
									(else  (HighPrint 88 8))
								)
							)
							((Said '/north,west,south,east') (HighPrint 88 9))
							((Said '/boulder') (HighPrint 88 10))
							((Said '/fungus') (HighPrint 88 11))
							((Said '/entrance,open') (HighPrint 88 12))
						)
					)
					((Said 'throw/') (HighPrint 88 13))
					((Said 'search/troll,monster,creature')
						(cond 
							((!= local0 4) (HighPrint 88 14))
							((ego inRect: 64 144 106 165) (= local2 0) (self setScript: egoSearch))
							(else (HighPrint 88 15))
						)
					)
					((Said 'hiden') (HighPrint 88 16))
					(
						(Said
							'get,search/collection,junk,item,collection,silver,gold,loot'
						)
						(if (ego inRect: 39 150 106 157)
							(= local2 1)
							(self setScript: egoSearch)
						else
							(HighPrint 88 17)
						)
					)
					((Said 'get,get>')
						(cond 
							((Said '/hair,beard')
								(cond 
									((!= local0 4) (HighPrint 88 14))
									((ego inRect: 64 144 106 165) (= local2 2) (self setScript: egoSearch))
									(else (HighPrint 88 15))
								)
							)
							((Said '/club,weapon')
								(cond 
									((== local0 2) (HighPrint 88 18))
									((!= local0 4) (HighPrint 88 14))
									(else (HighPrint 88 19))
								)
							)
							((Said '/fungus') (HighPrint 88 20))
							((Said '/troll,stalactite,stalagmite') (HighPrint 88 18))
							((Said '/boulder,water') (HighPrint 88 21))
						)
					)
					((Said 'feed/troll,monster,creature')
						(if (== local0 2)
							(HighPrint 88 22)
						else
							(HighPrint 88 14)
						)
					)
					((Said 'listen/')
						(if (or (== local0 0) (== local0 4))
							(HighPrint 88 23)
						else
							(HighPrint 88 24)
						)
					)
					((Said 'cast>')
						(= temp0 (SaidCast pEvent))
						(if (CastSpell temp0)
							(switch temp0
								(skDETECTMAGIC (HighPrint 88 25))
								(skDAZZLE (HighPrint 88 26))
								(skFLAMEDART (HighPrint 88 27))
								(skCALM (HighPrint 88 28))
								(skOPEN (HighPrint 88 29))
								(else  (HighPrint 88 30))
							)
						)
					)
					((Said 'fight')
						(if (Btest 250)
							(HighPrint 88 31)
						else
							(curRoom newRoom: 450)
						)
					)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance troll of Actor
	(properties
		yStep 3
		view 450
		cycleSpeed 1
		illegalBits $0000
		xStep 5
		moveSpeed 1
	)
)

(instance drip of Prop
	(properties
		y 204
		x 79
		view 88
		loop 1
	)
)

(instance pile of View
	(properties
		y 150
		x 60
		view 88
	)
)

(instance trollOut of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0 2)
				(LockEgo)
				(troll
					posn: 249 127
					init:
					setCycle: Walk
					setMotion: MoveTo 183 154 self
				)
			)
			(1
				(HighPrint 88 32)
				(curRoom newRoom: 450)
			)
		)
	)
)

(instance trollKills of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (LockEgo) (= cycles 3))
			(1
				(troll loop: 2 cel: 0 setCycle: EndLoop)
				(= cycles 1)
			)
			(2
				(troll loop: 3 cel: 0 setCycle: EndLoop)
				(ego
					view: 516
					loop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(3 (= cycles 12))
			(4
				(Die 88 33 80 {WHATA TROLL!} 82 800 0 0)
			)
		)
	)
)

(instance trollDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0 3)
				(Bset 250)
				(troll
					view: 451
					loop: 0
					cel: 0
					posn: 80 158
					init:
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(1
				(= local0 4)
				(troll addToPic:)
				(client setScript: 0)
			)
		)
	)
)

(instance dripScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(drip
					posn: [local7 local9] [local8 local9]
					setPri: 15
					setCycle: EndLoop self
				)
			)
			(1
				(= local9 (Random 0 5))
				(self changeState: 0)
			)
		)
	)
)

(instance egoSearch of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(FaceObject ego troll)
				(ego
					loop: (mod (+ (ego loop?) 4) 2)
					view: 510
					setCycle: EndLoop self
				)
			)
			(1
				(switch local2
					(0
						(if (Btest 340)
							(HighPrint 88 34)
						else
							(HighPrint 88 35)
						)
					)
					(1
						(HighPrint 88 36)
						(if (Btest 335)
							(HighPrint 88 37)
						else
							(Bset 335)
							(HighPrint 88 38)
							(ego get: invGoldCoin 5)
							(ego get: invSilverCoin 30)
						)
					)
					(2
						(if (Btest 340)
							(HighPrint 88 39)
						else
							(HighPrint 88 40)
							(Bset 340)
							(ego get: invTrollBeard)
						)
					)
				)
				(ego setCycle: BegLoop self)
			)
			(2 (StopEgo) (UnlockEgo))
		)
	)
)
