;;; Sierra Script 1.0 - (do not remove this comment)
(script# 152)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use System)

(public
	egoBlock 0
)

(local
	theCycles
	local1
	local2
)
(instance egoBlock of Script
	(properties)
	
	(method (init)
		(= local2 ((= local1 (ScriptID 213 0)) egoShield?))
		(super init: &rest)
	)
	
	(method (doit)
		(super doit:)
		(return (-- theCycles))
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 152)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= egoCanFight FALSE)
				(TestSkill skPARRY 0 20)
				(local1
					getTired: 1
					canFight: 0
					action: 3
					posn: (local1 baseX?) (+ (local1 baseY?) 5)
					stopUpd:
				)
				(local2
					setCel: 2
					posn: (+ (local2 x?) 22) (- (local2 y?) 10)
				)
				(= cycles 2)
				(= theCycles 10)
			)
			(1 (= cycles 6))
			(2
				(local2
					setCel: 0
					posn: (- (local1 baseX?) 74) (local1 baseY?)
				)
				(= cycles 4)
			)
			(3
				(local2 stopUpd:)
				(local1 posn: (local1 baseX?) (local1 baseY?))
				(= egoCanFight TRUE)
				(if (<= (= cycles theCycles) 0) (self cue:))
			)
			(4 (self dispose:))
		)
	)
)
