;;; Sierra Script 1.0 - (do not remove this comment)
(script# 339)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)

(public
	SaidTavern 0
	TavernLookAround 1
	TavernLookAtStool 2
)

(procedure (SaidTavern)
	(cond 
		(
			(Said
				'[<at,around][/!*,room,building,tavern,establishment]'
			)
			(TavernLookAround 0 0)
		)
		((Said '/barrel,barrel')
			(if (Btest 254) ((ScriptID 331 5) setCel: 2))
			(HighPrint 339 0 83)
		)
		((Said '/dirt') (HighPrint 339 1))
		((Said '/ale,sweat,breath,drink,beverage')
			(switch drinkInHand
				(drinkNOTHING (HighPrint 339 2))
				(drinkALE (HighPrint 339 3))
				(drinkTROLLSWEAT (HighPrint 339 4))
				(drinkDRAGONBREATH (HighPrint 339 5))
			)
		)
		((Said '/bar,spill,cup')
			(if (Btest 254) ((ScriptID 331 5) setCel: 1))
			(HighPrint 339 6)
		)
		((Said '/bartender,boot,chop,crewcut,tattoo')
			(if (Btest 254)
				(if (> ((ScriptID 331 2) x?) (ego x?))
					((ScriptID 331 5) setCel: 2)
				else
					((ScriptID 331 5) setCel: 1)
				)
			)
			(HighPrint 339 7)
		)
		(
		(or (Said '/bum,barber') (Said '/man/barstool'))
			(if (Btest 254) ((ScriptID 331 5) setCel: 1))
			(HighPrint 339 8)
		)
		((Said '/gambler,table,player,butcher,baker')
			(if (Btest 254) ((ScriptID 331 5) setCel: 2))
			(HighPrint 339 9)
		)
		((Said '/card,game,cardgame')
			(if (not (ego inRect: 171 140 291 183))
				(HighPrint 339 10)
			else
				(HighPrint 339 11)
			)
		)
		((Said '/man') (HighPrint 339 12))
		((Said '/bouncer,goon')
			(if (Btest 254) ((ScriptID 331 5) setCel: 1))
			(HighPrint 339 13)
		)
		((Said '/smoke,dragon') (HighPrint 339 14))
		((Said '<below/barstool')
			(cond 
				((ego inRect: 128 106 171 130)
					(if (Btest 113)
						(HighPrint 339 15)
					else
						(HighPrint 339 16)
					)
				)
				((ego inRect: 192 109 237 130) (HighPrint 339 17))
				(else (HighPrint 339 15))
			)
		)
		((Said '/barstool')
			(if (ego inRect: 192 109 237 130)
				(TavernLookAtStool 0)
			else
				(HighPrint 339 18)
			)
		)
		((Said '/goo')
			(if (ego inRect: 192 109 237 130)
				(HighPrint 339 19)
			else
				(PrintNotCloseEnough)
			)
		)
		(
		(or (Said '<up') (Said '/wall,ceiling,beam,forest')) (HighPrint 339 20))
		((or (Said '<down') (Said '/floor'))
			(if
			(and (ego inRect: 128 106 171 130) (not (Btest 113)))
				(HighPrint 339 16)
			else
				(HighPrint 339 20)
			)
		)
		((Said '/chasm,door,trap') (HighPrint 339 21))
	)
	(DisposeScript 339)
)

(procedure (TavernLookAround param1 param2)
	(HighPrint 339 22)
	(HighPrint 339 23)
	(if param1 (HighPrint 339 24))
	(if param2 (DisposeScript 339))
)

(procedure (TavernLookAtStool param1)
	(HighPrint 339 25)
	(if param1 (DisposeScript 339))
)
