;;; Sierra Script 1.0 - (do not remove this comment)
(script# 289)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use User)
(use Actor)
(use System)

(public
	bustedScript 0
	faceTheMusicScript 1
)

(local
	local0
	local1
)
(procedure (localproc_000e)
	(if local0
		(PrintWarning &rest)
	else
		(HighPrint &rest)
	)
)

(instance bustedScript of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 289)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(User canInput: 0)
				((ScriptID 321 6)
					setLoop: 0
					cel: 1
					posn: 125 119
					setPri: 8
				)
				((ScriptID 321 5) setLoop: 2 cel: 0 posn: 117 48)
				((ScriptID 321 7)
					loop: 7
					cel: 0
					posn: 109 119
					setPri: 9
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				((ScriptID 321 2)
					loop: 1
					number: (GetSongNumber 15)
					play:
				)
				((View new:)
					view: 321
					loop: 4
					cel: 5
					posn: 117 128
					init:
					stopUpd:
				)
				((View new:)
					view: 321
					loop: 4
					cel: 6
					posn: 139 128
					init:
					stopUpd:
				)
				((ScriptID 321 6) setPri: 9 setMotion: MoveTo 136 140)
				((ScriptID 321 8) setCycle: EndLoop self)
			)
			(2
				((ScriptID 321 5) setMotion: MoveTo 122 60 self)
			)
			(3
				(if (== local1 2)
					((ScriptID 321 3) stop:)
					(Die
						289
						0
						80
						{ Try to stay "in character" next time_}
						82
						503
						1
						0
					)
				else
					((ScriptID 321 3) stop:)
					(localproc_000e 289 1)
					(Die 289 2 80 { Criminal carelessness._} 82 602 4 0)
				)
			)
		)
	)
)

(instance faceTheMusicScript of Script
	(properties)
	
	(method (doit)
		(cond 
			((< (ego distanceTo: (ScriptID 321 6)) 20) (self changeState: 9))
			((> (ego y?) 187) (User canControl: 0) (User canInput: 0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 289)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 193)
				(localproc_000e 289 3)
				(self cue:)
			)
			(1
				(LockEgo)
				((ScriptID 321 10) setCel: 4)
				(Bset 194)
				(Bset 195)
				((ScriptID 321 2) loop: -1 number: 13 play:)
				(= seconds 3)
			)
			(2
				(localproc_000e 289 4 83)
				(localproc_000e 289 5)
				(ego setMotion: MoveTo (+ (ego x?) 30) (ego y?))
				(= seconds 2)
			)
			(3
				((ScriptID 321 6)
					setLoop: 1
					cel: 1
					posn: 130 118
					setPri: 8
				)
				((ScriptID 321 7) setCycle: EndLoop self)
			)
			(4
				(ego loop: 1)
				((ScriptID 321 6)
					cycleSpeed: 1
					moveSpeed: 1
					setMotion: MoveTo 130 150 self
				)
			)
			(5
				((ScriptID 321 6) setLoop: 5 cel: 0 setCycle: Forward)
				(= cycles 20)
			)
			(6
				(cond 
					((ego has: invMusicBox) (localproc_000e 289 6))
					((Btest 194)
						((ScriptID 321 10) setCel: 3 forceUpd:)
						((ScriptID 321 2) stop:)
						(localproc_000e 289 7 83)
						(Bclear 194)
					)
					(else (localproc_000e 289 8))
				)
				((ScriptID 321 6)
					setLoop: 2
					setCycle: Walk
					setMotion: MoveTo 130 118 self
				)
			)
			(7
				((ScriptID 321 6) posn: 0 1000 stopUpd:)
				((ScriptID 321 7) setCycle: BegLoop self)
			)
			(8
				(localproc_000e 289 9)
				(Bclear 193)
				(UnlockEgo)
				(ego setScript: 0)
			)
			(9
				((ScriptID 321 3) stop:)
				(Die 289 10 80 { Criminal carelessness._} 82 503 1 0)
			)
		)
	)
)
