;;; Sierra Script 1.0 - (do not remove this comment)
(script# 160)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use AnimateCalm)
(use AnimateDazzle)
(use Inventory)

(public
	SaidEndGameBrigands 0
)

(procedure (SaidEndGameBrigands param1 &tmp temp0)
	(cond 
		((Said 'look>')
			(cond 
				((Said '[<at,around][/place,area]') (HighPrint 160 0))
				((or (Said '<up') (Said '/ceiling')) (HighPrint 160 1))
				((or (Said '<down') (Said '/floor')) (HighPrint 160 2))
				((Said '/west,north,east') (HighPrint 160 3))
				((Said '/south') (HighPrint 160 4))
				((Said '/table') (HighPrint 160 5))
				((Said '/chandelier') (HighPrint 160 6))
				((Said '/candelabra') (HighPrint 160 7))
				((Said '/sign') (HighPrint 160 8))
				((Said '/bandit') (HighPrint 160 9))
				((Said '/rope') (HighPrint 160 10))
			)
		)
		((Said 'cast>')
			(= temp0 (SaidCast param1))
			(if (CastSpell temp0)
				(switch temp0
					(skDETECTMAGIC (HighPrint 160 11))
					(skDAZZLE (AnimateDazzle))
					(skFLAMEDART
						(AnimateThrowingFlameDart 0)
					)
					(skCALM (AnimateCalm))
					(skOPEN
						(cond 
							((ego inRect: 34 75 73 95) (ego setScript: (ScriptID 95 25)))
							((ego inRect: 250 162 310 190)
								(if ((ScriptID 95 0) notify: 3)
									(HighPrint 160 12)
								else
									(HighPrint 160 13)
								)
							)
							(
								(or
									(ego inRect: 263 82 320 93)
									(ego inRect: 0 90 47 100)
								)
								(HighPrint 160 14)
							)
							(else (HighPrint 160 15))
						)
					)
					(else  (HighPrint 160 16))
				)
			)
		)
		((Said 'get/boulder') (HighPrint 160 17))
		((Said 'open[/gate,door]')
			(cond 
				((ego inRect: 34 75 73 95) (ego setScript: (ScriptID 95 26)))
				((ego inRect: 250 162 310 190)
					(if ((ScriptID 95 0) notify: 3)
						(HighPrint 160 12)
					else
						(HighPrint 160 13)
					)
				)
				(
					(or
						(ego inRect: 263 82 320 93)
						(ego inRect: 0 90 47 100)
					)
					(HighPrint 160 14)
				)
				(else (HighPrint 160 15))
			)
		)
		(
			(or
				(Said 'close,close,hasp,bar/gate,door')
				(Said '/gate,door<bar')
			)
			(cond 
				((ego inRect: 34 75 73 95) (HighPrint 160 18))
				((ego inRect: 250 162 310 190)
					(if ((ScriptID 95 0) notify: 3)
						(HighPrint 160 19)
					else
						(ego setScript: (ScriptID 95 27))
					)
				)
				((ego inRect: 263 82 320 93) (HighPrint 160 14))
				((ego inRect: 0 90 47 100) (HighPrint 160 14))
				(else (HighPrint 160 15))
			)
		)
		((Said 'force,move,get,use/chair')
			(cond 
				(((ScriptID 95 0) notify: 4) (HighPrint 160 20))
				((ego inRect: 228 106 320 124) (ego setScript: (ScriptID 159 0)))
				(
					(or
						(ego inRect: 273 88 282 106)
						(ego inRect: 237 96 273 106)
					)
					((ScriptID 95 0) notify: 8)
					(ego setScript: (ScriptID 159 0))
				)
				(else (HighPrint 160 21))
			)
		)
		((Said 'bar,block/door,entrance,door')
			(cond 
				((ego inRect: 34 75 73 95) (HighPrint 160 22))
				((ego inRect: 250 162 310 190)
					(if ((ScriptID 95 0) notify: 3)
						(HighPrint 160 19)
					else
						(ego setScript: (ScriptID 95 27))
					)
				)
				((ego inRect: 0 90 47 100) (HighPrint 160 14))
				(((ScriptID 95 0) notify: 4) (HighPrint 160 20))
				((ego inRect: 228 106 320 124) (ego setScript: (ScriptID 159 0)))
				(
					(or
						(ego inRect: 273 88 282 106)
						(ego inRect: 237 96 273 106)
					)
					((ScriptID 95 0) notify: 8)
					(ego setScript: (ScriptID 159 0))
				)
				(else (HighPrint 160 21))
			)
		)
		(
			(Said
				'beat,force,shove,use,move,knock/candelabra,candle,candlestick'
			)
			(cond 
				(((ScriptID 95 0) notify: 1) (HighPrint 160 23))
				((ego inRect: 227 83 320 115)
					((ScriptID 95 0) notify: 8)
					(ego setScript: (ScriptID 159 1))
				)
				((ego inRect: 271 0 320 96) (ego setScript: (ScriptID 159 1)))
				(else (HighPrint 160 24))
			)
		)
		((Said 'get/candelabra,candle,candlestick') (HighPrint 160 25))
		((Said 'run,walk,sneak') (HighPrint 160 26))
	)
	(DisposeScript 160)
)
