;;; Sierra Script 1.0 - (do not remove this comment)
(script# 234)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	fallSideways 0
	trapFall 1
)

(instance fallSideways of Script
	(properties)
	
	(method (dispose)
		(Bset 267)
		(super dispose:)
		(DisposeScript 234)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (not (Btest 259))
					((ScriptID 96 6) setCel: 3)
					((ScriptID 96 5)
						setLoop: 4
						cel: 0
						cycleSpeed: 1
						setCycle: Forward
					)
				)
				(ego
					view: 517
					setLoop: (if (Btest 258) 3 else 2)
					x: (if (Btest 258) (- (ego x?) 10) else (+ (ego x?) 10))
					cel: 0
					cycleSpeed: 1
					setCycle: CycleTo 2 1 self
				)
				(if (== client (ScriptID 96 3))
					(ego setMotion: MoveTo (+ (ego x?) 12) (ego y?))
				)
			)
			(1
				((ScriptID 96 16)
					number: (GetSongNumber 9)
					loop: 1
					priority: 2
					play:
				)
				(ego
					setPri: (- (ego priority?) 1)
					yStep: 10
					illegalBits: 0
					setCycle: EndLoop
					setMotion: MoveTo (ego x?) 220 self
				)
			)
			(2
				(if (not (ReduceHP 5))
					(Die 234 0 80 {You're the Fall Guy again} 82 517 2 5)
				else
					(Bclear 258)
					(Bclear 257)
					(Bset 260)
					(if (Btest 256)
						(Bclear 256)
						(ego setScript: (ScriptID 226 0))
						(client setCel: 0 setScript: 0)
					else
						(ego setScript: (ScriptID 226 0))
					)
				)
			)
		)
	)
)

(instance trapFall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(client setCel: 1)
				(if (!= client (ScriptID 96 3))
					(client setPri: (- (client priority?) 1))
				)
				(= cycles 1)
			)
			(1
				(if (== client (ScriptID 96 4))
					(Bset 270)
					(self dispose:)
				else
					(client setScript: fallSideways)
				)
			)
		)
	)
)
