;;; Sierra Script 1.0 - (do not remove this comment)
(script# 228)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use User)
(use System)

(public
	goTo2 0
	goTo6 1
	goTo12 2
	goTo15 3
)

(procedure (localproc_0012)
	(switch (++ countdownAwaitingResponse)
		(1 (HighPrint 228 0))
		(2 (HighPrint 228 1))
		(3 (HighPrint 228 2))
		(4 (HighPrint 228 3))
		(5 (HighPrint 228 4))
		(6 (HighPrint 228 5))
		(7 (HighPrint 228 6))
	)
)

(instance goTo2 of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 228)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego setMotion: MoveTo (+ (ego x?) 20) (ego y?) self)
			)
			(1
				(localproc_0012)
				(= cycles 10)
			)
			(2
				(ego
					setPri: 7
					illegalBits: 0
					posn: 22 73
					setMotion: MoveTo 37 73 self
				)
			)
			(3
				(UnlockEgo)
				(ego illegalBits: cWHITE)
				(Bclear 263)
				(client setScript: 0)
			)
		)
	)
)

(instance goTo6 of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 228)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					setLoop: 3
					setMotion: MoveTo 215 97 self
				)
			)
			(1
				(ego setPri: 3 setMotion: MoveTo 194 83 self)
			)
			(2
				((ScriptID 96 9) setCycle: BegLoop self)
			)
			(3
				(localproc_0012)
				(StopEgo)
				((ScriptID 96 9) stopUpd:)
				(ego posn: 49 102 setMotion: MoveTo 87 102 self)
			)
			(4
				(UnlockEgo)
				(User canInput: 1)
				(Bclear 263)
				(client setScript: 0)
			)
		)
	)
)

(instance goTo12 of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 228)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					setMotion: MoveTo (- (ego x?) 25) (ego y?) self
				)
			)
			(1
				(localproc_0012)
				((ScriptID 96 10) setCycle: BegLoop self)
			)
			(2
				(ego
					view: 296
					setLoop: 8
					cel: 0
					posn: 265 102
					cycleSpeed: 1
					moveSpeed: 1
					setMotion: MoveTo 234 102 self
				)
			)
			(3
				(ego setLoop: 9 setCel: 0 posn: 231 101)
				(= cycles 3)
			)
			(4
				(ego setLoop: 1)
				(StopEgo)
				((ScriptID 96 10) setCycle: EndLoop self)
			)
			(5
				(UnlockEgo)
				(Bset 267)
				(Bclear 263)
				(client setScript: 0)
			)
		)
	)
)

(instance goTo15 of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 228)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					illegalBits: 0
					setMotion: MoveTo (- (ego x?) 15) (ego y?) self
				)
			)
			(1
				(localproc_0012)
				(ego posn: 325 129 setMotion: MoveTo 281 129 self)
			)
			(2
				(if (Btest 259) (Bset 267))
				(StopEgo)
				(UnlockEgo)
				(Bclear 263)
				(client setScript: 0)
			)
		)
	)
)
