;;; Sierra Script 1.0 - (do not remove this comment)
(script# 340)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Sound)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	dagNabIt 0
)

(local
	newView_3
	newView_4
	newProp
	newAct
	newAct_2
	newView
	newView_2
	local7
	local8
	local9
	local10
	local11
	local12
	local13
	local14
	local15
	local16
	local17
	local18
	local19 =  5
	local20
	local21 =  5
	local22 =  7
	[newView_5 12]
	local35
	theGNewSpeed
	[local37 50]
)
(procedure (localproc_000c param1 param2 param3 param4 param5 param6)
	(return
		(if
			(and
				(<= param3 param1)
				(< param1 param5)
				(<= param4 param2)
			)
			(< param2 param6)
		else
			0
		)
	)
)

(procedure (localproc_002a param1 param2 param3 param4)
	(Display
		(Format @local37 340 0 param1)
		p_at param3 param4
		p_mode teJustLeft
		p_font ARROW_CURSOR
		p_color param2
		p_back vBLACK
		p_width 18
	)
)

(procedure (localproc_0059)
	(= local8 (Random 40 100))
	(= local9 (Random 85 100))
)

(procedure (localproc_006e)
	(while (>= (-- local35) 0)
		([newView_5 local35] dispose:)
	)
	(= local35 0)
)

(procedure (localproc_0088 &tmp temp0 temp1)
	(= local10 (+ local8 (* 6 (- (newView_4 cel?) 7))))
	(= local11 (+ local9 (* -8 (newView_3 cel?))))
	(= temp0 (/ (- 100 [skills skLUCK]) 4))
	(TestSkill skLUCK 0 0)
	(if (and (TestSkill skTHROWING 0 0) (> temp0 6)) (= temp0 6))
	(= local10
		(+ local10 (- (= temp1 (Random 0 temp0)) (/ temp0 2)))
	)
	(if temp0
		(= local11
			(+ local11 (- (Random 0 temp0) (/ temp0 2)))
		)
	)
)

(procedure (localproc_0107 &tmp temp0 temp1)
	(if
		(<
			(= temp0 (- local20 (+ global300 (* local16 3))))
			6
		)
		(= temp0 6)
	)
	(if (>= global269 100) (= temp0 (Random 2 5)))
	(= local10
		(+ 70 (- (= temp1 (Random 0 temp0)) (/ temp0 2)))
	)
	(= temp0 (- temp0 temp1))
	(= local11 (+ 45 (- (Random 0 temp0) (/ temp0 2))))
)

(procedure (localproc_0163 param1)
	(cond 
		((< param1 0) (= param1 0))
		((> param1 11) (= param1 11))
	)
	(= local21 param1)
	(newView_3 setCel: local21 stopUpd:)
)

(procedure (localproc_0190 param1)
	(cond 
		((< param1 0) (= param1 0))
		((> param1 14) (= param1 14))
	)
	(= local22 param1)
	(newView_4 setCel: local22 stopUpd:)
)

(instance dagNabIt of Room
	(properties
		picture 340
		style $0007
	)
	
	(method (init)
		(super init: &rest)
		(Load rsVIEW 340)
		(Load rsVIEW 341)
		(Load rsSOUND (GetSongNumber 31))
		(Load rsSOUND (GetSongNumber 29))
		(Load rsSOUND (GetSongNumber 30))
		(AddToScore POINTS_PLAYDAGNABIT 3 CLASS_THIEF)
		(StatusLine code: dagStatus enable:)
		((View new:)
			view: 341
			loop: 0
			cel: 0
			posn: 70 45
			ignoreActors:
			setPri: 0
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 341
			loop: 1
			cel: 0
			posn: 68 183
			ignoreActors:
			setPri: 13
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 341
			loop: 2
			cel: 0
			posn: 183 180
			ignoreActors:
			setPri: 1
			init:
			stopUpd:
			addToPic:
		)
		((View new:)
			view: 341
			loop: 2
			cel: 1
			posn: 272 180
			ignoreActors:
			setPri: 1
			init:
			stopUpd:
			addToPic:
		)
		((= newView (View new:))
			view: 341
			loop: 5
			cel: 0
			ignoreActors:
			posn: 27 178
			setPri: 14
			init:
		)
		((= newView_2 (View new:))
			view: 341
			loop: 5
			cel: 1
			ignoreActors:
			posn: 110 178
			setPri: 14
			init:
		)
		(dagMusic number: (GetSongNumber 31) init:)
		(self setScript: dagnabitScript)
		(gKeyHandler addToFront: dagnabitScript)
		(gDirHandler addToFront: dagnabitScript)
		(gMouseHandler addToFront: dagnabitScript)
	)
	
	(method (dispose)
		(StatusLine code: dftStatusCode)
		(super dispose:)
	)
)

(instance dagnabitScript of Script
	(properties)
	
	(method (init)
		(= local19 5)
		((= newView_3 (View new:))
			view: 341
			loop: 3
			cel: local21
			posn: 160 178
			ignoreActors:
			setPri: 2
			init:
			stopUpd:
		)
		((= newView_4 (View new:))
			view: 341
			loop: 4
			cel: local22
			posn: 272 178
			ignoreActors:
			setPri: 2
			init:
			stopUpd:
		)
		(localproc_0059)
		((= newProp (Prop new:))
			view: 340
			setLoop: 2
			cel: 0
			posn: 900 0
			setPri: 6
			ignoreActors:
			init:
			stopUpd:
		)
		((= newAct (Actor new:))
			view: 340
			setLoop: 0
			cel: 0
			posn: 900 100
			setPri: 4
			ignoreActors:
			ignoreHorizon:
			init:
			stopUpd:
		)
		((= newAct_2 (Actor new:))
			view: 340
			setLoop: 6
			cel: 0
			posn: 900 200
			setPri: 7
			ignoreActors:
			init:
			stopUpd:
		)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(asm
			lap      newState
			aTop     state
			push    
			dup     
			ldi      0
			eq?     
			bnt      code_0812
code_0760:
			pushi    2
			lofsa    {"How much will you bet?"}
			push    
			lsl      local19
			calle    GetNumber,  4
			sal      local19
			push    
			ldi      0
			le?     
			bnt      code_078b
			pushi    2
			pushi    340
			pushi    2
			callb    HighPrint,  4
			pushi    #newRoom
			pushi    1
			pushi    332
			lag      curRoom
			send     6
			ret     
			jmp      code_0760
code_078b:
			lsl      local19
			ldi      50
			gt?     
			bnt      code_079f
			pushi    2
			pushi    340
			pushi    3
			callb    HighPrint,  4
			jmp      code_0760
code_079f:
			pushi    1
			lsl      local19
			callb    GiveSilverCoins,  2
			not     
			bnt      code_07bb
			pushi    2
			pushi    340
			pushi    4
			callb    HighPrint,  4
			jmp      code_0760
			jmp      code_07bb
			jmp      code_0760
code_07bb:
			lsg      global269
			ldi      100
			ge?     
			bnt      code_07cd
			pushi    2
			pushi    340
			pushi    5
			callb    HighPrint,  4
code_07cd:
			+ag      global300
			ldi      0
			sal      local15
			sal      local14
			sal      local12
			sal      local16
			pushi    2
			pushi    60
			pushi    90
			callk    Random,  4
			push    
			lal      local19
			sub     
			sal      local20
			ldi      0
			sal      local35
			pushi    4
			lsl      local14
			pushi    14
			pushi    47
			pushi    173
			call     localproc_002a,  8
			pushi    4
			lsl      local15
			pushi    11
			pushi    73
			pushi    173
			call     localproc_002a,  8
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0ab4
code_0812:
			dup     
			ldi      1
			eq?     
			bnt      code_0836
			pushi    0
			callb    LockEgo,  0
			ldi      0
			sal      local13
			ldi      1
			sal      local18
			pushi    0
			call     localproc_0059,  0
			pushi    #setScript
			pushi    1
			lofsa    blinkScript
			push    
			self     6
			jmp      code_0ab4
code_0836:
			dup     
			ldi      2
			eq?     
			bnt      code_0853
			pushi    0
			call     localproc_006e,  0
			pushi    #setScript
			pushi    1
			lofsa    throwScript
			push    
			self     6
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0ab4
code_0853:
			dup     
			ldi      3
			eq?     
			bnt      code_0898
			pushi    #cel
			pushi    1
			pushi    0
			pushi    196
			pushi    2
			lsl      local8
			lsl      local9
			pushi    198
			pushi    0
			lal      newProp
			send     18
			pushi    #setLoop
			pushi    1
			pushi    6
			pushi    7
			pushi    1
			pushi    0
			pushi    196
			pushi    2
			lsl      local8
			lsl      local9
			pushi    66
			pushi    1
			pushi    7
			pushi    198
			pushi    0
			lal      newAct_2
			send     30
			pushi    0
			callb    UnlockEgo,  0
			ldi      1
			sal      local17
			jmp      code_0ab4
code_0898:
			dup     
			ldi      4
			eq?     
			bnt      code_08b7
			ldi      0
			sal      local17
			pushi    0
			callb    LockEgo,  0
			pushi    0
			call     localproc_0088,  0
			pushi    #changeState
			pushi    1
			pushi    1
			pToa     script
			send     6
			jmp      code_0ab4
code_08b7:
			dup     
			ldi      5
			eq?     
			bnt      code_08f9
			pushi    4
			lsl      local14
			pushi    14
			pushi    47
			pushi    173
			call     localproc_002a,  8
			+al      local13
			push    
			ldi      3
			lt?     
			bnt      code_08e5
			pushi    0
			call     localproc_0059,  0
			pushi    #changeState
			pushi    1
			pushi    3
			self     6
			jmp      code_0ab4
code_08e5:
			pushi    #posn
			pushi    2
			pushi    900
			pushi    0
			lal      newProp
			send     8
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0ab4
code_08f9:
			dup     
			ldi      6
			eq?     
			bnt      code_0929
			pushi    #show
			pushi    0
			lal      newView
			send     4
			pushi    #hide
			pushi    0
			lal      newView_2
			send     4
			ldi      0
			sal      local18
			ldi      0
			sal      local13
			pushi    0
			call     localproc_0059,  0
			pushi    #setScript
			pushi    1
			lofsa    blinkScript
			push    
			self     6
			jmp      code_0ab4
code_0929:
			dup     
			ldi      7
			eq?     
			bnt      code_0941
			pushi    #setScript
			pushi    1
			lofsa    throwScript
			push    
			self     6
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0ab4
code_0941:
			dup     
			ldi      8
			eq?     
			bnt      code_0963
			pushi    #cel
			pushi    1
			pushi    0
			pushi    196
			pushi    2
			lsl      local8
			lsl      local9
			pushi    198
			pushi    0
			lal      newProp
			send     18
			ldi      20
			aTop     cycles
			jmp      code_0ab4
code_0963:
			dup     
			ldi      9
			eq?     
			bnt      code_097c
			pushi    0
			call     localproc_0107,  0
			+al      local16
			pushi    #changeState
			pushi    1
			pushi    1
			pToa     script
			send     6
			jmp      code_0ab4
code_097c:
			dup     
			ldi      10
			eq?     
			bnt      code_09c2
			pushi    4
			lsl      local15
			pushi    11
			pushi    73
			pushi    173
			call     localproc_002a,  8
			+al      local13
			push    
			ldi      3
			lt?     
			bnt      code_09a5
			pushi    #changeState
			pushi    1
			pushi    8
			self     6
			jmp      code_0ab4
code_09a5:
			pushi    #show
			pushi    0
			lal      newView_2
			send     4
			pushi    #posn
			pushi    2
			pushi    900
			pushi    0
			lal      newProp
			send     8
			+al      local12
			ldi      5
			aTop     cycles
			jmp      code_0ab4
code_09c2:
			dup     
			ldi      11
			eq?     
			bnt      code_09e2
			lsl      local12
			ldi      3
			lt?     
			bnt      code_09da
			pushi    #changeState
			pushi    1
			pushi    1
			self     6
			jmp      code_0ab4
code_09da:
			pushi    #cue
			pushi    0
			self     4
			jmp      code_0ab4
code_09e2:
			dup     
			ldi      12
			eq?     
			bnt      code_0a94
			pushi    0
			callb    UnlockEgo,  0
			lsl      local14
			lal      local15
			gt?     
			bnt      code_0a2c
			pushi    238
			pushi    #-info-
			pushi    1
			lsl      local19
			lal      local19
			add     
			push    
			lag      ego
			send     8
			pushi    2
			pushi    340
			pushi    6
			callb    HighPrint,  4
			lsl      local19
			ldi      25
			ge?     
			bnt      code_0a20
			pushi    3
			pushi    644
			pushi    5
			pushi    2
			callb    AddToScore,  6
code_0a20:
			lsg      global269
			lal      local19
			add     
			sag      global269
			jmp      code_0a78
code_0a2c:
			lsl      local14
			lal      local15
			lt?     
			bnt      code_0a49
			pushi    2
			pushi    340
			pushi    7
			callb    HighPrint,  4
			lsg      global269
			lal      local19
			sub     
			sag      global269
			jmp      code_0a78
code_0a49:
			pushi    #get
			pushi    2
			pushi    1
			lsl      local19
			lag      ego
			send     8
			lsl      local19
			ldi      25
			le?     
			bnt      code_0a6f
			pushi    2
			pushi    340
			pushi    8
			callb    HighPrint,  4
			lsl      local19
			lal      local19
			add     
			sal      local19
			jmp      code_0a78
code_0a6f:
			pushi    2
			pushi    340
			pushi    9
			callb    HighPrint,  4
code_0a78:
			pushi    0
			call     localproc_006e,  0
			pushi    2
			pushi    340
			pushi    10
			calle    Print,  4
			pushi    #setScript
			pushi    2
			lofsa    askPlayAgain
			push    
			pushSelf
			self     8
			jmp      code_0ab4
code_0a94:
			dup     
			ldi      13
			eq?     
			bnt      code_0ab4
			lal      local7
			bnt      code_0aa9
			pushi    #changeState
			pushi    1
			pushi    0
			self     6
			jmp      code_0ab4
code_0aa9:
			pushi    #newRoom
			pushi    1
			pushi    332
			lag      curRoom
			send     6
code_0ab4:
			toss    
			ret     
		)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 temp2)
		(= temp0 (pEvent message?))
		(if (super handleEvent: pEvent) (return 1))
		(return
			(switch (pEvent type?)
				(evMOUSEBUTTON
					(if local17
						(pEvent claimed: 1)
						(= temp1 (pEvent x?))
						(= temp2 (pEvent y?))
						(cond 
							((localproc_000c temp1 temp2 33 17 107 76) (self cue:))
							((localproc_000c temp1 temp2 149 154 176 166) (localproc_0163 (- local21 1)))
							((localproc_000c temp1 temp2 189 154 218 166) (localproc_0163 (+ local21 1)))
							((localproc_000c temp1 temp2 238 150 250 162) (localproc_0190 (- local22 1)))
							((localproc_000c temp1 temp2 294 150 305 162) (localproc_0190 (+ local22 1)))
							((localproc_000c temp1 temp2 155 172 211 180) (localproc_0163 (/ (- temp1 160) 4)))
							((localproc_000c temp1 temp2 245 163 298 180) (localproc_0190 (/ (- temp1 249) 3)))
						)
					)
				)
				(evKEYBOARD
					(cond 
						((== 63 temp0) (pEvent claimed: 1) (__proc341_0))
						((and local17 (== 13 temp0)) (pEvent claimed: 1) (self cue:))
					)
				)
				(evSAID
					(cond 
						((Said 'cease,end,done,quit,done') (curRoom newRoom: 332))
						(
							(or
								(Said 'ask/game,dagnabit,play,rule')
								(Said 'help,rule')
							)
							(__proc341_0)
						)
						((Said 'bet,play,begin') (HighPrint 340 1))
					)
				)
				(evJOYSTICK
					(pEvent claimed: 1)
					(if local17
						(switch (pEvent message?)
							(JOY_UP
								(localproc_0163 (+ local21 1))
							)
							(JOY_DOWN
								(localproc_0163 (- local21 1))
							)
							(JOY_RIGHT
								(localproc_0190 (+ local22 1))
							)
							(JOY_LEFT
								(localproc_0190 (- local22 1))
							)
						)
					)
				)
			)
		)
	)
)

(instance askPlayAgain of Script
	(properties)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((!= (pEvent type?) evSAID))
			((Said 'affirmative') (= local7 1) (self dispose:))
			((Said 'n') (= local7 0) (self dispose:))
		)
	)
)

(instance throwScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0)
			(1
				(= theGNewSpeed gNewSpeed)
				(theGame setSpeed: 0)
				(newProp cycleSpeed: 2 setCycle: CycleTo 2 1 self)
				(if local18 (newAct_2 cycleSpeed: 2 setCycle: CycleTo 2 1))
			)
			(2
				(newProp cycleSpeed: 0 setCycle: EndLoop self)
				(if local18 (newAct_2 cycleSpeed: 0 setCycle: EndLoop))
				(dagMusic number: (GetSongNumber 31) play:)
			)
			(3
				(newProp stopUpd:)
				(if local18 (newAct_2 posn: 900 200 stopUpd:))
				(newAct
					posn: local8 local9
					setPri: 4
					setLoop: (if local18 4 else 0)
					cel: 0
					cycleSpeed: 0
					moveSpeed: 0
					ignoreActors:
					ignoreControl: -1
					setCycle: EndLoop self
					setMotion: MoveTo local10 (+ local11 1)
				)
			)
			(4
				(newAct
					setPri: 3
					setLoop: (if local18 5 else 1)
					cel: 0
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: Forward
					setMotion: MoveTo local10 local11 self
				)
			)
			(5
				(newAct posn: 900 100 stopUpd:)
				(newProp cel: 0 forceUpd: stopUpd:)
				((= [newView_5 local35] (View new:))
					view: 340
					loop: (if local18 7 else 3)
					cel: 3
					posn: local10 local11
					ignoreActors:
					setPri: 1
					init:
					stopUpd:
				)
				(++ local35)
				(dagMusic stop:)
				(dagMusic
					number: (if local18 (GetSongNumber 29) else (GetSongNumber 30))
					play:
				)
				(= temp0
					(cond 
						((< local10 65) 0)
						((> local10 75) 2)
						(else 1)
					)
				)
				(= local10 (+ (* (- local10 70) 2) 229))
				(= local11 (+ (* (- local11 45) 2) 61))
				((= [newView_5 local35] (View new:))
					view: 340
					loop: (if local18 7 else 3)
					cel: temp0
					posn: local10 local11
					ignoreActors:
					setPri: 1
					init:
					stopUpd:
				)
				(++ local35)
				(= temp1
					(switch (OnControl 4 local10 local11)
						(2 1)
						(4 2)
						(8 3)
						(16 4)
						(else  0)
					)
				)
				(if local18
					(= local14 (+ local14 temp1))
				else
					(= local15 (+ local15 temp1))
				)
				(theGame setSpeed: theGNewSpeed)
				(client cue:)
			)
		)
	)
)

(instance blinkScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(= temp0 (if local18 newView else newView_2))
		(switch (= state newState)
			(0 (= register 3) (self cue:))
			(1
				(temp0 hide:)
				(if (not (-- register)) (self changeState: 3))
				(= cycles 6)
			)
			(2
				(temp0 show:)
				(= state 0)
				(= cycles 6)
			)
			(3 (client cue:))
		)
	)
)

(instance dagMusic of Sound
	(properties
		number 31
	)
)

(instance dagStatus of Code
	(properties)
	
	(method (doit param1)
		(Format param1 340 11 score)
	)
)
