;;; Sierra Script 1.0 - (do not remove this comment)
(script# 131)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ErasmusTower)
(use Interface)
(use Motion)
(use User)
(use Actor)
(use System)

(public
	intoTheTower 0
	gameOver 1
)

(local
	local0
	local1 =  1
	local2
	local3
	local4
	[local5 5] = [1 2 4 8 16]
	[local10 4] = [{Open} {Fetch} {Flame Dart} {Trigger}]
)
(instance cheese of View
	(properties
		y 122
		x 161
		view 31
		cel 4
	)
)

(instance intoTheTower of Script
	(properties)
	
	(method (init)
		(cheese init: setPri: 7 ignoreActors: stopUpd:)
		(super init: &rest)
	)
	
	(method (doit)
		(super doit:)
		(if (and local4 (not global310) (not local2))
			(self cue:)
		)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 131)
	)
	
	(method (changeState newState &tmp temp0 [temp1 40])
		(switch (= state newState)
			(0
				(ego
					illegalBits: 0
					setPri: 8
					posn: 200 208
					setMotion: MoveTo 175 183 self
				)
			)
			(1
				((ScriptID 31 1) setCycle: Forward)
				(= cycles 4)
			)
			(2
				(Print
					131
					1
					#at
					5
					40
					#width
					80
					#mode
					1
					#title
					{ Erasmus_}
					#dispose
					#time
					3
				)
				(ego setMotion: MoveTo 155 163 self)
				; Come in and sit down.
			)
			(3
				(StopEgo)
				(ego illegalBits: 0 setMotion: MoveTo 155 158 self)
			)
			(4
				((ScriptID 31 1) setCel: 0 setCycle: 0)
				(ego setMotion: MoveTo 174 152 self)
			)
			(5
				((ScriptID 31 2) setCel: 7)
				(ego
					view: 31
					setLoop: 4
					setCel: 2
					illegalBits: 0
					posn: 186 121
					stopUpd:
				)
				(= cycles 5)
			)
			(6
				((ScriptID 31 1) setCel: -1 setCycle: Forward)
				(Print
					131
					2
					#at
					5
					40
					#width
					80
					#mode
					1
					#title
					{ Erasmus_}
					#dispose
					#time
					4
				)
				(= seconds 4)
				; Fenrus, our guest has arrived.
			)
			(7
				((ScriptID 31 1) setCel: 0 setCycle: 0 stopUpd:)
				(ego setCel: 2)
				((ScriptID 31 3) setCycle: BegLoop self)
			)
			(8
				((ScriptID 31 3) setCycle: EndLoop self)
			)
			(9
				((ScriptID 31 4) setCycle: EndLoop)
				(= cycles 10)
			)
			(10
				(Print
					131
					3
					#at
					225
					85
					#width
					90
					#mode
					1
					#title
					{ Fenrus_}
					#dispose
					#time
					3
				)
				(ego setCycle: EndLoop)
				(= seconds 2)
				; Cheese, please!
			)
			(11
				((ScriptID 31 3)
					cycleSpeed: 0
					cel: 0
					posn: 197 102
					setPri: 14
					setCycle: EndLoop self
				)
			)
			(12
				((ScriptID 31 3) cel: 0 posn: 161 115 setCycle: EndLoop)
				(= cycles 10)
			)
			(13
				(cheese posn: (+ (cheese x?) 7) (- (cheese y?) 3))
				(++ local0)
				(= cycles 1)
			)
			(14
				(if (< local0 5)
					(self changeState: 13)
				else
					(cheese dispose:)
					((ScriptID 31 4) setLoop: 5 setCel: 0)
					(self cue:)
				)
			)
			(15
				((ScriptID 31 4) setCel: 1)
				(Print
					131
					4
					#at
					225
					85
					#width
					90
					#mode
					1
					#title
					{ Fenrus_}
					#dispose
					#time
					3
				)
				(ego setCycle: CycleTo 3 -1)
				(= seconds 3)
				; Ahhhhhh!
			)
			(16
				((ScriptID 31 4) cycleSpeed: 1 setCel: 0)
				(= cycles 2)
			)
			(17
				(if (>= [skills skMAGIC] 20)
					(= cycles 1)
				else
					(User canInput: 1)
					(ego setCel: 2)
					(client setScript: 0)
				)
			)
			(18
				(LockEgo)
				(= local4 1)
				(= global312 0)
				(= local1 0)
				(if (not (Btest 353))
					(Bset 353)
					(ErasmusPrint 8 131 5)
				else
					(= cycles 1)
				)
			)
			(19
				(while (& global281 [local5 register])
					(++ register)
				)
				(cond 
					(local3 (Bset 266) (ErasmusPrint 9 131 6))
					((& global280 [local5 register]) (ErasmusPrint 5 (Format @temp1 131 7 [local10 register])))
					((< register 4)
						(= global280 (| global280 [local5 register]))
						(ErasmusPrint 7 (Format @temp1 131 8 [local10 register]))
					)
					((Btest 266) (ErasmusPrint 7 131 9))
					(else (= local3 1) (-- state) (ErasmusPrint 7 131 10))
				)
			)
			(20
				(= local1 (= local2 1))
				(UnlockEgo)
				(User canControl: 0)
				(= seconds 14)
			)
			(21
				(LockEgo)
				(= local2 0)
				(cond 
					(local1
						(switch register
							(4
								(ego setCel: 2)
								(User canInput: 1)
								(client setScript: 0)
								(ErasmusPrint 8 131 11)
							)
							(3 (ErasmusPrint 8 131 12))
							(else  (ErasmusPrint 8 131 13))
						)
					)
					((>= register 4) (client setScript: (ScriptID 132 5)))
					(else
						(= global281 (| global281 [local5 register]))
						(++ register)
						(self changeState: 19)
					)
				)
			)
			(22
				(ego setCel: 2)
				(UnlockEgo)
				(User canControl: 0)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((and (== (pEvent type?) evSAID) local2)
				(= seconds 0)
				(cond 
					((Said 'affirmative/') (= local1 0) (self cue:))
					((Said 'n/') (self cue:))
					(else (pEvent claimed: 1) (ErasmusPrint 4 131 0))
				)
			)
		)
	)
)

(instance gameOver of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 131)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 31 2) setCel: 7)
				(ego
					view: 31
					setLoop: 4
					setCel: 0
					illegalBits: 0
					posn: 186 121
					stopUpd:
				)
				((ScriptID 31 4) setLoop: 5 cel: 1)
				(= cycles 5)
			)
			(1
				((ScriptID 31 3)
					cycleSpeed: 0
					cel: 0
					posn: 160 102
					setPri: 14
					setCycle: EndLoop self
				)
			)
			(2
				((ScriptID 31 9)
					setLoop: 0
					setCel: 0
					setMotion: MoveTo 153 119
					startUpd:
				)
				((ScriptID 31 10)
					setLoop: 0
					setCel: 0
					setMotion: MoveTo 168 119 self
					startUpd:
				)
			)
			(3
				((ScriptID 31 10) stopUpd:)
				((ScriptID 31 9) stopUpd:)
				(ego setCel: 2)
				(= cycles 5)
			)
			(4
				((ScriptID 31 1) setCel: -1 setCycle: Forward)
				(ego setCel: 1)
				(Print
					131
					14
					#at
					5
					40
					#width
					80
					#mode
					1
					#title
					{ Erasmus_}
					#dispose
					#time
					5
				)
				(= seconds 5)
				; I so enjoy playing the Mage's Maze.
			)
			(5
				(ego setCel: 2)
				((ScriptID 31 1) setCycle: BegLoop)
				(UnlockEgo)
				(User canControl: 0)
				(self dispose:)
			)
		)
	)
)
