;;; Sierra Script 1.0 - (do not remove this comment)
(script# 236)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use User)
(use System)

(public
	climbTree 0
	cantClimbTree 1
)

(local
	local0
)
(instance climbTree of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 236)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 40 186 self)
			)
			(1
				(ego view: 517 setLoop: 0 setCel: 0 setPri: 13)
				(self cue:)
			)
			(2 (= cycles 4))
			(3
				(++ local0)
				(ego
					setCel: (if (== (ego cel?) 3) 0 else (+ (ego cel?) 1))
					posn:
						(ego x?)
						(if (== (mod (ego cel?) 2) 0)
							(- (ego y?) 20)
						else
							(ego y?)
						)
				)
				(self cue:)
			)
			(4
				(if (< local0 6)
					(self changeState: 2)
				else
					(= local0 0)
					(= cycles 4)
				)
			)
			(5
				(ego
					setLoop: 1
					cel: 0
					x: (- (ego x?) 12)
					y: (- (ego y?) 33)
					setStep: 0 4
					cycleSpeed: 2
					moveSpeed: 2
					setCycle: EndLoop self
				)
			)
			(6
				(Bset 278)
				(User canInput: 1)
				((ScriptID 54 3) setScript: (ScriptID 54 5))
				(client setScript: 0)
			)
		)
	)
)

(instance cantClimbTree of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 236)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego illegalBits: 0 setMotion: MoveTo 40 180 self)
			)
			(1
				(ego view: 517 setLoop: 0 setCel: 0 setPri: 13)
				(= cycles 4)
			)
			(2
				(ego setCel: 1 posn: 40 160 cycleSpeed: 1 setCycle: Forward)
				(= seconds 4)
			)
			(3
				(HighPrint 236 0)
				(UnlockEgo)
				(StopEgo)
				(ego loop: 2 posn: 40 180)
				(client setScript: 0)
			)
		)
	)
)
