;;; Sierra Script 1.0 - (do not remove this comment)
(script# 139)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Interface)
(use Motion)
(use User)
(use System)

(public
	hermitHits 0
)

(local
	local0
)
(procedure (localproc_000c &tmp [temp0 200])
	(Format @temp0 &rest)
	(Print @temp0 #at 160 10)
)

(instance hermitHits of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 139)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (Btest 275)
					(Bclear 275)
					(localproc_000c 139 0)
					(User canControl: 1)
					(= cycles 15)
				else
					(self cue:)
				)
			)
			(1
				(if (not (ego script?)) (LockEgo))
				(Bset 352)
				(client
					view: 81
					loop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: CycleTo 4 1 self
				)
			)
			(2
				(cond 
					((== (ego onControl: origin) cLRED)
						((ScriptID 82 4)
							number: (GetSongNumber 84)
							loop: 1
							play:
						)
						(Bset 274)
						(ego setScript: (ScriptID 138 0))
					)
					((== (ego onControl: origin) cYELLOW) (Bset 276) (ego setPri: 0))
				)
				(client setCycle: EndLoop self)
			)
			(3
				(if (Btest 276)
					((ScriptID 82 4)
						number: (GetSongNumber 84)
						loop: 1
						play:
					)
					(ego hide:)
				)
				((ScriptID 82 1)
					posn: (- (client x?) 26) (- (client y?) 16)
					setCel: 0
					setPri: 15
					init:
				)
				(= cycles 5)
			)
			(4
				((ScriptID 82 1) setCel: 1)
				(= cycles 5)
			)
			(5
				(if
				(and (Btest 272) (not (Btest 274)) (not (Btest 276)))
					(Bclear 272)
					(localproc_000c 139 1)
					(ego setScript: (ScriptID 82 2))
					(client setScript: 0)
				else
					(PrintTimedMessage 4 139 2 80 {the Hermit mutters...})
					(= cycles 1)
				)
			)
			(6
				(++ local0)
				((ScriptID 82 1) setCel: 0)
				(= cycles 3)
			)
			(7
				((ScriptID 82 1) setCel: 1)
				(= cycles 3)
			)
			(8
				(if (< local0 4)
					(self changeState: 6)
				else
					(self cue:)
				)
			)
			(9
				(if (Btest 276)
					(ego
						view: 538
						setLoop: 0
						cel: 0
						x: (- (ego x?) 5)
						y: (- (ego y?) 3)
						stopUpd:
						show:
					)
				)
				((ScriptID 82 1) dispose:)
				(client setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(10
				(Bclear 352)
				(if (Btest 276) (ego setScript: (ScriptID 82 3)))
				(client setScript: 0)
			)
		)
	)
)
