;;; Sierra Script 1.0 - (do not remove this comment)
(script# 170)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use User)
(use System)

(public
	sitScript 0
)

(instance sitScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(cond 
			((> serveFoodCountdown 1)
				(-- serveFoodCountdown)
			)
			((== serveFoodCountdown 1)
				(= serveFoodCountdown 0)
				(if (not ((ScriptID 301 2) script?)) ;shema actor
					((ScriptID 301 2) setScript: (ScriptID 168 0)) ;comingOut script.
				)
			)
		)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 170)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (Btest 302) (Bclear 302) else (self cue:))
			)
			(1
				(LockEgo)
				((ScriptID 301 8) ignoreActors:)
				(if (< (ego x?) 158)
					(ego illegalBits: 0 setMotion: MoveTo 145 (ego y?) self)
				else
					(ego illegalBits: 0 setMotion: MoveTo (ego x?) 157)
					(= cycles 5)
				)
			)
			(2
				(if (> (ego x?) 145)
					(ego setMotion: MoveTo 145 (ego y?) self)
				else
					(self cue:)
				)
			)
			(3
				(ego setMotion: MoveTo (ego x?) 154)
				(= cycles 2)
			)
			(4
				((ScriptID 301 8) posn: 156 154)
				(= cycles 3)
			)
			(5
				(ego ignoreActors: stopUpd: hide:)
				((ScriptID 301 8)
					setLoop: 6
					setCel: 0
					setPri: 12
					posn: 141 154
					ignoreActors: 0
				)
				(= cycles 2)
			)
			(6
				((ScriptID 301 8) setCycle: EndLoop)
				(Bset 254)
				(= cycles 15)
			)
			(7
				(cond 
					((not (gCast contains: (ScriptID 301 2)))
						((ScriptID 301 2) init:)
						(gCast delete: (ScriptID 301 2))
						(gCast addToFront: (ScriptID 301 2))
					)
					(
						(and
							(not (Btest 301))
							(not ((ScriptID 301 2) script?))
						)
						((ScriptID 301 2) setScript: (ScriptID 168 0))
					)
				)
			)
			(8
				(User canInput: 0)
				((ScriptID 301 8) setCycle: BegLoop self)
			)
			(9
				((ScriptID 301 8)
					setLoop: 5
					setCel: 4
					setPri: 6
					posn: 141 154
					stopUpd:
				)
				(ego loop: 1 show:)
				(= cycles 3)
			)
			(10
				(ego setMotion: MoveTo (ego x?) 160 self)
			)
			(11
				((ScriptID 301 8) setPri: -1)
				(Bclear 254)
				(= foodOrdered mealNOTHING)
				(= teaOrdered mealNOTHING)
				(UnlockEgo)
				(ego illegalBits: cWHITE ignoreActors: 0 setScript: 0)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(switch (pEvent type?)
			(evSAID
				(if (or (Said 'stand') (Said 'get<up'))
					(cond 
						(
							(and
								(Btest 301)
								(< ((ScriptID 301 2) distanceTo: ego) 30)
							)
							(HighPrint 170 0)
							;Not until you're through with Shema.
						)
						((or (== foodOrdered mealORDERED) (== teaOrdered mealORDERED))
							(HighPrint 170 1)
							;You should wait for Shema to bring you what you ordered.
						)
						((== foodOrdered mealATTABLE)
							(HighPrint 170 2)
							;Eat your meal first.
						)
						((== teaOrdered mealATTABLE)
							(HighPrint 170 3)
							;Finish your drink.
						)
						(else 
							(self changeState: 8)
						)
					)
				)
			)
		)
	)
)
