;;; Sierra Script 1.0 - (do not remove this comment)
(script# 123)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	caveDazzle 0
	koboldDazzle 1
)

(local
	local0
)
(instance caveDazzle of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(ego
					view: 521
					setLoop: (if (Btest 149) 2 else 3)
					cel: 0
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(Bset 294)
				(ego setCycle: EndLoop)
				(= cycles 6)
			)
			(2
				(StopEgo)
				(FaceObject ego (ScriptID 15 1))
				(UnlockEgo)
				(client setScript: 0)
			)
		)
	)
)

(instance koboldDazzle of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 123)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 157)
				(Bset 216)
				(Bclear 314)
				(= local0 0)
				(if (< koboldStatus 2)
					((ScriptID 15 1)
						posn: ((ScriptID 15 2) x?) ((ScriptID 15 2) y?)
					)
					((ScriptID 15 2) dispose:)
					(= koboldStatus 2)
				)
				((ScriptID 15 1) view: 179 setCel: 0 forceUpd:)
				(= cycles 10)
			)
			(1
				((ScriptID 15 1)
					setCel: -1
					cycleSpeed: 2
					setCycle: CycleTo 2 1
				)
				(= cycles 10)
			)
			(2
				(++ local0)
				((ScriptID 15 1) setCel: 3)
				(= cycles 4)
			)
			(3
				((ScriptID 15 1) setCel: 4)
				(= cycles 4)
			)
			(4
				(if (< local0 5)
					(self changeState: 2)
				else
					(= cycles 15)
				)
			)
			(5
				((ScriptID 15 1) setCel: 5)
				(= seconds 3)
			)
			(6
				(Bset 344)
				(Bclear 216)
				(Bset 280)
				(self dispose:)
			)
		)
	)
)
