;;; Sierra Script 1.0 - (do not remove this comment)
(script# 117)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	dartHit 0
	koboldDies 1
)

(instance dartHit of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 117)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 15 1)
					view: 178
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(if (Btest 346)
					(Bclear 346)
					(= global343 (- global343 global345))
				else
					(= global343 (- global343 global346))
				)
				(if (<= global343 0)
					(Bset 283)
					(self dispose:)
				else
					(Bset 344)
					(self dispose:)
				)
			)
		)
	)
)

(instance koboldDies of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 118)
		(DisposeScript 117)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				((ScriptID 15 4) setCycle: 0 dispose:)
				(= koboldStatus koboldDead)
				(= global319 4)
				((ScriptID 15 1)
					view: 178
					setLoop: 5
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
				(if (== global321 0)
					((ScriptID 15 7)
						illegalBits: 0
						ignoreActors:
						view: 178
						posn: ((ScriptID 15 1) x?) ((ScriptID 15 1) y?)
						setLoop: 6
						setPri: (if (Btest 149) 5 else -1)
						cycleSpeed: 1
						setCycle: EndLoop
					)
					(= global321 1)
				)
			)
			(1
				(= global332 0)
				(= gMonsterHealth 0)
				(cSound number: 20 loop: -1 play:)
				((ScriptID 15 7)
					setPri: (- ((ScriptID 15 7) priority?) 1)
					stopUpd:
				)
				(if
				(or (== heroType CLASS_FIGHTER) (== heroType CLASS_MAGICUSER))
					(AddToScore POINTS_KILLKOBOLD 10)
				)
				(UnlockEgo)
				((ScriptID 15 1) dispose:)
			)
		)
	)
)
