;;; Sierra Script 1.0 - (do not remove this comment)
(script# 128)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	DodgeLeft 0
	DodgeRight 1
	Duck 2
	Lunge 3
)

(instance DodgeLeft of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 128)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 6 else 1)
					setCel: 0
					setMotion: 0
					setCycle: 0
				)
				(= cycles 10)
			)
			(1
				(ego setLoop: (if (Btest 149) 5 else 0) setCel: 0)
				(Bset 318)
				(self dispose:)
			)
		)
	)
)

(instance DodgeRight of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 128)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 7 else 2)
					setCel: 0
					setMotion: 0
					setCycle: 0
				)
				(= cycles 10)
			)
			(1
				(ego setLoop: (if (Btest 149) 5 else 0) setCel: 0)
				(Bset 318)
				(self dispose:)
			)
		)
	)
)

(instance Duck of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 128)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bclear 318)
				(= cycles 0)
				(ego
					setLoop: (if (Btest 149) 8 else 3)
					setCel: 0
					setMotion: 0
					setCycle: 0
				)
				(= cycles 10)
			)
			(1
				(ego setLoop: (if (Btest 149) 5 else 0) setCel: 0)
				(Bset 318)
				(self dispose:)
			)
		)
	)
)

(instance Lunge of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(Bset 318)
		(DisposeScript 128)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(Bclear 318)
				(ego
					setLoop: (if (Btest 149) 5 else 0)
					setCel: -1
					setMotion: 0
					cel: 0
					illegalBits: 0
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(if
					(and
						(>= global344 (RollDice))
						(!= ((ScriptID 15 1) script?) (ScriptID 118 1))
					)
					(Bset 319)
					(= global343 (- global343 global345))
				)
				(= cycles 4)
			)
			(2 (ego setCycle: EndLoop self))
			(3
				(ego illegalBits: cWHITE setCel: 0)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)
