;;; Sierra Script 1.0 - (do not remove this comment)
(script# 116)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	ricochet 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	[local6 11]
	[local17 11]
)
(procedure (localproc_000c)
	(= local0 (- (ego x?) ((ScriptID 15 1) x?)))
	(= local1 (- (ego y?) ((ScriptID 15 1) y?)))
	(= local2 (+ ((ScriptID 15 1) x?) (* local0 10)))
	(= local3 (+ ((ScriptID 15 1) y?) (* local1 10)))
)

(instance ricochet of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(= [local6 0] 17)
		(= [local17 0] 47)
		(= [local6 1] 44)
		(= [local17 1] 155)
		(= [local6 2] 17)
		(= [local17 2] 134)
		(= [local6 3] 251)
		(= [local17 3] 186)
		(= [local6 4] 101)
		(= [local17 4] 47)
		(= [local6 5] 183)
		(= [local17 5] 145)
		(= [local6 6] 283)
		(= [local17 6] 124)
		(= [local6 7] 316)
		(= [local17 7] 212)
		(= [local6 8] 102)
		(= [local17 8] 161)
		(= [local6 9] 244)
		(= [local17 9] 51)
		(= [local6 10] 169)
		(= [local17 10] 55)
	)
	
	(method (doit)
		(if
			(and
				local4
				(not ((ScriptID 15 4) inRect: 10 35 310 205))
			)
			(= local4 0)
			(self cue:)
		)
		(if ((ScriptID 15 1) script?) (self dispose:))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 116)
	)
	
	(method (changeState newState &tmp [temp0 20])
		(switch (= state newState)
			(0
				(Bclear 314)
				(= local5 (Random 0 2))
				(if (not (Btest 151))
					((ScriptID 15 4)
						posn:
							(switch ((ScriptID 15 1) loop?)
								(0
									(- ((ScriptID 15 1) x?) 24)
								)
								(1
									(+ ((ScriptID 15 1) x?) 24)
								)
								(2
									(- ((ScriptID 15 1) x?) 17)
								)
								(3
									(+ ((ScriptID 15 1) x?) 17)
								)
								(4 (- ((ScriptID 15 1) x?) 5))
							)
							(switch ((ScriptID 15 1) loop?)
								(0 (+ ((ScriptID 15 1) y?) 6))
								(1 (+ ((ScriptID 15 1) y?) 6))
								(2
									(+ ((ScriptID 15 1) y?) 10)
								)
								(3
									(+ ((ScriptID 15 1) y?) 10)
								)
								(4
									(+ ((ScriptID 15 1) y?) 13)
								)
							)
						show:
					)
				)
				(self cue:)
			)
			(1
				(if (not (Btest 151))
					(= local4 1)
					(localproc_000c)
					((ScriptID 15 4)
						show:
						setLoop: 5
						setStep: 24 16
						setCycle: Forward
						startUpd:
						setMotion: MoveTo local2 local3
					)
				else
					(self cue:)
				)
			)
			(2
				(if (not (Btest 151))
					(self cue:)
				else
					(localproc_000c)
					(= local4 1)
					((ScriptID 15 4) setMotion: MoveTo local2 local3)
				)
			)
			(3
				((ScriptID 15 3)
					ignoreActors:
					cel: 0
					setPri: 12
					posn: ((ScriptID 15 4) x?) ((ScriptID 15 4) y?)
					setCycle: EndLoop
				)
				(= local5 (+ local5 (Random 1 4)))
				((ScriptID 15 4)
					setMotion: MoveTo [local6 local5] [local17 local5] self
				)
			)
			(4
				(if (< local5 10)
					(self changeState: 3)
				else
					(self cue:)
				)
			)
			(5
				((ScriptID 15 4)
					setLoop: 6
					cel: 0
					setMotion: 0
					setCycle: EndLoop self
				)
			)
			(6
				((ScriptID 15 4) setScript: 0)
			)
		)
	)
)
