;;; Sierra Script 1.0 - (do not remove this comment)
(script# 114)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use System)

(public
	turn 0
	halfTime 1
)

(instance turn of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 114)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 317)
				(Bset 316)
				(Bclear 318)
				(ego
					setLoop: 4
					illegalBits: 0
					setCel: (if (Btest 320) 4 else 0)
					setMotion: 0
					setCycle: 0
				)
				(if (Btest 320) (ego x: (+ (ego x?) 15)))
				(= cycles 4)
			)
			(1
				(ego
					illegalBits: 0
					setStep: 15 2
					setCycle: (if (Btest 320) BegLoop else EndLoop)
				)
				(if (Btest 320)
					(ego setMotion: MoveTo 172 94 self)
				else
					(ego setMotion: MoveTo 126 96 self)
				)
			)
			(2
				(ego
					setLoop: (if (Btest 320) 0 else 5)
					setCel: 0
					setStep: 3 2
					setMotion: 0
					setCycle: 0
					illegalBits: 0
				)
				(if (not (Btest 320)) (ego x: (- (ego x?) 15)))
				(= cycles 6)
			)
			(3
				(Bclear 317)
				(Bclear 316)
				(Bset 318)
				(self dispose:)
			)
		)
	)
)

(instance halfTime of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 114)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 317)
				(ego setLoop: (if (Btest 320) 0 else 1) cel: 0)
				(= cycles 2)
			)
			(1
				(ego
					setLoop: (if (Btest 320) 4 else 5)
					illegalBits: 0
					cycleSpeed: 2
					setCycle: Forward
				)
				(if (Btest 320)
					(ego setMotion: MoveTo 172 94 self)
				else
					(ego setMotion: MoveTo 111 96 self)
				)
			)
			(2
				(ego
					cycleSpeed: 0
					setCycle: 0
					setLoop: (if (Btest 320) 0 else 1)
					setCel: 0
				)
				(= cycles 2)
			)
			(3
				(Bset 318)
				(Bclear 317)
				(ego illegalBits: cWHITE)
				(self dispose:)
			)
		)
	)
)
