;;; Sierra Script 1.0 - (do not remove this comment)
(script# 202)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	selChar 0
)

(local
	newProp
	newProp_3
	newProp_2
	newProp_4
	newView_2
	newView_3
	newView_4
	newView_5
	newView_6
	newView_7
	newView_8
	local11
	local12
	newView
	local14
	local15
	local16
	local17 =  1
)
(procedure (localproc_000c)
	(LockEgo)
	(curRoom newRoom: 203)
)

(procedure (localproc_001c)
	(switch local11
		(1
			(newView setCel: 0 posn: 64 127 stopUpd:)
			(mageScript changeState: 0)
			(thiefScript changeState: 0)
			(fighterScript changeState: 1)
		)
		(2
			(newView setCel: 0 posn: 158 127 stopUpd:)
			(fighterScript changeState: 0)
			(thiefScript changeState: 0)
			(if local16
				(newProp_3 setLoop: 1 setCel: 3)
				(newProp_2 show:)
			else
				(mageScript changeState: 1)
			)
		)
		(3
			(newView setCel: 0 posn: 252 127 stopUpd:)
			(fighterScript changeState: 0)
			(mageScript changeState: 0)
			(thiefScript changeState: 1)
		)
	)
)

(procedure (localproc_00ec)
	(switch local11
		(1
			(= heroType CLASS_FIGHTER)
			(localproc_000c)
		)
		(2
			(= heroType CLASS_MAGICUSER)
			(localproc_000c)
		)
		(3
			(= heroType CLASS_THIEF)
			(localproc_000c)
		)
	)
)

(instance selChar of Room
	(properties
		picture 905
		style $0008
	)
	
	(method (init)
		(Load rsSOUND (GetSongNumber 73))
		(User canInput: 0)
		((= newView (View new:))
			view: 506
			setLoop: 0
			setCel: 0
			posn: 0 1000
			setPri: 5
			init:
			ignoreActors:
			stopUpd:
		)
		((= newProp (Prop new:))
			view: 505
			setPri: 5
			init:
			ignoreActors:
			stopUpd:
			setScript: fighterScript
		)
		((= newProp_2 (Prop new:))
			view: 505
			setLoop: 3
			setCel: 0
			posn: 158 84
			setPri: 6
			init:
			ignoreActors:
		)
		((= newProp_3 (Prop new:))
			view: 505
			setPri: 5
			init:
			ignoreActors:
			stopUpd:
			setScript: mageScript
		)
		((= newProp_4 (Prop new:))
			view: 505
			setPri: 5
			init:
			ignoreActors:
			stopUpd:
			setScript: thiefScript
		)
		((= newView_2 (View new:))
			view: 506
			setLoop: 1
			setCel: 0
			posn: 83 25
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_3 (View new:))
			view: 506
			setLoop: 1
			setCel: 1
			posn: 146 27
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_4 (View new:))
			view: 506
			setLoop: 1
			setCel: 2
			posn: 220 27
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_5 (View new:))
			view: 506
			setLoop: 1
			setCel: 3
			posn: 65 155
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_6 (View new:))
			view: 506
			setLoop: 1
			setCel: 4
			posn: 159 147
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_7 (View new:))
			view: 506
			setLoop: 1
			setCel: 6
			posn: 161 163
			init:
			ignoreActors:
			stopUpd:
		)
		((= newView_8 (View new:))
			view: 506
			setLoop: 1
			setCel: 5
			posn: 252 153
			init:
			ignoreActors:
			stopUpd:
		)
		(self setScript: selScript)
		(super init:)
		(gMouseHandler add: self)
		(gKeyHandler add: self)
		(gDirHandler add: self)
		(if
			(or
				(== (cSound state?) 0)
				(!= (cSound number?) (GetSongNumber 61))
			)
			(cSound number: (GetSongNumber 73) loop: -1 play:)
		)
		(cSound prevSignal: 0)
		(Joystick 12 30)
	)
	
	(method (doit)
		(cond 
			(
				(and
					local17
					(or
						(== (cSound signal?) 2)
						(== (cSound prevSignal?) 2)
					)
				)
				(= local17 0)
				(cSound stop:)
				(cSound number: (GetSongNumber 73) loop: -1 play:)
			)
			((and local15 (== (cSound prevSignal?) 3))
				(cSound prevSignal: 0)
				(if (== local11 3) (= local11 1) else (++ local11))
				(= local14 0)
				(localproc_001c)
			)
			(local16 (= local16 0) (localproc_00ec))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Joystick 12 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 temp2 [temp3 60])
		(if local14
			(if (== (pEvent type?) evKEYBOARD)
				(= local15 0)
				(switch (pEvent message?)
					(KEY_TAB
						(pEvent type: 64)
						(pEvent message: 3)
					)
					(KEY_SHIFTTAB
						(pEvent type: 64)
						(pEvent message: 7)
					)
					(KEY_RETURN
						(pEvent claimed: 1)
						(= local16 1)
					)
				)
			)
			(switch (pEvent type?)
				(evMOUSEBUTTON
					(= temp1 (pEvent x?))
					(= temp2 (pEvent y?))
					(= temp0 (OnControl 4 temp1 temp2))
					(= local15 0)
					(pEvent claimed: 1)
					(cond 
						((& temp0 $4000) (= local11 1) (= local16 1))
						((& temp0 $2000) (= local11 2) (= local16 1))
						((& temp0 $1000) (= local11 3) (= local16 1))
						(else (pEvent claimed: 0))
					)
					(pEvent claimed: 1)
					(= local14 0)
					(localproc_001c)
				)
				(evJOYSTICK
					(switch (pEvent message?)
						(JOY_LEFT
							(if (== local11 1) (= local11 3) else (-- local11))
						)
						(JOY_RIGHT
							(if (== local11 3) (= local11 1) else (++ local11))
						)
					)
					(pEvent claimed: 1)
					(= local15 0)
					(= local14 0)
					(localproc_001c)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance fighterScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= seconds (= cycles 0))
				(newProp setLoop: 4 setCel: 0 posn: 64 117)
			)
			(1
				(= seconds (= cycles 0))
				(= local11 1)
				(newProp setLoop: 0 setCel: 1)
				(= local14 1)
				(= cycles 5)
			)
			(2
				(newProp setCel: 0)
				(= cycles 5)
			)
			(3
				(fighterScript changeState: 1)
			)
		)
	)
)

(instance mageScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= seconds (= cycles 0))
				(newProp_3 setLoop: 4 setCel: 1 posn: 158 117)
				(newProp_2 stopUpd: hide:)
			)
			(1
				(= seconds (= cycles 0))
				(= local11 2)
				(newProp_3 setLoop: 1 setCel: 0)
				(= local14 1)
				(= cycles 3)
			)
			(2
				(newProp_3 setCel: -1 setCycle: EndLoop self)
			)
			(3
				(newProp_2 show: setCycle: Forward startUpd:)
				(= seconds 3)
			)
			(4 (self changeState: 3))
		)
	)
)

(instance thiefScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= seconds (= cycles 0))
				(newProp_4 setLoop: 4 setCel: 2 posn: 252 117)
			)
			(1
				(= seconds (= cycles 0))
				(= local11 3)
				(newProp_4 setLoop: 2 setCel: 0)
				(= local14 1)
				(= seconds 2)
			)
			(2
				(newProp_4 setCel: -1 setCycle: EndLoop)
				(= seconds 2)
			)
			(3
				(newProp_4 setCycle: BegLoop self)
			)
			(4 (thiefScript changeState: 1))
		)
	)
)

(instance selScript of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== state 3)
				(not local15)
				(== (cSound prevSignal?) 3)
			)
			(cSound prevSignal: 0)
			(= local14 1)
			(= local15 1)
			(fighterScript changeState: 1)
			(self dispose:)
		else
			(super doit:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(++ local12)
				(newView_2 hide:)
				(newView_3 hide:)
				(newView_4 hide:)
				(= cycles 3)
			)
			(2
				(newView_2 show:)
				(newView_3 show:)
				(newView_4 show:)
				(= cycles 3)
			)
			(3
				(cSound prevSignal: 0)
				(if (< local12 2) (self changeState: 1))
			)
		)
	)
)
